﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.AsciiDoc
{
    public class AsciiDocImage
    {
        private string caption;
        private int figureNr;
        private string fileName;
        private int width;
        private int height;
       

        public AsciiDocImage(string caption, string fileName, int figureNr, int width, int height) 
        {
            this.caption = caption;
            this.figureNr = figureNr;
            this.fileName = fileName;
            this.width = width;
            this.height = height;
        }

        /*
         * [#Figure3]
         * .Put the title/caption text here
         * image::smiley.jpg["An example image.", 200, 150]
         */

        public string GetImage()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("[caption=\"Figure " + figureNr + ": \"]\n");
            sb.Append("." + caption + "\n");
            if(width > 0 && height > 0)
            {
                sb.Append("image::" + fileName + "[\"" + caption + "\", " + width + ", " + height + "]\n");
            } else
            {
                sb.Append("image::" + fileName + "[\"" + caption + "\"]\n");
            }
            return sb.ToString();
        }
    }
}
