﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CimSyntaxGen.AsciiDoc
{
    public class AsciiDocTable
    {
        private List<string> headerRow = new List<string>();
        private List<List<string>> listOfRows = new List<List<string>>();
        private string name;


        public AsciiDocTable(string name) 
        {
            this.name = name;
        }

        public void SetHeaderRow(List<string> headerRow)
        {
            this.headerRow = headerRow;
        }

        public void AddRow(List<string> row)
        {
            listOfRows.Add(row);
        }

        public String GetTable(string cols, int widthInPercent)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("\n\n." + name + "\n");
            sb.Append("[cols=\"" + cols + "\", grid=rows,width=\"" + widthInPercent + "%\"]\n");
            sb.Append("|===\n");
            bool hasHeaderRow = false;
            if(headerRow.Count > 0)
            {
                listOfRows.Insert(0, headerRow);
                hasHeaderRow = true;
            }
            foreach(List<string> row in listOfRows)
            {
                foreach(string cell in row)
                {
                    sb.Append("|" + cell);
                }
                sb.Append("\n");
                if (hasHeaderRow)
                {
                    sb.Append("\n");
                    hasHeaderRow = false;
                }
            }
            sb.Append("|===\n\n");
            return sb.ToString();
        }

    }
}
