﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.AvroGeneration
{
    public class AvroArray<TValue>: JsonBase
    {
        private JsonKeyValue<string> type = new JsonKeyValue<string>("type", AvroTypes.ARRAY);
        private JsonKeyValue<string> items;
        private JsonKeyValue<JsonBase> itemObjs;
        private JsonObject<TValue> jObj = new JsonObject<TValue>("");
        private string name = "";

        public AvroArray()
        {
        }

        public AvroArray(string itemType)
        {
            items = new JsonKeyValue<string>("items", itemType);
            jObj.Add(type);
            jObj.Add(items);
        }

        public AvroArray(JsonBase itemRecord)
        {
            itemObjs = new JsonKeyValue<JsonBase>("items", itemRecord);
            jObj.Add(type);
            jObj.Add(itemObjs);
        }

        public void AddItem(AvroRecord items)
        {
            jObj.Add(items);
        }


        public string GetName()
        {
            return this.name;
        }

        public string AsString()
        {
            return jObj.AsString();
        }

    }
}
