using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;

namespace CimSyntaxGen


{

    class CIMSchemaGenerator
    {
        private const bool hierarchie = true;
        public static XmlSchema schema; // main generated schema
        public static ConstantDefinition CD = new ConstantDefinition();
        private const string NS_XSD = "http://www.w3.org/2001/XMLSchema";
        public const string NS_SAWSDL = "http://www.w3.org/ns/sawsdl";
        public const string NS_CIMP = "http://www.iec.ch/cimprofile";
        // XMLParser XMLP=new XMPLParser();// am juin 2011
        public static XMLProfileParameters profparameters = new XMLProfileParameters();// operator's data
        private static string schemaversion = "1";
        private string res = "";
        public static string nomfic = "XSDexample.xsd";
        //static TextWriter ficlog = new StreamWriter("ficlog.txt");
        //static public TextWriter   reportlog; // to report details of generation
        static public StreamWriter reportlog; // to report details of generation
        static public string stringtowrite;
        static public List<long> ElemRootList;  // list of rootclass (WG19NDR)
        static public XmlSchemaUse usage = new XmlSchemaUse();
        static public TextWriter fluxdata;
        static RDFutilitaires rdfutilitaires;
        static List<long> datatypetraite; // to avoid duplication of datatype, enumeration and compound elements
        static Dictionary<string, List<long>> dicsamerolesbyname; // give for each element the roles which are identical
        static EA.Repository Repos;
        static Dictionary<string, string> mapforprimitivetypes;  // these roles usualy come from associations to subclasses inherited
        static List<string> LocalDatatypeNames;
        static List<long> LocalDatatypeIDs;
        static List<string> LocalClassNames;
        static Dictionary<long, EA.Element> dicInline; // classes inline id,element
        static Dictionary<long, Connexion> ConexesWithUnion;  // list of connexions in a union


        /*
            public static List<string> Cimstereos = new List<string>()
                                          {
                                            "Class",
                                            "Datatype",
                                            "Primitive",
                                            "Compound",
                                            "enumeration",
                                           };
    */
        public static long ConexesID;

        public struct Connexion
        {
            public long ConexID;
            public long ConnectorID;
            public EA.Element Source_element;
            public EA.Element Target_element;
            public EA.ConnectorEnd Source;
            public int SourceAggregation;
            public EA.ConnectorEnd Target;
            public int TargetAggregation;

            public Connexion(EA.Connector con)
            {

                ConstDefinition constantes = new ConstDefinition(); // constants
                ConexesID++;
                ConexID = ConexesID;
                ConnectorID = con.ConnectorID;
                Source_element = RDFutilitaires.dicelembyid[con.ClientID];
                Target_element = RDFutilitaires.dicelembyid[con.SupplierID];
                Source = con.ClientEnd;
                SourceAggregation = (con.ClientEnd).Aggregation;
                Target = con.SupplierEnd;
                TargetAggregation = (con.SupplierEnd).Aggregation;
            }
            public Connexion(Connexion conex)
            {
                ConexesID++;
                ConexID = ConexesID;
                ConnectorID = conex.ConnectorID;
                Source_element = conex.Source_element;
                Target_element = conex.Target_element;
                Source = conex.Source;
                SourceAggregation = conex.SourceAggregation;
                Target = conex.Target;
                TargetAggregation = conex.TargetAggregation;
            }
        }
        public static List<long> inheritedconids; // list of father  connectors inherited for each concrete class byid
        public static Dictionary<long, List<Connexion>> inheritedconex; // list of inherited conex  for each concrete class byid
        public static List<long> motherconids; // list of inherited mother conid   for each concrete class byid

        public static List<long> CreatedEnumerations;

        /// <summary>
        /// for memmo of an EA object
        /// </summary>
        public class ModelObject
        {
            public EA.Element el = null;
            public EA.Connector con = null;
            public EA.Attribute attribute = null; // pointeur vers un attribut si objet  
            public Connexion conex;
            public string type = "";  //
            public string keyname = "";
            public ModelObject(EA.Element el, EA.Attribute atr)
            {
                this.el = el;
                type = "attribute";
                attribute = atr;
                if (atr != null)
                {
                    keyname = atr.Name;

                }
            }
            public ModelObject(EA.Element element, EA.Connector connector)
            {
                el = element;
                conex = new Connexion(connector);
                type = "connexion";
                keyname = GetConnexionName(this);
            }
            public ModelObject(EA.Element element, Connexion conex)
            {
                el = element;
                this.conex = conex;
                type = "connexion";
                keyname = GetConnexionName(this);
            }

        }


        /// <summary>
        /// for xsg generation according of the target wg
        /// wg19,wg14
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="aPackage"></param>
        /// <param name="wg"></param>
        public static void PackageGenerateXSD(EA.Repository repo, EA.Package aPackage, string wg)
        {


            Repos = repo;
            repo.SaveAllDiagrams();
            Dictionary<long, XmlSchemaElement> dicrootcardinality = new Dictionary<long, XmlSchemaElement>();
            ConstDefinition constantes = new ConstDefinition(); // constants
            //  CreatedEnumerations = new List<long>(); // lists of already created enumerations
            datatypetraite = new List<long>(); // lists of already created datatypes,compounds or enumerations
            XMLParser XMLP = new XMLParser(); //am juin 2011
            XMLProfileParameters profparameters = new XMLProfileParameters();
            try
            {

                reportlog = new StreamWriter(Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen)); //  the report file
                RDFutilitaires.reportlog = reportlog;
                if (RDFutilitaires.ongoing == false) return;
            }
            catch (Exception e)
            {
                MessageBox.Show(" Error when opening file CimSyntaxGenReport.txt ");
                return;
            }


            if (wg == "wg19")
            {
                Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19");
                aDialxsd.ShowDialog();
            }

            if (wg == "wg14")
            {

                // check if the selected package contains a proper <<assembly>> package
                // if not abort
                bool ok = false;
                ElemRootList = new List<long>();
                EA.Package packageenvelop = null;
                EA.Element eltenvelop = null;
                ConnectorEnd theotherend = null;
                long theotherendID = 0;
                foreach (EA.Package pa in aPackage.Packages)
                {
                    if (pa.StereotypeEx.Contains(CD.GetAssemblyStereotype()))
                    {
                        foreach (EA.Element el in pa.Elements)
                        {
                            if (el.Type == "Class" && (el.StereotypeEx.Contains(CD.GetAssemblyStereotype())))
                            {
                                foreach (EA.Connector con in el.Connectors)
                                {
                                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                                    {
                                        if (con.ClientID == el.ElementID)  // the otherend is target
                                        {

                                            if ((con.SupplierEnd.Role != "") && (con.SupplierEnd.Aggregation == 0))
                                            {//the otherend is target
                                                theotherend = con.SupplierEnd;
                                                theotherendID = con.SupplierID;

                                            }
                                        }
                                        if (con.SupplierID == el.ElementID)  // the otherend is source
                                        {

                                            if ((con.ClientEnd.Role != "") && (con.ClientEnd.Aggregation == 0))
                                            {//the otherend is source
                                                theotherend = con.ClientEnd;
                                                theotherendID = con.ClientID;

                                            }
                                        }

                                        if (!ElemRootList.Contains(theotherendID))
                                        {// we mark the class as root in the profile
                                            ElemRootList.Add(theotherendID);
                                            XmlSchemaElement sel = new XmlSchemaElement();
                                            sel.Name = theotherend.Role;
                                            char[] arg = { '.' };
                                            string cardinalite = theotherend.Cardinality;
                                            if (cardinalite == "") cardinalite = "0..*";
                                            string[] split = cardinalite.Split(arg);
                                            if (split[0] != "") sel.MinOccursString = split[0];
                                            if ((split.Length != 1) && (split.Length != 3))
                                            {
                                                MessageBox.Show("Error for " + sel.Name + " bad syntax of a cardinality");
                                                reportlog.WriteLine("Error for " + sel.Name + " bad syntax of a cardinality");
                                                return;
                                            }
                                            if (split.Length == 3)
                                            {
                                                if (split[2] != "*")
                                                {
                                                    sel.MaxOccursString = split[2];
                                                }
                                                else
                                                {
                                                    sel.MaxOccursString = "unbounded";
                                                }
                                            }
                                            else
                                            {
                                                if (split[0] == "*")
                                                { //very special case where there is only one digit cardinality
                                                    sel.MaxOccursString = "unbounded";
                                                }
                                                else
                                                {
                                                    sel.MaxOccursString = "1";
                                                }

                                            }
                                            dicrootcardinality.Add(theotherendID, sel);
                                            ok = true;
                                            //must treat role and cardinality
                                        }


                                    }

                                }

                            }
                            if (ok)
                            {
                                eltenvelop = el;
                                break;
                            }
                        }
                    }


                    if (ok)
                    {
                        packageenvelop = pa;
                        break;
                    }
                }

                if (!ok)
                {
                    string message = "Abort: The Profile is not conform because\n";
                    message = message + " either there is no <<Assembly>> package\n";
                    message = message + " or there is no <<assembly>> class in this package\n";
                    message = message + " or this class has no connexion with a role root to at least one class of the profile";
                    MessageBox.Show(message);
                    RDFutilitaires.ongoing = false;
                    return;

                }
                if (eltenvelop != null)
                {
                    foreach (EA.Attribute atr in eltenvelop.Attributes)
                    {
                        if (atr.Name == "version")
                        {
                            profparameters.Version = atr.Default.ToString();
                        }
                    }
                    profparameters.EnvelopName = eltenvelop.Name;

                    Dialxsd aDialxsd = new Dialxsd(profparameters, "wg14");
                    aDialxsd.ShowDialog();
                }
            }




            // ArrayList elements = new ArrayList();

            if (RDFutilitaires.ongoing == false) return;


            reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating XSD profile : ");
            // reportlog.Write(stringtowrite);
            reportlog.WriteLine("\t\t{0}", profparameters.TargetNamespace);
            reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            reportlog.WriteLine("--------------------------------------------------------------------------------\n");

            schema = new XmlSchema { };
            schema.Namespaces.Add(profparameters.Prefix, profparameters.TargetNamespace);// pointe sur ce schema
            schema.Namespaces.Add("cimp", NS_CIMP);
            schema.Namespaces.Add("xs", "http://www.w3.org/2001/XMLSchema");
            schema.Namespaces.Add("sawsdl", NS_SAWSDL);
            schema.TargetNamespace = profparameters.TargetNamespace;
            schema.AttributeFormDefault = XmlSchemaForm.Unqualified;
            schema.ElementFormDefault = XmlSchemaForm.Qualified;

            // -------begining of the iterative traitment
            rdfutilitaires = new RDFutilitaires();
            List<EA.Element> ElemList = new List<EA.Element>();
            // we initialize the necessary dictionaries
            EA.Collection modellist;
            modellist = repo.Models;
            EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, repo);

            RDFutilitaires.buildDicsElem(toppack);
            // RDFutilitaires.getStereotypedElements(aPackage, ElemList, Cimstereos);
            RDFutilitaires.getTypedElements(aPackage, ElemList, "Class");
            RDFutilitaires.buildDicsrepo(repo);
            RDFutilitaires.buildDicstereo(repo);
            //RDFutilitaires.buildDiscsDatatype(toppack);
            mapforprimitivetypes = new Dictionary<string, string>();
            BuildMapforprimitivetypes(mapforprimitivetypes);
            LocalDatatypeNames = new List<string>();
            LocalDatatypeIDs = new List<long>();
            buildLocalDatatypeNames(aPackage, LocalDatatypeNames, LocalDatatypeIDs);
            LocalClassNames = new List<string>();
            buildLocalClassNames(aPackage, LocalClassNames);
            dicInline = new Dictionary<long, EA.Element>();

            ConexesID = 0; // resen of conexes IDs
            inheritedconex = new Dictionary<long, List<Connexion>>(); // to find for each class the possible inherited Connexion
            inheritedconids = new List<long>(); // to find all the inherited connexion
            motherconids = new List<long>(); // to know which connection are already be inherited
            BuidInheritedConnexion(inheritedconids, inheritedconex, motherconids, ElemList);
            //dicconexDump(inheritedconex);

            //------------------------------------------
            //---  test if the profile has been donewith help of CimContextor and there no class of the same name

            List<EA.Element> ProfileClasses = new List<EA.Element>();
            RDFutilitaires.getAllElements(aPackage, ProfileClasses, "Class");
            List<string> NoDoublons = new List<string>();
            foreach (EA.Element elt in ProfileClasses)
            {
                string nom = elt.Name;
                if (nom.Length != 0)
                { // no treatment it's probably a note
                    if (!NoDoublons.Contains(elt.Name))
                    {
                        NoDoublons.Add(elt.Name);
                    }
                    else
                    {
                        reportlog.WriteLine(" ERROR there are at least two classes of the same name " + elt.Name + " in the profile");
                        MessageBox.Show(" ERROR there are at least two classes of the same name " + elt.Name + " in the profile so the process will be interrupted");

                        return;
                    }
                    if (elt == RDFutilitaires.getElementBasedonElement(elt))
                    { //element not based on another class
                        string name = "";
                        name = elt.Name;
                        DialogResult r = MessageBox.Show("Error the Class " + name + " is not based on another Class the Profile is not correct", "Error", MessageBoxButtons.OKCancel);
                        if (r == DialogResult.Cancel) return;
                        // return;
                    }
                }
            }


            //---------------------------------------

            //  treatment of every "root classes"

            // RDFutilitaires.GetClassesWithoutAscendant(aPackage, ElemRootList);
            if (wg == "wg19")
            {
                ElemRootList = new List<long>();
                foreach (EA.Element elt in ElemList)
                {
                    if (elt.IsActive)
                    {
                        if (!ElemRootList.Contains(elt.ElementID))
                        {
                            ElemRootList.Add(elt.ElementID);
                        }
                    }

                }
            }
            if (ElemRootList.Count == 0)
            {
                MessageBox.Show("Error!   There must be at least one RootClass in the model");
                reportlog.WriteLine("\t\t !!!ERROR  the program is interupted because there should be at least on RootClass in the profile");
                return;


            }
            try
            {
                // creation of the top element
                XmlSchemaElement elementItem = new XmlSchemaElement();
                elementItem.Name = profparameters.EnvelopName;
                elementItem.SchemaTypeName = new XmlQualifiedName(profparameters.EnvelopName, profparameters.TargetNamespace);
                schema.Items.Add(elementItem);
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                schema.Items.Add(ct);
                ct.Name = profparameters.EnvelopName;
                XmlSchemaSequence sequence = new XmlSchemaSequence();
                ct.Particle = sequence;
                //EA.Element clroot;
                foreach (long clrootid in ElemRootList)
                {
                    EA.Element clroot = RDFutilitaires.dicelembyid[clrootid];
                    if (RDFutilitaires.ElementBelongsToProfile(clroot, aPackage, toppack))
                    {

                        XmlSchemaElement nel = new XmlSchemaElement();

                        string atrtype = clroot.Name;

                        if (wg == "wg19")
                        {

                            nel.Name = clroot.Name;
                            Dialroot aDialroot = new Dialroot(nel);
                            aDialroot.ShowDialog();
                        }
                        if (wg == "wg14")
                        {
                            nel = dicrootcardinality[clroot.ElementID];
                        }

                        nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                        sequence.Items.Add(nel);
                    }
                }
            }
            catch (Exception e)
            {

                DialogResult r = MessageBox.Show("the following error has occured: " + e.Message, "Error", MessageBoxButtons.OKCancel);

                reportlog.WriteLine("\t\t !!!ERROR  {0}", e.Message);
                if (r == DialogResult.Cancel) return;

            }

            // treatment of "Float" datatype
            // We assume that we nead for CIM a global a simple type named Float
            /*
            if (!LocalDatatypeNames.Contains(CD.GetFloatType()))
            {
                foreach (EA.Element el in RDFutilitaires.dicelembyid.Values)
                {
                    if (el.StereotypeEx.Contains(CD.GetPrimitiveStereotype()) && (el.Name == CD.GetFloatType()))
                    {
                        //<xs:simpleType name="Float">

                        XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                        flottant.Name = CD.GetFloatType();
                        schema.Items.Add(flottant);
                        XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                        flottant.Content = union;
                        XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                        union.MemberTypes = members;
                        XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                        flottant.Annotation = flotanno; ;
                        ArrayList reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
                        string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                        AddAppInfoSawdsl(flotanno, reference);
                        if (el.Notes != "")
                        {
                            XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                            flotanno.Items.Add(flotdoc);
                            flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                        }
                        break;
                    }

                }
            }
     */



            // we explore each Package in turn (pour l'instant)
            List<long> packlist = new List<long>();
            RDFutilitaires.getAllPackID(aPackage.PackageID, packlist);
            foreach (long paid in packlist)
            {
                EA.Package pa = RDFutilitaires.dicrepobyid[paid];

                reportlog.WriteLine(" \t\t ++++  The Package {0} is beeing treated +++", pa.Name);

                List<EA.Element> elList = new List<EA.Element>();
                // elList = RDFutilitaires.getLocalStereotypedElements(pa, Cimstereos);
                elList = RDFutilitaires.getLocalTypedElements(pa, "Class");
                XmlSchemaObject sobj = null;
                foreach (EA.Element nel in elList)
                {
                    //on ne cree pas a priori les objets identifiers  priori mais au fur et  mesure de leur utilisation
                    if (RDFLAutilitaires.StereoExContainsStereo( nel.StereotypeEx, ConstantDefinition.CimDatatypeStereos))
                    {
                        continue; //on passe a element suivant  // am juil 2011
                    }
                    
                    try
                    {
                        reportlog.WriteLine(" \t\t\t ... The Element {0} is beeing treated", nel.Name);
                        //   MessageBox.Show("The Element " + nel.Name + "is beeing treated"); // for test

                        sobj = TraitElem(nel, pa, schema);
                        if ((sobj != null) && !IsInline(nel))
                        {
                            schema.Items.Add(sobj);
                        }

                    }
                    catch (Exception e)
                    {
                        DialogResult r = MessageBox.Show(" error TraitElem " + e.Message, "Error", MessageBoxButtons.OKCancel);
                        reportlog.WriteLine("\t\t !!!ERROR {0}", e.Message);
                        if (r == DialogResult.Cancel) return;
                    }
                }
            }
            //---------------------------------------------------------------------------
            try
            {
                XmlSchemaSet schemaSet = new XmlSchemaSet();
                schemaSet.ValidationEventHandler += new ValidationEventHandler(ValidationCallbackOne);
                schemaSet.Add(schema);

                schemaSet.Compile();

                XmlSchema compiledSchema = null;

                foreach (XmlSchema schema1 in schemaSet.Schemas())
                {
                    compiledSchema = schema1;



                }





                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xs", NS_XSD);
                nsmgr.AddNamespace(profparameters.Prefix, profparameters.TargetNamespace);
                nsmgr.AddNamespace("cimp", NS_CIMP);



                //  compiledSchema.Write(Console.Out, nsmgr);
                // StreamWriter fluxdata = new StreamWriter(nomfic);
                fluxdata =
                        new StreamWriter(nomfic);
                // true, System.Text.Encoding.UTF8, 512);

                // XmlWriter fluxdata = XmlWriter.Create(nomfic);
                if (compiledSchema == null)
                {
                    MessageBox.Show("  Error , the compiled schema is empty ");
                }
                else
                {
                    compiledSchema.Write(fluxdata);
                }
                fluxdata.Flush();
                fluxdata.Close();

                Schemarecopie(profparameters);

                //ficlog.WriteLine("----------------------------" + DateTime.Now.ToLongDateString());
                //  ficlog.Close();

            }
            catch (XmlSchemaException e)
            {
                reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);
                reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
                reportlog.WriteLine("LinePosition = {0}", e.LinePosition);

            }

        }



        public static void ValidationCallbackOne(object sender, ValidationEventArgs args)
        {
            try
            {
                Console.WriteLine(args.Message);


                reportlog.WriteLine("validation of the schema while beeing created:  " + args.Message);
                //  MessageBox.Show(" Validation Schema: " + args.Message);
            }
            catch (Exception e)
            {
                MessageBox.Show("40- Error Validation Schema: " + e.Message, "Error");
                // ficlog.WriteLine("40- Error Validation Schema: " + e.Message);
                reportlog.WriteLine(" \t\t ---MessageFromSchemaValidator:  {0}", e.Message);
            }

        }

        /************************************************************************************
        * here begins all programs which allow the transformation from UML to XSD
        * each program is preceded by the relevant NDR rule
        *************************************************************************************/

        /*****************************************************************************
         *  * top level element
         * ++++++++++++ R1 +++++++++++++++++++++++
          <xs:element 
            name= envelope-name 
            type= envelope-name>
        </xs:element>
        *   not yet impmented
         ******************************************************************************/
        /*****************************************************************************
          * Structured and Compound Classes
          * ++++++++++++ R2 +++++++++++++++++++++++
                <xs:complexType 
	              name = class-name
	             abstract = abstract-value (true or false)
	            sawsdl:modelReference = class-ref>
	            Content: (annotation, (whole-class|derived-class))
               </xs:complexType>
         * +++++++++++++++++++++++++
         * for a subclass
         * ++++++++++++++++++++++++
         * <xs:extension 
	         base = super-name>
	        Content: whole-class
            </xs:extension>
         * +++++++++++++++++++
         * the content:
         * 
         * <xs:sequence>
	     Content: ((simple-elem|typed-elem|ref-elem|
	     choice-elem|inline-elem|compound-elem)*)
        </xs:sequence> 
         * ******************************************************************************/
        /// <summary>
        /// to treat each element (like class)
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        static XmlSchemaObject TraitElem(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            XmlSchemaObject ret = null;
            string prov = el.Name;

            string stereos = el.StereotypeEx;
            string cas = "";
            string[] split = stereos.Split(new Char[] { ',' });
            if (!((split.Length == 1) && (split[0] == CD.GetInlineStereotype())))

                foreach (string ss in split)
                {
                    if (ss == CD.GetPrimitiveStereotype()) { cas = ss; break; };
                    if (ss == "Datatype") { cas = ss; break; };// ascendant compatibility
                    if (ss == CD.GetDatatypeStereotype()) { cas = ss; break; };
                    if (ss == CD.GetCompoundStereotype()) { cas = ss; break; };
                    if (ss == CD.GetEnumStereotype()) { cas = ss; break; };
                    if (ss == CD.GetInlineStereotype()) { cas = "none"; continue; };
                    if (ss == CD.GetAssemblyStereotype()) { cas = ss; break; }; // case of wg14 treatment envelop object
                }

            switch (cas)
            {

                case "none":
                    break;
                case ConstantDefinition.PrimitiveStereotype:
                    transPrimitive(el, apackage, schem);
                    break;
                case "Datatype": // ascending compatibility    
                    ret = transDatatype(el, apackage, schem);
                    break;
                case ConstantDefinition.DatatypeStereotype:
                    ret = transDatatype(el, apackage, schem);
                    break;
                case ConstantDefinition.CompoundStereotype:
                    ret = transCompound(el, apackage, schem);
                    break;
                case ConstantDefinition.EnumStereotype:
                    if (el.StereotypeEx.Contains(CD.GetCodeListStereotype()))
                    {
                        ret = transCodeListEnumeration(el, apackage, schem);
                        break;
                    }
                    ret = transenumeration(el, apackage, schem);
                    break;
                case ConstantDefinition.AssemblyStereotype:
                    break;
                default:
                    ret = transClass(el, apackage, schem);
                    break;
            }

            return ret;
        }


        //-------------------------------------------


        //------------------------------------------- 

        static XmlSchemaObject transClass(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            XmlSchemaObject ret = null;
            try
            {
                if (hierarchie)
                {
                    if (el.Name != "")
                    {

                        //  MessageBox.Show(" treatin the class " + el.Name + " "); // for test
                        // <xs:complexType name="">
                        XmlSchemaComplexType ct = new XmlSchemaComplexType();
                        ret = ct;
                        // schem.Items.Add(ct);
                        if (!IsInline(el)) ct.Name = el.Name;
                        XmlSchemaObject sobj = ct;
                        string prov = sobj.ToString();
                        //==============================================================================
                        //documentation et  attribut sawsdl
                        if (el.Abstract == "1")
                        { // case where the class is abstract
                            ct.IsAbstract = true;
                        }
                        AddAnnForClass(el, ct, false);

                        //==============================================================================
                        // treatment in case of the existence of a super class or not
                        XmlSchemaSequence sequence = new XmlSchemaSequence();
                        EA.Element mother = RDFutilitaires.GetMotherClass(el);
                        if (mother != null)
                        {
                            // <xs:complexContent>
                            XmlSchemaComplexContent complexContent = new XmlSchemaComplexContent();
                            ct.ContentModel = complexContent;

                            // <xs:extension base="class">
                            XmlSchemaComplexContentExtension extensionClass = new XmlSchemaComplexContentExtension();
                            complexContent.Content = extensionClass;
                            extensionClass.BaseTypeName = new XmlQualifiedName(mother.Name, profparameters.TargetNamespace);

                            // <xs:sequence>

                            extensionClass.Particle = sequence;

                        }
                        else
                        {
                            ct.Particle = sequence;
                        }
                        // <xs:element name=""   type=""/>
                        EA.Collection colattributes = el.Attributes;
                        List<EA.Attribute> attributes = new List<EA.Attribute>();
                        List<ModelObject> listconmobj = new List<ModelObject>();
                        EA.Attribute atmrid = null;
                        ModelObject mobj;
                        foreach (EA.Attribute attrib in colattributes)
                        {
                            if (attrib.Name == "mRID")
                            {
                                atmrid = attrib;
                            }
                            else
                            {
                                if (isTypeCompound(attrib))
                                {
                                    mobj = new ModelObject(el, attrib);
                                    if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);

                                }
                                else
                                {
                                    attributes.Add(attrib);
                                }
                            }
                        }

                        attributes.Sort(RDFutilitaires.CompareAttributesbyName);
                        if (atmrid != null) attributes.Insert(0, atmrid);

                        foreach (EA.Attribute atr in attributes)
                        {
                            XmlSchemaElement nel = new XmlSchemaElement();
                            sequence.Items.Add(nel);
                            nel.Name = atr.Name;
                            string atrtype = atr.Type;
                            long classifierid = atr.ClassifierID;
                            if ((classifierid != 0) && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
                            {
                                EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];

                                //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                                //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                                string classtereos = "";

                                classtereos = classifier.StereotypeEx;
                                string xstype= "";
                                if (classifier.StereotypeEx.Contains(CD.GetPrimitiveStereotype()))
                                {
                                    xstype = classifier.Name;
                                }
                                else
                                {
                                    xstype = GetXSType(classifier);
                                }
                                if ((classtereos != "") && IsValidCimDatatype(classtereos) ) // 
                                    // on peut reduire le classifier  une primitive xs ou a une union (dans le cas Float)
                                {

                                    if ( xstype != "") //classtereos.Contains(CD.GetPrimitiveStereotype()))
                                        // il s'agit d'une primitive de type xs ou un union Float
                                    {
                                        if (xstype == CD.GetFloatType())
                                        { //Float is a special case

                                            nel.SchemaTypeName = new XmlQualifiedName(xstype, profparameters.TargetNamespace);
                                            if (!LocalDatatypeNames.Contains(xstype))
                                            {
                                                if(classtereos.Contains(CD.GetPrimitiveStereotype())){
                                                     transPrimitive(classifier, apackage, schem);
                                                }else{ // il s'agit d'un datatype a une value
                                                EA.Attribute at=(EA.Attribute)classifier.Attributes.GetAt(0);
                                                EA.Element elfloat=Repos.GetElementByID((int)at.ClassifierID);
                                                transPrimitive(elfloat, apackage, schem);
                                                if (!LocalDatatypeNames.Contains(xstype)) LocalDatatypeNames.Add(xstype);
                                            }
                                            }

                                        }
                                        else
                                        {
                                            if (!mapforprimitivetypes.ContainsKey( xstype))//classifier.Name))
                                            {
                                                // a primitive should be with the given list
                                                MessageBox.Show("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                                    " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                                reportlog.WriteLine("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                                " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                                //RDFutilitaires.ongoing= false;
                                                //return;

                                            }
                                            else
                                            {

                                                nel.SchemaTypeName = new XmlQualifiedName(mapforprimitivetypes[xstype], NS_XSD); //classifier.Name
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (IsInline(classifier))
                                        {
                                            XmlSchemaObject sobjj = TraitElem(classifier, apackage, schem);
                                            string xmltyp = sobjj.GetType().ToString();
                                            switch (xmltyp)
                                            {
                                                case "System.Xml.Schema.XmlSchemaComplexType":
                                                    nel.SchemaType = (XmlSchemaComplexType)sobjj;
                                                    break;
                                                case "System.Xml.Schema.XmlSchemaSimpleType":
                                                    nel.SchemaType = (XmlSchemaSimpleType)sobjj;
                                                    break;
                                                default:
                                                    break;
                                            }
                                        }
                                        else
                                        {
                                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                                            if (!datatypetraite.Contains(classifierid))
                                            {
                                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                                                //TraitElem(classifier,apackage,schem);
                                            }
                                        }
                                    }
                                    if (atr.LowerBound == "0") nel.MinOccurs = 0;
                                    AddAnnForAtr(el, nel, atr, true);
                                    /******** default or fixed values of the attribute ************************/
                                    if (atr.Default != "")
                                    {
                                        if (atr.IsConst)
                                        {
                                            nel.FixedValue = atr.Default;
                                        }
                                        else
                                        {
                                            nel.DefaultValue = atr.Default;
                                        }
                                    }

                                }
                                else
                                {
                                    // classifier == not a CIM type
                                    MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type " + classifier.Name + "  The element has been created without any type");
                                    reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type " + classifier.Name + ". The element has been created without any type");
                                }
                            }
                            else
                            {  // classifier == 0 probably a type from EA
                                MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type( native?). The element has been created without any type");
                                reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type( native?). The element has been created without any type");
                            }
                        }
                        // ====================     treatment of associations

                        prov = el.Name;// pour test
                        //                     

                        Dictionary<long, List<EA.Connector>> constraineds = new Dictionary<long, List<EA.Connector>>(); // connectors which are constrained 

                        dicsamerolesbyname = new Dictionary<string, List<long>>();
                        initDicSamerolesbyname(el);
                        /*               
                      SortedDictionary<string, EA.Connector> sortedcons = new SortedDictionary<string, EA.Connector>();
                      buildDicSortedCons(el, sortedcons);
                        */

                        if (el.Abstract == "0")
                        { // there is no direct connection generated if the class is abstract
                            // all connections are between concrete classes
                            EA.Collection connectors = el.Connectors;
                            /*
                            List<EA.Connector> connectors = new List<Connector>();
                            foreach(KeyValuePair<string,EA.Connector>kv in sortedcons){
                                connectors.Add(kv.Value);
                            }
                             * */

                            //  List<ModelObject> listconmobj = new List<ModelObject>(); 
                            foreach (EA.Connector con in connectors)
                            {

                                if (con.Type == "Association" ||
                                             con.Type == "Aggregation")
                                {
                                    if (!LocalClassNames.Contains((RDFutilitaires.dicelembyid[con.ClientID]).Name)
                                        || !LocalClassNames.Contains((RDFutilitaires.dicelembyid[con.SupplierID]).Name))
                                    {// one end is not part of the profile
                                        string texte = "WARNING one  end  of an association between " + (RDFutilitaires.dicelembyid[con.ClientID]).Name + " and " + (RDFutilitaires.dicelembyid[con.SupplierID]).Name;
                                        texte = texte + "\n seems not to be part of the profile.  That is not correct";
                                        reportlog.WriteLine(texte);
                                        MessageBox.Show(texte);
                                        return ret;
                                    }
                                }


                                if (!RDFutilitaires.dicconstbycon.ContainsKey(con.ConnectorID))
                                {
                                    if (con.Type == "Association" ||
                                           con.Type == "Aggregation")
                                    {
                                        mobj = new ModelObject(el, con);
                                        if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);
                                        //  transConnector(el, sequence, con);
                                    }
                                }
                                else
                                {
                                    List<long> constids = RDFutilitaires.dicconstbycon[con.ConnectorID];
                                    foreach (long constid in constids)
                                    { // for each constraints attached to the given connector
                                        if (constraineds.ContainsKey(constid))
                                        {// we regroup the constrained associations by constraint ID
                                            constraineds[constid].Add(con);
                                        }
                                        else
                                        {
                                            constraineds.Add(constid, new List<EA.Connector>());
                                            constraineds[constid].Add(con);
                                        }
                                    }
                                }
                            }
                            /*
                                                        listconmobj.Sort(CompareModelObjectbyKeyName); 
                                                        foreach (ModelObject mob in listconmobj)
                                                        {
                                                            if (mob.keyname != "")
                                                            {
                                                                string[] split = mob.keyname.Split('!');
                                                                switch (split[1])
                                                                {
                                                                    case "ref":
                                                                        if (split[0] == "T")
                                                                        {
                                                                            AddElementRef(sequence, getMrid(el), mob.conex.Target_element, mob.conex.Target);
                                                                        }
                                                                        else
                                                                        {
                                                                            AddElementRef(sequence, getMrid(el), mob.conex.Source_element, mob.conex.Source);
                                                                        }
                                                                        break;
                                                                    default:
                                                                        if (split[0] == "T")
                                                                        {
                                                                            AddElement(sequence, split[1], mob.conex.Target_element.Name, mob.conex.Target_element, mob.conex.Target);
                                                                        }
                                                                        else
                                                                        {
                                                                            AddElement(sequence, split[1], mob.conex.Source_element.Name, mob.conex.Source_element, mob.conex.Source);
                                                                        }
                                                                        break;
                                                                }
                                                            }

                                                        }
                            **/
                            foreach (long constid in constraineds.Keys)
                            {

                                if (RDFutilitaires.dicelembyid[constid].Notes == "XOR")
                                { //we treat  the "choices" case
                                    if (constraineds[constid].Count > 1)
                                    { // must be at least 2 to have a choice
                                        transChoiceConnector(el, sequence, constraineds[constid]);

                                    }
                                }
                            }

                            //  treatment of inherited connections
                            prov = el.Name; // pour test
                            Dictionary<long, List<Connexion>> inheritedConstrainedConexes = new Dictionary<long, List<Connexion>>(); // all conexes inheriting a choice condid are registered as constraint
                            List<long> choicedconids = new List<long>(); // we marq the conid which are constrained with a choice
                            Dictionary<long, List<Connexion>> unions = new Dictionary<long, List<Connexion>>(); // eltid,connex
                            if (inheritedconex.ContainsKey(el.ElementID))
                            {
                                List<Connexion> co = inheritedconex[el.ElementID];
                                foreach (Connexion conex in inheritedconex[el.ElementID])
                                {
                                    if ((!RDFutilitaires.dicconstbycon.ContainsKey(conex.ConnectorID)) && !(ConexesWithUnion.ContainsKey(conex.ConexID)))
                                    { // no constrained connection
                                        EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);
                                        if (con.Type == "Association" ||
                                          con.Type == "Aggregation")
                                        {
                                            mobj = new ModelObject(el, conex);
                                            if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);
                                            // transInheritedConnector(el, sequence, conex);

                                        }
                                    }
                                    else
                                    {
                                        // it is a constrained  connection
                                        // ici il doit y avoir un test sur la nature de la contrainte
                                        // mais aujourd'hui c'est forcement un choice par construction
                                        if ((!inheritedConstrainedConexes.ContainsKey(conex.ConnectorID)) && (!ConexesWithUnion.ContainsKey(conex.ConexID)))
                                        { // we regroupe connections inherited from the same conid
                                            inheritedConstrainedConexes.Add(conex.ConnectorID, new List<Connexion>());
                                            inheritedConstrainedConexes[conex.ConnectorID].Add(conex);
                                        }
                                        else
                                        {
                                            bool present = false;
                                            if (inheritedConstrainedConexes.Count > 0)
                                            {
                                                foreach (Connexion con in inheritedConstrainedConexes[conex.ConnectorID])
                                                {
                                                    if (con.ConexID == conex.ConexID)
                                                    {
                                                        present = true;
                                                        break;
                                                    }
                                                }
                                                if (!present) inheritedConstrainedConexes[conex.ConnectorID].Add(conex);

                                            }
                                        }
                                        if (ConexesWithUnion.Count > 0)
                                        {
                                            if (ConexesWithUnion.ContainsKey(conex.ConexID))
                                            {  // this connexion is member of an union
                                                long conid = conex.ConnectorID; // get the connector id
                                                if (!unions.ContainsKey(conid))
                                                {
                                                    unions.Add(conid, new List<Connexion>());
                                                }
                                                if (!unions[conid].Contains(conex)) { unions[conid].Add(conex); };

                                            }

                                        }
                                    }

                                }//foreach

                                foreach (KeyValuePair<long, List<Connexion>> kv in inheritedConstrainedConexes)
                                { // we treat all the choiced connections
                                    transChoiceInheritedConnector(el, sequence, kv.Value);
                                }
                                foreach (KeyValuePair<long, List<Connexion>> kv in unions)
                                {
                                    transUnionInheritedConnector(el, sequence, kv.Value);
                                }

                            }

                            listconmobj.Sort(CompareModelObjectbyKeyName);// il y a aussi les attributs compound
                            foreach (ModelObject mob in listconmobj)
                            {
                                if (mob.keyname != "")
                                {
                                    switch (mob.type)
                                    {
                                        case "attribute":
                                            AddElementAttribute(schem, sequence, apackage, el, mob.attribute);
                                            break;
                                        case "connexion":

                                            string[] split = mob.keyname.Split('!');
                                            switch (split[1])
                                            {
                                                case "ref":
                                                    if (split[0] == "T")  // T comme target
                                                    {
                                                        AddElementRef(sequence, getMrid(el), mob.conex.Target_element, mob.conex.Target);
                                                    }
                                                    else
                                                    {
                                                        AddElementRef(sequence, getMrid(el), mob.conex.Source_element, mob.conex.Source);
                                                    }
                                                    break;
                                                default:
                                                    if (split[0] == "T")
                                                    {
                                                        AddElement(sequence, split[1], mob.conex.Target_element.Name, mob.conex.Target_element, mob.conex.Target);
                                                    }
                                                    else
                                                    {
                                                        AddElement(sequence, split[1], mob.conex.Source_element.Name, mob.conex.Source_element, mob.conex.Source);
                                                    }
                                                    break;
                                            }
                                            break;
                                        default:
                                            break; ;
                                    }
                                }

                            }



                            //------------------------------------------------------------------------------- 

                        }
                    }
                    else
                    {
                        // it is an unnamed element. Most probably a constraint to associations
                        //MessageBox.Show( "|notes=" + el.Notes + "|Otype=" + el.ObjectType + "|type=" + el.Type );


                        //-------------------------------------------------------------------------------------------------

                    }

                }//

                else
                {// not hierarchy
                }

            }

            catch (Exception e)
            {
                MessageBox.Show("2-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR in treating an Element of Type  Class " + el.Name + "   " + e.Message);
            }
            return ret;
        }




        //--------------------------------------------
        //-------------------------------------------
        /// <summary>
        ///  // nous devons decider plusieurs cas de datatypes qui peuvent tre en ligne ou non en ligne
        ///  on commence par verifier la compatibilit des elements fourni avec in-line ou non
        ///att2: primitive, enumeration  pas in-line
        ///att3: CimDatatype  simple value and restriction in-line ou pas in-line
        ///att4: CimDatatype multi  pas in-line 
        ///  
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        /// <returns></returns>
        static XmlSchemaObject transDatatype(EA.Element el, EA.Package apackage, XmlSchema schem)
        {

            XmlSchemaObject ret = null;
            bool inline = false;
            if (IsInline(el))
            {
                inline = true;
            }
            if ((el.ElementID != 0) && (datatypetraite.Contains(el.ElementID)))
            {//  already treated
                return ret;  // return null
            }
            //MessageBox.Show(" treating Datatype" + el.Name);// pour test 

            //datatypetraite.Add(el.ElementID);


            string cas = "datatype";
            EA.Attribute value = null;
            EA.Attribute multiplier = null;
            EA.Attribute unit = null;
            int count = 0;
            if (el.Attributes.Count <= 3)
            {
                foreach (EA.Attribute att in el.Attributes)
                {
                    if (att.Name == "value") { value = att; count++; };
                    if (att.Name == "multiplier") { multiplier = att; count++; };
                    if (att.Name == "unit") { unit = att; count++; };
                }
                if (value != null)
                {
                   // MessageBox.Show(" datatype=" + el.Name + " attribute of name=" + value.Name + " nb contraintes=" + (value.Constraints).Count.ToString());


                    if (!IsValuePrimitive(value.Type))
                    {
                        string texte = "Error there is a CimDatatype" + el.Name + "which has a value" + value.Type + " not being a primitivet";
                        //	MessageBox.Show(texte);
                        reportlog.Write(texte);
                        return ret;
                    };
                    if (count == 1) { cas = "valueseule"; };
                    if ((cas == "valueseule") && (value.Constraints.Count > 0)) { cas = "valueseulerestreinte"; };
                    if ((count == 2) && ((multiplier != null) || (unit != null))) { cas = "valueetmulti"; };
                    if ((count == 3) && (multiplier != null) && (unit != null)) { cas = "valueetmulti"; };
                    if ((cas == "valueetmulti") && (value.Constraints.Count > 0)) {
                        bool rest = true;
                        if ((cas == "valueetmulti") && (value.Constraints.Count == 1) &&
                            ((value.Type == CD.GetFloatType()) || (value.Type == CD.GetStringType()))
                            )
                        {
                            EA.AttributeConstraint co = (EA.AttributeConstraint)(value.Constraints.GetAt(0));
                            if (co.Type == "INV") { cas = "valueetmulti"; rest = false; }
                        }
                        if(rest) cas = "valueetmultirestreinte"; 
                    }
                
                }
                else
                {
                    cas = "datatype";
                }
                if (inline && (cas == "valueetmultirestreinte"))
                {
                    string texte = " WARNING  datatype " + el.Name + " which is restricted and with multiplier or unit cannot be with stereotype  " + CD.GetInlineStereotype() + " it will bee ignored";
                    reportlog.WriteLine(texte);
                    MessageBox.Show(texte);
                    //return ret; // ret=null car interdit
                }
                datatypetraite.Add(el.ElementID);
                switch (cas)
                {
                    case "valueseule":
                        ret = traitValueSeule(apackage, schem, el, value, ret);

                        break;

                    case "valueseulerestreinte":
                        ret = traitValueSeuleRestrainte(apackage, schem, el, value, ret);

                        break;

                    case "valueetmulti":
                        ret = traitValueEtMulti(apackage, schem, el, value, multiplier, unit, ret);
                        break;

                    case "valueetmultirestreinte":
                        ret = traitValueEtMultiRestreinte(apackage, schem, el, value, multiplier, unit, ret);
                        break;

                    case "datatype":
                        ret = traitDatatype(apackage, schem, el, ret);
                        break;
                    default:
                        break;

                }
            }
            return ret;
        }// end if elemnt exits already



        //--------------------------------------------
        //-------------------------------------------
        static void transPrimitive(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            // traitement specifique de la primitive FLOAT (global simple type creation)
     
            {

                if (el.Name == CD.GetFloatType())
                {
                    if (!datatypetraite.Contains(el.ElementID))
                        
                    {
                        datatypetraite.Add(el.ElementID);

                        //-----------------------------------------------------------------------

                        
          if (!LocalDatatypeNames.Contains(CD.GetFloatType()))
          {
              
                      //<xs:simpleType name="Float">

                      XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                      flottant.Name = CD.GetFloatType();
                      schema.Items.Add(flottant);
                      XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                      flottant.Content = union;
                      XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                      union.MemberTypes = members;
                      XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                      flottant.Annotation = flotanno; ;
                      ArrayList reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
                      string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                      AddAppInfoSawdsl(flotanno, reference);
                      if (el.Notes != "")
                      {
                          XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                          flotanno.Items.Add(flotdoc);
                          flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                      }
                      
                  }

              
          
                      /*
                      //<xs:simpleType name="Float">
                      XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                      flottant.Name = CD.GetFloatType();
                      schem.Items.Add(flottant);
                      XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                      flottant.Content = union;
                      XmlQualifiedName[] members;
                      //   members.SetValue( new XmlQualifiedName("double", NS_XSD));
                      // members.SetValue( new XmlQualifiedName("float", NS_XSD));
                      XmlQualifiedName qname = new XmlQualifiedName("double", NS_XSD);
                      union.MemberTypes.SetValue(qname, 0);
                      qname = new XmlQualifiedName("float", NS_XSD);
                      union.MemberTypes.SetValue(qname, 1);
                      */
                    }
                        
                }
            }
        }
        //--------------------------------------------
        //-------------------------------------------
        static XmlSchemaObject transenumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            try
            {
                XmlSchemaObject ret = null;
                bool inline = IsInline(el);
                if ((!inline) && ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID))))
                {
                    ret = null;

                }
                //if ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID)))
                //{
                if (!inline) datatypetraite.Add(el.ElementID);
                // <xs:simpleType name="">
                XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                //if(IsInline(el)) simpptype.Name = el.Name;
                if (!inline)
                {
                    simpptype.Name = el.Name;
                    schem.Items.Add(simpptype);
                }
                else
                {
                    ret = simpptype;

                }
                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();

                simppRestriction.BaseTypeName = new XmlQualifiedName("string", NS_XSD);
                //les facets
                int nombre = el.Attributes.Count;
                EA.Collection attributes = el.Attributes;
                EA.Attribute co;
                for (short i = 0; i < nombre; i++)
                {
                    co = (EA.Attribute)attributes.GetAt(i);
                    AddFacetEnumeration(simppRestriction, co);
                }
                simpptype.Content = simppRestriction;
                // schem.Items.Add(simpptype);
                AddAnnForStx(el, simpptype, false);
                string texte = " le simple element enumeration " + el.Name + " a t ajout au schema";
                reportlog.WriteLine(texte);
                // MessageBox.Show(el.Name + " contrainte");
                EA.Element bel = RDFutilitaires.getElementBasedonElement(el);
                if (bel != null)
                {
                    //          transBaseEnumeration(bel, apackage, schem);
                }
                return ret;
            }
            catch (XmlException e)
            {
                MessageBox.Show(" dans transenumeration :" + e.Message);

            }
            // }
            return null;
        }


        //-------------------------------------------
        static XmlSchemaObject transCodeListEnumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            try
            {
                XmlSchemaObject ret = null;
                bool inline = IsInline(el);
                if ((!inline) && ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID))))
                {
                    ret = null;

                }
                // if ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID)))
                // {
                if (!inline) datatypetraite.Add(el.ElementID);
                // <xs:simpleType name="">
                XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                //simpptype.Name = el.Name;
                if (!inline)
                {
                    simpptype.Name = el.Name;
                    schem.Items.Add(simpptype);
                }
                else
                {
                    ret = simpptype;

                }

                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                string codelistvaluetype = getCodeListValueType(el);
                simppRestriction.BaseTypeName = new XmlQualifiedName(codelistvaluetype, NS_XSD);
                //les facets
                int nombre = el.Attributes.Count;
                EA.Collection attributes = el.Attributes;
                EA.Attribute co;
                for (short i = 0; i < nombre; i++)
                {
                    co = (EA.Attribute)attributes.GetAt(i);
                    AddFacetCodeListEnumeration(simppRestriction, co);
                }
                simpptype.Content = simppRestriction;
                //schem.Items.Add(simpptype);
                AddAnnForStx(el, simpptype, false);
                // MessageBox.Show(el.Name + " contrainte");
                EA.Element bel = RDFutilitaires.getElementBasedonElement(el);
                if (bel != null)
                {
                    //   transBaseEnumeration(bel, apackage, schem);
                }
                return ret;
                //}
            }
            catch (XmlException e)
            {
                MessageBox.Show(" dans transCodelistenumeration :" + e.Message);

            }
            // }
            return null;
        }
        //--------------------------------------------
        //-------------------------------------------
        /// <summary>
        /// create the XSD the enumeration which is the base of an other enumeration
        /// verify that it is not created twice
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        static void transBaseEnumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            //  if (!CreatedEnumerations.Contains(el.ElementID))

            if ((el.ElementID != 0) && (!el.StereotypeEx.Contains(CD.GetPrimitiveStereotype())) && (!datatypetraite.Contains(el.ElementID)))
            {
                // CreatedEnumerations.Add(el.ElementID);
                datatypetraite.Add(el.ElementID);
                if (!LocalDatatypeNames.Contains(el.Name))
                { // there is no classifier with same name
                    if (!datatypetraite.Contains(el.ElementID)) datatypetraite.Add(el.ElementID);
                    // <xs:simpleType name="">
                    XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                    simpptype.Name = el.Name;
                    XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                    simppRestriction.BaseTypeName = new XmlQualifiedName("string", NS_XSD);
                    //les facets
                    int nombre = el.Attributes.Count;
                    EA.Collection attributes = el.Attributes;
                    EA.Attribute co;
                    for (short i = 0; i < nombre; i++)
                    {
                        co = (EA.Attribute)attributes.GetAt(i);
                        AddFacetEnumeration(simppRestriction, co);
                    }
                    simpptype.Content = simppRestriction;
                    schem.Items.Add(simpptype);
                    AddAnnForStx(el, simpptype, false);
                    // MessageBox.Show(el.Name + " contrainte");

                }
                else
                {
                    // a similar name already exists in the package
                    if (!LocalDatatypeIDs.Contains(el.ElementID))
                    {
                        string texte = " WARNING: it seems that you used a type " + el.Name + " which was already been defined in the profile\n";
                        texte = texte + " the reference has been made to the already  defined local type";
                        MessageBox.Show(texte);
                        reportlog.WriteLine(texte);
                    }
                }
            }
        }
        //--------------------------------------------
        //-------------------------------------------
        static XmlSchemaObject transCompound(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            return transClass(el, apackage, schem);
        }
        //--------------------------------------------
        public static XmlNode[] TextToNodeArray(string text)
        {
            XmlDocument doc = new XmlDocument();
            return new XmlNode[1] {
                   doc.CreateTextNode(text)};
        }
        //-----------------------------------------
        static void ContainmentPath(EA.Package pa, List<String> path)
        {
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
            {
                ContainmentPath(RDFutilitaires.dicrepobyid[pa.ParentID], path);

            }
        }
        //-----------------------------------------------------
        static void AddFacet(XmlSchemaSimpleTypeRestriction rest, EA.AttributeConstraint co)
        {
            string[] fac = {"fractiondigits","length","maxexclusive","maxinclusive","maxlength","minexclusive","mininclusive","minlength","pattern","totaldigits","whitespace","enumeration"
    };



            List<string> facets = new List<string>(fac);
            string notes = RDFutilitaires.RemoveRc(co.Notes);
            notes = notes.ToLower();
            int ind1 = notes.IndexOf("->"); // position de operateur OCL
            int ind2 = notes.IndexOf('('); // parenthese fermante de operateur , suppose aucune parenthese pealable
            int ind3 = notes.IndexOf(')');
            if (!(ind1 > 0) || !(ind2 > ind1 + 2) || !(ind3 > ind1 + 3))
            {
                string texte = " ATTENTION la contrainte " + co.Name + " contient " + notes + " et semble mal formee";
                reportlog.WriteLine(texte);
                return;
            }
            string s = notes.Substring(ind1 + 2, ind2 - ind1 - 2);
            string value = notes.Substring(ind2 + 1, ind3 - ind2 - 1);
            if (!facets.Contains(s))
            {
                string texte = " ATTENTION operateur dans la contrainte " + co.Name + " de contenu" + notes + " pas une facette valide pour XML";
                reportlog.WriteLine(texte);
                return;
            }

            switch (s)
            {
                case "fractiondigits":
                    XmlSchemaFractionDigitsFacet fa = new XmlSchemaFractionDigitsFacet();
                    fa.Value = value;
                    rest.Facets.Add(fa);
                    break;
                case "length":
                    XmlSchemaLengthFacet length = new XmlSchemaLengthFacet();
                    length.Value = value;
                    rest.Facets.Add(length);
                    break;
                case "maxexclusive":
                    XmlSchemaMaxExclusiveFacet maxexclusive = new XmlSchemaMaxExclusiveFacet();
                    maxexclusive.Value = value;
                    rest.Facets.Add(maxexclusive);
                    break;
                case "maxinclusive":
                    XmlSchemaMaxInclusiveFacet maxinclusive = new XmlSchemaMaxInclusiveFacet();
                    maxinclusive.Value = value;
                    rest.Facets.Add(maxinclusive);
                    break;
                case "maxlength":
                    XmlSchemaMaxLengthFacet maxlength = new XmlSchemaMaxLengthFacet();
                    maxlength.Value = value;
                    rest.Facets.Add(maxlength);
                    break;
                case "minexclusive":
                    XmlSchemaMinExclusiveFacet minexclusive = new XmlSchemaMinExclusiveFacet();
                    minexclusive.Value = value;
                    rest.Facets.Add(minexclusive);
                    break;
                case "mininclusive":
                    XmlSchemaMinInclusiveFacet mininclusive = new XmlSchemaMinInclusiveFacet();
                    mininclusive.Value = value;
                    rest.Facets.Add(mininclusive);
                    break;
                case "minlength":
                    XmlSchemaMinLengthFacet minlength = new XmlSchemaMinLengthFacet();
                    minlength.Value = value;
                    rest.Facets.Add(minlength);
                    break;
                case "pattern":
                    XmlSchemaPatternFacet pattern = new XmlSchemaPatternFacet();
                    pattern.Value = value;
                    rest.Facets.Add(pattern);
                    break;
                case "totaldigits":
                    XmlSchemaTotalDigitsFacet totaldigits = new XmlSchemaTotalDigitsFacet();
                    totaldigits.Value = value;
                    rest.Facets.Add(totaldigits);
                    break;
                case "whitespace":
                    XmlSchemaWhiteSpaceFacet whitespace = new XmlSchemaWhiteSpaceFacet();
                    whitespace.Value = value;
                    rest.Facets.Add(whitespace);
                    break;
                case "enumeration":
                    XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                    enumeration.Value = value;
                    rest.Facets.Add(enumeration);
                    break;
                default:

                    break;
            }
        }

        //-----------------------------------------------------------
        /// <summary>
        /// add a facet xith precision for Float facet
        /// </summary>
        /// <param name="rest"></param>
        /// <param name="co"></param>
        /// <param name="precision"></param>
        static void AddFacet(XmlSchemaSimpleTypeRestriction rest, EA.AttributeConstraint co, string precision)
        {
            string[] fac = {"fractiondigits","length","maxexclusive","maxinclusive","maxlength","minexclusive","mininclusive","minlength","pattern","totaldigits","whitespace","enumeration"
    };



            List<string> facets = new List<string>(fac);
            string notes = RDFutilitaires.RemoveRc(co.Notes);
            notes = notes.ToLower();
            foreach (string s in facets)
            {
                string op = s + "(";
                if (notes.Contains(op))
                {
                    string[] split = notes.Split(new Char[] { '(', ')' });
                    string value = split[1];
                    switch (s)
                    {
                        case "fractiondigits":
                            XmlSchemaFractionDigitsFacet fa = new XmlSchemaFractionDigitsFacet();
                            fa.Value = value;
                            rest.Facets.Add(fa);
                            break;
                        case "length":
                            XmlSchemaLengthFacet length = new XmlSchemaLengthFacet();
                            length.Value = value;
                            rest.Facets.Add(length);
                            break;
                        case "maxexclusive":
                            XmlSchemaMaxExclusiveFacet maxexclusive = new XmlSchemaMaxExclusiveFacet();
                            maxexclusive.Value = value;
                            rest.Facets.Add(maxexclusive);
                            break;
                        case "maxinclusive":
                            XmlSchemaMaxInclusiveFacet maxinclusive = new XmlSchemaMaxInclusiveFacet();
                            maxinclusive.Value = value;
                            rest.Facets.Add(maxinclusive);
                            break;
                        case "maxlength":
                            XmlSchemaMaxLengthFacet maxlength = new XmlSchemaMaxLengthFacet();
                            maxlength.Value = value;
                            rest.Facets.Add(maxlength);
                            break;
                        case "minexclusive":
                            XmlSchemaMinExclusiveFacet minexclusive = new XmlSchemaMinExclusiveFacet();
                            minexclusive.Value = value;
                            rest.Facets.Add(minexclusive);
                            break;
                        case "mininclusive":
                            XmlSchemaMinInclusiveFacet mininclusive = new XmlSchemaMinInclusiveFacet();
                            mininclusive.Value = value;
                            rest.Facets.Add(mininclusive);
                            break;
                        case "minlength":
                            XmlSchemaMinLengthFacet minlength = new XmlSchemaMinLengthFacet();
                            minlength.Value = value;
                            rest.Facets.Add(minlength);
                            break;
                        case "pattern":
                            XmlSchemaPatternFacet pattern = new XmlSchemaPatternFacet();
                            pattern.Value = value;
                            rest.Facets.Add(pattern);
                            break;
                        case "totaldigits":
                            XmlSchemaTotalDigitsFacet totaldigits = new XmlSchemaTotalDigitsFacet();
                            totaldigits.Value = value;
                            rest.Facets.Add(totaldigits);
                            break;
                        case "whitespace":
                            XmlSchemaWhiteSpaceFacet whitespace = new XmlSchemaWhiteSpaceFacet();
                            whitespace.Value = value;
                            rest.Facets.Add(whitespace);
                            break;
                        case "enumeration":
                            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                            enumeration.Value = value;
                            rest.Facets.Add(enumeration);
                            break;
                        default:
                            break;
                    }
                }
            }
        }
        //-----------------------------------------------------------

        static void AddFacetEnumeration(XmlSchemaSimpleTypeRestriction rest, EA.Attribute co)
        {
            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
            enumeration.Value = co.Name;
            rest.Facets.Add(enumeration);
        }
        //-----------------------------------------------------------

        static void AddFacetCodeListEnumeration(XmlSchemaSimpleTypeRestriction rest, EA.Attribute at)
        {
            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
            enumeration.Value = at.Style;
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            enumeration.Annotation = ann;
            AddDocCat(ann, "enumValue", "", at.Name, "");
            rest.Facets.Add(enumeration);
        }
        //----------------------------------------------------------------------------

        public static void transConnector(EA.Element el, XmlSchemaSequence sequence, EA.Connector con)
        {

            if (con.Type == "Association" ||
                      con.Type == "Aggregation")
            {

                Connexion conex = new Connexion(con);


                //  MessageBox.Show("elem=" + el.Name + " se= " + conex.Source_element.Name + " te= " + conex.Target_element.Name );

                // we decide to treat only the otherend with a role name and if it is not abstract

                if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                {

                    if (conex.Target_element.Abstract == "0")
                    { //the other end class is concrete


                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {
                            if (conex.Target_element.Abstract == "0")
                            { //the other end class is concrete

                                if (conex.Target.Containment == "Reference")
                                {
                                    //AddElementRef(sequence, getMrid(el), conex.Target_element.Name, conex.Target.Cardinality);
                                    AddElementRef(sequence, getMrid(el), conex.Target_element, conex.Target);
                                }
                                else
                                {
                                    string rolname = conex.Target.Role;
                                    if (IsRoleClass(conex.Target.Role, con.ConnectorGUID))
                                    { //  rolename=classname in original asssociation
                                        // this is systematic even if the role is unique
                                        string[] split = ((conex.Target).Role).Split(new char[] { '_' });
                                        string qualifier = "";
                                        if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                        if (qualifier != "")
                                        {
                                            rolname = qualifier + "_" + conex.Target_element.Name;
                                        }
                                        else
                                        {
                                            rolname = conex.Target_element.Name;
                                        }
                                    }
                                    else
                                    {
                                        if (IsRoleNotUnique((conex.Target).Role))
                                        { // 
                                            rolname = (conex.Target).Role + "-" + conex.Target_element.Name;
                                        }
                                    }
                                    AddElement(sequence, rolname, conex.Target_element.Name, conex.Target_element, conex.Target);
                                }
                            }
                        }
                    }
                }
                if (conex.Target_element.ElementID == el.ElementID)
                {//the other end is a source
                    if (conex.Source_element.Abstract == "0")
                    { //the other end class is concrete


                        if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                        {

                            if ((conex.Source).Containment == "Reference")
                            {

                                // AddElementRef(sequence,getMrid(el),conex.Source_element.Name,(conex.Source).Cardinality);   
                                AddElementRef(sequence, getMrid(el), conex.Source_element, conex.Source);
                            }
                            else
                            {

                                // AddElement(sequence, (conex.Source).Role, conex.Source_element.Name,(Conex.Source).Cardinality);
                                string rolname = (conex.Source).Role;
                                if (IsRoleClass((conex.Source).Role, con.ConnectorGUID))
                                { //  rolename=classname in original asssociation
                                    string[] split = ((conex.Source).Role).Split(new char[] { '_' });
                                    string qualifier = "";
                                    if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                    if (qualifier != "")
                                    {
                                        rolname = qualifier + "_" + conex.Source_element.Name;
                                    }
                                    else
                                    {
                                        rolname = conex.Source_element.Name;
                                    }
                                }
                                else
                                {
                                    if (IsRoleNotUnique((conex.Source).Role))
                                    {
                                        rolname = (conex.Source).Role + "-" + conex.Source_element.Name;
                                    }
                                }
                                AddElement(sequence, rolname, conex.Source_element.Name, conex.Source_element, conex.Source);
                            }
                        }
                    }
                }

            }
        }

        //----------------------------------------------------------------------------------------
        public static void transChoiceConnector(EA.Element el, XmlSchemaSequence sequence, List<EA.Connector> cons)
        {
            string conids = "";
            foreach (EA.Connector co in cons)
            {
                conids = conids + " ConID=" + (co.ConnectorID).ToString() + "|";
            }
            //MessageBox.Show(" elementName=" + el.Name + "|" + conids);

            bool atraiter = true;

            XmlSchemaChoice choice = new XmlSchemaChoice();

            foreach (EA.Connector con in cons)
            {

                if (con.Type == "Association" ||
                          con.Type == "Aggregation")
                {

                    EA.Element source_element = RDFutilitaires.dicelembyid[con.ClientID];
                    EA.Element target_element = RDFutilitaires.dicelembyid[con.SupplierID];
                    EA.ConnectorEnd source = con.ClientEnd;
                    EA.ConnectorEnd target = con.SupplierEnd;
                    //  MessageBox.Show("elem=" + el.Name + " se= " + source_element.Name + " te= " + target_element.Name );
                    bool isAggregatesource = false;
                    bool isAggregatetarget = false;

                    if (con.Type == "Aggregation" || source.Aggregation == 1)
                    {
                        isAggregatesource = true;
                    }
                    if (con.Type == "Aggregation" || target.Aggregation == 1) // achtoung doute
                    {
                        isAggregatetarget = true;
                    }


                    // we decide to treat only the otherend with a role name
                    if (((source_element.ElementID == el.ElementID)
                               && ((target.Containment == "Reference") || (target.Role != "")))
                             ||
                            ((target_element.ElementID == el.ElementID)
                               && ((source.Containment == "Reference") || (source.Role != ""))))
                    {
                        if (atraiter)
                        {
                            // sequence.Items.Add(cxtype);
                            sequence.Items.Add(choice);

                            atraiter = false;
                        }
                    }


                    if (source_element.ElementID == el.ElementID)
                    {

                        if (target.Containment == "Reference")
                        {
                            // AddElementRefChoice(choice, getMrid(el), target.Role, target.Cardinality);
                            AddElementRefChoice(choice, getMrid(el), source_element, target);
                        }
                        else
                        {

                            if ((target.Role != "") && !isAggregatetarget)
                            {
                                //    AddElementChoice(choice, target.Role, target.Role, target.Cardinality);
                                string rolname = target.Role;
                                if (IsRoleClass(target.Role, con.ConnectorGUID))
                                { //  rolename=classname in original asssociation
                                    string[] split = (target.Role).Split(new char[] { '_' });
                                    string qualifier = "";
                                    if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                    if (qualifier != "")
                                    {
                                        rolname = qualifier + "_" + target_element.Name;
                                    }
                                    else
                                    {
                                        rolname = target_element.Name;
                                    }
                                }
                                else
                                {
                                    if (IsRoleNotUnique(target.Role))
                                    {
                                        rolname = target.Role + "-" + target_element.Name;
                                    }
                                }

                                AddElementChoice(choice, rolname, target_element.Name, source_element, target);
                            }
                        }
                    }
                    if (target_element.ElementID == el.ElementID)
                    {

                        if (source.Containment == "Reference")
                        {

                            //  AddElementRefChoice(choice, getMrid(el), source.Role, source.Cardinality);
                            AddElementRefChoice(choice, getMrid(el), target_element, source);
                        }
                        else
                        {
                            if ((source.Role != "") && !isAggregatesource)
                            {
                                string rolname = source.Role;

                                if (IsRoleClass(source.Role, con.ConnectorGUID))
                                { //  rolename=classname in original asssociation
                                    string[] split = (source.Role).Split(new char[] { '_' });
                                    string qualifier = "";
                                    if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                    if (qualifier != "")
                                    {
                                        rolname = qualifier + "_" + source_element.Name;
                                    }
                                    else
                                    {
                                        rolname = source_element.Name;
                                    }
                                }
                                else
                                {
                                    if (IsRoleNotUnique(source.Role))
                                    {

                                        rolname = source.Role + "-" + source_element.Name;
                                    }
                                }

                                AddElementChoice(choice, rolname, source_element.Name, target_element, source);

                            }
                        }
                    }
                }
            }



        }
        //-----------------------------------------------------------------------------------------
        static void AddElement(XmlSchemaSequence sequence, string name, string atrtype, EA.Element otherelementend, EA.ConnectorEnd end)
        {

            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                sequence.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                if (IsInline(otherelementend))
                { // element inline
                    if (!dicInline.ContainsKey(otherelementend.ElementID))
                    { //the member is inline
                        dicInline.Add(otherelementend.ElementID, otherelementend);
                    }
                    XmlSchemaObject sobj = TraitElem(otherelementend, Repos.GetPackageByID(otherelementend.PackageID), schema);
                    if (sobj != null)
                    {
                        string xmltyp = sobj.GetType().ToString();
                        switch (xmltyp)
                        {
                            case "System.Xml.Schema.XmlSchemaComplexType":
                                nel.SchemaType = (XmlSchemaComplexType)sobj;
                                break;
                            case "System.Xml.Schema.XmlSchemaSimpleType":
                                nel.SchemaType = (XmlSchemaSimpleType)sobj;
                                break;
                            default:
                                break;
                        }
                    }
                }
                else
                {
                    nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                }

                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if ((split.Length != 1) && (split.Length != 3))
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }
                AddAnnForAssociationEnd(otherelementend, nel, end, false);
            }
            catch (Exception e)
            {
                MessageBox.Show("3-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR while adding an element to a squence {0} ", e.Message);
                return;
            }
        }

        //--------------------------
        static void AddElementRef(XmlSchemaSequence sequence, string reff, EA.Element elementend, EA.ConnectorEnd end)
        {
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                sequence.Items.Add(nel);

                nel.Name = end.Role;
                // string atrtype = type;
                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }

                AddAnnForAssociationEnd(elementend, nel, end, false);

                XmlSchemaComplexType complexType = new XmlSchemaComplexType();
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;



                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;

                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);
            }
            catch (Exception e)
            {
                MessageBox.Show("4-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an AssociationEnd {0} | {1}", end.Role);
            }
        }
        //
        //------------------------------------------------
        static void AddAnnTagForXmlAttribute(XmlSchemaAttribute attribute, EA.ConnectorEnd end, string tagname)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            attribute.Annotation = ann;
            //==============    treatment of  tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                if (tag.Tag == tagname)
                {
                    AddSpecDocCat(ann, "TagValue", tag.Tag, tag.Value, "");
                    break;
                }

            }
        }
        //-----------------------------------------------------------------------------------------
        static void AddElementChoice(XmlSchemaChoice choice, string name, string atrtype, EA.Element elementend, EA.ConnectorEnd end)
        {
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }
                AddAnnForAssociationEnd(elementend, nel, end, false);
            }
            catch (Exception e)
            {
                MessageBox.Show("5-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an choice AssociationEnd {0} | {1}", end.Role);

            }
        }


        //------------------------------------------------------------
        //--------------------------
        static void AddElementRefChoice(XmlSchemaChoice choice, string reff, EA.Element elementend, EA.ConnectorEnd end)
        {
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);

                nel.Name = end.Role;
                // string atrtype = type;
                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }
                AddAnnForAssociationEnd(elementend, nel, end, false);
                XmlSchemaComplexType complexType = new XmlSchemaComplexType();
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;




                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;
                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);


            }
            catch (Exception e)
            {
                MessageBox.Show("6-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an reference choice AssociationEnd {0} | {1}", end.Role);
            }
        }

        //-----------------------------------------------------------------------------------------

        static void AddAppInfoSawdsl(XmlSchemaAnnotation ann, string refstring, string abstrac)
        {

            XmlSchemaAppInfo ressource = new XmlSchemaAppInfo();
            ann.Items.Add(ressource);


            string bontexte = "<newattributes>"
                               + "<attribute name='modelReference'>"

                               + refstring

                               + "</attribute>";

            if (abstrac != "0")
            {
                bontexte = bontexte + "<attribute name='abstract'>"

                                    + "true"

                                    + "</attribute>";
            }

            bontexte = bontexte + "</newattributes>";
            bontexte = bontexte.Normalize();
            ressource.Markup = TextToNodeArray(bontexte);
        }

        /// <summary>
        /// add sawdsl to an annotation
        /// </summary>
        /// <param name="ann"></param>
        /// <param name="refstring"></param>
        static void AddAppInfoSawdsl(XmlSchemaAnnotation ann, string refstring)
        {

            XmlSchemaAppInfo ressource = new XmlSchemaAppInfo();
            ann.Items.Add(ressource);


            string bontexte = "<newattributes>"
                               + "<attribute name='modelReference'>"

                               + refstring

                               + "</attribute>"
                               + "</newattributes>";

            bontexte = bontexte.Normalize();
            ressource.Markup = TextToNodeArray(bontexte);
        }
        //-----------------------------------------------------------------------------------------


        static void AddDocCat(XmlSchemaAnnotation ann, string category, string subcategory, string value, string notes)
        {
            // <xs:documentation><m:category name='tagvalue'>toto</m:category></xs:documentation>
            //we introduce a filter for certain categories like tagvalues
            if (!CD.GetAnnCategoryOption()) { return; } // nothing to do if option is absent
            if (!profparameters.TagValuesToFiler.Contains(subcategory))
            {

                XmlSchemaDocumentation categorie = new XmlSchemaDocumentation();
                ann.Items.Add(categorie);

                string bontexte = "<newattributes>"
                                   + "<attribute name='category'>" + category + "</attribute>\n";
                if (subcategory != "")
                {
                    bontexte = bontexte + "<attribute name='subcategory'>" + subcategory + "</attribute>\n";
                }
                if (notes != "")
                {
                    bontexte = bontexte + "<attribute name='notes'>" + notes + "</attribute>\n";
                }
                bontexte = bontexte + "<attribute name='content'>" + value + "</attribute>\n"
                + "</newattributes>";
                bontexte = bontexte.Normalize();
                categorie.Markup = TextToNodeArray(bontexte);

            }
        }

        //--------------------------------------------------------
        /// <summary>
        /// action according to special names of subcategory
        /// </summary>
        /// <param name="ann"></param>
        /// <param name="category"></param>
        /// <param name="subcategory"></param>
        /// <param name="value"></param>
        /// <param name="notes"></param>
        static void AddSpecDocCat(XmlSchemaAnnotation ann, string category, string subcategory, string value, string notes)
        {
            // <xs:documentation><m:category name='tagvalue'>toto</m:category></xs:documentation>
            //we introduce a filter for certain categories like tagvalues
            if (!CD.GetAnnCategoryOption()) { return; } // nothing to do if option is absent
            if (profparameters.TagValuesToFiler.Contains(subcategory))
            {

                switch (subcategory)
                {
                    case XMLProfileParameters.Referencetypes:

                        subcategory = "";

                        XmlSchemaDocumentation categorie = new XmlSchemaDocumentation();
                        ann.Items.Add(categorie);

                        string bontexte = "<newattributes>"
                                           + "<attribute name='category'>" + XMLProfileParameters.Referencetypes + "</attribute>\n";
                        if (subcategory != "")
                        {
                            bontexte = bontexte + "<attribute name='subcategory'>" + subcategory + "</attribute>\n";
                        }
                        if (notes != "")
                        {
                            bontexte = bontexte + "<attribute name='notes'>" + notes + "</attribute>\n";
                        }
                        bontexte = bontexte + "<attribute name='content'>" + value + "</attribute>\n"
                        + "</newattributes>";
                        bontexte = bontexte.Normalize();
                        categorie.Markup = TextToNodeArray(bontexte);

                        break;
                    default:
                        break;
                }
            }
        }


        //------------------------------------------------------------------------------------------------------

        static string getMrid(EA.Element el)
        {
            string result = "";
            foreach (EA.Attribute at in el.Attributes)
            {
                if (at.Name == "mRID") result = at.Type;
            }
            return result;
        }

        //------------------------------------------------------------

        public static void Schemarecopie(XMLProfileParameters profparams)
        {

            //string toto = "prov";

            XmlDocument doc = new XmlDocument();
            try
            {


                TextReader FileReader = new StreamReader("XSDexample.xsd");
                doc.Load(FileReader);



                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xs", NS_XSD);
                nsmgr.AddNamespace(profparams.Prefix, profparams.TargetNamespace);
                nsmgr.AddNamespace("cimp", NS_CIMP);



                //on repere les partie <documentation
                XmlNodeList nodeList;


                nodeList = doc.SelectNodes("xs:schema//xs:documentation", nsmgr);

                foreach (XmlElement noeud in nodeList)
                {
                    string contenu = noeud.InnerText;
                    //MessageBox.Show("type noeud= "+ noeud.NodeType);
                    // MessageBox.Show(contenu);
                    string contenudoc = null;
                    if (contenu.StartsWith("<"))
                    {
                        XmlDocument dd = new XmlDocument();
                        dd.LoadXml(contenu);
                        XmlNodeList nList;
                        nList = dd.SelectNodes("newattributes/attribute");
                        foreach (XmlNode nn in nList)
                        {
                            if (nn != null)
                            {
                                string contient = nn.InnerText;
                                XmlAttributeCollection atcol = nn.Attributes;
                                foreach (XmlNode at in atcol)
                                {

                                    //MessageBox.Show(" | " + "LocalName=" + at.LocalName + "|" + "value=" + at.Value + "|" + "contenu=" + contient);
                                    // on modifie le document d'origine en ajoutant un attribut qui n'est pas dans le namespace xs

                                    if (at.Value == "content")
                                    {
                                        contenudoc = contient;
                                    }
                                    else
                                    {
                                        XmlAttribute batr = doc.CreateAttribute(at.Value, NS_CIMP);
                                        //batr.Prefix = "m:";

                                        batr.Value = contient;
                                        noeud.SetAttributeNode(batr);

                                    }

                                }
                            }
                        }
                        noeud.InnerText = contenudoc;
                    }
                }

                //------------------------------------------------------------------------------
                nodeList = doc.SelectNodes("xs:schema//xs:appinfo", nsmgr);


                XmlElement noeudparent;
                XmlNode noeudGdparent;

                foreach (XmlElement noeud in nodeList)
                {

                    string contenu = noeud.InnerText;
                    //   MessageBox.Show("type noeud= "+ noeud.NodeType);
                    //   MessageBox.Show(contenu);
                    string contenudoc = null;
                    if (contenu.StartsWith("<"))
                    {
                        XmlDocument dd = new XmlDocument();
                        dd.LoadXml(contenu);
                        XmlNodeList nList;
                        nList = dd.SelectNodes("newattributes/attribute");
                        foreach (XmlNode nn in nList)
                        {
                            if (nn != null)
                            {
                                string contient = nn.InnerText;
                                XmlAttributeCollection atcol = nn.Attributes;
                                foreach (XmlNode at in atcol)
                                {

                                    // MessageBox.Show(" | " + "LocalName=" + at.LocalName + "|" + "value=" + at.Value + "|" + "contenu=" + contient);
                                    // on modifie le document d'origine en ajoutant un attribut qui n'est pas dans le namespace xs

                                    if (at.Value == "content")
                                    {
                                        contenudoc = contient;
                                    }
                                    else
                                    {
                                        XmlAttribute batr = doc.CreateAttribute(at.Value, NS_SAWSDL);
                                        //batr.Prefix = "sawsdl";
                                        batr.Value = contient;
                                        noeud.InnerText = contenudoc;
                                        noeudGdparent = (noeud.ParentNode).ParentNode;
                                        ((XmlElement)noeudGdparent).SetAttributeNode(batr);
                                    }
                                }
                            }
                        }

                        noeudparent = (XmlElement)noeud.ParentNode;
                        noeudGdparent = (noeud.ParentNode).ParentNode;
                        noeudparent.RemoveChild(noeud);
                        // we go up one level to see if there is any doc left and if not remove the annotation node
                        /*        
                    // XmlNodeList nnList = noeudGdparent.SelectNodes("xs:Annotation/xs:documentation", nsmgr);
                            string innercontenu=noeudparent.InnerText; 
                            if((innercontenu == "" ) 
                    */
                        /*
                          XmlElement nodeparent = (XmlElement)noeud.ParentNode; // we go up to the xs:annotation
                          if (nodeparent.InnerText == "")
                          { // if there are no other document in the annotation
                              XmlElement nodeGdparent = (XmlElement)(noeud.ParentNode).ParentNode;// then we go up to the above element
                              nodeGdparent.RemoveChild(nodeparent);// then we remove completly the annotation
                          }
   
                       */
                    }
                }

                //----------------------------------------------------------------------------

                TextWriter FileWriter = new StreamWriter(profparams.CurrentXSDFilePath);
                XmlTextWriter writer = new XmlTextWriter(FileWriter);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Flush();
                writer.Close();
                FileReader.Close();
                FileReader.Dispose();
                string path = "./" + nomfic;
                try
                {
                    //   MessageBox.Show(" for test no delete of " + path);
                    // System.IO.File.Delete(path);
                }
                catch (Exception e)
                {
                    MessageBox.Show("30-CIMSchemagenerator Error : " + e.Message);
                    reportlog.WriteLine("\t\t !!!ERROR  file {0} access", nomfic);
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("7-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR while creating final file from  intermediate file {0} ", e.Message);
            }




        }
        //  -----------------------------------------
        static void AddAnnForCtx(EA.Element el, XmlSchemaComplexType ct, bool origin)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            ct.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            AddAppInfoSawdsl(ann, reference);
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }

            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }
            }

        }
        //--------------------------------------------------------------
        static void AddAnnForStx(EA.Element el, XmlSchemaSimpleType st, bool origin)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            st.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
            // string basedonel = RDFutilitaires.getElementBasedonElement;
            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            AddAppInfoSawdsl(ann, reference);
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype stt in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", stt.Name, RDFutilitaires.RemoveRc(stt.Notes));

                }
            }

        }

        //--------------------------------------------------------------
        static void AddAnnForStxBase(EA.Element el, XmlSchemaSimpleType st)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            st.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            AddAppInfoSawdsl(ann, reference);
            /*
              //<xs:documentation>[the class notes]</xs:documentation>
                         if (el.Notes != "")
                         {
                             XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                             ann.Items.Add(notes);
                             notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                         }
            */

        }


        //-----------------------------------------------------------
        static void AddAnnForAtr(EA.Element el, XmlSchemaElement elt, EA.Attribute atr, bool origin)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            elt.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>

            ArrayList reff;
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);

            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);

            }
            // string basedonel = RDFutilitaires.getElementBasedonElement;

            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + elt.Name;
            AddAppInfoSawdsl(ann, reference);
            //<xs:documentation>[the class notes]</xs:documentation>
            if (atr.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(atr.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.AttributeTag tag in atr.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.AttributeConstraint aconstrt in atr.Constraints)
            {
                AddDocCat(ann, "Constrtraint", aconstrt.Name, aconstrt.Type, RDFutilitaires.RemoveRc(aconstrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = atr.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }
            }
        }
        //-----------------------------------------------------------

        //  -----------------------------------------
        static void AddAnnForClass(EA.Element el, XmlSchemaComplexType ct, bool origin)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            ct.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;

            AddAppInfoSawdsl(ann, reference);
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    if (RDFutilitaires.dicstereobyname.ContainsKey(split[i]))
                    {
                        stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                    }
                    else
                    {
                        MessageBox.Show("Error " + split[i] + "seems to be pure texte and not a UML EA stereotype");
                        reportlog.WriteLine("Error " + split[i] + "seems to be pure texte and not a UML EA stereotype");
                    }
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }

            }

        }

        //  -----------------------------------------
        static void AddAnnForAssociationEnd(EA.Element el, XmlSchemaElement nel, EA.ConnectorEnd end, bool origin)
        {
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            nel.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
            string role = "";
            string[] split = { "" };
            char[] delimit = { '_' };
            if (end.Role != "") split = (end.Role).Split(delimit);
            if (split.Length == 1) { role = split[0]; } else { role = split[1]; };
            string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + role;

            AddAppInfoSawdsl(ann, reference);
            //<xs:documentation>[the class notes]</xs:documentation>
            if (end.RoleNote != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(end.RoleNote));
            }
            //==============    treatment of tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Tag, tag.Value, "");

            }

        }
        //--------------------------------------------------------------------------------------------------
        static public void AddDataType(EA.Attribute at, EA.Package apackage, XmlSchema schem)
        {
            long classifierid = at.ClassifierID;
            if ((classifierid != 0) && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];

                string classtereos = classifier.StereotypeEx;

                if ((classtereos != "") && (!classtereos.Contains(CD.GetPrimitiveStereotype())))
                {
                    if (!datatypetraite.Contains(classifierid))
                    {
                        CreateDatatypIfNeeded(classifierid, apackage, schem);
                        // TraitElem(classifier,apackage,schem);
                    }
                }
            }
        }


        //--------------------------------------------------------------------------------------------------
        static public void initDicSamerolesbyname(EA.Element el)
        {
            //++++
            // treatment of the connectors
            EA.Collection connectors = el.Connectors;
            foreach (EA.Connector con in connectors)
            {
                // we consider only the other end
                if (con.Type == "Association" ||
                            con.Type == "Aggregation")
                {
                    Connexion conex = new Connexion(con);

                    // we decide to treat only the otherend with a role name

                    if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                    {
                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Target.Role))
                            {  // 
                                dicsamerolesbyname[conex.Target.Role].Add(con.SupplierID);

                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Target.Role, new List<long>() { con.SupplierID });
                            }
                        }
                    }
                    if (conex.Target_element.ElementID == el.ElementID)  //the otherend is source
                    {
                        if ((conex.Source.Role != "") && conex.SourceAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Source.Role))
                            {  // 
                                dicsamerolesbyname[conex.Source.Role].Add(con.ClientID);
                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Source.Role, new List<long>() { con.ClientID });
                            }
                        }
                    }
                }
            }

            // ++++
            //treatment of the inherited connections
            if (inheritedconex.ContainsKey(el.ElementID))
            {
                List<Connexion> conexes = inheritedconex[el.ElementID];
                foreach (Connexion conex in conexes)
                {
                    // we consider only the other end
                    EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);
                    // we decide to treat only the otherend with a role name

                    if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                    {
                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Target.Role))
                            {  // 
                                dicsamerolesbyname[conex.Target.Role].Add(con.SupplierID);

                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Target.Role, new List<long>() { con.SupplierID });
                            }
                        }
                    }
                    if (conex.Target_element.ElementID == el.ElementID)  //the otherend is source
                    {
                        if ((conex.Source.Role != "") && conex.SourceAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Source.Role))
                            {  // 
                                dicsamerolesbyname[conex.Source.Role].Add(con.ClientID);
                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Source.Role, new List<long>() { con.ClientID });
                            }
                        }
                    }
                }
            }
            Dictionary<string, List<long>>.KeyCollection names = dicsamerolesbyname.Keys;
            List<string> toberemoved = new List<string>();
            foreach (string key in names)
            {
                if (dicsamerolesbyname[key].Count < 2)
                    toberemoved.Add(key);
            }
            foreach (string key in toberemoved)
            {
                dicsamerolesbyname.Remove(key);
            }

        }


        //--------------------------------------------------------------------------------------------------

        static bool IsRoleNotUnique(string role)
        {  //decide si ce nom de role est unique pour un element donne
            bool ret = false;
            if (dicsamerolesbyname.Count == 0) return ret;
            if (!dicsamerolesbyname.ContainsKey(role)) return ret;
            ret = true;
            return ret;
        }
        //--------------------------------------------------------------------------------------------------

        static bool IsRoleClass(string role, string guid)
        {  //decide si ce nom de role doit etre le nom de la classe associe
            bool ret = false;
            string guidorg = RDFutilitaires.getOriginBasedOnConnectorbyGUID(Repos, guid); // find the original association
            if (guidorg == "") return ret;
            EA.Connector conorg = Repos.GetConnectorByGuid(guidorg);
            EA.ConnectorEnd source = conorg.ClientEnd;
            EA.ConnectorEnd target = conorg.SupplierEnd;
            EA.Element source_element = RDFutilitaires.dicelembyid[conorg.ClientID];
            EA.Element target_element = RDFutilitaires.dicelembyid[conorg.SupplierID];
            if (RDFutilitaires.RemoveQual(role) == source_element.Name)
            {
                ret = true;
            }
            else
            {
                if (RDFutilitaires.RemoveQual(role) == target_element.Name) ret = true;
            }
            return ret;
        }
        static void setAtrTypeName(XmlSchemaAttribute sat, EA.Attribute eat, EA.Package apackage, XmlSchema schem)
        {
            // Be careful: we presuppose here that eat  has a type based on string and there is no control of tha fact
            string atrtype = eat.Type;
            long classifierid = eat.ClassifierID;
            if ((classifierid != 0) && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];

                string classtereos = "";

                classtereos = classifier.StereotypeEx;

                if ((classtereos != "") && (classtereos.Contains(CD.GetPrimitiveStereotype())))
                {
                    sat.SchemaTypeName = new XmlQualifiedName(classifier.Name.ToLower(), NS_XSD);
                }
                else
                {
                    if (!IsInline(classifier))
                    {
                        sat.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                        if (!datatypetraite.Contains(classifierid))
                        {
                            CreateDatatypIfNeeded(classifierid, apackage, schem);
                        }
                    }
                    else
                    {
                        if (!dicInline.ContainsKey(classifier.ElementID)) dicInline.Add(classifier.ElementID, classifier);
                        XmlSchemaObject sobj = TraitElem(classifier, apackage, schem);
                        string xmltyp = sobj.GetType().ToString();
                        if (xmltyp != "System.Xml.Schema.XmlSchemaSimpleType")
                        {
                            sat.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                        }
                        else
                        {
                            sat.SchemaType = (XmlSchemaSimpleType)sobj;

                        }

                    }
                }
            }
            else
            {
                //in that case atrtype should be String or string for multiplier or unit
                if ((atrtype == "string") || (atrtype == CD.GetStringType()))
                {
                    sat.SchemaTypeName = new XmlQualifiedName(atrtype.ToLower(), NS_XSD);
                }
                else
                {
                    MessageBox.Show("Error!   multiplier or unit should be based on String");
                    reportlog.WriteLine("\t\t !!!ERROR  multiplier or unit should be based on String ");
                    return;
                }
            }
        }


        //-------------------------------------------------------------------------------------------------
        static void BuildMapforprimitivetypes(Dictionary<string, string> map)
        {

            map.Add(CD.GetIntegerType(), "integer");
            map.Add("integer", "integer");
            map.Add("float", "float");
            map.Add(CD.GetBooleanType(), "boolean");
            map.Add("boolean", "boolean");
            map.Add(CD.GetStringType(), "string");
            map.Add("string", "string");
            map.Add("double", "double");
            map.Add("Double", "double");
            map.Add("Time", "time");
            map.Add("time", "time");
            map.Add("Date", "date");
            map.Add("date", "date");
            map.Add("DateTime", "dateTime");
            map.Add("dateTime", "dateTime");
            map.Add("Decimal", "decimal");
            map.Add("decimal", "decimal");
            map.Add("Duration", "duration");
            map.Add("duration", "duration");
            map.Add("normalizedString", "normalizedString");
            map.Add("token", "token");
            map.Add("NMTOKEN", "NMTOKEN");
            map.Add("Name", "Name");
            map.Add("NCName", "NCName");
            map.Add("anyURI", "anyURI");

        }



        //------------------------------------------------------------------------------------
        static bool IsValuePrimitive(string v)
        {
            bool ret = false;
            if (mapforprimitivetypes.ContainsKey(v) || (v==CD.GetFloatType())) ret = true;
            return ret;
        }

        //--------------------------------------------------------------------------------

        public static void BuidInheritedConnexion(List<long> inheritedconids, Dictionary<long, List<Connexion>> inheritedconex
            , List<long> motherconids, List<EA.Element> Elemlist)
        {// build dictionnaries for inherited connexion
            // ACHTOUNG pour optimisation regarder si on ne peut pas tester le premier passage avec le  risque que les elements evoluent da,s le modle d'information.
            // for each abstract classes we populate the dictionnaries for concrete classes with the different inherited connexions
            List<EA.Element> abstractlist = new List<EA.Element>();
            ConexesWithUnion = new Dictionary<long, Connexion>();  // list ol all inherited connexion wich support a union
            List<long> dejatraite = new List<long>();
            foreach (EA.Element elt in Elemlist)
            {
                if ((elt.Abstract == "1") && (!abstractlist.Contains(elt)))
                {
                    abstractlist.Add(elt);
                }
            }

            foreach (EA.Element el in abstractlist)
            {
                // MessageBox.Show(" BuidInheritedConnexion  element: " + el.Name);// pour test
                if (!dejatraite.Contains(el.ElementID))
                {// if this element has previously not been treated
                    dejatraite.Add(el.ElementID);
                    bool union = false;
                    List<long> concretids = new List<long>(); // all the concrete classes for one abstract class
                    RDFutilitaires.GetConcreteDescendants(el, concretids);
                    List<long> otherendconcretids = null;
                    if (el.StereotypeEx.Contains(CD.GetUnionStereotype())) { union = true; };
                    foreach (EA.Connector con in el.Connectors)
                    {
                        if ((con.Type == "Association") || (con.Type == "Aggregation"))
                        { //eligible association
                            if (con.StereotypeEx.Contains(CD.GetUnionStereotype())) { union = true; };
                            Connexion conex = new Connexion(con);
                            if (!motherconids.Contains(conex.ConnectorID))
                            { // not yet registered connection
                                motherconids.Add(conex.ConnectorID);
                                // look for the element at the other end
                                string typeotherend = TypeOtherEnd(el, conex); // source or target of the connexion
                                EA.Element elotherend;
                                if ("source" == TypeOtherEnd(el, conex)) { elotherend = conex.Source_element; } else { elotherend = conex.Target_element; }
                                otherendconcretids = new List<long>();
                                RDFutilitaires.GetConcreteDescendants(elotherend, otherendconcretids);

                                // for each concrete classes on abstract elt  side we create a  connection if not yet registered
                                foreach (long classid in concretids)
                                {
                                    if (!inheritedconex.ContainsKey(classid))
                                    { // the inherited connnextion must be created from the abstractside
                                        inheritedconex.Add(classid, new List<Connexion>());
                                    }
                                    foreach (long otherclassid in otherendconcretids)
                                    {
                                        Connexion newconex = new Connexion(conex);
                                        typeotherend = TypeOtherEnd(el, conex);
                                        if (typeotherend == "source")
                                        {
                                            newconex.Source_element = RDFutilitaires.dicelembyid[otherclassid];
                                            newconex.Target_element = RDFutilitaires.dicelembyid[classid];
                                        }
                                        else
                                        {
                                            newconex.Target_element = RDFutilitaires.dicelembyid[otherclassid];
                                            newconex.Source_element = RDFutilitaires.dicelembyid[classid];
                                        }


                                        inheritedconex[classid].Add(newconex);
                                        if ((union == true) && !(ConexesWithUnion.ContainsKey(newconex.ConexID)))
                                        {
                                            ConexesWithUnion.Add(newconex.ConexID, newconex);
                                        }

                                        if (!inheritedconex.ContainsKey(otherclassid))
                                        { // the inherited connnextion must be created from the abstractside
                                            inheritedconex.Add(otherclassid, new List<Connexion>());
                                        }
                                        inheritedconex[otherclassid].Add(newconex);

                                    }
                                    //	}
                                }// classid
                            }//motherconids
                        }//eligible

                    }//connectors
                }// dejatraite
            }// abstractlist

        }


        //--------------------------------------------------------------------------------
        public static string TypeOtherEnd(EA.Element el, Connexion conex)
        { // which is   the other end type (source or target?)
            if ((conex.Source_element).ElementID == el.ElementID)
            {
                return "target";
            }
            else
            {
                return "source";
            }
        }
        //--------------------------------------------------------------------------------
        public static void dicconexDump(Dictionary<long, List<Connexion>> dicconex)
        {
            reportlog.WriteLine("------------------- dum du dico des conex ------------------------\n");
            foreach (KeyValuePair<long, List<Connexion>> kv in dicconex)
            {
                reportlog.WriteLine("classid " + kv.Key.ToString() + "|" + RDFutilitaires.dicelembyid[kv.Key].Name + "\n");
                foreach (Connexion conex in kv.Value)
                {
                    reportlog.WriteLine("\t\t| " + (kv.Value).Count + "|" + conex.ConexID.ToString() + "|" + (conex.Source_element).Name + "|" + ((conex.Target_element).Name) + "|\n");

                }
            }
        }
        //--------------------------------------------------------------------------------

        public static void transInheritedConnector(EA.Element el, XmlSchemaSequence sequence, Connexion conex)
        {

            EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);




            // we decide to treat only the otherend with a role name

            if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
            {
                if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                {
                    if (conex.Target.Containment == "Reference")
                    {
                        //AddElementRef(sequence, getMrid(el), conex.Target_element.Name, conex.Target.Cardinality);
                        AddElementRef(sequence, getMrid(el), conex.Source_element, conex.Target);
                    }
                    else
                    {
                        string rolname = conex.Target.Role;
                        if (IsRoleClass(conex.Target.Role, con.ConnectorGUID))
                        { //  rolename=classname in original asssociation
                            // this is systematic even if the role is unique
                            string[] split = ((conex.Target).Role).Split(new char[] { '_' });
                            string qualifier = "";
                            if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                            if (qualifier != "")
                            {
                                rolname = qualifier + "_" + conex.Target_element.Name;
                            }
                            else
                            {
                                rolname = conex.Target_element.Name;
                            }
                        }
                        else
                        {
                            if (IsRoleNotUnique((conex.Target).Role))
                            { // 
                                rolname = (conex.Target).Role + "-" + conex.Target_element.Name;
                            }
                        }
                        AddElement(sequence, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);
                    }
                }
            }

            if (conex.Target_element.ElementID == el.ElementID)
            {
                if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                {

                    if ((conex.Source).Containment == "Reference")
                    {

                        // AddElementRef(sequence,getMrid(el),conex.Source_element.Name,(conex.Source).Cardinality);   
                        AddElementRef(sequence, getMrid(el), conex.Target_element, conex.Source);
                    }
                    else
                    {

                        // AddElement(sequence, (conex.Source).Role, conex.Source_element.Name,(Conex.Source).Cardinality);
                        string rolname = (conex.Source).Role;
                        if (IsRoleClass((conex.Source).Role, con.ConnectorGUID))
                        { //  rolename=classname in original asssociation
                            string[] split = ((conex.Source).Role).Split(new char[] { '_' });
                            string qualifier = "";
                            if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                            if (qualifier != "")
                            {
                                rolname = qualifier + "_" + conex.Source_element.Name;
                            }
                            else
                            {
                                rolname = conex.Source_element.Name;
                            }
                        }
                        else
                        {
                            if (IsRoleNotUnique((conex.Source).Role))
                            {
                                rolname = (conex.Source).Role + "-" + conex.Source_element.Name;
                            }
                        }
                        AddElement(sequence, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);
                    }
                }
            }

        }
        //---------------------------------------------------------------------------------------- 
        public static void transChoiceInheritedConnector(EA.Element el, XmlSchemaSequence sequence, List<Connexion> conexes)
        {
            if ((conexes == null) || (conexes.Count == 0)) return; // liste vide
            bool atraiter = true;
            XmlSchemaChoice choice = new XmlSchemaChoice();

            foreach (Connexion conex in conexes)
            {
                EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);


                // we decide to treat only the otherend with a role name

                // we decide to treat only the otherend with a role name
                if (((conex.Source_element.ElementID == el.ElementID)
                           && ((conex.Target.Containment == "Reference") || (conex.Target.Role != "")))
                         ||
                        ((conex.Target_element.ElementID == el.ElementID)
                           && ((conex.Source.Containment == "Reference") || (conex.Source.Role != ""))))
                {
                    if (atraiter)
                    {
                        // sequence.Items.Add(cxtype);
                        sequence.Items.Add(choice);

                        atraiter = false;
                    }
                }

                if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                {
                    if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                    {
                        if (conex.Target.Containment == "Reference")
                        {
                            //AddElementRef(sequence, getMrid(el), conex.Target_element.Name, conex.Target.Cardinality);
                            AddElementRefChoice(choice, getMrid(el), conex.Source_element, conex.Target);
                        }
                        else
                        {
                            string rolname = conex.Target.Role;
                            if (IsRoleClass(conex.Target.Role, con.ConnectorGUID))
                            { //  rolename=classname in original asssociation
                                // this is systematic even if the role is unique
                                string[] split = ((conex.Target).Role).Split(new char[] { '_' });
                                string qualifier = "";
                                if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                if (qualifier != "")
                                {
                                    rolname = qualifier + "_" + conex.Target_element.Name;
                                }
                                else
                                {
                                    rolname = conex.Target_element.Name;
                                }
                            }
                            else
                            {
                                if (IsRoleNotUnique((conex.Target).Role))
                                { // 
                                    rolname = (conex.Target).Role + "-" + conex.Target_element.Name;
                                }
                            }
                            AddElementChoice(choice, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);
                        }
                    }
                }

                if (conex.Target_element.ElementID == el.ElementID)
                {
                    if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                    {

                        if ((conex.Source).Containment == "Reference")
                        {

                            // AddElementRef(sequence,getMrid(el),conex.Source_element.Name,(conex.Source).Cardinality);   
                            AddElementRefChoice(choice, getMrid(el), conex.Target_element, conex.Source);
                        }
                        else
                        {

                            // AddElement(sequence, (conex.Source).Role, conex.Source_element.Name,(Conex.Source).Cardinality);
                            string rolname = (conex.Source).Role;
                            if (IsRoleClass((conex.Source).Role, con.ConnectorGUID))
                            { //  rolename=classname in original asssociation
                                string[] split = ((conex.Source).Role).Split(new char[] { '_' });
                                string qualifier = "";
                                if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                if (qualifier != "")
                                {
                                    rolname = qualifier + "_" + conex.Source_element.Name;
                                }
                                else
                                {
                                    rolname = conex.Source_element.Name;
                                }
                            }
                            else
                            {
                                if (IsRoleNotUnique((conex.Source).Role))
                                {
                                    rolname = (conex.Source).Role + "-" + conex.Source_element.Name;
                                }
                            }
                            AddElementChoice(choice, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);
                        }
                    }
                }

            }
        }

        //--------------------------------------------------------------------------------
        public static void buildLocalDatatypeNames(EA.Package apackage, List<string> datanamelist, List<long> dataidlist)
        {
            /*   // devenu inutile depuis qu'on a cree les datatype individuellement
            List<EA.Element> ellist = new List<EA.Element>();
            RDFutilitaires.getStereotypedElements(apackage, ellist, new List<string>()
                                      {
                                        "Datatype",  // compatibility
	                                CD.GetDatatypeStereotype(),
                                        CD.GetPrimitiveStereotype(),
	                                CD.GetCompoundStereotype(),
	                                CD.GetEnumStereotype(),
                                       });

            foreach (EA.Element el in ellist)
            {
                if (el.Name != null)
                {
                    datanamelist.Add(el.Name);
                    dataidlist.Add(el.ElementID);
                    //  MessageBox.Show(" datatype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }
             * */

        }
        //-------------------------------------------------------------------------------
        public static void buildLocalClassNames(EA.Package apackage, List<string> classnamelist)
        {
            List<EA.Element> ellist = new List<EA.Element>();
            RDFutilitaires.getTypedElements(apackage, ellist, "Class");
            foreach (EA.Element el in ellist)
            {
                if (el.Name != null)
                {
                    classnamelist.Add(el.Name);

                    //  MessageBox.Show(" classtype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }

        }
        //--------------------------------------------------------------------------------

        /*
        static XmlSchemaObject  CreateFloatSimpleTypeIfNeeded(long classifierid, EA.Package apackage, XmlSchema schem)
        {
              XmlSchemaObject ret=null;
              if (el.Name == CD.GetFloatType())
            { // in the case ther is locally defined "Float"
                if (!LocalDatatypeNames.Contains(CD.GetFloatType())) LocalDatatypeNames.Add(CD.GetFloatType());
                XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                flottant.Name = CD.GetFloatType();
                //   schem.Items.Add(flottant); //220311
                ret = flottant;
                XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                flottant.Content = union;
                XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                union.MemberTypes = members;
                XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                flottant.Annotation = flotanno; ;
                ArrayList reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
                string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                AddAppInfoSawdsl(flotanno, reference);
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                    flotanno.Items.Add(flotdoc);
                    flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }//float
        }
         * */
        static void CreateDatatypIfNeeded(long classifierid, EA.Package apackage, XmlSchema schem)
        {

            EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];
            XmlSchemaObject sobj = null;
            if (!datatypetraite.Contains(classifierid))
            {
                if (LocalDatatypeNames.Contains(classifier.Name))
                {
                    string texte = " le datattype " + classifier.Name + " existait deja, il n'a pas t recree localement";
                    reportlog.WriteLine(texte);
                }
                if (!LocalDatatypeNames.Contains(classifier.Name))
                {
                    
                    sobj = TraitElem(classifier, apackage, schem);
                    if ((sobj != null) && (!IsInline(classifier)))
                    {
                        schem.Items.Add(sobj);
                    }
                     if (!LocalDatatypeNames.Contains(classifier.Name)) LocalDatatypeNames.Add(classifier.Name);  // am june 2011
                }
                else
                { // a similar name already exists in the package
                    if (!LocalDatatypeIDs.Contains(classifierid))
                    {
                        string texte = " WARNING: it seems that you used a type " + classifier.Name + " which was already been defined in the profile\n";
                        texte = texte + " the reference has been made to the already  defined local type";
                        //	MessageBox.Show(texte);
                        reportlog.WriteLine(texte);
                    }
                }
            }
        }

        //-------------------------------------------------------------------------------------------
        static bool IsMandatory(EA.Attribute at)
        {
            string lowerbound = at.LowerBound;
            if (lowerbound == "0")
            {
                return false;
            }
            else
            {
                return true;
            }
        }
        //----------------------------------------------
        static bool IsInline(EA.Element el)
        {
            bool ret = false;
            if (el.StereotypeEx.Contains(CD.GetInlineStereotype()))
            {
                ret = true;
            }
            return ret;
        }
        //--------------------------------------------------------------------------------------------------
        static bool IsValidCimDatatype(string stereos)
        {
            bool ret = false;
            List<string> cimdatatypes = new List<string>() { CD.GetPrimitiveStereotype(), "Datatype", CD.GetDatatypeStereotype(), CD.GetCompoundStereotype(), CD.GetEnumStereotype() };
            if (stereos != "")
            {
                char[] sep = { ',' };
                string[] split = stereos.Split(sep);
                for (int i = 0; i < split.Length; i++)
                    if (cimdatatypes.Contains(split[i]))
                    {
                        ret = true;
                        break;
                    }
            }
            return ret;
        }
        /// <summary>
        /// buid a sorted dictionary
        /// string, EA.Connector
        /// each key and cons are eligible roles
        /// for this Class
        /// </summary>
        /// <param name="el"></param>

        static void buildDicSortedCons(EA.Element el, SortedDictionary<string, EA.Connector> sortedcons)
        {
            EA.Collection col = el.Connectors;
            string nomrole = "";
            ArrayList res;
            foreach (EA.Connector con in col)
            {
                res = RDFutilitaires.getOtherend(el, con);
                if ((EA.ConnectorEnd)res[0] != null)
                {
                    sortedcons.Add(((EA.ConnectorEnd)res[0]).Role, con);

                }
            }
        }

        //--------------------------------------------------------------------------------------------------
        /// <summary>
        /// This is a transitory method to get the version of the CIM package of an element 
        /// assuming that the profile is in the same package 
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string GetVersionElement(EA.Element el)
        {
            string ret = "";
            return ret;
        }

        //------------------------ programmes pour union  -------------------------------------------------------------------
        //---------------------------------------------------------------------------------------- 
        public static void transUnionInheritedConnector(EA.Element el, XmlSchemaSequence sequence, List<Connexion> conexes)
        {
            string prov = el.Name; // pour test
            if ((conexes == null) || (conexes.Count == 0)) return; // liste vide
            bool atraiter = true;
            bool cardinalite = true;
            XmlSchemaChoice choice = new XmlSchemaChoice();
            if (conexes.Count > 0)
            { // there is at leat one  connexion
                // because it is an inherited connexion
                // We are going to Search  for the cardinality of the original connexion

                foreach (Connexion conex in conexes)
                {
                    EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);


                    // we decide to treat only the otherend with a role name

                    // we decide to treat only the otherend with a role name
                    if (((conex.Source_element.ElementID == el.ElementID)
                               && ((conex.Target.Containment == "Reference") || ((conex.Target.Role != "") && (conex.TargetAggregation == 0))))
                             ||
                            ((conex.Target_element.ElementID == el.ElementID)
                               && ((conex.Source.Containment == "Reference") || ((conex.Source.Role != "") && (conex.SourceAggregation == 0)))))
                    {
                        if (atraiter)
                        {

                            // sequence.Items.Add(cxtype);

                            sequence.Items.Add(choice);

                            atraiter = false;
                        }
                    }

                    if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                    {
                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {

                           

                                string rolname = conex.Target.Role;
                                if (IsRoleClass(conex.Target.Role, con.ConnectorGUID))
                                { //  rolename=classname in original asssociation
                                    // this is systematic even if the role is unique
                                    string[] split = ((conex.Target).Role).Split(new char[] { '_' });
                                    string qualifier = "";
                                    if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                    if (qualifier != "")
                                    {
                                        rolname = qualifier + "_" + conex.Target_element.Name;
                                    }
                                    else
                                    {
                                        rolname = conex.Target_element.Name;
                                    }
                                }
                                else
                                {
                                    if (IsRoleNotUnique((conex.Target).Role))
                                    { // 
                                        rolname = (conex.Target).Role + "-" + conex.Target_element.Name;
                                    }
                                }
                                if (cardinalite)  // the first time we must put choice's cardinality
                                {
                                    string[] occur = getEndCardinality(conex.Target);
                                    string[] vide = { "0", "0" };

                                    if (!occur.Equals(vide))
                                    {
                                        choice.MinOccursString = occur[0];
                                        choice.MaxOccursString = occur[1];
                                    }
                                    cardinalite = false;
                                }
                                if (conex.Target.Containment == "Reference")
                                {
                                //AddElementRef(sequence, getMrid(el), conex.Target_element.Name, conex.Target.Cardinality);


                                AddElementRefUnion(choice, rolname, conex.Source_element, conex.Target);


                            }
                            else
                            {
                                
                                AddElementUnion(choice, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);

                            }
                        }
                    }

                    if (conex.Target_element.ElementID == el.ElementID)
                    {
                        if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                        {
                            string rolname = (conex.Source).Role;
                            if (IsRoleClass((conex.Source).Role, con.ConnectorGUID))
                            { //  rolename=classname in original asssociation
                                string[] split = ((conex.Source).Role).Split(new char[] { '_' });
                                string qualifier = "";
                                if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                if (qualifier != "")
                                {
                                    rolname = qualifier + "_" + conex.Source_element.Name;
                                }
                                else
                                {
                                    rolname = conex.Source_element.Name;
                                }
                            }
                            else
                            {
                                if (IsRoleNotUnique((conex.Source).Role))
                                {
                                    rolname = (conex.Source).Role + "-" + conex.Source_element.Name;
                                }
                            }
                            if (cardinalite)  // the first time we must put choice's cardinality
                            {
                                string[] occur = getEndCardinality(conex.Source);
                                string[] vide = { "0", "0" };

                                if (!occur.Equals(vide))
                                {
                                    choice.MinOccursString = occur[0];
                                    choice.MaxOccursString = occur[1];
                                }
                                cardinalite = false;
                            }

                            if ((conex.Source).Containment == "Reference")
                            {
                               
                                // AddElementRef(sequence,getMrid(el),conex.Source_element.Name,(conex.Source).Cardinality);   
                                AddElementRefUnion(choice, rolname, conex.Target_element, conex.Source);

                            }
                            else
                            {

                                // AddElement(sequence, (conex.Source).Role, conex.Source_element.Name,(Conex.Source).Cardinality);
                              

                                AddElementUnion(choice, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);

                            }
                        }
                    }

                }
            }
        }
        //--------------------------------

        static long getotherendid(EA.Element el, Connexion conex)
        {

            if (conex.Source_element.ElementID == el.ElementID) return conex.Target_element.ElementID;
            if (conex.Target_element.ElementID == el.ElementID) return conex.Source_element.ElementID;
            return 0;
        }
        //--------------------------------
        //-----------------------------------------------------------------------------------------
        static void AddElementUnion(XmlSchemaChoice choice, string name, string atrtype, EA.Element elementend, EA.ConnectorEnd end)
        {
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);

                AddAnnForAssociationEnd(elementend, nel, end, false);
            }
            catch (Exception e)
            {
                MessageBox.Show("5-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an choice AssociationEnd {0} | {1}", end.Role);

            }
        }


        //------------------------------------------------------------
        //--------------------------
        static void AddElementRefUnion(XmlSchemaChoice choice, string reff, EA.Element elementend, EA.ConnectorEnd end)
        {
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);

                nel.Name = reff;
                // string atrtype = type;
                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);

                AddAnnForAssociationEnd(elementend, nel, end, false);
                XmlSchemaComplexType complexType = new XmlSchemaComplexType();

                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;

                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;
                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);
            }
            catch (Exception e)
            {
                MessageBox.Show("6-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an reference choice AssociationEnd {0} | {1}", end.Role);
            }
        }
        //---------------------------------
        static string[] getEndCardinality(EA.ConnectorEnd end)
        {
            string[] ret = { "0", "0" };
            char[] arg = { '.' };
            string cardinalite = "";
            cardinalite = end.Cardinality;
            if (cardinalite == "") cardinalite = "0..*";
            string[] split = cardinalite.Split(arg);
            if (split[0] != "") ret[0] = split[0];
            if (split.Length != 3)
            {
                MessageBox.Show("Error  bad syntax of a cardinality");
                reportlog.WriteLine("Error for  bad syntax of a cardinality");
                return ret;
            }
            if (split.Length == 3)
            {
                if (split[2] != "*")
                {
                    ret[1] = split[2];
                }
                else
                {
                    ret[1] = "unbounded";
                }
            }
            else
            {
                if (split[0] == "*")
                { //very special case where there is only one digit cardinality
                    ret[1] = "unbounded";
                }
                else
                {
                    ret[1] = "1";
                }
            }
            return ret;
        }

        ///-----------------------------------------------------
        public static XmlSchemaObject traitValueSeule(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, XmlSchemaObject ret)
        {
            return null; // les datatypes value seule sans restriction,
                           // ont forcement une valeur primitive 
                           // se trouvent transforms en xs:facetvalue et ne sont pas gnrs en tan que tel (saul Float)


            // <xs:simpleType name="">
            bool inline = IsInline(el);
            /*
            if (el.Name == CD.GetFloatType())
            { // in the case ther is locally defined "Float"
                if (!datatypetraite.Contains(el.ElementID)) datatypetraite.Add(el.ElementID);
                XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                flottant.Name = CD.GetFloatType();
                //   schem.Items.Add(flottant); //220311
                ret = flottant;
                XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                flottant.Content = union;
                XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                union.MemberTypes = members;
                XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                flottant.Annotation = flotanno; ;
                ArrayList reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
                string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                AddAppInfoSawdsl(flotanno, reference);
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                    flotanno.Items.Add(flotdoc);
                    flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }//float
            */
            XmlSchemaSimpleType simptype = new XmlSchemaSimpleType();
            if (!inline) simptype.Name = el.Name;
            XmlSchemaSimpleTypeRestriction simpRestriction = new XmlSchemaSimpleTypeRestriction();
            string justelname = RDFutilitaires.RemoveQual(el.Name);
            // general case
            if (value.Type != CD.GetFloatType())
            {
                if (justelname == "AbsoluteDate")
                {
                    simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes["date"], NS_XSD);
                }
                else
                {
                    if (!mapforprimitivetypes.ContainsKey(value.Type))
                    {
                        // a primitive should be with the given list
                        MessageBox.Show("Error the type  " + value.Type + " for  " + value.Name + "\n" +
                        " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                        reportlog.WriteLine("Error the type  " + value.Type + " for  " + value.Name + "\n" +
                        " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                        //RDFutilitaires.ongoing= false;
                        //return;
                    }
                    else
                    {
                        simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[value.Type], NS_XSD);

                    }
                }
            }
            else
            {
                simpRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);
            }

            simptype.Content = simpRestriction;
            // schem.Items.Add(simptype);  //220311
            ret = simptype;
            // doc and annotations sawdsl
            AddAnnForStx(el, simptype, false);
            return ret;

        }
        //----------------------------------------------
        public static XmlSchemaObject traitValueSeuleRestrainte(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, XmlSchemaObject ret)
        {

            // <xs:simpleType name="">
            XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
            if (!IsInline(el)) simpptype.Name = el.Name;
            string valuetype = value.Type;
            EA.Collection contraintes = value.Constraints;
            EA.AttributeConstraint co;

            List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            int nombre = value.Constraints.Count;
            string precision = "";
            for (short i = 0; i < nombre; i++)
            {
                co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
            }
            //specific case of specific FACETS (not xml)
            if (valuetype == CD.GetFloatType() || valuetype == CD.GetStringType())
            {
                if (InvConstraints.Count > 0)
                { // we treat only precision constraint

                    switch (valuetype)
                    {
                        case "Float":
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice=simple"))
                                {
                                    precision = "simple"; valuetype = "float";
                                }
                                if (constr.Notes.Contains("choice=double"))
                                {
                                    precision = "double"; valuetype = "double";
                                }
                            }
                            break;
                        case "String":
                            valuetype = "string";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);
                                    break;
                                }
                            }
                            break;
                        default:
                            break;
                    }

                }
            }
            if ((valuetype != CD.GetFloatType()))
            {
                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();

                if (!mapforprimitivetypes.ContainsKey(valuetype))
                {
                    // a primitive should be with the given list
                    MessageBox.Show("Error the type  " + valuetype + " for value \n" +
                        " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                    reportlog.WriteLine("Error the type  " + valuetype + " for value \n" +
                    " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                    //RDFutilitaires.ongoing= false;
                    //return;

                }
                else
                {

                    simppRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);
                }



                //les facets

                if (OclConstraints.Count > 0)
                {

                    foreach (EA.AttributeConstraint constr in OclConstraints)
                    {

                        AddFacet(simppRestriction, constr);

                    }
                }
                //---
                simpptype.Content = simppRestriction;
                // schem.Items.Add(simpptype);//220311
                ret = simpptype;
                // MessageBox.Show(el.Name + " contrainte");

            }
            else
            {
                MessageBox.Show("Error  in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                reportlog.WriteLine(" \t\t :::Error  a restriction can't be applied to a Float  without giving the precision");
                return ret;

            }
            // doc and annotations sawdsl
            AddAnnForStx(el, simpptype, false);
            return ret;
        }
        //--------------------------------------------------------------
        public static string getXmlType(EA.AttributeConstraint constr)
        {
            string ret = "";
            string notes = constr.Notes;

            if (!notes.Contains("choice=")) return ret; // retour immediat
            int index = notes.IndexOf("choice=");
            ret = notes.Substring(index + 7).TrimEnd(' ');
            return ret;
        }
        //--------------------------------------
        public static XmlSchemaObject traitValueEtMulti(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {
            try
            {
                string valuetype = "";
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                //schem.Items.Add(ct); //220311
                ret = ct;
                if (!IsInline(el)) ct.Name = el.Name;
                // <xs:complexContent>
                XmlSchemaComplexContent complexContent = new XmlSchemaComplexContent();
                ct.ContentModel = complexContent;

                // <xs:extension base="address">
                XmlSchemaComplexContentExtension extensionvalue = new XmlSchemaComplexContentExtension();
                complexContent.Content = extensionvalue;

                //   extensionvalue.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);
                valuetype = GetXSType(value);
                if (valuetype != "")
                {                 
                    extensionvalue.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);
                    
                }
                else
                {
                    extensionvalue.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
                }


               
                if (multiplier != null)
                {
                    AddDataType(multiplier, apackage, schem); // add a datatype to the profile if necessary

                    XmlSchemaAttribute atr = new XmlSchemaAttribute();
                    extensionvalue.Attributes.Add(atr);

                    atr.Name = "multiplier";
                    //   atr.SchemaTypeName = new XmlQualifiedName(multiplier.Type, profparameters.TargetNamespace);
                    setAtrTypeName(atr, multiplier, apackage, schem);
                    if (multiplier.Default != "")
                    {
                        if (multiplier.IsConst)
                        {
                            atr.Use = XmlSchemaUse.Required;
                            if (IsMandatory(multiplier)) atr.FixedValue = multiplier.Default;
                        }
                        else
                        {
                            atr.DefaultValue = multiplier.Default;
                        }
                    }
                    else
                    {
                        if (IsMandatory(multiplier)) atr.Use = XmlSchemaUse.Required;
                    }
                }



                if (unit != null)
                {
                    AddDataType(unit, apackage, schem); // add a datatype to the profile if necessary
                    XmlSchemaAttribute at = new XmlSchemaAttribute();
                    at.Name = "unit";
                    //   at.SchemaTypeName = new XmlQualifiedName(unit.Type, profparameters.TargetNamespace);

                    setAtrTypeName(at, unit, apackage, schem);

                    if (unit.Default != "")
                    {
                        if (unit.IsConst)
                        {
                            if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                            at.FixedValue = unit.Default;
                        }
                        else
                        {
                            at.DefaultValue = unit.Default;
                        }
                    }
                    else
                    {
                        if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                    }
                    extensionvalue.Attributes.Add(at);
                }

                // doc and annotations sawdsl
                AddAnnForCtx(el, ct, false);
            }

            catch (Exception e)
            {
                DialogResult r = MessageBox.Show("20- Error  " + e.Message, "Error", MessageBoxButtons.OKCancel);
                reportlog.WriteLine("\t\t !!!ERROR  in treating a Datattype {0}", e.Message);
                if (r == DialogResult.Cancel) return ret;
            }
            return ret;
        }
        //-----------------------------------------------------------
        public static XmlSchemaObject traitValueEtMultiRestreinte(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {

            EA.Collection contraintes = value.Constraints;
            List<AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            int nombre = value.Constraints.Count;
            string precision = "";
            for (short i = 0; i < nombre; i++)
            {
                EA.AttributeConstraint co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
            }
            // <xs:simpleType name="">
            XmlSchemaSimpleType simptype = new XmlSchemaSimpleType();
            simptype.Name = el.Name + "-base";
            XmlSchemaSimpleTypeRestriction simpRestriction = new XmlSchemaSimpleTypeRestriction();
           // simpRestriction.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);
            string valuetype = value.Type;
            valuetype = GetXSType(value);
            if (valuetype != "")
            {
                simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);

            }
            else
            {
                MessageBox.Show("Error   in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                reportlog.WriteLine(" \t\t :::Error  in: {0},  a restriction can't be applied to a Float  without giving the precision", el.Name);
                return ret;
               // simpRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
            }
            //---

      


                //les facets

                if (OclConstraints.Count > 0)
                {

                    foreach (EA.AttributeConstraint constr in OclConstraints)
                    {

                        AddFacet(simpRestriction, constr);

                    }
                }
                //---
                simptype.Content = simpRestriction;
                //ret= simppptype;
                schem.Items.Add(simptype);
                // MessageBox.Show(el.Name + " contrainte");
                // doc and annotations sawdsl
                AddAnnForStxBase(el, simptype);


            


            //complextype
            XmlSchemaComplexType ctt = new XmlSchemaComplexType();
            //schem.Items.Add(ctt);
            ret = ctt;
            ctt.Name = el.Name;

            // <xs:complexContent>
            XmlSchemaComplexContent complexContentt = new XmlSchemaComplexContent();
            ctt.ContentModel = complexContentt;

            // <xs:extension base="address">
            XmlSchemaComplexContentExtension extensionvaluee = new XmlSchemaComplexContentExtension();
            complexContentt.Content = extensionvaluee;
            extensionvaluee.BaseTypeName = new XmlQualifiedName((el.Name + "-base"), profparameters.TargetNamespace);
            if (multiplier != null)
            {
                AddDataType(multiplier, apackage, schem); // add a datatype to the profile if necessary
                XmlSchemaAttribute att = new XmlSchemaAttribute();
                att.Name = "multiplier";
                //att.SchemaTypeName = new XmlQualifiedName(multiplier.Type, profparameters.TargetNamespace);
                setAtrTypeName(att, multiplier, apackage, schem);
                if (multiplier.Default != "")
                {
                    if (multiplier.IsConst)
                    {
                        if (IsMandatory(multiplier)) att.Use = XmlSchemaUse.Required;
                        att.FixedValue = multiplier.Default;
                    }
                    else
                    {
                        att.DefaultValue = multiplier.Default;
                    }
                }
                else
                {
                    if (IsMandatory(multiplier)) att.Use = XmlSchemaUse.Required;
                }

                extensionvaluee.Attributes.Add(att);
            }
            if (unit != null)
            {
                AddDataType(unit, apackage, schem); // add a datatype to the profile if necessary
                XmlSchemaAttribute at = new XmlSchemaAttribute();
                at.Name = "unit";
                //  at.SchemaTypeName = new XmlQualifiedName(unit.Type, profparameters.TargetNamespace);
                setAtrTypeName(at, unit, apackage, schem);
                if (unit.Default != "")
                {
                    if (unit.IsConst)
                    {
                        if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                        at.FixedValue = unit.Default;
                    }
                    else
                    {
                        at.DefaultValue = unit.Default;
                    }
                }
                else
                {
                    if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                }


                extensionvaluee.Attributes.Add(at);
            }
            //MessageBox.Show(el.Name + " contrainte");


            // doc and annotations sawdsl
            AddAnnForCtx(el, ctt, false);
            return ret;
        }
        //------------------------------------------------------------
        public static XmlSchemaObject traitDatatype(EA.Package apackage, XmlSchema schem, EA.Element el, XmlSchemaObject ret)
        {
            // normal UML datatype
            try
            {


                // <xs:complexType name="">
                XmlSchemaComplexType ctx = new XmlSchemaComplexType();
                // schem.Items.Add(ctx);  //220311
                ret = ctx;
                if (!IsInline(el)) ctx.Name = el.Name;
                //==============================================================================
                //documentation et  attribut sawsdl
                // <xs:annotation>
                AddAnnForClass(el, ctx, false);

                //============================================================
                // <xs:sequence> Attributes
                //==========================================================
                XmlSchemaSequence sequenc = new XmlSchemaSequence();
                ctx.Particle = sequenc;


                // <xs:element name=""   type=""/>
                foreach (EA.Attribute atr in el.Attributes)
                {
                    XmlSchemaElement nel = new XmlSchemaElement();
                    sequenc.Items.Add(nel);
                    nel.Name = atr.Name;
                    string atrtype = atr.Type;
                    long classifierid = atr.ClassifierID;
                    if ((classifierid != 0) && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
                    {
                        EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];

                        //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                        //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                        string classtereos = "";

                        classtereos = classifier.StereotypeEx;

                        if ((classtereos != "") && (classtereos.Contains(CD.GetPrimitiveStereotype())))
                        {
                            if (classifier.Name == CD.GetFloatType())
                            { //Float is a special case

                                nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);

                            }
                            else
                            {
                                nel.SchemaTypeName = new XmlQualifiedName(classifier.Name.ToLower(), NS_XSD);
                            }
                        }
                        else
                        {

                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            if (!datatypetraite.Contains(classifierid))
                            {
                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                                //	TraitElem(classifier,apackage,schem);
                            }
                        }
                        if (atr.LowerBound == "0") nel.MinOccurs = 0;
                        AddAnnForAtr(el, nel, atr, true);
                        /******** default or fixed values of the attribute ************************/
                        if (atr.Default != "")
                        {
                            if (atr.IsConst)
                            {
                                nel.FixedValue = atr.Default;
                            }
                            else
                            {
                                nel.DefaultValue = atr.Default;
                            }
                        }

                    }
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("9-CIMSchemagenerator Error : " + e.Message);
                reportlog.WriteLine("\t\t !!!ERROR while treating a No CimDatatype {0} ", e.Message);
            }
            return ret;
        }
        /// <summary>
        /// type enumeration
        /// decrit dans un stereotype de
        /// CodeListValueType et qui prend comme valeur 
        /// les types xml valides
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        static string getCodeListValueType(EA.Element el)
        {
            string tagvalue = "string"; // the default value is always string
            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                if (tag.Name == XMLProfileParameters.CodeListValueType)
                {
                    tagvalue = tag.Value; ;
                    break;
                }
            }
            if ((tagvalue != "") && (!mapforprimitivetypes.ContainsValue(tagvalue)))
            {
                tagvalue = "string";
            }
            return tagvalue;
        }

        //------------------

        static string GetConnexionName(ModelObject mobj)
        {
            EA.Connector con = Repos.GetConnectorByID((int)mobj.conex.ConnectorID);
            string ret = "";
            // we decide to treat only the otherend with a role name and if it is not abstract         
                           
            if (mobj.conex.Source_element.ElementID == mobj.el.ElementID)  // the otherend is target
            {
                if ((mobj.conex.Target_element.Abstract == "1")
                    && mobj.conex.Target_element.StereotypeEx.Contains(CD.GetUnionStereotype())
                    )
                { // on ne definipas une association vers la classe abstraite dans le cas de l'union
                    return ret;
                }
                //if (mobj.conex.Target_element.Abstract == "0")
               // { //the other end class is concrete


                    if ((mobj.conex.Target.Role != "") && mobj.conex.TargetAggregation == 0)
                    {
                       // if (mobj.conex.Target_element.Abstract == "0")
                       // { //the other end class is concrete

                            if (mobj.conex.Target.Containment == "Reference")
                            {
                                //AddElementRef(sequence, getMrid(el), conex.Target_element.Name, conex.Target.Cardinality);
                                // AddElementRef(sequence, getMrid(el), conex.Target_element, conex.Target);
                                ret = "T!" + "ref";
                            }
                            else
                            {
                                string rolname = mobj.conex.Target.Role;

                                if (IsRoleClass(mobj.conex.Target.Role, con.ConnectorGUID))
                                { //  rolename=classname in original asssociation
                                    // this is systematic even if the role is unique
                                    string[] split = ((mobj.conex.Target).Role).Split(new char[] { '_' });
                                    string qualifier = "";
                                    if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                    if (qualifier != "")
                                    {
                                        rolname = qualifier + "_" + mobj.conex.Target_element.Name;
                                    }
                                    else
                                    {
                                        rolname = mobj.conex.Target_element.Name;
                                    }
                                }
                                else
                                {
                                    if (IsRoleNotUnique((mobj.conex.Target).Role))
                                    { // 
                                        rolname = (mobj.conex.Target).Role + "-" + mobj.conex.Target_element.Name;
                                    }
                                }
                                //  AddElement(sequence, rolname, conex.Target_element.Name, conex.Target_element, conex.Target);
                                ret = "T!" + rolname;
                            }
                        }
                   // }
                //}
            }
            if (mobj.conex.Target_element.ElementID == mobj.el.ElementID)
            {//the other end is a source

                if ((mobj.conex.Source_element.Abstract == "1")
                    && mobj.conex.Source_element.StereotypeEx.Contains(CD.GetUnionStereotype())
                    )
                { // on ne definipas une association vers la classe abstraite dans le cas de l'union
                    return ret;
                }

               // if (mobj.conex.Source_element.Abstract == "0")
               // { //the other end class is concrete


                    if (((mobj.conex.Source).Role != "") && mobj.conex.SourceAggregation == 0)
                    {

                        if ((mobj.conex.Source).Containment == "Reference")
                        {

                            // AddElementRef(sequence,getMrid(el),mobj.conex.Source_element.Name,(conex.Source).Cardinality);   
                            // AddElementRef(sequence, getMrid(el), conex.Source_element, conex.Source);
                            ret = "S!" + "ref";
                        }
                        else
                        {

                            // AddElement(sequence, (conex.Source).Role, conex.Source_element.Name,(Conex.Source).Cardinality);
                            string rolname = (mobj.conex.Source).Role;
                            if (IsRoleClass((mobj.conex.Source).Role, con.ConnectorGUID))
                            { //  rolename=classname in original asssociation
                                string[] split = ((mobj.conex.Source).Role).Split(new char[] { '_' });
                                string qualifier = "";
                                if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                                if (qualifier != "")
                                {
                                    rolname = qualifier + "_" + mobj.conex.Source_element.Name;
                                }
                                else
                                {
                                    rolname = mobj.conex.Source_element.Name;
                                }
                            }
                            else
                            {
                                if (IsRoleNotUnique((mobj.conex.Source).Role))
                                {
                                    rolname = (mobj.conex.Source).Role + "-" + mobj.conex.Source_element.Name;
                                }
                            }
                            // AddElement(sequence, rolname, mobj.conex.Source_element.Name, mobj.conex.Source_element, conex.Source);
                            ret = "S!" + rolname;
                        }
                    
                    }
               // } 
            }
            return ret;
        }

        //--------------
        public static int CompareModelObjectbyKeyName(ModelObject x, ModelObject y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    string xname = x.keyname;
                    string yname = y.keyname;
                    string[] split = null;
                    if (x.type == "connexion")
                    {
                        if (x.keyname.Contains("!"))
                        {
                            split = x.keyname.Split('!');
                            xname = split[1];
                        }
                    }
                    if (y.type == "connexion")
                    {
                        if (y.keyname.Contains("!"))
                        {
                            split = y.keyname.Split('!');
                            yname = split[1];
                        }
                    }
                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }
        //-------------------------
        /// <summary>
        /// le type d'un attribut est un compound
        /// </summary>
        /// <param name="atr"></param>
        /// <returns></returns>
        static bool isTypeCompound(EA.Attribute atr)
        {
            bool ret = false;
            if (ObjectType.otAttribute != atr.ObjectType) return ret;

            if (atr.ClassifierID != 0)// il y a un classifier peut-etre compound
            {
                try
                {
                    if (Repos.GetElementByID((int)atr.ClassifierID).StereotypeEx.Contains(CD.GetCompoundStereotype()))
                    {
                        // eligible
                        ret = true;
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(" In IsTypeCompound , error geting classifier=" + atr.ClassifierID.ToString() + " " + e.Message);
                }
            }
            return ret;

        }
        //------------------------
        /// si un  datatype est form d'une valeur simple mais restreinte et que cette valeur porte une restriction
        ///  et une seule restriction speciale sur String ou Float , alors on donne directement le xs format,
        /// sinon on garde un simple type  de restriction comme d'habitude
       static  string GetXSType(EA.Element cimdatatype)
        {
            if (!cimdatatype.StereotypeEx.Contains(CD.GetDatatypeStereotype()) && !cimdatatype.StereotypeEx.Contains("Datatype")) return "";
           // ce traitement n'a d'intrt que pour les classes de type datatype  une value , resteinte spciale dans le cas de Float ou de String
            string ret = ""; // ce n'est pas un nom de xstype  priori
            EA.Attribute value = null;
            if (cimdatatype.Attributes.Count != 1) return ret; // il faut une base de restriction
            value = (EA.Attribute)cimdatatype.Attributes.GetAt(0);
            if (value.Name != "value")
            {
                MessageBox.Show(" the classifier " + cimdatatype.Name + " has not an attribute named value");
                reportlog.WriteLine(" the classifier " + cimdatatype.Name + " has not an attribute named value");
                return ret;
            }
            string valuetype = value.Type;
            List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            int nombre = value.Constraints.Count;
            string precision = "";
            EA.AttributeConstraint co = null;
            EA.Collection contraintes = value.Constraints;
            for (short i = 0; i < nombre; i++)
            {
                co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
            }
            if ((nombre == 0) && (valuetype == CD.GetFloatType())) return CD.GetFloatType(); // cas de Float
            if (nombre == 0)
            { // il n'y a pas de contraintes on peut donner le nom d'un type xs si possible
                bool isprimitive = false;
                foreach (string ss in mapforprimitivetypes.Keys)
                {
                    if (ss == valuetype)
                    { // en fait il s'agit d'une primitive
                        isprimitive = true;
                        return valuetype;

                    }
                }
            }

            if ((valuetype == CD.GetFloatType() || valuetype == CD.GetStringType()) && OclConstraints.Count == 0)
            {
                if (InvConstraints.Count > 0)
                { // we treat only precision constraint

                    switch (valuetype)
                    {
                        case "Float":
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice=simple"))
                                {
                                    precision = "simple"; valuetype = "float";
                                }
                                if (constr.Notes.Contains("choice=double"))
                                {
                                    precision = "double"; valuetype = "double";
                                }
                            }
                            ret = valuetype;
                            break;
                        case "String":
                            valuetype = "string";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);

                                    break;
                                }
                            }
                            ret = valuetype;
                            break;
                        default:
                            return ret;
                            break;
                    }

                }
            }


            return ret;

        }

       //------------------------
       /// si un  attribut value (en general d'un datatype  a une  valeur qui porte une restriction
       ///  et une seule restriction speciale sur String ou Float , alors on donne directement le xs format,
       /// sinon on garde un simple type  de restriction comme d'habitude
       static string GetXSType(EA.Attribute value)
       {
           string ret = "";
           if (value.Name != "value")
           {
               MessageBox.Show("treating an attribute value of a datatype but the  name is not value ");
               reportlog.WriteLine("treating an attribute value of a datatype but the  name is not value ");
               return ret;
           }
           string valuetype = value.Type;
           List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
           List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
           int nombre = value.Constraints.Count;
           string precision = "";
           EA.AttributeConstraint co = null;
           EA.Collection contraintes = value.Constraints;
           for (short i = 0; i < nombre; i++)
           {
               co = (EA.AttributeConstraint)contraintes.GetAt(i);
               if (co.Type == "OCL") OclConstraints.Add(co);
               if (co.Type == "INV") InvConstraints.Add(co);
           }

           if (nombre == 0)
           { // il n'y a pas de contraintes on peut donner le nom d'un type xs si possible
               bool isprimitive = false;
               foreach (string ss in mapforprimitivetypes.Keys)
               {
                   if (ss == valuetype)
                   { // en fait il s'agit d'une primitive
                       isprimitive = true;
                       return valuetype;

                   }
               }
           }

           if (valuetype == CD.GetFloatType() || valuetype == CD.GetStringType())
           {
               if (InvConstraints.Count > 0)
               { // we treat only precision constraint

                   switch (valuetype)
                   {
                       case "Float":
                           foreach (EA.AttributeConstraint constr in InvConstraints)
                           {
                               if (constr.Notes.Contains("choice=simple"))
                               {
                                   precision = "simple"; valuetype = "float";
                               }
                               if (constr.Notes.Contains("choice=double"))
                               {
                                   precision = "double"; valuetype = "double";
                               }
                           }
                           ret = valuetype;
                           break;
                       case "String":
                           valuetype = "string";
                           foreach (EA.AttributeConstraint constr in InvConstraints)
                           {
                               if (constr.Notes.Contains("choice="))
                               {
                                   valuetype = getXmlType(constr);

                                   break;
                               }
                           }
                           ret = valuetype;
                           break;
                       default:
                           return ret;
                           break;
                   }

               }
           }


           return ret;

       }

        //-------------------------------------------------
        static void AddElementAttribute(XmlSchema schem, XmlSchemaSequence sequence, EA.Package apackage, EA.Element el, EA.Attribute atr)
        {
            XmlSchemaElement nel = new XmlSchemaElement();
            sequence.Items.Add(nel);
            nel.Name = atr.Name;
            string atrtype = atr.Type;
            long classifierid = atr.ClassifierID;
            if ((classifierid != 0) && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = RDFutilitaires.dicelembyid[classifierid];

                //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                string classtereos = "";

                classtereos = classifier.StereotypeEx;
                if ((classtereos != "") && IsValidCimDatatype(classtereos))
                {

                    if (classtereos.Contains(CD.GetPrimitiveStereotype()))
                    {
                        if (classifier.Name == CD.GetFloatType())
                        { //Float is a special case

                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);

                        }
                        else
                        {
                            if (!mapforprimitivetypes.ContainsKey(classifier.Name))
                            {
                                // a primitive should be with the given list
                                MessageBox.Show("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                    " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                reportlog.WriteLine("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                //RDFutilitaires.ongoing= false;
                                //return;

                            }
                            else
                            {

                                nel.SchemaTypeName = new XmlQualifiedName(mapforprimitivetypes[classifier.Name], NS_XSD);
                            }
                        }
                    }
                    else
                    {
                        if (IsInline(classifier))
                        {
                            XmlSchemaObject sobjj = TraitElem(classifier, apackage, schem);
                            string xmltyp = sobjj.GetType().ToString();
                            switch (xmltyp)
                            {
                                case "System.Xml.Schema.XmlSchemaComplexType":
                                    nel.SchemaType = (XmlSchemaComplexType)sobjj;
                                    break;
                                case "System.Xml.Schema.XmlSchemaSimpleType":
                                    nel.SchemaType = (XmlSchemaSimpleType)sobjj;
                                    break;
                                default:
                                    break;
                            }
                        }
                        else
                        {
                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            if (!datatypetraite.Contains(classifierid))
                            {
                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                                //TraitElem(classifier,apackage,schem);
                            }
                        }
                    }
                    if (atr.LowerBound == "0") nel.MinOccurs = 0;
                    AddAnnForAtr(el, nel, atr, true);
                    /******** default or fixed values of the attribute ************************/
                    if (atr.Default != "")
                    {
                        if (atr.IsConst)
                        {
                            nel.FixedValue = atr.Default;
                        }
                        else
                        {
                            nel.DefaultValue = atr.Default;
                        }
                    }

                }
                else
                {
                    // classifier == not a CIM type
                    MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type " + classifier.Name + "  The element has been created without any type");
                    reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type " + classifier.Name + ". The element has been created without any type");
                }
            }
            else
            {  // classifier == 0 probably a type from EA
                MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type( native?). The element has been created without any type");
                reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type( native?). The element has been created without any type");
            }
        }

    

        //-------------------------------------------------------------------------------------------
    }
}



