using System;
using System.IO;
using System.Xml;
using System.Windows.Forms;
using System.Collections;
using System.Security.Principal;
using System.Collections.Generic;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company : Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CodeComponent
{
   public class XMLParser
    { 
        private static string CONFIG_FILE = @"\CimSyntaxgen-Config.xml";
        private static string LOG_FILE = @"\Log.xml";
        private string Path = "";
        
        private XmlTextReader XmlReader = null;
        private FileStream StreamFile = null;
        private string ActivatedFilePath;
        public string ActiveFilePath
        {
            get
            {
                return ActivatedFilePath;
            }
        }
        //---------- ajout am -------------------------------
        private XmlDocument confdoc;

        public XMLParser()
        {
            confdoc = new XmlDocument(); // am juil 2015
            
            
            string filepath = ".\\"; // am dec 2019

            if (File.Exists(filepath + CONFIG_FILE)) // if there is a config file in the database directory
                                                     // its path is take as Path or the directory is appdata
            {
                Path = filepath;
            }
            else
            {
                Path = Environment.GetEnvironmentVariable("APPDATA");// am jun 2013
                Path = Path + "\\Zamiren\\CimSyntaxGen\\Ressources"; // am jun 
            }

        }
        public XMLParser(string addin)
        {
            confdoc = new XmlDocument(); // am juil 2015
            Path = Environment.GetEnvironmentVariable("APPDATA");// am jun 2013
            Path = Path + "\\Zamiren\\CimSyntaxGen\\Ressources"; // am jun 2013

        }
        private void setFilePath(string FilePath){
            if (FilePath.Equals("DefaultLog"))
            {
                ActivatedFilePath = Path + LOG_FILE;
            }
            else if (FilePath.Equals("DefaultConfig"))
            {
                ActivatedFilePath = Path + CONFIG_FILE;
            }
            else {
                ActivatedFilePath = FilePath;
            }
            //MessageBox.Show(" path vers config.xml =" + ActivatedFilePath);
            confdoc = new XmlDocument();
            confdoc.Load(ActivatedFilePath); // chargement du config
        }
    
        private XmlTextReader ReadConfig()
        {

                        try
                        {
                            StreamFile = new FileStream(ActivatedFilePath, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite);
                            XmlReader = new XmlTextReader(StreamFile);
                            //MessageBox.Show(ActivatedFilePath);
                        }
                        catch(IOException Ex)
                        {
                            MessageBox.Show("Unexpected error (n°1).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }

                        return XmlReader;
                }
 
                public void Close()
                {
                    if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
 
                        if ( StreamFile != null )
                        {
                                StreamFile.Close();
                        }
                }

                private void InitXMLConfig()
                {
                    
                    this.Close();  //juil 2015
                    /*
                    XmlDocument NewXmlWriter = new XmlDocument();     
                    XmlNode RootNode = NewXmlWriter.CreateNode(XmlNodeType.XmlDeclaration, "1.0", "UTF-8");
                    NewXmlWriter.AppendChild(RootNode);
                    XmlElement RootElement = NewXmlWriter.CreateElement("", "add-in", "");
                    NewXmlWriter.AppendChild(RootElement);
                    XmlElement tmpAppSet = NewXmlWriter.CreateElement("", "appSettings", "");
                    XmlNode sectionNode = RootElement.AppendChild(tmpAppSet);
                    XmlElement tmpIsBasedOn = NewXmlWriter.CreateElement("", "configuration", "");
                    XmlAttribute AttributeXml = NewXmlWriter.CreateAttribute("name");
                    AttributeXml.Value = "Log";
                    tmpIsBasedOn.Attributes.Append(AttributeXml);
                    AttributeXml = NewXmlWriter.CreateAttribute("value");
                    AttributeXml.Value = "Unchecked";
                    tmpIsBasedOn.Attributes.Append(AttributeXml);
                    sectionNode = tmpAppSet.AppendChild(tmpIsBasedOn);
                    XmlElement Tmpelem = NewXmlWriter.CreateElement("", "dataProfile", "");
                    sectionNode = RootElement.AppendChild(Tmpelem);
		    XmlElement tmpPrefix = NewXmlWriter.CreateElement("", "profdata", "");
                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                    AttributeXml.Value = "Prefix";
                    tmpPrefix.Attributes.Append(AttributeXml);
                    AttributeXml = NewXmlWriter.CreateAttribute("value");
                    AttributeXml.Value = "m";
                    tmpPrefix.Attributes.Append(AttributeXml);
                    sectionNode = tmpAppSet.AppendChild(tmpPrefix);
                    NewXmlWriter.Save(ActivatedFilePath);
                    XmlReader.Close();
                     * */
                }
                public string GetXmlValueConfig(string ElementName)
                {
                    string ret = null;
                    try{                 
                    this.setFilePath("DefaultConfig");
                    string filtre = "//configuration[@name=\"" + ElementName + "\"]";
                    XmlNode elnode=confdoc.SelectSingleNode(filtre);
                    if(elnode==null) return ret;
                   System.Xml.XPath.XPathNavigator elnav=elnode.CreateNavigator();
                    ret=elnav.GetAttribute("value","");   
                        }catch(Exception e)
                    {
                        MessageBox.Show("Error   in getting configurationvalue " + ElementName + "," + e.Message);
                    }
                    return ret;
                }
       /*
                public string GetXmlValueConfig(string ElementName)
                {
                        this.setFilePath("DefaultConfig");

                        string Value = null;
                        XmlTextReader XmlReader = null;

                        try { XmlReader = ReadConfig(); }
                        catch{
                            this.InitXMLConfig();
                            XmlReader = ReadConfig();
                        }

                        try
                        {
                               while ( XmlReader.Read() )
                                {
                                    
                                        XmlNodeType NodeType = XmlReader.NodeType;

                                   
                                        if( NodeType == XmlNodeType.Element )
                                        {
                                            if (XmlReader.Name.Equals("configuration") && XmlReader.GetAttribute("name").Equals(ElementName))
                                                {
                                                        Value = XmlReader.GetAttribute("value");
                                                        XmlReader.Close();
                                                        return Value;
                                                }
                                        }
                                }
                        }
                        catch (XmlException Ex)
                        {
                            InitXMLConfig();
                            MessageBox.Show("Unexpected error (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        finally
                        {
                                if ( XmlReader != null )
                                {
                                        XmlReader.Close();
                                }
                        }
 
                        return Value;
                }

                */

                
                public void SetXmlValueConfig(string ElementName, string Value)
                {
                    if(this.GetXmlValueConfig("Log")==("Checked")){
                        this.AddXmlLog("Config Saved", "Element:"+ElementName +" Value:"+Value);
                    }

                        this.setFilePath("DefaultConfig");
                        XmlTextReader XmlReader = null;
                        XmlDocument NewXmlWriter = null;
                               
                        try
                        {
                                XmlReader = ReadConfig();
                                while ( XmlReader.Read() )
                                {                                       
                                    if (XmlReader.Name.Equals("configuration") && XmlReader.GetAttribute("name").Equals(ElementName))
                                        {
                                                this.Close();
                                                NewXmlWriter = new XmlDocument();
                                                NewXmlWriter.Load(ActivatedFilePath);

                                                XmlElement ElementRacine = NewXmlWriter.DocumentElement;
 
                                                XmlAttribute AttributeXml = null;
                                                XmlNode sectionNode = null;
 
                                                XmlNode groupNode = ElementRacine;
 
                                                sectionNode = groupNode.SelectSingleNode("appSettings");
 
                                                if (sectionNode == null)
                                                {
                                                    sectionNode = groupNode.AppendChild(NewXmlWriter.CreateElement("appSettings"));
                                                }                                               
 
                                                XmlNode NodeCherche = sectionNode.SelectSingleNode("configuration[@name=\"" + ElementName + "\"]");
 
                                                if ( NodeCherche == null )
                                                {
                                                    XmlElement Element = NewXmlWriter.CreateElement("configuration");
                                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                                        AttributeXml.Value = ElementName;
                                                        Element.Attributes.Append(AttributeXml);                       
 
                                                        NodeCherche = sectionNode.AppendChild(Element);                       
                                                }

                                                AttributeXml = NewXmlWriter.CreateAttribute("value");
                                                AttributeXml.Value = Value.ToString();
                                                NodeCherche.Attributes.Append(AttributeXml);
                                              /*  // juil 2015
                                                // ---- ajout provisoire ----------------
                                                try
                                                {
                                                    System.IO.File.Delete(ActivatedFilePath);
                                                }
                                                catch (Exception e)
                                                {
                                                    MessageBox.Show("Error deletion fichier " + ActivatedFilePath + " " + e.Message);
                                                }
                                           */
                                                NewXmlWriter.Save(ActivatedFilePath);
                                        }
                                }
                        }
                        catch (XmlException Ex)
                        {
                            if (this.GetXmlValueConfig("Log") == ("Checked"))
                            {
                                this.AddXmlLog("Warning!", "Error in XMLParser (SetXmlValueConfig) XMLException:"+Ex.Message);
                            }
                            MessageBox.Show("Unexpected error(n°3).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        catch (Exception Ex)
                        {
                            if (XmlReader != null)  //am juil 2015
                            {
                                XmlReader.Close();
                            }
                          //  InitXMLConfig(); //am juil 2015
                            this.AddXmlLog("Warning!", "Error in XMLParser (SetXmlValueConfig)Exception:" + Ex.Message);
                            
                            MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        finally
                        {
                                if ( XmlReader != null )
                                {
                                        XmlReader.Close();
                                }
                        }
                }


        //Quallifier
                public ArrayList GetXmlQualifier(string Allowed)
                {
                    this.setFilePath("DefaultConfig");
                    ArrayList ValueList = new ArrayList();
                    XmlTextReader XmlReader = null;

                    try
                    {
                        XmlReader = ReadConfig();
                        while (XmlReader.Read())
                        {
                            XmlNodeType NodeType = XmlReader.NodeType;

                            
                            if (NodeType == XmlNodeType.Element)
                            {
                                if (XmlReader.Name.Equals("qualifier") )
                                {

                                    if (XmlReader.GetAttribute("allowedTo").Equals(Allowed) || XmlReader.GetAttribute("allowedTo").Equals("any"))
                                    {
                                        ValueList.Add(XmlReader.GetAttribute("name"));
                                    }
                                }
                            }
                        }
                        XmlReader.Close();
                        return ValueList;
                    }
                    catch (XmlException Ex)
                    {
                        if (XmlReader != null)  //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();  //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (GetXMLQualifier) XMLException:" + Ex);
                        MessageBox.Show("Unexpected error read qualifiers (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                       if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }

                    return ValueList;
                }


                public void AddXmlQualifier(string ElementName, string Allowed)
                {

                    this.AddXmlLog("Adding Qualifier", "Added Qualifier:"+ElementName);
                    
                    this.setFilePath("DefaultConfig");
                    XmlTextReader XmlReader = null;
                    XmlDocument NewXmlWriter = null;
                    

                    try
                    {
                        XmlReader = ReadConfig();

                        while (XmlReader.Read())
                        {
                            if (XmlReader.Name.Equals("appSettings"))
                            {
                                this.Close();
                                NewXmlWriter = new XmlDocument();
                                NewXmlWriter.Load(ActivatedFilePath);
                
                                    XmlElement RootElement = NewXmlWriter.DocumentElement;
                                

                                XmlAttribute AttributeXml = null;
                                XmlNode sectionNode = null;

                                XmlNode groupNode = RootElement;
                                sectionNode = groupNode.SelectSingleNode("dataQualifier");
                                if (sectionNode == null)
                                {
                                    sectionNode = groupNode.AppendChild(NewXmlWriter.CreateElement("data"));
                                }

                                XmlNode SearchedNode = sectionNode.SelectSingleNode("qualifier[@name=\"" + ElementName + "\"]");

                                if (SearchedNode == null)
                                {
                                    XmlElement Element = NewXmlWriter.CreateElement("qualifier");
                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                    AttributeXml.Value = ElementName;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("allowedTo");
                                    AttributeXml.Value = Allowed;
                                    Element.Attributes.Append(AttributeXml);
                                    SearchedNode = sectionNode.AppendChild(Element);
                                }
                                else{
                                    sectionNode.RemoveChild(SearchedNode);
                                    XmlElement Element = NewXmlWriter.CreateElement("qualifier");
                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                    AttributeXml.Value = ElementName;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("allowedTo");
                                    AttributeXml.Value = Allowed;
                                    Element.Attributes.Append(AttributeXml);
                                    
                                    SearchedNode = sectionNode.AppendChild(Element);
                                }


                              //  SearchedNode.Attributes.Append(AttributeXml);
                                NewXmlWriter.Save(ActivatedFilePath);
                            }
                        }
                    }
                    catch (XmlException Ex)
                    {

                        this.AddXmlLog("Warning!", "Error in XMLParser (AddXmlQualifier) XMLException:" + Ex);
                        
                        MessageBox.Show("Unexpected XML error(n°3).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                      //  InitXMLConfig();  am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (AddXmlQualifier) Exception:" + Ex);
                        MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }
                }

                public void DeleteXmlQualifier(string ElementName)
                {
                    
                    this.AddXmlLog("Deleting Qualifier", "Deleted Qualifier:"+ElementName);

                    this.setFilePath("DefaultConfig");
                    if(!ElementName.Equals(null)){
                    XmlTextReader XmlReader = null;
                    XmlDocument NewXmlWriter = null;

                    try
                    {
                        XmlReader = ReadConfig();

                        while (XmlReader.Read())
                        {
                            if (XmlReader.Name.Equals("qualifier"))
                            {
                                this.Close();

                                NewXmlWriter = new XmlDocument();
                                NewXmlWriter.Load(ActivatedFilePath);

                                XmlElement ElementRacine = NewXmlWriter.DocumentElement;

                                XmlNode sectionNode = null;

                                XmlNode groupNode = ElementRacine;
                                sectionNode = groupNode.SelectSingleNode("dataQualifier");

                                XmlNode SearchedNode = sectionNode.SelectSingleNode("qualifier[@name=\"" + ElementName + "\"]");

                                if (!(SearchedNode==null))
                                {
                                    sectionNode.RemoveChild(SearchedNode);
                                }
                                NewXmlWriter.Save(ActivatedFilePath);
                            }
                        }
                    }
                    catch (XmlException Ex)
                    {
                        this.AddXmlLog("Warning!", "Error in XMLParser (DeleteXmlQualifier) XMLException:" + Ex);
                        
                        MessageBox.Show("Unexpected XML error(n°3).\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();   //am juil 2015                        this.AddXmlLog("Warning!", "Error in XMLParser (DeleteXmlQualifier) Exception:" + Ex);                        
                        MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }
                    }
                }

        //Log
                public void AddXmlLog(string EventType, string LogValue)
                {
                    if (!(this.GetXmlValueConfig("Log") == ("Checked")))
                    {
                        return;
                    }
                    //eventtype must not have any whitespace
                    EventType = EventType.Replace(" ","");
                    XmlTextReader XmlReader = null;
                    XmlDocument NewXmlWriter = null;
                    /*
                    try
                    {
                        string FilePath = this.GetXmlValueConfig("LogFolder");
                        if (FilePath.Equals(null) || FilePath.Equals(""))
                        {
                            this.setFilePath(FilePath);
                        }
                    }
                    catch
                    {*/
                        this.setFilePath("DefaultLog");
                  /*  }*/

                    try
                    {//ErreurPar ICI
                        XmlReader = ReadConfig();
                        this.Close();
                        NewXmlWriter = new XmlDocument();
                        
                        
                        XmlElement RootElement;
                        try
                        {
                             NewXmlWriter.Load(ActivatedFilePath);
                             RootElement = NewXmlWriter.DocumentElement;
                        }
                        catch
                        {
                            
                            XmlNode RootNode = NewXmlWriter.CreateNode(XmlNodeType.XmlDeclaration, "", "");
                            NewXmlWriter.AppendChild(RootNode);

                            RootElement = NewXmlWriter.CreateElement("", "add-inLogs", "");
                            NewXmlWriter.AppendChild(RootElement);

                        }

                        
                                XmlAttribute AttributeXml = null;
                                XmlNode sectionNode = null;

                                foreach( XmlNode ANode in RootElement.SelectNodes("logDate")){
                                    if (ANode.Attributes[0].Value.Equals(DateTime.Now.ToString("MM-dd-yyyy")))
                                    {
                                        sectionNode = ANode;
                                    }
                                }
                                if (sectionNode == null)
                                {
                                    XmlElement tmpelem = NewXmlWriter.CreateElement("","logDate","");
                                    AttributeXml = NewXmlWriter.CreateAttribute("date");
                                    AttributeXml.Value = (DateTime.Now.ToString("MM-dd-yyyy"));
                                    tmpelem.Attributes.Append(AttributeXml);
                                    sectionNode = RootElement.AppendChild(tmpelem);
                                }
                                
                                
                                XmlElement Element = NewXmlWriter.CreateElement("","log","");

                                    AttributeXml = NewXmlWriter.CreateAttribute("time");
                                    AttributeXml.Value = DateTime.Now.ToString("HH:mm:ss");
                                    Element.Attributes.Append(AttributeXml);
                                    
                                    AttributeXml = NewXmlWriter.CreateAttribute("username");
                                    AttributeXml.Value = WindowsIdentity.GetCurrent().Name.ToString();
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute(EventType);
                                    AttributeXml.Value = LogValue;
                                    Element.Attributes.Append(AttributeXml);

                                    XmlNode NewNode = sectionNode.AppendChild(Element);



                                    NewNode.Attributes.Append(AttributeXml);
                                    NewXmlWriter.Save(ActivatedFilePath);
                           
                    }
                    catch (XmlException Ex)
                    {
                        MessageBox.Show("Unexpected XML error(n°3).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception Ex)
                    {
                        MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }
                }





        //Constraint

                public ArrayList GetXmlConstraint(string Allowed)
                {
                    this.setFilePath("DefaultConfig");
                    ArrayList ValueList = new ArrayList();
                    XmlTextReader XmlReader = null;

                    try
                    {
                        XmlReader = ReadConfig();
                        while (XmlReader.Read())
                        {
                            XmlNodeType NodeType = XmlReader.NodeType;


                            if (NodeType == XmlNodeType.Element)
                            {
                                if (XmlReader.Name.Equals("constraint"))
                                {
                                    if (XmlReader.GetAttribute("allowedTo").Equals(Allowed) || XmlReader.GetAttribute("allowedTo").Equals("any"))
                                    {
                                  //  ValueList.Add( new XMLConstraint(XmlReader.GetAttribute("name"), XmlReader.GetAttribute("type"), XmlReader.GetAttribute("notes")) );
                                    }
                                }
                            }
                        }
                        XmlReader.Close();
                        return ValueList;
                    }
                    catch (XmlException Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig(); //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (GetXMLQualifier) XMLException:" + Ex.Message);
                        MessageBox.Show("Unexpected error reading constraints (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }

                    return ValueList;
                }

                public ArrayList GetXmlClassifierConstraint(string Allowed)
                {
                    this.setFilePath("DefaultConfig");
                    ArrayList ValueList = new ArrayList();
                    XmlTextReader XmlReader = null;

                    try
                    {
                        XmlReader = ReadConfig();
                        while (XmlReader.Read())
                        {
                            XmlNodeType NodeType = XmlReader.NodeType;


                            if (NodeType == XmlNodeType.Element)
                            {
                                if (XmlReader.Name.Equals("classifierconstraint"))
                                {
                                    if (XmlReader.GetAttribute("allowedTo").ToLower().Equals(Allowed.ToLower()) || XmlReader.GetAttribute("allowedTo").ToLower().Equals("any".ToLower()))
                                    {
                                        try
                                        {

                                       //     ValueList.Add(new XMLClassifierConstraint(XmlReader.GetAttribute("name"), XmlReader.GetAttribute("type"), XmlReader.GetAttribute("variableType"), XmlReader.GetAttribute("variableList"), XmlReader.GetAttribute("comment"), XmlReader.ReadString()));
                                        }
                                        catch(Exception Ex)
                                        {
                                            MessageBox.Show("Error while recovering the XML data of " + XmlReader.GetAttribute("name") + "\nThe constraint list will probably be corrupted, you should close this window and check the config file. \n" +Ex.Message , "Error while recovering XML data", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                                        }
                                    }
                                }
                            }
                        }
                        XmlReader.Close();
                        return ValueList;
                    }
                    catch (XmlException Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();  //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (GetXMLQualifier) XMLException:" + Ex);
                        MessageBox.Show("Unexpected error getClassifierConstraint (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }

                    return ValueList;
                }
        //-----------------------------------
        //profdata
                public List<string> GetXmlAllProfstereo()
                {
                    this.setFilePath("DefaultConfig");
                    List<string> ValueList = new List<string>();
                    XmlTextReader XmlReader = null;
                    string stereo = "";

                    try
                    {
                        XmlReader = ReadConfig();
                        while (XmlReader.Read())
                        {
                            XmlNodeType NodeType = XmlReader.NodeType;


                            if (NodeType == XmlNodeType.Element)
                            {
                                if (XmlReader.Name.Equals("profstereo"))
                                {

                                    stereo = XmlReader.GetAttribute("name");
                                    ValueList.Add(stereo);
                                    
                                }
                            }
                        }
                        XmlReader.Close();
                        return ValueList;
                    }
                    catch (XmlException Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();  //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (GetXMLQualifier) XMLException:" + Ex);
                        MessageBox.Show("Unexpected error getprofstereo(n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }

                    return ValueList;
                }
                public string GetXmlValueProfData(string ElementName)
                {
                    string ret = null;
                    try
                    {
                        this.setFilePath("DefaultConfig");
                        XmlNode elnode = confdoc.SelectSingleNode("//profdata[@name=\"" + ElementName + "\"]");
                        if (elnode == null) return ret;
                        System.Xml.XPath.XPathNavigator elnav = elnode.CreateNavigator();
                        ret = elnav.GetAttribute("value", "");
                    }catch(Exception e)
                    {
                        MessageBox.Show("Error   in getting profdatavalue " + ElementName + "," + e.Message);
                    }
                    return ret;
                }
       /*
            public string GetXmlValueProfData(string ElementName)
                {
                        this.setFilePath("DefaultConfig");
                        string Value = null;
                        XmlTextReader XmlReader = null;

                        try { XmlReader = ReadConfig(); }
                        catch{
                            this.InitXMLConfig();
                            XmlReader = ReadConfig();
                        }

                        try
                        {
                               while ( XmlReader.Read() )
                                {
                                    
                                        XmlNodeType NodeType = XmlReader.NodeType;

                                   
                                        if( NodeType == XmlNodeType.Element )
                                        {
                                            string prov = XmlReader.GetAttribute("name");
                                            if (XmlReader.Name.Equals("profdata") && XmlReader.GetAttribute("name").Equals(ElementName))
                                                {
                                                        Value = XmlReader.GetAttribute("value");
                                                        XmlReader.Close();
                                                        return Value;
                                                }
                                        }
                                }
                        }
                        catch (XmlException Ex)
                        {
                            InitXMLConfig();
                            MessageBox.Show("Unexpected error (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        finally
                        {
                                if ( XmlReader != null )
                                {
                                        XmlReader.Close();
                                }
                        }
 
                        return Value;
                }   
       */

                public void SetXmlValueProfData(string ElementName, string Value)
                {
		/*
                    if(this.GetXmlValueConfig("Log")==("Checked")){
                        this.AddXmlLog("Config Saved", "Element:"+ElementName +" Value:"+Value);
                    }
                */
                        this.setFilePath("DefaultConfig");
                        XmlTextReader XmlReader = null;
                        XmlDocument NewXmlWriter = null;
                               
                        try
                        {
                                XmlReader = ReadConfig();
                                while ( XmlReader.Read() )
                                {                                       
                                    if (XmlReader.Name.Equals("profdata") && XmlReader.GetAttribute("name").Equals(ElementName))
                                        {
                                                this.Close();
                                                NewXmlWriter = new XmlDocument();
                                                NewXmlWriter.Load(ActivatedFilePath);

                                                XmlElement ElementRacine = NewXmlWriter.DocumentElement;
 
                                                XmlAttribute AttributeXml = null;
                                                XmlNode sectionNode = null;
 
                                                XmlNode groupNode = ElementRacine;
 
                                                sectionNode = groupNode.SelectSingleNode("dataProfile");
 
                                                if (sectionNode == null)
                                                {
                                                    sectionNode = groupNode.AppendChild(NewXmlWriter.CreateElement("dataProfile"));
                                                }                                               
 
                                                XmlNode NodeCherche = sectionNode.SelectSingleNode("profdata[@name=\"" + ElementName + "\"]");
 
                                                if ( NodeCherche == null )
                                                {
                                                    XmlElement Element = NewXmlWriter.CreateElement("profdata");
                                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                                        AttributeXml.Value = ElementName;
                                                        Element.Attributes.Append(AttributeXml);                       
 
                                                        NodeCherche = sectionNode.AppendChild(Element);                       
                                                }

                                                AttributeXml = NewXmlWriter.CreateAttribute("value");
                                                AttributeXml.Value = Value.ToString();
                                                NodeCherche.Attributes.Append(AttributeXml);
                                                //am juil 2015
                                              /*
                                                // ---- ajout provisoire ----------------
                                                try
                                                {
                                                    System.IO.File.Delete(ActivatedFilePath);
                                                }
                                                catch (Exception e)
                                                {
                                                    MessageBox.Show("Error deletion fichier " + ActivatedFilePath + " " + e.Message);
                                                }
                                                */
                                                NewXmlWriter.Save(ActivatedFilePath);
                                               
                                        }
                                }
                        }
                        catch (XmlException Ex)
                        {
                           /*
                            if (this.GetXmlValueConfig("Log") == ("Checked"))
                            {
                                this.AddXmlLog("Warning!", "Error in XMLParser (SetXmlValueConfig) XMLException:"+Ex);
                            }
                          */
                            MessageBox.Show("Unexpected error(n°3) dans  SetXmlValueProfData.\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        catch (Exception Ex)
                        {
                            if (XmlReader != null)
                            {
                                XmlReader.Close();
                            }
                            //InitXMLConfig();
                            this.AddXmlLog("Warning!", "Error in XMLParser (SetXmlValueProfData)Exception:" + Ex.Message);

                            MessageBox.Show("Unexpected error(n°4)(SetXmlValueProfData) .\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        }
                        finally
                        {
                                if ( XmlReader != null )
                                {  
                                        XmlReader.Close();
                                }
                               
                        }
                }
// profstereo
        
                public ArrayList GetXmlProfstereo(string name)
                {
                    this.setFilePath("DefaultConfig");
                    ArrayList ValueList = new ArrayList();
                    XmlTextReader XmlReader = null;

                    try
                    {
                        XmlReader = ReadConfig();
                        while (XmlReader.Read())
                        {
                            XmlNodeType NodeType = XmlReader.NodeType;

                            
                            if (NodeType == XmlNodeType.Element)
                            {
                                if (XmlReader.Name.Equals("profstereo") )
                                {
				   
                                   if( XmlReader.GetAttribute("name").Equals(name))                                    {
                                        ValueList.Add(XmlReader.GetAttribute("prefix"));
 					ValueList.Add(XmlReader.GetAttribute("uri"));
                    ValueList.Add(XmlReader.GetAttribute("html"));
                    ValueList.Add(XmlReader.GetAttribute("rdfs"));
                                    }
				
                                }
                            }
                        }
                        XmlReader.Close();
                        return ValueList;
                    }
                    catch (XmlException Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();  //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (GetXMLProfstereo) XMLException:" + Ex);
                        MessageBox.Show("Unexpected error (n°2).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                       if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }

                    return ValueList;
                }


                public void AddXmlProfstereo(string Stereo, string Prefix,string Uri,string Html,string Rdfs,string Desc)
                {

                    this.AddXmlLog("Adding Profstereo", "Added Profstereo:"+ Stereo);
                    
                    this.setFilePath("DefaultConfig");
                    XmlTextReader XmlReader = null;
                    XmlDocument NewXmlWriter = null;
                    

                    try
                    {
                        XmlReader = ReadConfig();

                        while (XmlReader.Read())
                        {
                            if (XmlReader.Name.Equals("appSettings"))
                            {
                                this.Close();
                                NewXmlWriter = new XmlDocument();
                                NewXmlWriter.Load(ActivatedFilePath);
                
                                    XmlElement RootElement = NewXmlWriter.DocumentElement;
                                

                                XmlAttribute AttributeXml = null;
                                XmlNode sectionNode = null;

                                XmlNode groupNode = RootElement;
                                sectionNode = groupNode.SelectSingleNode("dataProfile");
                                if (sectionNode == null)
                                {
                                    sectionNode = groupNode.AppendChild(NewXmlWriter.CreateElement("dataProfile"));
                                }

                                XmlNode SearchedNode = sectionNode.SelectSingleNode("profstereo[@name=\"" + Stereo + "\"]");

                                if (SearchedNode == null)
                                {
                                    XmlElement Element = NewXmlWriter.CreateElement("profstereo");
                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                    AttributeXml.Value = Stereo;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("prefix");
                                    AttributeXml.Value = Prefix;
                                    Element.Attributes.Append(AttributeXml);
				                    AttributeXml = NewXmlWriter.CreateAttribute("uri");
                                    AttributeXml.Value = Uri;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("html");
                                    AttributeXml.Value = Html;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("rdfs");
                                    AttributeXml.Value = Rdfs;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("desc");
                                    AttributeXml.Value = Rdfs;
                                    Element.Attributes.Append(AttributeXml);
                                    SearchedNode = sectionNode.AppendChild(Element);
                                }
                                else{
                                    ArrayList oldprofstereo = this.GetXmlProfstereo(Stereo);
                                    sectionNode.RemoveChild(SearchedNode);
                                    XmlElement Element = NewXmlWriter.CreateElement("profstereo");
                                    AttributeXml = NewXmlWriter.CreateAttribute("name");
                                    AttributeXml.Value = Stereo;
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("prefix");
                                    if (Prefix == null)
                                    {
                                        AttributeXml.Value = (string)oldprofstereo[0];
                                    }
                                    else
                                    {
                                        AttributeXml.Value = Prefix;
                                    }
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("uri");
                                    if (Uri == null)
                                    {
                                        AttributeXml.Value = (string)oldprofstereo[1];
                                    }
                                    else
                                    {
                                        AttributeXml.Value = Uri;
                                    }
                                    Element.Attributes.Append(AttributeXml);


                                    AttributeXml = NewXmlWriter.CreateAttribute("html");
                                    if (Html == null)
                                    {
                                        AttributeXml.Value = (string)oldprofstereo[2];
                                    }
                                    else
                                    {
                                        AttributeXml.Value = Html;
                                    }
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("rdfs");
                                    if (Rdfs == null)
                                    {
                                        AttributeXml.Value = (string)oldprofstereo[3];
                                    }
                                    else
                                    {
                                        AttributeXml.Value = Rdfs;
                                    }
                                    Element.Attributes.Append(AttributeXml);

                                    AttributeXml = NewXmlWriter.CreateAttribute("desc");
                                    if (Rdfs == null)
                                    {
                                        AttributeXml.Value = (string)oldprofstereo[3];
                                    }
                                    else
                                    {
                                        AttributeXml.Value = Rdfs;
                                    }
                                    Element.Attributes.Append(AttributeXml);

                            SearchedNode = sectionNode.AppendChild(Element);
                                }


                              //  SearchedNode.Attributes.Append(AttributeXml);
                                NewXmlWriter.Save(ActivatedFilePath);
                            }
                        }
                    }
                    catch (XmlException Ex)
                    {

                        this.AddXmlLog("Warning!", "Error in XMLParser (AddXmlProfstereo) XMLException:" + Ex);
                        
                        MessageBox.Show("Unexpected XML error(n°3).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                       // InitXMLConfig();  //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (AddXmlProfstereo) Exception:" + Ex);
                        MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }
                }
       /// <summary>
      
                public void DeleteXmlProfstereo(string Stereo)
                {
                    
                    this.AddXmlLog("Deleting Profstereo", "Deleted Stereo:"+ Stereo);

                    this.setFilePath("DefaultConfig");
                    if(!Stereo.Equals(null)){
                    XmlTextReader XmlReader = null;
                    XmlDocument NewXmlWriter = null;

                    try
                    {
                        XmlReader = ReadConfig();

                        while (XmlReader.Read())
                        {
                            if (XmlReader.Name.Equals("profstereo"))
                            {
                                this.Close();

                                NewXmlWriter = new XmlDocument();
                                NewXmlWriter.Load(ActivatedFilePath);

                                XmlElement ElementRacine = NewXmlWriter.DocumentElement;

                                XmlNode sectionNode = null;

                                XmlNode groupNode = ElementRacine;
                                sectionNode = groupNode.SelectSingleNode("dataProfile");

                                XmlNode SearchedNode = sectionNode.SelectSingleNode("profstereo[@name=\"" + Stereo + "\"]");

                                if (!(SearchedNode==null))
                                {
                                    sectionNode.RemoveChild(SearchedNode);
                                }
                                NewXmlWriter.Save(ActivatedFilePath);
                            }
                        }
                    }
                    catch (XmlException Ex)
                    {
                        this.AddXmlLog("Warning!", "Error in XMLParser (DeleteXmlProfstereo) XMLException:" + Ex);
                        
                        MessageBox.Show("Unexpected XML error(n°3).\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception Ex)
                    {
                        if (XmlReader != null) //am juil 2015
                        {
                            XmlReader.Close();
                        }
                      //  InitXMLConfig(); //am juil 2015
                        this.AddXmlLog("Warning!", "Error in XMLParser (DeleteXmlProfstereo) Exception:" + Ex);                        
                        MessageBox.Show("Unexpected error(n°4).\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                    }
                    finally
                    {
                        if (XmlReader != null)
                        {
                            XmlReader.Close();
                        }
                    }
                    }
                }

//--------------------------------------------------------------------------
    }
}
