﻿using System;
using System.Collections.Generic;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Compression;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company : Zamiren (Joinville-le-Pont France)  *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.1.0                                    *    septembre  2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/

namespace CodeComponent
{
    public partial class codecomponentForm : Form
    {
        string _commentaire = "";
        public string commentaire
        {
            get
            {
                return _commentaire;
            }
            set
            {
                _commentaire = value;
            }
        }
        XMLParser XMLP;
        string[] selectedFiles;
        List<string> selectedCCFiles;
        public codecomponentForm()
        {
            
            XMLP = new XMLParser();
            InitializeComponent();
            InitializeOpenFileDialog();
             this.comboBox1.Text = XMLP.GetXmlValueProfData("CCTypeOfDocument");
            this.comboBox2.Text = XMLP.GetXmlValueProfData("CCStandardNumber");
            this.comboBox3.Text = XMLP.GetXmlValueProfData("CCCodeComponentName");
            this.comboBox5.Text = XMLP.GetXmlValueProfData("CCDiffusionState");
            this.comboBox4.Text = XMLP.GetXmlValueProfData("CCLightFull");
            this.textBox1.Text = XMLP.GetXmlValueProfData("CCProfileName");
            this.textBox2.Text = XMLP.GetXmlValueProfData("CCVersionStateInfo");
            this.textBox3.Text= XMLP.GetXmlValueProfData("CCPublicationDate");
            this.label9.Text = makePackageName();
            string ss = XMLP.GetXmlValueProfData("CCSelectedFiles");
            selectedCCFiles = new List<string>();
            this.label11.Text = "";
            if ( ss!= "")
            {
                string[] split = ss.Split(new char[] { ',' });
                for(int i=0;i < split.Length;i++)
                {
                    if (split[i] != "")
                    {
                        if (!selectedCCFiles.Contains(split[i])) selectedCCFiles.Add(split[i]);

                        this.label11.Text = this.label11.Text + "::" + System.IO.Path.GetFileName(split[i]);
                    }
                }
              
            }
        }
        
        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }


        private void InitializeOpenFileDialog()
        {
            // Set the file dialog to filter for graphics files.
            this.openFileDialog1.Filter =
                "Profiles (*.XSD;*.rdf;|"; //+ "All files (*.*)|*.*";

            // Allow the user to select multiple images.
            this.openFileDialog1.Multiselect = true;
            this.openFileDialog1.Title = "ProfileFiles select";
        }

        private void BUTSelectFiles_Click(object sender, EventArgs e)


        {
            DialogResult dr = this.openFileDialog1.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                // Read the files
                

                foreach (String file in openFileDialog1.FileNames)
                {
                    // memorize he fies.
                    try
                    {
                        if (!selectedCCFiles.Contains(file))
                        {
                            selectedCCFiles.Add(file);
                            this.label11.Text = this.label11.Text +  "::" + Path.GetFileName(file);
                        }
                    
                    }

                    catch (Exception ex)
                    {
                        // Could not load the image - probably related to Windows file system permissions.
                        MessageBox.Show("codecomponent openFileDialog " + ex.Message);
                        XMLP.AddXmlLog("codecomponent openFileDialog ", ex.Message);
                    }
                }
            }
        }

        private void taus(object sender, EventArgs e)
        {

        }

        private void BUTOK_Click(object sender, EventArgs e)
        {
            try
            {
                //MessageBox.Show(" debut OK");
                XMLP.SetXmlValueProfData("CCTypeOfDocument", this.comboBox1.Text);
                XMLP.SetXmlValueProfData("CCStandardNumber", this.comboBox2.Text);
                XMLP.SetXmlValueProfData("CCCodeComponentName", this.comboBox3.Text);
                XMLP.SetXmlValueProfData("CCDiffusionState", this.comboBox5.Text);
                XMLP.SetXmlValueProfData("CCLightFull", this.comboBox4.Text);
                XMLP.SetXmlValueProfData("CCProfileName", this.textBox1.Text);
                XMLP.SetXmlValueProfData("CCVersionStateInfo", this.textBox2.Text);
                XMLP.SetXmlValueProfData("CCPublicationDate", this.textBox3.Text);
                /*
                string ccfilename = "IEC_";
                if (this.comboBox1.Text != "IS")
                {
                    ccfilename=ccfilename + this.comboBox1.Text + "_";
                }

                ccfilename = ccfilename + this.comboBox2.Text + this.textBox1.Text;
                ccfilename = ccfilename + "." + this.comboBox3.Text + "." + this.textBox2.Text;
                ccfilename = ccfilename + "." + this.comboBox4.Text;
                if(this.comboBox5.Text !="IEC")
                {
                    ccfilename = ccfilename + "." + this.comboBox5.Text;

                }
                XMLP.SetXmlValueProfData("CCVersionStateInfo", this.textBox2.Text);

         */
              
                XMLP.SetXmlValueProfData("CCPackageName", makePackageName());
                if (
                    (!XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("XSD"))
                    &&
                    (!XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("RDFS"))
                    )
                {
                    MessageBox.Show(" At this moment only insertion of copyright in XSDs or RDFS  profiles are taken into account");
                    this.Dispose();
                }
                if (selectedCCFiles.Count == 0)
                {
                    MessageBox.Show(" you must select some profile files");
                }
                else
                {
                    string ss = "";
                    foreach (string file in selectedCCFiles)
                    {
                        ss = ss + "," + file;
                    }
                    XMLP.SetXmlValueProfData("CCSelectedFiles", ss);
                    insertCopyright();
                    makeManifest();
                    prodCodeComponent();
                    this.Dispose();
                }

                // production du zip
                
            }catch(Exception ex)
            {
                MessageBox.Show(" BUTOK" + ex.Message);
            }
        }

        private void BUTCancel_Click(object sender, EventArgs e)
        {
            selectedCCFiles = new List<string>();
            this.Dispose();
        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        string makePackageName()
        {
            
            string ccfilename = "IEC_";
            if (this.comboBox1.Text != "IS")
            {
                ccfilename = ccfilename + this.comboBox1.Text + "_";
            }

            ccfilename = ccfilename + this.comboBox2.Text + this.textBox1.Text;
            ccfilename = ccfilename + "." + this.comboBox3.Text + "." + this.textBox2.Text;
            ccfilename = ccfilename + "." + this.comboBox4.Text;
            if (this.comboBox5.Text != "IEC")
            {
                ccfilename = ccfilename + "." + this.comboBox5.Text;

            }
                 return ccfilename;
        }

        private void comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.label9.Text = makePackageName();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.label9.Text = makePackageName();
        }
        private void prodCodeComponent()
        {
            try
            {
                //manipulating the files

                // creating the zip for the codeComponent
               // MessageBox.Show("  prodComponent " + Directory.GetCurrentDirectory());
                string packagename = XMLP.GetXmlValueProfData("CCPackageName") + ".zip";
                //MessageBox.Show(" essai prodcomponent avec" + packagename);
                if (File.Exists(packagename)) File.Delete(packagename);

                using (FileStream zipToOpen = new FileStream(packagename, FileMode.OpenOrCreate))
                {
                    using (ZipArchive archive = new ZipArchive(zipToOpen, ZipArchiveMode.Update))
                    {
                        foreach (string file in selectedCCFiles)
                        {
                            ZipArchiveEntry readmeEntry = archive.CreateEntry(Path.GetFileName(file));

                            using (StreamWriter writer = new StreamWriter(readmeEntry.Open()))
                            {
                                using (StreamReader reader = new StreamReader(file))
                                {

                                    writer.Write(reader.ReadToEnd());

                                }
                            }

                        }
                    }
                }
                string prov = Directory.GetCurrentDirectory();
                MessageBox.Show("the PackageZip file is in " + prov);

            }

            catch (Exception ex)
            {
                XMLP.AddXmlLog("prodComponent", ex.Message);
            }
        }
        void makeManifest()
        {
            try
            {
                XmlDocument doc = new XmlDocument();

                string path =Environment.GetEnvironmentVariable("APPDATA");// 
                path = path + "\\Zamiren\\CimSyntaxGen\\Ressources\\"; //
                TextReader tfile = new StreamReader(path + "IECManifestHeader.xml");
                doc.Load(tfile);
                XmlElement root = doc.DocumentElement;
                XmlNode fc = root.FirstChild;
                XmlNode notice = fc.FirstChild;
                string noticetext = "COPYRIGHT(c) IEC,";
                noticetext = noticetext + XMLP.GetXmlValueProfData("CCPublicationDate");
                string type = XMLP.GetXmlValueProfData("CCCodeComponentName");
                if (type.Contains("XSD"))
                {
                    type = "XSD";
                }
                else
                {
                    if (type.Contains("RDFS"))
                    {
                        type = "RDFS";
                    }
                }
                if (type == "XSD")
                {
                    noticetext = noticetext + " .This version of this XSD is part of  IEC ";
                }
                else
                {
                    if (type == "RDFS")
                    { 
                    noticetext = noticetext + " .This version of this RDFS is part of  IEC ";
                    }
                }
                noticetext = noticetext + XMLP.GetXmlValueProfData("CCStandardNumber") + " " + XMLP.GetXmlValueProfData("CCProfileName");
                noticetext = noticetext + "; see the IEC " + XMLP.GetXmlValueProfData("CCStandardNumber") + " " + XMLP.GetXmlValueProfData("CCProfileName");
                noticetext = noticetext + " for full legal notices.In case of any differences between the here - below code and the IEC published content, the IEC published content remains the reference to be considered.The whole document has to be taken into account to have a full description of this code component.";
                noticetext = noticetext + "See www.iec.ch / CCv1 for copyright details.";
                notice.InnerText = noticetext;
                XmlNode ccnode = fc.NextSibling;
                XmlAttributeCollection attributes = ccnode.Attributes;
                XmlNode atr = attributes.GetNamedItem("id");
                string id = type + "." + XMLP.GetXmlValueProfData("CCStandardNumber") +XMLP.GetXmlValueProfData("CCProfileName") + "." + XMLP.GetXmlValueProfData("CCVersionStateInfo");
                atr.Value = id;
                atr= attributes.GetNamedItem("name");
                string name= XMLP.GetXmlValueProfData("CCStandardNumber") + " " + XMLP.GetXmlValueProfData("CCProfileName") + " " + XMLP.GetXmlValueProfData("CCVersionStateInfo");
                atr.Value = name;
                atr = attributes.GetNamedItem("date");
                atr.Value = XMLP.GetXmlValueProfData("CCPublicationDate");
                atr = attributes.GetNamedItem("content");
                atr.Value = XMLP.GetXmlValueProfData("CCLightFull");
                XmlNode publinode = ccnode.FirstChild;
                 attributes = publinode.Attributes;
                atr = attributes.GetNamedItem("name");
                name = "IEC" + " " + XMLP.GetXmlValueProfData("CCStandardNumber") + " " + XMLP.GetXmlValueProfData("CCProfileName");
                atr.Value = name;
                atr = attributes.GetNamedItem("comment");
                // string comment= "Machine - processable format of IEC ";
                //comment = comment + XMLP.GetXmlValueProfData("CCStandardNumber");
                //comment = comment + "-related data models for tools";
                Comment commentform = new Comment(this);
                commentform.fichier = "CodeComponent.Publication";
                commentform.ShowDialog();
                atr.Value = commentaire;
              

                foreach(string file in selectedCCFiles)
                {  
                    
                    string filename = Path.GetFileName(file);
                    if (!filename.Contains("history"))
                    {
                        
                        XmlElement xmlel = doc.CreateElement("File");
                        atr = xmlel.SetAttributeNode("name", "");
                        atr.Value = filename;
                        atr = xmlel.SetAttributeNode("category", "");
                        if (XMLP.GetXmlValueProfData("CCDiffusionState") == "IEC")
                        {
                            atr.Value = "normative";
                        }
                        else
                        {
                            atr.Value = "informative";
                        }
                        atr = xmlel.SetAttributeNode("content", "");
                        atr.Value = XMLP.GetXmlValueProfData("CCLightFull");
                        atr = xmlel.SetAttributeNode("comment", "");
                        commentform.fichier = Path.GetFileName(file);
                        commentform.ShowDialog();
                        atr.Value = commentaire;
                        atr = attributes.GetNamedItem("xmlns");
                        if (atr != null) xmlel.RemoveAttribute("xmlns");
                        XmlNode filenode = ccnode.AppendChild(xmlel);

                    }
                    else
                    {
                        XmlElement xmlel = doc.CreateElement("HistoryFile");
                        atr = xmlel.SetAttributeNode("name", "");
                        atr.Value = filename;
                        XmlNode filenode = ccnode.AppendChild(xmlel);
                    }
                }
                string actualfilepath = XMLP.ActiveFilePath;
                string manifest = Path.GetDirectoryName(actualfilepath) + "\\" + "IECManifest.xml";
                if (File.Exists(manifest)) File.Delete(manifest);
                string d = Path.GetDirectoryName(manifest);
                string f = Path.GetFileName(manifest);
                string newmanifest = d + "\\new" + f;
                if (File.Exists(newmanifest)) File.Delete(newmanifest);
               // TextWriter tm = new StreamWriter(manifest);
                //doc.Save(tm);
               // tm.Close();
                doc.Save(newmanifest);
                TextReader rm = new StreamReader(newmanifest);
                TextWriter wm = new StreamWriter(manifest);
                string ligne = "";
                string newline = "";
                while(true)
                {
                    ligne = rm.ReadLine();
                    if (ligne == null) break;
                    if(ligne.Contains("<File"))
                    {
                      newline=ligne.Replace("xmlns=\"\""," ");
                    }
                    else
                    {
                        newline = ligne;
                    }
                    wm.WriteLine(newline);
                }
                rm.Close();
                wm.Close();
                string chemin = Environment.GetEnvironmentVariable("APPDATA");// 
                chemin = chemin + "\\Zamiren\\CimSyntaxGen\\Ressources\\"; //
                if (!selectedCCFiles.Contains(manifest)) selectedCCFiles.Add(manifest);
                string copyright =  chemin + "IECCopyright.xsd";
                if (!selectedCCFiles.Contains(copyright)) selectedCCFiles.Add(copyright);
                string manifeste= chemin + "IECManifest.xsd";
                if (!selectedCCFiles.Contains(manifeste)) selectedCCFiles.Add(manifeste);
            }
            catch (Exception ee)
            {
                throw new Exception(" " + ee.Message);
            }
        }
        void insertCopyright()
        {

            /******************preparation exemple  inclusion du copyright en cas de codecomponent *************
            if(XMLP.GetXmlValueConfig("CodeComponent")=="Checked")
            {
                < Copyright >
            < Notice >
            COPYRIGHT(c) IEC, 2016.This version of this NSD is part of IEC 61850 - 7 - 4:2007B; see the IEC 61850 -
                7 - 4:2007B for full legal notices.In case of any differences between the here - below code and the IEC published content, the
             here - below definition supersedes the IEC publication; it may contain updates. See history files.The whole document has to be taken
              into account to have a full description of this code component.
                See www.iec.ch / CCv1 for copyright details
             </ Notice >
            < License uri = "www.iec.ch/CCv1" kind = "Standard" > IEC License </ License >
             </ Copyright >
             }
             ***************************************************************/

            XmlDocument filedoc;
            foreach(string file in selectedCCFiles)
            {
                filedoc = new XmlDocument();  
                XmlNamespaceManager nsmgr = new XmlNamespaceManager(filedoc.NameTable);
                //tt filedoc.NameTable.Add("xs:annotation"); 
                string ext = Path.GetExtension(file);
                if (ext == ".XSD")
                {
                    nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema");
                    TextReader tfile = new StreamReader(file);
                    filedoc.Load(tfile);
                    tfile.Close();
                    XmlNode root = filedoc.DocumentElement;
                    /// XmlNode firstnode = root.FirstChild;bb
                    XmlNode annode = filedoc.CreateElement("xs:annotation", "http://www.w3.org/2001/XMLSchema");
                    // XmlNode annode = filedoc.CreateElement("xs:annotation");
                    //annode.Prefix = "xs";
                    XmlNode annod = root.InsertAfter(annode, root.FirstChild);
                    XmlNode docnode = filedoc.CreateElement("xs:documentation", "http://www.w3.org/2001/XMLSchema");
                    //docnode.Prefix = "xs";
                    XmlNode docnod = annode.AppendChild(docnode);
                    XmlElement copynode = filedoc.CreateElement("Copyright");
                    XmlNode copynod = docnod.AppendChild(copynode);
                    XmlNode noticenode = filedoc.CreateElement("Notice");

                    string notice = "COPYRIGHT(c) IEC,";
                    int ind = XMLP.GetXmlValueProfData("CCPublicationDate").IndexOf("20");
                    string date = XMLP.GetXmlValueProfData("CCPublicationDate").Substring(ind, 4);
                    string profilename = XMLP.GetXmlValueProfData("CCStandardNumber") + XMLP.GetXmlValueProfData("CCProfileName");
                    string type = "";
                    if (XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("XSD"))
                    {
                        type = "XSD";
                    }
                    else
                    {
                        if (XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("RDFS"))
                        {
                            type = "RDFS";
                        }
                    }
                    notice = notice + " " + date + "2016.This version of this" + " XSD" +  " is part of IEC" + " " + profilename;
                    notice = notice + "; \n\rsee the IEC " + profilename;
                    notice = notice + " for full legal notices.In case of any differences between the here - below code and the IEC published content,";
                    notice = notice + "the ";
                    notice = notice + "here - below definition supersedes the IEC publication; \n\rit may contain updates.";
                    notice = notice + "See history files (if it exists).\n\rThe whole document has to be taken into account to have a full description of this code component.\n\r";
                    notice = notice + "See www.iec.ch / CCv1 for copyright details\n\r";
                    noticenode.InnerText = notice;
                    XmlNode noticenod = copynode.AppendChild(noticenode);
                    XmlElement licelt = filedoc.CreateElement("License");

                    XmlAttribute atr = licelt.SetAttributeNode("uri", "");
                    atr.Value = " www.iec.ch/CCv1 ";
                    atr = licelt.SetAttributeNode("kind", "");
                    if (XMLP.GetXmlValueProfData("CCDiffusionState") == "IEC")
                    {
                        atr.Value = "Standard";
                    }
                    else
                    {
                        atr.Value = XMLP.GetXmlValueProfData("CCDiffusionState");
                    }
                    licelt.InnerText = "IEC License";
                    XmlNode licencenod = copynode.AppendChild(licelt);
                    string oldfile = file.Replace(".xsd", "-old.xsd");
                    if (File.Exists(oldfile)) File.Delete(oldfile);
                    File.Copy(file, oldfile);
                    TextWriter wfile = new StreamWriter(file);
                    filedoc.Save(wfile);
                    wfile.Close();
                }
                else
                {
                    if(ext==".rdf")
                    {
                       // throw new Exception(" not yet implemented");
                        nsmgr.AddNamespace("rdf", "http://www.w3.org/1999/02/22-rdf-syntax-ns#");
                        TextReader tfile = new StreamReader(file);
                        filedoc.Load(tfile);
                        tfile.Close();
                        throw new Exception(" not yet implemented");
                        XmlNode root = filedoc.DocumentElement;
                        /// XmlNode firstnode = root.FirstChild;bb
                        XmlElement annode = filedoc.CreateElement("comment", "http://www.w3.org/1999/02/22-rdf-syntax-ns#");
                        XmlAttribute atr = annode.SetAttributeNode("parseType", "http://www.w3.org/1999/02/22-rdf-syntax-ns#");
                        XmlNode annod = root.InsertAfter(annode, root.FirstChild);
                        XmlElement copynode = filedoc.CreateElement("Copyright");
                        XmlNode noticenode = filedoc.CreateElement("Notice");
                        string notice = "COPYRIGHT(c) IEC,";
                        int ind = XMLP.GetXmlValueProfData("CCPublicationDate").IndexOf("20");
                        string date = XMLP.GetXmlValueProfData("CCPublicationDate").Substring(ind, 4);
                        string profilename = XMLP.GetXmlValueProfData("CCStandardNumber") + XMLP.GetXmlValueProfData("CCProfileName");
                        string type = "";
                        if (XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("XSD"))
                        {
                            type = "XSD";
                        }
                        else
                        {
                            if (XMLP.GetXmlValueProfData("CCCodeComponentName").Contains("RDFS"))
                            {
                                type = "RDFS";
                            }
                        }
                        notice = notice + " " + date + "2016.This version of this" + " XSD" + " is part of IEC" + " " + profilename;
                        notice = notice + "; \n\rsee the IEC " + profilename;
                        notice = notice + " for full legal notices.In case of any differences between the here - below code and the IEC published content,";
                        notice = notice + "the ";
                        notice = notice + "here - below definition supersedes the IEC publication; \n\rit may contain updates.";
                        notice = notice + "See history files (if it exists).\n\rThe whole document has to be taken into account to have a full description of this code component.\n\r";
                        notice = notice + "See www.iec.ch / CCv1 for copyright details\n\r";
                        noticenode.InnerText = notice;
                        XmlNode noticenod = copynode.AppendChild(noticenode);
                        XmlElement licelt = filedoc.CreateElement("License");
                        atr.Value = " www.iec.ch/CCv1 ";
                        atr = licelt.SetAttributeNode("kind", "");
                        if (XMLP.GetXmlValueProfData("CCDiffusionState") == "IEC")
                        {
                            atr.Value = "Standard";
                        }
                        else
                        {
                            atr.Value = XMLP.GetXmlValueProfData("CCDiffusionState");
                        }
                        licelt.InnerText = "IEC License";
                        XmlNode licencenod = copynode.AppendChild(licelt);
                        string commenttext = copynode.OuterXml;
                        annod.InnerText = commenttext;
                        string oldfile = file.Replace(".rdf", "-old.rdf");
                        if (File.Exists(oldfile)) File.Delete(oldfile);
                        File.Copy(file, oldfile);
                        TextWriter wfile = new StreamWriter(file);
                        filedoc.Save(wfile);
                        wfile.Close();
                    }
                }
                

            }
        }

        private void BUTCancelSel_Click(object sender, EventArgs e)
        {
            selectedCCFiles = new List<string>();
            this.label11.Text = "";
            XMLP.SetXmlValueProfData("CCSelectedFiles", "");
        }

      
    }
    
}
