using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.XPath;
using System.Windows.Forms;
using System.IO;
using EA;
using CimSyntaxGen.HtmlGen;
using CimSyntaxGen.Option;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    class CodeLists
    {
        const string ETSOCODELITS = "etso-code-lists.xsd";  // le fichier memoire des code lists ETSO sans standard
        const string FICSTANDARD = "urn-entsoe-eu-wgedi-codelists.xsd";
        const string FICLOCAL = "urn-entsoe-eu-local-extension-types.xsd";
        const string REPERTOIRE="codelist";
        EA.Repository repo;
        EA.Package thepack;
        XmlDocument doc;
        XmlSchema schema;
         public TextWriter fluxdata;
        XmlNamespaceManager nsmgr;
        XMLParser XMLP = null;// new XMLParser();
       // public static XMLProfileParameters profparameters = new XMLProfileParameters();// operator's data
     public static string repertoire;
        string fichier;//"wgedi-codelists.xsd";
        string fichierext;
        string nomfichierlog="iereport.log";
        string nomfichier;
        string nomfichierext;
        string prefstd = "Standard"; // prefixe les noms de typelists standard
        string prefext = "Local"; //prefixe les noms de typelist fichier d'extension
        string pref; //prend la valeur Standard ou Extension
        XmlElement racine;
        Dictionary<string, EA.Element> dicElems = new Dictionary<string, EA.Element>(); // dictionnaire des elements selon leur nom
        public StreamWriter reportlog; // to report details of generation

        //Dictionary<string, Dictionary<string, string>> dicEvolt = new Dictionary<string, Dictionary<string, string>>();// ce dictionnare
                                                                                        // pour chaque TypeList
                                                                                         // un dictionaire pour chaque membre avec changement
          
                                                                               // avec comme indication Added| Modified description | Deleted
        manageIBO.CopyLibrary cl = new manageIBO.CopyLibrary();
        EA.Project project;
      public  CodeLists(EA.Repository repo,string sens)
        {
            try
            {
                XMLP = new XMLParser(repo);
                repertoire = XMLP.GetXmlValueProfData(DialCodelistExport.LAST_CODELISTS_DIRECTORY);
                //DateTime date=DateTime.Now;
                //repertoire=date.Year.ToString()  + "-"
                //    + date.Month.ToString() + "-"
                //    + date.Day.ToString()  + "-"
                //    + date.Hour.ToString() + "-"
                //    + date.Minute.ToString() + "-"
                //    +REPERTOIRE;
                // if (System.IO.Directory.Exists(repertoire)) System.IO.File.Delete(repertoire);
                // System.IO.Directory.CreateDirectory(".\\" + repertoire);


                // this.nomfichier = Path.GetDirectoryName(fichier) + "\\New" + Path.GetFileName(fichier);

                //fichierext = XMLP.GetXmlValueProfData("ExtensiontCodeListsFile"); //am 22/10/15
                //nomfichierext = Path.GetDirectoryName(fichierext) + "\\New" + Path.GetFileName(fichierext);
                //nomfichierext = repertoire +"\\" + Path.GetFileName(fichierext);
                this.repo = repo;
                this.thepack = repo.GetTreeSelectedPackage();

                // fichier=XMLP.GetXmlValueConfig("HarmonisationEnabled") == "Checked")
                // fluxdata =new StreamWriter(nomfichier);
                // fichier log
                //18 if (reportlog != null) reportlog.Close();
                //18if (System.IO.File.Exists( nomfichierlog)) System.IO.File.Delete(nomfichierlog);
                //18  reportlog = new StreamWriter( nomfichierlog, true); //  the report file
                //18  reportlog.AutoFlush = true;
                //reportlog = Main.reportlog;
                doc = new XmlDocument();
                if (sens == "import")
                {
                    fichier = XMLP.GetXmlValueProfData(DialCodelistImport.LAST_CODELISTS_FILENAME);   // am 22/10/15
                    if (!repertoire.EndsWith("\\")) repertoire += "\\";
                    string fullFilename = repertoire + fichier;
                    doc.Load(fullFilename);
                }
                nsmgr = new XmlNamespaceManager(doc.NameTable);
                nsmgr.AddNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
                nsmgr.AddNamespace("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
                nsmgr.AddNamespace("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
                nsmgr.AddNamespace("adms", "http://www.w3.org/ns/adms#"); // ABA20231011
                racine = doc.DocumentElement;

                buildDicElemens(thepack);
               
            }
            catch (Exception e)
            {
                ErrorCodes.ShowException(ErrorCodes.ERROR_059, e);
                //MessageBox.Show("impossible charger fichier codelists " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("impossible charger fichier codelists " + e.Message);
            }
            
        }
        /// <summary>
        /// importation du fichier de declaration des codelists
        /// pour chaque TypeList lors de l'import pour chacun des membres on rajoute une tagvalue d'evolution par rapport au cas precedent
        /// TypeEvolution = Added | Modification Description | Deleted (dans ce cas on rajoute le stereotype deprecrated
        /// </summary>
        public   void import()
        {
           
            try
            {

                 if (thepack.Elements.Count > 0) // le package est deja remplit 
                    {
                        // si la version du fichier est supérieure à celle du modèle on le remplace avec le contenu du fich
                        if (compareVersion(thepack, doc))
                        {
                            for (short i = 0; i < thepack.Elements.Count; i++)
                            {
                                thepack.Elements.DeleteAt(i, false);


                            }
                            thepack.Elements.Refresh();
                            thepack.Update();
                            dicElems = new Dictionary<string, EA.Element>();
                          
                        }
                        else
                        {
                            return; // la version est deja importee , rien a faire
                        }

                    }
                 

                // creation de la classe Version

                string vv=traitVersion();
                if (vv == null) return;
                // traitement des TypeLists
                XmlNodeList typelists = doc.SelectNodes("//xsd:simpleType",nsmgr);
                foreach (XmlNode typelist in typelists)
                {
                    XmlDocument typelistdoc = new XmlDocument();
                    typelistdoc.LoadXml(typelist.OuterXml);
                    XmlNodeList members = typelistdoc.SelectNodes("//xsd:enumeration", nsmgr);
                    if (members.Count==0) break;  // on ne cree pas de classe si le nom n'est pas precede par Standard
                    string suid = typelistdoc.SelectSingleNode("//Uid", nsmgr).InnerText;
                    string tlNotes = typelistdoc.SelectSingleNode("//xsd:annotation/xsd:documentation/Definition", nsmgr).InnerText;
                    System.Xml.XPath.XPathNavigator xnav = typelist.CreateNavigator();
                    string stdnom = xnav.GetAttribute("name", "");
                   
                    string nom = stdnom.Substring(8);
                    if (nom == "AllocationModeTypeList")
                    {
                        string prov = nom;
                    }
                    EA.Element newel = (EA.Element)thepack.Elements.AddNew(nom, "Class");
                    newel.Update();
                    thepack.Elements.Refresh();
                    newel.Stereotype = "enumeration";
                    string nn = xnav.SelectSingleNode("./xsd:annotation/xsd:documentation/Definition", nsmgr).Value;
                    if (!(nn == null)) newel.Notes = nn;
                    EA.TaggedValue uid = (EA.TaggedValue)newel.TaggedValues.AddNew("Uid", xnav.SelectSingleNode("./xsd:annotation/xsd:documentation/Uid", nsmgr).Value);
                    uid.Update();
                    newel.TaggedValues.Refresh();
                    newel.Update();

                    List < XmlNode> listmembers = new List<XmlNode>();

                    foreach (XmlNode member in members)
                    {
                        if (!listmembers.Contains(member)) listmembers.Add(member);
                    }

                    listmembers.Sort(CompareXmlNodebyName);
                    int ind = 0;
                    foreach (XmlNode member in listmembers)
                    {
                        traitmember(member, newel,ind);
                        ind++;
                    }
                   

                }
                    
                

                if (thepack.Diagrams.Count > 0)
                {
                    EA.Diagram diag = (EA.Diagram)thepack.Diagrams.GetAt(0);
                    DiagPopulate(repo, diag); //, new List<string>() { "Enumeration", "enumeration" });
                }
                else
                {
                    MessageBox.Show("ATTENTION there is no diagram in the package");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("ATTENTION there is no diagram in the package");
                }

            
            }
            catch(Exception e)
            {
                MessageBox.Show("Error pb in importing the codelists " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error pb in importing the codelists " + e.Message);
            }
            // reportlog.Flush();
            //18 reportlog.Close();
        }

        private void traitmember(XmlNode member,EA.Element elt,int position)
        {

            System.Xml.XPath.XPathNavigator xnav = member.CreateNavigator();
            string initvalue = xnav.GetAttribute("value", "");
            string title=member.SelectSingleNode("./xsd:annotation/xsd:documentation/CodeDescription/Title",nsmgr).InnerText;
            if (title == "Percent")
            {
                string prov = title;
            }
          
            EA.Attribute newat = (EA.Attribute)elt.Attributes.AddNew( title, "");
           
           // EA.Attribute newat = (EA.Attribute)elt.Attributes.AddNew(initvalue, "");
            elt.Attributes.Refresh();
            string notes = member.SelectSingleNode("./xsd:annotation/xsd:documentation/CodeDescription/Definition", nsmgr).InnerText;
            newat.Notes = notes;
            newat.Default = initvalue;
           // newat.Default = title;
            newat.Pos = position;
            newat.Stereotype = "enum";
            newat.Update();
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("Creation du membre " + title + "  code=" + initvalue + " pour enumeration " + elt.Name + "   position=" + newat.Pos.ToString());
        }



        public void 
            
            
            export()
        {
            // export du fichier codelist etso
            // nomfichier = Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen);

            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating CodeLists : ");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t export of file for codelists in " + ETSOCODELITS);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            schema = new XmlSchema { };
            schema.Namespaces.Add(XMLP.GetXmlValueProfData("PrefixCodelist"), ETSOCODELITS);// pointe sur ce schema
            //  schema.Namespaces.Add("ns1", profparameters.URICodelist);
            schema.Namespaces.Add("xsd", "http://www.w3.org/2001/XMLSchema");
            schema.Namespaces.Add("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
            schema.Namespaces.Add("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
            schema.Namespaces.Add("adms", "http://www.w3.org/ns/adms#"); // ABA20231011

            schema.TargetNamespace = ETSOCODELITS;
            schema.AttributeFormDefault = XmlSchemaForm.Unqualified;
            schema.ElementFormDefault = XmlSchemaForm.Qualified;

            // -------begining of the iterative traitment for the standard file
          
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            schema.Items.Add(ann);
            XmlSchemaDocumentation anndoc = new XmlSchemaDocumentation();
            ann.Items.Add(anndoc);
            XmlNode[] xmln = prodVersion();
            if (xmln != null) anndoc.Markup = xmln;
            foreach (EA.Element typelist in thepack.Elements)
            {
                if ((typelist.Name != "Version") && (((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")) || (typelist.Type=="Enumeration")))
                {
                    if(typelist.Name.Contains("CodingScheme"))
                    {
                        string prov = typelist.Name;
                    }
                    prodTypeList(typelist, schema,false);
                }
            }
          

            //---------------------------------------------------------------------------
            //  export du schema
            //--------------------------------------------------------------------------
            try
            {
                XmlSchemaSet schemaSet = new XmlSchemaSet();
                schemaSet.ValidationEventHandler += new ValidationEventHandler(ValidationCallbackOne);
                schemaSet.Add(schema);

                schemaSet.Compile();

                XmlSchema compiledSchema = null;

                foreach (XmlSchema schema1 in schemaSet.Schemas())
                {
                    compiledSchema = schema1;
                }





                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
                nsmgr.AddNamespace("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
                nsmgr.AddNamespace("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
                nsmgr.AddNamespace("adms", "http://www.w3.org/ns/adms#"); // ABA20231011
                nsmgr.AddNamespace(XMLP.GetXmlValueProfData("PrefixCodelist"), ETSOCODELITS);
                //  nsmgr.AddNamespace("ns1", XMLP.GetXmlValueProfData("URICodelist"));



                //  compiledSchema.Write(Console.Out, nsmgr);
                // StreamWriter fluxdata = new StreamWriter(nomfic);
                // fluxdata =new StreamWriter(nomfic);
                // true, System.Text.Encoding.UTF8, 512);

                // XmlWriter fluxdata = XmlWriter.Create(nomfic);
                repertoire = XMLP.GetXmlValueProfData(DialCodelistExport.LAST_CODELISTS_DIRECTORY);
                fluxdata = new StreamWriter(repertoire + "\\" + ETSOCODELITS);
                if (compiledSchema == null)
                {
                    MessageBox.Show("  Error , the compiled schema is empty ");
                }
                else
                {
                    try
                    {
                        compiledSchema.Write(fluxdata, nsmgr);
                    }
                    catch (Exception e)
                    {
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);

                    }

                }
                fluxdata.Flush();
                fluxdata.Close();

            }
            catch (XmlSchemaException e)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message \nl ", e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LinePosition = {0}", e.LinePosition);
                fluxdata.Flush();
                fluxdata.Close();
                // if (dialgenerxsd != null) dialgenerxsd.Close();
            }
            // reportlog.Flush();
            //reportlog.Close();
        }
        public void  exportstd()
        {
            // nomfichier = Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen);
            //nomfichier = repertoire + "\\" + Path.GetFileName(XMLP.GetXmlValueProfData("StandardCodeListsFile"));
            //nomfichierext = repertoire + "\\" + Path.GetFileName(XMLP.GetXmlValueProfData("ExtensiontCodeListsFile"));
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating CodeLists : ");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t export of file for codelists in " + Path.GetFileName(nomfichier));
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            schema = new XmlSchema { };
            schema.Namespaces.Add(XMLP.GetXmlValueProfData("PrefixCodelist"), XMLP.GetXmlValueProfData("URICodelist"));// pointe sur ce schema
          //  schema.Namespaces.Add("ns1", profparameters.URICodelist);
            schema.Namespaces.Add("xsd", "http://www.w3.org/2001/XMLSchema");
            schema.Namespaces.Add("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
            schema.Namespaces.Add("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
            schema.Namespaces.Add("adms", "http://www.w3.org/ns/adms#"); // ABA20231011

            schema.TargetNamespace = XMLP.GetXmlValueProfData("URICodelist");
            schema.AttributeFormDefault = XmlSchemaForm.Unqualified;
            schema.ElementFormDefault = XmlSchemaForm.Qualified;

            // -------begining of the iterative traitment for the standard file
            pref = prefstd; // il s'agit du fichier standard
            XmlSchemaInclude xinc = new XmlSchemaInclude(); // include le schema local
            schema.Includes.Add(xinc);
            xinc.SchemaLocation = XMLP.GetXmlValueProfData("CodeListLocalLocation");
          //  xinc.SchemaLocation = XMLP.GetXmlValueProfData("CodeListLocation");
           // xinc.SchemaLocation = "urn-entsoe-eu-local-extension-types.xsd";//Path.GetFileName(nomfichierext);
           // xinc.SchemaLocation = XMLP.GetXmlValueProfData("URISchemaLocation");
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            schema.Items.Add(ann);
            XmlSchemaDocumentation anndoc = new XmlSchemaDocumentation();
            ann.Items.Add(anndoc);
            XmlNode[] xmln=prodVersion();
            if (xmln != null) anndoc.Markup = xmln;
            foreach (EA.Element typelist in thepack.Elements)
            {
               // if ((typelist.Name != "Version") && ((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")))
                if ((typelist.Name != "Version") && (((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")) || (typelist.Type == "Enumeration")))
                {
                    prodTypeList(typelist, schema,true);
                }
            }
            foreach (EA.Element typelist in thepack.Elements)
            {
               // if ((typelist.Name != "Version") && ((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")))
                if ((typelist.Name != "Version") && (((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")) || (typelist.Type == "Enumeration")))
                {
                    prodUnionTypeList(typelist, schema);
                }
            }
            prodCodeScheme(schema);
           
            //---------------------------------------------------------------------------
            //  export du schema
            //--------------------------------------------------------------------------
            try
            {
                XmlSchemaSet schemaSet = new XmlSchemaSet();
                schemaSet.ValidationEventHandler += new ValidationEventHandler(ValidationCallbackOne);
                schemaSet.Add(schema);

                schemaSet.Compile();

                XmlSchema compiledSchema = null;

                foreach (XmlSchema schema1 in schemaSet.Schemas())
                {
                    compiledSchema = schema1;
                }




                
                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
                nsmgr.AddNamespace("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
                nsmgr.AddNamespace("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
                nsmgr.AddNamespace("adms", "http://www.w3.org/ns/adms#"); // ABA20231011

                nsmgr.AddNamespace(XMLP.GetXmlValueProfData("PrefixCodelist"), XMLP.GetXmlValueProfData("URICodelist"));
                //  nsmgr.AddNamespace("ns1", XMLP.GetXmlValueProfData("URICodelist"));



                //  compiledSchema.Write(Console.Out, nsmgr);
                // StreamWriter fluxdata = new StreamWriter(nomfic);
                // fluxdata =new StreamWriter(nomfic);
                // true, System.Text.Encoding.UTF8, 512);

                // XmlWriter fluxdata = XmlWriter.Create(nomfic);
                repertoire = XMLP.GetXmlValueProfData(DialCodelistExport.LAST_CODELISTS_DIRECTORY);
                fluxdata = new StreamWriter(repertoire + "\\" + FICSTANDARD);
                if (compiledSchema == null)
                {
                    MessageBox.Show("  Error , the compiled schema is empty ");
                }
                else
                {
                    try {
                        compiledSchema.Write(fluxdata, nsmgr);
                    }
                     catch (Exception e)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);
               
            }

                }
                fluxdata.Flush();
                fluxdata.Close();
                
            }
            catch (XmlSchemaException e)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message \nl ", e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LinePosition = {0}", e.LinePosition);
                fluxdata.Flush();
                fluxdata.Close();
                // if (dialgenerxsd != null) dialgenerxsd.Close();
            }
            // reportlog.Flush();
            //reportlog.Close();
        }

        private void prodCodeScheme(XmlSchema schema)
        {
            XmlSchemaSimpleType st = new XmlSchemaSimpleType();
            schema.Items.Add(st);
            st.Name = ("CodingSchemeType");
            XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
            XmlQualifiedName std = new XmlQualifiedName(prefstd + "CodingSchemeTypeList", XMLP.GetXmlValueProfData("URICodelist"));
            XmlQualifiedName ext = new XmlQualifiedName(prefext + "CodingSchemeType", XMLP.GetXmlValueProfData("URICodelist"));      
            XmlQualifiedName[] mt = { std, ext };
            union.MemberTypes = mt;
            st.Content = union;
        }

        private void prodUnionTypeList(Element typelist, XmlSchema schema)
        {

            XmlSchemaSimpleType st = new XmlSchemaSimpleType();
            schema.Items.Add(st);
            st.Name = (typelist.Name) ;
          XmlSchemaSimpleTypeUnion union= new XmlSchemaSimpleTypeUnion();
          XmlQualifiedName std = new XmlQualifiedName(prefstd + typelist.Name, XMLP.GetXmlValueProfData("URICodelist"));
          XmlQualifiedName ext = new XmlQualifiedName((prefext + typelist.Name).Replace("List", ""), XMLP.GetXmlValueProfData("URICodelist"));
          XmlQualifiedName[] mt = { std, ext };       
          union.MemberTypes = mt;
            st.Content =union;
        }

            public  void ValidationCallbackOne(object sender, ValidationEventArgs args)
        {
            try
            {
               // Console.WriteLine(args.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("validation of the schema while beeing created:  " + args.Message);
                //  MessageBox.Show(" Validation Schema: " + args.Message);
            }
            catch (Exception e)
            {
                MessageBox.Show("40- Error Validation Schema: " + e.Message, "Error");
                // ficlog.WriteLine("40- Error Validation Schema: " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t ---MessageFromSchemaValidator:  {0}", e.Message);
            }

        }
        void buildDicElemens(EA.Package pack)
        {
            foreach (EA.Element el in pack.Elements)
            {
                if ((el.Name != "") && (!dicElems.ContainsKey(el.Name))) dicElems.Add(el.Name, el);
                string name = el.Name;
                string type = el.Type;
                string sterotyp = el.Stereotype;
                string sterotyps = el.StereotypeEx;
               
            }
        }

        /// <summary>
        /// vrai si la version du fichier est plus grande que celle du modèle
        /// </summary>
        /// <param name="pack"></param>
        /// <param name="xdoc"></param>
        /// <returns></returns>
        bool compareVersion(EA.Package pack,XmlDocument xdoc)
        {
            bool result = false;

            // ABA20231011 string version = xdoc.SelectSingleNode("//Version",nsmgr).InnerText;
            // ABA20231011 string date = xdoc.SelectSingleNode("//ReleaseDate",nsmgr).InnerText;
            string version = xdoc.SelectSingleNode("//dcat:version", nsmgr).InnerText;
            string date = xdoc.SelectSingleNode("//dcterms:issued", nsmgr).InnerText;
            if ((version == null) && (date == null))
            {
                string texte="Pb the Version cannot be found in the imported codelist file";
                MessageBox.Show(texte);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return true; // on abandonne l'import
            }
            EA.Element elvers = dicElems["Version"];
            foreach(EA.Attribute at in elvers.Attributes)
            {
                String atversion = at.Default;
                int res=atversion.CompareTo(version);
                if ((at.Name == "dcat:version") && ( res < 0))
                {
                    result = true;
                    break;
                }
                if ((at.Name == "dcterms:issued") && (at.Default.CompareTo(date) < 0))
                {
                    result = true;
                    break;
                }
            }
            
            return result;
        }

/// <summary>
/// cree la cllasse Version
/// </summary>
        string traitVersion()
        {
            string vv;
            
            EA.Element racel = (EA.Element)thepack.Elements.AddNew("Version", "Class");
            racel.Update();// on sauvegarde l'element version
            thepack.Elements.Refresh();
            // ABA20231011 vv =  creVersionAttribute(racel, racine, "Version");
            vv = creVersionAttribute(racel, racine, "dcat:version");
            if (vv==null)
         {
             string texte = "Pb the Version cannot be found in the imported codelist file";
             MessageBox.Show(texte);
             // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
             thepack.Elements.DeleteAt(0, true);
             thepack.Elements.Refresh();
             return vv;
         }

            // ABA20231011 creVersionAttribute(racel, racine, "Titre");
            // ABA20231011 creVersionAttribute(racel, racine, "Title");
            // ABA20231011 creVersionAttribute(racel, racine, "Release");
            // ABA20231011 creVersionAttribute(racel, racine, "ReleaseDate");
            creVersionAttribute(racel, racine, "dcterms:title");
            //creVersionAttribute(racel, racine, "Release");
            creVersionAttribute(racel, racine, "dcterms:issued");
            creVersionAttribute(racel, racine, "adms:versionNotes");
            racel.Update();
            return vv;
        } 
          string  creVersionAttribute(EA.Element racel,XmlNode racine,string nom)
        {
              string res=null;
              try
              {
                  res = racine.SelectSingleNode("./xsd:annotation/xsd:documentation/" + nom, nsmgr).InnerText;
                  EA.Attribute newat = (EA.Attribute)racel.Attributes.AddNew(nom, "String");
                  newat.Default = res;
                  newat.Update();
                  racel.Attributes.Refresh();
              }catch(Exception)
              {
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine(" pb could not find an xsd;annotation at the schama root");
              }
              return res;
        }
        /// <summary>
        /// Populate the Diagram with all the elements of the package
        /// </summary>
        /// <param name="repo"></param>! 
        /// <param name="pack"></param>
        /// <param name="stereos"></param>
        void DiagPopulate(Repository repo, EA.Diagram diag) // ,List<string> stereos)
        {
            EA.Package pack = repo.GetPackageByID(diag.PackageID);
            diag.ShowPackageContents = true;
            diag.Update();
            repo.ReloadDiagram(diag.DiagramID);
            repo.OpenDiagram(diag.DiagramID);
            repo.ActivateDiagram(diag.DiagramID);
            EA.DiagramObject diagobj;
            int offset = 0;
            /* ABA20230905
            int left = 200;
            int right = 300;
            int top = 200;
            int bottom = 400;*/
            //string positions;
            foreach (EA.Element el in pack.Elements)
            {
                // MessageBox.Show("creation decimal l'element " + el.Name + " dans le diagrame " + diag.Name);

                bool ok = true;
                /*
                foreach (string s in stereos)
                {
                    if (el.StereotypeEx.Contains(s))
                    {
                        ok = false;
                        break;
                    }
                }
                 */
                if (ok)
                {
                    string position = "";
                   //  position = "l=" + (200 + offset).ToString() + "r=" + (300 + offset).ToString();
                   // position = position + "t=" + (200 + offset).ToString() + "b=" + (300 + offset).ToString();
                     position = "l=" + (200 + 0).ToString() + "r=" + (300 + offset).ToString();
                    position = position + "t=" + (200 + offset).ToString() + "b=" + (300 + offset).ToString();

                    diagobj = (EA.DiagramObject)diag.DiagramObjects.AddNew("l=200;r=300;t=200;b=300;", "");
                   // diagobj = (EA.DiagramObject)diag.DiagramObjects.AddNew(position,"");
                    offset = offset + 300;

                    diagobj.ElementID = el.ElementID;
                    diagobj.Update();
                    diag.DiagramObjects.Refresh();

                    string message = " positions par defaut du diagramme pour " + el.Name;
                    //MessageBox.Show(message + " l=" + diagobj.left + ",r=" + diagobj.right + ",t=" + diagobj.top + ",b=" + diagobj.bottom);


                }

            }
            // repo.ReloadDiagram(diag.DiagramID);
            // repo.OpenDiagram(diag.DiagramID);
            // repo.ActivateDiagram(diag.DiagramID);

            int style = ConstLayoutStyles.lsLayoutDirectionUp;
            int iterations = 4;
            int layerspacing = 20;
            int ColumnSpacing = 20;
            bool savetodiagram = true;

            //bool res=project.LayoutDiagramEx(diag.DiagramGUID, ConstLayoutStyles.lsDiagramDefault,4,20,20, savetodiagram);
            //bool res= project.LayoutDiagramEx(diag.DiagramGUID,ConstLayoutStyles.lsCycleRemoveDFS,4,20,20, savetodiagram);
            // bool res = project.LayoutDiagramEx(diag.DiagramGUID,ConstLayoutStyles.lsLayeringOptimalLinkLength ,4,20,20, savetodiagram);
            // project.LayoutDiagramEx(diag.DiagramGUID, ConstLayoutStyles.lsInitializeDFSOut, 4, 20, 20, savetodiagram);
            // bool res = project.LayoutDiagramEx(diag.DiagramGUID, style, iterations, layerspacing, ColumnSpacing, savetodiagram);
           // style = ConstLayoutStyles.lsInitializeDFSOut + ConstLayoutStyles.lsLayeringOptimalLinkLength + ConstLayoutStyles.lsCycleRemoveDFS + ConstLayoutStyles.lsLayoutDirectionUp;
            style = ConstLayoutStyles.lsInitializeNaive + ConstLayoutStyles.lsLayoutDirectionDown;
            project = repo.GetProjectInterface();
            bool res = project.LayoutDiagramEx(diag.DiagramGUID, style, iterations, layerspacing, ColumnSpacing, savetodiagram);
            res = diag.Update();
            string err = diag.GetLastError();
            //MessageBox.Show("apres layout " + res.ToString()+ "|" + err);
             repo.ReloadDiagram(diag.DiagramID);
             repo.OpenDiagram(diag.DiagramID);
             repo.ActivateDiagram(diag.DiagramID);
            repo.RefreshOpenDiagrams(false);


        }
        
        XmlNode[] prodVersion()
        {
            
            if(!dicElems.ContainsKey("Version"))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("ERROR  the package does not have a clas Version");
                return null;
            }
            EA.Element versionel = dicElems["Version"];

            XmlDocument doc = new XmlDocument();           
            XmlNode[] xmlnodes = new XmlNode[4];
            int index = 0;
            foreach (EA.Attribute at in versionel.Attributes)
            {
                xmlnodes[index] = doc.CreateNode(XmlNodeType.Element, at.Name, "");
                xmlnodes[index].InnerText = at.Default;
                index++;
            }
            return xmlnodes;
        }

        void prodTypeList(EA.Element typlist,XmlSchema schema,bool avecprefixe)
        {
            XmlDocument doc = new XmlDocument();
            XmlNode[] xmlnodes = new XmlNode[2];
            List<EA.Attribute> lat=new List<EA.Attribute>();
            XmlSchemaSimpleType sst = new XmlSchemaSimpleType();
            if (avecprefixe)
            {
                sst.Name = prefstd + typlist.Name; //ATTENTION on rajoute le prefixe Standard au nom de la typeList
            }
            else
            {
                if (!typlist.Name.Contains("CodingScheme")) // cas particulier foireux du CodingScheme
                {
                    sst.Name = typlist.Name;
                }
                else
                {
                    sst.Name = typlist.Name.Replace("List", "");
                }
            }
            XmlSchemaElement xel = new XmlSchemaElement();
            schema.Items.Add(sst);
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            sst.Annotation = ann;
            XmlSchemaDocumentation anndoc = new XmlSchemaDocumentation();
            ann.Items.Add(anndoc);
            xmlnodes[0] = doc.CreateNode(XmlNodeType.Element, "Uid", "");
           xmlnodes[0].InnerText= getTagValue(typlist, "Uid");
           xmlnodes[1] = doc.CreateNode(XmlNodeType.Element, "Definition", "");
           xmlnodes[1].InnerText = typlist.Notes;
           anndoc.Markup = xmlnodes;
           XmlSchemaSimpleTypeRestriction restrict = new XmlSchemaSimpleTypeRestriction();
           restrict.BaseTypeName = new XmlQualifiedName("NMTOKEN", "http://www.w3.org/2001/XMLSchema");
           sst.Content = restrict;
           foreach (EA.Attribute at in typlist.Attributes)
           {
               if (!lat.Contains(at)) lat.Add(at);
           }
           lat.Sort(CompareAttributebyDefault);
          // lat.Sort(CompareAttributebyName);
           foreach (EA.Attribute at in lat)
           {
               XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
               enumeration.Value = at.Default;
              // enumeration.Value = at.Name;
               restrict.Facets.Add(enumeration);
               XmlSchemaAnnotation restann = new XmlSchemaAnnotation();
               enumeration.Annotation = restann;
               XmlSchemaDocumentation restdoc = new XmlSchemaDocumentation();
               XmlNode[] xmln= prodCode( at);
                   restann.Items.Add(restdoc);
                   restdoc.Markup =prodCode( at);
               }

           }

private XmlNode[] prodCode(EA.Attribute at)
{
 	 XmlDocument doc = new XmlDocument();           
     XmlNode[] xmlnodes = new XmlNode[1];
           
                xmlnodes[0] = doc.CreateNode(XmlNodeType.Element, "CodeDescription", "");
                XmlNode eltitle=doc.CreateNode(XmlNodeType.Element, "Title", "");
                eltitle.InnerText=at.Name;
               // eltitle.InnerText = at.Default;
                XmlNode eldefinition=doc.CreateNode(XmlNodeType.Element, "Definition", "");
                eldefinition.InnerText=at.Notes;
                   xmlnodes[0].AppendChild(eltitle);
                  xmlnodes[0].AppendChild(eldefinition);
            return xmlnodes;
}

        

        public string getTagValue(Element typlist, string p)
        {
            string result = "";
            foreach (TaggedValue tag in typlist.TaggedValues)
            {
                if (tag.Name == "Uid")
                {
                    result = tag.Value;
                    break;
                }
            }
            return result;
        }
        public  XmlNode[] TextToNodeArray(string text)
        {
            XmlDocument doc = new XmlDocument();
            return new XmlNode[1] { doc.CreateTextNode(text) };
        }

        public static int CompareAttributebyName(EA.Attribute x, EA.Attribute y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    string xname = x.Name;
                    string yname = y.Name;

                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }

        public static int CompareAttributebyDefault(EA.Attribute x, EA.Attribute y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    string xname = x.Default;
                    string yname = y.Default;

                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }

        public  int  CompareXmlNodebyName (XmlNode x, XmlNode y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {

                    System.Xml.XPath.XPathNavigator xnav = x.CreateNavigator();
                    string initvalue = xnav.GetAttribute("value", "");
                   // string title = x.SelectSingleNode("./xsd:annotation/xsd:documentation/CodeDescription/Title", nsmgr).InnerText;
                   // string xname = title;
                    string xname = initvalue;
                      xnav = y.CreateNavigator();
                     initvalue = xnav.GetAttribute("value", "");
                   //  title = y.SelectSingleNode("./xsd:annotation/xsd:documentation/CodeDescription/Title", nsmgr).InnerText;                 
                   // string yname = title;
                     string yname = initvalue;
                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }

        public void exportext()
        {
            // fichier d'extensions locales
            //string prov = XMLP.GetXmlValueProfData("ExtensiontCodeListsFile");
           // nomfichierext = repertoire + "\\" + XMLP.GetXmlValueProfData("ExtensiontCodeListsFile");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating CodeLists : ");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t export of file extension for codelists in " + Path.GetFileName(nomfichierext));
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            schema = new XmlSchema { };
            schema.Namespaces.Add(XMLP.GetXmlValueProfData("PrefixCodelist"), XMLP.GetXmlValueProfData("URICodelist"));// pointe sur ce schema
            //  schema.Namespaces.Add("ns1", profparameters.URICodelist);
            schema.Namespaces.Add("xsd", "http://www.w3.org/2001/XMLSchema");
            schema.Namespaces.Add("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
            schema.Namespaces.Add("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
            schema.Namespaces.Add("adms", "http://www.w3.org/ns/adms#"); // ABA20231011

            //schema.TargetNamespace = XMLP.GetXmlValueProfData("URICodelist");
            schema.AttributeFormDefault = XmlSchemaForm.Unqualified;
            schema.ElementFormDefault = XmlSchemaForm.Qualified;

            // -------begining of the iterative traitment for the standard file

           
            foreach (EA.Element typelist in thepack.Elements)
            {
              //  if ((typelist.Name != "Version") && ((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")))
                if ((typelist.Name != "Version") && (((typelist.Stereotype == "enumeration") || (typelist.Stereotype == "Enumeration")) || (typelist.Type == "Enumeration")))
                {
                    prodExtTypeList(typelist, schema);
                }
            }
           
            

            //---------------------------------------------------------------------------
            //  export du schema
            //--------------------------------------------------------------------------
            try
            {
                XmlSchemaSet schemaSet = new XmlSchemaSet();
                schemaSet.ValidationEventHandler += new ValidationEventHandler(ValidationCallbackOne);
                schemaSet.Add(schema);

                schemaSet.Compile();

                XmlSchema compiledSchema = null;

                foreach (XmlSchema schema1 in schemaSet.Schemas())
                {
                    compiledSchema = schema1;
                }





                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
                nsmgr.AddNamespace("dcterms", "http://purl.org/dc/terms/#"); // ABA20231011
                nsmgr.AddNamespace("dcat", "http://www.w3.org/ns/dcat#"); // ABA20231011
                nsmgr.AddNamespace("adms", "http://www.w3.org/ns/adms#"); // ABA20231011

                nsmgr.AddNamespace(XMLP.GetXmlValueProfData("PrefixCodelist"), XMLP.GetXmlValueProfData("URICodelist"));

                //fluxdata = new StreamWriter(nomfichierext);
                repertoire = XMLP.GetXmlValueProfData(DialCodelistExport.LAST_CODELISTS_DIRECTORY);
                fluxdata = new StreamWriter(repertoire + "\\" + FICLOCAL);
                if (compiledSchema == null)
                {
                    MessageBox.Show("  Error , the compiled schema is empty ");
                }
                else
                {
                    try
                    {
                        compiledSchema.Write(fluxdata, nsmgr);
                    }
                    catch (Exception e)
                    {
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);

                    }

                }
                fluxdata.Flush();
                fluxdata.Close();

            }
            catch (XmlSchemaException e)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message \nl ", e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LinePosition = {0}", e.LinePosition);
                fluxdata.Flush();
                fluxdata.Close();
                // if (dialgenerxsd != null) dialgenerxsd.Close();
            }
           // reportlog.Flush();
           //18 reportlog.Close();
        }

        void prodExtTypeList(EA.Element typlist, XmlSchema schema)
        {
            XmlDocument doc = new XmlDocument();
            XmlNode[] xmlnodes = new XmlNode[2];
            List<EA.Attribute> lat = new List<EA.Attribute>();
            XmlSchemaSimpleType sst = new XmlSchemaSimpleType();
            sst.Name = ("Local" + typlist.Name).Replace("List", ""); ; 
            XmlSchemaElement xel = new XmlSchemaElement();
            schema.Items.Add(sst);         
            XmlSchemaSimpleTypeRestriction restrict = new XmlSchemaSimpleTypeRestriction();
            restrict.BaseTypeName = new XmlQualifiedName("NMTOKEN", "http://www.w3.org/2001/XMLSchema");
            sst.Content = restrict;
            if (typlist.Attributes.Count == 0) return;
            foreach (EA.Attribute at in typlist.Attributes)
            {
                if (!lat.Contains(at)) lat.Add(at);
            }
             lat.Sort(CompareAttributebyDefault);
           // lat.Sort(CompareAttributebyName);
            EA.Attribute premat = lat[0]; ;
            
                XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                enumeration.Value = premat.Default;
                // enumeration.Value = at.Name;
                restrict.Facets.Add(enumeration);
        }
      public  void toHtml()
        {
            HtmlEsmpCodeListDocumentation ht = new HtmlEsmpCodeListDocumentation(repo,repertoire);
            ht.prodDoc(repo);
        }
        //--------------------------------------------------------------------------------------
    }
}
