using System;
using System.Collections.Generic;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version :     3.8.12                                     *    march 2020* 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public sealed class ConstantDefinition
    {
        public string ReportGen = FileManager.GetParentDirPath() + "\\CimSyntaxGenReport.log";
        public string UNITKIND = "UnitSymbol";
        public string MULTIPLIERKIND = "UnitMultiplier";
        public string GetUNITKIND()
        {
            return UNITKIND;
        }
        public string GetMULTIPLIERKIND()
        {
            return MULTIPLIERKIND;
        }
        //----------  pour XSDTOProfile --------------------
        public short SOURCE = 0;
        public short TARGET = 1;
        public string VRAI = "1";
        public string FAUX = "0";
        public string ChoiceType = "_choicetype";
        public string GetChoiceType()
        {
            return ChoiceType;
        }
        public string[] facets = { "fractiondigits", "length", "maxexclusive", "maxinclusive", "maxlength", "minexclusive", "mininclusive", "minlength", "pattern", "totaldigits", "whitespace", "enumeration" };
        public string[] facetsocl = { "fractionDigits", "length", "maxExclusive", "maxInclusive", "maxLength", "minExclusive", "minInclusive", "minLength", "pattern", "totalDigits", "whitespace", "enumeration" };


        //-------------------------------------
        public const string EnumCodeTag = "CodeValue";
        public string GetEnumCodeTag()
        {
            return EnumCodeTag;
        }

        public const bool ImportCodeList = true;
        public bool GetImportCodeList()
        {
            return ImportCodeList;
        }
        public const string ImageExt = ".emf"; // can be .emf, bmp, .jpg, .gif, .png, .tga
        public string GetImageExt()
        {
            return ImageExt;
        }
        public const string SuffixESMEnvelop = "_E";
        public string GetSuffixESMEEnvelop()
        {
            return SuffixESMEnvelop;
        }
        public const string ESMBusinessTermTag = "EtsoBusinessTerm";
        public string GetESMBusinessTermTag()
        {
            return ESMBusinessTermTag;
        }
        public List<string> ListeFacets = new List<string> { "fractiondigits", "length", "maxexclusive", "maxinclusive", "maxlength", "minexclusive", "mininclusive", "minlength", "pattern", "totaldigits", "whitespace", "enumeration" };
        public List<string> GetListeFacets()
        {
            return ListeFacets;
        }

        public string[] CodingScheme = { "codingScheme", "CodingSchemeType" };// [0] name,[1] type

        public string[] GetCodingScheme()
        {
            return CodingScheme;
        }

        public const string EnumStereotype = "enumeration";
        public const string DatatypeStereotype = "CIMDatatype";
        public const string PrimitiveStereotype = "Primitive";
        public const string IsBasedOnStereotype = "IsBasedOn";
        public const string CompoundStereotype = "Compound";
        public const string AssemblyStereotype = "Assembly";
        public const string InlineStereotype = "Anonymous";
        public const string UnionStereotype = "Union";
        public const string CodeListStereotype = "CodeList";
        public const string ImportStereotype = "Importfrom";
        public const string IncludeStereotype = "Includefrom";



        public const string StringType = "String";
        public const string EnumType = "enumeration";
        public const string BooleanType = "Boolean";
        public const string IntegerType = "Integer";
        public const string FloatType = "Float";
        public const string DateTimeType = "DateTime";

        // --------- additional primitives  -------------------------
        private string DateType = "Date";
        private string TimeType = "Time";
        //---- additional list of primitives 
        private string AnyUriType = "AniURI";
        private string Base64BinaryType = "Base64Binary";
        private string ByteType = "Byte";
        private string HexBinaryType = "HexBinary";
        private string IDType = "ID";
        private string IDREFType = "IDREF";
        private string IntType = "Int";
        private string LongType = "Long";
        private string ShortType = "Short";
        private string UnsignedByteType = "UnsignedByte";
        private string UnsignedIntType = "UnsignedInt";
        private string UnsignedLongType = "UnsignedLong";
        private string UnsignedShortType = "UnsignedShort";

        public const bool AnnCategoryOption = true; // enable special annotations in xsds
        public static List<string> Cimstereos = new List<string>()
                                      {
                                        "Class",
                                        "Datatype",   // for ascending compatibility
			             	            "CIMDatatype", // take care of the consistency with above definitions
				                    	"enumeration",
                                        "Enumeration", //am juin 2018
	                                    "Compound",
                                       };
        public static List<string> CimDatatypeStereos = new List<string>()
                                         {
                                         "Datatype",
                                         "Enumeration", //am juin 2018
                                          DatatypeStereotype,
                                          CompoundStereotype,
                                          PrimitiveStereotype,
                                           EnumStereotype
                                           };



        public List<string> SubprofilesStereos = new List<string>()
                                    {
                                        "ShortCircuit",
                                        "Operation",
                                        "Entsoe",
                                        "Entsoe,ShortCircuit",
                                        "ACC",
                                        "ABIE",

                                    };
        //will need to add it as  a primitive type so that when you click on facet it give you the right window
        private string DecimalType = "Decimal";
        //
        private static bool CheckExpirationDate = true;


        public string[] EntityToCodes ={
        "&ndash;", "&#x2013;",
        "&ne;", "&#x2260;",
        "&infin;", "&#x221E;",
        "&minus;", "&#x2212;",
        "&le;", "&#x2264;",
        "&ge;", "&#x2265;",
        "&sect;", "&#xA7;",
        "&deg;", "&#xB0;",
        "&plusmn;", "&#xB1;",
        "&divide;", "&#xF7;",
        "&micro;", "&#xB5;",
        "&bull;", "&#x2022;",
        "&prime;", "&#x2032;",
        "&Prime;", "&#x2033;",
        "&frasl;", "&#x2044;",
        "&tilde;", "&#x2DC;",
        "&lsquo;", "&#x2018;",
        "&rsquo;", "&#x2019;",
        "&ldquo;", "&#x201C;",
        "&rdquo;", "&#x201D;",
        "&euro;", "&#x20AC;",
    };
        public Dictionary<string, string> EntityToString = new Dictionary<string, string>();

        public enum VariableType
        {
            Numeric,
            Defined,
            Any
        }

        public static ConstantDefinition Instance
        {
            get
            {
                return Nested.instance;
            }
        }

        class Nested
        {

            static Nested()
            {
            }
            internal static readonly ConstantDefinition instance = new ConstantDefinition();
        }


        public string GetRangTagValue()
        {
            return "ESMPRG";
        }

        public string GetDateTimeType()
        {
            return DateTimeType;
        }
        public string GetBooleanType()
        {
            return BooleanType;
        }
        public string GetIntegerType()
        {
            return IntegerType;
        }
        public string GetFloatType()
        {
            return FloatType;
        }

        // ---- additionnal access to types ----------------------
        public string GetDateType()
        {
            return DateType;
        }
        public string GetTimeType()
        {
            return TimeType;
        }

        public string GetAnyUriType()
        {
            return AnyUriType;
        }
        public string GetBase64BinaryType()
        {
            return Base64BinaryType;
        }
        public string GetByteType()
        {
            return ByteType;
        }
        public string GetHexBinaryType()
        {
            return HexBinaryType;
        }
        public string GetIDType()
        {
            return IDType;
        }
        public string GetIDREFType()
        {
            return IDREFType;
        }
        public string GetIntType()
        {
            return IntType;
        }
        public string GetLongType()
        {
            return LongType;
        }
        public string GetShortType()
        {
            return ShortType;
        }
        public string GetUnsignedByteType()
        {
            return UnsignedByteType;
        }
        public string GetUnsignedIntType()
        {
            return UnsignedIntType;
        }
        public string GetUnsignedLongType()
        {
            return UnsignedLongType;
        }
        public string GetUnsignedShortType()
        {
            return UnsignedShortType;
        }


        public string GetIBOTagValue()
        {
            return "GUIDBasedOn";
        }

        /// <summary>
        /// Return the date limit at witch the software must be desactivated.
        /// !!This will only be checked if CheckExpirationDate is = true!!
        /// </summary>
        /// <returns>date : 04 Nov 2009 23:59:59</returns>
        public DateTime GetExpirationDate()
        {
            DateTime date = DateTime.Parse("30 March 2099 23:59:59"); // ABA20230301, set to 2099
            return date;
        }

        /// <summary>
        /// Return the string to be shown in case of an expiration of the licence
        /// </summary>
        /// <returns></returns>
        public string GetExpirationWarning()
        {
            return "Your licence have expired." + " \r\n" + " \r\n" + "If it shouldn't have, please contact ENTSO-E.";
        }

        /// <summary>
        /// Return the format of an enumeration stereotype
        /// </summary>
        /// <returns></returns>
        public string GetEnumType()
        {
            return EnumType;
        }

        /// <summary>
        /// Return the format of a string type
        /// </summary>
        /// <returns></returns>
        public string GetStringType()
        {
            return StringType;
        }

        /// <summary>
        /// Return the format of the decimal stereotype
        /// </summary>
        /// <returns></returns>
        public string GetDecimalType()
        {
            return DecimalType;
        }

        /// <summary>
        /// Return the format of the enum stereotype
        /// </summary>
        /// <returns></returns>
        public string GetCodeListStereotype()
        {
            return CodeListStereotype;
        }
        /// <summary>
        /// Return the format of the enum stereotype
        /// </summary>
        /// <returns></returns>
        public string GetEnumStereotype()
        {
            return EnumStereotype;
        }
        /// <summary>
        /// Return the format of the Union Stereotype
        /// </summary>
        /// <returns></returns>
        public string GetUnionStereotype()
        {
            return UnionStereotype;
        }
        /// <summary>
        /// Return the format of the Compound  stereotype
        /// </summary>
        /// <returns></returns>
        public string GetCompoundStereotype()
        {
            return CompoundStereotype;
        }
        /// <summary>
        /// Return the format of the Assembly  stereotype
        /// </summary>
        /// <returns></returns>
        public string GetAssemblyStereotype()
        {
            return AssemblyStereotype;
        }

        /// <summary>
        /// Return the format of the Datatype stereotype
        /// </summary>
        /// <returns></returns>
        public string GetDatatypeStereotype()
        {
            return DatatypeStereotype;
        }
        /// <summary>
        /// Return the format of the IBO stereotype
        /// </summary>
        /// <returns></returns>
        public string GetIsBasedOnStereotype()
        {
            return IsBasedOnStereotype;
        }
        /// <summary>
        /// Return the format of the primitive stereotype
        /// </summary>
        /// <returns></returns>
        public string GetPrimitiveStereotype()
        {
            return PrimitiveStereotype;
        }
        public string GetInlineStereotype()
        {
            return InlineStereotype;
        }

        /////////////////////Code dependant constant
        /// <summary>
        /// Used as possible mode for EAClass
        /// </summary>
        /// <returns></returns>
        public string GetCreate()
        {
            return "CREATE";
        }
        /// <summary>
        /// Used as possible mode for EAClass
        /// </summary>
        /// <returns></returns>
        public string GetUpdate()
        {
            return "UPDATE";
        }

        /// <summary>
        /// Return the string representing the "no qualifier" case.
        /// </summary>
        /// <returns></returns>
        public string GetNoQualifier()
        {
            return "No qualifier";
        }
        /// <summary>
        /// Return the format used for any in the xmlconfig describing the different roles
        /// </summary>
        /// <returns></returns>
        public string GetAny()
        {
            return "any";
        }
        /// <summary>
        /// Return the format used for class in the xmlconfig describing the different roles
        /// </summary>
        /// <returns></returns>
        public string GetClass()
        {
            return "class";
        }


        public string GetDependency()
        {
            return "Dependency";
        }

        public string GetImportStereotype()
        {
            return ImportStereotype;
        }
        public string GetIncludeStereotype()
        {
            return IncludeStereotype;
        }

        /// <summary>
        /// Define if the expiration date must be checked.
        /// </summary>
        /// <returns></returns>
        public static bool GetExpirationCheckState()
        {
            return CheckExpirationDate;
        }
        public bool GetAnnCategoryOption()
        {
            return AnnCategoryOption;
        }
        public Dictionary<string, string> types2019=new Dictionary<string, string>();
        public ConstantDefinition()
        {
            types2019.Add("http://www.w3.org/2001/XMLSchema#iri", "http://www.w3.org/2001/XMLSchema#anyURI");
            types2019.Add("http://www.w3.org/2001/XMLSchema#stringfixedlanguage", "http://www.w3.org/2001/XMLSchema#string");
            types2019.Add("http://www.w3.org/2001/XMLSchema#url", "http://www.w3.org/2001/XMLSchema#anyURI");
            types2019.Add("http://www.w3.org/2001/XMLSchema#stringiri", "http://www.w3.org/2001/XMLSchema#anyURI");
            EntityToString.Add("&amp;", "&");
            EntityToString.Add("&#x0026;", "&");
            EntityToString.Add("&ndash;","_");
            EntityToString.Add("&#x2013;", "_");
            EntityToString.Add("&ne;", "!=");
            EntityToString.Add("&#x2260;", "!=");
            EntityToString.Add("&#x221E;", "infinity");
            EntityToString.Add("&minus;", "-");
            EntityToString.Add("&#x2212;", "-");
            EntityToString.Add("&le;", "<");
            EntityToString.Add("&#x2264;", "<");
            EntityToString.Add("&ge;", ">");
            EntityToString.Add("&#x2265;", ">");
            EntityToString.Add("&sect;", "");
            EntityToString.Add("&#xA7;", "");
            EntityToString.Add("&deg;", "C");
            EntityToString.Add("&#xB0;", "C");
            EntityToString.Add("&plusmn;", "+mn");
            EntityToString.Add("&#xB1;", "+mn");
            EntityToString.Add("&divide;", "/");
            EntityToString.Add("&#xF7;", "/");
            EntityToString.Add("&micro;", "");
            EntityToString.Add("&#xB5;", "" );
            EntityToString.Add("&bull;", "."); //bullet
            EntityToString.Add("&#x2022;", ".");
            EntityToString.Add("&prime;", "'");
            EntityToString.Add("&#x2032;", "'");
            EntityToString.Add("&Prime;", "\"");
            EntityToString.Add("&#x2033;", "\"");
            EntityToString.Add("&frasl;", "/");
            EntityToString.Add("&#x2044;", "/");
            EntityToString.Add("&tilde;", "~");
            EntityToString.Add("&#x2DC;", "~");
            EntityToString.Add("&lsquo;", "`");
            EntityToString.Add("&#x2018;", "`");
            EntityToString.Add("&rsquo;", "'");
            EntityToString.Add("&#x2019;", "'");
            EntityToString.Add("&ldquo;", "\"");
            EntityToString.Add("&#x201C;", "\"");
            EntityToString.Add("&rdquo;", "\"");
            EntityToString.Add("&#x201D;", "\"");
            EntityToString.Add("&euro;", "");
            EntityToString.Add("&#x20AC;", "");
        }

        //----------------------------------------------------------------------
    }
}
