using System;
using System.IO;
using System.Collections.Generic;
using System.Collections;
//using System.Linq;
using System.Text;
//using CimExportImport.manageIBO;
using System.Windows.Forms;



/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.113                                        *   april 2022 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    ///  // create a profile from a profiles directory
    // we  try and select CIM packages to which we will be dependant and then 
    //  create a profilepackage under the clicked package
    /// </summary>
    class CreateProfile
    {
        
       
       
       // static string repofile = "";
        static public EA.Repository repository;
        string profname = ""; // the chosen name of the profile
        List<string> selectedpackages = null;  // packge names
        static ConstantDefinition constantes = new ConstantDefinition();
        static public bool Errorspresent = false;
        string texte = "";
        static public long profilepackid = 0;
        static EA.Package atop = null; // le model top
        public EA.Package profpack;
        static ConstantDefinition CD = new ConstantDefinition();
      
        
        public  CreateProfile(EA.Repository repo,EA.Package pack)
        {
            XMLParser xmlp = new XMLParser(repo);
           
            try
            {
            string packnames=xmlp.GetXmlValueConfig("SelectedCanonicalPackagesForXsdToProf" );
             List<string>packnamelist= new List<string>();
                if(packnames != "" )
                {
                    packnamelist=new List<string>(packnames.Split(','));
                }
            profname = "newprofile"; // on impose dans un premier temps le nom du profil
            atop = RDFutilitaires.GetModelPackage(pack, repo);  // we suppose that the container of the profiles is at the same level of the major CIM Packages
            repository = repo;
            repo.RefreshModelView(0);
            ConstantDefinition constantes = new ConstantDefinition();
            //DialSPackages dialog = new DialSPackages();
            // Sets up the initial objects in the CheckedListBox.
            //string[] packagesname = new string[100];// a priori 
            
            Dictionary<string, EA.Package> packages = new Dictionary<string, EA.Package>();
     
            List<EA.Package> Listpackages = new List<EA.Package>();
            //RDFutilitaires.getAllPackages(atop, Listpackages);
            foreach(EA.Package  pa in atop.Packages)
            {
                 foreach(EA.Package piec in pa.Packages)
                 {
                         if(packnamelist.Contains(piec.Name))
                         {
                             packages.Add(piec.Name, piec);
                         }
                 }
             }

            EA.Project project = repo.GetProjectInterface();// we get project interface
            
           
                /************** creation package *****************/
                profpack = (EA.Package)pack.Packages.AddNew(profname, "Package");
                profpack.Update();
                string prov = profpack.Name;
                pack.Packages.Refresh();
               
                
               
                foreach (string paname in packages.Keys)
                {
                    EA.Connector con = (EA.Connector)profpack.Element.Connectors.AddNew("", "Dependency");
                    con.ClientID = profpack.Element.ElementID;
                    con.SupplierID = packages[paname].Element.ElementID;
                    con.Stereotype = CD.GetIsBasedOnStereotype();
                    con.Update();
                    profpack.Element.Connectors.Refresh();
                }
                EA.Diagram profdiag = (EA.Diagram)profpack.Diagrams.AddNew(profname, "Class");
                profdiag.Update();
                profpack.Diagrams.Refresh();
            }
            catch (Exception e)
            {
                string texte = "Error in creating the profile " + profname + e.Message;
                MessageBox.Show(texte);
               // ManageIBOUtilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                CreateProfile.Errorspresent = true;
            }
        }

        //-----------------------------------------------------------------------    }
       
    }
}