﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public partial class DialFile : Form
    {
        XMLParser XMLP;
       string packnames;
       List<string> packnamelist = new List<string>();

        public DialFile(EA.Repository repo)
        {
            
            InitializeComponent();
            XMLP = new XMLParser(repo);
            if (XMLP.GetXmlValueConfig("NavigationEnabled")=="Checked")
            {
                this.CBNavigable.CheckState = CheckState.Checked;
            }
            else
            {
                this.CBNavigable.CheckState = CheckState.Unchecked;
            }

            packnames = XMLP.GetXmlValueConfig("SelectedCanonicalPackagesForXsdToProf");
            if(packnames==null)
            {
                //MessageBox.Show("ERROR   no access to config parameter SelectedCanonicalPackagesForXsdToProf");
                throw new Exception(" no access to SelectedCanonicalPackagesForXsdToProf");
            }
            
            if(packnames != "")
            {
               packnamelist = new List<string>(packnames.Split(','));
            }
          
                if(packnamelist.Contains("IEC61970"))
                {
                    this.CB61970.CheckState = CheckState.Checked;
                }
                else
                {
                    this.CB61970.CheckState = CheckState.Unchecked;
                }
                 if(packnamelist.Contains("IEC61968"))
                {
                    this.CB61968.CheckState = CheckState.Checked;
                }
                else
                {
                    this.CB61968.CheckState = CheckState.Unchecked;
                }
                     if(packnamelist.Contains("IEC62325"))
                {
                    this.CB62325.CheckState = CheckState.Checked;
                }
                else
                {
                    this.CB62325.CheckState = CheckState.Unchecked;
                }
            
        }
            
        

        private void button1_click(object sender, EventArgs e)
        {
            if(openFileDialog1.ShowDialog() == DialogResult.OK)
    {
        try
        {
            GenerprofilesFromXSD.fichier = openFileDialog1.FileName;
            this.textBox1.Text = openFileDialog1.FileName;
           //MessageBox.Show("fichier selectionne=\n\r" + openFileDialog1.FileName);
        }
        catch (Exception ex)
        {
            MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
        }
    }
     }

        

        private void DialFile_Load(object sender, EventArgs e)
        {

        }

        private void textbox1_enter(object sender, EventArgs e)
        {
            if (this.textBox1.Text != "")
            {
                GenerprofilesFromXSD.fichier = this.textBox1.Text;
                MessageBox.Show("fichier selectionne=\n\r" + this.textBox1.Text);
            }

        }

        private void button2_click(object sender, EventArgs e)
        {
            if (this.CBNavigable.CheckState == CheckState.Checked)
            {
                XMLP.SetXmlValueConfig("NavigationEnabled", "Checked");
            }
            else
            {
                XMLP.SetXmlValueConfig("NavigationEnabled", "Unchecked");
            }

            if (this.CB61970.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC61970")) { packnamelist.Add("IEC61970"); };
            }
            else
            {
                if (packnamelist.Contains("IEC61970"))
                {
                    int ind = packnamelist.IndexOf("IEC61970");
                    packnamelist.RemoveAt(ind);
                };
            }

            if (this.CB61968.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC61968")) { packnamelist.Add("IEC61968"); };
            }
            else
            {

                if (packnamelist.Contains("IEC61968"))
                {
                    int ind = packnamelist.IndexOf("IEC61968");
                    packnamelist.RemoveAt(ind);
                };
            }

            if (this.CB62325.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC62325")) { packnamelist.Add("IEC62325"); };
            }
            else
            {
                if (packnamelist.Contains("IEC62325"))
                {
                    int ind = packnamelist.IndexOf("IEC62325");
                    packnamelist.RemoveAt(ind);
                };
            }

            packnames = "";
               foreach(string packname in packnamelist)
               {
           if(packname != "") packnames=packnames+ "," + packname;
               }
               packnames = packnames.Trim(',');
               XMLP.SetXmlValueConfig("SelectedCanonicalPackagesForXsdToProf", packnames);
            this.Close();
        }

        private void CBNavigable_changed(object sender, EventArgs e)
        {
            if(this.CBNavigable.CheckState== CheckState.Checked)
            {
                XMLP.SetXmlValueConfig("NavigationEnabled", "Checked");
            }
            else
            {
                XMLP.SetXmlValueConfig("NavigationEnabled", "Unchecked");
            }
        }
        private void CB61970_changed(object sender, EventArgs e)
        {
            /*
            if (this.CB61970.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC61970")) { packnamelist.Add("IEC61970"); };
            }
            else
            {
                if (packnamelist.Contains("IEC61970")) {
                    int ind = packnamelist.IndexOf("IEC61970");
                    packnamelist.RemoveAt(ind); };
            }
             * */
        }
        private void CB61968_changed(object sender, EventArgs e)
        {
            /*
            if (this.CB61968.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC61968")) { packnamelist.Add("IEC61968"); };
            }
            else
            {
               
                if (packnamelist.Contains("IEC61968")) {
                    int ind = packnamelist.IndexOf("IEC61968");
                    packnamelist.RemoveAt(ind); };
            }
             * */
        }
        private void CB62325_changed(object sender, EventArgs e)
        {
            /*
            if (this.CB62325.CheckState == CheckState.Checked)
            {
                if (!packnamelist.Contains("IEC62325")) { packnamelist.Add("IEC62325"); };
            }
            else
            {
                if (packnamelist.Contains("IEC62325")) {
                    int ind = packnamelist.IndexOf("IEC62325");
                    packnamelist.RemoveAt(ind); };
            }
             * */
        }

        private void CB61970_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}
