﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
//using CimExportImport.manageIBO;
using CimSyntaxGen;
using CimSyntaxGen.manageIBO;
using System.Xml;
using EA;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    /// generation de profiles a partir du fichier XSD 
    /// on suppose que ces fichiers suivent les regles de NDR 
    /// sauf exception trairee par le wg14
    ///
    /// </summary>
    class GenerprofilesFromXSD
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="repo"></param>      repository EA
        /// <param name="Package"></param>  package racine des profiles
        /// <param name="directorypath"></param>  repertoire des fichiers xsd
        /// 
        /****  analyse preformance ********************/
        bool withtimeanalysis = false;
        string repertoire=".";
        TextWriter reportlogtime;
        string conguid = ""; // guid  d'un lien pour test
        static DateTime starttime=new DateTime(0);
        static DateTime endtime=new DateTime(0);
        static TimeSpan cumultime=new TimeSpan(0);
        /*******************************/

        public static string fichier = FileManager.GetUserDirPath() + "\\essai.xsd";
        static Dictionary<string, MyList<EA.Element>> dicElemByName;  //  name;ArrayList fo elements
        static Dictionary<string, EA.Element> dicProfElemByName; // les elements du profile a creer
        static Dictionary<string, EA.Element> dicCIMElemByName; // tous les elements de CIMM qui peuvent être parent 
        static Dictionary<string, EA.Element> dicCIMElemByGUID; // tous les elements de CIMM qui peuvent être parent
        static Dictionary<long,EA.Element> dicCIMElemByID;
        static Dictionary<string, long> profidentifiers; // name/elemid  donne l'identifier de type par son nom
        static Dictionary<long,List<EA.Element>> dicancestorsbyelid=new Dictionary<long,List<EA.Element>>();
        static  Dictionary<long, List<long>> dicancestoridsbyelid = new Dictionary<long, List<long>>();
        static List<EA.Element> listelem=null;
        static string repofile = "";
        static EA.Project project;
        public static string datePatt = @"M/d/yyyy hh:mm:ss tt";
        EA.Repository Repo;
        static public ConstantDefinition CD = new ConstantDefinition();
        static string EnvelopName = "";
        static EA.Package profilespack = null; // le package du profil
        static List<string> rootslist = new List<string>();
        static StreamWriter reportlog=null;
        string aPackageGuid; // the package to gobally copy
        static ConstantDefinition constantes = null;
        static public Dictionary<string, string> mapprimitives = new Dictionary<string, string>();
        static public XMLParser XMLP;
        public class MyList<T> : List<T>
        {
            T retour;
            public  MyList  ( ){
                 new List<T>();
               }
           public  T First(){
     
                foreach(T t in this){
                    retour = t;
                    break;
                }
                return retour;
            }
            }
        int _anonymqualif = 0;
        public string anonymqualif
        {
            get
            {
                _anonymqualif++;
                return ("a" + _anonymqualif.ToString());
            }
            set
            {
                string v = value;
                _anonymqualif = Convert.ToInt32(v);
            }
        }
       public Dictionary<string,string> xmltocim = new Dictionary<string,string>();
        
        List<EA.Package> ProfileIBOPackages; // liste of all the packages of the profile
        List<long> ProfileIBOPackagesID; // liste of all the parent packages of the profile
        MyList<EA.Element> malist   = new MyList<EA.Element>();
        Dictionary<string, long> dicParentSonID; // parentguid/profileid
        Dictionary<long, EA.Package> dicPackPack;  // packid/package   parent/fils
        List<long> Conids;    //list of package connectors
      
       // List<long> ElemsInProfile; // list of all the elements of the package
       // List<EA.Package> ParentPackages; // list of all base packages 
       // List<EA.Element> ParentElements; // list of all base elements
        Dictionary<string, DocElement> DicDocEltFromXSDlByName;
        static List<long> Elementdejatraite;
        
        //EA.Package profilespack = null; // where we are going to inser the new profile
        
        List<EA.Package> allpackages = new List<EA.Package>();

        Affiche affiche = new Affiche();// am fev 2013
        


        //-----   differentes classes   -----
      public  class DocElement
        {
            public string type; // type classe, datatype, compound,enumeration
            public bool abstrait = false;
            public bool anonymous=false; // cas où l'element est declare dans l'element xsd
            public string name;
	    public string simpletype; // le type primitif d'un type simple
            public string package = "";
            public string comment = "";
            public List<string> notes; // notes sur les elements (EAElements anonymes)

            public List<DocMember> members;
            public List<DocChoiceElement> choicemembers;
           // public Dictionary<string,string> facets; // les restrictions appliquees en cas de typesimple (nomfacet/valeur)
           // public List<string> attributs; //members qui sont des liens
            public List<string> ParentClasses;  // les clasesGuid dont cet element hérite
            public string[]sawsdl={"",""};
            public DocElement()
            {
                notes = new List<string>();
                members = new List<DocMember>();
                choicemembers=new List<DocChoiceElement>();
              
                ParentClasses = new List<string>();
            }
            public DocMember IsMember(string ss)
            {
                //teste si ss est un nom  des membres natifs
                DocMember ret = null;
                foreach (DocMember dmemb in members)
                {
                    // MessageBox.Show("test ss=|" + ss + "| ; dmemb.name |" + dmemb.name.Trim() + "| "  + (ss==dmemb.name.Trim()).ToString());
                    if (ss.Equals(dmemb.name.Trim()))
                    {
                        ret = dmemb;
                        //  break;
                    }
                }
                return ret;
            }
            /*
            public string LowerBound()
            {
                string ret = "1";
                if (cardinality != "")
                {
                    if (cardinality.Contains(".."))
                    {
                        int ind = cardinality.IndexOf("..");
                        ret = cardinality.Substring(0, ind);
                    }
                }
                return ret;
            }
            public string UpperBound()
            {
                string ret = "1";
                if (cardinality != "")
                {
                    if (cardinality.Contains(".."))
                    {
                        int ind = cardinality.IndexOf("..");
                        ret = cardinality.Substring(ind + 2);
                    }
                }
                return ret;
            }
             * */
        }
        public class DocMember
        {
            public string name;
          public  string[] _type={"",""}; // dans le cas du choice type[0]="_choicetype" et type[1]=vrai si ref (ou faux)
                                          // dans le cas d'un membre qui pointe tyoe[1]="ref";
                                          // dans le cas d'un membre herite _type[1]="inherit"
                                          //                et _type[0]=nom de la class d'heritage
            public string upperbound;
            public string lowerbound;
            public string comment;
             public string[] sawsdl={"",""}; 
        public Dictionary<string,string>  facets= null;  //nom/valeur
            public DocMember()
            {
		facets=new Dictionary<string,string>();  //nom/valeur
                name = ""; comment = "";
               sawsdl[0]=sawsdl[1]="";
          
            }
            
               public string type {
                     get{
                        return _type[1];
                       }
                     set{
                       if(value.Contains(":")){
                       string[] split=value.Split(':');
			_type[0]=split[0];
			_type[1]=split[1];                      
                          }else{
			_type[0]="";
                        _type[1]=value;
                           }
                       }
			}
                       }

      
        public class DocChoiceElement
        {
             public string name;
           public  List<DocMember> elements;
            public string upperbound;
            public string lowerbound;
            public string comment;

             public string[] sawsdl={"",""};
            public DocChoiceElement()
            {
                elements = new List<DocMember>();
                name = ""; comment = "";
               sawsdl[0]=sawsdl[1]="";
               upperbound = lowerbound = "0";

            }
        }


        //-----------------------------------
        //-----------------------
        /// <summary>
        /// traitement de chacun des contenus des div
        /// chaque div peut être 
        /// soit une classe contrete
        /// soit une classe abstraite
        /// soit un datattype
        /// soit une enumeration
        /// soit un compound
        /// on cree un element structure 
        /// </summary>
        /// <param name="dansdiv"></param>
        DocElement traitdiv(string dansdiv,string type)  // traitement d'un complextype ou d'un simpletype
        {
            string texte = "";
            DocElement elt = new DocElement();
            XmlTextReader reader = new XmlTextReader(new StringReader(dansdiv));
            reader.MoveToContent();
            elt.name=reader.Name;
            elt.type = type;
           
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           
            if (reader.HasAttributes)
            {

                while (reader.MoveToNextAttribute())
                {
                    switch (reader.Name)
                    {
                        case "name":
                            elt.name = reader.Value;
                            /* ABA20230905
                            if (elt.name.Contains( "PSRMap"))
                            {
                                string tt = "";
                            }*/
            //texte = " Traitement d'un div  name=" + elt.name + " ,  type=" + elt.type;
                            break;
                        case "sawsdl:modelReference":
                            elt.sawsdl = RDFutilitaires.GetCleanSwsdl(reader.Value);
                            break;
                        default:
                            break;
                    }
                }
            }
            // Move the reader back to the element node.
           
            reader.MoveToElement();
            string eltname="";
            switch (type)
            {
                case "complexType":
                    do
                    {
                    eltname=reader.Name;
                    
                    switch(eltname)
                    {
                        case "xs:annotation":
                            string anncontent = reader.ReadOuterXml();
                            XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
                            if (readann.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
                            {
                                elt.notes.Add(readann.ReadElementString());

                                while (readann.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
                                {
                                    elt.notes.Add(readann.ReadElementString());
                                }
                            }
                             //trEltAnnotation(reader, elt);
                            break;
                        
                        case "xs:sequence":
                            if (reader.IsStartElement())
                            {
                                try
                                {
                                    if (!reader.IsEmptyElement) trEltSequence(reader, elt);
                                }
                                catch (XmlException e)
                                {
                                    Main.erreurs = Main.erreurs + 1;
                                    texte="Error trEltSequence " + e.Message + " at line" + e.LineNumber.ToString();
                                    //MessageBox.Show(texte);
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }
                            }
                            break;
                        case "xs:simpleContent":

                            break;
                        case "xs:complexContent":
                            if (reader.IsStartElement())
                            {
                                try
                                {
                                    if (!reader.IsEmptyElement) trEltComplexContent(reader, elt);
                                }
                                catch (XmlException e)
                                {
                                    Main.erreurs = Main.erreurs + 1;
                                    texte = "Error trEltComplexContent" + e.Message + " at line" + e.LineNumber.ToString();
                                    //MessageBox.Show(texte);
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }
                            }
                            break;
                        default:
                            break;
                    }
                        reader.Read();
                    }while((reader.NodeType != XmlNodeType.EndElement) || (reader.Name != "xs:complexType"));
                    break;
                    
                case "simpleType":
                    do
                    {
                    eltname=reader.Name;
                    switch(eltname)
                    {
                        case "xs:annotation":
                            string anncontent = reader.ReadOuterXml();
                            XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
                            if (readann.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
                            {
                                elt.notes.Add(readann.ReadElementString());

                                while (readann.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
                                {
                                    elt.notes.Add(readann.ReadElementString());
                                }
                            }
                           
                            //trEltAnnotation(reader, elt);
                            break;
                        case "xs:restriction":
                            trEltRestriction(reader, elt);
                           
                            if ((reader.NodeType == XmlNodeType.EndElement) && (reader.Name == "xs:simpleType"))
                            {
                              if ((elt.type != "") && !DicDocEltFromXSDlByName.ContainsKey(elt.name)) DicDocEltFromXSDlByName.Add(elt.name, elt);
                                return elt;
                            }
                            
                            break;                      
                        default:
                            break;
                    }
                        reader.Read();
                    }while((reader.NodeType != XmlNodeType.EndElement) || ( reader.Name != "xs:simpleType"));
                    break;
                default :
                    break;

            }
        
           if (elt.type == "enveloppe") return elt;
            if ((elt.type != "") && !DicDocEltFromXSDlByName.ContainsKey(elt.name)) DicDocEltFromXSDlByName.Add(elt.name, elt);
            return elt;
        }
        //----------------




        public GenerprofilesFromXSD(EA.Repository repos, string directorypath)
        {
            XMLP = new XMLParser(repos);
            //reportlogtime= new StreamWriter(repertoire + "XsdTpProfTime.log");
            Main.erreurs=0; // compteur des erreurs à zero
             DicDocEltFromXSDlByName=new Dictionary<string, DocElement>();
            //EA.Package package = repos.GetTreeSelectedPackage();
            EA.Package profiles= repos.GetTreeSelectedPackage();
            string dpath = directorypath;
            string texte = ""; // for tests
            CreateProfile profil=new CreateProfile(repos,profiles);
            EA.Package package = profil.profpack; // package;// le package du profil (pouvant contenir d'autres packages)
            profilespack = package;
          //18  string  filepath = System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString);
           //16  reportlog = new StreamWriter(filepath + "\\GenerprofilesFromXSD.log"); //  the report  filePath
            reportlog = Main.reportlog;
            ManageIBOUtilitaires.reportlog = reportlog;
        // MessageBox.Show("reporting log in: " + filepath + "\\GenerprofilesFromXSD.log");
           //18  RDFutilitaires.reportlog = (StreamWriter)reportlog;
            RDFutilitaires.reportlog = reportlog;
            Repo = repos;
            repofile = Repo.ConnectionString;
            ManageIBOUtilitaires.repo = Repo;
            Repo.RefreshModelView(0);
            aPackageGuid = profilespack.PackageGUID;
            
            constantes = new ConstantDefinition();
            Elementdejatraite = new List<long>();
            dicParentSonID = new Dictionary<string, long>(); // elguid/elid
            dicPackPack = new Dictionary<long, EA.Package>(); //packid/pack
            ProfileIBOPackages = new List<EA.Package>();
            ProfileIBOPackagesID = new List<long>();
            Conids = new List<long>();
             CD = new ConstantDefinition();


            EA.Package toppack = RDFutilitaires.GetModelPackage(package, Repo);
            RDFutilitaires.getAllPackages(toppack, allpackages);
            /* //18
            foreach(EA.Package pa in allpackages){
                if(!RDFutilitaires.dicpackbyid.ContainsKey(pa.PackageID)){
                    RDFutilitaires.dicpackbyid.Add(pa.PackageID,pa);
                }
            }
            */
            List<long> CIMpackageids = new List<long>();

          // ProfileIBOPackagesID= getParentPackages(package.PackageID,RDFutilitaires.dicpackbyid ,packageids);
            getCIMPackageslist(package, CIMpackageids);
            //getCIMPackageslist(profilespack, CIMpackageids);
            if (CIMpackageids.Count == 0)
            {
                Main.erreurs = Main.erreurs + 1;
                texte = "Error the package " + package.Name + " does not seem to be IsBasedOn to the CIM";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
               // MessageBox.Show(texte);
                return;
            }
           // reportTime("395");

            buildCIMDics(CIMpackageids);

            //reportTime("399");
          
            GenerateProfile(package);
           // GenerateProfile(profilespack);
           // reportTime("409");
           // reportlogtime.Close();
        }
        /// <summary>
        /// donne la liste des packages sur lesquels sont bases le package donne en appel
        /// </summary>
        /// <param name="aPackage"></param>
        public List<long> getParentPackages(long packid,Dictionary<long,EA.Package> dicpackbyid,List<long> packageids ){
            List<long> retour = new List<long>();
            RDFutilitaires.getPackagesOrigineIBO(packid, dicpackbyid, packageids);
            foreach (long paid in packageids)
            {
                RDFutilitaires.getAllPackID(paid, retour);
            }
            return retour;
        }


//-----------------------------------
        /// <summary>
        /// obtient la liste des packages a partir des dependance
        /// isbasedon sur les quelles le package du profile  se base
        /// </summary>
        /// <param name="profilepackage"></param>
        void getCIMPackageslist(EA.Package pack,List<long> parentpackageids)
        {
            ConstantDefinition CD=new ConstantDefinition();
            List<long> packageids=new List<long>(); // liste des packages IsBasedOn du package du profile
            foreach (EA.Connector con in pack.Connectors)
            {
                if ((con.Type == "Dependency") && (con.StereotypeEx.Contains(CD.GetIsBasedOnStereotype())) && (con.ClientID == pack.Element.ElementID))
                {
                    EA.Package parentpack = Repo.GetPackageByID((int) Repo.GetElementByID((int)con.SupplierID).PackageID);
                    string packname = Repo.GetElementByID((int)con.SupplierID).Name;
                    long paid = 0;
                    foreach (EA.Package pa in parentpack.Packages)
                    {
                        if (pa.Name == packname)
                        {
                            paid= pa.PackageID;
                            break;
                        }
                    }
                    if (paid == 0)
                    {
                        Main.erreurs = Main.erreurs + 1;
                       string texte = "Error while searching  CIM packages";
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    }
                      if (!packageids.Contains(paid))
                    {
                        packageids.Add(paid);
                        string texte = Repo.GetPackageByID((int) paid).Name;
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("  Package trouve de CIM : " + texte);
                    }
                }
            }
        
            foreach (long packageid in packageids)
            {
                List<EA.Package> packagesdupack = new List<EA.Package>();
                ManageIBOUtilitaires.getAllPackages( Repo.GetPackageByID((int) packageid),packagesdupack);
                foreach (EA.Package pa in packagesdupack)
                {
                    if (!parentpackageids.Contains(pa.PackageID)) parentpackageids.Add(pa.PackageID);
                }
            }
        }
        /// <summary>
        /// construction des dictionnaires du modele d'info à partir 
        /// des identificateurs des packages du systeme d'info CIM sur lesquel on est baseEA.Package
        /// </summary>
        /// <param name="pack"></param>
        void buildCIMDics(List<long> cimpackageids)
        {

            string texte="";
            Main.dicCIMElemByName = new Dictionary<string, EA.Element>();
            Main.dicCIMElemByID=new Dictionary<long,EA.Element>();
            Main.dicCIMElemByGUID = new Dictionary<string, EA.Element>();
            listelem = new List<EA.Element>();
            List<long> listelemid = new List<long>();
            EA.Package pack = null;
            try
            {
                if (Main.dicCIMElemByName.Count > 0) return; // les dictionnaires sont deja remplis
                foreach (long packid in cimpackageids)
                {
                    pack = Repo.GetPackageByID((int)packid);
                    string prov = pack.Name + "::" + pack.Packages.Count.ToString();
                    string tex = " Packages retenus du CIM " + prov;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(tex);
                    getTypedElements(pack, listelem, listelemid, "Class");

                    //// reportlog.Flush();  texte = "======   retour GetTypedList element=" + pack.Name;
                    //// if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    // reportlog.Flush();

                }
                foreach (EA.Element el in listelem)
                {
                    string prov = el.Name;
                    if ((el.Name != "") && !Main.dicCIMElemByName.ContainsKey(el.Name))
                    {

                       if(!Main.dicCIMElemByName.ContainsKey(el.Name)) Main.dicCIMElemByName.Add(el.Name, el);
                       if(!Main.dicCIMElemByID.ContainsKey(el.ElementID)) Main.dicCIMElemByID.Add(el.ElementID, el);
                       if (!Main.dicCIMElemByGUID.ContainsKey(el.ElementGUID)) Main.dicCIMElemByGUID.Add(el.ElementGUID, el);
                    }

                }
                //MessageBox.Show(" fin buildCIMDics "); //pour test
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                texte = "Error problem in building CIM dictionaries " + e.Message;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);

            }
               
                }

            
        


//---------------------------------------------------------------
        //-----------------------------------------------------------------------------------
        /// <summary>
        /// Generation d'un profil à partir d'un fichier xsd(cimcontextor ou cimtool)
        /// - creation d'un package (et diagrame) de nom  fic quand le nom d'origine est fic.xsd
        /// On selectionne dans l'ordre les noeuds h2 dont la valeur est
        /// Datatypes
        /// Enumerations
        /// Compound types
        /// Abstract Classes
        /// Concrete Classes
        /// Pour les differents types d'objets
        /// et on cree au fur  et à mesure les objets classes et objets diagramme nécéssaires
        /// on memorise le status de l'objet cree vide ou cree
        /// 
        /// 
        ///                         
        ///
        /// 
        /// </summary>
        /// <param name="fichier"></param>
       
        public void 
            GenerateProfile(EA.Package Pack)
        {
            string texte; // receptacle des messages erreur
            dicProfElemByName = new Dictionary<string, EA.Element>();
            profidentifiers = new Dictionary<string, long>();
            reportTime("550");
            BuildMapforprimitivetypes(mapprimitives);
            BuildCIMMapfromprimitivetypes(xmltocim);
            reportTime("552");
                // on verifie l'existence d'un diagramme de meme nom ou on le detruit 
                EA.Collection col = Pack.Diagrams;
                short ii=0;
                if (col.Count > 0)
                {
                    foreach (EA.Diagram diag in col)
                    {
                        if (diag.Name == Pack.Name)
                        {
                            break;
                        }
                        ii++;
                    }
                    if (ii < col.Count)
                    {
                        col.Delete(ii);


                        Pack.Diagrams.Refresh();
                    }
                }
            

           
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("----------------------------");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("rapport de lecture et transformation du fichier " + Pack.Name + " date:" + DateTime.Now);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("----------------------------");
            // reportlog.Flush();

             //  newtext(affiche,"rapport de lecture et transformation du fichier " + Pack.Name + " date:" + DateTime.Now);//am fev 2013
           // affiche.ShowDialog();
            //---------------- debut de l'algoritme de recherche--------------

            
           //  ReadDocument();
             
            try
            {

               
                  // doc.Load(FileReader);

                //on repere les partie <documentation
               // 
                // on applique ici un algorythme tres direct
                // en partant de la racine des document on récupère chaque noeud de type div,
                // si il est de type class, ou datatype ou enumeration ou Compound ,
                // on crée l'objet EA correspondant et on met à jour un dictionnaires des elements EA par id et par nom
                // on cré au passage la dependance isBasedOn utile (avec le lien et la tagvalue GUID)
                // on gère au passage un dictionnaire des éléments créés et avec 2 status 'encreation' et 'cree'
                //puis on effectue une deuxième passe en remplissant chacun des objets avec ses attributs et en creant les classes type des attributs 
                // si elles ne sont pas encore cree localement en utilisant le lien isBasedOn
               // ReadDocument(doc);
                
                // on commence par mettre a jour le fichier de configuration en vue de la prochiane exportation
                XmlDocument doc = new XmlDocument();
                XmlNamespaceManager nsmgr = new XmlNamespaceManager(doc.NameTable);
                nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema");
                doc.Load(fichier);
                
                XmlNode root = doc.DocumentElement; // la racine
                XmlNode schem = root.SelectSingleNode("//xs:schema",nsmgr);
                XmlAttributeCollection attribs = root.Attributes;
                string ficnom = Path.GetFileNameWithoutExtension(fichier);
                string ficdir = Path.GetDirectoryName(fichier);
                XMLP.SetXmlValueProfData("CurrentXSDFilePath",ficdir+ "\\" + ficnom+"-New" + ".xsd");
                XMLP.SetXmlValueProfData("DefaultXSDFilePath", ficdir + "\\" + ficnom + "-New" + ".xsd");
                string targetnamespace = attribs["targetNamespace"].Value;
                XMLP.SetXmlValueProfData("TargetNamespace", targetnamespace );
                for(int i=0;i<attribs.Count;i++)
                {
                 string nom = attribs[i].Name;
                 string  val = attribs[i].Value;  
                    if((val==targetnamespace)
                        && (nom.Contains(":"))
                        )
                    {
                       
                     XMLP.SetXmlValueProfData("Prefix",nom.Split(':')[1]);
                    }
                }
                 string[] targetsplit = targetnamespace.Split('/');
                 int nb = targetsplit.Length;
                 string profilname = targetsplit[nb - 1].TrimEnd('#');
                 XMLP.SetXmlValueProfData("EnvelopName",profilname);
                 

                 
                
                //XMLP.SetXmlValueProfData("targetNamespace",attribs.Item["xmlns:m",)
                // on commence à lire le fichier
                TextReader FileReader = new StreamReader(fichier);
               // XmlReaderSettings settings = new XmlReaderSettings();
               // settings.ProhibitDtd = true;
                XmlReader ficxmlr = XmlReader.Create(FileReader);

                ficxmlr.MoveToContent();
                string dansfic = ficxmlr.ReadOuterXml();
                XmlTextReader xmlr = new XmlTextReader(new StringReader(dansfic));
                string noeudtype = xmlr.LocalName;
                xmlr.ReadToFollowing("xs:element");
                string prov = xmlr.Name;
                noeudtype = xmlr.LocalName;
                
                EnvelopName = xmlr.GetAttribute("name");
                reportTime("621");
                xmlr.Read();
                while (((xmlr.NodeType != XmlNodeType.Element) && (xmlr.NodeType != XmlNodeType.EndElement)) || xmlr.Name != "xs:schema")
                {
                    if ((xmlr.Name == "xs:complexType") || (xmlr.Name == "xs:simpleType"))
                    {

                        DocElement delt = new DocElement();
                        prov = xmlr.Name;
                        noeudtype = xmlr.LocalName;
                        string div = xmlr.ReadOuterXml();

                        delt = traitdiv(div, noeudtype);


                    }
                    xmlr.Read();
                }
                reportTime("639");
                //----------------     on cree chacun des éléments mais sans les liens

                 foreach (DocElement del in DicDocEltFromXSDlByName.Values)
                {
                    //MessageBox.Show(" traitement du DocElement : " + del.name); // pour test
                    try
                    {
                        reportTime(del.name);
                        if (del.name.Contains("Work"))
                        {
                            prov = del.name;
                        }
                        EA.Element fromel = null;
                        if (Main.dicCIMElemByName.ContainsKey(ManageIBOUtilitaires.RemoveQual(del.name)))
                        {
                            fromel = Main.dicCIMElemByName[ManageIBOUtilitaires.RemoveQual(del.name)];
                            if(fromel != null )
                            {
                                prov = Repo.GetPackageByID((int)fromel.PackageID).Name + "::" + fromel.Name;
                            }
                        }
                        else
                        {
                            Main.erreurs = Main.erreurs + 1;
                            texte="Error the element of name " + del.name + "seems to be missing from DicCIMElementByName";
                           // MessageBox.Show(texte);  // pour test
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            continue;
                        }
                
                       // if (dicPackPack.ContainsKey(fromel.PackageID))  // Version preparee pour un profile mirrorant
                        //          les packages du modèle d'info ce qui n'est pas le cas dans un premier temps
                      //  {
                         
                          //  EA.Package topack = dicPackPack[fromel.PackageID];
                        EA.Package topack = profilespack;
                            EA.Element elt;
                           if (fromel != null)
                            {
                                // if (!Elementdejatraite.Contains(fromel.ElementID))
                               if(!dicProfElemByName.ContainsKey(del.name)) 
                                 {
                                    //Elementdejatraite.Add(fromel.ElementID); // donot treat something already done
                                    string prov1 = fromel.Name;
                                     elt = CreProfElem(fromel, topack, del);
                                   
                                    if(elt!=null)  prov1= elt.Name;
                                     
                                if (elt != null)
                                {
                                    if (!dicProfElemByName.ContainsKey(elt.Name)) dicProfElemByName.Add(elt.Name, elt);
                                    if (!dicParentSonID.ContainsKey(fromel.ElementGUID))
                   
                                    {

                                        prov="----" + Repo.GetPackageByID((int)fromel.PackageID).Name +"::"+ fromel.Name;
                                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(prov);
                                        texte = "--- entry dicParentSonID for " + elt.Name + " guid=" + fromel.ElementGUID + "eltid=" + elt.ElementID;
                                        dicParentSonID.Add(fromel.ElementGUID, elt.ElementID);
                              
                                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                    }
                                }
                                  }
                            }

                      //  }
                      //  else
                      //  {
                      //      MessageBox.Show("Error the package  " + Repo.GetPackageByID(fromel.PackageID).Name + " seems to be missing from DicPackByName");
                      //  }
                           reportTime(" fin " + del.name);
                    }
                    catch (Exception e)
                    {
                        Main.erreurs = Main.erreurs + 1;
                        //MessageBox.Show(" Error :  while treating  element " + del.name + ","+ e.Message);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while treating  element " + del.name + "," + e.Message);
                    }
                   //18  // reportlog.Flush();
                }

                
                
                //---------------   on cree tous les liens 
                // normalement les liens sont decrits appartenant à un seul element
                // mais on verifiera
                foreach (DocElement del in DicDocEltFromXSDlByName.Values)
                {
                    try
                    {
                        reportTime("liens " + del.name);
                        EA.Element fromel = null;
                        EA.Element proffromel = null;
                        if (del.type != "class") continue;
                        if ( dicProfElemByName.ContainsKey(del.name))
                        {
                             /*-- pour test */
                            if ((del.name == "EndDevice") || (del.name == "ACLineSegment"))
                            {
                                prov = del.type;
                            }
                             /* */
                            proffromel = dicProfElemByName[del.name];
                           // fromel = Repo.GetElementByGuid(ManageIBOUtilitaires.getParentGuid(proffromel)); //avr 2013
                            fromel = Main.dicCIMElemByGUID[ManageIBOUtilitaires.getParentGuid(proffromel)];
                        }
                        else
                        {
                            Main.erreurs = Main.erreurs + 1;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the element of name " + del.name + "seems to be missing from DicParentelementByName");
                        }
                        EA.Element proftoel;
                       
                        foreach (DocMember demb in del.members)
                        {
                            string dembtype = demb.type;
                            if (dembtype == "inherit")
                            {

                                EA.Connector conihn = creInherintlink(fromel, proffromel, demb, del);

                            }
                            if(demb.type=="_ref")
                            {
                                dembtype=getNomClassfromSawsdl(fromel,demb.sawsdl);
                            }
                            if (dicProfElemByName.ContainsKey(dembtype))
                            {
                                proftoel = dicProfElemByName[dembtype];
                                if (!proftoel.StereotypeEx.Contains("Datatype")
                                    && !proftoel.StereotypeEx.Contains(CD.GetDatatypeStereotype())
                                    && !proftoel.StereotypeEx.Contains(CD.GetEnumStereotype())
                                    && !proftoel.StereotypeEx.Contains(CD.GetCompoundStereotype())
                                    && !proftoel.StereotypeEx.Contains(CD.GetPrimitiveStereotype())
                                    )
                                {
                                    //lien potentiel trouvé avec toel
                                    EA.Element toel = Repo.GetElementByGuid(ManageIBOUtilitaires.getParentGuid(proftoel));//avr 2013
                                    
                                    // on verifie que fromel et toel sont relie et on  cre le lien correspondant dans le profil
                                   // Dictionary<long, string> ties = ManageIBOUtilitaires.IsRelated(fromel, toel);
                                    reportTime("779");
                                    //Dictionary<long, string> ties = IsAllRelated(fromel, toel,reportlog);
                                    Dictionary<long, string> ties = IsTousRelated(fromel, toel,reportlog);
                                    reportTime("781");
                                    if (ties.Keys.Count != 0)
                                    {
                                        foreach (KeyValuePair<long, string> kvp in ties)
                                        {
                                            if (ManageIBOUtilitaires.RemoveQual(demb.name) == kvp.Value)
                                            {// le role est compatible
                                                // on doit creer le lien si necessaire
                                               // if (!Conids.Contains(kvp.Key))// le lien n'a pas ete encore cree 	
                                               // {
                                                  //  Conids.Add(kvp.Key);
                                                    EA.Connector con = null;

                                                    // role compatible
                                                    con = creLink(fromel, proffromel, proftoel, demb, kvp);
                                               // }
                                            }

                                        }
                                    }

                                }
                            }
                        }
                         foreach (DocChoiceElement ce in del.choicemembers)
                        {
                            CreUnionLinks(proffromel, fromel, ce); 
                            // reportlog.Flush();
                        }
                        reportTime("fin " + " liens " + del.name);
                        if (conguid != "")
                        {
                            EA.Connector contest = Repo.GetConnectorByGuid(conguid);
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 883 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                        }
                        //18 // reportlog.Flush(); 
 
                    }
                    catch (Exception e)
                    {
                        Main.erreurs = Main.erreurs + 1;
                        //MessageBox.Show(" Error : while treating  links of " + del.name + e.Message);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while treating  links of " + del.name + "," + e.Message);
                    }
                }
                if (conguid != "")
                {
                    EA.Connector contest = Repo.GetConnectorByGuid(conguid);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 892 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                }
               //18  // reportlog.Flush();
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                //MessageBox.Show(" Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while treating  xsd file  ", e.Message);
            }

            changeNamePackage(Pack); // change nom du pack
            // ---------------------   on reconstitue les pointeurs de type
                           majIdentifiers();

            // --------on reconstitue les IBO dependency
                           WithIBODependency wth = new WithIBODependency(Repo);
            //---------------------- on cree le diagrame assossiee  ---------------------
                           if (conguid != "")
                           {
                               EA.Connector contest = Repo.GetConnectorByGuid(conguid);
                               // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 907 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                           }

            EA.Diagram ndiag = CreDiag(Repo, profilespack, dicProfElemByName);
            if (conguid != "")
            {
                EA.Connector contest = Repo.GetConnectorByGuid(conguid);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 923 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
            }
            Repo.ReloadDiagram((int)ndiag.DiagramID);
            Repo.SaveAllDiagrams();
            Repo.RefreshModelView(0);
            // reportlog.Flush();
           //18  reportlog.Close();    
        }
        //----------------------------------------------------------------------------	
        public void ReadDocument()
        {
             XmlDocument doc = new XmlDocument();
             doc.Load(fichier);
            //ClassStatus = "";
            foreach (XmlNode n in doc.ChildNodes)
            {
                readRecursif(n);
            }
             //// reportlog.Flush();
           //  reportlog.Close();
        }

        /// <summary>
        /// Lecture d'un noeud.
        /// Appel récursif sur tous les fils du noeud.
        /// <param name="noeud">le noeud</param>
        /// </summary>
        private void readRecursif(XmlNode noeud)
        {
            //affichage et traitement du noeud courant
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("----------------------------");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Type du noeud=" + noeud.NodeType);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Nom de noeud=" + noeud.Name);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Contenu du noeud=" + noeud.Value);
            if ((noeud.NodeType.ToString() == "Element") && (noeud.Name == "h1"))
            {
                //ClassStatus = noeud.InnerText;
               // // if(Main.DO_REPORTLOG) reportlog.WriteLine("classstatus=" + ClassStatus);
            }

            //-------------  appel recursif  ---------------------
            foreach (XmlNode n in noeud.ChildNodes)
                readRecursif(n);
        }
        //----------------------------------------------

         void  traitmember(string dansmember, DocElement elt)
        {
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("  traitmember member=" + dansmember);// pour test
          //18   // reportlog.Flush();
            /* ABA20230905
             if((elt.name=="Asset") && dansmember.Contains("AssetContainer"))
             {
                 string prov="";
             }*/
            try
            {
                XmlDocument memberdoc = new XmlDocument();
                    memberdoc.LoadXml(dansmember);
                XmlNode rootelem = memberdoc.DocumentElement;
                string nomclasse = "";
                if (elt.name == EnvelopName)
                {// il s'agit d'un element de la classe enveloppe qui designe une classe root
                    foreach (XmlAttribute att in rootelem.Attributes)
                    {
                        if (att.Name == "type")
                        {
                            nomclasse = att.Value;
                            string[] split=nomclasse.Split(new char[]{':'});
                            if (split.Length > 1)
                            {
                                nomclasse = split[1];
                            }
                            else
                            {
                                nomclasse = split[0];
                            }
                        }
                    }             
                    // if(!rootslist.Contains(reader.Value)) rootslist.Add(reader.Value);
                    if (!rootslist.Contains(nomclasse)) rootslist.Add(nomclasse);
                    elt.type = "enveloppe";  // l'element ne doit pas etre enregistre dans le dictionnaire
                    return;
                }
              
                DocMember member = new DocMember();
                foreach (XmlAttribute at in rootelem.Attributes)
                {
                    string nom = at.Name;
                    switch (nom)
                    {
                        case "name":
                            member.name = at.Value;
                            break;
                        case "sawsdl:modelReference":
                            string[] prov = RDFutilitaires.GetCleanSwsdl(at.Value);//pour test
                            member.sawsdl = RDFutilitaires.GetCleanSwsdl(at.Value);

                            break;
                        case "type":
                            member.type = at.Value;
                            break;
                        case "minOccurs":
                            member.lowerbound = at.Value;
                            break;
                        case "maxOccurs":
                            member.upperbound = at.Value;
                            break;
                        default:
                            break;
                    }
                }
               
                if (!elt.members.Contains(member)) elt.members.Add(member);// ajoute le membre à la collection
                if (!rootelem.HasChildNodes) return;
                
                foreach (XmlNode noeud in rootelem.ChildNodes)
                {
                    switch (noeud.Name)
                    {
                        case "xs:annotation" :
                            XmlDocument anndoc = new XmlDocument();
                            anndoc.LoadXml(noeud.OuterXml);
                            XmlElement docroot=anndoc.DocumentElement;
                            XmlNodeList  notesnods = docroot.GetElementsByTagName("xs:documentation");
                            member.comment = "";
                            foreach (XmlNode notesnod in notesnods)
                            {
                                if (member.comment == "")
                                {
                                    member.comment = notesnod.InnerText;
                                 } else
                                {
                                    member.comment = member.comment +"\n\r" + notesnod.InnerText;
                                }

                            }

                            /*
                                string anncontent = noeud.OuterXml;
                                XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
                                while (readann.ReadToFollowing("xs:documentation"))
                                {
                                    member.comment = member.comment + readann.ReadElementString() + "\n";
                                }
                             * */
                           break;
                        case "xs:complexType" :
                           if (member.type != "") // il s'agit d'une association reference
                           {

                               string[] prov = member.sawsdl;
                               // string choicetype = CD.GetChoiceType();
                               //member.type = member.type + ":" + "_ref";
                           }

                           else
                           {
                               if (noeud.FirstChild.Name == "xs:attribute")
                               {
                                   foreach (XmlAttribute atr in noeud.FirstChild.Attributes)
                                   {
                                       if ((atr.Name == "name") && (atr.Value=="ref"))
                                       {
                                           member.type = "_ref";
                                           break;
                                       }
                                   }
                               }
                               else
                               {

                                   // il s'agit d'une définition Anonyme:
                                   // ATTENTION il faut vérifier à poseriori que toutes 
                                   //les definitions "inline" n'ont pas de definition dans l'espace du profil
                                   // XmlDocument  anonymousDoc= new anonymousDoc(noeud.OuterXml);
                                   DocElement del = traitAnonymous(noeud, member, "complexType", elt.name);
                                   member.type = del.name; //am 2013 apres intro du qualifier
                                   /* 
                                      try
                         {
                             reportTime(del.name);
                             string prov = "";
                             if (del.name == "Reading")
                             {
                                 prov = del.name;
                             }
                             EA.Element fromel = null; ;
                             if (dicCIMElemByName.ContainsKey(ManageIBOUtilitaires.RemoveQual(del.name)))
                             {
                                 fromel = dicCIMElemByName[ManageIBOUtilitaires.RemoveQual(del.name)];
                                 prov=Repo.GetPackageByID((int)fromel.PackageID).Name + "::" + fromel.Name;
                             }
                             else
                             {
                              string   texte="Error the element of name " + del.name + "seems to be missing from DicCIMElementByName";
                                // MessageBox.Show(texte);  // pour test
                                 // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                             }
                
                      
                             EA.Package topack = profilespack;
                                 EA.Element elem;
                                if (fromel != null)
                                 {
                                      if (!Elementdejatraite.Contains(fromel.ElementID))
                                      {
                                         Elementdejatraite.Add(fromel.ElementID); // donot treat something already done
                                         string prov1 = fromel.Name;
                                          elem = CreProfElem(fromel, topack, del);
                                   
                                         if(elem!=null)  prov1= elem.Name;
                                     
                                     if (elem != null)
                                     {
                                         if (!dicProfElemByName.ContainsKey(elem.Name)) dicProfElemByName.Add(elem.Name, elem);
                                         if (!dicParentSonID.ContainsKey(fromel.ElementGUID))
                   
                                         {

                                             prov="----" + Repo.GetPackageByID((int)fromel.PackageID).Name +"::"+ fromel.Name;
                                             // if(Main.DO_REPORTLOG) reportlog.WriteLine(prov);
                                            string  texte = "--- entry dicParentSonID for " + elem.Name + " guid=" + fromel.ElementGUID + "elemid=" + elem.ElementID;
                                             dicParentSonID.Add(fromel.ElementGUID, elem.ElementID);
                              
                                             // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                         }
                                     }
                                       }
                                 }

                     
                                reportTime(" fin " + del.name);
                         }
                         catch (Exception e)
                         {
                             MessageBox.Show(" Error :  while treating  element " + del.name + ","+ e.Message);
                             // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while treating  element " + del.name + "," + e.Message);
                         }
                                    */

                               }

                           }
                            break;
                             case "xs:simpleType" :
                            if (member.type != "") // pb
                            {
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING member type dans xs:simpleType of " + elt.name + "should be empty");
                            }
                            else
                            {
                                // il s'agit d'une définition Anonyme:
                                // ATTENTION il faut vérifier à poseriori que toutes 
                                //les definitions "inline" n'ont pas de definition dans l'espace du profil
                                // XmlDocument  anonymousDoc= new anonymousDoc(noeud.OuterXml);
                                DocElement del = traitAnonymous(noeud, member, "simpleType",elt.name);
                                //member.name = del.name; //am 2013 apres intro du qualifier
                            }
                               break;
                        default:
                            break;
                    }
                }
                    
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                string texte = "Error  in traitmember for " + elt.name + " " + e.Message;
                //MessageBox.Show(texte);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            }
        }
         //----------------------------------------------
        /// <summary>
        /// traitement d'un membre d'heritage
        /// </summary>
        /// <param name="dansmember"></param>
        /// <param name="elt"></param>
         void traitextcont(string dansmember, DocElement elt)
         {
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("  traitextcont member=" + dansmember);// pour test
            //18  // reportlog.Flush();
             try
             {
                 XmlDocument memberdoc = new XmlDocument();
                 memberdoc.LoadXml(dansmember);
                 XmlNode rootelem = memberdoc.DocumentElement;
                 XmlNamespaceManager nsmgr = new XmlNamespaceManager(memberdoc.NameTable);
                 nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema");
                 if(rootelem.Name != "xs:extension") return ; // il ne s'agit pas d'un heritage
                 //string nomclasse = "";
                 DocMember member = new DocMember();
                 member.name = "inheritedfrom";
                 if (!elt.members.Contains(member)) elt.members.Add(member);// ajoute le membre à la collection
                 if (!rootelem.HasChildNodes) return;
                 
                             foreach (XmlAttribute atr in rootelem.Attributes)
                             {
                                 if (atr.Name == "base")
                                 {
                                     member.type = "inherit";
                                     string parent = atr.Value;
                                     if (parent.Contains(":"))
                                     {
                                         string[] splite = parent.Split(new char[] { ':' });
                                         member._type[0] = splite[1];
                                     }
                                     else
                                     {
                                         member._type[0] = parent;
                                     }
                                     break;
                                 }
                             }
                             XmlNode debseq = rootelem.SelectSingleNode("xs:sequence",nsmgr);
                            // if (debseq != null)
                            // {
                              //   foreach (XmlNode seqelement in debseq.SelectNodes("xs:element",nsmgr))
                                // {
                                     //trEltSequence(seqelement, elt);
                             trEltSequence(debseq, elt);

                                // }

                            // }

             }
             catch (Exception e)
             {
                 Main.erreurs = Main.erreurs + 1;
                 string texte = "Error  in traitmember for " + elt.name + " " + e.Message;
                 //MessageBox.Show(texte);
                 // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
             }
         }
//------------------------------
         void  traitmemberenum(string dansmember, DocElement elt)
         {
             try
             {
                 XmlTextReader reader = new XmlTextReader(new StringReader(dansmember));
                 reader.MoveToContent();
                 DocMember member = new DocMember();
                 member.type = "enumeration";
                 while (reader.MoveToNextAttribute())
                 {
                     switch (reader.Name)
                     {
                         case "value":
                             member.name = reader.Value;
                             break;

                         default:
                             break;
                     }
                 }
                 reader.MoveToElement();
                 while ((reader.NodeType != XmlNodeType.Element) && (reader.Name != "xs:annotation"))
                 {
                     reader.Read();

                 }
                 if (reader.Name == "xs:annotation")
                 {
                     /*
                     if (reader.ReadToDescendant("xs:documentation"))
                     {
                         reader.MoveToContent();
                         member.comment = reader.ReadString();
                     }
                      * */
                     string anncontent = reader.ReadOuterXml();
                     XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
                     if (readann.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
                     {
                         elt.notes.Add(readann.ReadElementString());

                         while (readann.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
                         {
                             elt.notes.Add(readann.ReadElementString());
                         }
                     }
                     
                    
                     //trEltAnnotation(reader, elt);

                 }
                 elt.members.Add(member);
             }
             catch (Exception e)
             {
                 Main.erreurs = Main.erreurs + 1;
                 writelog( "Error pb in traitmemberenum ..." + e.Message);
                
             }
         }

//--------------------------------------

  //----------------
        /// <summary>
        /// cree un package à partir du package de base 
        /// dans le package profile
        /// ou le bon sous package ATTENTION cette version ne suppose qu'un sous-niveau
        /// </summary>
        /// <param name="frompack"></param>
        /// <param name="topack"></param>
        /// <returns></returns>
        EA.Package CreProfpack(EA.Package frompack, EA.Package topack)
        {
            EA.Package newpack = null;
            try
            {
                newpack = (EA.Package)topack.Packages.AddNew(frompack.Name, "Package");
                newpack.Update();
                topack.Packages.Refresh();
                newpack.Name = frompack.Name;
                newpack.Notes = frompack.Notes;

                EA.Element newasel = (EA.Element)newpack.Element; // the element associated with the package and which holds the associations
                EA.Element fromasel = (EA.Element)frompack.Element;
                newasel.Stereotype = fromasel.Stereotype;
                newasel.Multiplicity = fromasel.Multiplicity;
                newasel.Tag = fromasel.Tag;
                newasel.Abstract = fromasel.Abstract;
                newasel.IsActive = fromasel.IsActive;
                newasel.Type = fromasel.Type;
                newasel.Subtype = fromasel.Subtype;
                newasel.Status = fromasel.Status;
                bool aGuid = false;
                foreach (EA.TaggedValue tgv in fromasel.TaggedValues)
                {

                    if (tgv.Name == CD.GetIBOTagValue())
                    {
                        aGuid = true;
                    }
                    CopyTaggedValue(tgv, newasel);

                }
                if (!aGuid)
                {

                    // mark the IBO elemnt with parent GUID
                    EA.TaggedValue guid = (EA.TaggedValue)newasel.TaggedValues.AddNew(CD.GetIBOTagValue(), fromasel.ElementGUID);
                    guid.Update();
                    newasel.TaggedValues.Refresh();
                    newasel.Update();
                }

                foreach (EA.Constraint constr in fromasel.Constraints)
                {
                    CopyConstraint(constr, newasel);
                }
                topack.Update();
                newasel.Update();
               
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                writelog("Error in CreProfpack ... " + e.Message);
            }
            return newpack;
        }
        //-----------
        void CopyTaggedValue(EA.TaggedValue fromtag, EA.Element toel)
        {
            // creat atvalue and copy simple attributes
            EA.TaggedValue tgv = (EA.TaggedValue)toel.TaggedValues.AddNew(fromtag.Name, fromtag.Value);
            tgv.Update();
            toel.TaggedValues.Refresh();
            tgv.Name = fromtag.Name;
            tgv.Name = fromtag.Value;
            tgv.Notes = fromtag.Notes;
        }

        EA.Constraint CopyConstraint(EA.Constraint fromconst, EA.Element toel)
        {
            EA.Constraint newconst = (EA.Constraint)toel.Constraints.AddNew(fromconst.Name, fromconst.Type);
            newconst.Update();
            toel.Constraints.Refresh();
            newconst.Name = fromconst.Name;
            newconst.Type = fromconst.Type;
            newconst.Notes = fromconst.Notes;
            return newconst;
        }

        //----
        /// <summary>
        /// creation d'un element
        /// ATTENTION^pour l'instant cet algorithme specule
        /// l'unicite des noms d'element sur TOUT le Modèle 
        /// et non par package ce qui serait plus logique (mais contraire à CimTool)
        /// </summary>
        /// <param name="fromel"></param>
        /// <param name="topack"></param>
        /// <param name="del"></param>
        /// <returns></returns>
         EA.Element CreProfElem(EA.Element fromel, EA.Package topack, DocElement del)
        {
            string prov = del.name;
            if (prov == "EquipmentFault")
            {
                prov = del.name;
            }
            
             //MessageBox.Show(" creation d'un element du profil : " + prov); // pour test

             bool pareil = isTypeLikeParent(fromel, del);
            if (pareil && !del.anonymous)
           
             {
               
                 // cela veut dire que l'on a pas besoin de creer l'identifieur dans le profil
                     // on enregistre l'id de l'identifier qui pointe vers le CIM
                     if (!profidentifiers.ContainsKey(fromel.Name))
                     {
                         profidentifiers.Add(fromel.Name, fromel.ElementID);

                     }
                 
                
                 return null;
             }
            prov = fromel.ObjectType.ToString();
            EA.Element newel = (EA.Element)topack.Elements.AddNew(fromel.Name,fromel.Type);
            //foreach (EA.ElementClass ob in fromel.BaseClasses)
            //{
            //    prov = ob.Name;
            //}
           // newel.Update();
            topack.Elements.Refresh();
            newel.Name = del.name; //fromel.Name;
          
            newel.Stereotype = fromel.Stereotype;
           // newel.Update();
         //   if ((fromel.Stereotype == "Enumeration") || (fromel.Stereotype == "enumeration"))
         //   {
         //       prov = newel.Stereotype;
         //}
            newel.StereotypeEx = fromel.StereotypeEx;
            if (del.anonymous)
            {
                newel.StereotypeEx = fromel.StereotypeEx + "," + CD.GetInlineStereotype();
            }
            //newel.Notes = fromel.Notes;
             foreach(string ss in del.notes)
             {
            newel.Notes = newel.Notes + ss + "\n\r";
            }
            newel.Multiplicity = fromel.Multiplicity;
            newel.Tag = fromel.Tag;
            newel.Abstract = fromel.Abstract;
            if(del.abstrait==true) newel.Abstract="1";
            newel.IsActive = fromel.IsActive;
            if (rootslist.Contains(newel.Name)) newel.IsActive = true;
            //newel.Type = fromel.Type;
            newel.Subtype = fromel.Subtype;
            newel.Status = fromel.Status;
            prov = (newel.IsActive).ToString(); //am          
            newel.Update();
            
           // topack.Update();
            prov = newel.Stereotype; //am
           
            if ((fromel.Stereotype == "Enumeration") || (fromel.Stereotype == "enumeration"))
            {
                prov = newel.Stereotype;
            }
            string texte = "CreatEL from " + ((EA.Package)Repo.GetPackageByID((int)fromel.PackageID)).Name + "::" + fromel.Name + "  " + ((EA.Package)Repo.GetPackageByID((int)newel.PackageID)).Name + "::" + newel.Name;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
             texte= "fromel StereotypeEx " + fromel.StereotypeEx + " newel stereotypeEx  " + newel.StereotypeEx;
             // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
             texte = "fromguid=" + fromel.ElementGUID + " toid=" + newel.ElementID;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            // on recopie juste les attributs du profiles
            bool thereisvalue = false;
            foreach (EA.Attribute atr in fromel.AttributesEx)
            {
                DocMember dmemb = new DocMember();
                if(atr.Name=="value") thereisvalue=true;
                 dmemb = del.IsMember(atr.Name);
                if (dmemb != null)
                {
                    { // cet attribut doit ere cree

                        CreAttribute(atr, newel, dmemb);
                        //del.attributs.Add(atr.Name);
                    }
                    
                }

            }
            if (fromel.StereotypeEx.Contains("CIMDatatype") && (del.type == "datatype") && !thereisvalue)
            {//alors le simpletype contient à minima l'attribut value
                CreAttributeValue(fromel, newel);
            }
            bool aGuid = false;
            foreach(EA.TaggedValue tgv in fromel.TaggedValues){
                if (tgv.Name == CD.GetIBOTagValue())
                {
                    aGuid = true;
                }
CopyTaggedValue(tgv,newel);
}
            if (!aGuid)
            {
                // mark the IBO elemnt with parent GUID
                EA.TaggedValue guid = (EA.TaggedValue)newel.TaggedValues.AddNew(CD.GetIBOTagValue(), fromel.ElementGUID);
                guid.Update();
                newel.TaggedValues.Refresh();
                prov = newel.Stereotype;//am
                newel.Update();
                prov = newel.Stereotype;//am
            }
foreach (EA.Constraint constr in fromel.Constraints)
{
    CopyConstraint(constr, newel);
}
             /**
if (pareil && del.anonymous)
{
  
    {// cela veut dire que l'on a pas besoin de creer l'identifieur dans le profil
        // on enregistre l'id de l'identifier qui pointe vers le CIM
        if (!profidentifiers.ContainsKey(fromel.Name))
        {
            profidentifiers.Add(fromel.Name, fromel.ElementID);

        }
    }

**/
            return newel;
        }

        //----
        /// <summary>
        /// creation d'un attribut selon son profil
        /// </summary>
        /// <param name="fromat"></param>
        /// <param name="elt"></param>
        /// <param name="demb"></param>
        /// <returns></returns>
        EA.Attribute CreAttribute(EA.Attribute fromat, EA.Element elt, DocMember demb)
        {
            string prov = elt.Name;
            /* ABA20230905
            if (elt.Name == "Organisation")
            {
                int a = 1;
            }*/
            if (demb.name == "value")  // pour test
            {
                 prov = elt.Name;
            }
            EA.Attribute newat = (EA.Attribute)elt.Attributes.AddNew(fromat.Name, fromat.Type);
            newat.Update();
            elt.Attributes.Refresh();
            newat.Name = fromat.Name;
            if(xmltocim.ContainsKey(demb.type))
            {
            newat.Type = xmltocim[demb.type];//fromat.Type
            }else{
           newat.Type = demb.type;
            }

            newat.Notes = demb.comment; // fromat.Notes;
            
            newat.LowerBound = demb.lowerbound;// fromat.LowerBound;
            newat.UpperBound = demb.upperbound;// fromat.UpperBound;
            newat.Pos = fromat.Pos;
            newat.IsConst = fromat.IsConst;
            newat.Default = fromat.Default;
            newat.Stereotype = fromat.Stereotype;
            newat.Precision = fromat.Precision;
            bool aGuid = false;
            newat.Update();
            foreach (EA.AttributeTag atgv in fromat.TaggedValues)
            {
                if (atgv.Name == CD.GetIBOTagValue())
                {
                    aGuid = true;
                }
                CopyAtTaggedValue(atgv, newat);
            }
            if (!aGuid)
            {
                // mark the IBO attribute with parent GUID
                EA.AttributeTag guid = (EA.AttributeTag)newat.TaggedValues.AddNew(CD.GetIBOTagValue(), fromat.AttributeGUID);
                guid.Update();
                newat.TaggedValues.Refresh();
                newat.Update();
            }
            string precision = "";
            
            foreach (EA.AttributeConstraint atconst in fromat.Constraints)
            {
                if(fromat.Type == CD.GetFloatType()) 
                {
                    if(atconst.Type=="INV") 
                    {
                        if(atconst.Name=="precision")
                        {
                            if (atconst.Notes == "choice=simple")
                            {
                                precision = "simple";
                            }
                            if (atconst.Notes == "choice=double")
                            {
                                precision = "double";
                            }
                        }
                    }
                }
                CopyAtConstraint(atconst, newat);
            }
            // creation des contraintes de restriction
            if (fromat.Type == CD.GetFloatType())
            {
                if (precision == "")
                {// le type du datatype de l'IS etait Float sans restriction => on doit le creer a ce niveau
                    if (demb.type == "float")
                    {
                        // on doit ajouter une contrainte de precision 
                        precision = "simple";
                        CrePrecisionConst(newat, precision);
                    }
                    if (demb.type == "double")
                    {
                        // on doit ajouter une contrainte de precision 

                        CrePrecisionConst(newat, precision);
                    }
                }
            }
            foreach(string ss  in demb.facets.Keys)
            {
                CreFacetConst(newat, ss,demb.facets[ss]);
                
            }
            return newat;
        }
        //----
        EA.Attribute CreAttributeValue(EA.Element fromel, EA.Element elt)
        {
           
            EA.Attribute fromat = null;
            EA.Attribute newat = null;
            if (!fromel.StereotypeEx.Contains("CIMDatatype")) return fromat;
            foreach (EA.Attribute at in fromel.Attributes)
            {
                if (at.Name == "value")
                {
                    fromat = at;
                    break;
                }
            }
            if (fromat == null) return newat;
            newat = (EA.Attribute)elt.Attributes.AddNew(fromat.Name, fromat.Type);
            newat.Update();
            elt.Attributes.Refresh();
            newat.Name = fromat.Name;
            newat.Type = fromat.Type;
            newat.Notes = fromat.Notes;
            newat.LowerBound =  fromat.LowerBound;
            newat.UpperBound =  fromat.UpperBound;
            newat.Pos = fromat.Pos;
            newat.IsConst = fromat.IsConst;
            newat.Default = fromat.Default;
            newat.Type = fromat.Type;
            newat.Stereotype = fromat.Stereotype;
            newat.Precision = fromat.Precision;
            newat.Update();
            bool aGuid = false;

            foreach (EA.AttributeTag atgv in fromat.TaggedValues)
            {
                if (atgv.Name == CD.GetIBOTagValue())
                {
                    aGuid = true;
                }
                CopyAtTaggedValue(atgv, newat);
            }
            if (!aGuid)
            {
                // mark the IBO attribute with parent GUID
                EA.AttributeTag guid = (EA.AttributeTag)newat.TaggedValues.AddNew(CD.GetIBOTagValue(), fromat.AttributeGUID);
                guid.Update();
                newat.TaggedValues.Refresh();
                newat.Update();
            }
            foreach (EA.AttributeConstraint atconst in fromat.Constraints)
            {
                CopyAtConstraint(atconst, newat);
            }
            return newat;
        }
        //---
        void CopyAtTaggedValue(EA.AttributeTag fromatgv, EA.Attribute newat)
        {
            // creat atvalue and copy simple attributes
            EA.AttributeTag atgv = (EA.AttributeTag)newat.TaggedValues.AddNew(fromatgv.Name, fromatgv.Value);
            atgv.Update();
            newat.TaggedValues.Refresh();
            atgv.Name = fromatgv.Name;
            atgv.Value = fromatgv.Value;
            atgv.Notes = fromatgv.Notes;
        }

        //--
        EA.AttributeConstraint CopyAtConstraint(EA.AttributeConstraint fromatconst, EA.Attribute newat)
        {
            // creat atconstraint and copy simple attributes
            EA.AttributeConstraint atconst = (EA.AttributeConstraint)newat.Constraints.AddNew(fromatconst.Name, fromatconst.Type);
            atconst.Update();
            newat.Constraints.Refresh();
            atconst.Name = fromatconst.Name;
            atconst.Type = fromatconst.Type;
            atconst.Notes = fromatconst.Notes;
            return atconst;
        }

        //--   
        EA.Connector creLink(EA.Element fromel, EA.Element profel, EA.Element proftoel, DocMember del, KeyValuePair<long, string> kvp)
        {
            string prov = del.name;
             string texte = "";
            if(del.name == "Names")
            {
                texte="";
            }
           
            EA.Connector ret = null;
            texte = " -----  crelink   --- ";
            texte = "del name=" + del.name + " del.type=" + del.type ;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = " fromel=" + fromel.Name + "guid=" + fromel.ElementGUID + "id=" + fromel.ElementID;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = " toel=" + profel.Name + "guid=" + profel.ElementGUID + "id=" + profel.ElementID;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = " proftoel=" + proftoel.Name + "guid=" + proftoel.ElementGUID + "id=" + proftoel.ElementID;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = " kvp=" + kvp.Key.ToString() + "," + kvp.Value.ToString();
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            try
            {
            //foreach(EA.Connector con in parentel.Connectors){
            EA.Connector con = Repo.GetConnectorByID((int)kvp.Key); // connexion parente
            texte = "createCon between " + ((EA.Package)Repo.GetPackageByID((int)profel.PackageID)).Name + "::" + profel.Name + " , " + ((EA.Package)Repo.GetPackageByID((int)proftoel.PackageID)).Name + "::" + proftoel.Name;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            EA.Connector newcon = null;
            newcon = (EA.Connector)profel.Connectors.AddNew("", con.Type);
            bool coteclient=false; // role côte toel eest du cote client
            if (con.ClientID == fromel.ElementID)
            {
                newcon.ClientID = profel.ElementID;
                newcon.SupplierID = proftoel.ElementID;
            }
            else
            {
                newcon.SupplierID = profel.ElementID;
                newcon.ClientID = proftoel.ElementID;
                coteclient = true;
            }
            newcon.Update();
            profel.Connectors.Refresh();
            newcon.Alias = con.Alias;
            newcon.Direction = con.Direction;
            newcon.EventFlags = con.EventFlags;
            newcon.Name = con.Name;
            newcon.Notes = con.Notes;
            newcon.Color = con.Color;
            newcon.Stereotype = con.Stereotype;
            newcon.IsLeaf = con.IsLeaf;
            newcon.IsRoot = con.IsRoot;
            newcon.IsSpec = con.IsSpec;
            newcon.StyleEx = con.StyleEx;
            newcon.Subtype = con.Subtype;
            newcon.Type = con.Type;
            newcon.VirtualInheritance = con.VirtualInheritance;
            newcon.Width = con.Width;
            newcon.Update();
          
                foreach (EA.ConnectorTag contag in con.TaggedValues)
                {
                    CopyConTgv(contag, newcon);
                }

                EA.ConnectorTag ctag = (EA.ConnectorTag)newcon.TaggedValues.AddNew(CD.GetIBOTagValue(), con.ConnectorGUID);
                ctag.Update();
                newcon.TaggedValues.Refresh();
                ctag.Value = con.ConnectorGUID;
                if (!dicParentSonID.ContainsKey(con.ConnectorGUID))
                {
                    dicParentSonID.Add(con.ConnectorGUID, newcon.ConnectorID);
                }
                else
                {
                    Main.erreurs = Main.erreurs + 1;
                    texte = "Warning while creating a nen connector from " + con.ConnectorGUID + " it seems that a son has already been created, probably through inheritance";
                    //MessageBox.Show(texte);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);

                }
                foreach (EA.ConnectorConstraint conconst in con.Constraints)
                {
                    CopyConConst(conconst, newcon);
                }
                // treatment of the Roles
                if (coteclient)
                {
                    CopyEnd(con.ClientEnd, newcon.ClientEnd, del);
                    CopyEnd(con.SupplierEnd, newcon.SupplierEnd, null);

                }
                else
                {
                    CopyEnd(con.ClientEnd, newcon.ClientEnd, null);
                    CopyEnd(con.SupplierEnd, newcon.SupplierEnd, del);

                }


                if (del.name == newcon.ClientEnd.Role)
                {
                    newcon.SupplierEnd.Role = "";
                    if (XMLP.GetXmlValueConfig("NavigationEnabled")=="Checked")
                    {
                        //newcon.SupplierEnd.Aggregation = 0;
                        newcon.ClientEnd.Navigable = "Navigable";
                        newcon.ClientEnd.Update();
                    }
                    else
                    {
                        newcon.SupplierEnd.Aggregation = 1;
                        //newcon.ClientEnd.Navigable = "Unspecified";
                    }
                    newcon.SupplierEnd.Cardinality = "";
                    newcon.SupplierEnd.Update();

                }
                else
                {
                    if (del.name == newcon.SupplierEnd.Role)
                    {
                        newcon.ClientEnd.Role = "";
                        if (XMLP.GetXmlValueConfig("NavigationEnabled") == "Checked")
                        {
                            //newcon.ClientEnd.Aggregation = 0;
                            newcon.SupplierEnd.Navigable = "Navigable";
                            newcon.SupplierEnd.Update();
                        }
                        else
                        {
                            newcon.ClientEnd.Aggregation = 1;
                            //newcon.SupplierEnd.Navigable = "Unspecified";
                        }
                       // newcon.ClientEnd.Aggregation = 1;
                        newcon.ClientEnd.Cardinality = "";
                        newcon.ClientEnd.Update();

                    }
                }
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error in crelink ..." + e.Message);
            }
             return ret;
            }



        //--   
        EA.Connector creInherintlink(EA.Element fromel, EA.Element profel,DocMember demb,DocElement del)
        {
            string prov = del.name;
            string texte = "";
            if (del.name == "ACLineSegment")
            {
                texte = "";
            }

            EA.Connector ret = null;
            texte = " -----  crelink   --- ";
            texte = "demb name=" + demb.name + " demb.type=" + demb._type[0] +"," + demb._type[1];
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = " fromel=" + fromel.Name + "guid=" + fromel.ElementGUID + "id=" + fromel.ElementID;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            EA.Element parentel=null;
            EA.Element profparentel=null;
            bool ok=false;
            try
            {
                foreach (EA.Connector con in fromel.Connectors)
                {
                    if (con.Type == "Generalization")
                    {
                        if (fromel.ElementID == con.ClientID)
                        {// on a peut-etre trouve l'ancetre
                            parentel = Repo.GetElementByID((int)con.SupplierID);
                            if (dicProfElemByName.ContainsKey(demb._type[0])) // doit pointer sur la classe dont on herite
                            {//on a bien trouve
                                prov = RDFutilitaires.getParentGuid(dicProfElemByName[demb._type[0]]);
                                string prov1 = Repo.GetPackageByID((int)parentel.PackageID) + "::" + parentel.Name;
                               // if (RDFutilitaires.getParentGuid(dicProfElemByName[demb._type[0]]) == parentel.ElementGUID) 
                                    Dictionary<long,EA.Element> resultlist=new Dictionary<long,EA.Element>();
                                    RDFutilitaires.getInheritanceEltById(Repo,parentel, resultlist);
                                    if (!resultlist.ContainsKey(parentel.ElementID)) resultlist.Add(parentel.ElementID, parentel);//am aout 2014
                                    profparentel = dicProfElemByName[demb._type[0]];
                                    string parentguid=RDFutilitaires.getParentGuid(profparentel);
                                    foreach(EA.Element elt in resultlist.Values)
                                    {
                                        if(elt.ElementGUID == parentguid)
                                        {
                                            ok = true; //profparentel est base sur une classe de la chaine d'heritage
                                            break;
                                        }
                                    
                                    }
                                }
                                else
                                {
                                    Main.erreurs = Main.erreurs + 1;
                                    texte = "Error while creating inheritage for class " + del.name;
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }
                            }                   
                          
                        }
                    if (ok) break;

                    }
                
                if (!ok) return ret; // pas trouve correct parentel
                
                EA.Connector newcon = null;
                newcon = (EA.Connector)profel.Connectors.AddNew("", "Generalization");
                
                    newcon.ClientID = profel.ElementID;
                    newcon.SupplierID = profparentel.ElementID;
                newcon.Update();
                profel.Connectors.Refresh();    
                
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error in creInheritlink ..." + e.Message);
            }
            return ret;
        }                  



    //--
 EA.ConnectorConstraint CopyConConst(EA.ConnectorConstraint fromconst,EA.Connector newcon){
EA.ConnectorConstraint  conconst=(EA.ConnectorConstraint) newcon.Constraints.AddNew(fromconst.Name,newcon.Type);
conconst.Update();
newcon.Constraints.Refresh();
conconst.Name=fromconst.Name;
conconst.Type=fromconst.Type;
conconst.Notes=fromconst.Notes;
return conconst;
}
//----
void CopyEnd(EA.ConnectorEnd fromend,EA.ConnectorEnd toend,DocMember demb){
toend.Aggregation=fromend.Aggregation;
toend.Navigable = fromend.Navigable;// am juil 2017
toend.Alias=fromend.Alias;
toend.AllowDuplicates=fromend.AllowDuplicates;
toend.Cardinality=fromend.Cardinality;
if (demb != null) // juin 2014
{
    if ((demb.upperbound == "*") || (demb.upperbound == "unbounded"))
    {
        toend.Cardinality = demb.lowerbound + ".." + "*";
    }
    else
    {
        toend.Cardinality = demb.lowerbound + ".." + demb.upperbound;
    }
}

toend.Constraint=fromend.Constraint;
toend.Containment=fromend.Containment;
toend.Derived=fromend.Derived;
toend.DerivedUnion=fromend.DerivedUnion;
toend.IsChangeable=fromend.IsChangeable;
toend.IsNavigable=fromend.IsNavigable;
toend.Navigable=fromend.Navigable;
toend.Ordering=fromend.Ordering;
toend.OwnedByClassifier=fromend.OwnedByClassifier;
toend.Qualifier=fromend.Qualifier;
toend.Role = fromend.Role; 
toend.RoleNote=fromend.RoleNote;
toend.RoleType=fromend.RoleType;
toend.Stereotype=fromend.Stereotype;
toend.Visibility=fromend.Visibility;




foreach(EA.RoleTag rtag in fromend.TaggedValues){
CopyRolTag( rtag,toend);
}
if (demb != null)
{
    toend.Role = demb.name;
    toend.RoleNote = demb.comment;
    if (demb.type=="_ref")
    {
        // c'est une reference
        toend.Containment = "Reference";
        if (toend.StereotypeEx != "")
        {
            toend.StereotypeEx = toend.StereotypeEx + "," + "ByRef";
        }
        else
        {
            toend.Stereotype = "ByRef";
        }

    }
}
toend.Update();
}
//----
void CopyRolTag(EA.RoleTag rtag,EA.ConnectorEnd conend){
EA.RoleTag newrtag = (EA.RoleTag) conend.TaggedValues.AddNew(rtag.Tag,rtag.Value);
newrtag.Update();
conend.TaggedValues.Refresh();
conend.Update();
newrtag.BaseClass=rtag.BaseClass;
newrtag.Tag=rtag.Tag ;
newrtag.Value=rtag.Value;
}
//--
EA.ConnectorTag CopyConTgv(EA.ConnectorTag fromcontgv, EA.Connector newcon)
{
    EA.ConnectorTag contag = (EA.ConnectorTag)newcon.TaggedValues.AddNew(fromcontgv.Name, fromcontgv.Value);
    contag.Update();
    newcon.TaggedValues.Refresh();
    contag.Name = fromcontgv.Name;
    contag.Notes = fromcontgv.Notes;
    return contag;
}
        //--
public  List<EA.Element> getTypedElements(EA.Package package, List<EA.Element> resultList,List<long> resultidlist, string type)
{
    try
    {
        foreach (EA.Element e in package.Elements)
        {
            if (e.Name == "") continue;
            if (e.Type == type)
            {
                if (!resultidlist.Contains(e.ElementID)&& (!resultList.Contains(e))) { resultList.Add(e); resultidlist.Add(e.ElementID); }

                string texte = "======   GetTypedList element=" + e.Name;
              //  // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
              //  // reportlog.Flush();
                //MessageBox.Show(texte);
            }
        }
        foreach (EA.Package p in package.Packages)
        {
            getTypedElements(p, resultList, resultidlist, type);
        }
    }
    catch (Exception e)
    {
        Main.erreurs = Main.erreurs + 1;
        writelog("Error pb in getTypedElement ... " + e.Message);
    }

   
    return resultList;
}
        //-------------------------------------------
        /*
public void getSortedElements(EA.Package package, List<EA.Element> resultclasses, List<EA.Element> resultclassifiers, List<long> resultids)
{

    foreach (EA.Element e in package.Elements)
    {
        if (e.Name == "") continue;
        {
            if ((e.Stereotype == "") || (e.StereotypeEx.Contains("Class")))
            {

                if (!resultids.Contains(e.ElementID)) { resultclasses.Add(e); resultids.Add(e.ElementID); }

                string texte = "======   GetTypedList element=" + e.Name;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                //MessageBox.Show(texte);

            }
            else
            {
                if (CD.CimClassifierStereos.Contains(e.Stereotype))
                {

                    if (!resultids.Contains(e.ElementID)) { resultclassifiers.Add(e); resultids.Add(e.ElementID); }

                    string texte = "======   GetTypedList element=" + e.Name;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    //MessageBox.Show(texte);

                }

            }
        }
        foreach (EA.Package p in package.Packages)
        {
            getSortedElements(p, resultList, resultidlist, type);
        }
    }
}
        */
//---------------------------------------------------------
/// <summary>
/// Populate the Diagram with all the elements of the package
/// </summary>
/// <param name="repo"></param>! 
/// <param name="pack"></param>
/// <param name="stereos"></param>
void DiagPopulate(Repository repo, EA.Diagram diag, List<string> stereos)
{
    EA.Package pack = repo.GetPackageByID(diag.PackageID);
    diag.ShowPackageContents = true;
    diag.Update();
    repo.ReloadDiagram(diag.DiagramID);
    repo.OpenDiagram(diag.DiagramID);
    repo.ActivateDiagram(diag.DiagramID);
    EA.DiagramObject diagobj;
    int offset = 0;
            /* ABA20230905
    int left = 200;
    int right = 300;
    int top = 200;
    int bottom = 400;
    string positions;*/
    foreach (EA.Element el in pack.Elements)
    {
        // MessageBox.Show("creation decimal l'element " + el.Name + " dans le diagrame " + diag.Name);
 
        bool ok = true;
        foreach (string s in stereos)
        {
            if (el.StereotypeEx.Contains(s))
            {
                ok = false;
                break;
            }
        }
        if (ok)
        {
            string position = "l=" + (200 + offset).ToString() + "r=" + (300 + offset).ToString();
            position = position + "t=" + (200 + offset).ToString() + "b=" + (300 + offset).ToString();

            diagobj = (EA.DiagramObject)diag.DiagramObjects.AddNew("l=200;r=300;t=200;b=300;", "");

            offset = offset + 300;

            diagobj.ElementID = el.ElementID;
            diagobj.Update();
            diag.DiagramObjects.Refresh();

            string message = " positions par defaut du diagramme pour " + el.Name;
            //MessageBox.Show(message + " l=" + diagobj.left + ",r=" + diagobj.right + ",t=" + diagobj.top + ",b=" + diagobj.bottom);


        }

    }
    // repo.ReloadDiagram(diag.DiagramID);
    // repo.OpenDiagram(diag.DiagramID);
    // repo.ActivateDiagram(diag.DiagramID);

    int style = ConstLayoutStyles.lsLayoutDirectionUp;
    int iterations = 4;
    int layerspacing = 20;
    int ColumnSpacing = 20;
    bool savetodiagram = true;

    //bool res=project.LayoutDiagramEx(diag.DiagramGUID, ConstLayoutStyles.lsDiagramDefault,4,20,20, savetodiagram);
    //bool res= project.LayoutDiagramEx(diag.DiagramGUID,ConstLayoutStyles.lsCycleRemoveDFS,4,20,20, savetodiagram);
    // bool res = project.LayoutDiagramEx(diag.DiagramGUID,ConstLayoutStyles.lsLayeringOptimalLinkLength ,4,20,20, savetodiagram);
    // project.LayoutDiagramEx(diag.DiagramGUID, ConstLayoutStyles.lsInitializeDFSOut, 4, 20, 20, savetodiagram);
    // bool res = project.LayoutDiagramEx(diag.DiagramGUID, style, iterations, layerspacing, ColumnSpacing, savetodiagram);
    style = ConstLayoutStyles.lsInitializeDFSOut + ConstLayoutStyles.lsLayeringOptimalLinkLength + ConstLayoutStyles.lsCycleRemoveDFS + ConstLayoutStyles.lsLayoutDirectionUp;
    project = repo.GetProjectInterface();
    bool res = project.LayoutDiagramEx(diag.DiagramGUID, style, iterations, layerspacing, ColumnSpacing, savetodiagram);
    res = diag.Update();
    string err = diag.GetLastError();
    //MessageBox.Show("apres layout " + res.ToString()+ "|" + err);
    repo.RefreshOpenDiagrams(false);
    

} 
        /// <summary>
/// cree un diagram avec tous les éléments du profil
/// 
/// </summary>
/// <param name="repo"></param>
/// <param name="listelem"></param>

EA.Diagram  CreDiag(Repository repo, EA.Package profilepack, Dictionary<string,EA.Element> dicprofelems)
{
    EA.Diagram diag = (EA.Diagram)profilepack.Diagrams.AddNew(profilepack.Name, "Class");
                diag.Update();
                profilepack.Diagrams.Refresh();
            
             repo.SaveAllDiagrams();           
            diag.Name = profilepack.Name;        
            repo.ReloadDiagram((int)diag.DiagramID);
            repo.RefreshOpenDiagrams(false);
    repo.SaveAllDiagrams();
    diag.ShowPackageContents = true;

    EA.DiagramObject diagobj;
    int offset = 0;
            /* ABA20230905
    int left = 200;
    int right = 300;
    int top = 200;
    int bottom = 400;
    string positions;*/
   // List<EA.Element> listelem = new List<EA.Element>();
   // ut.GetAllProfElements(pack, listelem);
    foreach (EA.Element el in dicprofelems.Values)
    {
        // MessageBox.Show("creation decimal l'element " + el.Name + " dans le diagrame " + diag.Name); 

        string position = "l=" + (200 + offset).ToString() + "r=" + (300 + offset).ToString();
        position = position + "t=" + (200 + offset).ToString() + "b=" + (300 + offset).ToString();

        diagobj = (EA.DiagramObject)diag.DiagramObjects.AddNew("l=200;r=300;t=200;b=300;", "");

        offset = offset + 300;

        diagobj.ElementID = el.ElementID;
        if (conguid != "")
        {
            EA.Connector contest = Repo.GetConnectorByGuid(conguid);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 2260 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + " elname=" + el.Name);
        }
        diagobj.Update();
        if (conguid != "")
        {
            EA.Connector contest = Repo.GetConnectorByGuid(conguid);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 2266 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + " elname=" + el.Name);
        }
        /*
        diagobj = (EA.DiagramObject)diag.DiagramObjects.AddNew("l=200;r=300;t=200;b=300;", "");

        offset = offset + 300;

        diagobj.ElementID = repo.GetElementByGuid(ut.getEltParentGuid(el)).ElementID;
         * */

        diagobj.Update();


        diag.DiagramObjects.Refresh();

        string message = " positions par defaut du diagramme pour " + el.Name;
        //MessageBox.Show(message + " l=" + diagobj.left + ",r=" + diagobj.right + ",t=" + diagobj.top + ",b=" + diagobj.bottom);


        if (conguid != "")
        {
            EA.Connector contest = Repo.GetConnectorByGuid(conguid);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 2288supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + " elname=" + el.Name);
        }

    }

    /*
    EA.Connector con = null;
    foreach (EA.DiagramLink dl in diag.DiagramLinks)
    {
        con = repo.GetConnectorByID((int)dl.ConnectorID);
        if (con.Type != "Dependency")
        {
            dl.IsHidden = true;
            dl.Update();
        }
    }
     * */
    if (conguid != "")
    {
        EA.Connector contest = Repo.GetConnectorByGuid(conguid);
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 2308 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + " elname=" );
    }
    int style = ConstLayoutStyles.lsLayoutDirectionUp;
    int iterations = 4;
    int layerspacing = 20;
    int ColumnSpacing = 20;
    bool savetodiagram = true;

    style = ConstLayoutStyles.lsInitializeDFSOut + ConstLayoutStyles.lsLayeringOptimalLinkLength + ConstLayoutStyles.lsCycleRemoveDFS + ConstLayoutStyles.lsLayoutDirectionDown;
    project = repo.GetProjectInterface();
    bool res = project.LayoutDiagramEx(diag.DiagramGUID, style, iterations, layerspacing, ColumnSpacing, savetodiagram);
    diag.Update();
    if (conguid != "")
    {
        EA.Connector contest = Repo.GetConnectorByGuid(conguid);
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 2323 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + " elname=");
    }
    string err = diag.GetLastError();
    //MessageBox.Show("apres layout " + res.ToString()+ "|" + err);
    //repo.RefreshOpenDiagrams(false);
    profilepack.Update();

    return diag;

}
        /// <summary>
        /// dans le cas des datatype, enumeration, primitive et compound
        /// donne vrai si les attributs sont semblables sauf pour les datatype avec value,multiplier, et unit
        /// dans cette version cela se traduit uniquement par un restriction sur un type de base 
        /// </summary>
        /// <param name="fromel"></param>
        /// <param name="del"></param>
     public  static bool isTypeLikeParent(EA.Element fromel,DocElement del)
        {
            bool res = false;
            try
            {
                
                string cas = "class";
                del.type = "class";
                if (fromel.StereotypeEx.Contains(CD.GetDatatypeStereotype())) { cas = "datatype"; del.type = "datatype"; }
                if (fromel.StereotypeEx.Contains(CD.GetEnumStereotype())) { cas = "enum"; del.type = "enum"; }
                if (fromel.StereotypeEx.Contains(CD.GetCompoundStereotype())) { cas = "compound"; del.type = "compound"; }
                if (fromel.StereotypeEx.Contains(CD.GetPrimitiveStereotype())) { cas = "primitive"; del.type = "primitive"; };
                switch (cas)
                {
                    case "datatype":
                        if ((del.name == fromel.Name) && (del.members.Count == 0) && isCIMDatatype(fromel))
                        {
                            res = true;
                        }
                        break;
                    case "class":
                        res = false;
                        break;
                    case "compound":
                        Dictionary<string, string> members = new Dictionary<string, string>();
                        foreach (DocMember mbr in del.members)
                        {
                            members.Add(mbr.name, mbr.type);

                        }
                        foreach (EA.Attribute at in fromel.Attributes)
                        {
                            if (!members.ContainsKey(at.Name))
                            {
                                res = false; return res;
                                //break;
                            }
                            string attype = "";
                            if (mapprimitives.ContainsKey(at.Type))
                            {
                                attype = mapprimitives[at.Type];
                            }
                            else
                            {
                                attype = at.Type;
                            }
                            if (members[at.Name] != attype)
                            {
                                res = false; return res;
                                //break;
                            }
                        }
                        res = true;
                        break;
                    case "enum":
                        List<string> enummembers = new List<string>();
                        foreach (DocMember mbr in del.members)
                        {
                            enummembers.Add(mbr.name);

                        }
                        foreach (EA.Attribute at in fromel.Attributes)
                        {
                            if (!enummembers.Contains(at.Name))
                            {
                                res = false; return res;
                                //break;
                            }

                        }
                        res = true;
                        break;
                    case "primitive":
                        return true;
                        //break;
                    default:
                        return false;
                        //break;
                }
            }
            catch (Exception e)
            {
                Main.erreurs = Main.erreurs + 1;
                string texte = "Error in isTypeLikeParent ... " + e.Message;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error in isTypeLikeParent ... " + e.Message);
            }
          return res;
          }
      /// <summary>
      /// dit si est constitue au moins de value;
      /// </summary>
      /// <param name="el"></param>
      /// <returns></returns>
      public static  bool isCIMDatatype(EA.Element el)
      {
          bool res = false;
          try
          {
              
              if (!el.StereotypeEx.Contains(CD.GetDatatypeStereotype())) return res;
              // on ne verifie pas le nb total d'attribut (car il peut y voir des extensions
              // dans le futur
              List<string> attributes = new List<string>();
              foreach (EA.Attribute at in el.Attributes)
              {
                  attributes.Add(at.Name);


              }
              if (!attributes.Contains("value"))
              {
                  res = false;
                  //ATTENTION on ne tient pas compte de UNit et multiplier 
                  // dans cette version
              }
              else
              {
                  res = true;
              }
          }
          catch (Exception e)
          {
              Main.erreurs = Main.erreurs + 1;
              // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error in ....isCIMDatatype" + e.Message);
          }
          return res;
      }
      static void BuildMapforprimitivetypes(Dictionary<string, string> map)
      {
          if (map.Count > 0) return; // le dictionnaire a deja ete initialise
          map.Add(CD.GetIntegerType(), "integer");
          map.Add("integer", "integer");
          map.Add("float", "float");
          map.Add(CD.GetBooleanType(), "boolean");
          map.Add("boolean", "boolean");
          map.Add(CD.GetStringType(), "string");
          map.Add("string", "string");
          map.Add("double", "double");
          map.Add("Double", "double");
          map.Add("Time", "time");
          map.Add("time", "time");
          map.Add("Date", "date");
          map.Add("date", "date");
          map.Add("DateTime", "dateTime");
          map.Add("dateTime", "dateTime");
          map.Add("Decimal", "decimal");
          map.Add("decimal", "decimal");
          map.Add("Duration", "duration");
          map.Add("duration", "duration");
          map.Add("normalizedString", "normalizedString");
          map.Add("token", "token");
          map.Add("NMTOKEN", "NMTOKEN");
          map.Add("Name", "Name");
          map.Add("NCName", "NCName");
          map.Add("anyURI", "anyURI");

      }
        /// <summary>
        /// mes a jour les identifiers
        /// </summary>
      void majIdentifiers()
      {
          /*********** pour test ***************/
          List<string> prov = new List<string>();
              foreach(string kk in dicProfElemByName.Keys)
              {
                  prov.Add(kk);
              }
          /************************************/
          foreach (KeyValuePair<string, EA.Element> kv in dicProfElemByName)
          {

              string pp = kv.Value.Name;
                /* ABA20230905
              if (pp == "Work")
              {
                  string p = "";
              }*/
              if ((kv.Value.Stereotype.Contains(CD.GetEnumStereotype())) ||
                 (kv.Value.Stereotype.Contains("enumeration")))
              {
                  continue;// les attributs d'une enumeration n'ont pas de identiifiers
              }

              foreach(EA.Attribute at   in kv.Value.Attributes)
              {
                  if (dicProfElemByName.ContainsKey(at.Type))
                  {
                      at.ClassifierID = dicProfElemByName[at.Type].ElementID;
                      at.Update();
                      continue;
                  }
                  else
                  {
                      if (profidentifiers.ContainsKey(at.Type))
                      {
                          at.ClassifierID = (int)profidentifiers[at.Type];
                          at.Update();
                          continue;
                      }
                      else
                      {
                          if (Main.dicCIMElemByName.ContainsKey(at.Type))
                          {
                              at.ClassifierID = (int)Main.dicCIMElemByName[at.Type].ElementID;
                              at.Update();
                              continue;
                          }

                      }
                  }
                  Main.erreurs = Main.erreurs + 1;
              string texte="Error pas de lien de classifier pour " + kv.Key + "." + at.Name  + " de type " + at.Type;
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                  //MessageBox.Show(texte);
          }
      }
      }
            /// <summary>
        /// tell if two elements are related 
        /// </summary>
        /// <param name="fromel"></param>
        /// <param name="toel"></param>
        /// <returns>retourne un dictionnare donnant une conid et un role</returns>
    public static   Dictionary<long, string> IsAllRelated(EA.Element fromel, EA.Element toel,TextWriter reportlog)
       {
           string texte;
          texte="-------------------------------------";
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           texte = " Isrelated fromel=" + fromel.Name + " , toel=" + toel.Name;
          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           Dictionary<long, string> liens = new Dictionary<long, string>();
           string role = "";
           List<EA.Element> fromelancesters=new List<EA.Element>();
           List<EA.Element> toelancesters=new List<EA.Element>();
           ManageIBOUtilitaires.getAllParents(fromel, fromelancesters);
           ManageIBOUtilitaires.getAllParents(toel, toelancesters);
           List<long> toelancestreids=new List<long>();
           foreach(EA.Element el in toelancesters)
           {
                    if(!toelancestreids.Contains(el.ElementID)) toelancestreids.Add(el.ElementID);
           }



           string prov = fromel.Name + "," + fromel.ElementID.ToString();
                
           foreach (EA.Element elt in fromelancesters)
           {
               prov = elt.Name + "," + elt.ElementID;
               foreach (EA.Connector con in elt.Connectors)
               {
                   if ((con.Type == "Association") || (con.Type == "Aggregation") )
                   {
                       EA.Element theotherend = ManageIBOUtilitaires.getTheotherend(elt, con);
                       texte = theotherend.Name;
                        foreach(long toid in toelancestreids)
                        {
                          if (theotherend.ElementID==toid)
                             { // connexion eligible
                               if (con.ClientID == theotherend.ElementID)
                              {
                               role = con.ClientEnd.Role;
                              }
                             else
                             {
                               role = con.SupplierEnd.Role;
                             }
                               if (!liens.ContainsKey(con.ConnectorID))
                              {
                               liens.Add(con.ConnectorID, role);
                               texte = " pour con.ConnectorID role retenu=" + role + " entre " + elt.Name + " et " + theotherend.Name;

                              // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                           }
                              break;
                         }
                            
                        }
                   }
               } 
           }
           

           return liens;
       }
        //----------
    public static Dictionary<long, string> IsTousRelated(EA.Element fromel, EA.Element toel, TextWriter reportlog)
    {
        string texte;
        texte = "-------------------------------------";
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        texte = " Isrelated fromel=" + fromel.Name + " , toel=" + toel.Name;
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        Dictionary<long, string> liens = new Dictionary<long, string>();
        string role = "";
        List<EA.Element> fromelancesters = new List<EA.Element>();
        List<EA.Element> toelancesters = new List<EA.Element>();
        List<long> toelancestreids = new List<long>();
        if(!dicancestorsbyelid.ContainsKey(fromel.ElementID))
        {
            ManageIBOUtilitaires.getAllParents(fromel, fromelancesters);
            dicancestorsbyelid.Add(fromel.ElementID, fromelancesters);
            dicancestoridsbyelid.Add(fromel.ElementID, new List<long>());
            foreach (EA.Element el in fromelancesters)
            {
                if(!dicancestoridsbyelid[fromel.ElementID].Contains(el.ElementID))
                {
                 dicancestoridsbyelid[fromel.ElementID].Add(el.ElementID); 
                }
            }
            
        }
        if (!dicancestorsbyelid.ContainsKey(toel.ElementID))
        {
            ManageIBOUtilitaires.getAllParents(toel, toelancesters);
            dicancestorsbyelid.Add(toel.ElementID, toelancesters);
            dicancestoridsbyelid.Add(toel.ElementID, new List<long>());
            foreach (EA.Element el in toelancesters)
            {
                if (!dicancestoridsbyelid[toel.ElementID].Contains(el.ElementID))
                {
                    dicancestoridsbyelid[toel.ElementID].Add(el.ElementID); 
            }
            }
            
        }
               
        string prov = fromel.Name + "," + fromel.ElementID.ToString();

        foreach (EA.Element elt in dicancestorsbyelid[fromel.ElementID])
        {
            prov = elt.Name + "," + elt.ElementID;
            foreach (EA.Connector con in elt.Connectors)
            {
                if ((con.Type == "Association") || (con.Type == "Aggregation"))
                {
                    EA.Element theotherend = ManageIBOUtilitaires.getTheotherend(elt, con);
                    texte = theotherend.Name;
                    foreach (long toid in dicancestoridsbyelid[toel.ElementID])//toelancestreids)
                    {
                        if (theotherend.ElementID == toid)
                        { // connexion eligible
                            if (con.ClientID == theotherend.ElementID)
                            {
                                role = con.ClientEnd.Role;
                            }
                            else
                            {
                                role = con.SupplierEnd.Role;
                            }
                            if (!liens.ContainsKey(con.ConnectorID))
                            {
                                liens.Add(con.ConnectorID, role);
                                texte = " pour con.ConnectorID role retenu=" + role + " entre " + elt.Name + " et " + theotherend.Name;

                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            }
                            break;
                        }

                    }
                }
            }
        }


        return liens;
    }
    //----------
    void traitchoicecontent(string dansmember, DocElement elt)
    {
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("  traitchoicecontent pour " + elt.name + " dansmember=" + dansmember);
        //18 // reportlog.Flush();
        if(elt.name == "EndDevice")
        {
            string gg=elt.name;
         }
        try
        {
            //XmlTextReader reader = new XmlTextReader(new StringReader(dansmember));
           // reader.MoveToContent();
            XmlDocument choicecontent = new XmlDocument();
            choicecontent.LoadXml(dansmember);
            DocChoiceElement choicelt = new DocChoiceElement();
            //while (reader.MoveToNextAttribute())
           // {
              //  switch (reader.Name)
            XmlNode startnode = choicecontent.DocumentElement;
            XmlNamespaceManager nsmgr = new XmlNamespaceManager(choicecontent.NameTable);
            nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema");
            nsmgr.AddNamespace("sawsdl", "http://www.w3.org/ns/sawsdl");

            foreach(XmlAttribute atr in startnode.Attributes)
                {
                  switch(atr.Name)
                  {
                    case "sawsdl:modelReference":
                       // choicelt.sawsdl = RDFutilitaires.GetCleanSwsdl(reader.Value);

                          choicelt.sawsdl = RDFutilitaires.GetCleanSwsdl(atr.Value);
                        break;

                    case "minOccurs":
                        //choicelt.lowerbound = reader.Value;
                        choicelt.lowerbound = atr.Value;
                        break;
                    case "maxOccurs":
                        //choicelt.upperbound = reader.Value;
                        choicelt.upperbound = atr.Value;
                        break;
                    default:
                        break;
                }
            }
            string texte = " traitement d'un element choice " + choicelt.sawsdl[0]+"."+choicelt.sawsdl[1];
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            //reader.MoveToElement();
            //string eltname = "";
            /*
            foreach (XmlNode nod in choicecontent.ChildNodes)
             do
            //{
                //eltname = reader.Name;
                eltname = nod.Name;
                switch (eltname)
                {
                    case "xs:annotation":
                       // trChoiceEltAnnotation(reader, choicelt);
                        trEltAnnotation(choicecontent.OuterXml, elt);
                        break;
                    case "xs:element":
                        //string choicemember = reader.ReadOuterXml();
                        string choicemember = choicecontent.OuterXml;
                        traitchoicemember(choicemember, choicelt);
                        break;
                    default:
                        break;
                }

                //do
                //{
                //   reader.Read();
                //} while ((reader.Name != "xs:element") && (reader.Name != "xs:annotation")
                //  && (reader.NodeType != XmlNodeType.EndElement) && (reader.Name != "xs:choice"))  ;
                //} while ((reader.NodeType != XmlNodeType.EndElement) || (reader.Name != "xs:choice"));
            }
             * */
            XmlNodeList nodlist=startnode.SelectNodes("xs:element",nsmgr);
            foreach (XmlNode element in nodlist)
            {
                string choicemember = element.OuterXml;
                traitchoicemember(choicemember, choicelt);
               
            }

            elt.choicemembers.Add(choicelt);
        }
        catch (Exception e)
        {
            Main.erreurs = Main.erreurs + 1;
            writelog("Error in  traitchoicecontent ..." + e.Message);
        }
    }
        //------------------------
    void traitchoicemember(string dansmember, DocChoiceElement choicelt)
    {
        try
        {
            XmlDocument document = new XmlDocument();
            document.LoadXml(dansmember);
            XmlNode startnode = document.DocumentElement;
            DocMember member = new DocMember();
            member.type = "";
            foreach (XmlAttribute atr in startnode.Attributes)
            {
                switch (atr.Name)
                {
                    case "name":
                        member.name = atr.Value;
                        break;
                    case "sawsdl:modelReference":
                        member.sawsdl = RDFutilitaires.GetCleanSwsdl(atr.Value);
                        break;
                    case "minOccurs":
                        member.lowerbound = atr.Value;
                        break;
                    case "maxOccurs":
                        member.upperbound = atr.Value;
                        break;
                    case "type":
                        member.type = CD.GetChoiceType() + ":" + CD.FAUX;
                        break;

                    default:
                        break;
                }
            }
            string texte = " traitement d'un element de choice " + member.name;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            XmlNamespaceManager nsmgr = new XmlNamespaceManager(document.NameTable);
            nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema");
            XmlNode compnod = startnode.SelectSingleNode("xs:complexType", nsmgr);
            if (compnod == null)
            {
                // il s'agit d'un membre non ref et non anonymous
                member.type = CD.GetChoiceType() + ":" + CD.FAUX;
            }
            else
            {
                if ((member.type == "") && (compnod.Attributes.Count == 0))
                    // am oct 2013 ATTENTION ai rajoute le test sur le nb d'attributs
                    // c'est a priori bon mais dans le cas ou un anonyme pourrait avoir 
                    // un attribut autre que name="ref" cela pourrait se rebveler faux
                {
                    //its an element of a union anonymouns
                   DocElement anonymdocel= traitAnonymousComptype(compnod, member);
                    member.type = CD.GetChoiceType() + ":" + CD.FAUX;
                    member.name = anonymdocel.name;

                }
                else
                {
                    //its an element of a union ref
                    {
                        member.type = CD.GetChoiceType() + ":" + CD.VRAI;
                        //traiter un member non reference    
                    }
                }
            }
            choicelt.elements.Add(member);
        }
        catch (Exception e)
        {
            Main.erreurs = Main.erreurs + 1;
            writelog("Error in ... traitchoicemember  " + e.Message);
        }
    }

    void trEltAnnotation(string anncontent, DocElement elt)
    {
        try{
       
        XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
        if (readann.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
        {
            elt.notes.Add(readann.ReadElementString());

            while (readann.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
            {
                elt.notes.Add(readann.ReadElementString());
            }
        }
        

        /*
        reader.MoveToContent();
        reader.Read();
        while (((reader.NodeType != XmlNodeType.Element) && (reader.NodeType != XmlNodeType.EndElement)) || reader.Name != "xs:annotation")
        {

            if (reader.Name == "xs:documentation")
            {
                elt.notes.Add(reader.ReadElementString());
            }

            reader.Read();
        }
        */
        }catch(Exception e){
            Main.erreurs = Main.erreurs + 1;
            writelog("Error in trEltAnnotation ...." + e.Message);
        }

    }
    void trChoiceEltAnnotation(XmlTextReader reader, DocChoiceElement choicelt)
    {
        reader.MoveToContent();
        reader.Read();
        while (((reader.NodeType != XmlNodeType.Element) && (reader.NodeType != XmlNodeType.EndElement)) || reader.Name != "xs:annotation")
        {

            if (reader.Name == "xs:documentation")
            {
                choicelt.comment=choicelt.comment + ";" +reader.ReadElementString();
            }

            reader.Read();
        }
    }


    void trEltSequence(XmlTextReader reader, DocElement elt)
    {
        XmlDocument doc = new XmlDocument();
        doc.LoadXml(reader.ReadOuterXml());
        try
        {
           
            foreach(XmlNode nod in doc.DocumentElement.ChildNodes)
            {
          
               string typelt = nod.Name;
              
                switch (typelt)
                {
                    case "xs:element":
                        string member = nod.OuterXml;
                        
                        traitmember(member, elt);
                        break;
                    case "xs:choice":
                        string choicecont = nod.OuterXml;
                        traitchoicecontent(choicecont, elt);
                       // reader.Skip();
                        break;
                    default:
                        break;

                }

            }
            }
        
        catch (XmlException e)
        {
            Main.erreurs = Main.erreurs + 1;
            //MessageBox.Show("Error " + "in trEltSequence for " + elt.name + e.Message);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error " + "in trEltSequence " + elt.name + e.Message);
        }
    }
        //

void trEltSequence(XmlNode noeud, DocElement elt)
    {
        
        try
        {
            
            foreach(XmlNode nod in noeud.ChildNodes)
            {
          
               string typelt = nod.Name;
              
                switch (typelt)
                {
                    case "xs:element":
                        string member = nod.OuterXml;
                        traitmember(member, elt);
                        break;
                    case "xs:choice":
                        string choicecont = nod.OuterXml;
                        traitchoicecontent(choicecont, elt);
                        break;
                    default:
                        break;

                }

            }
            }
        
        catch (XmlException e)
        {
            Main.erreurs = Main.erreurs + 1;
            //MessageBox.Show("Error " + "in trEltSequence for " + elt.name + e.Message);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error " + "in trEltSequence " + elt.name + e.Message);
        }
    }

  void trNodAttributes(XmlNode noeud,DocElement elt)
{
}

        //

    void trEltRestriction(XmlTextReader reader, DocElement elt)
    {

        XmlDocument doc = new XmlDocument();
        reader.MoveToContent();
        string r = reader.ReadOuterXml();
        doc.LoadXml(r);
        try
        {
            string typelt = "";
            elt.type = "datatype";
            // elt.simpletype = reader.GetAttribute("base");
            foreach (XmlAttribute atr in doc.DocumentElement.Attributes)
            {
                if (atr.Name == "base")
                {
                    elt.simpletype = atr.Value;
                }
            }

            DocMember member = null;
            bool issimplevalue = true;
            foreach (XmlNode nod in doc.DocumentElement.ChildNodes)
            //   do
            {
                // typelt = reader.Name;
                typelt = nod.Name;
                // if((reader.NodeType == XmlNodeType.EndElement)&& (reader.Name == "xs:simpleType"))
                // {
                member = new DocMember();
                // member.name = "value";
                member.type = elt.simpletype;
                member.lowerbound = member.upperbound = "1";
                
                // ajout  am  sept 2012 
                switch (elt.simpletype)
                {
                    case "xs:double":
                        //member.facets.Add("precision", "double");
                        member.facets.Add("none", "");
                        break;
                    case "xs:float":
                        //member.facets.Add("precision", "simple");
                        member.facets.Add("none", "");
                        break;
                    case "xs:decimal":
                        member.facets.Add("none", "");
                        break;
                    default:
                        break;

                }
                // --------------------------------
                //  elt.members.Add(member);

                // break;
                // }




                typelt = typelt.ToLower();

                string value = ""; // valeur de la restriction
                switch (typelt)
                {
                    case "xs:enumeration":
                        issimplevalue = false;
                        string dansmember = nod.OuterXml;

                        traitmemberenum(dansmember, elt);
                        break;

                    case "xs:fractiondigits":
                    case "xs:length":
                    case "xs:maxexclusive":
                    case "xs:maxinclusive":
                    case "xs:maxlength":
                    case "xs:minexclusive":
                    case "xs:mininclusive":
                    case "xs:minlength":
                    case "xs:pattern":
                    case "xs:totaldigits":
                    case "xs:whitespace":
                        issimplevalue = true;
                        value = reader.GetAttribute("value");
                        if (issimplevalue && (member == null))
                        {
                            member = new DocMember();
                            member.name = "value";
                            member.type = elt.simpletype;
                            member.lowerbound = member.upperbound = "1";
                            elt.members.Add(member);
                        }
                        if (!member.facets.ContainsKey(typelt))
                        {
                            member.facets.Add(typelt, value);
                        }
                        break;

                    default:
                        issimplevalue = false;


                        break;
                }
                if (issimplevalue && (member == null))
                {
                    member = new DocMember();
                    member.name = "value";
                    member.type = elt.simpletype;
                    member.lowerbound = member.upperbound = "1";
                    elt.members.Add(member);
                }
                
                //}while((reader.NodeType != XmlNodeType.EndElement)|| (reader.Name != "xs:restriction"));
            }
        }
        catch (Exception e)
        {
            Main.erreurs = Main.erreurs + 1;
            writelog("Error in trEltRestriction ..." + e.Message);
        }
    }

    void CreUnionNote()
    {
    }

    void CrePrecisionConst(EA.Attribute newat, string precision)
    {
        if (precision == "") return; // rien a faire 
        EA.AttributeConstraint newconst = (EA.AttributeConstraint)newat.Constraints.AddNew("precision", "INV");
        if(precision=="float") newconst.Notes="choice=simple";
        if (precision == "double") newconst.Notes = "choice=double";
        newconst.Update();
        newat.Constraints.Refresh();
    }
    void CreFacetConst(EA.Attribute newat, string facet,string facetvalue)
    {
        string progocl = ""; // le programme ocl correspondant à la facet

        for (int i = 0; i < CD.facets.Length; i++)
        {
            if ((("xs:" + CD.facets[i]) == facet) || ("none" == facet))
            {
                if (facet == "none")// pour forcer la ceation de simpletype 
                {
                    progocl = "none";
                }
                else
                {
                    progocl = CD.facetsocl[i];
                }
                break;
            }

        }
        EA.AttributeConstraint newconst = (EA.AttributeConstraint)newat.Constraints.AddNew(progocl, "OCL");
        
        if(progocl=="") return;
        newconst.Notes = "inv: self->" + progocl + "(" + facetvalue + ")";
        newconst.Update();
        newat.Constraints.Refresh();
    }
        /// <summary>
        /// creer tous les liens union 
        /// ce sous programme suppose que l'élement à relier est relié à une classe marquee
        /// <<union>>  sans parametre et abstraite dont les classes reliées sont les descendantes.
        /// on commence par creer cette classe abstraite qui a le nom du sawsdl de l'element choice recontré
        /// on doit avoir un element choice par classe abstraite
        /// </summary>
        /// <param name="proffromel"></param>
        /// <param name="fromel"></param>
        /// <param name="ce"></param>
    void CreUnionLinks(EA.Element proffromel, EA.Element fromel, DocChoiceElement ce)
    {
        try
        {
            string texte = "";

            if ((ce.sawsdl[0] == "") && (ce.sawsdl[1] == ""))
            {
                Main.erreurs = Main.erreurs + 1;
                texte = "Error in CreUnionLink   sawsdl of DocChoiceElement " + ce.name + " is empty";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return;
            }
            string nomunionclasse = ce.sawsdl[0]; // a priori le nom de la classe est le meme que le role
            string nomunionrole = ce.sawsdl[1];  // mais on doit verifier
            EA.Connector conparent = null;  // le lien dans le CIM
            EA.Element toel = null; // la classe abstraite portant l'union
            EA.Element proftoel = null;
            bool issource = false;
            foreach (EA.Connector con in fromel.Connectors)
            {
                if ((con.Type != "Association") && (con.Type != "Aggregation")) continue;

                if (con.ClientID == fromel.ElementID) // la classe origine est source
                {
                    if (nomunionrole == con.SupplierEnd.Role) // c'est le bon lien
                    {
                        issource = true;
                        toel = this.Repo.GetElementByID(con.SupplierID);
                        nomunionclasse = toel.Name;
                        conparent = con;
                        break;
                    }
                }
                else
                {// la classe origine est target
                    if (nomunionrole == con.ClientEnd.Role) // c'est le bon lien
                    {
                        toel = this.Repo.GetElementByID(con.ClientID);
                        nomunionclasse = toel.Name;
                        conparent = con;
                        break;
                    }
                }
            }
            if (toel == null)  // la classe n'a pas ete trouve
            {
                Main.erreurs = Main.erreurs + 1;
                texte = " Error CreUnionLink , there is no link from " + fromel.Name + " with otherend role=" + nomunionrole;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return;
            }
            if (dicProfElemByName.ContainsKey(nomunionclasse))
            {
                proftoel = dicProfElemByName[nomunionclasse];
                if (proftoel.Attributes.Count != 0)
                {
                    // il y a peut-être une autre classe du même nom 
                    // qui est anonymous et qui doit être renommée avec un qualifieur
                    //TBT
                    MessageBox.Show(" cela ne devrait pas arriver");
                }
                else
                {
                    Main.erreurs = Main.erreurs + 1;
                    texte = "Error CreUnionLink the union class " + nomunionclasse + " is present as complextype in the xsd, but has attributes";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    return;
                }
            }
            else
            {

                DocElement del = new DocElement();
                del.type = "classe";
                del.abstrait = true;
                del.name = nomunionclasse;
                del.comment = ce.comment;// on pourrait aussi prendre la description du parent (A VOIR)
                del.sawsdl = ce.sawsdl;
                proftoel = CreProfElem(toel, profilespack, del);
                // on rajoute le stereotype union
                proftoel.StereotypeEx = proftoel.StereotypeEx + "," + CD.GetUnionStereotype();
                proftoel.Update();
                if (!dicProfElemByName.ContainsKey(proftoel.Name)) dicProfElemByName.Add(proftoel.Name, proftoel);
            }
            if (!proftoel.StereotypeEx.Contains(CD.GetUnionStereotype()))
            {
                if (proftoel.StereotypeEx == "")
                {
                    proftoel.StereotypeEx = proftoel.StereotypeEx + CD.GetUnionStereotype();
                }
                else
                {
                    proftoel.StereotypeEx = proftoel.StereotypeEx + ";" + CD.GetUnionStereotype();
                }
            }
            //-------------------------  creer les liens et les heritages -------------------------------
            // le lien

            EA.Connector confille = (EA.Connector)proffromel.Connectors.AddNew("", "Association");
            proffromel.Connectors.Refresh();
            EA.Connector contest = null;
            if (issource)
            {
                confille.ClientID = proffromel.ElementID;
                confille.SupplierID = proftoel.ElementID;
                confille.Update();
                conguid = confille.ConnectorGUID;
                contest = Repo.GetConnectorByGuid(conguid);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3246 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                if (XMLP.GetXmlValueConfig("NavigationEnabled") == "Checked")
                {
                    //confille.ClientEnd.Aggregation = 0;
                    confille.SupplierEnd.Navigable = "Navigable";

                    MessageBox.Show(" maj navigable de confille =" + confille.SupplierEnd.Navigable + " changeable=" + confille.SupplierEnd.IsChangeable + " visibility=" + confille.SupplierEnd.Visibility);
                    confille.SupplierEnd.Update();
                 
                 // if(Main.DO_REPORTLOG) reportlog.WriteLine("confille ligne 3255 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
                 // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3255 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + contest.ConnectorGUID);
                }
                else
                {
                    confille.ClientEnd.Aggregation = 1;
                    //confille.SupplierEnd.Navigable = "Unspecified";
                    confille.ClientEnd.Update(); // am juil 2017
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3259 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                }

                // if(Main.DO_REPORTLOG) reportlog.WriteLine("confille ligne 3266 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3267 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
                confille.SupplierEnd.Role = nomunionrole;
                string upper=ce.upperbound;
                if (upper == "unbounded") upper = "*";
                confille.SupplierEnd.Cardinality = ce.lowerbound + ".." + upper;
                
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("confille ligne 3269 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
               
                confille.SupplierEnd.Update(); // am juil 2017
                // confille.ClientEnd.Update(); // am juil 2017
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("confille ligne 3272 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3278 supend= " + confille.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable + "conguid=" + confille.ConnectorGUID);
                //   confille.SupplierEnd.IsNavigable = false;
                //   confille.SupplierEnd.Navigable = "Non-Navigable";
                contest = Repo.GetConnectorByGuid(confille.ConnectorGUID);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3282 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
            }
            else
            {
                confille.SupplierID = proffromel.ElementID;
                confille.ClientID = proftoel.ElementID;
                confille.Update();
                contest = Repo.GetConnectorByGuid(confille.ConnectorGUID);
                if (XMLP.GetXmlValueConfig("NavigationEnabled") == "Checked")
                {
                    //confille.SupplierEnd.Aggregation = 0;
                    confille.ClientEnd.Navigable = "Navigable";
                }
                else
                {
                    confille.SupplierEnd.Aggregation = 1;
                    //confille.ClientEnd.Navigable = "Unspecified";
                    confille.SupplierEnd.Update(); // am juil 2017
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3288 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                }
                //confille.SupplierEnd.Aggregation = 1; // am juil 2017
                confille.ClientEnd.Role = nomunionrole;
                string upper = ce.upperbound;
                if (upper == "unbounded") upper = "*";
                confille.ClientEnd.Cardinality = ce.lowerbound + ".." + upper;
                // confille.SupplierEnd.Update(); // am juil 2017
                confille.ClientEnd.Update(); // am juil 2017
                // confille.ClientEnd.IsNavigable = false;
                //  confille.ClientEnd.Navigable = "Non-Navigable";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3297 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
            }
            confille.Direction = "Unspecified";
            confille.Update();
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3381 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);

            proffromel.Connectors.Refresh();
            EA.ConnectorTag ctag = (EA.ConnectorTag)confille.TaggedValues.AddNew(CD.GetIBOTagValue(), conparent.ConnectorGUID);
            ctag.Update();
            confille.TaggedValues.Refresh();
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3307 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
            foreach (DocMember dme in ce.elements)
            {
                CreUnionElement(toel, proftoel, dme);
                if (dme.type == CD.VRAI)
                {
                    // il s'agit d'une reference
                    if (issource)
                    {
                        confille.SupplierEnd.Containment = "Reference";
                        if (confille.SupplierEnd.StereotypeEx != "")
                        {
                            confille.SupplierEnd.StereotypeEx = confille.SupplierEnd.StereotypeEx + "," + "Byref";
                        }
                        else
                        {
                            confille.SupplierEnd.Stereotype = "Byref";
                        }
                    }
                    else
                    {
                        confille.ClientEnd.Containment = "Reference";
                        if (confille.ClientEnd.StereotypeEx != "")
                        {
                            confille.ClientEnd.StereotypeEx = confille.ClientEnd.StereotypeEx + "," + "Byref";
                        }
                        else
                        {
                            confille.ClientEnd.Stereotype = "Byref";

                        }
                    }

                    confille.ClientEnd.Update();
                    confille.SupplierEnd.Update();
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("contest ligne 3342 supend= " + contest.SupplierEnd.Navigable + "| clend= " + contest.ClientEnd.Navigable);
                }
            }
        }
        catch (Exception e)
        {
            Main.erreurs = Main.erreurs + 1;
           string texte = "Error UnionCrelinks for class" + fromel.Name + " "  + e.Message  ;
           // MessageBox.Show(texte);
           // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        }
    }

        void CreUnionElement(EA.Element toel,EA.Element proftoel,DocMember dme)
        {
            string texte = "";
            if((toel==null) || (proftoel==null))
            {
                Main.erreurs = Main.erreurs + 1;
                texte="Error CreUnionLink element parameter null";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return;
            }
            if (!dicProfElemByName.ContainsKey(dme.name))
            {
                Main.erreurs = Main.erreurs + 1;
               texte = "Error CreUnionLinks incoherence element " + dme.name + " n'existe pas";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            }
            else
            {
                
                EA.Element profel = dicProfElemByName[dme.name];
                string profelguid=RDFutilitaires.getParentGuid(profel);
                EA.Element el = null;
                if (profelguid != "") el = Repo.GetElementByGuid(profelguid);
                if (el == null)
                {
                    Main.erreurs = Main.erreurs + 1;
                    texte = "Error CreUnionLinks the profiles's element " + profel.Name + " is not isbasedon(no parentguid)";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    return;
                }
                // on recupere l'association de generalization d'origine
                string conguid = "";

                foreach (EA.Connector con in el.Connectors)
                {
                    if (con.Type != "Generalization") continue;
                    if ((con.ClientID == el.ElementID) && (con.SupplierID == toel.ElementID))
                    {
                        conguid = con.ConnectorGUID;

                        break;
                    }
                   
                }
                if (conguid=="")
                {
                    Main.erreurs = Main.erreurs + 1;
                    texte = "Error creUnionLink no generalization link between " + toel.Name + " and " + el.Name;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    return;
                }
                
                EA.Connector conn = (EA.Connector) proftoel.Connectors.AddNew("", "Generalization");
                conn.SupplierID = proftoel.ElementID;
                conn.ClientID = profel.ElementID;
                conn.Update();
                proftoel.Connectors.Refresh();
                EA.ConnectorTag ctag=(EA.ConnectorTag) conn.TaggedValues.AddNew(CD.GetIBOTagValue(),conguid);
                ctag.Update();
            }
        }
     string getNomClassfromSawsdl(EA.Element fromel,string[] sawsdl)
	{
    string result="";
    string rolename="";
    if(sawsdl[1]=="") 
        {
        return result;
        }else{
        rolename=sawsdl[1];
        }
      EA.Element otherend=null;
     foreach(EA.Connector con in fromel.Connectors)
	{
        if((con.Type=="Association") || (con.Type=="Aggregation"))
	{
        ArrayList prov = RDFutilitaires.getOtherend(fromel, con);// pour test
        long elemid= (long)RDFutilitaires.getOtherend(fromel, con)[1];
	otherend=Repo.GetElementByID((int)elemid);
        if(otherend != null)
        {
         if(con.ClientID==fromel.ElementID)
          {
          if(rolename==con.SupplierEnd.Role)
            {
            result=otherend.Name;
            break;
            }
	  }else{
          if(rolename==con.ClientEnd.Role)
            {
            result=otherend.Name;
           break;
            }
        	 }
	}
        
        }
	}
  return result;	   
}
//---------------------------------------------------------
     void changeNamePackage(EA.Package pa)
     {
       string[] split = Path.GetFileName(fichier).Split('.');
          pa.Name=split[0];
         pa.Update();
     }
   public  void writelog(string erreur)
     {
                 // if(Main.DO_REPORTLOG) reportlog.WriteLine(erreur);
                 MessageBox.Show(erreur);
     }
   public void newtext(Affiche dial, string text)
   {
       dial.Text = text;
       dial.newtext(text);
       dial.Show();
       System.Threading.Thread.Sleep(1000);
       dial.Close();
   }

        /*
    void DisplayTime(DateTime inputDt)
   {
       string dtString = inputDt.ToString(datePatt);
       Console.WriteLine("{0} {1}, Kind = {2}",
                         title, dtString, inputDt.Kind);
   }
        */

   void reportTime(string repere)
   {
       if (reportlogtime == null) return; // rien a faire pas de fichier 

       DateTime heure = DateTime.Now;
       DateTime zer = new DateTime(0);
       if (starttime == zer)
       {
           starttime = heure;

           reportlogtime.WriteLine("-- heure ---- " + repere + " : " + heure.ToString(datePatt) + "::" + heure.Millisecond.ToString());
         
       }
       else
       {
           endtime = heure;
           TimeSpan dt = endtime - starttime;
           reportlogtime.WriteLine("-- heure ---- " + repere + " : " + heure.ToString(datePatt) + "::" + heure.Millisecond.ToString());
           reportlogtime.WriteLine("-- durée  heure ---- " + ":" + dt.TotalSeconds.ToString());
           
           cumultime=cumultime+dt;
           reportlogtime.WriteLine("-- heure cumul ----" + ":" + cumultime.Minutes.ToString() + "." + cumultime.TotalSeconds.ToString() );
           starttime = zer;
       }
       
       
       }
        /// <summary>
        /// cre si besoin est un element de profil anonyme soit classe soit, datatype, soit compound , soit enum.
        /// </summary>
        /// <param name="noeud"></param>
        /// <param name="member"></param>
        /// <returns></returns>
     public DocElement  traitAnonymous(XmlNode noeud,DocMember member,string type,string eltnom) //type=complexType ou simpleType
      {
        
          string texte = "";
          DocElement docelt = new DocElement();
          docelt.anonymous = true;

        //  XmlDocument anonymdoc = new XmlDocument();
         // anonymdoc.LoadXml(noeud.OuterXml);
         foreach(XmlAttribute atr in noeud.Attributes)// anonymdoc.DocumentElement.Attributes)
              {
                  switch (atr.Name)
                  {
                      case "name":
                          docelt.name = atr.Value;

                          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                          texte = " Traitement d'un anonymous  name=" + docelt.name + " ,  type=" + docelt.type;
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                          // MessageBox.Show(texte); // pour test
                          break;
                      case "sawsdl:modelReference":
                          docelt.sawsdl = RDFutilitaires.GetCleanSwsdl(atr.Value);
                          // unfortunately the wg14 package uses the "s" to mark plural of certain AsociationRole label 
                          // so we have to trm the last s but of course we have to keep it for some name which are terminated by "s"
                          // like Status or Adress 
                         string singularnames=XMLP.GetXmlValueProfData("ListSingularName");
                        // string[] split=singularnames.Split(new Char[]{'|'});
                          if(!singularnames.Contains(docelt.sawsdl[0]))
                          {
                          docelt.name = docelt.sawsdl[0].TrimEnd('s');  // puisqu'on n'a pas de nom on le trouve dans sawsdl
                          }else{
                          docelt.name = docelt.sawsdl[0];
                          }
                              break;
                      default:
                          break;
                  }
        //          member.type = docelt.name; // juin 2014
              }
        // foreach (XmlNode nod in noeud.ChildNodes)
        // {
             string eltname = "";
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("     traitanonymous noeud=" + noeud.Name + " type=" + type + "  docelem=" + docelt.ToString());
             switch (noeud.Name)
             {
                      case "xs:annotation":
                                 string anncontent = noeud.OuterXml;
                                 XmlTextReader readann = new XmlTextReader(new StringReader(anncontent));
                                 if (readann.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
                                 {
                                     docelt.notes.Add(readann.ReadElementString());

                                     while (readann.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
                                     {
                                         docelt.notes.Add(readann.ReadElementString());
                                     }
                                 }
                                
                                 break;
                   case "xs:complexType":
                     foreach(XmlNode cnod in noeud.ChildNodes)
                     {
                         eltname = cnod.Name;
                         switch (eltname)
                         {
                             case "xs:annotation":
                                 string ancontent = cnod.OuterXml;
                                 XmlTextReader readan = new XmlTextReader(new StringReader(ancontent));
                                 while (readan.ReadToFollowing("xs:documentation"))
                                 {
                                     docelt.notes.Add(readan.ReadElementString());
                                 }
                                 break;
                             case "xs:sequence":
                                 XmlTextReader reader = new XmlTextReader(new StringReader(cnod.OuterXml));
                                 if (reader.IsStartElement())
                                 {
                                     try
                                     {
                                         if (!reader.IsEmptyElement)
                                         {
                                             trEltSequence(reader, docelt);

                                         }
                                     }
                                     catch (XmlException e)
                                     {
                                         Main.erreurs = Main.erreurs + 1;
                                         texte = "Error trEltSequence " + e.Message + " at line" + e.LineNumber.ToString();
                                         // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                     }
                                 }
                                 break;
                             case "xs:simpleContent":

                                 break;
                             default:
                                 break;
                         }
                     } 
                     break;

                 case "xs:simpleType":
                     foreach(XmlNode nn in noeud.ChildNodes)
                     {
                         eltname = nn.Name;
                         switch (eltname)
                         {
                             case "xs:annotation":
                                 string annncontent = nn.OuterXml;
                                 XmlTextReader readannn = new XmlTextReader(new StringReader(annncontent));
                                 if (readannn.ReadToDescendant("xs:documentation"))//ReadToFollowing("xs:documentation))
                                 {
                                     docelt.notes.Add(readannn.ReadElementString());

                                     while (readannn.ReadToNextSibling("xs:documentation"))//ReadToFollowing("xs:documentation))
                                     {
                                         docelt.notes.Add(readannn.ReadElementString());
                                     }
                                 }
                                
                                 break;
                             case "xs:restriction":
                                 string ss = nn.OuterXml;
                                 StringReader sr = new StringReader(ss);
                                 XmlTextReader reader = new XmlTextReader(sr );
                              //   reader.MoveToContent();                    
                                 trEltRestriction(reader, docelt);

                                 //if ((reader.NodeType == XmlNodeType.EndElement) && (reader.Name == "xs:simpleType"))
                                 //{
                                 //    if ((docelt.type != "") && !DicDocEltFromXSDlByName.ContainsKey(docelt.name)) DicDocEltFromXSDlByName.Add(docelt.name, docelt);
                                 //    return docelt;
                                 //}

                                 break;
                             default:
                                 break;
                         }
                        
                     } 
                     break;
                 default:
                     break;

             }
        // }
         
         // if ((docelt.type != "") && !DicDocEltFromXSDlByName.ContainsKey(docelt.name)) DicDocEltFromXSDlByName.Add(docelt.name, docelt);
             if (docelt.type != "")  //&& !DicDocEltFromXSDlByName.ContainsKey(docelt.name))
             {
                 // c'est une une classe  anonyme : on ajoute automatiquement un qualifier
                 //docelt.name = anonymqualif + "_" + docelt.name;
                 docelt.name = eltnom + "_" + docelt.name;
                 member.type = docelt.name;// juin 2014

                 if (!DicDocEltFromXSDlByName.ContainsKey(docelt.name)) DicDocEltFromXSDlByName.Add(docelt.name, docelt);

             }
        //18  // reportlog.Flush();
         return docelt;
      }

/// <summary>
        /// cre si besoin est un element de profil anonyme pour un complextype
        /// </summary>
        /// <param name="noeud"></param>
        /// <param name="member"></param>
        /// <returns></returns>
     public DocElement  traitAnonymousComptype(XmlNode noeud,DocMember member) //type=complexType ou simpleType
      {
        
          string texte = "";
          DocElement docelt = new DocElement();
          docelt.anonymous = true;

        //  XmlDocument anonymdoc = new XmlDocument();
         // anonymdoc.LoadXml(noeud.OuterXml);
         foreach(XmlAttribute atr in noeud.Attributes)// anonymdoc.DocumentElement.Attributes)
              {
                  switch (atr.Name)
                  {
                      case "name":
                          docelt.name = atr.Value;

                        
                          texte = " --------------------------";
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                          // ABA20240116 texte = " Traitement d'un anonymous  name=" + docelt.name + " ,  type=" + docelt.type;
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                          // MessageBox.Show(texte); // pour test
                          break;
                      case "sawsdl:modelReference":
                          docelt.sawsdl = RDFutilitaires.GetCleanSwsdl(atr.Value);
                          docelt.name = docelt.sawsdl[0].TrimEnd('s');  // puisqu'on n'a pas de nom on le trouve dans sawsdl
                          break;
                      default:
                          break;
                  }
              }
        // foreach (XmlNode nod in noeud.ChildNodes)
        // {
             string eltname = "";
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("     traitcompanonymouscomptype noeud=" + noeud.Name +  "  docelem=" + docelt.ToString());
             
                     foreach(XmlNode cnod in noeud.ChildNodes)
                     {
                         eltname = cnod.Name;
                         switch (eltname)
                         {
                             case "xs:annotation":
                                 string ancontent = cnod.OuterXml;
                                 XmlTextReader readan = new XmlTextReader(new StringReader(ancontent));
                                 while (readan.ReadToFollowing("xs:documentation"))
                                 {
                                     docelt.notes.Add(readan.ReadElementString());
                                 }
                                 break;
                             case "xs:sequence":
                                 //XmlTextReader reader = new XmlTextReader(new StringReader(cnod.OuterXml));
                               
                                // if (reader.IsStartElement())
                                // {
                                     try
                                     {
                                       //  if (!reader.IsEmptyElement)
                                        // {
                                             //trEltSequence(reader, docelt);
                                         trEltSequence(cnod, docelt);

                                        // }
                                     }
                                     catch (XmlException e)
                                     {
                                         Main.erreurs = Main.erreurs + 1;
                                         texte = "Error trEltSequence " + e.Message + " at line" + e.LineNumber.ToString();
                                         // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                     }
                                // }
                                 break;
                             case "xs:simpleContent":

                                 break;
                             default:
                                 break;
                         }
                         }
                 //    } 
                          
        // }
         
         // if ((docelt.type != "") && !DicDocEltFromXSDlByName.ContainsKey(docelt.name)) DicDocEltFromXSDlByName.Add(docelt.name, docelt);
         if (docelt.type != "")
         {
             if (docelt.type != "")  //&& !DicDocEltFromXSDlByName.ContainsKey(docelt.name))
             {
                 // c'est une une classe  anonyme : on ajoute automatiquement un qualifier
                 docelt.name = anonymqualif + "_" + docelt.name;
                 if (!DicDocEltFromXSDlByName.ContainsKey(docelt.name)) DicDocEltFromXSDlByName.Add(docelt.name, docelt);

             }  
         }
         
         // reportlog.Flush();
         return docelt;
      }




     public string removeS(string chain)
     {
         string resul = chain;
         resul = resul.TrimEnd('s');
         return resul;
     }

     static void BuildCIMMapfromprimitivetypes(Dictionary<string, string> map)
     {
         if (map.Count > 0) return; // le dictionnaire a deja ete initialise
         map.Add( "integer",CD.GetIntegerType());
         map.Add("float", "Float");
         map.Add("boolean", CD.GetBooleanType());
         map.Add("string",CD.GetStringType());
         map.Add("double", "Double");
         map.Add("time", "Time");
         map.Add("date", "Date");
         map.Add("dateTime", "DateTime");
         map.Add("decimal", "Decimal");
         map.Add("duration", "Duration");
     }
     void trEltComplexContent(XmlReader reader, DocElement elt)
     {
         XmlDocument doc = new XmlDocument();
         doc.LoadXml(reader.ReadOuterXml());
         XmlNode startnod=doc.DocumentElement;
         try
         {
             

             foreach (XmlNode nod in doc.DocumentElement.ChildNodes)
             {

                 string typelt = nod.Name;

                 switch (typelt)
                 {
                     case "xs:element":
                         string member = nod.OuterXml;
                         traitmember(member, elt);
                         break;
                     case "xs:extension":
                         string extcont = nod.OuterXml;
                         traitextcont(extcont, elt);
                         // reader.Skip();
                         break;
                     default:
                         break;

                 }

             }
         }

         catch (XmlException e)
         {
             Main.erreurs = Main.erreurs + 1;
             //MessageBox.Show("Error " + "in trEltSequence for " + elt.name + e.Message);
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error " + "in trEltSequence " + elt.name + e.Message);
         }
     }
        //-------------------------------------
    }
}









