using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using Microsoft.Win32;
using System.Reflection;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.HtmlGen
{

    class HtmlDocumentation
    {

        StreamWriter reportlog;  //for logs


        string categorie = ""; // la categorie de la classe (stereo de classification)
        string nomfichier = ""; // file to write the documentation
	string nomrepimages=""; // directory for images for the documentation
        StreamWriter docfile;
        static List<EA.Element> ProfileClasses;
        static StringBuilder AbstractsBuffer = new StringBuilder();
        StringWriter sw = new StringWriter(AbstractsBuffer);    
        Dictionary <string,List<long>> TypeList;// string, elementID
   
        Dictionary<long, string> dicNoteforClass;
        ConstantDefinition CD = new ConstantDefinition();
	Dictionary<long,string> dicPackim;
  	  Repository repository;
	EA.Project project;
    List<string> notpureclasses;  // to be used by find predicates
    List<string> notclassestereos; // sterotypes of objects different from classes (ex: enumeration or datattype)
    string subprofilestereotype;  // to be used by find predicates
    List<string> SubprofilesStereos; // list of non cim stereotypes
    List<long> dejatrouvee;// liste des  classes deja traitee (evite de dupliquer les traitement de multiples stereotypes)

    bool pourtest = false;
	XMLParser XMLP;
        private static string HTML_HEADER_FILE = @"DocHtmlHeader.txt";

        //---------------------------------------------------------
        /// <summary>
        /// constructor with several initialisations
        /// </summary>
        public HtmlDocumentation(EA.Repository repo)
        {
            repository = repo;
            CIMSchemaGenerator.Repos = repo; //pour test 
	    project = repository.GetProjectInterface();

            EA.Package pack = repo.GetTreeSelectedPackage();

            /************** pour test **********************
            //============================================
            ArrayList c = new ArrayList(){"Entsoe","ShortCircuit","operation"};
            RDFutilitaires.setper(c);
            string dump = "";
            string dumpit="";
            for (int i = 0; i < RDFutilitaires.resulpermutation.Count;i++ )
            {
                dumpit = "";
                for (int j = 0; j < ((ArrayList)RDFutilitaires.resulpermutation[i]).Count; j++)
                {
                    dumpit = dumpit + ((ArrayList)RDFutilitaires.resulpermutation[i])[j] + "|";                   
                }
                dump = dump + "{" + dumpit + "},";
            }
            MessageBox.Show("essai de permutation:" + dump);

            return;
            //============================================
            ************************************************/

               XMLP=new XMLParser(repository);
               if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
               {
                   string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                   string[] stereos = liststereos.Split(new char[] { '|' });
                   SubprofilesStereos = new List<string>(stereos);
                 
                    //MessageBox.Show("it seems that you want to introduce classifying stereos but you do not have saved your choices \n\r (menu option)");
                    RDFLAutilitaires.InitIndStereos(stereos, XMLP);//am mai 2020
                

            }
            else
               {
                   SubprofilesStereos = new List<string>();
               }

               SubprofilesStereos.Sort(RDFutilitaires.CompareStringsByLength);// assure qu'on traite les stereos composes en premier
               SubprofilesStereos.Reverse();

           

            try
            {
                RegistryKey eaReg = Registry.CurrentUser.OpenSubKey("Software\\Sparx Systems\\EAAddins\\CimSyntaxGen");
               // string path = (string)eaReg.GetValue("RessourcesFolder");
                //string path = "";
                if (XMLP.GetXmlValueConfig ("ModeBatch")== "Checked")
                {
                    nomfichier = XMLP.GetXmlValueProfData("HtmlDocumentationFilePath");
                    if ((nomfichier==null) || (nomfichier==""))  throw  new Exception(" Error in the configfile for HtmlDocumentationFilePath ");
                }
                else
                {
                    nomfichier = RDFutilitaires.SelectFile("html");
                }
                //path = FileManager.GetParentDirPath(); ABA20230830
                //path = path + "\\DocHtmlHeader.txt";
                //System.IO.File.Copy(path, nomfichier, true);
                Assembly myAssembly = Assembly.GetExecutingAssembly(); // ABA20230830
                Stream stream = myAssembly.GetManifestResourceStream("CimSyntaxGen.Resources." + HTML_HEADER_FILE);
                FileManager.CopyStream(stream, nomfichier);

                docfile = System.IO.File.AppendText(nomfichier);
                 string [] split = Path.GetFileName(nomfichier).Split(new char[]{'.'});

                 nomrepimages = Path.GetDirectoryName(nomfichier) + "\\" + split[0] + "_images";
 		if(Directory.Exists(nomrepimages)) Directory.Delete(nomrepimages,true);
		Directory.CreateDirectory(nomrepimages);
         //18 reportlog = new StreamWriter(Path.GetDirectoryName(nomfichier) + "\\" + split[0] +"log.txt");
        reportlog = Main.reportlog;
        RDFutilitaires.reportlog = reportlog;
                //MessageBox.Show("le fichier de log est sur"+ nomfichier + "\\" + split[0] + "log.txt");  
        //=====================
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n------------------\t\treport for html documenting profile  : ---------------------------------------------");
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf for {0}", Main.Repo.GetTreeSelectedPackage().Name);
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t Time of Generation:" + DateTime.Now + "\n");
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
        // ======================
         

                ProfileClasses = new List<EA.Element>();
                EA.Collection modellist = repo.Models;
                EA.Package toppack;
                toppack = null;
                foreach (EA.Package mod in modellist)
                {
                    toppack = mod;  // the root package
                    string prov = mod.Name;
                }

               //am mai 2020 RDFutilitaires.buildDicsElem(toppack);

     		dicPackim=new Dictionary<long,string>();
              AbstractsBuffer = new StringBuilder();
              sw = new StringWriter(AbstractsBuffer);
              TypeList= new Dictionary<string,List<long>>();
              TypeList.Add("datatype", new List<long>());
              TypeList.Add("enumeration", new List<long>());
              TypeList.Add("compound", new List<long>());
            }         

            catch (Exception e)
            {
                MessageBox.Show("An exception occured while reading the DocHtmlHeader.txt :" + e.Message);
            }

        }
        public void prodDoc(Repository repo)
        {

            EA.Package pack = repo.GetTreeSelectedPackage();
            // open body
            docfile.WriteLine("<body>");
            RDFutilitaires.getTypedElements(pack, ProfileClasses, "Class");
            ProfileClasses.Sort(RDFutilitaires.CompareElementsbyName);

            //--------
            notpureclasses = new List<string>();
            notpureclasses.Add(CD.GetEnumStereotype());
            notpureclasses.Add("Enumeration"); // am juin 2018
            notpureclasses.Add("Datatype");
            notpureclasses.Add(CD.GetDatatypeStereotype());
            notpureclasses.Add(CD.GetPrimitiveStereotype());
            notpureclasses.Add(CD.GetCompoundStereotype());
            notclassestereos = new List<string>(notpureclasses);
            notpureclasses.AddRange(SubprofilesStereos);

            List<EA.Element> classlists;
            string texte = " List of stereotye to categorize subProfiles" + "\r\n";
            foreach (string stereo in SubprofilesStereos)
            {
                texte = texte + "     " + stereo + "\r\n";
            }
            MessageBox.Show(texte);
            docfile.WriteLine(texte);
            dejatrouvee = new List<long>();
            for (int ii = 0; ii < SubprofilesStereos.Count; ii++)
            {
                string stereo = SubprofilesStereos[ii];
                if (RDFLAutilitaires.getPublishable(stereo) < 2) continue;//am mai 2020
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("production du sous-profil stereo=" + stereo);
                classlists = new List<EA.Element>();
                subprofilestereotype = stereo;
                classlists = ProfileClasses.FindAll(HasClassStereotype);
                classlists.Sort(RDFutilitaires.CompareElementsbyName);
                if (classlists.Count > 0)
                {
                    docfile.WriteLine("<h1>" + " " + "Concrete Classes" + " (" + stereo + ")" + "</h1>");
                    foreach (EA.Element elt in classlists)
                    {
                        string prov = elt.Name; // pour test
                        prodClass(elt);
                    }
                }
            }
            // classes concretes
            classlists = new List<EA.Element>();
            classlists = ProfileClasses.FindAll(HasNotClassStereotype);
            classlists.Sort(RDFutilitaires.CompareElementsbyName);
            docfile.WriteLine("<h1>" + " " + "Concrete Classes" + "</h1>");
            foreach (EA.Element elt in classlists)
            {
                //    MessageBox.Show("avant traitement:" + elt.Name);// pour test
                prodClass(elt);
            }

            /*******************
                        docfile.WriteLine("<h1>Concrete Classes</h1>");
            

                        foreach (EA.Element elt in ProfileClasses)
                        {
                
                         //   MessageBox.Show(elt.Name + " stereo " + elt.StereotypeEx);
                            List<string> lstereos=new List<string>((elt.StereotypeEx).Split(new char[]{','}));
                notpureclasses.Add(CD.GetEnumStereotype()))
                    notpureclasses.Add("Datatype"))
                    notpureclasses.Add(CD.GetDatatypeStereotype()))
                    notpureclasses.Add(CD.GetPrimitiveStereotype()))
                    notpureclasses.Add(CD.GetCompoundStereotype())))
                {
                   // WIP.StartWip();
                    prodClass(elt);
                   // WIP.CloseWip();
                }
                        }
            **************************/

            /**********************
             * the abstract classes
             * *******************/
            if (AbstractsBuffer.Length > 0)
            { // there is at least one abstract classes*/
                docfile.WriteLine("<h1>Abstract Classes</h1>");

                string aLine = null;//, aParagraph = null;
                StringReader strReader = new StringReader(AbstractsBuffer.ToString());
                while (true)
                {
                    aLine = strReader.ReadLine();
                    if (aLine != null)
                    {
                        docfile.WriteLine(aLine);
                    }
                    else
                    {
                        break;
                    }
                }
            }
                /*************************************************
                 * Enumerations
                 * ***********************************************/
                docfile.WriteLine("<h1>Enumerations</h1>");

                foreach (long kind in TypeList["enumeration"])
                {
                    //18 prodEnumeration(RDFutilitaires.dicelembyid[kind]);
                    prodEnumeration(Main.Repo.GetElementByID((int)kind));
                }


                /*************************************************
                 * Compound types types
                 * ***********************************************/
                docfile.WriteLine("<h1>Compound types</h1>");

                foreach (long comp in TypeList["compound"])
                {
                    prodCompoundtype(Main.Repo.GetElementByID((int)comp));
                }
                /*************************************************
                 * Datatypes
                 * ***********************************************/
                docfile.WriteLine("<h1>Datatypes</h1>");



                foreach (long data in TypeList["datatype"])
                {
                   //18  prodDatatype(RDFutilitaires.dicelembyid[data]);
                    prodDatatype(Main.Repo.GetElementByID((int)data));
                }


                //--------
                //end of file
                docfile.WriteLine("</body>");
                docfile.WriteLine("</html>");
                docfile.Flush();
                docfile.Close();
                // reportlog.Flush();
               //18  reportlog.Close();
            }
        



        
        /// <summary>
        /// production of documentation for a class
        /// </summary>
        /// <param name="elt"></param>
        void prodClass(EA.Element elt)
        {
            string prov = elt.Name;
       //  MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test
       /* ABA20230905
            if (prov == "TopologyBoundaryVersion")
            {
                int a=1;
            }*/
            if (RDFLAutilitaires.getPublishable(elt.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production classe=" + elt.Name);
            string texte = "";
            texte = "<div id=\"" + elt.Name + "\" class=\"group\">";
            ToDoc(texte, elt.Abstract);
            texte = "<a href=\"#" + elt.Name + "\">";
            ToDoc(texte, elt.Abstract);

            if (elt.Abstract == "1")
            {
                string ster="";
                foreach(string stereo in SubprofilesStereos){
                    if(elt.StereotypeEx.Contains(stereo)){
                        ster=stereo;break;
                    }
                }
                if(ster==""){
                texte = "<h2 class=\"abstract\">" + elt.Name +  "</h2>";
                }else{
                texte = "<h2 class=\"abstract\">" + elt.Name + " (" + ster  + ") " + "</h2>";
                }
                sw.WriteLine(texte);
            }
            else
            {
                //texte = "<h2 class=\"concrete\">" + elt.Name + "</h2>";
                categorie = getEltProfStereo(elt);
                categorie = categorie != "" ? " (" + categorie + ") ":"";
                texte = "<h2 class=\"concrete\">" + elt.Name + categorie  + "</h2>";
                docfile.WriteLine(texte);
            }
            texte = "</a>";
            ToDoc(texte, elt.Abstract);
  //          texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[elt.PackageID]).Name + " </p>";
 //           ToDoc(texte, elt.Abstract);
		prodPackage(elt.PackageID,elt.Abstract);
            texte = "<p class=\"comment\">" + brNote(elt.Notes) + "</p>";
            ToDoc(texte, elt.Abstract);

            //-----------new am
            prodClassConstraint(elt,elt.Abstract);
            //----------------
            if (elt.Connectors.Count > 0)
            {
                foreach (EA.Connector con in elt.Connectors)
                {
                    if (con.Type == "NoteLink")
                    {

                        prodNote(elt, con, elt.Abstract);
                    }


                }

            }
            List<long> atrids = new List<long>();
            /**********************
            *   natives attributes
            **********************/
          
            /****   pour test 
            if (elt.Name == "Terminal"){
                MessageBox.Show("element= terminal");
                pourtest = true;
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "trace de HtmlDocumentation " + DateTime.Now.ToString();
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        }
            ************************/

            bool native=false;
            Dictionary<string, List<EA.Attribute>> subprofiles = new Dictionary<string, List<EA.Attribute>>();
            Dictionary<string, List<EA.Connector>> consubprofiles = new Dictionary<string, List<EA.Connector>>();
            if (elt.Attributes.Count > 0)
            {
                 prov = elt.Name;  // pour test
                // am treatment of subprofiles
                // we prepare as many lists as of profiles categories
          
                foreach (string stereo in SubprofilesStereos)
                {
                    subprofiles[stereo] = new List<EA.Attribute>();
                }
                subprofiles["profile"] = new List<EA.Attribute>();


       
                //------------- end of declarations

                List<EA.Attribute> atrlist = SortAttributesByName(elt.Attributes);


                foreach (EA.Attribute atr in atrlist)
                {

                    string atrname = atr.Name;
                    bool subprofile = false; // the attribute is not in a subprofile
                    string stereosenordre =   RDFLAutilitaires.RedressStereo(atr.StereotypeEx);

                    // on se rappelle que les Subprofiles stereo sont classs par ordre decroissant de longueur
                    foreach (string stereo in SubprofilesStereos)
                    {
                        if (!stereo.Contains(","))
                        {
                            //if(stereosenordre.Contains(stereo)
                            if (stereosenordre.Contains( stereo))
                            {
                                subprofiles[stereo].Add(atr);
                                subprofile = true;
                                break;
                            }
                        }
                        else
                        {
                            string sterenordre = RDFLAutilitaires.RedressStereo(stereo);
                            if (stereosenordre.Contains(sterenordre))
                            {
                                subprofiles[stereo].Add(atr);
                                subprofile = true;
                                break;
                            }
                        }

                    }
                    if (!subprofile) { subprofiles["profile"].Add(atr); }
                }
            }
            if (elt.Connectors.Count > 0)
            {
                
                foreach (string stereo in SubprofilesStereos)
                {
                    consubprofiles[stereo] = new List<EA.Connector>();
                }
                consubprofiles["profile"] = new List<EA.Connector>();

                // classifying connections
                
                bool subprofile = false;
                EA.Element otherendelt = null;
                //if (pourtest)
                //{
                //    texte = "---------------- connectors of element  " + elt.Name + " -------------------------";
                //    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                //}
                foreach (EA.Connector con in elt.Connectors)
                {
                    subprofile = false;
                       if (pourtest)
                        {
                            texte = "--------   new connexion ------------- \r\n";
                            texte=texte+"type="+con.Type;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                    foreach (string stereo in SubprofilesStereos)

                    {   if((con.Type == "Association" )|| (con.Type == "Aggregation")){

                      

                        otherendelt=RDFutilitaires.getTheotherend(repository, elt, con);
   
                        string  otherendstereo = otherendelt.StereotypeEx;
                        
                        if (otherendstereo.Contains(stereo) || con.StereotypeEx.Contains(stereo))
                        {
                            if(!consubprofiles[stereo].Contains(con))consubprofiles[stereo].Add(con);
                            if (pourtest)
                            {
                                
                              texte = "\t otherend=" + otherendelt.Name + "," + " StereoEx=" + otherendelt.StereotypeEx;
                              // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                
                                texte = "addcon in consubprofile[" + stereo + "]";
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            }
                            subprofile = true;
                            break;
                        }
                    }
                    }
                    if (!subprofile)
                    {
                          if((con.Type == "Association" )|| (con.Type == "Aggregation"))
                            {
                        consubprofiles["profile"].Add(con);
                              
                        if (pourtest)
                        {
                            
                                texte = "\t otherend=" + otherendelt.Name + "," + " StereoEx=" + otherendelt.StereotypeEx;
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            
                            texte = "addcon in consubprofile[" + "profile" + "]";
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                              
                            }
                       
                    }
  
                }

            }

                //-------------------------

                native = false;
               
                foreach (string stereo in SubprofilesStereos)
                {
                    
                    if (( subprofiles.ContainsKey(stereo) && (subprofiles[stereo].Count > 0))
                        || ThereIsLegitimateConnexion(elt,consubprofiles,stereo))
                    {
                    if (RDFLAutilitaires.getPublishable(stereo) < 2) continue;//am mai 2020
                        native = true;
                        texte = "<h3>Native Members" + " (" + stereo + ")" + "</h3>";
                        ToDoc(texte, elt.Abstract);
                        texte = "<table>";
                        ToDoc(texte, elt.Abstract);

			if(( subprofiles.ContainsKey(stereo) && (subprofiles[stereo].Count > 0))){
                      
                        foreach (EA.Attribute at in subprofiles[stereo])
                        {
                            atrids.Add(at.AttributeID);
                            prodAttribute(elt, at, elt.Abstract);
                        }
			}						                                                           	
                      if(consubprofiles.ContainsKey(stereo) && (consubprofiles[stereo].Count >0)){
                          
                       foreach (EA.Connector con in consubprofiles[stereo])
                        {
                          // MessageBox.Show(" element " + elt.Name + "stereotype="+stereo+ " connector= " + con.ConnectorID.ToString() + "type= " + con.Type);
                            if ((con.Type == "Association") || (con.Type == "Aggregation"))
                            {
                               
                                prodAssoc(elt, con, elt.Abstract);
                            }
                        }                    
                      }
                      if (native == true)
                      {
                          texte = "</table>";
                          ToDoc(texte, elt.Abstract);
                          
                      }
		             	}
                }
		

            native=false;
                  if(elt.Attributes.Count >0){
                      native = true;
                    texte = "<h3>Native Members</h3>";
                    ToDoc(texte, elt.Abstract);
                    texte = "<table>";
                    ToDoc(texte, elt.Abstract);
                   if(subprofiles.ContainsKey("profile")){
                    foreach (EA.Attribute at in subprofiles["profile"])
                    {
                        atrids.Add(at.AttributeID);
                        prodAttribute(elt, at, elt.Abstract);
                    }
                   }
                  }
                  if (consubprofiles.ContainsKey("profile") && consubprofiles["profile"].Count > 0)
                  {
                      if (!native)
                      {
                          native = true;
                          texte = "<h3>Native Members</h3>";
                          ToDoc(texte, elt.Abstract);
                          texte = "<table>";
                          ToDoc(texte, elt.Abstract);
                      }
                      if(consubprofiles.ContainsKey("profile")) 
                      {
                      foreach (EA.Connector con in consubprofiles["profile"])
                      {
                          //MessageBox.Show(" element " + elt.Name + " connector= " + con.ConnectorID.ToString() + "type= " + con.Type);
                          if ((con.Type == "Association") || (con.Type == "Aggregation"))
                          {

                             prodAssoc(elt, con, elt.Abstract);
                          }
                      }
                      }
                  }
            
            if(native==true){	  
             texte = "</table>";
             ToDoc(texte, elt.Abstract);
		}

            /**********************
            *   inherited  attributes
            **********************/
            List<long> lmotherselid =new List<long>();
              RDFutilitaires.GetMothersClass(elt.ElementID, lmotherselid );
            EA.Element mel;
            if (lmotherselid.Count > 0)
            {
                texte = "<h3>Inherited Members</h3>";
                ToDoc(texte, elt.Abstract);

                texte = "<h4> Inheritance pass: " + RDFutilitaires.GetInheritancePath(repository, elt.ElementID, lmotherselid) + "</h4>";
                ToDoc(texte, elt.Abstract);
              
                texte = "<table>";
                ToDoc(texte, elt.Abstract);
                foreach (long id in lmotherselid)
                {
                    //18 mel = RDFutilitaires.dicelembyid[id];
                    mel = Main.Repo.GetElementByID((int)id);
                    List<EA.Attribute> matlist = SortAttributesByName(mel.Attributes);
                    foreach (EA.Attribute att in matlist)
                    {
                        atrids.Add(att.AttributeID);
                        prodInheritedAttribute(mel, att,elt.Abstract);
                    }
		   foreach(EA.Connector con in mel.Connectors){
			prodInheritedAssoc(mel,con,elt.Abstract);
		}

                }
                texte = "</table>";
                ToDoc(texte, elt.Abstract);
  
            }
              texte = "</div>";
              ToDoc(texte, elt.Abstract);
        }

//---------------
        void prodAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            if (RDFLAutilitaires.getPublishable(at.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production attribute=" + at.Name);
            // MessageBox.Show("at.name=" + at.Name + " at.type=" + at.Type + " at.notes=" + at.Notes);
            string texte;
texte="<tr>";
	 ToDoc(texte,isabstract);
texte="<th>";
	 ToDoc(texte,isabstract);
     categorie = getAtrProfStereo(at) != "" ?  getAtrProfStereo(at) : (getEltProfStereo(elt)!="" ? getEltProfStereo(elt) : ""); // on cascade le stereotype d'attribut et de classe
     categorie = categorie != "" ? " (" + categorie + ") " : "";
//texte="<p class=\"name\" id=\"" + elt.Name + "." + at.Name +"\">" + at.Name+ " </p>";
     texte = "<p class=\"attribut\" id=\"" + elt.Name + "." + at.Name + "\">" + at.Name + " " +  categorie + " </p>";
	 ToDoc(texte,isabstract);
texte="</th>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p class=\"cardinality\">" + at.LowerBound + ".." + at.UpperBound + "</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td class=\"type\">";
	 ToDoc(texte,isabstract);
texte="<p class=\"type\">";
	 ToDoc(texte,isabstract);

 /*           
if((at.ClassifierID == 0) || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
    // attention dans certain cas un type non lie n'annule pas le ClassifierID
{
texte=at.Type;
}else{
    EA.Element claselt = RDFutilitaires.dicelembyid[at.ClassifierID];
    texte = claselt.Name;
    string type = getTypeElt(claselt);
    if (TypeList.ContainsKey(type))
    {
        if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);
    }
}
            */

     if (!(
         (elt.StereotypeEx.Contains(CD.GetEnumStereotype()))
         ||
         (elt.StereotypeEx.Contains("Enumeration")) //am juin 2018
         ))
     {
         if (at.ClassifierID == 0)
         {
             // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error classifier=0 for attribute " + at.Name + " in " + elt.Name);
         }
     }
     texte = traitClassifierID(at.ClassifierID);

texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
ToDoc(texte, isabstract); //am juin 2018
     //prodRestrict(elt, at, isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
     if (at.ClassifierID != 0)
     {
         string prov = "";

         if (elt.Name == "ActivePower")
         {
             prov = elt.Name;
         }

         prov = elt.Name + "|" + repository.GetElementByID((int)at.ClassifierID).Name + "|" + repository.GetElementByID((int)at.ClassifierID).Stereotype;
         // if (repository.GetElementByID((int)at.ClassifierID).Stereotype == CD.GetPrimitiveStereotype()) // il s'agit dune priimitive
         // {
         if (at.Default != "")
         {
             if (at.IsConst)
             {
                 texte = " ConstantValue=";
             }
             else
             {
                 texte = " DefaultValue=";
             }
             string initval = at.Default;
             if (initval.Contains("http"))// il s'agit d'une reference
             {
                 initval = "<a href=\"" + initval + "\"><font color=\"#0000ff\"><u>" + initval + "</u></font></a>";
             }
             texte = texte + " " + initval + " <br/>";
             ToDoc(texte, isabstract);
         }
         // }
     }
texte="<p class=\"comment\">" + brNote(at.Notes) + "</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

texte="</tr>";
	 ToDoc(texte,isabstract);
        }

//-------------------------------

        void prodInheritedAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            if (RDFLAutilitaires.getPublishable(at.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production inheritedattribute=" + at.Name);
            string texte;
texte="<tr>";
	 ToDoc(texte,isabstract);
texte="<th>";
	 ToDoc(texte,isabstract);
     string stereo = getAtrProfStereo(at);
     if (stereo == "")
     {
         texte = "<p class=\"inheritattribut\">" + at.Name + " </p>";
     }
     else
     {
         texte = "<p class=\"inheritattribut\">" + at.Name + " (" + stereo + ") " + " </p>";
     }
	 ToDoc(texte,isabstract);
texte="</th>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p class=\"cardinality\">" + at.LowerBound + ".." + at.UpperBound + "</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td class=\"type\">";
	 ToDoc(texte,isabstract);
texte="<p class=\"type\">";
	 ToDoc(texte,isabstract);
     if ((at.ClassifierID == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
{
texte=at.Type;
}else{
   //18 texte = RDFutilitaires.dicelembyid[at.ClassifierID].Name;
         texte = Main.Repo.GetElementByID((int)at.ClassifierID).Name;
}
texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p class=\"comment\">" + at.Notes + "</p>";
//	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name + "\">" + elt.Name + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="</tr>";
	 ToDoc(texte,isabstract);
        }

//-------------------------------
        void prodAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            if ((RDFLAutilitaires.getPublishable(elt.StereotypeEx) < 2) || (RDFLAutilitaires.getPublishable(con.StereotypeEx) < 2)) return;//am mai 2020
            CIMSchemaGenerator.ConexesID = 0;
            /***********************************************************/
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.ConnectorEnd myend;
            EA.Element otherendelt;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend=connex.Source;
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend=connex.Target;
            }
            
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable=="Navigable"))
                && myend.Navigable != "Navigable")
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                {// the association creates an effective memmber

                    string texte;
   

                    texte = "<tr>";
                    ToDoc(texte, isabstract);

                    
                                        
                    texte = "<td class=\"type\">";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">";
                    ToDoc(texte, isabstract);
                   // texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                    categorie = getAssocProfStereo(con);
                    if (categorie == "")
                    {
                        categorie = getEltProfStereo(elt) != "" ? getEltProfStereo(elt) : "";
                    }
                   categorie = categorie != "" ? " (" + categorie + ") " : "";  
                    texte = "<p class=\"role\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + "[" + cardinality + "]" + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                   // texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                    texte = "<p><a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a></p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"comment\">" + brNote(otherend.RoleNote) + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "</tr>";
                    ToDoc(texte, isabstract);
                }
            }
            /* ********************/
        }
        //-------------------------------
        void prodInheritedAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            if ((RDFLAutilitaires.getPublishable(elt.StereotypeEx) < 2) || (RDFLAutilitaires.getPublishable(con.StereotypeEx) < 2)) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production inheritedassociation pour" + elt.Name);
            CIMSchemaGenerator.ConexesID = 0;
            if (con.Type == "NoteLink") return;
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.Element otherendelt;
            EA.ConnectorEnd myend;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
                
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable=="Navigable"))
                && (myend.Navigable != "Navigable"))
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                string texte;
                texte = "<tr>";
                ToDoc(texte, isabstract);
                texte = "<th>";
                ToDoc(texte, isabstract);
                string stereo = getEltProfStereo(elt);
                categorie = getAssocProfStereo(con);
                categorie = categorie != "" ? " (" + categorie + ") " : ""; 
                if (stereo == "")
                {
                    
                    //texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                    texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
                }
                else
                {
              //texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                    if (categorie != "")
                    {
                        texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
                    }
                    else
                    {
                        texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                    }
                }
                    ToDoc(texte, isabstract);
                texte = "</th>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td class=\"type\">";
                ToDoc(texte, isabstract);
                texte = "<p class=\"type\">";
                ToDoc(texte, isabstract);
                texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                ToDoc(texte, isabstract);
                texte = "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
//                texte = "<p class=\"comment\">" + otherend.RoleNote + "</p>";
//                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name  + "\">" + elt.Name + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

                texte = "</tr>";
                ToDoc(texte, isabstract);
            }
        }
//------------
   void prodEnumeration(EA.Element enumelt){
            if (RDFLAutilitaires.getPublishable(enumelt.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production =enumeration" + enumelt.Name);
            //  MessageBox.Show(" enumeration " + enumelt.Name);// pour test
            string texte = "";
       string prov = removestereo(CD.GetEnumStereotype(),enumelt.Name);
//texte="<div id=\"" + enumelt.Name +"(" +  prov + ")" + "\" class=\"group\">";
texte = "<div id=\"" + enumelt.Name + "\" class=\"group\">";
               docfile.WriteLine(texte);
texte="<a href=\"#" + enumelt.Name + "\">";
               docfile.WriteLine(texte);
texte="<h2 class=\"enumerated\">" + enumelt.Name + "</h2>";
               docfile.WriteLine(texte);
texte="</a>";
               docfile.WriteLine(texte);
//texte="<p class=\"package\">"+ (RDFutilitaires.dicpackbyid[enumelt.PackageID]).Name + "</p>";
     //          docfile.WriteLine(texte);
		prodPackage(enumelt.PackageID,"0");
texte="<p class=\"comment\">" + brNote(enumelt.Notes) + "</p>";
               docfile.WriteLine(texte);
texte="<table>";
               docfile.WriteLine(texte);
	foreach(EA.Attribute at  in enumelt.Attributes){
	prodMember(enumelt,at);
		}
texte="</table>";
               docfile.WriteLine(texte);
texte="</div>";
               docfile.WriteLine(texte);

}
   //------------
   void prodDatatype(EA.Element dataelt)
   {
             if (RDFLAutilitaires.getPublishable(dataelt.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production =datatype" + dataelt.Name);

            //MessageBox.Show("datatype= " + dataelt.Name);// pour test
            string texte = "";
       texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
       docfile.WriteLine(texte);
       texte = "<a href=\"#" + dataelt.Name + "\">";
       docfile.WriteLine(texte);
       texte = "<h2 class=\"datatype\">" + dataelt.Name + "</h2>";
       docfile.WriteLine(texte);
       texte = "</a>";
       docfile.WriteLine(texte);
 //      texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
 //      docfile.WriteLine(texte);
		prodPackage(dataelt.PackageID,"0");
     texte = "<p class=\"comment\">" + brNote(dataelt.Notes) + "</p>";
       docfile.WriteLine(texte);
       if (dataelt.Connectors.Count > 0)
       {
           foreach (EA.Connector con in dataelt.Connectors)
           {
               if (con.Type == "NoteLink")
               {
                   prodNote(dataelt, con, "0");
               }


           }

       }
       texte = "<table>";
       docfile.WriteLine(texte);
       foreach (EA.Attribute at in dataelt.Attributes)
       {
          // MessageBox.Show("datatype.name=" + dataelt.Name + " | at.name=" + at.Name + " | at.type=" + at.Type + " | at.notes=" + at.Notes);
           prodAttribute(dataelt, at, "0");
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
 //------------
   void prodMember(EA.Element enumelt,EA.Attribute at)
   {
  docfile.WriteLine( "<tr>");
docfile.WriteLine("<th>");
docfile.WriteLine("<p class=\"name\">" + at.Name +  "</p>");
docfile.WriteLine("</th>");
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"comment\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("</tr>");


   }
//------------
   void prodCompoundtype(EA.Element dataelt)
   {
           if (RDFLAutilitaires.getPublishable(dataelt.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production compound=" + dataelt.Name);
            // MessageBox.Show(" compound =" + dataelt.Name);
            string texte = "";
       texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
       docfile.WriteLine(texte);
       texte = "<a href=\"#" + dataelt.Name + "\">";
       docfile.WriteLine(texte);
       texte = "<h2 class=\"enumerated\">" + dataelt.Name + "</h2>";
       docfile.WriteLine(texte);
       texte = "</a>";
       docfile.WriteLine(texte);
  //     texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
     //  docfile.WriteLine(texte);
		prodPackage(dataelt.PackageID,"0");
       texte = "<p class=\"comment\">" + brNote(dataelt.Notes) + "</p>";
       docfile.WriteLine(texte);
       texte = "<table>";
       docfile.WriteLine(texte);
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           prodAttribute(dataelt, at, "0");
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
  void prodNote(EA.Element elt,EA.Connector con,string isabstract){
            if (RDFLAutilitaires.getPublishable(elt.StereotypeEx) < 2) return;//am mai 2020
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("production note pour" + elt.Name);
            long eid = 0;
      string pp = elt.Name;
      if (elt.ElementID == con.ClientID)
      {
          eid = con.SupplierID; // note is on the otherend of the notelink
      }
      else
      {
          eid = con.ClientID; // note is at the source end of the notelink
      }
      string note="";
      /****** pour test ******************
      string prov1 = repository.GetElementByID((int)eid).Name;
      string prov2 = repository.GetElementByID((int)eid).Notes;
      string prov3 = repository.GetElementByID((int)eid).ObjectType.ToString();
       * 
       ***********************************/
      switch(elt.Type)
      {
              /*
          case "Constraint" :
              if (eid != 0) note = "CONSTRAINT: " + repository.GetElementByID((int)eid).Name;
              break;
               * */
          case "Note" :
              note = repository.GetElementByID((int)eid).Notes;
              break;
          default:
              if (eid != 0)
              {
                  //18 if (RDFutilitaires.dicelembyid.ContainsKey(eid))
                 //18  {
                    //18   note = RDFutilitaires.dicelembyid[eid].Notes;
                  note = Main.Repo.GetElementByID((int)eid).Notes;
                  //18 }
                      /*
                  else
                  {
                      note = "CONSTRAINT :" +  repository.GetElementByID((int)eid).Name; // attention bricolage car je ne sais pas distinguer les contraintes
                  }
                       * */
              }
            break;
    
             }
      char[] pourtest = note.ToCharArray();
      string prov = note;
      if (note != "")
      {
          string texte = "<p class=\"note\">-" + brNote(note) + "</p>";
          ToDoc(texte, isabstract);
      }

  }
//------------------------
         
	void  prodPackage(long packid,string isabstract){
       
        // if a diagram exits and is not yet saved, it is then saved and refered to
        string prov = repository.GetPackageByID((int)packid).Name;
            /* ABA20230905
        if (prov == "AsynchronousMachineDynamics")
        {
            int a = 1;
        }*/
        EA.Collection dialcol = Main.Repo.GetPackageByID((int)packid).Diagrams;
        if (!(dialcol.Count > 0)) return;
                
        if (!dicPackim.ContainsKey(packid))
        {

            //   string  pathfile = ".\\" + (RDFutilitaires.dicpackbyid[packid]).Name + ".png";
            string packname = (Main.Repo.GetPackageByID((int)packid)).Name;
          //  MessageBox.Show(" prod " + packname);// pour test
            string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt");//".png";
            //string prempathfile = pathfile;
            //pathfile = nomrepimages + "\\" + packname + ".png";
           // dicPackim.Add(packid, prempathfile);


            {// image does not yet exists
               // EA.Collection dialcol = RDFutilitaires.dicpackbyid[packid].Diagrams;

                if (dialcol.Count > 0)
                {
                    string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;

                   // project.PutDiagramImageToFile(diagramguid, pathfile, 1);

                    for (short i = 0; i < dialcol.Count; i++)
                    {
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt");//".png";
                        if (i == 0) //am 2013
                        {
                            string prempathfile = Path.GetFileName(nomrepimages) + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt");// ".png";
                            dicPackim.Add(packid, prempathfile);
                        }
                        if (XMLP.GetXmlValueConfig("ImageExt") == ".emf")
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);
                        }
                        else
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        }
                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    }
                }
            }
        }
        try
        {
            string texte = "<p class=\"package\">";
            texte = texte + "<a href=\"" + dicPackim[packid] + "\"" + " target=\"_blanc" + "\">";
            texte = texte + (Main.Repo.GetPackageByID((int)packid)).Name + " </a></p>";
            ToDoc(texte, isabstract);
        }
        catch (Exception e)
        {
            MessageBox.Show("problem acces of dicPackim or dicPackid du package " + Main.Repo.GetPackageByID((int)packid).Name + "," +  e.Message);
        }

        
        }


//------------
        /// <summary>
        /// print a texte line in the correct buffer
        /// </summary>
        /// <param name="texte"></param>
        /// <param name="abstr"></param>
        ///  abstr=1  => 
        void ToDoc(string texte, string typbuf)
        {
            switch(typbuf) {
                case "1":  // typbuf=1 classe abstraite
                    sw.WriteLine(texte);
                    break;
 
                default:
            docfile.WriteLine(texte);
                    break;
            
            }
        }


//-----------------------------------------------
     List<EA.Attribute>  SortAttributesByName(EA.Collection col){
     List<EA.Attribute> retlist=new List<EA.Attribute>();
     
	Dictionary<string,EA.Attribute> dicAtrByName= new Dictionary<string,EA.Attribute>();
	foreach(EA.Attribute at in col){
	dicAtrByName.Add(at.Name,at);
	}

	Dictionary<string,EA.Attribute>.KeyCollection keysCol =dicAtrByName.Keys;
	string[] arkeys=new string[keysCol.Count];
	keysCol.CopyTo(arkeys,0);
	Array.Sort(arkeys);

	for(int i=0;i < arkeys.Length;i++){
	 retlist.Add(dicAtrByName[arkeys[i]]);		}
    return retlist;

 }
//-----------------------------------------------
     /// <summary>
     /// print a column for default value, fix value and factet
     /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void prodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         texte = "<td>";
         ToDoc(texte, isabstract);
            string constante=at.IsConst ? "constant=true":"";
            string statique=at.IsStatic ? "static=true" : "";
            string pardefaut = "DefaultValue=";
            if (at.IsConst || at.IsStatic)
            {
                pardefaut = "FixedValue=";
            }
            if (at.Default != "")
            {
                texte = "<p class=\"restriction\">" +  pardefaut + at.Default + "</p>";
                ToDoc(texte, isabstract);
            }

            if (at.Constraints.Count > 0)
            {
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    cont = ac.Notes;
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (contenu != "")
                    {
                        texte = "<p class=\"restriction\">" + " Constraint=" + contenu + "</p>";
                        ToDoc(texte, isabstract);
                    }
                }
            }
         texte="</td>";
         ToDoc(texte, isabstract);
 
     }
        //---
        /// <summary>
        /// recupere le type d'un element
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string getTypeElt(EA.Element el)
        {
            string ret="";
            if (el.StereotypeEx.Contains(CD.GetEnumStereotype())) ret = "enumeration";
            if (el.StereotypeEx.Contains("Enumeration")) ret = "enumeration";
            if (el.Type == "Enumeration") ret = "enumeration"; // am juin 2018
             if (el.MetaType == "Enumeration") //am janv 2018
            {
                ret= "enumeration";
            }
            if (el.StereotypeEx.Contains(CD.GetDatatypeStereotype())) ret = "datatype";
            if (el.StereotypeEx.Contains(CD.GetCompoundStereotype())) ret = "compound";
            if (el.StereotypeEx.Contains("datatype")) ret = "Datatype"; // legacy
            return ret;
        }
        /// <summary>
        /// print a column for default value, fix value and factet
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="at"></param>
        /// <param name="isabstract"></param>
        void prodClassConstraint(EA.Element elt,string isabstract)
        {
  
            string texte;
            foreach (EA.Constraint constr in elt.Constraints)
            {
                if (constr.Type =="Invariant")
                {
                   texte = "<p class=\"note\"><b>" + "constraint:</b>" + constr.Name + "={" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, isabstract);
                }
                if (constr.Type == "OCL")
                {
                    texte = "<p class=\"note\"><b>" + "OCL constraint:</b>" + constr.Name + "</p>";// +"={" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, isabstract);
                }
            }

        }
        //---

        //-------------------------------
        /// <summary>
        /// transform a string in an html string with linfeeds
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        string brNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
               {
                    if (ret.Contains("<ul>") || ret.Contains("</li>"))
                    {
                        ret = ret + split[i];// "<br/>" + split[i];
                    }
                    else
                    {
                        ret = ret + "<br/>" + split[i];
                    }
                }
                else
                {
                    if (split[i] == "<ul>\r")
                    {
                        ret=ret +  "<ul>";
                    }
                    else
                    {
                        ret = ret + split[i];
                    }
                  }
            }
            return ret;
        }
        
        //---------------------------------------
        //-------------------------
        public bool HasClassStereotype(EA.Element elt)
        {
            // MessageBox.Show("dans HasClassStereotype: Element=" + elt.Name + " stereotypeex=" + elt.StereotypeEx + "\n" + " subprofilestereotype" + subprofilestereotype);
            bool ret = false;
            // true if element 

            if (subprofilestereotype == "Class")
            {
                if ((elt.StereotypeEx == "") || (elt.StereotypeEx.Contains("Class")))
                {
                    ret = true;
                }

            }
            if (!subprofilestereotype.Contains(","))
            {
                if (elt.StereotypeEx.Contains(subprofilestereotype))
                {
                    ret = true;
                    foreach (string stereo in notclassestereos)
                    {
                        if (elt.StereotypeEx.Contains(stereo))
                        {
                            ret = false;
                            break;
                        }
                    }
                   
                }
            }
            else
            {
                ArrayList subprofslist = new ArrayList(subprofilestereotype.Split(new char[] { ',' }));

                RDFutilitaires.setper(subprofslist);
                for (int j = 0; j < RDFutilitaires.resulpermutation.Count; j++)
                {
                    string res = "";
                    for (int i = 0; i < ((ArrayList)RDFutilitaires.resulpermutation[j]).Count; i++)
                    {
                        res = res + (string)((ArrayList)RDFutilitaires.resulpermutation[j])[i] + ",";

                    }
                    res = res.Trim(',');
                    if (elt.StereotypeEx.Contains(res))
                    {
                        ret = true;
                        foreach (string stereo in notclassestereos)
                        {
                            if (elt.StereotypeEx.Contains(stereo))
                            {
                                ret = false;
                                break;
                            }

                        }
                       
                        break;
                    }
                }
            }
                if (ret == true)
                {
                    if (!dejatrouvee.Contains(elt.ElementID))
                    {
                        dejatrouvee.Add(elt.ElementID);
                    }
                    else
                    {
                        ret = false;
                    }
                }            
            return ret;
        }
        //------------------------
        public  bool HasNotClassStereotype(EA.Element elt)
        {
            string prov = elt.Name;
            bool ret = true;
            if (elt.StereotypeEx == "") ret = true;  // obvious
            foreach (string stereo in notpureclasses)
            {
                if (elt.StereotypeEx.Contains(stereo))
                {
                    ret = false;
                    break;
                }
            }
            //MessageBox.Show("hasnotclass elt=" + elt.Name + " , stereotypes=" + elt.StereotypeEx  + " => " + ret.ToString()); // pour test
            return ret;
        }
//---------------------
        string getAtrProfStereo(EA.Attribute atr){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {

                if (RDFLAutilitaires.StereoExContainsStereo(atr.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
        //---------------------
        string getEltProfStereo(EA.Element elt){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(elt.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
        //---------------------
        string getAssocProfStereo(EA.Connector con)
        {
            string ret = "";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(con.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
//----------------------------
        bool ThereIsLegitimateConnexion(EA.Element el,Dictionary<string, List<EA.Connector>> consubprofiles,string stereo)
        {
            bool ret=false;
            if (consubprofiles.ContainsKey(stereo) && consubprofiles[stereo].Count > 0)
            {
                foreach (EA.Connector con in consubprofiles[stereo])
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        string cardinality=getOtherEndCardinality(el, con);
                        EA.ConnectorEnd otherend = (ConnectorEnd)(RDFutilitaires.getOtherend(el, con)[0]);

                        if ((cardinality == "1") || (cardinality == "1..1") || (cardinality == "0..1") || (otherend.Navigable=="Navigable"))
                        {
                            ret = true;
                            break;
                        }
                    }
                }
            }
            return ret;
        }
        //----------------------

        string getOtherEndCardinality(EA.Element el, EA.Connector con)
        {
            string cardinality = "";
            if ((con.Type == "Association") || (con.Type == "Aggregation"))
            {
                EA.ConnectorEnd end=null;
                if (con.ClientID == el.ElementID) end = con.SupplierEnd;
                if (con.SupplierID == el.ElementID) end = con.ClientEnd;
                cardinality = end.Cardinality;
                string prov = end.Role; // pour test
            }
            return cardinality;
        }

        /****
        /// <summary>
        /// les stereosEx se prsentent sous la forme de listes de
        /// string.
        /// Ce programme redonne une chaine liste o tous les membres sont dans l'ordre alaphabtique
        /// </summary>
        /// <param name="stereos"></param>
        public string RedressStereo(string stereos){
            string ret ="";
            string[] ss = stereos.Split(',');
            List<string> lss = new List<string>(ss);
            lss.Sort();
            StringBuilder newstereos = new StringBuilder();
            foreach (string s in lss)
            {
                newstereos.Append( "," + s);
            }
            ret = newstereos.ToString().Trim(',');
            return ret ;
        }
        ****/ 
         
        /// <summary>
        /// les stereotype peuvent tre constitu d'une composition
        /// exemple "ShortCircuit,Entsoe"
        /// suivant la maniere dont on les range il faut les comparer
        /// </summary>
        /// <param name="stereos"></param>
        public bool CompareCompositeStereo(string stereo1, string stereo2)
        {

            if (stereo1.Length != stereo2.Length) return false;
            if (!stereo1.Contains(",") && !stereo2.Contains(",")) return stereo1 == stereo2;
            {// il s'agit bien de  chaines composees
                string[] ss1 = stereo1.Split(',');
                List<string> lss1 = new List<string>(ss1);
                lss1.Sort();
                string[] ss2 = stereo2.Split(',');
                List<string> lss2 = new List<string>(ss1);
                lss2.Sort();
                if (lss1.Count != lss2.Count) return false;
                for (int i = 0; i < lss1.Count; i++)
                {
                    if (lss1[i] != lss2[i]) return false;
                }
                return true;
            }
        }
        string removestereo(string stereo, string ss)
        {
            if(!ss.Contains(stereo)) return ss;
            int l = stereo.Length;
            int index = ss.IndexOf(stereo);
            return (ss.Remove(index, index)).Trim(',');
        }

        /**
        /// <summary>
        /// verifie si un StereoEx d'un element contient un stereo
        /// qui peutetre une chaine comme "Entsoe,ShortCircuit"
        /// </su<param name="stereo"></param>mmary>
        /// 
        /// <param name="stereoex"></param>
        /// <returns></returns>
        bool StereoExContainsStereo(string stereoex, string stereo)
        {
            bool ret = false;
            if (!stereo.Contains(","))
            {
                if (stereoex.Contains(stereo))
                {
                    ret = true;
                }
            }
            else
            {
                if (!stereoex.Contains(","))
                {
                    ret = false;
                }
                else
                {

                    stereo = RedressStereo(stereo);
                    stereoex = RedressStereo(stereoex);

                    if (stereoex.Contains(stereo))
                    {
                        ret = true;
                    }
                }
            }
            return ret;
        } 
          **/
        //--------------------------------
        void newprodAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.ConnectorEnd myend;
            EA.Element otherendelt;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable == "Navigable"))
                && myend.Navigable != "Navigable")
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                {// the association creates an effective memmber

                    string texte;


                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<th>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</th>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td class=\"type\">";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">";
                    ToDoc(texte, isabstract);
                    texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                    ToDoc(texte, isabstract);
                    texte = "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"comment\">" + brNote(otherend.RoleNote) + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "</tr>";
                    ToDoc(texte, isabstract);
                }
            }
        }
        //-----------------------------------
        string traitClassifierID(long classifierid)
        {
            string res = "";
            string texte="";
            string erreur = "!!classifier error!!";
            if ((classifierid == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            // attention dans certain cas un type non lie n'annule pas le ClassifierID
            {
               
                    res = erreur;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" warning attempt to treat a classifier which is 0, check that the types of your attributes are properly bound to a valid class");
              
            }
            else
            {
               //18  EA.Element claselt = RDFutilitaires.dicelembyid[classifierid];
                EA.Element claselt = Main.Repo.GetElementByID((int)classifierid);
               
                string type = getTypeElt(claselt);
                if (TypeList.ContainsKey(type))
                {
                    if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);
                }

                foreach (EA.Attribute at in claselt.Attributes)
                {
                    if ((at.ClassifierID == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
                    // attention dans certain cas un type non lie n'annule pas le ClassifierID
                    {
                        if ((at.ClassifierID == 0) && !(
                                                         (claselt.StereotypeEx.Contains(CD.GetEnumStereotype())
                                                           ||
                                                          (claselt.StereotypeEx.Contains("Enumeration")
                                                          ||
                                                          (claselt.Type=="Enumeration")
                                                        ))))
                        {
                            string prov = "classe=" + claselt.Name + " at=" + at.Name;
                            // ABA20240116 texte = erreur + "the classifiet is 0 for " + at.Name + " in classe=" + claselt.Name;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                        else
                        {
                           //18 if (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID))
                           //18 {
                                if ( !(
                                    (claselt.StereotypeEx.Contains(CD.GetEnumStereotype()))
                                    || (claselt.StereotypeEx.Contains("Enumeration"))
                                    || (claselt.Type=="Enumeration")
                                    )
                                    )
                                {
                                    string prov = "classe=" + claselt.Name + " at=" + at.Name;
                                    texte = erreur + "the classifier  for " + at.Name + " in classe=" + claselt.Name + " was not found";
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }
                            //18}
                        }
                        
                    }
                    else
                    {
                        //18 EA.Element clamelt = RDFutilitaires.dicelembyid[at.ClassifierID];
                        EA.Element clamelt = Main.Repo.GetElementByID((int)at.ClassifierID);
                        texte= traitClassifierID(at.ClassifierID);
                        if (texte == erreur)
                        {
                            texte = erreur + "the classifiet in 0 fot " + at.Name + " in classe=" + clamelt.Name;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                    
                    }
                }
            }

            if (res != erreur) { res = Main.Repo.GetElementByID((int)classifierid).Name; };
            return res;
        }
        //-------------------------------
    }
}
