using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using Microsoft.Win32;
using System.Reflection;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.HtmlGen
{

    class HtmlENTSOEDocumentation
    {

        StreamWriter reportlog;  //for logs


        string categorie = ""; // la categorie de la classe (stereo de classification)
        string nomfichier = ""; // file to write the documentation
	string nomrepimages=""; // directory for images for the documentation
        StreamWriter docfile;
        static List<EA.Element> ProfileClasses;
        static StringBuilder AbstractsBuffer = new StringBuilder();
        StringWriter sw = new StringWriter(AbstractsBuffer);    
        Dictionary <string,List<long>> TypeList;// string, elementID
        Dictionary <long,int> dicPackLevel;
        Dictionary<long, string> dicNoteforClass;
        ConstantDefinition CD = new ConstantDefinition();
	Dictionary<long,string> dicPackim;
  	  Repository repository;
	EA.Project project;
    List<string> notpureclasses;  // to be used by find predicates
    List<string> notclassestereos; // sterotypes of objects different from classes (ex: enumeration or datattype)
    string subprofilestereotype;  // to be used by find predicates
    List<string> SubprofilesStereos; // list of non cim stereotypes
    List<long> dejatrouvee;// liste des  classes deja traitee (evite de dupliquer les traitement de multiples stereotypes)
    List<string> newsections;// liste des sections crees dans le texte
    bool pourtest = false;
	XMLParser XMLP;
        private static string HTML_HEADER_FILE = @"DocHtmlIECHeader.txt";
        //-------------- ajour 2013 -----------------
    static string basesignet = "ESMP_"; // entete de signets
    static int rgtable = 0;
    static int rgfigure = 0;
    static long compteursgnt = 0; // compteur pour signet
        //-------------------------------------------
    static EA.Package ProfPack = null; // package of the profile

        //---------------------------------------------------------
        /// <summary>
        /// constructor with several initialisations
        /// </summary>
        public HtmlENTSOEDocumentation(EA.Repository repo)  // modif am 2013
        {
            repository = repo;
            CIMSchemaGenerator.Repos = repo; //pour test 
	    project = repository.GetProjectInterface();
        XMLP = new XMLParser(repository);

            EA.Package pack = repo.GetTreeSelectedPackage();
            ProfPack = pack;

            /************** pour test **********************
            //============================================
            ArrayList c = new ArrayList(){"Entsoe","ShortCircuit","operation"};
            RDFutilitaires.setper(c);
            string dump = "";
            string dumpit="";
            for (int i = 0; i < RDFutilitaires.resulpermutation.Count;i++ )
            {
                dumpit = "";
                for (int j = 0; j < ((ArrayList)RDFutilitaires.resulpermutation[i]).Count; j++)
                {
                    dumpit = dumpit + ((ArrayList)RDFutilitaires.resulpermutation[i])[j] + "|";                   
                }
                dump = dump + "{" + dumpit + "},";
            }
            MessageBox.Show("essai de permutation:" + dump);

            return;
            //============================================
            ************************************************/

               XMLP=new XMLParser(Main.Repo);
               if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
               {
                   string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                   string[] stereos = liststereos.Split(new char[] { '|' });
                   SubprofilesStereos = new List<string>(stereos);
               }
               else
               {
                   SubprofilesStereos = new List<string>();
               }

               SubprofilesStereos.Sort(RDFutilitaires.CompareStringsByLength);// assure qu'on traite les stereos composes en premier
               SubprofilesStereos.Reverse();

           

            try
            {
                //18 RegistryKey eaReg = Registry.CurrentUser.OpenSubKey("Software\\Sparx Systems\\EAAddins\\CimSyntaxGen");
                //string path = (string)eaReg.GetValue("RessourcesFolder");
                //string path = "";
                if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")
                {
                    nomfichier = XMLP.GetXmlValueProfData("HtmlDocumentationFilePath");
                    if ((nomfichier == null) || (nomfichier == "")) throw new Exception(" Error in the configfile for HtmlDocumentationFilePath ");
                }
                else
                {
                    nomfichier = RDFutilitaires.SelectFile("html");
                }

                //path = FileManager.GetParentDirPath(); // ABA20230830
                //path = path + "\\DocHtmlIECHeader.txt"; // modif am 2013
                //System.IO.File.Copy(path, nomfichier, true);
                Assembly myAssembly = Assembly.GetExecutingAssembly(); // ABA20230830
                Stream stream = myAssembly.GetManifestResourceStream("CimSyntaxGen.Resources." + HTML_HEADER_FILE);
                FileManager.CopyStream(stream, nomfichier);

                docfile = System.IO.File.AppendText(nomfichier);
                 string [] split = Path.GetFileName(nomfichier).Split(new char[]{'.'});

                 nomrepimages = Path.GetDirectoryName(nomfichier) + "\\" + split[0] + "_images";
 		if(Directory.Exists(nomrepimages)) Directory.Delete(nomrepimages,true);
		Directory.CreateDirectory(nomrepimages);
         //18 reportlog = new StreamWriter(Path.GetDirectoryName(nomfichier) + "\\" + split[0] +"log.txt");
        reportlog = Main.reportlog;
                //MessageBox.Show("le fichier de log est sur"+ nomfichier + "\\" + split[0] + "log.txt");  
                    RDFutilitaires.reportlog = reportlog;


                ProfileClasses = new List<EA.Element>();
                EA.Collection modellist = repo.Models;
                EA.Package toppack;
                toppack = null;
                foreach (EA.Package mod in modellist)
                {
                    toppack = mod;  // the root package
                    string prov = mod.Name;
                }

                RDFutilitaires.buildDicsElem(toppack);
     		dicPackim=new Dictionary<long,string>();
                dicPackLevel=new Dictionary<long,int>();

            //2014  AbstractsBuffer = new StringBuilder();
            //2014  sw = new StringWriter(AbstractsBuffer);
              TypeList= new Dictionary<string,List<long>>();
              TypeList.Add("datatype", new List<long>());
              TypeList.Add("enumeration", new List<long>());
              //TypeList.Add("Enumeration", new List<long>()); //am juin 2018
              TypeList.Add("compound", new List<long>());
              TypeList.Add("primitive", new List<long>());

            }         

            catch (Exception e)
            {
                MessageBox.Show("An exception occured while reading the DocHtmlIECHeader.txt :" + e.Message);
            }

        }
        public void 
            
            prodDoc(Repository repo)
         {

            EA.Package pack = repo.GetTreeSelectedPackage();
            // open body
            docfile.WriteLine("<body>");          
            buildDicPackLevel(pack,1); // build hierarchy
          
            //--------
            notpureclasses = new List<string>();
            notpureclasses.Add(CD.GetEnumStereotype());
           // notpureclasses.Add("Enumeration"); //am juin 2018
            notpureclasses.Add("Datatype");
            notpureclasses.Add(CD.GetDatatypeStereotype());
            notpureclasses.Add(CD.GetPrimitiveStereotype());
            notpureclasses.Add(CD.GetCompoundStereotype());
            
            foreach (KeyValuePair<long, int> kv in dicPackLevel)
            {
                prodDocPack(repo,repo.GetPackageByID((int)kv.Key),kv.Value);
            }
            /****************** global datatypes ****************************/
            traitTypeList(1);
            //--------
                //--------
                //end of file
                docfile.WriteLine("</body>");
                docfile.WriteLine("</html>");
                docfile.Flush();
                docfile.Close();
                // reportlog.Flush();
             //18  reportlog.Close(); //am 2014
            }
        
        public void prodDocPack(Repository repo,EA.Package pack,int level)
         {
              string prov1 = pack.Name; 
       	  List<EA.Element> PackClasses=new List<EA.Element>();
         // List<EA.Element> localDatatypes=new List<EA.Element>(); // for local datatypes 
          Dictionary<string, List<EA.Element>> diclocalDatatypes = new Dictionary<string, List<Element>>();
          newsections = new List<string>();
          List <EA.Element> packnotes=new List<EA.Element>();
          dejatrouvee = new List<long>();
            string texte = "";
            diclocalDatatypes = new Dictionary<string, List<EA.Element>>();
            diclocalDatatypes.Add("datatype", new List<EA.Element>());
            diclocalDatatypes.Add("enumeration", new List<EA.Element>());
            diclocalDatatypes.Add("compound", new List<EA.Element>());
            diclocalDatatypes.Add("primitive", new List<EA.Element>());
            /*****************  classify the elements    */
           foreach(EA.Element el in pack.Elements)
            {
             
             if(el.Type=="Class")
               {
                string isclass="class";
                 foreach(string stereo in notpureclasses)
                 {
                 if(el.StereotypeEx.Contains(stereo))
                    {
                    isclass=stereo.ToLower();
                    break;
                     }
                }
                 if (isclass == "class")
                 {
                     if (!PackClasses.Contains(el)) PackClasses.Add(el);
                 }
                 else
                 {

                     if (!diclocalDatatypes[isclass].Contains(el))
                     {
                         diclocalDatatypes[isclass].Add(el);
                     }
                 }
	    }else{
             if(el.Type=="Note")
               {
		if(!packnotes.Contains(el)) packnotes.Add(el);
		}
             }
	}
	/*********************  package header *****************************/

           texte = "<h" + level.ToString() + ">" + pack.Name + " </h" + level.ToString()+ "  >"; //am 2014
            ToDoc(texte, "0");
        
            texte =  "<h" + (level+1).ToString() + "  class=\"general\"" + ">" + " General " + " </h" + (level+1).ToString()+ "  >" ;
            ToDoc(texte, "0");
   	 texte = "<p class=\"myparagraph\">" + brNote(pack.Notes) + "</p>";
             ToDoc(texte, "0");
            prodDiagrams(pack);
             
           /****************  package elements ***************************/
           foreach(EA.Element elt in PackClasses)
                 {
                 string prov = elt.Name; // pour test
                if (prov == "PowerSystemResource")
                {
                    prov = "PowerSystemResource";
                }
                        prodClass(elt,level);
		}
            /********************  package datatypes **********************/
           foreach (string stereo in diclocalDatatypes.Keys)
           {
               foreach (EA.Element elt in diclocalDatatypes[stereo])
               {
                   if (stereo == "primitive")
                   {
                       newsection("Primitives", level +1);
                       prodPrimitive(elt, level + 2);
                       
                   }
                   if (stereo == "enumeration")
                   {
                       newsection("Enumerations", level + 1);
                       prodEnumeration(elt, level + 2);
                   }
                   if (stereo == "datatype")
                   {
                       newsection("Datatypes", level + 1);
                       prodDatatype(elt, level + 2);
                   }
                   if (stereo == "compound")
                   {
                       newsection("Compounds", level + 1);
                       prodCompoundtype(elt, level + 2);
                   }
               }

           }
           
                //end of file
                docfile.Flush();
                // reportlog.Flush();
                //docfile.Close();
                //reportlog.Close();
            
            }


        
        /// <summary>
        /// production of documentation for a class
        /// </summary>
        /// <param name="elt"></param>
        void prodClass(EA.Element elt,int level)
        {
            string prov = elt.Name;
            if (elt.Name == "PowerSystemResource")
            {
                prov = elt.Name;
            }
            // MessageBox.Show("class= " + elt.Name + " | " + elt.ElementID + "|" + elt.StereotypeEx); //pour test
            string texte = "";
            texte = "<div id=\"" + elt.Name + "\" class=\"group\">";
            // texte = "<div  class=\"group\" align=\"center\">";
            ToDoc(texte, "0");
            texte = "<a name=" + elt.Name + "></a>";
            // ToDoc(texte, elt.Abstract);
            ToDoc(texte, "0");
            categorie = getEltProfStereo(elt); //am nov 15
            if(elt.Abstract=="1")
            {
                // categorie = getEltProfStereo(elt); //am nov 15
                string marqueabstract="";
                if(!elt.StereotypeEx.Contains("Abtract")) marqueabstract="(Abstract)"; // juin 2014
                categorie = categorie != "" ? " (" + categorie + ") ":"";
                texte =  "<h" + (level+1).ToString()+ " class=\"abstract\"  align=\"left\">" + categorie +  elt.Name + marqueabstract + " </h" + (level+1).ToString()+ "  >";
                docfile.WriteLine(texte);
            }else{
                categorie = categorie != "" ? " (" + categorie + ") " : ""; //am nov 15
                texte = "<h" + (level+1).ToString()+ " class=\"concrete\">" +  categorie +  elt.Name + " </h" + (level+1).ToString()+ "  >";
                docfile.WriteLine(texte);
            }
    

            texte = "<p class=\"myparagraph\">" + brNote(elt.Notes) + "</p>";
            // ToDoc(texte, elt.Abstract);
            ToDoc(texte, "0");
        
            //-----------new am
            prodClassConstraint(elt,elt.Abstract);
            //----------------
            if (elt.Connectors.Count > 0)
            {
                bool thereisnote=false;
                foreach (EA.Connector con in elt.Connectors)
                {
                     if (con.Type == "NoteLink")
                     {
                         if (!thereisnote)
                         {
                             thereisnote = true;
                             texte = "<p class=\"myparagraph\">";
                             ToDoc(texte, "0");

                         }
                         
                         prodNote(elt, con,"0");
                         if (thereisnote)
                         {
                            texte = "</p>";
                            ToDoc(texte, "0");
                         }
                     }
                }

            }
        
        
            /******** production des diagrammes de classe ********************/
            prodClassDiags(elt);
            /***************************************************************/
            List<long> atrids = new List<long>();
            /**********************
            *   natives attributes
            **********************/
           /************** is it an inherited class? ***************/

    		List<long> lmotherselid =new List<long>();
            RDFutilitaires.GetMothersClass(elt.ElementID, lmotherselid );
            bool inheritedclass=false;
            EA.Element mel;

            if (lmotherselid.Count > 0)
            {
                inheritedclass=true;
                if (XMLP.GetXmlValueConfig("EntsoeKeepInheritancePath") == "Checked")
           		{
                    texte = "<p class=\"myparagraph\">" + "Inheritance path: " + RDFutilitaires.GetInheritancePath(repository, elt.ElementID, lmotherselid)  + "</p>";
                    // ToDoc(texte, elt.Abstract);
                    ToDoc(texte, "0");
			    }
            }
            bool tablewriten=false;
            /************  members attributes  ***************/
            if (elt.AttributesEx.Count > 0)
			{
                tablewriten=true;
                //-------------------- ajout am  aout 2014  --------------------------------- 
                texte = "<p  class=\"myparagraph\">" + " !#" + " shows all attributes of " + elt.Name + "." + "</p>";
                // ToDoc(texte, elt.Abstract);
                ToDoc(texte, "0");
                texte = "<p align=\"center\" class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
                string nompa = repository.GetPackageByID(elt.PackageID).Name;
                texte = texte + " -" + " Attributes of " + nompa + "::" + elt.Name; // +".";
                texte = texte + "</p>";
                // ToDoc(texte, elt.Abstract);
                ToDoc(texte, "0");
                //-----------------------------------------------------------------------------
                texte = "<table align=\"center\" style=\"border-collapse: collapse\">";                                   
                // ToDoc(texte, elt.Abstract);
                ToDoc(texte, "0");
                prodAttributeEntete("0");
                foreach(EA.Attribute at in elt.Attributes)
                    // prodAttribute(elt, at, elt.Abstract);
                {
    			    prodAttribute(elt, at, "0");
                }
                if(inheritedclass)
                {
                    foreach (long id in lmotherselid)
                    {
                        //18 mel = RDFutilitaires.dicelembyid[id];
                        mel = Main.Repo.GetElementByID((int)id);
                        foreach (EA.Attribute att in mel.Attributes)
                        {
                            //prodInheritedAttribute(mel, att,elt.Abstract);
	                        prodInheritedAttribute(mel, att,"0");
                        }
                    }
				}
                
                if(tablewriten)
                {
			        texte="</table>";
                    ToDoc(texte,"0");
                }   

                /********************  associations ************************/
             	tablewriten=false;
                //bool tableentetewriten = false;                          	
                List<EA.Connector> eligiblecons=new List<EA.Connector>();
                foreach(EA.Connector con in elt.Connectors)
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        if(!eligiblecons.Contains(con)) eligiblecons.Add(con);                     
                    }
			    }  

                if(eligiblecons.Count > 0)
		        {
                    foreach(EA.Connector co in eligiblecons)
                    {
                     	prodAssoc(elt, co,ref tablewriten, "0");  
					}             
                }
        
       			/**********************
      			*   inherited  associations
   				**********************/
                if(inheritedclass)
                {
                    Dictionary<EA.Connector,EA.Element> eligibleinheritedcons=new Dictionary<EA.Connector,EA.Element>();
                    foreach (long id in lmotherselid)
                    {
                        //18  mel = RDFutilitaires.dicelembyid[id];
                        mel = Main.Repo.GetElementByID((int)id);
                        prov = mel.Name;
                        foreach(EA.Connector con in mel.Connectors)
				        {
                            if ((con.Type == "Association") || (con.Type == "Aggregation"))
                            {
                                if(!eligibleinheritedcons.ContainsKey(con)) eligibleinheritedcons.Add(con,mel);                 
                            }
                        }
                    }

			        if(eligibleinheritedcons.Keys.Count > 0)
                    {                        
                       foreach(EA.Connector c in eligibleinheritedcons.Keys)
                       {
                           // prodInheritedAssoc(mel,con,elt.Abstract);
                           prodInheritedAssoc(eligibleinheritedcons[c],c,ref tablewriten,"0");
                       }
                    }
                }
                          
                if(tablewriten)
                {
                    texte = "</table>";
                    // ToDoc(texte, elt.Abstract);
                    ToDoc(texte, "0");
                }
            }
            texte = "</div>";
            ToDoc(texte, "0");
        }
        

//---------------
        void prodAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            // MessageBox.Show("at.name=" + at.Name + " at.type=" + at.Type + " at.notes=" + at.Notes);
            string texte;
            texte="<tr>";
            ToDoc(texte,isabstract);
            texte="<th>";
	        ToDoc(texte,isabstract);
            categorie = getAtrProfStereo(at) != "" ?  getAtrProfStereo(at) : (getEltProfStereo(elt)!="" ? getEltProfStereo(elt) : ""); // on cascade le stereotype d'attribut et de classe
            categorie = categorie != "" ? " (" + categorie + ") " : "";
            texte =  at.Name + " " + categorie ;
            ToDoc(texte,isabstract);
            texte="</th>";
	        ToDoc(texte,isabstract);
            texte="<td>";
            ToDoc(texte,isabstract);
            texte= at.LowerBound + ".." + at.UpperBound ;
            ToDoc(texte,isabstract);
            texte="</td>";
            ToDoc(texte,isabstract);
            texte="<td class=\"type\">";
            ToDoc(texte,isabstract);
            texte="<p class=\"type\">";
            ToDoc(texte,isabstract);
            if (
                 !(
                    (elt.StereotypeEx.Contains(CD.GetEnumStereotype())) //am juin 2018
                    || (elt.StereotypeEx.Contains("Enumeration"))
                    || (elt.Type=="Enumeration")
                   )
                )
            {
                 if (at.ClassifierID == 0)
                 {
                     // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error classifier=0 for attribute " + at.Name + " in " + elt.Name);
                 }
            }
            texte = traitClassifierID(at.ClassifierID);
   
            if (XMLP.GetXmlValueConfig("EntsoeKeepHyperlinks") == "Checked")
            {
                 texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
            }
   
	        ToDoc(texte,isabstract);
            texte="</p>";
	        ToDoc(texte,isabstract);
            texte="</td>";
            texte="<td>";
	        ToDoc(texte,isabstract);
   
            if (at.ClassifierID != 0)
            {
                string prov = "";

            if(elt.Name== "ActivePower")
            {
                 prov=elt.Name;
            }
     
            prov = elt.Name + "|" + repository.GetElementByID((int)at.ClassifierID).Name + "|" + repository.GetElementByID((int)at.ClassifierID).Stereotype;
            if(at.Default != "")
            {
                 if (at.IsConst)
                 {
                     texte = " ConstantValue=";
                 }
                 else
                 {
                     texte = " DefaultValue=";
                 }
                 string initval = at.Default;
                 if(initval.Contains("http") )// il s'agit d'une reference
                 {
                     initval="<a href=\"" + initval + "\"><font color=\"#0000ff\"><u>" + initval + "</u></font></a>";
                 }
                 texte = texte + " " + initval + " <br/>";
                 ToDoc(texte, isabstract);
            }
        }
        texte = brNote(at.Notes);
	    ToDoc(texte,isabstract);
        texte="</td>";
	    ToDoc(texte,isabstract);

        texte="</tr>";
	    ToDoc(texte,isabstract);
    } // end of prodAttribute

//-------------------------------

        void prodInheritedAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            string texte;
texte="<tr>";
	 ToDoc(texte,isabstract);
texte="<th>";
	 ToDoc(texte,isabstract);
     string stereo = getAtrProfStereo(at);
     if (stereo == "")
     {
        // texte = "<p class=\"inheritattribut\">" + at.Name + " </p>";
         texte =  at.Name ;
     }
     else
     {
         //texte = "<p class=\"inheritattribut\">" + at.Name + " (" + stereo + ") " + " </p>";
         texte =  at.Name + " (" + stereo + ") " ;
     }
	 ToDoc(texte,isabstract);
texte="</th>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p class=\"cardinality\">" + at.LowerBound + ".." + at.UpperBound + "</p>";
  texte=at.LowerBound + ".." + at.UpperBound ;
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td class=\"mytable-cell\">";
          
	 ToDoc(texte,isabstract);
//texte="<p class=\"type\">";
   //texte = "<p class=\"mytable-cell\">";//am
	 //ToDoc(texte,isabstract);
     if ((at.ClassifierID == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
{
texte=at.Type;
}else{
    texte = Main.Repo.GetElementByID((int)at.ClassifierID).Name;
}
     if (XMLP.GetXmlValueConfig("EntsoeKeepHyperlinks") == "Checked")
     {
         texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
     }
     
	 ToDoc(texte,isabstract);
//texte="</p>";
	// ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
     //texte = at.Notes + "<br/>";
     texte = "see " + elt.Name; //am
     if (XMLP.GetXmlValueConfig("EntsoeKeepHyperlinks") == "Checked")
     {
         texte = "see <a class=\"mytable-cell\" href=\"#" + elt.Name + "\">" + elt.Name + "</a>";
     }
     
	 ToDoc(texte,isabstract);
//texte="</p>";
	// ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="</tr>";
	 ToDoc(texte,isabstract);
        }
//------------------------------------------
   void prodAssocEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            //texte = "<p class=\"name\" >" + "Name" + " </p>";
            texte =  "mult.";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            //texte = "<p class=\"name\" >" + "Role" + " </p>";
            texte = "mult." ;
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
           //texte = "<p class=\"name\" >" + "Class type name" + " </p>";
            texte =  "Class type name";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
          // texte = "<p class=\"name\" >" + "Description" + " </p>";
            texte = "Description" ;
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "</tr>";
            ToDoc(texte, isabstract);

        }
//-------------------------------
   void prodAssoc(EA.Element elt, EA.Connector con, ref  bool  tablewriten, string isabstract)
   {

       CIMSchemaGenerator.ConexesID = 0;
       /***********************************************************/
       string pp = con.Type;
       CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
       EA.ConnectorEnd otherend;
       EA.ConnectorEnd myend;
       EA.Element otherendelt;
       string texte = "";
       if (connex.Source_element.ElementID == elt.ElementID)
       {// the element is the Source
           otherend = connex.Target;
           otherendelt = connex.Target_element;
           myend = connex.Source;
       }
       else
       {
           otherend = connex.Source;
           otherendelt = connex.Source_element;
           myend = connex.Target;
       }

       string cardinality = otherend.Cardinality;
       bool eligible = false;
       if (cardinality == "1") cardinality = "1..1";
       if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable == "Navigable"))
           && (myend.Navigable != "Navigable"))
       {// the other end is eligible as member
           eligible = true;
       }
       if (eligible && (otherend.Role != ""))
       {
           {// the association creates an effective memmber

               if (!tablewriten)
               {
                   tablewriten = true;
                 
                   //------------  ajout am aout 2014
                   texte = "<p  class=\"myparagraph\">" + " !#" ;
                   texte = texte + " shows all association ends of " + elt.Name + " with other classes.";
                   texte = texte + "</p>";
                   //ToDoc(texte, elt.Abstract);
                   ToDoc(texte, "0");
                   texte = "<p align=\"center\" class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>" ;
                   string nompa = repository.GetPackageByID(elt.PackageID).Name;
                   texte = texte + " -" + " Association ends of " + nompa + "::" + elt.Name + " with other classes" ;  //+".";
                   texte = texte + "</p>";
                   //ToDoc(texte, elt.Abstract);
                   ToDoc(texte, "0");

                   //-----------------------------------------------------------------------------  
                   texte = "<table align=\"center\" style=\"border-collapse: collapse\">";
                   ToDoc(texte, "0");
                   prodAssocEntete("0");
               }
               texte = "<tr>";
               ToDoc(texte, isabstract);



               texte = "<td class=\"type\">";
               ToDoc(texte, isabstract);
              // texte = "<p class=\"type\">";
              // ToDoc(texte, isabstract);
                texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
               categorie = getAssocProfStereo(con);
               if (categorie == "")
               {
                   categorie = getEltProfStereo(elt) != "" ? getEltProfStereo(elt) : "";
               }
               categorie = categorie != "" ? " (" + categorie + ") " : "";
               //texte = "<p class=\"role\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
               texte =  otherend.Role  + categorie ;
               ToDoc(texte, isabstract);
               //texte = "</p>";
              // ToDoc(texte, isabstract);
               texte = "</td>";
               ToDoc(texte, isabstract);
               texte = "<td>";
               ToDoc(texte, isabstract);
             //  texte = "<p class=\"cardinality\">" + "[" + cardinality + "]" + "</p>";
               texte =  "[" + cardinality + "]" ;
               ToDoc(texte, isabstract);
               texte = "</td>";
               ToDoc(texte, isabstract);
               texte = "<td>";
               ToDoc(texte, isabstract);
               texte = otherendelt.Name;
               // texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
               if (XMLP.GetXmlValueConfig("EntsoeKeepHyperlinks") == "Checked")
               {
                    texte = "<p class=\"table-cell\"><a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a></p>";   
               }
                   // texte = "<p class=\"table-cell\">" + otherendelt.Name ;
             
               ToDoc(texte, isabstract);
               texte = "</td>";
               ToDoc(texte, isabstract);
               texte = "<td>";
               ToDoc(texte, isabstract);
              // texte = "<p class=\"myparagraph\">" + brNote(otherend.RoleNote) + "</p>";
               texte =  brNote(otherend.RoleNote) ;
               ToDoc(texte, isabstract);
                   texte = "<br/>";
                    ToDoc(texte, isabstract);
                    texte = " Association Based On : " + "<br/>";
                    ToDoc(texte, isabstract);
                   // texte = prodAssocIsBasedOn(repository, con)[0]+ "<br/>";
                    texte = brNote(prodAssocIsBasedOn(repository, con)[0]); 
                    ToDoc(texte, isabstract);
                    texte =  "\t\t-----" + "<br/>";
                    ToDoc(texte, isabstract);
                    texte =  prodAssocIsBasedOn(repository, con)[1] + "</p>";
                    ToDoc(texte, isabstract);
               texte = "</td>";
               ToDoc(texte, isabstract);
               texte = "</tr>";
               ToDoc(texte, isabstract);
           }
       }
       /* ********************/
   }
        //-------------------------------
        void prodInheritedAssoc(EA.Element elt, EA.Connector con, ref bool tablewriten, string isabstract)
        {
            string prov = elt.Name;
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.Element otherendelt;
            EA.ConnectorEnd myend;
            
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
                
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable=="Navigable"))
                && (myend.Navigable != "Navigable"))
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                if (!tablewriten)
                {
                    tablewriten = true;
                    string text = "";
                    //------------  ajout am aout 2014
                     text = "<p  class=\"myparagraph\">" + " !#";
                    text = text + " shows all association ends of " + elt.Name + " with other classes.";
                    text = text + "</p>";
                    //ToDoc(text, elt.Abstract);
                    ToDoc(text, "0");
                    text = "<p align=\"center\" class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
                    string nompa = repository.GetPackageByID(elt.PackageID).Name;
                    text = text + " -" + " Association ends of " + nompa + "::" + elt.Name + " with other classes";  //+".";
                    text = text + "</p>";
                    //ToDoc(text, elt.Abstract);
                    ToDoc(text, "0");

                    //-----------------------------------------------------------------------------  
                    text = "<table align=\"center\" style=\"border-collapse: collapse\">";
                    ToDoc(text, "0");
                    prodAssocEntete( "0");
                }
                string texte;
                texte = "<tr>";
                ToDoc(texte, isabstract);
                texte = "<th>";
                ToDoc(texte, isabstract);
                string stereo = getEltProfStereo(elt);
                categorie = getAssocProfStereo(con);
                categorie = categorie != "" ? " (" + categorie + ") " : ""; 
                if (stereo == "")
                {
                    
                    //texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                    //texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
                   // texte =  elt.Name + "." + otherend.Role + categorie ;
                    texte = otherend.Role;
                }
                else
                {
              //texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                    if (categorie != "")
                    {
                        //texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie + "</p>";
                       // texte = elt.Name + "." + otherend.Role + "\">" + otherend.Role + categorie ;
                        texte = otherend.Role + categorie;
                    }
                    else
                    {
                        //texte = "<p class=\"inheritrole\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                        texte = otherend.Role + " (" + stereo + ")" ;
                    }
                }
                    ToDoc(texte, isabstract);
                texte = "</th>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
               // texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                texte =  cardinality ;
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td class=\"type\">";
                ToDoc(texte, isabstract);
                //texte = "<p class=\"type\">";
                //texte = "<p class=\"mytable-cell\">";
                //ToDoc(texte, isabstract);
                texte = otherendelt.Name;
                if (XMLP.GetXmlValueConfig("EntsoeKeepHyperlinks") == "Checked")
                {
                     texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                }
                
                ToDoc(texte, isabstract);
               // texte = "</p>";
                //ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
            //    texte = "<td>";  // DOIT ON ECRIRE LA NOTE du role?
              //  ToDoc(texte, isabstract);
//                texte = "<p class=\"comment\">" + otherend.RoleNote + "</p>";
              //  texte = otherend.RoleNote ;

//                ToDoc(texte, isabstract);
              //  texte = "</td>";
               // ToDoc(texte, isabstract);
texte="<td>";
	 //ToDoc(texte,isabstract);
//texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name  + "\">" + elt.Name + "</a>";
     //texte = "<p class=\"mytable-cell\" >see " + elt.Name; //am
    // texte = "see " + elt.Name; //am
	 //ToDoc(texte,isabstract);
//	 ToDoc(texte,isabstract);
     ToDoc(texte, isabstract);
     texte = "<br/>";
     ToDoc(texte, isabstract);
     texte = " Inherited Association Based On : " + "<br/>";
     ToDoc(texte, isabstract);
     texte = prodAssocIsBasedOn(repository, con)[0] + "<br/>";
     ToDoc(texte, isabstract);
     texte = "\t\t-----" + "<br/>";
     ToDoc(texte, isabstract);
    // texte = prodAssocIsBasedOn(repository, con)[1] + "</p>";
     texte = brNote(prodAssocIsBasedOn(repository, con)[1]) + "</p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

                texte = "</tr>";
                ToDoc(texte, isabstract);
            }
        }
//------------
   void prodEnumeration(EA.Element enumelt,int level){
       
    //  MessageBox.Show(" enumeration " + enumelt.Name);// pour test
       string texte = "";
       string prov = removestereo(CD.GetEnumStereotype(),enumelt.Name);
//texte="<div id=\"" + enumelt.Name +"(" +  prov + ")" + "\" class=\"group\">";
//texte = "<div id=\"" + enumelt.Name + "\" class=\"group\">";
       texte = "<div class=\"group\">";
               docfile.WriteLine(texte);
       texte="<A name=" + enumelt.Name + "></A>";
       docfile.WriteLine(texte);
//texte="<a href=\"#" + enumelt.Name + "\">";
    //           docfile.WriteLine(texte);
//texte="<h2 class=\"enumerated\">" + enumelt.Name + "</h2>";
               texte = "<h" + level.ToString() + ">" + 
                   //"(" + CD.GetEnumStereotype() + ")" +
                    enumelt.Name + " </h" + level.ToString() + "  >"; //am 2014
               ToDoc(texte, "0");
        
//texte="</a>";
              // docfile.WriteLine(texte);
//texte="<p class=\"package\">"+ (RDFutilitaires.dicpackbyid[enumelt.PackageID]).Name + "</p>";
     //          docfile.WriteLine(texte);
	//	prodPackage(enumelt.PackageID,"0");
//texte="<p class=\"comment\">" + brNote(enumelt.Notes) + "</p>";
texte="<p class=\"myparagraph\">" + brNote(enumelt.Notes) + "</p>";
               docfile.WriteLine(texte);
texte="<table align=\"center\" style=\"border-collapse: collapse\">";
               docfile.WriteLine(texte);
               prodEnumEntete("0");
	foreach(EA.Attribute at  in enumelt.Attributes){
	prodMember(enumelt,at);
		}
texte="</table>";
               docfile.WriteLine(texte);
texte="</div>";
               docfile.WriteLine(texte);

}
   //------------
   void prodPrimitive(EA.Element enumelt, int level)
   {

       //  MessageBox.Show(" enumeration " + enumelt.Name);// pour test
       string texte = "";
       string prov = removestereo(CD.GetEnumStereotype(), enumelt.Name);
      // texte = "<div id=\"" + enumelt.Name + "\" class=\"group\">";
       texte = "<div  class=\"group\">";
       docfile.WriteLine(texte);
       texte = "<A name=" + enumelt.Name + "></A>";
       docfile.WriteLine(texte);
       texte = "<h" + level.ToString() + ">"   //+ "(" + CD.GetEnumStereotype() + ")"
           + enumelt.Name + " </h" + level.ToString() + "  >"; //am 2014
       ToDoc(texte, "0");

 
       //texte="<p class=\"package\">"+ (RDFutilitaires.dicpackbyid[enumelt.PackageID]).Name + "</p>";
       //          docfile.WriteLine(texte);
       //	prodPackage(enumelt.PackageID,"0");
     
       texte = "<p class=\"myparagraph\">" + brNote(enumelt.Notes) + "</p>";
       docfile.WriteLine(texte);
     
       texte = "</div>";
       docfile.WriteLine(texte);

   }
   //------------
   void prodDatatype(EA.Element dataelt,int level)
   {
       //MessageBox.Show("datatype= " + dataelt.Name);// pour test
       string texte = "";
     //  texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
      // docfile.WriteLine(texte);
      // texte = "<a href=\"#" + dataelt.Name + "\">";
      // docfile.WriteLine(texte);
       //texte = "<h2 class=\"datatype\">" + dataelt.Name + "</h2>";
       //docfile.WriteLine(texte);
      // texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
       texte = "<div class=\"group\">";
       docfile.WriteLine(texte);
       texte = "<A name=" + dataelt.Name + "></A>";
       docfile.WriteLine(texte);
       texte = "<h" + level.ToString() + ">" +
           //"(" + CD.GetDatatypeStereotype() + ")" + 
           dataelt.Name  +" </h" + level.ToString() + "  >"; //am 2014
       ToDoc(texte, "0");
       //texte = "</a>";
      // docfile.WriteLine(texte);

 //      texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
 //      docfile.WriteLine(texte);
	//	prodPackage(dataelt.PackageID,"0");
    // texte = "<p class=\"myparagraph\">" + brNote(dataelt.Notes) + "</p>";
         texte = brpNote(dataelt.Notes); 
       docfile.WriteLine(texte);
       if (dataelt.Connectors.Count > 0)
       {
           foreach (EA.Connector con in dataelt.Connectors)
           {
               if (con.Type == "NoteLink")
               {
                   prodNote(dataelt, con, "0");
               }


           }

       }

       //-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       texte = texte + "</p>";
       docfile.WriteLine(texte);
       
       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name+ ".";
       texte = texte + "</p>";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<table align=\"center\" style=\"border-collapse: collapse\">";
       docfile.WriteLine(texte);
       prodAttributeEntete("0");
       foreach (EA.Attribute at in dataelt.Attributes)
       {
          // MessageBox.Show("datatype.name=" + dataelt.Name + " | at.name=" + at.Name + " | at.type=" + at.Type + " | at.notes=" + at.Notes);
      
           prodAttribute(dataelt, at, "0");
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
 //------------
   void prodMember(EA.Element enumelt,EA.Attribute at)
   {
  docfile.WriteLine( "<tr>");
docfile.WriteLine("<th>");
docfile.WriteLine("<p class=\"name\">" + at.Name +  "</p>");
docfile.WriteLine("</th>");
docfile.WriteLine("<td>");
//docfile.WriteLine("<p class=\"comment\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("<p class=\"myparagraph\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"myparagraph\">" + at.Default + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("</tr>");


   }
//------------
   void prodCompoundtype(EA.Element dataelt,int level)
   {
      // MessageBox.Show(" compound =" + dataelt.Name);
       string texte = "";
       texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
       docfile.WriteLine(texte);
       texte = "<A name=" + dataelt.Name + "></A>";
       docfile.WriteLine(texte);

       //texte = "<h2 class=\"enumerated\">" + dataelt.Name + "</h2>";
       //docfile.WriteLine(texte);
       texte = "<h" + level.ToString() + ">" +
           //"(" + CD.GetCompoundStereotype() + ")" + 
           dataelt.Name 
           + " </h" + level.ToString() + "  >"; //am 2014
       ToDoc(texte, "0");
       
      // texte = "</a>";
      // docfile.WriteLine(texte);
  //     texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
     //  docfile.WriteLine(texte);
	//	prodPackage(dataelt.PackageID,"0");
      // texte = "<p class=\"comment\">" + brNote(dataelt.Notes) + "</p>";
          texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);
//-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       texte = texte + "</p>";
       docfile.WriteLine(texte);
       
       texte = "<p align=\"center\" class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name + ".";
       texte=texte+"</p>";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<table style=\"border-collapse: collapse\">";
       docfile.WriteLine(texte);
       prodAttributeEntete("0");
       foreach (EA.Attribute at in dataelt.Attributes)
       {
         
           prodAttribute(dataelt, at, "0");
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
  void prodNote(EA.Element elt,EA.Connector con,string isabstract){
      long eid = 0;
      if (elt.ElementID == con.ClientID)
      {
          eid = con.SupplierID; // note is on the otherend of the notelink
      }
      else
      {
          eid = con.ClientID; // note is at the source end of the notelink
      }
      string note="";
      if(eid != 0){
      //18 if(RDFutilitaires.dicelembyid.ContainsKey(eid)) {
            note=Main.Repo.GetElementByID((int)eid).Notes;
      //18 }
      }
      char[] pourtest = note.ToCharArray();
      string prov = note;

      //string texte="<p class=\"myparagraph\">-" + note + "</p>";
             string texte = note;
               ToDoc(texte, isabstract);

  }
//------------------------
         
	void  prodPackage(long packid,string isabstract){
       
        // if a diagram exits and is not yet saved, it is then saved and refered to
        string prov = repository.GetPackageByID((int)packid).Name;
       
        EA.Collection dialcol = Main.Repo.GetPackageByID((int)packid).Diagrams;
        if (!(dialcol.Count > 0)) return;
                
        if (!dicPackim.ContainsKey(packid))
        {
            string packname = (Main.Repo.GetPackageByID((int)packid)).Name;
           // string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + ".png";
            string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
            {// image does not yet exists
                if (dialcol.Count > 0)
                {
                    string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;
                    for (short i = 0; i < dialcol.Count; i++)
                    {
                       // pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
                        if (i == 0) //am 2013
                        {
                           // string prempathfile = Path.GetFileName(nomrepimages) + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                            string prempathfile = Path.GetFileName(nomrepimages) + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
                            dicPackim.Add(packid, prempathfile);
                        }
                        if (XMLP.GetXmlValueConfig("ImageExt") == ".emf")
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);
                        }
                        else {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        }


                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    }
                }
            }
        }
        try
        {
            string texte = "<p class=\"package\">";
            texte = texte + (Main.Repo.GetPackageByID((int)packid)).Name + "</p>";
            ToDoc(texte, isabstract);
	   // texte = "<p class=\"myparagraph\">" + brNote(pack.Notes) + "</p>";
        //     ToDoc(texte, elt.Abstract);

	   prodDiagrams(Main.Repo.GetPackageByID((int)packid));

        }
        catch (Exception e)
        {
            MessageBox.Show("problem acces of dicPackim or dicPackid du package " + Main.Repo.GetPackageByID((int)packid).Name + "," +  e.Message);
        }

        
        }


//------------
    //------------------------
/// <summary>
/// production des diagrammes propres  une classe
/// </summary>
/// <param name="packid"></param>
/// <param name="isabstract"></param>
    void prodClassDiags(EA.Element elt)
    {
        string pathfile = ""; // le chemin vers une image
        string packname = "";
        string texte = "";
        if (XMLP.GetXmlValueConfig("EntsoeKeepClassDiagrams") != "Checked")
        {
            return;
        }
        try
        {
            packname = (Main.Repo.GetPackageByID((int)elt.PackageID)).Name;
        }
        catch (Exception e)
        {
            MessageBox.Show("problem acces of  dicPackid du package " + Main.Repo.GetPackageByID((int)elt.PackageID).Name + "," + e.Message);
        }
        EA.Collection dialcol = elt.Diagrams;

        if (dialcol.Count > 0)
        {
            string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;

            // project.PutDiagramImageToFile(diagramguid, pathfile, 1);

            for (short i = 0; i < dialcol.Count; i++)
            {
                pathfile = nomrepimages + "\\" + packname + "_" + elt.Name + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".bmp";

                project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
            }
        }
        foreach (EA.Diagram diag in elt.Diagrams)
        {
            docfile.WriteLine("<p class=\"myparagraph\">!#  class diagram</p> ");
            docfile.WriteLine("<p  align=\"center\" >"); // pour que l'image prenne le style figur class=\"myfigure\"
            texte = "<img src=\"" + nomrepimages + "\\" + packname + "_" + elt.Name + "_" + diag.Name + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">"; // class=\"myfigure\"
            ToDoc(texte, "0");
            docfile.WriteLine("</p>");
            docfile.WriteLine("<p class=\"myparagraph\">  </p>"); // une ligne sous la figure
            docfile.WriteLine("<p align=\"center\" class=\"myfigure-title\">" + addSignetFigure() + "Figure" + " !#</a>  - figure " + diag.Name + "</p>");
            //-----------   ajout mar 2014  ------------------------------
            texte = "<p class=\"myparagraph\">" + brNote(diag.Notes) + "</p>";
            // ToDoc(texte, elt.Abstract);
            ToDoc(texte, "0");
            //repository.CloseDiagram(diag.DiagramID);
            //------------------------------------------------------------
        }
    }
    //------------
        /// <summary>
        /// print a texte line in the correct buffer
        /// </summary>
        /// <param name="texte"></param>
        /// <param name="abstr"></param>
        ///  abstr=1  => 
        void ToDoc(string texte, string typbuf)
        {
            switch(typbuf) {
                case "1":  // typbuf=1 classe abstraite
                    sw.WriteLine(texte);
                    break;
 
                default:
            docfile.WriteLine(texte);
                    break;
            
            }
        }


//-----------------------------------------------
     List<EA.Attribute>  SortAttributesByName(EA.Collection col){
     List<EA.Attribute> retlist=new List<EA.Attribute>();
     
	Dictionary<string,EA.Attribute> dicAtrByName= new Dictionary<string,EA.Attribute>();
	foreach(EA.Attribute at in col){
	dicAtrByName.Add(at.Name,at);
	}

	Dictionary<string,EA.Attribute>.KeyCollection keysCol =dicAtrByName.Keys;
	string[] arkeys=new string[keysCol.Count];
	keysCol.CopyTo(arkeys,0);
	Array.Sort(arkeys);

	for(int i=0;i < arkeys.Length;i++){
	 retlist.Add(dicAtrByName[arkeys[i]]);		}
    return retlist;

 }
//-----------------------------------------------
     /// <summary>
     /// print a column for default value, fix value and factet
     /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void prodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         texte = "<td>";
         ToDoc(texte, isabstract);
            string constante=at.IsConst ? "constant=true":"";
            string statique=at.IsStatic ? "static=true" : "";
            string pardefaut = "DefaultValue=";
            if (at.IsConst || at.IsStatic)
            {
                pardefaut = "FixedValue=";
            }
            if (at.Default != "")
            {
                texte = "<p class=\"restriction\">" +  pardefaut + at.Default + "</p>";
                ToDoc(texte, isabstract);
            }

            if (at.Constraints.Count > 0)
            {
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    cont = ac.Notes;
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (contenu != "")
                    {
                        texte = "<p class=\"restriction\">" + " Constraint=" + contenu + "</p>";
                        ToDoc(texte, isabstract);
                    }
                }
            }
         texte="</td>";
         ToDoc(texte, isabstract);
 
     }
        //---
        /// <summary>
        /// recupere le type d'un element
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string getTypeElt(EA.Element el)
        {
            string prov = el.Name + " || " + el.StereotypeEx;
            string ret="";
            if (el.StereotypeEx.Contains(CD.GetEnumStereotype())) ret = "enumeration";
            if (el.StereotypeEx.Contains("Enumeration")) ret = "enumeration"; //am juin 2018
            if (el.StereotypeEx.Contains(CD.GetDatatypeStereotype())) ret = "datatype";
            if (el.StereotypeEx.Contains(CD.GetCompoundStereotype())) ret = "compound";
            if (el.StereotypeEx.Contains(CD.GetPrimitiveStereotype())) ret = "primitive";
            
            if (el.StereotypeEx.Contains("datatype")) ret = "Datatype"; // legacy
            if(
                ((ret=="")
                && 
                ((el.Type=="Enumeration")
                 || ((el.Type=="Class")&&(el.MetaType=="Enumeration"))
                ))
                )
            {
                ret = "enumeration";
            }


            return ret;
        }
        /// <summary>
        /// print a column for default value, fix value and factet
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="at"></param>
        /// <param name="isabstract"></param>
        void prodClassConstraint(EA.Element elt,string isabstract)
        {
  
            string texte;
            foreach (EA.Constraint constr in elt.Constraints)
            {
                if (constr.Type =="Invariant")
                {
                   texte = "<p class=\"note\"><b>" + "constraint:</b>" + constr.Name + "={" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, "0");
                }
                if (constr.Type == "OCL")
                {
                    texte = "<p class=\"note\"><b>" + "OCL constraint:</b>" + constr.Name + "</p>";// +" = {" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, "0");
                }
            }

        }
        //---

        //-------------------------------
        /// <summary>
        /// transform a string in an html string with linfeeds
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        string brNote(string ss)
        {
            string ret = "";
            string sss = ss;
            if(ss.Contains("<a href=\"{??"))
            {
                sss = modifrefs(ss, "<a href=\"{??");
            }
            string[] split = sss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    if (ret.Contains("<ul>") || ret.Contains("</li>"))
                    {
                        ret = ret + split[i];// "<br/>" + split[i];
                    }
                    else
                    {
                        ret = ret + "<br/>" + split[i];
                    }
                }
                else
                {
                    ret = ret + split[i];
                }
            }

            
           // ret.Replace("\n", " ");
            return ret;
        }
        
        //---------------------------------------
        //-------------------------
        public bool HasClassStereotype(EA.Element elt)
        {
            // MessageBox.Show("dans HasClassStereotype: Element=" + elt.Name + " stereotypeex=" + elt.StereotypeEx + "\n" + " subprofilestereotype" + subprofilestereotype);
            bool ret = false;
            // true if element 

            if (subprofilestereotype == "Class")
            {
                if ((elt.StereotypeEx == "") || (elt.StereotypeEx.Contains("Class")))
                {
                    ret = true;
                }

            }
            if (!subprofilestereotype.Contains(","))
            {
                if (elt.StereotypeEx.Contains(subprofilestereotype))
                {
                    ret = true;
                    foreach (string stereo in notclassestereos)
                    {
                        if (elt.StereotypeEx.Contains(stereo))
                        {
                            ret = false;
                            break;
                        }
                    }
                   
                }
            }
            else
            {
                ArrayList subprofslist = new ArrayList(subprofilestereotype.Split(new char[] { ',' }));

                RDFutilitaires.setper(subprofslist);
                for (int j = 0; j < RDFutilitaires.resulpermutation.Count; j++)
                {
                    string res = "";
                    for (int i = 0; i < ((ArrayList)RDFutilitaires.resulpermutation[j]).Count; i++)
                    {
                        res = res + (string)((ArrayList)RDFutilitaires.resulpermutation[j])[i] + ",";

                    }
                    res = res.Trim(',');
                    if (elt.StereotypeEx.Contains(res))
                    {
                        ret = true;
                        foreach (string stereo in notclassestereos)
                        {
                            if (elt.StereotypeEx.Contains(stereo))
                            {
                                ret = false;
                                break;
                            }

                        }
                       
                        break;
                    }
                }
            }
                if (ret == true)
                {
                    if (!dejatrouvee.Contains(elt.ElementID))
                    {
                        dejatrouvee.Add(elt.ElementID);
                    }
                    else
                    {
                        ret = false;
                    }
                }            
            return ret;
        }
        //------------------------
        public  bool HasNotClassStereotype(EA.Element elt)
        {
            string prov = elt.Name;
            bool ret = true;
            if (elt.StereotypeEx == "") ret = true;  // obvious
            foreach (string stereo in notpureclasses)
            {
                if (elt.StereotypeEx.Contains(stereo))
                {
                    ret = false;
                    break;
                }
            }
            //MessageBox.Show("hasnotclass elt=" + elt.Name + " , stereotypes=" + elt.StereotypeEx  + " => " + ret.ToString()); // pour test
            return ret;
        }
//---------------------
        string getAtrProfStereo(EA.Attribute atr){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {

                if (RDFLAutilitaires.StereoExContainsStereo(atr.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
        //---------------------
        /*****   am  nov 2015  ***************
        string getEltProfStereo(EA.Element elt){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(elt.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
         * */

        /// <summary>
        /// donne une categorie de stereotype
        /// cette categorie peut tre composee
        /// on suppose que dans le fichier de configuration les stereotypes sont donns
        /// non composs
        /// </summary>
        /// <param name="elt"></param>
        /// <returns></returns>
          string getEltProfStereo(EA.Element elt){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {
                if (stereo.Contains(","))
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" ERROR   the configuration data \"ListStereoNamespace\" is composed");
                    MessageBox.Show(" ERROR   the configuration data \"ListStereoNamespace\" is composed ");
                    ret = "";
                    break;
                }
            }
            if (elt.StereotypeEx != "")
            {

                string[] split = elt.StereotypeEx.Split(',');
                for (int i = 0; i < split.Length; i++)
                {
                    //if (SubprofilesStereos.Contains(split[i])) ;  ABA20230905 NO EFFECT!!
                    if (i > 0)
                    {
                        ret = ret + "," + split[i];
                    }
                    else
                    {
                        ret = ret  + split[i];
                    }
                }
              
            }
            
            return ret;
        }
         
        //---------------------
        string getAssocProfStereo(EA.Connector con)
        {
            string ret = "";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(con.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
//----------------------------
        bool ThereIsLegitimateConnexion(EA.Element el,Dictionary<string, List<EA.Connector>> consubprofiles,string stereo)
        {
            bool ret=false;
            if (consubprofiles.ContainsKey(stereo) && consubprofiles[stereo].Count > 0)
            {
                foreach (EA.Connector con in consubprofiles[stereo])
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        string cardinality=getOtherEndCardinality(el, con);
                        EA.ConnectorEnd otherend = (ConnectorEnd)(RDFutilitaires.getOtherend(el, con)[0]);

                        if ((cardinality == "1") || (cardinality == "1..1") || (cardinality == "0..1") || (otherend.Navigable=="Navigable"))
                        {
                            ret = true;
                            break;
                        }
                    }
                }
            }
            return ret;
        }
        //----------------------

        string getOtherEndCardinality(EA.Element el, EA.Connector con)
        {
            string cardinality = "";
            if ((con.Type == "Association") || (con.Type == "Aggregation"))
            {
                EA.ConnectorEnd end=null;
                if (con.ClientID == el.ElementID) end = con.SupplierEnd;
                if (con.SupplierID == el.ElementID) end = con.ClientEnd;
                cardinality = end.Cardinality;
                string prov = end.Role; // pour test
            }
            return cardinality;
        }

        /****
        /// <summary>
        /// les stereosEx se prsentent sous la forme de listes de
        /// string.
        /// Ce programme redonne une chaine liste o tous les membres sont dans l'ordre alaphabtique
        /// </summary>
        /// <param name="stereos"></param>
        public string RedressStereo(string stereos){
            string ret ="";
            string[] ss = stereos.Split(',');
            List<string> lss = new List<string>(ss);
            lss.Sort();
            StringBuilder newstereos = new StringBuilder();
            foreach (string s in lss)
            {
                newstereos.Append( "," + s);
            }
            ret = newstereos.ToString().Trim(',');
            return ret ;
        }
        ****/ 
         
        /// <summary>
        /// les stereotype peuvent tre constitu d'une composition
        /// exemple "ShortCircuit,Entsoe"
        /// suivant la maniere dont on les range il faut les comparer
        /// </summary>
        /// <param name="stereos"></param>
        public bool CompareCompositeStereo(string stereo1, string stereo2)
        {

            if (stereo1.Length != stereo2.Length) return false;
            if (!stereo1.Contains(",") && !stereo2.Contains(",")) return stereo1 == stereo2;
            {// il s'agit bien de  chaines composees
                string[] ss1 = stereo1.Split(',');
                List<string> lss1 = new List<string>(ss1);
                lss1.Sort();
                string[] ss2 = stereo2.Split(',');
                List<string> lss2 = new List<string>(ss1);
                lss2.Sort();
                if (lss1.Count != lss2.Count) return false;
                for (int i = 0; i < lss1.Count; i++)
                {
                    if (lss1[i] != lss2[i]) return false;
                }
                return true;
            }
        }
        string removestereo(string stereo, string ss)
        {
            if(!ss.Contains(stereo)) return ss;
            int l = stereo.Length;
            int index = ss.IndexOf(stereo);
            return (ss.Remove(index, index)).Trim(',');
        }

        /**
        /// <summary>
        /// verifie si un StereoEx d'un element contient un stereo
        /// qui peutetre une chaine comme "Entsoe,ShortCircuit"
        /// </su<param name="stereo"></param>mmary>
        /// 
        /// <param name="stereoex"></param>
        /// <returns></returns>
        bool StereoExContainsStereo(string stereoex, string stereo)
        {
            bool ret = false;
            if (!stereo.Contains(","))
            {
                if (stereoex.Contains(stereo))
                {
                    ret = true;
                }
            }
            else
            {
                if (!stereoex.Contains(","))
                {
                    ret = false;
                }
                else
                {

                    stereo = RedressStereo(stereo);
                    stereoex = RedressStereo(stereoex);

                    if (stereoex.Contains(stereo))
                    {
                        ret = true;
                    }
                }
            }
            return ret;
        } 
          **/
        //--------------------------------
        void newprodAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.ConnectorEnd myend;
            EA.Element otherendelt;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (((cardinality == "0..1") || (cardinality == "1..1") || (otherend.Navigable == "Navigable"))
                && myend.Navigable != "Navigable")
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                {// the association creates an effective memmber

                    string texte;


                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<th>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</th>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td class=\"type\">";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">";
                    ToDoc(texte, isabstract);
                    texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                    ToDoc(texte, isabstract);
                    texte = "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"comment\">" + brNote(otherend.RoleNote) + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "</tr>";
                    ToDoc(texte, isabstract);
                }
            }
        }
        //-----------------------------------
        string traitClassifierID(long classifierid)
        {
            string res = "";
            string texte="";
            string erreur = "!!classifier error!!";
            if ((classifierid == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            // attention dans certain cas un type non lie n'annule pas le ClassifierID
            {

                res = erreur;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" warning attempt to treat a classifier which is 0, check that the types of your attributes are properly bound to a valid class");

            }
            else
            {
                EA.Element claselt = Main.Repo.GetElementByID((int)classifierid);
                
                string prov = claselt.Name + " || " + claselt.StereotypeEx;
                string type = getTypeElt(claselt);

                if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);

                if (!dejatrouvee.Contains(classifierid))  // something to do
                {
                    dejatrouvee.Add(classifierid);
                    if ( // il n'y a pas a analyser les attributs d'une enum
                   
                                    !(
                                    (claselt.StereotypeEx.Contains(CD.GetEnumStereotype())) // am juin 2018
                                    || (claselt.StereotypeEx.Contains("Enumeration"))
                                    || (claselt.Type=="Enumeration")
                                    )
                        )
                    
                    {
                        foreach (EA.Attribute at in claselt.Attributes)
                        {
                            if ((at.ClassifierID == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
                            // attention dans certain cas un type non lie n'annule pas le ClassifierID
                            {
                                if ((at.ClassifierID == 0) && (
                                                      
                                                                  !(
                                                                        (claselt.StereotypeEx.Contains(CD.GetEnumStereotype())) //am juin 2018
                                                                       || (claselt.StereotypeEx.Contains("Enumeration"))
                                                                       || (claselt.Type=="Enumeration")
                                                                     )
                                                               ))
                                {
                                    prov = "classe=" + claselt.Name + " at=" + at.Name;
                                    texte = erreur + "the classifiet is 0 for " + at.Name + " in classe=" + claselt.Name;
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }
                                else
                                {
                                    //18 if (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID))
                                    //18 {
                                        if (   
                                              !(
                                                  (claselt.StereotypeEx.Contains(CD.GetEnumStereotype())) //am juin 2018
                                                 || (claselt.StereotypeEx.Contains("Enumeration"))
                                                 || (claselt.Type=="Enumeration")
                                                 )
                                           )
                                            
                                        {
                                             prov = "classe=" + claselt.Name + " at=" + at.Name;
                                            texte = erreur + "the classifier  for " + at.Name + " in classe=" + claselt.Name + " was not found";
                                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                        }
                                   //18 }
                                }

                            }
                            else
                            {
                               //18  EA.Element clamelt = RDFutilitaires.dicelembyid[at.ClassifierID];
                                EA.Element clamelt = Main.Repo.GetElementByID((int)at.ClassifierID);
                                texte = traitClassifierID(at.ClassifierID);
                                if (texte == erreur)
                                {
                                    texte = erreur + "the classifiet in 0 fot " + at.Name + " in classe=" + clamelt.Name;
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                }

                            }
                        }
                    }
                }
            }
            if (res != erreur) { res = Main.Repo.GetElementByID((int)classifierid).Name; };
            return res;
        }
        /// <summary>
        /// this program treats all datatypes.
        /// If it is local , it is published after the other classes  under a section Local Datatypes
        /// If not it is published under a new section Used Datatype
        ///
        /// </summary>
        /// 
  
        void traitTypeList(int level)
        {
            newsections = new List<string>();
            int nbdatatypes = 0;
            foreach (string stereo in TypeList.Keys)
            {
                nbdatatypes = nbdatatypes + TypeList[stereo].Count;
            }
            if (nbdatatypes == 0) return; // nothing todo
            newsection("Global Used  Datatypes", level+1);
            EA.Element elt = null;
            foreach (string stereo in TypeList.Keys)
            {
                foreach (long elid in TypeList[stereo])
                {
                    if (elid != 0)
                    {
                        elt = repository.GetElementByID((int)elid);
                    }
                    if (stereo == "primitive")
                    {
                        newsection("Primitives", level + 2);
                        prodPrimitive(elt, level + 3);

                    }
                    if (stereo == "enumeration")
                    {
                        newsection("Enumerations", level + 2);
                        prodEnumeration(elt, level + 3);
                    }
                    if (stereo == "datatype")
                    {
                        newsection("Datatypes", level + 2);
                        string prov = elt.Name;
                        prodDatatype(elt, level + 3);
                    }
                    if (stereo == "compound")
                    {
                        newsection("Compounds", level + 2);
                        prodCompoundtype(elt, level + 3);
                    }
                }

            }
           
        }
      //-----------------------------------
        string brpNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>";
                }
                else
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>";
                }
                // ret = ret + split[i];
            }
            ret.Replace("\n", " ");
            return ret;
        }
        //--------------------------------
        static string addSignetTable()
        {
            string texte = "";
            rgtable++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;
            texte = "<a name=\"" + basesignet + compteursgnt.ToString() + rgtable.ToString() + "\">";
            return texte;

        }
        static string addSignetFigure()
        {
            string texte = "";
            rgtable++;
            // rgfigure++;
            //compteursgnt++;
            long prevcompteur=compteursgnt;
            compteursgnt = DateTime.Now.Ticks;// pour se distinguer d'une table dclare au meme moment
            while (prevcompteur == compteursgnt)
            {
                compteursgnt = DateTime.Now.Ticks;
            }


            texte = "<a name=\"" + basesignet + compteursgnt.ToString() + rgfigure.ToString() + "\">";
            return texte;

        }
//---------------
        void prodAttributeEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
             ToDoc(texte,isabstract);
            texte="<td>";
	      ToDoc(texte,isabstract);
          texte = "<p class=\"mytable-col-heading\">" + "Attribute name" + " </p>";
	  ToDoc(texte,isabstract);
          texte="</td>";
              ToDoc(texte, isabstract);
           texte="<td>";
	 ToDoc(texte,isabstract);
     texte = "<p class=\"mytable-col-heading\">" +  "mult."  + " </p>";
	 ToDoc(texte,isabstract);
       texte="</td>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + "Attribute type" + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
        }
 void prodEnumEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Literal" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + " Code "  + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
        }
/// <summary>
/// gnre tous les diagrames du profil publie
/// en explorant recursivement tous les diagrammes
/// en respectant la hierarchoe des packages a l'impression
/// </summary>
/// <param name="pack"></param>
/// <param name="packages"></param>
 void prodDiagrams(EA.Package pack, List<EA.Package> packages)
 {
     try
     {
         string texte = "";
         string packname = pack.Name;
         string pathfile = "";
         if (pack.Diagrams.Count != 0)  //  diagrammes dans le package
         {
             texte = "<h2> Diagram  " + pack.Name + "</h2>";
             ToDoc(texte, "0");

             foreach (EA.Diagram diag in pack.Diagrams)
             {
                 string diagramguid = diag.DiagramGUID;
                 pathfile = nomrepimages + "\\" + packname + "_" + diag.Name + ".bmp";
                 project.PutDiagramImageToFile(diagramguid, pathfile, 1);
                 repository.CloseDiagram(diag.DiagramID);
                 docfile.WriteLine("<p class=\"myparagraph\">!# shows the diagram. </p> ");
                 docfile.WriteLine("<p align=\"center\" >"); // pour que l'image prenne le style figur  //class=\"myfigure\"
                 texte = "<img  src=\"" + nomrepimages + "\\" + packname + "_" + diag.Name + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";//class=\"myfigure\"
                 ToDoc(texte, "0");
                 docfile.WriteLine("</p>");
                 docfile.WriteLine("<p class=\"myparagraph\">  </p>"); // une ligne sous la figure
                 docfile.WriteLine("<p align=\"center\"  class=\"myfigure-title\">" + addSignetFigure() + "Figure" + " !#</a>  - diagram " + diag.Name + "</p>");

             }
         }
         foreach (EA.Package pa in pack.Packages)
         {
             prodDiagrams(pa, packages);
         }
     }
     catch (Exception e)
     {
         MessageBox.Show (" Isuues in creating profile diagrame files :\n " + e.Message);
     }

 }


/// <summary>
/// gnre tous les diagrames d'un package
/// </summary>
/// <param name="pack"></param>
/// <param name="packages"></param>
 void prodDiagrams(EA.Package pack)
 {
       if (XMLP.GetXmlValueConfig("EntsoeKeepUMLDiagrams") != "Checked")
        {
        return;
        }
     try
     {
         string texte = "";
         string packname = pack.Name;
         string pathfile = "";
         if (pack.Diagrams.Count == 0) return; // pas de diagrammes dans le package   
           //  texte = "<h2> Diagram  " + pack.Name + "</h2>"; //am 2014
            // ToDoc(texte, "0");                              //am 2014

         foreach (EA.Diagram diag in pack.Diagrams)
         {
              string diagramguid = diag.DiagramGUID;
             //pathfile = nomrepimages + "\\" + packname + "_" + diag.Name + ".png";
              pathfile = nomrepimages + "\\" + packname + "_" + diag.Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
             if (XMLP.GetXmlValueConfig("ImageExt") == ".emf")
             {
                 project.PutDiagramImageToFile(diagramguid, pathfile, 0);
             }
             else
             {
                 project.PutDiagramImageToFile(diagramguid, pathfile, 1);
             }
            // repository.CloseDiagram(diag.DiagramID);
             docfile.WriteLine("<p class=\"myparagraph\">!# shows the diagram. </p> ");
             docfile.WriteLine("<p  align=\"center\">"); // pour que l'image prenne le style figur //class=\"myfigure\"
             //  texte = "<img  src=\"" + nomrepimages + "\\" + packname + "_" + diag.Name + ".png\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";//class=\"myfigure\"
             texte = "<img  src=\"" + nomrepimages + "\\" + packname + "_" + diag.Name + XMLP.GetXmlValueConfig("ImageExt") + "\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";//class=\"myfigure\"// am juin 2017
             ToDoc(texte, "0");
             docfile.WriteLine("</p>");
             docfile.WriteLine("<p class=\"myparagraph\">  </p>"); // une ligne sous la figure
             docfile.WriteLine("<p align=\"center\" class=\"myfigure-title\">" + addSignetFigure() + "Figure" + " !#</a>  - diagram " + diag.Name + "</p>");
           //-----------   ajout mar 2014  ------------------------------
             texte = "<p class=\"myparagraph\">" + brNote(diag.Notes) + "</p>";
             // ToDoc(texte, elt.Abstract);
             ToDoc(texte, "0");
             repository.CloseDiagram(diag.DiagramID);
           //------------------------------------------------------------
         }

     }
     catch (Exception e)
     {
         MessageBox.Show (" Isuues in creating package diagram files "+pack.Name+" :\n " + e.Message);
     }

 }
 void buildDicPackLevel(EA.Package pack,int level)
  {
    int depth=level+1;
   if(dicPackLevel.ContainsKey(pack.PackageID)) {return;};
  dicPackLevel.Add(pack.PackageID,level);
  foreach(EA.Package pa in pack.Packages)
 {
  if( !dicPackLevel.ContainsKey(pa.PackageID))
 {
  buildDicPackLevel(pa,depth);
	}
 }
  }
 //---
        /// <summary>
        /// cree le commentaire de description sur l'AssocEnd
        /// </summary>
        /// <param name="con"></param>
        string[]  prodAssocIsBasedOn(EA.Repository repo,EA.Connector con)
        {
           
            string IBOGuid = RDFutilitaires.getBasedOnConnectoryGUID(repo,con.ConnectorGUID);
            
            EA.Connector IBOcon = repo.GetConnectorByGuid(IBOGuid);
             string[] texte={"",""};
             if (IBOcon != null)
             {
                 EA.Element source_element = repo.GetElementByID((int)IBOcon.ClientID);
                 EA.Element target_element = repo.GetElementByID((int)IBOcon.SupplierID);
                 EA.ConnectorEnd source = IBOcon.ClientEnd;
                 EA.ConnectorEnd target = IBOcon.SupplierEnd;

                 texte[0] = repo.GetPackageByID((int)source_element.PackageID).Name + "::\n" + source_element.Name + "." + source.Role;
                 texte[0] = texte[0] + "[" + source.Cardinality + "]";
                 texte[1] = repo.GetPackageByID((int)target_element.PackageID).Name + "::\n" + target_element.Name + "." + target.Role;
                 texte[1] = texte[1] + "[" + target.Cardinality + "]";
             }
             else
             {
              MessageBox.Show("WARNING there is a problem in the model the association de roles: " + "ClientRole=" + con.ClientEnd.Role + "," +"SupplierRole=" + con.SupplierEnd.Role+ "\n\r modele not build with CimSyntaxGen");
             }
            return texte;

        }
        /// <summary>
        /// cre une section package
        /// </summary>
        /// <param name="nompack"></param>
        /// <param name="level"></param>
        void crePack(string nompack, int level)
        {
            string texte = "";
            bool trouvpack = false;
            EA.Package datatypack = null;
            foreach (EA.Package pa in ProfPack.Packages)
            {
                if (pa.Name == nompack)
                {
                    trouvpack = true;
                }

            }
            if (!trouvpack)
            {
                datatypack = (EA.Package)ProfPack.Packages.AddNew(nompack, "Package");
                datatypack.Update();
                ProfPack.Packages.Refresh();
                texte = "<h" + (level + 1).ToString() + ">" + datatypack.Name + " </h" + level.ToString() + "  >"; //am 2014
                ToDoc(texte, "0");
            }
            
        }
        /// <summary>
        /// cree une nouvelle section du document
        /// </summary>
        /// <param name="nompack"></param>
        /// <param name="level"></param>
        void newsection(string nompack, int level)
        {
            string texte = "";
            if (!newsections.Contains(nompack))
            {

                newsections.Add(nompack);
                texte = "<h" + (level).ToString() + ">" + nompack + " </h" + level.ToString() + "  >"; //am 2014
                ToDoc(texte, "0");
            }

        }
        string modifrefs(string ss,string chaine)
            // on suppose que la string contient des strings de type 
            //<a href="{??')"><font color="#0000ff"><u>https://a</u></font></a>
        // ou <a href="{??')"><font color="#0000ff"><u>https://a</u></font></a>
        {
            string res = ss;
            string substr = "";
        List <int> startrefs=new List<int>();
            List <int> endrefs =new List<int>();
            ArrayList refs=new ArrayList();
            ArrayList newrefs= new ArrayList();

      int   ind = 0;
        while (ind >= 0)
        {
            ind = ss.IndexOf(chaine, ind);
            if (ind >= 0)
            {
                startrefs.Add(ind);
                ind++;
            }
           
        }
        foreach (int i in startrefs)
        {
            int fin = ss.IndexOf("</a>", i);
            int startu;
            int endu;
            substr = ss.Substring(i, fin + 4-i);
            //string[] splitu;
             startu = substr.IndexOf("<u>");
            string substrref = "";
            if (startu >= 0)
            {
                endu = substr.IndexOf("</u>");
                substrref = substr.Substring(startu+3, endu -startu-3);               
                
            }
            
            string tt = "";
            
                tt="<a href=\"" + substrref + "\"><font color=\"#0000ff\">";
                refs.Add(substr.Substring(0,startu));
                newrefs.Add(tt);

        }
        for (int j = 0; j<  refs.Count; j++)
        {
            string avant = (string)refs[j];
            string apres= (string)newrefs[j];
            string g = res.Replace(avant, apres);
            res = g;
        }
        return res;
        }
        //-------------------------------
        //-------------------------------

    }
}
