using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using Microsoft.Win32;
using System.Runtime.CompilerServices;
using System.Reflection;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.HtmlGen
{

    class HtmlEsmpCodeListDocumentation
    {

       public  StreamWriter reportlog;  //for logs
       public CodeLists cle;
       Dictionary<string, EA.Element> dicElems = new Dictionary<string, EA.Element>();
       List<EA.Element> Elements;
        string nomfichier = ""; // file to write the documentation
	string nomrepimages=""; // directory for images for the documentation
        public StreamWriter docfile;
        static StringBuilder AbstractsBuffer = new StringBuilder();
        static EA.Package lepackage = null;
        static string basesignet = "ESMP_"; // entete de signets
        static int rgtable = 0;
        static int rgfigure = 0;
        static long compteursgnt = 0; // compteur pour signet
        StringWriter sw = new StringWriter(AbstractsBuffer);
        ConstantDefinition CD = new ConstantDefinition();
  	  Repository repository;
	EA.Project project; 
	XMLParser XMLP;
    string texte = "";
        private static string HTML_HEADER_FILE = @"DocHtmlEsmpHeader.txt";


        //---------------------------------------------------------
        /// <summary>
        /// constructor with several initialisations
        /// iec inhibate publishing of datatypes and enumerations
        /// </summary>
    public HtmlEsmpCodeListDocumentation(EA.Repository repo,string repertoire)
        {
            repository = repo;
            rgtable = 0;
	    project = repository.GetProjectInterface();

            EA.Package pack = repo.GetTreeSelectedPackage();
            lepackage = pack;    

            try
            {
                //RegistryKey eaReg = Registry.CurrentUser.OpenSubKey("Software\\Sparx Systems\\EAAddins\\CimSyntaxGen");
               // string path = (string)eaReg.GetValue("RessourcesFolder");
                //string path;
                //nomfichier = RDFutilitaires.SelectFile("html");
                nomfichier = repertoire + "\\" + "entso-e-codelist.html";
                //path = FileManager.GetParentDirPath();
                //path = path + "\\DocHtmlEsmpHeader.txt";
                //System.IO.File.Copy(path, nomfichier, true);
                
                Assembly myAssembly = Assembly.GetExecutingAssembly(); // ABA20230830
                Stream stream = myAssembly.GetManifestResourceStream("CimSyntaxGen.Resources." + HTML_HEADER_FILE);
                FileManager.CopyStream(stream, nomfichier);

                docfile = System.IO.File.AppendText(nomfichier);
                string [] split = Path.GetFileName(nomfichier).Split(new char[]{'.'});

                 nomrepimages = Path.GetDirectoryName(nomfichier) + "\\" + split[0] + "_images";
 		if(Directory.Exists(nomrepimages)) Directory.Delete(nomrepimages,true);
		Directory.CreateDirectory(nomrepimages);
         //18  reportlog = new StreamWriter(Path.GetDirectoryName(nomfichier) + "\\" + split[0] +"log.txt");
        reportlog = Main.reportlog;

          dicElems = new Dictionary<string, EA.Element>();
          Elements = new List<EA.Element>();
          buildDicElemens(pack);
       
            }
            catch (Exception e)
            {
                MessageBox.Show("An exception occured while reading the DocHtmlHeader.txt :" + e.Message);
            }

        }

    public void prodDoc(Repository repo, EA.Package pack)
    {


        docfile.WriteLine("<body>");


        docfile.WriteLine(" <h1> ENTSO-E codelist </h3>");

        //------------------

        texte = "<p class=\"myparagraph\">" + "##MXM##" + "</p>";
        docfile.WriteLine(texte);
        //--------



        /*************************************************
       * Enumerations
       * ***********************************************/

    }           


//---------------------------------------------------------------------------

        public void
            prodDoc(Repository repo)
        {

            EA.Package pack = repo.GetTreeSelectedPackage();
            // open body
            docfile.WriteLine("<body>");


            //------------------
            // titre de la suite du document
   
            docfile.WriteLine("---------------------------------------------------------------------");
            docfile.WriteLine("<h1>" + " " + "ENTSO-E codelist    " + getVersion() + "</h1>");
            docfile.WriteLine("---------------------------------------------------------------------");

            //--------

            /*************************************************
           * Enumerations
           * ***********************************************/
            foreach (EA.Element elt in Elements)
            {
                if (((elt.Stereotype.Contains("enumeration")) || (elt.Stereotype.Contains("Enumeration"))) || (elt.Type == "Enumeration"))
                {
                   
                    prodEnumeration(elt);
                }
                else
                {
                  //  prodVersion(elt);
                }
            }
            docfile.Flush();
            docfile.Close();
        }


        /// <summary>
        ///  recupere les donnees de version
        /// </summary>
        /// <returns></returns>
        private string getVersion()
        {
            string res = "";
            foreach (EA.Element el in Elements)
            {
                if(el.Name=="Version")
                {
                    string vers = "";
                    string date = "";
                    foreach (EA.Attribute at in el.Attributes)
                    {
                        if (at.Name == "Version")
                        {
                            vers = at.Default;
                        }
                        if (at.Name == "ReleaseDate")
                        {
                            date = at.Default;
                        }
                        res = "      "  + vers + "      " + "Release Date:  " + date;
                    }
                    break;
                }
            }
            return res;
        }
            //--------

  
//------------

private void prodVersion(Element elt)
{
 	throw new NotImplementedException();
} 
        
       void  prodEnumeration(EA.Element enumelt){
       string texte = "";
       if (enumelt.Name == "DocumentTypeList")
       {
           string prov = enumelt.Name;
       }
           //MessageBox.Show(" enumeration " + enumelt.Name);// pour test
       string name = enumelt.Name.Replace("List", "");
          
          // texte = "<h2 class=\"enumerated\">" + enumelt.Name + " enumeration" + "</h2>";
       texte = "<h2 class=\"enumerated\">" + name + " enumeration" + "</h2>";
           docfile.WriteLine(texte);
           
           texte =brpNote(enumelt.Notes);
           docfile.WriteLine(texte);

           //-------------------- ajout am  aout 2012  --------------------------------- 
       
           
               //texte = "<p class=\"myparagraph\">" + " !#" + "shows  detail of Codelist" +   enumelt.Name + ".";
           texte = "<p class=\"myparagraph\">" + " !#" + " provides  details of the Codelist " + name + ".";
           docfile.WriteLine(texte);

           texte = "<p class=\"mytable-title\">" + addSignetTable() + " Table " + " !#  ";
          // texte = texte + " -" + "codelist  "  +  enumelt.Name; // +".";
           texte = texte + " -" + " Codelist  " + name + "</p>"; // +".";
           docfile.WriteLine(texte);
           //-----------------------------------------------------------------------------


           texte = "<table>";
           docfile.WriteLine(texte);
           prodEnumEntete("0");
           List<EA.Attribute> atlist = new List<EA.Attribute>();
           foreach (EA.Attribute at in enumelt.Attributes)
           {
               if (!atlist.Contains(at)) atlist.Add(at);
           }
           atlist.Sort(CodeLists.CompareAttributebyDefault);
           foreach (EA.Attribute at in atlist)
           {
               prodMember(enumelt, at);
           }
           texte = "</table>";
           docfile.WriteLine(texte);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";; 
           docfile.WriteLine(texte);
           texte = "</div>";
           docfile.WriteLine(texte);
       
}
   //------------
  
  
   void prodMember(EA.Element enumelt,EA.Attribute at)
   {
  docfile.WriteLine( "<tr>");
docfile.WriteLine("<td style=\"width:5%;\">");
docfile.WriteLine("<p class=\"name\" >" + at.Default +  "</p>");
docfile.WriteLine("</td>");
//---------------- ajout am september   2012  -------------------------------
docfile.WriteLine("<td style=\"width:20%;\">");
docfile.WriteLine("<p class=\"comment\">" +   at.Name + " "  + "</p>");
docfile.WriteLine("</td>");
//---------------------------------------------------------------------------
docfile.WriteLine("<td style=\"width:75%;\">");
docfile.WriteLine("<p class=\"comment\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("</tr>");


   }
//------------
 
    
  
//------------------------
 
  
 


//------------
        /// <summary>
        /// print a texte line in the correct buffer
        /// </summary>
        /// <param name="texte"></param>
        /// <param name="abstr"></param>
        ///  abstr=1  => 
        void ToDoc(string texte, string typbuf)
        {
            switch(typbuf) {
                case "1":  // typbuf=1 classe abstraite
                    sw.WriteLine(texte);
                    break;
 
                default:
            docfile.WriteLine(texte);
                    break;
            
            }
        }



//-----------------------------------------------
 
   
        //-------------------------------
        /// <summary>
        /// transform a string in an html string with linfeeds
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        string brNote(string ss)
        {
            string ret = "";
            string [] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<br/>" + split[i];
                }
                else
                {
                    ret = ret + split[i];
                }
               // ret = ret + split[i];
            }
            ret.Replace("\n"," ");
            return ret;
        }
        string brpNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                else
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                // ret = ret + split[i];
            }
            ret.Replace("\n", " ");
            return ret;
        }
        //---------------------------------------
        //-------------------------
   
        //--------------------------------
        static string addSignetTable()
        {
            string texte = "";
            rgtable++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;
            texte= "<a name=\"" + basesignet + compteursgnt.ToString() + rgtable.ToString()+ "\">";
            return texte;

        }
        static string addSignetFigure()
        {
            string texte = "";
            rgtable++;
           // rgfigure++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;// pour se distinguer d'une table dclare au meme moment
            texte = "<a name=\"" + basesignet + compteursgnt.ToString() + rgfigure.ToString() + "\">";
            return texte;

        }
        string getEnumCode( EA.Attribute at)
        {
            string resul = "";
            foreach (EA.AttributeTag tag in at.TaggedValues)
            {
                if (tag.Name == CD.GetEnumCodeTag())
                {
                    resul = tag.Value;
                }
            }
            return resul;
        }
  

        //-------------------------------
        /// <summary>
        /// get the Package path  in which the object on which 
        /// the element  is situated
   
  
  
//------------------------------------------------------------------------------------------------------
         void buildDicElemens(EA.Package pack)
         {
             foreach (EA.Element el in pack.Elements)
             {
                 if ((el.Name != "") && (!dicElems.ContainsKey(el.Name)))   dicElems.Add(el.Name, el);
                 if ((el.Name != "") && (!Elements.Contains(el)))   Elements.Add( el);
                
             }
         }

         void prodEnumEntete(string isabstract)
         {
             string texte;
             texte = "<tr>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-col-heading\">" + "Code" + " </p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-col-heading\">" + "Title " + " </p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
         }

  
   //------------
//-------------------------------------------------------------------------------------------------------
    }
}
