using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using Microsoft.Win32;
using System.Reflection;
using CimSyntaxGen.Utilities;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.HtmlGen
{

    class HtmlEsmpDocumentation
    {
        private static Logger logger = new Logger(Main.LOG_FILE, Main.DO_LOG);

        public StreamWriter reportlog;  //for logs


        string nomfichier = ""; // file to write the documentation
	string nomrepimages=""; // directory for images for the documentation
        public StreamWriter docfile;
        static bool iec = false; // permet une edition sans datatype
        static List<EA.Element> ProfileClasses;
        static StringBuilder AbstractsBuffer = new StringBuilder();
        static EA.Package lepackage = null;
        static string basesignet = "ESMP_"; // entete de signets
        static int rgtable = 0;
        static int rgfigure = 0;
        static long compteursgnt = 0; // compteur pour signet
        StringWriter sw = new StringWriter(AbstractsBuffer);    
       public  Dictionary <string,List<long>> TypeList;// string, elementID
       public List<EA.Element> listprimitive; // list des primitives du 351
       public EA.Package toppack;
            Dictionary<long, string> dicNoteforClass;
        ConstantDefinition CD = new ConstantDefinition();
	Dictionary<long,string> dicPackim;
  	  Repository repository;
	EA.Project project;
    List<string> notpureclasses;  // to be used by find predicates
    List<string> notclassestereos; // sterotypes of objects different from classes (ex: enumeration or datattype)
    string subprofilestereotype;  // to be used by find predicates
    List<string> SubprofilesStereos; // list of non cim stereotypes
    List<long> dejatrouvee;// liste des  classes deja traitee (evite de dupliquer les traitement de multiples stereotypes)

    bool pourtest = false;
  public  bool is351 = false; // cas particulier de IEC62325-351 on doit voir toutes les primitives
	XMLParser XMLP;
        private static string HTML_HEADER_FILE = @"DocHtmlEsmpHeader.txt";

        //---------------------------------------------------------
        /// <summary>
        /// constructor with several initialisations
        /// iec inhibate publishing of datatypes and enumerations
        /// </summary>
    public HtmlEsmpDocumentation(EA.Repository repo, bool foriec)
        {
            iec = foriec;
            repository = repo;
            XMLP = new XMLParser(repo);
            CIMSchemaGenerator.Repos = repo;
            rgtable = 0;
	    project = repository.GetProjectInterface();

            EA.Package pack = repo.GetTreeSelectedPackage();
            lepackage = pack;
            //basesignet = pack.Name.Replace(' ', '_');

    /************** pour test **********************        
            //============================================
            ArrayList c = new ArrayList(){"Entsoe","ShortCircuit","operation"};
            RDFutilitaires.setper(c);
            string dump = "";
            string dumpit="";
            for (int i = 0; i < RDFutilitaires.resulpermutation.Count;i++ )
            {
                dumpit = "";
                for (int j = 0; j < ((ArrayList)RDFutilitaires.resulpermutation[i]).Count; j++)
                {
                    dumpit = dumpit + ((ArrayList)RDFutilitaires.resulpermutation[i])[j] + "|";                   
                }
                dump = dump + "{" + dumpit + "},";
            }
            MessageBox.Show("essai de permutation:" + dump);

            return;
            //============================================
            ************************************************/

            XMLP =new XMLParser(repository);
               if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
               {
                   string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                   string[] stereos = liststereos.Split(new char[] { '|' });
                   SubprofilesStereos = new List<string>(stereos);
               }
               else
               {
                   SubprofilesStereos = new List<string>();
               }

               SubprofilesStereos.Sort(RDFutilitaires.CompareStringsByLength);// assure qu'on traite les stereos composes en premier
               SubprofilesStereos.Reverse();

           

            try
            {
                //RegistryKey eaReg = Registry.CurrentUser.OpenSubKey("Software\\Sparx Systems\\EAAddins\\CimSyntaxGen");
               // string path = (string)eaReg.GetValue("RessourcesFolder");
                //string path;
                if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")
                {
                    nomfichier = XMLP.GetXmlValueProfData("HtmlEsmpDocumentationFilePath");
                    if ((nomfichier == null) || (nomfichier == "")) throw new Exception(" Error in the configfile for HtmlDocumentationFilePath ");
                }
                else
                {
                    nomfichier = RDFutilitaires.SelectFile("html");
                }

                //path = FileManager.GetParentDirPath(); ABA20230830
                //path = path + "\\DocHtmlEsmpHeader.txt";
                //System.IO.File.Copy(path, nomfichier, true);
                Assembly myAssembly = Assembly.GetExecutingAssembly(); // ABA20230830
                Stream stream = myAssembly.GetManifestResourceStream("CimSyntaxGen.Resources." + HTML_HEADER_FILE);
                FileManager.CopyStream(stream, nomfichier);

                docfile = System.IO.File.AppendText(nomfichier);
                 string [] split = Path.GetFileName(nomfichier).Split(new char[]{'.'});

                 nomrepimages = Path.GetDirectoryName(nomfichier) + "\\" + split[0] + "_images";
 		if(Directory.Exists(nomrepimages)) Directory.Delete(nomrepimages,true);
		Directory.CreateDirectory(nomrepimages);
         //18 reportlog = new StreamWriter(Path.GetDirectoryName(nomfichier) + "\\" + split[0] +"log.txt");
        reportlog = Main.reportlog;
                RDFutilitaires.reportlog = reportlog;



                ProfileClasses = new List<EA.Element>();
                EA.Collection modellist = repo.Models;
               
                toppack = null;
                foreach (EA.Package mod in modellist)
                {
                    toppack = mod;  // the root package
                }
                
                RDFutilitaires.buildDicsElem(toppack);
              
     		dicPackim=new Dictionary<long,string>();
              AbstractsBuffer = new StringBuilder();
              sw = new StringWriter(AbstractsBuffer);
              TypeList= new Dictionary<string,List<long>>();
              TypeList.Add("datatype", new List<long>());
              TypeList.Add("enumeration", new List<long>());
              TypeList.Add("compound", new List<long>());
            }         

            catch (Exception e)
            {
                MessageBox.Show("An exception occured while reading the DocHtmlHeader.txt :" + e.Message);
            }

        }
        public void prodDoc(Repository repo,EA.Package pack)
        {
          
            //EA.Package pack = repo.GetTreeSelectedPackage();
            // open body
            docfile.WriteLine("<body>");
            ProfileClasses = new List<EA.Element>();
            RDFutilitaires.getTypedElements(pack, ProfileClasses, "Class");
           ProfileClasses.Sort(RDFutilitaires.CompareElementsbyName);
            //------------------- am novembre 2012 ---------------------------
            //  production de l'entete du document et preparation de l'insertion de l'image
            //  l'image est sauvegardee selon le nom du package
           docfile.WriteLine("<h2>" + pack.Name + "</h2>"); 
            docfile.WriteLine(" <h3> Overview of the model </h3>");
             docfile.WriteLine("<p class=\"myparagraph\">!# shows the model. </p> ");
            //docfile.WriteLine("<p class=\"myparagraph\">!# shows the model.  ");
           // docfile.WriteLine("<p class=\"myparagraph\">");
             docfile.WriteLine("<p class=\"myfigure\">"); // pour que l'image prenne le style figure
            crePackageImage(pack);
            docfile.WriteLine("</p>");
            docfile.WriteLine("<p class=\"myparagraph\">  </p>"); // une ligne sous la figure
            docfile.WriteLine("<p class=\"myfigure-title\">" + addSignetFigure() + "Figure" + " !#</a>  - " + pack.Name + "</p>");
            //------------------------------------------------------------------
            //------------------
            // table des basedon
           string texte;
           //docfile.WriteLine("<h1>" + " " + "BasedOn classes"  + "</h1>");
           docfile.WriteLine("<h3>" + " " + "IsBasedOn relationships from the European style market profile" + "</h3>");
           //-------------------- ajout am  aout 2012  --------------------------------- 
           texte = "<p class=\"myparagraph\">" + "!#"  + " shows  the traceability dependency of the classes used in this package towards the upper level.</p>";
           ToDoc(texte, "0");
           texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table" + " !#</a>"; 
           texte = texte + " -" + " IsBasedOn dependency</p>";
           ToDoc(texte, "0");
           //-----------------------------------------------------------------------------
           
           texte = "<table>";
           docfile.WriteLine(texte);
           prodBasedOnEntete("0");
           foreach (EA.Element elt in ProfileClasses)
           {
               prodBasedOn(repo, elt, "0");
           }

           texte = "</table>";
           docfile.WriteLine(texte);
	   texte = "<p class=\"myparagraph\">" + "##MXM##" + "</p>";
           docfile.WriteLine(texte);
            //--------
        notpureclasses = new List<string>();
        notpureclasses.Add(CD.GetEnumStereotype());
        notpureclasses.Add("Datatype");
        notpureclasses.Add(CD.GetDatatypeStereotype());
        notpureclasses.Add(CD.GetPrimitiveStereotype());
        notpureclasses.Add(CD.GetCompoundStereotype());
       
        notclassestereos = new List<string>(notpureclasses);
        notpureclasses.AddRange(SubprofilesStereos);

        List<EA.Element> classlists;
            texte=" List of stereotye to categorize subProfiles" +"\r\n";
        foreach (string stereo in SubprofilesStereos)
        {
            texte = texte + "     " + stereo + "\r\n";
        }
       // MessageBox.Show(texte);
       // docfile.WriteLine(texte);
        dejatrouvee = new List<long>();
        for (int ii = 0; ii < SubprofilesStereos.Count;ii++ )
        {
             string stereo =SubprofilesStereos[ii];
            classlists = new List<EA.Element>();
            subprofilestereotype = stereo;
            classlists = ProfileClasses.FindAll(HasClassStereotype);
            classlists.Sort(RDFutilitaires.CompareElementsbyName);
            if (classlists.Count > 0)
            {
                docfile.WriteLine("<h1>" + " " + "Concrete Classes" + " (" + stereo + ")" + "</h1>");
                //docfile.WriteLine("<h1>" + " " + "Concrete Classes" + " (" + stereo + ")" + "</h1>");
                foreach (EA.Element elt in classlists)
                {
                    string prov = elt.Name; // pour test
                    prodClass(elt,false);
                }
            }
        }
            // classes concretes
             classlists = new List<EA.Element>();
             classlists = ProfileClasses.FindAll(HasNotClassStereotype);
             List<EA.Element> rootlist = new List<EA.Element>();
             List<long> todelete = new List<long>();
             //short ind = 0;
             foreach (EA.Element elt in classlists)
             {
                 if (elt.IsActive)
                 {
                     string prov = elt.Name;
                     rootlist.Add(elt); 
                 }
                
             }
            
             foreach (EA.Element el in rootlist)
             {
                 classlists.Remove(el);
             }
            


            classlists.Sort(RDFutilitaires.CompareElementsbyName);
            //-------- ajout am 2012 ----------------------------------
            docfile.WriteLine("<h3>" + "Detailed" + " "  + pack.Name  + "</h3>");
           // docfile.WriteLine("<h1>" + " " + "Concrete Classes" + "</h1>");
            foreach (EA.Element elt in rootlist)
            {
                // MessageBox.Show("avant traitement:" + elt.Name);// pour test

                prodClass(elt,true);
            }
           
            foreach (EA.Element elt in classlists)
            {
              // MessageBox.Show("avant traitement:" + elt.Name);// pour test

                prodClass(elt,false);
            }

    
    /*************************************************
     * Datatypes
     * *********************************************/
            if (!pack.Name.Contains("contextual") && !pack.Name.Contains("Contextual"))
            {
                //------------------  ajout dec 2012  ------------------------//
                // on traite  ce niveau les datatypes et compound locaux eventuels //
                // qui sinon sont produits automatiquement  partir des classifiers des attributs 
                
                foreach (EA.Element elt in ProfileClasses)
                {                
                    //   MessageBox.Show(elt.Name + " stereo " + elt.StereotypeEx);
                    string elttype=getTypeElt(elt);            
	    
                    {
                        if (TypeList.ContainsKey(elttype))
                        {
                            if (!TypeList[elttype].Contains(elt.ElementID)) TypeList[elttype].Add(elt.ElementID);
                        }
                    }
                }

             if (is351)
             { // cas particulier du 351
                 /*************************************************
               * Primitive types types
               * ***********************************************/
                 //docfile.WriteLine("<h1>Compound types</h1>");
                 if (!iec)
                 {
                     docfile.WriteLine("<h3>Primitives</h3>");
                 }
                 foreach (EA.Element prim in listprimitive)
                 {
                     if (prim.Name == "")
                     {
                         prodPrimitiveType(prim);
                     }
                 }

                 foreach (EA.Element  prim in listprimitive)
                 {

                     if (prim.Name != "")
                     {
                         prodPrimitiveType(prim);
                     }
                         
                     
                 }

             }
                /*************************************************
                * Compound types types
                * ***********************************************/
                //docfile.WriteLine("<h1>Compound types</h1>");
             if (!iec)
             {
                 docfile.WriteLine("<h3>Datatypes</h3>");
             }
                
                if (TypeList["compound"].Count > 0)
                {
                    TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName); // pmise en ordre alphabetique
                }
                if (!iec)
                    majCompoundList(); //on explore la liste et on ajoute les compound appeles par d'aures compounds
                TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName);
                foreach (long comp in TypeList["compound"])
                {
                    prodCompoundtype(Main.Repo.GetElementByID((int)comp));
                }

                if (TypeList["datatype"].Count > 0)
                {
                    List<string> l1 = new List<string>();
                    
                    List<string> lsor=new List<string>() ;
                    foreach (long ii in TypeList["datatype"])
                    {
                        lsor.Add((repo.GetElementByID((int)ii)).Name);
                    }

                    TypeList["datatype"].Sort(RDFutilitaires.CompareElementIDsbyName);
                    List<string> lsora = new List<string>();
                    foreach (long ii in TypeList["datatype"])
                    {
                        lsora.Add(repo.GetElementByID((int)ii).Name);
                    }
                }
                if(!iec)
                foreach (long data in TypeList["datatype"])
                {

                   //18  prodDatatype(RDFutilitaires.dicelembyid[data]);
                    prodDatatype(Main.Repo.GetElementByID((int)data));
                }

                /*************************************************
               * Enumerations
               * ***********************************************/
                //docfile.WriteLine("<h1>Enumerations</h1>");
                if(!iec)
                docfile.WriteLine("<h3>Enumerations</h3>");
                if (TypeList["enumeration"].Count > 0)
                {
                    string rootclassname = "";
                    if((!(rootlist != null))&& (rootlist.Count>0)){
                    rootclassname = rootlist[0].Name; // nom de la rootclass
                    }
                    texte = "<p class=\"myparagraph\">" + "The list of enumerations used for the " + pack.Name +" is as follows:</p>";//rootclassname
                    docfile.WriteLine(texte);
                    TypeList["enumeration"].Sort(RDFutilitaires.CompareElementIDsbyName);
                }
                List<string> typelists = new List<string>();
                
                foreach (long kind in TypeList["enumeration"])
                {
                    //18 string nom = RDFutilitaires.dicelembyid[kind].Name;
                    string nom = Main.Repo.GetElementByID((int)kind).Name;
                    if(!iec)
                    if((!nom.Contains("TypeList"))
                        && (!(nom=="UnitMultiplier"))
                        && (!(nom=="UnitSymbol"))
                        )
                    {
                    //18 prodEnumeration(RDFutilitaires.dicelembyid[kind]);
                        prodEnumeration(Main.Repo.GetElementByID((int)kind));
                    }else{
                        if (!typelists.Contains(nom)) typelists.Add(nom);
                    }

                }
                if (typelists.Count > 0)
                {// il y a des enumerations de type codelist  faire apparaitre comme des listes de nom
                    texte = "<ul type=\"disc\">";
                    docfile.WriteLine(texte);
                    foreach (string n in typelists)
                    {
                        texte = "<li>" + n + "</li>";
                        docfile.WriteLine(texte);
                    }

                    texte = "</ul>";
                    docfile.WriteLine(texte);
                    
                }

            } 
            //--------
            //end of file
}
//---------------------------------------------------------------------------

        public void prodDoc(Repository repo)
        {
            //DEPRECRATED
            ProfileClasses = new List<EA.Element>();
            EA.Package pack = repo.GetTreeSelectedPackage();
            // open body
            docfile.WriteLine("<body>");
            ProfileClasses = new List<EA.Element>();
            RDFutilitaires.getTypedOneLevelElements(pack, ProfileClasses, "Class");
            ProfileClasses.Sort(RDFutilitaires.CompareElementsbyName);

            //------------------
            // titre de la suite du document
            
            string texte;
            docfile.WriteLine("---------------------------------------------------------------------");
            docfile.WriteLine("<h2>" + " " + "Document for package :"  +  pack.Name + "</h2>");
            docfile.WriteLine("---------------------------------------------------------------------");
            // table des basedon
            docfile.WriteLine("<h1>" + " " + "BasedOn classes" + "</h1>");
            //-------------------- ajout am  aout 2012  --------------------------------- 
            texte = "<p class=\"myparagraph\">" + "!#" + " shows  the traceability dependency of the classes used in this package towards the upper level.";
            ToDoc(texte, "0");
            texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table" + " !#</a>"; ;
            texte = texte + " -" + " IsBasedOn dependency";
            ToDoc(texte, "0");
            //-----------------------------------------------------------------------------

            texte = "<table>";
            docfile.WriteLine(texte);
            prodBasedOnEntete("0");
            foreach (EA.Element elt in ProfileClasses)
            {
                prodBasedOn(repo, elt, "0");
            }

            texte = "</table>";
            docfile.WriteLine(texte);
  	   texte ="<p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
            //--------
            notpureclasses = new List<string>();
            notpureclasses.Add(CD.GetEnumStereotype());
            notpureclasses.Add("Datatype");
            notpureclasses.Add(CD.GetDatatypeStereotype());
            notpureclasses.Add(CD.GetPrimitiveStereotype());
            notpureclasses.Add(CD.GetCompoundStereotype());
            notclassestereos = new List<string>(notpureclasses);
            notpureclasses.AddRange(SubprofilesStereos);

            List<EA.Element> classlists;
            texte = " List of stereotye to categorize subProfiles" + "\r\n";
            foreach (string stereo in SubprofilesStereos)
            {
                texte = texte + "     " + stereo + "\r\n";
            }
            // MessageBox.Show(texte);
            //docfile.WriteLine(texte);
            dejatrouvee = new List<long>();
            for (int ii = 0; ii < SubprofilesStereos.Count; ii++)
            {
                string stereo = SubprofilesStereos[ii];
                classlists = new List<EA.Element>();
                subprofilestereotype = stereo;
                classlists = ProfileClasses.FindAll(HasClassStereotype);
                classlists.Sort(RDFutilitaires.CompareElementsbyName);
                if (classlists.Count > 0)
                {
                    docfile.WriteLine("<h1>" + " " + "Concrete Classes" + " (" + stereo + ")" + "</h1>");
                    //docfile.WriteLine("<h1>" + " " + "Concrete Classes" + " (" + stereo + ")" + "</h1>");
                    foreach (EA.Element elt in classlists)
                    {
                        string prov = elt.Name; // pour test
                        prodClass(elt, false);
                    }
                }
            }
            // classes concretes
            classlists = new List<EA.Element>();
            classlists = ProfileClasses.FindAll(HasNotClassStereotype);
            List<EA.Element> rootlist = new List<EA.Element>();
            List<long> todelete = new List<long>();
            //short ind = 0;
            foreach (EA.Element elt in classlists)
            {
                if (elt.IsActive)
                {
                    string prov = elt.Name;
                    rootlist.Add(elt);
                }

            }

            foreach (EA.Element el in rootlist)
            {
                classlists.Remove(el);
            }



            classlists.Sort(RDFutilitaires.CompareElementsbyName);
            //-------- ajout am 2012 ----------------------------------
            //docfile.WriteLine("<h1>" + "Detailed" + " " + "|" + lepackage.Name + "|" + "</h1>");
            docfile.WriteLine("<h1>" + "Detailed" + " " + lepackage.Name  + "</h1>");
            // docfile.WriteLine("<h1>" + " " + "Concrete Classes" + "</h1>");
            foreach (EA.Element elt in rootlist)
            {
                // MessageBox.Show("avant traitement:" + elt.Name);// pour test
  
                prodClass(elt, true);
            }

            foreach (EA.Element elt in classlists)
            {
                // MessageBox.Show("avant traitement:" + elt.Name);// pour test

                prodClass(elt, false);
            }
            /*
                        docfile.WriteLine("<h1>Concrete Classes</h1>");
            

                        foreach (EA.Element elt in ProfileClasses)
                        {
                
                         //   MessageBox.Show(elt.Name + " stereo " + elt.StereotypeEx);
                            List<string> lstereos=new List<string>((elt.StereotypeEx).Split(new char[]{','}));
                notpureclasses.Add(CD.GetEnumStereotype()))
                    notpureclasses.Add("Datatype"))
                    notpureclasses.Add(CD.GetDatatypeStereotype()))
                    notpureclasses.Add(CD.GetPrimitiveStereotype()))
                    notpureclasses.Add(CD.GetCompoundStereotype())))
                {
                   // WIP.StartWip();
                    prodClass(elt);
                   // WIP.CloseWip();
                }
                        }
            */

            /**********************
             * the abstract classes
             * *******************/
            /* if (AbstractsBuffer.Length > 0)
             { // there is at least one abstract classes*/
            docfile.WriteLine("<h1>Abstract Classes</h1>");

            string aLine = null;
            //string aParagraph = null; ABA20230905
            StringReader strReader = new StringReader(AbstractsBuffer.ToString());
            while (true)
            {
                aLine = strReader.ReadLine();
                if (aLine != null)
                {
                    docfile.WriteLine(aLine);
                }
                else
                {
                    break;
                }
            }


            /*************************************************
             * Compound types types
             * ***********************************************/
            if(!iec)
            docfile.WriteLine("<h1>Compound types</h1>");
            if (TypeList["compound"].Count > 0)
            {
                TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName);
            }
            if(!iec)
            foreach (long comp in TypeList["compound"])
            {
                /* 18
                if (!RDFutilitaires.dicelembyid.ContainsKey(comp))
                {
                    EA.Element pp = repo.GetElementByID((int)comp);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error dans proddoc element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                    MessageBox.Show(" Error element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                }
                else
                {
                 * */
                    prodCompoundtype(Main.Repo.GetElementByID((int)comp));
               //18 }
            }
            /*************************************************
             * Datatypes
             * ***********************************************/
            if(!iec)
            docfile.WriteLine("<h1>Datatypes</h1>");

            if (TypeList["datatype"].Count > 0)
            {
                TypeList["datatype"].Sort(RDFutilitaires.CompareElementIDsbyName);
            }
            if(!iec)
            foreach (long data in TypeList["datatype"])

            {
                /* 18
                if (!RDFutilitaires.dicelembyid.ContainsKey(data))
                {
                    EA.Element pp = repo.GetElementByID((int)data);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error dans proddoc element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                    MessageBox.Show(" Error element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                }
                else
                {
                 * */
                    prodDatatype(Main.Repo.GetElementByID((int)data));
                //18}
            }

            /*************************************************
           * Enumerations
           * ***********************************************/
            if(!iec)
            docfile.WriteLine("<h1>Enumerations</h1>");
            if (TypeList["enumeration"].Count > 0)
            {
                string rootclassname = rootlist[0].Name; // nom de la rootclass
                 texte = "<p class=\"myparagraph\">" + "The list of enumerations used for the " + pack.Name + "is as follows:</p>";//rootclassname 
               docfile.WriteLine(texte);
                
                TypeList["enumeration"].Sort(RDFutilitaires.CompareElementIDsbyName);
            }
            if(!iec)
            foreach (long kind in TypeList["enumeration"])
            {
                /* 18
                if (!RDFutilitaires.dicelembyid.ContainsKey(kind))
                {
                    EA.Element pp = repo.GetElementByID((int)kind);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error dans proddoc element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                    MessageBox.Show(" Error element " + repo.GetPackageByID((int)pp.PackageID).Name
                               + "::" + pp.Name + "not in  dicelembyid");
                }
                else
                {
                 * */
                    prodEnumeration(Main.Repo.GetElementByID((int)kind));
                //18}
            }

            //--------
            //end of file
            /*
            docfile.WriteLine("</body>");
            docfile.WriteLine("</html>");
            docfile.Flush();
            docfile.Close();
            // reportlog.Flush();
            reportlog.Close();
             * */
        }
//----------------------------------------------------------------------------


        
        /// <summary>
        /// production of documentation for a class
        /// </summary>
        /// <param name="elt"></param>
        void prodClass(EA.Element elt,bool isroot)
        {
            string prov = elt.Name;
            /* ABA20230905 Makes no sense!!
            if (prov == "VoltageLevel")
            {
                prov = prov;
            }*/
            string texte = "";
         //MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test
            texte = "<div id=\"" + elt.Name + "\" class=\"group\">";
           //texte = "<div class=\"group\">";

            ToDoc(texte, elt.Abstract);
            //texte = "<a href=\"#" + elt.Name + "\">";
           // ToDoc(texte, elt.Abstract);


            if (elt.Abstract == "1")
            {
                string ster="";
                foreach(string stereo in SubprofilesStereos){
                    if(elt.StereotypeEx.Contains(stereo)){
                        ster=stereo;break;
                    }
                }
                if(ster==""){
               // texte = "<h2 class=\"abstract\">" + elt.Name +  "</h2>";
                 texte = "<h4 class=\"abstract\">" + elt.Name + "</h4>";
                }else{
               // texte = "<h2 class=\"abstract\">" + elt.Name + " (" + ster  + ") " + "</h2>";
                  texte = "<h4 class=\"abstract\">" + elt.Name + " (" + ster + ") " + "</h4>";
                }
                sw.WriteLine(texte);
            }
            else
            {
                string addit = "";
                if (isroot) addit = " root class";
                texte = "<h4 class=\"concrete\">" + elt.Name +  addit  + "</h4>";
                docfile.WriteLine(texte);
              
            }
           // texte = "</a>";
           // ToDoc(texte, elt.Abstract);
  //          texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[elt.PackageID]).Name + " </p>";
 //           ToDoc(texte, elt.Abstract);
           // texte = "<p class=\"myparagraph\">" + brNote(elt.Notes) + "</p>";
              texte=brpNote(elt.Notes);
            ToDoc(texte, elt.Abstract);
            //-----------------------  ajout am aout 2012---------
            prodBasedOn(repository, elt, elt.Abstract,true);
            //----------------------------------------------------
            //-----------new am
            prodClassConstraint(elt,elt.Abstract);
            //----------------
            if (elt.Connectors.Count > 0)
            {
                foreach (EA.Connector con in elt.Connectors)
                {
                    if (con.Type == "NoteLink")
                    {
                        prodNote(elt, con, elt.Abstract);
                    }


                }

            }
            List<long> atrids = new List<long>();
            /**********************
            *   natives attributes
            **********************/
          
            /****   pour test 
            if (elt.Name == "Terminal"){
                MessageBox.Show("element= terminal");
                pourtest = true;
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "trace de HtmlDocumentation " + DateTime.Now.ToString();
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        }
            ************************/

            bool native=false;
            int needtable;
            Dictionary<string, List<EA.Attribute>> subprofiles = new Dictionary<string, List<EA.Attribute>>();
            Dictionary<string, List<EA.Connector>> consubprofiles = new Dictionary<string, List<EA.Connector>>();
            if (elt.Attributes.Count > 0)
            {
                 prov = elt.Name;  // pour test
                // am treatment of subprofiles
                // we prepare as many lists as of profiles categories
          
                foreach (string stereo in SubprofilesStereos)
                {
                    subprofiles[stereo] = new List<EA.Attribute>();
                }
                subprofiles["profile"] = new List<EA.Attribute>();


       
                //------------- end of declarations

                List<EA.Attribute> atrlist = SortAttributesByName(elt.Attributes);


                foreach (EA.Attribute atr in atrlist)
                {

                    string atrname = atr.Name;
                    bool subprofile = false; // the attribute is not in a subprofile
                    string stereosenordre =   RDFLAutilitaires.RedressStereo(atr.StereotypeEx);

                    // on se rappelle que les Subprofiles stereo sont classs par ordre decroissant de longueur
                    foreach (string stereo in SubprofilesStereos)
                    {
                        if (!stereo.Contains(","))
                        {
                            //if(stereosenordre.Contains(stereo)
                            if (stereosenordre.Contains( stereo))
                            {
                                subprofiles[stereo].Add(atr);
                                subprofile = true;
                                break;
                            }
                        }
                        else
                        {
                            string sterenordre = RDFLAutilitaires.RedressStereo(stereo);
                            if (stereosenordre.Contains(sterenordre))
                            {
                                subprofiles[stereo].Add(atr);
                                subprofile = true;
                                break;
                            }
                        }

                    }
                    if (!subprofile) { subprofiles["profile"].Add(atr); }
                }
            }
            if (elt.Connectors.Count > 0)
            {
                
                foreach (string stereo in SubprofilesStereos)
                {
                    consubprofiles[stereo] = new List<EA.Connector>();
                }
                consubprofiles["profile"] = new List<EA.Connector>();

                // classifying connections
                
                bool subprofile = false;
                EA.Element otherendelt = null;
                if (pourtest)
                {
                    texte = "---------------- connectors of element  " + elt.Name + " -------------------------";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                foreach (EA.Connector con in elt.Connectors)
                {
                    subprofile = false;
                       if (pourtest)
                        {
                            texte = "--------   new connexion ------------- \r\n";
                            texte=texte+"type="+con.Type;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                    foreach (string stereo in SubprofilesStereos)

                    {   if((con.Type == "Association" )|| (con.Type == "Aggregation")){

                      

                        otherendelt=RDFutilitaires.getTheotherend(repository, elt, con);
   
                        string  otherendstereo = otherendelt.StereotypeEx;
                        
                        if (otherendstereo.Contains(stereo) || con.StereotypeEx.Contains(stereo))
                        {
                            if(!consubprofiles[stereo].Contains(con))consubprofiles[stereo].Add(con);
                            if (pourtest)
                            {
                                
                              texte = "\t otherend=" + otherendelt.Name + "," + " StereoEx=" + otherendelt.StereotypeEx;
                              // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                
                                texte = "addcon in consubprofile[" + stereo + "]";
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            }
                            subprofile = true;
                            break;
                        }
                    }
                    }
                    if (!subprofile)
                    {
                          if((con.Type == "Association" )|| (con.Type == "Aggregation"))
                            {
                        consubprofiles["profile"].Add(con);
                              
                        if (pourtest)
                        {
                            
                                texte = "\t otherend=" + otherendelt.Name + "," + " StereoEx=" + otherendelt.StereotypeEx;
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            
                            texte = "addcon in consubprofile[" + "profile" + "]";
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                              
                            }
                       
                    }
  
                }

            }

                //-------------------------

                native = false;
               
               
                foreach (string stereo in SubprofilesStereos)
                {
                    
                    if (( subprofiles.ContainsKey(stereo) && (subprofiles[stereo].Count > 0))
                        || ThereIsLegitimateConnexion(elt,consubprofiles,stereo))
                    {
                        native = true;
                        texte = "<h3>Native Members" + " (" + stereo + ")" + "</h3>";
                        ToDoc(texte, elt.Abstract);
                        texte = "<table>";
                        ToDoc(texte, elt.Abstract);
                        prodAttributeEntete("0");

			if(( subprofiles.ContainsKey(stereo) && (subprofiles[stereo].Count > 0))){
                      
                        foreach (EA.Attribute at in subprofiles[stereo])
                        {
                            atrids.Add(at.AttributeID);
                            
                            prodAttribute(elt, at, elt.Abstract);
                        }
			}
            if (native == true)
            {
                texte = "</table>";
                ToDoc(texte, elt.Abstract);
  	  texte = texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);

            }
	                                                           	
                      if(consubprofiles.ContainsKey(stereo) && (consubprofiles[stereo].Count >0)){
                        

                           needtable = 0;
                        
                         
                       foreach (EA.Connector con in consubprofiles[stereo])
                        {
                           //MessageBox.Show(" element " + elt.Name + "stereotype="+stereo+ " connector= " + con.ConnectorID.ToString() + "type= " + con.Type);
                            if ((con.Type == "Association") || (con.Type == "Aggregation"))
                            {
                                
                                prodAssoc(repository, elt, con, elt.Abstract,ref needtable);
                            }
                        }
                      // texte = "</table>";
                       //ToDoc(texte, elt.Abstract);
                      }
                        
                      if (native == true)
                      {
                          texte = "</table>";
                          ToDoc(texte, elt.Abstract);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
                          
                      }
                        
                    //  texte = "</table>";  //am 
                   //   ToDoc(texte, elt.Abstract);// am
		             	}
                }  
		

            native=false;
                  if(elt.Attributes.Count >0){
                      native = true;
                   // texte = "<h3>Native Members</h3>";
  //-------------------- ajout am  aout 2012  --------------------------------- 
texte = "<p class=\"myparagraph\">" + " !#" +" shows all attributes of " + elt.Name + ".";
                    ToDoc(texte, elt.Abstract);

 texte = "<p class=\"mytable-title\">" + addSignetTable() +  "Table " + " !#</a>";
string nompa=repository.GetPackageByID(elt.PackageID).Name;
texte = texte + " -" + " Attributes of " + nompa + "::" + elt.Name; // +".";
ToDoc(texte, elt.Abstract);
//-----------------------------------------------------------------------------
                   

                    texte = "<table>";
                    ToDoc(texte, elt.Abstract);
                    prodAttributeEntete("0");
                   if(subprofiles.ContainsKey("profile")){
                    foreach (EA.Attribute at in subprofiles["profile"])
                    {
                        atrids.Add(at.AttributeID);
                       
                        prodAttribute(elt, at, elt.Abstract);
                    }
                   }
                   if (native == true)
                   {
                       texte = "</table>";
                       ToDoc(texte, elt.Abstract);
  	  texte =" <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
                   }
                  }
                  if (consubprofiles.ContainsKey("profile") && consubprofiles["profile"].Count > 0)
                  {
                      //-------------------- ajout am  aout 2012  --------------------------------- 
                      if (consubprofiles["profile"].Count > 0)
                      {
                          

                          //-----------------------------------------------------------------------------    

                          if (!native)
                          {
                              native = true;
                              texte = "<h3>Native Members</h3>";
                              ToDoc(texte, elt.Abstract);
                          }
                          //texte = "<br/>";
                         // ToDoc(texte, elt.Abstract);
                        //  texte = "<table>";
                        //  ToDoc(texte, elt.Abstract);
                          //   }
                          if (consubprofiles.ContainsKey("profile"))
                          {
                              needtable = 0;
                              List<EA.Connector> cs = new List<EA.Connector>();
                              foreach (EA.Connector cn in consubprofiles["profile"])
                              {
                                  if(isConElligible(elt,cn))
                                      try{
                                      cs.Add(cn);
                                      }catch(Exception e){
                                          MessageBox.Show(e.Message);
                                      }

                              }

                        cs.Sort(RDFutilitaires.CompareEltConnectorsbyRoleName);
                             
                             // foreach (EA.Connector con in consubprofiles["profile"])
                              foreach (EA.Connector con in cs)
                              {
                                  //MessageBox.Show(" element " + elt.Name + " connector= " + con.ConnectorID.ToString() + "type= " + con.Type);
                                  if ((con.Type == "Association") || (con.Type == "Aggregation"))
                                  {

                                      prodAssoc(repository, elt, con, elt.Abstract, ref needtable);
                                  }
                              }

                              if (needtable > 0)
                              {
                                   texte = "</table>";
                                  ToDoc(texte, elt.Abstract);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
                              }
                          }
                      }
                  }

              texte = "</div>";
              ToDoc(texte, elt.Abstract);
        }

        void prodAttributeEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
             ToDoc(texte,isabstract);
            texte="<td>";
	      ToDoc(texte,isabstract);
        texte="<p class=\"mytable-col-heading\">" + "mult."  +   " </p>";
	  ToDoc(texte,isabstract);
          texte="</td>";
              ToDoc(texte, isabstract);
           texte="<td>";
	 ToDoc(texte,isabstract);
     texte = "<p class=\"mytable-col-heading\">" + "Attribute name / type" + " </p>";
	 ToDoc(texte,isabstract);
       texte="</td>";
	 ToDoc(texte,isabstract);
            /*
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + "Attribute type" + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
             * */
     ToDoc(texte, isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
        }

        //---------------
        void prodRestrictEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
             ToDoc(texte,isabstract);
            texte="<td>";
	      ToDoc(texte,isabstract);
        texte="<p class=\"mytable-col-heading\">" + " Name "  +   " </p>";
	  ToDoc(texte,isabstract);
          texte="</td>";
              ToDoc(texte, isabstract);
           texte="<td>";
	 ToDoc(texte,isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Constraint " + " </p>";
	 ToDoc(texte,isabstract);
       texte="</td>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Type " + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Expression of constraint " + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
        }



        void prodEnumEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Literal" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + " Code " + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
        }



        void prodAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
           // MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
            string texte;
     texte="<tr>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-cell\">" + "[" + at.LowerBound + ".."  + at.UpperBound  + "]" + "</p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
            /*
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p class=\"mytable-cell\" id=\"" + elt.Name + "." + at.Name +"\">" + at.Name+ " </p>";
	 ToDoc(texte,isabstract);
texte="</td>";            
	 ToDoc(texte,isabstract);
*/   
texte="<td class=\"type\">";
	 ToDoc(texte,isabstract);
     texte = "<p class=\"mytable-cell\" id=\"" + elt.Name + "." + at.Name + "\">" + at.Name + " </p>";
     ToDoc(texte, isabstract);
texte="<p class=\"mytable-cell\">";
	 ToDoc(texte,isabstract);
if((at.ClassifierID == 0)) //18  || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
    // attention dans certain cas un type non lie n'annule pas le ClassifierID
{
texte=at.Type;
}else{

    EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
    texte = claselt.Name;
    string type = getTypeElt(claselt);
   // MessageBox.Show(" test  cassifiername=" + texte + "type=" + type);
    if (TypeList.ContainsKey(type))
    {
        if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);
    }
}
//texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
	// ToDoc(texte,isabstract);
ToDoc(texte, isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
    // prodRestrict(elt, at, isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
texte="<p class=\"mytable-cell\">" + brNote(at.Notes) + "</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

texte="</tr>";
	 ToDoc(texte,isabstract);
        }

        /// <summary>
        /// le programme prodAttribute met a jour les listes de datatypes au fur et  mesure
        /// seuls les compound peuvent avoir des attribut de type tant eux mme des compounds
        /// on ne peut pas explorer la typelist[compound] de maniere recursive 
        /// Ce sous programe est destine  explorer tous les compounds (et uniquement les compounds
        /// de manire recursive pour mettre  jour TypeList[compound]
        /// </summary>
        /// <param name="elt"></param>
        void majCompoundList()
        {
            int nbcompound = TypeList["compound"].Count;
            List<long> locallist = new List<long>(TypeList["compound"]);

            foreach (long elid in locallist)
            {
                EA.Element elt = repository.GetElementByID((int)elid);

                foreach (EA.Attribute at in elt.Attributes)
                {
                    if (at.ClassifierID != 0)
                    {
                        EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
                        string texte = claselt.Name;
                        if (
                            (claselt.StereotypeEx.Contains(CD.GetCompoundStereotype()))
                            && (!TypeList["compound"].Contains(claselt.ElementID))
                            )
                        {
                            TypeList["compound"].Add(claselt.ElementID);
                        }
                    }
                }

            }
            if (TypeList["compound"].Count != nbcompound)
            {
                majCompoundList(); // il faut tenir compte des cascadisations successives d'o la recursion
            }
        }
//-------------------------------

        void prodInheritedAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            string texte;
texte="<tr>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"cardinality\">" + at.LowerBound + ".." + at.UpperBound + "</p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
texte="<td>";
	 ToDoc(texte,isabstract);
     string stereo = getAtrProfStereo(at);
     if (stereo == "")
     {
         texte = "<p class=\"name\">" + at.Name + " </p>";
     }
     else
     {
         texte = "<p class=\"name\">" + at.Name + " (" + stereo + ") " + " </p>";
     }
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);

texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td class=\"type\">";
	 ToDoc(texte,isabstract);
texte="<p class=\"type\">";
	 ToDoc(texte,isabstract);
     if ((at.ClassifierID == 0)) //18  || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
{
texte=at.Type;
}else{
    texte = Main.Repo.GetElementByID((int)at.ClassifierID).Name;
}
//texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
	// ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p class=\"comment\">" + at.Notes + "</p>";
//	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
ToDoc(texte,isabstract);
//texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name + "\">" + elt.Name + "</a>";
texte = "<p>" + "inherited from" +  elt.Name + "</p>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="</tr>";
	 ToDoc(texte,isabstract);
        }
        //---------------
        void prodAssocEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "mult." + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            //texte = "<p class=\"name\" >" + "Role" + " </p>";
            texte = "<p class=\"name\" >" + "Class name / Role" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            /*
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Class type name" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
             * */
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Description" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "</tr>";
            ToDoc(texte, isabstract);

        }
        void prodAssoc(Repository repo, EA.Element elt, EA.Connector con, string isabstract, ref int   needtable)
        {

            CIMSchemaGenerator.ConexesID = 0;
            /***********************************************************/
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.ConnectorEnd myend;
            EA.Element otherendelt;

            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string prov1 = otherendelt.Name;
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (myend.Aggregation != 0)
                
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                {// the association creates an effective memmber

                    string texte;

                    if (needtable == 0)
                    {
                        //------------  ajout am aout 2012
                          texte = "<p class=\"myparagraph\">" + " !#";
                          texte = texte + " shows all association ends of " + elt.Name + " with other classes.";
                          ToDoc(texte, elt.Abstract);

                          texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
                          string nompa = repository.GetPackageByID(elt.PackageID).Name;
                          texte = texte + " -" + " Association ends of " + nompa + "::" + elt.Name + " with other classes";  //+".";
                          ToDoc(texte, elt.Abstract);
                         

                          //-----------------------------------------------------------------------------    

                        texte = "<table>";
                        ToDoc(texte, elt.Abstract);
                        prodAssocEntete(elt.Abstract);
                        needtable++;
                    }

                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + "[" + cardinality + "]" + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherendelt.Name + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">";
                    ToDoc(texte, isabstract);
                    //texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                    texte = otherend.Role;
                    ToDoc(texte, isabstract);
                    texte = "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    
                    /*
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherendelt.Name + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                     * */
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">" + brNote(otherend.RoleNote) ;                           
                    ToDoc(texte, isabstract);
                    texte = "<br/>";
                    ToDoc(texte, isabstract);
                    texte = " Association Based On : " + "<br/>";
                    ToDoc(texte, isabstract);
                    texte = prodAssocIsBasedOn(repo,con)[0] + "<br/>";
                    ToDoc(texte, isabstract);
                    texte =  "\t\t-----" + "<br/>";
                    ToDoc(texte, isabstract);
                    texte =  prodAssocIsBasedOn(repo, con)[1] + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "</tr>";
                    ToDoc(texte, isabstract);

                }
            }
           
            /* ********************/
        }
//-------------------------------
      
        //-------------------------------
        void prodInheritedAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.Element otherendelt;
            EA.ConnectorEnd myend;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
                
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (myend.Aggregation != 0)
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                string texte;
                texte = "<tr>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                string stereo = getEltProfStereo(otherendelt);
                if (stereo == "")
                {
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                }
                else
                {
              texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                }
                    ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                
                texte = "<td class=\"type\">";
                ToDoc(texte, isabstract);
                texte = "<p class=\"type\">";
                ToDoc(texte, isabstract);
                //texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                texte = otherendelt.Name;
                ToDoc(texte, isabstract);
                texte = "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
//                texte = "<p class=\"comment\">" + otherend.RoleNote + "</p>";
//                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name  + "\">" + elt.Name + "</a>";
     texte = "<p>" + "inherited from" + elt.Name + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

                texte = "</tr>";
                ToDoc(texte, isabstract);
            }
        }
//------------
   void prodEnumeration(EA.Element enumelt){
       string texte = "";
       string prov = removestereo(CD.GetEnumStereotype(), enumelt.Name);
       

           //MessageBox.Show(" enumeration " + enumelt.Name);// pour test
       
           //texte="<div id=\"" + enumelt.Name +"(" +  prov + ")" + "\" class=\"group\">";
           //     docfile.WriteLine(texte);
           //texte="<a href=\"#" + enumelt.Name + "\">";
           //   docfile.WriteLine(texte);
           //texte="<h2 class=\"enumerated\">" + enumelt.Name + " enumeration" + "</h2>";
           texte = "<h4 class=\"enumerated\">" + enumelt.Name + " enumeration" + "</h4>";
           docfile.WriteLine(texte);
           //texte="</a>";
           //  docfile.WriteLine(texte);
           //texte="<p class=\"package\">"+ (RDFutilitaires.dicpackbyid[enumelt.PackageID]).Name + "</p>";
           //          docfile.WriteLine(texte);
           //prodPackage(enumelt.PackageID,"0");
           //texte="<p class=\"comment\">" + brNote(enumelt.Notes) + "</p>";
          // texte = "<p class=\"myparagraph\">" + brNote(enumelt.Notes) + "</p>";
           texte =brpNote(enumelt.Notes);
           docfile.WriteLine(texte);

           //-------------------- ajout am  aout 2012  --------------------------------- 
           if (enumelt.Name.Contains("TypeList"))
           {
               texte = "<p class=\"myparagraph\">" + " !#" + " shows examples of literals for " + enumelt.Name + ".";
           }
           else
           {
               texte = "<p class=\"myparagraph\">" + " !#" + " shows all literals of " + enumelt.Name;
           }
           docfile.WriteLine(texte);

           texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
           string nompa = repository.GetPackageByID(enumelt.PackageID).Name;
           texte = texte + " -" + " Literals of " + nompa + "::" + enumelt.Name; // +".";
           docfile.WriteLine(texte);
           //-----------------------------------------------------------------------------


           texte = "<table>";
           docfile.WriteLine(texte);
           prodEnumEntete("0");
           foreach (EA.Attribute at in enumelt.Attributes)
           {
               prodMember(enumelt, at);
           }
           texte = "</table>";
           docfile.WriteLine(texte);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";; 
           docfile.WriteLine(texte);
           texte = "</div>";
           docfile.WriteLine(texte);
       
}
   //------------
   void prodDatatype(EA.Element dataelt)
   {
       //MessageBox.Show("datatype= " + dataelt.Name);// pour test
       string texte = "";
       //texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
      // docfile.WriteLine(texte);
       //texte = "<a href=\"#" + dataelt.Name + "\">";
      // docfile.WriteLine(texte);


      // texte = "<h2>" + dataelt.Name + " datatype" + "</h2>";
       texte = "<h4>" + dataelt.Name + " datatype" + "</h4>";
       docfile.WriteLine(texte);

 //      texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";


       //texte = "<p class=\"myparagraph\">" + brNote(dataelt.Notes) + "</p>";
       texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);
       if (dataelt.Connectors.Count > 0)
       {
           foreach (EA.Connector con in dataelt.Connectors)
           {
               if (con.Type == "NoteLink")
               {
                   prodNote(dataelt, con, "0");
               }


           }

       }

       //-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------

       texte = "<table>";
       docfile.WriteLine(texte);
       prodAttributeEntete("0");
       List<EA.Attribute> listat = new List<EA.Attribute>();
       bool ilyacontraintes=false;
       foreach (EA.Attribute at in dataelt.Attributes)
       {
          // MessageBox.Show("datatype.name=" + dataelt.Name + " | at.name=" + at.Name + " | at.type=" + at.Type + " | at.notes=" + at.Notes);
           
           prodAttribute(dataelt, at, "0");
           if (at.Constraints.Count > 0) ilyacontraintes = true;
       }
       texte = "</table>";
       docfile.WriteLine(texte);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
       if (!ilyacontraintes) return; // il n'y a pas de contraintes.
       //-------------------- ajout am  mai 2013  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all restrictions applied to the attributes  of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Restrictions of attributes for  " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<div>";
       docfile.WriteLine(texte);
       texte = "<table>";
       docfile.WriteLine(texte);
       prodRestrictEntete("0");
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           prodRestrict(dataelt, at, "0");
       }
       texte = "</table>";
       docfile.WriteLine(texte);
  	  texte =" <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);
   }
   //------------
   void prodPrimitiveType(EA.Element dataelt)
   {
       //MessageBox.Show("datatype= " + dataelt.Name);// pour test
       string texte = "";
       if (dataelt.Name != "")
       {
           texte = "<h4>" + dataelt.Name + " primitive" + "</h4>";
           docfile.WriteLine(texte);
       }
       texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);   

      
      // texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>"; ;
      // docfile.WriteLine(texte);    
   }
 //------------
   void prodMember(EA.Element enumelt,EA.Attribute at)
   {
  docfile.WriteLine( "<tr>");
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"name\">" + at.Name +  "</p>");
docfile.WriteLine("</td>");
//---------------- ajout am september   2012  -------------------------------
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"cardinality\">" + " " + getEnumCode(at)+ " "  + "</p>");
docfile.WriteLine("</td>");
//---------------------------------------------------------------------------
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"comment\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("</tr>");


   }
//------------
   //------------
   void prodCompoundtype(EA.Element dataelt)
   {
       //MessageBox.Show(" compound =" + dataelt.Name);
       string texte = "";
     //  texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
      // docfile.WriteLine(texte);
      // texte = "<a href=\"#" + dataelt.Name + "\">";
     //  docfile.WriteLine(texte);

      
      
      // texte = "<h2 class=\"concrete\">" + dataelt.Name + " compound" + "</h2>";
    texte = "<h4>" + dataelt.Name + " compound" + "</h4>";
       docfile.WriteLine(texte);
       //texte = "</a>";
       //docfile.WriteLine(texte);
       //     texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
       //  docfile.WriteLine(texte);

       
      // prodPackage(dataelt.PackageID, "0");
       


       //texte = "<p class=\"myparagraph\">" + brNote(dataelt.Notes) + "</p>";
       texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);
       //-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<table>";
       docfile.WriteLine(texte);
       prodAttributeEntete("0");
       int ind = 0;
       Dictionary<int, int> dicordre = new Dictionary<int, int>();
       //int position = 0; // position dans le browser
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           //Console.WriteLine("nom attribut=" + at.Name + "::pos=" +at.Pos);

          // position = at.Pos;
           /*
            if (at.Pos > dataelt.Attributes.Count - 1)
            {
                position = dataelt.Attributes.Count - 1;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the attribute position exceeds the maximumum index it is forced to the max index");
            }
            * */
             if(!dicordre.ContainsKey(at.Pos)) dicordre.Add(at.Pos,ind);
           
           // if (!dicordre.ContainsKey(position)) dicordre.Add(position, ind);

            ind++;   
       }
        /*** ajout am juin 2014 ***/
       List<int> positions = new List<int>(); //les positions sont recopiees de l'elementdu CIM 
                                              // et ne sont pas forcement daas l'ordre croissant a partir de 0
                                              
       for (short i = 0; i < dataelt.Attributes.Count; i++)
       {
           EA.Attribute atr=(EA.Attribute)dataelt.Attributes.GetAt(i);
           if (!positions.Contains((atr.Pos)))
           {
             positions.Add(atr.Pos);
           }
       }
        /*** ajout am juin 2014 ***/
      // for ( pos = 0; pos < dataelt.Attributes.Count; pos++)
       foreach (int pos in positions) //ajout am juin 2014 
       {
           if (dicordre[pos] < dataelt.Attributes.Count)
           {
               prodAttribute(dataelt, (EA.Attribute)dataelt.Attributes.GetAt((short)dicordre[pos]), "0");
           }
           else
           {
               // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the attribute position "
               //    + dicordre[pos].ToString() + "of " + dataelt.Name  + "exceeds the maximumum index");
           }
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "<p class=\"myparagraph\">" + "##MXM##" + "</p>";
           docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
        //--------------
  void prodNote(EA.Element elt,EA.Connector con,string isabstract){
      long eid = 0;
      if (elt.ElementID == con.ClientID)
      {
          eid = con.SupplierID; // note is on the otherend of the notelink
      }
      else
      {
          eid = con.ClientID; // note is at the source end of the notelink
      }
      string note="";
      if(eid != 0){
      //18 if(RDFutilitaires.dicelembyid.ContainsKey(eid)) {
        //18  note = RDFutilitaires.dicelembyid[eid].Notes;
          note = Main.Repo.GetElementByID((int)eid).Notes;
      //18 }
      }
      char[] pourtest = note.ToCharArray();
      string prov = note;

      string texte="<p class=\"note\">-" + brNote(note) + "</p>";
               ToDoc(texte, isabstract);

  }
//------------------------
  void prodBasedOnEntete(string isabstract)
  {
      string texte;
      texte = "<tr>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\"" + "\">" + "Name" + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\"" + "\">" + "Complete IsBasedOn Path" + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);
      
  }
        /// <summary>
        /// if isabstract=="classheader" on produit la ligne
       /// IsBasedOn: directory::class
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="elt"></param>
        /// <param name="isabstract"></param>
  void prodBasedOn(EA.Repository repo,EA.Element elt, string isabstract)
  {
      string prov = elt.Name;
        /* ABA20230905 Makes no sense!!
      if (prov == "MktGeneratingUnit")
      {
          prov = prov;
      }*/
       // MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test
      
      string texte = "";
      texte = "<tr>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\" >" + elt.Name + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);

     


      texte = "<td>";
      ToDoc(texte, isabstract);
      EA.Element basedon = RDFutilitaires.getElementOriginBasedonElement(elt);
     // texte = "<p class=\"name\" >" + GetPackageContainmentPath(basedon) + "::" + elt.Name + "</p>";
      texte = "<p class=\"name\" >" + GetPackageContainmentPath(basedon) + "::" + basedon.Name + "</p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);

      texte = "</tr>";
      ToDoc(texte, isabstract);


  }
        /// <summary>
        /// pour imprimer la ligne de basedon de la table de classe
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="elt"></param>
        /// <param name="isabstract"></param>
        /// <param name="classheader"></param>
  void prodBasedOn(EA.Repository repo, EA.Element elt, string isabstract,bool classheader)
  {
      //string prov = elt.Name;
      // MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test

      string texte = "";
      if (!classheader) return; // on ne fait rien
      
      EA.Element basedon = RDFutilitaires.getElementBasedonElement(elt);
      texte = "<p class=\"name\" >" + " IsBasedOn: "; 
      EA.Package paparent=repo.GetPackageByID((int)basedon.PackageID);
     // texte=texte +   paparent.Name + "::" + basedon.Name + " </p>";
   //  texte=texte + " " +  GetPackageContainmentPath(basedon) + "::" + elt.Name ;
      texte = texte + " " + GetPackageContainmentPath(basedon) + "::" + basedon.Name;
      ToDoc(texte, isabstract);

  }
	void  prodPackage(long packid,string isabstract){
       
        // if a diagram exits and is not yet saved, it is then saved and refered to
        string prov = repository.GetPackageByID((int)packid).Name;
        if (!dicPackim.ContainsKey(packid))
        {

            //   string  pathfile = ".\\" + (RDFutilitaires.dicpackbyid[packid]).Name + ".png";
            string packname = (Main.Repo.GetPackageByID((int)packid)).Name;
           // MessageBox.Show(" prod " + packname);// pour test
           // string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + ".png";
            string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();//am june 2017
             pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + ".bmp"; //ajout am sept 2013

            string prempathfile = pathfile;
           // pathfile = nomrepimages + "\\" + packname + ".png";
            pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();//am june 2017
            pathfile = nomrepimages + "\\" + packname + ".bmp"; //ajout am sept 2013
           
            dicPackim.Add(packid, prempathfile);


            {// image does not yet exists
                EA.Collection dialcol = Main.Repo.GetPackageByID((int)packid).Diagrams;

                if (dialcol.Count > 0)
                {
                    string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;

                    project.PutDiagramImageToFile(diagramguid, pathfile, 1);

                    for (short i = 0; i < dialcol.Count; i++)
                    {
                       // pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
                        if (XMLP.GetXmlValueConfig("ImageExt") == ".emf")
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);
                        }
                        else
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        }
                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                        /*  ajout am september 2013*/
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".bmp";
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                        /***************************/ 
                    }
                }
            }
        }
           // string texte = "<p class=\"name\">";
        string texte = " <h2>";
            texte = texte + "<a href=\"" + dicPackim[packid] + "\"" + " target=\"_blanc" + "\">";
            texte = texte + (Main.Repo.GetPackageByID((int)packid)).Name + " </a></h2>";
            ToDoc(texte, isabstract);

        
        }


//------------
        /// <summary>
        /// print a texte line in the correct buffer
        /// </summary>
        /// <param name="texte"></param>
        /// <param name="abstr"></param>
        ///  abstr=1  => 
        void ToDoc(string texte, string typbuf)
        {
            switch(typbuf) {
                case "1":  // typbuf=1 classe abstraite
                    sw.WriteLine(texte);
                    break;
 
                default:
            docfile.WriteLine(texte);
                    break;
            
            }
        }


//-----------------------------------------------
     List<EA.Attribute>  SortAttributesByName(EA.Collection col){
     List<EA.Attribute> retlist=new List<EA.Attribute>();
     
	Dictionary<string,EA.Attribute> dicAtrByName= new Dictionary<string,EA.Attribute>();
	foreach(EA.Attribute at in col){
	dicAtrByName.Add(at.Name,at);
	}

	Dictionary<string,EA.Attribute>.KeyCollection keysCol =dicAtrByName.Keys;
	string[] arkeys=new string[keysCol.Count];
	keysCol.CopyTo(arkeys,0);
	Array.Sort(arkeys);

	for(int i=0;i < arkeys.Length;i++){
	 retlist.Add(dicAtrByName[arkeys[i]]);		}
    return retlist;

 }
//-----------------------------------------------
        /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void OldprodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         texte = "<td>";
         ToDoc(texte, isabstract);
            string constante=at.IsConst ? "constant=true":"";
            string statique=at.IsStatic ? "static=true" : "";
            string pardefaut = "DefaultValue=";
            if (at.IsConst || at.IsStatic)
            {
                pardefaut = "FixedValue=";
            }
            if (at.Default != "")
            {
                texte = "<p class=\"mytable-cell\">" +  pardefaut + at.Default + "</p>";
                ToDoc(texte, isabstract);
            }

            if (at.Constraints.Count > 0)
            {
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    cont = ac.Notes;
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (contenu != "")
                    {
                        texte = "<p class=\"mytable-cell\">" + " Constraint=" + contenu + "</p>";
                        ToDoc(texte, isabstract);
                    }
                }
            }
         texte="</td>";
         ToDoc(texte, isabstract);
 
     }
     /// <summary>
     /// print a column for default name of attribute, name of constraint,type of constraint and expression
     /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void prodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         
         if (at.IsConst)
         {
             texte = "<tr>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Name + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "Constant" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
                 texte = "<p class=\"mytable-cell\">" + at.Default.ToString() + "</p>";
                 ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "</tr>";
             ToDoc(texte, isabstract);            
         }

         if (at.IsStatic)
         {
             texte = "<tr>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Name + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "Fixed" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Default.ToString() + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "</tr>";
             ToDoc(texte, isabstract);
         }     
            if (at.Constraints.Count > 0)
            {
                
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + at.Name+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + ac.Name+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                    cont = ac.Notes;
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + ac.Type+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                     texte = "<td>";
                     ToDoc(texte, isabstract);
                    
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (cont != "")
                    {
                        texte = "<p class=\"mytable-cell\">"  + cont + "</p>";
                        ToDoc(texte, isabstract);
                    }
                     texte="</td>";
                  ToDoc(texte, isabstract);
                  texte = "</tr>";
                  ToDoc(texte, isabstract);
                }
            }
        
  texte = "</tr>";
           ToDoc(texte, isabstract);
     }

        //---
        /// <summary>
        /// recupere le type d'un element
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string getTypeElt(EA.Element el)
        {
            string ret="";

            if ((el.StereotypeEx.Contains(CD.GetEnumStereotype())) || (el.Type=="Enumeration")) //am nov 2015
            {
                ret = "enumeration";
            }
            if (el.StereotypeEx.Contains(CD.GetDatatypeStereotype())) ret = "datatype";
            if (el.StereotypeEx.Contains(CD.GetCompoundStereotype())) ret = "compound";
            if (el.StereotypeEx.Contains("datatype")) ret = "Datatype"; // legacy
            if((is351) && (el.StereotypeEx.Contains(CD.GetPrimitiveStereotype()))) ret = "primitive";
            return ret;
        }
        /// <summary>
        /// print a column for default value, fix value and factet
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="at"></param>
        /// <param name="isabstract"></param>
        void prodClassConstraint(EA.Element elt,string isabstract)
        {
  
            string texte;
            foreach (EA.Constraint constr in elt.Constraints)
            {
                if (constr.Type =="Invariant")
                {
                   texte = "<p class=\"note\"><b>" + "constraint:</b>" + constr.Name + "={" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, isabstract);
                }
            }

        }
        //---
        /// <summary>
        /// cree le commentaire de description sur l'AssocEnd
        /// </summary>
        /// <param name="con"></param>
        string[]  prodAssocIsBasedOn(EA.Repository repo,EA.Connector con)
        {
           
            string IBOGuid = RDFutilitaires.getBasedOnConnectoryGUID(repo,con.ConnectorGUID);
            
            EA.Connector IBOcon = repo.GetConnectorByGuid(IBOGuid);
             string[] texte={"",""};
             if (IBOcon != null)
             {
                 EA.Element source_element = repo.GetElementByID((int)IBOcon.ClientID);
                 EA.Element target_element = repo.GetElementByID((int)IBOcon.SupplierID);
                 EA.ConnectorEnd source = IBOcon.ClientEnd;
                 EA.ConnectorEnd target = IBOcon.SupplierEnd;



                 texte[0] = repo.GetPackageByID((int)source_element.PackageID).Name + "::" + source_element.Name + "." + source.Role;
                 texte[0] = texte[0] + "[" + source.Cardinality + "]";
                 texte[1] = repo.GetPackageByID((int)target_element.PackageID).Name + "::" + target_element.Name + "." + target.Role;
                 texte[1] = texte[1] + "[" + target.Cardinality + "]";
             }
             else
             {
              MessageBox.Show("WARNING there is a problem in the model the association de roles: " + "ClientRole=" + con.ClientEnd.Role + "," +"SupplierRole=" + con.SupplierEnd.Role+ "\n\r modele not build with CimSyntaxGen");
             }
            return texte;

        }
        //-------------------------------
        /// <summary>
        /// transform a string in an html string with linfeeds
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        string brNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<br/>" + split[i];
                }
                else
                {
                    ret = ret + split[i];
                }
               // ret = ret + split[i];
            }
            ret.Replace("\n"," ");
            return ret;
        }
        string brpNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                else
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                // ret = ret + split[i];
            }
            ret.Replace("\n", " ");
            return ret;
        }
        //---------------------------------------
        //-------------------------
        public bool HasClassStereotype(EA.Element elt)
        {
            // MessageBox.Show("dans HasClassStereotype: Element=" + elt.Name + " stereotypeex=" + elt.StereotypeEx + "\n" + " subprofilestereotype" + subprofilestereotype);
            bool ret = false;
            // true if element 

            if (subprofilestereotype == "Class")
            {
                if ((elt.StereotypeEx == "") || (elt.StereotypeEx.Contains("Class")))
                {
                    ret = true;
                }

            }
            if (!subprofilestereotype.Contains(","))
            {
                if (elt.StereotypeEx.Contains(subprofilestereotype))
                {
                    ret = true;
                    foreach (string stereo in notclassestereos)
                    {
                        if (elt.StereotypeEx.Contains(stereo))
                        {
                            ret = false;
                            break;
                        }
                    }
                   
                }
            }
            else
            {
                ArrayList subprofslist = new ArrayList(subprofilestereotype.Split(new char[] { ',' }));

                RDFutilitaires.setper(subprofslist);
                for (int j = 0; j < RDFutilitaires.resulpermutation.Count; j++)
                {
                    string res = "";
                    for (int i = 0; i < ((ArrayList)RDFutilitaires.resulpermutation[j]).Count; i++)
                    {
                        res = res + (string)((ArrayList)RDFutilitaires.resulpermutation[j])[i] + ",";

                    }
                    res = res.Trim(',');
                    if (elt.StereotypeEx.Contains(res))
                    {
                        ret = true;
                        foreach (string stereo in notclassestereos)
                        {
                            if (elt.StereotypeEx.Contains(stereo))
                            {
                                ret = false;
                                break;
                            }

                        }
                       
                        break;
                    }
                }
            }
                if (ret == true)
                {
                    if (!dejatrouvee.Contains(elt.ElementID))
                    {
                        dejatrouvee.Add(elt.ElementID);
                    }
                    else
                    {
                        ret = false;
                    }
                }            
            return ret;
        }
        //------------------------
        public  bool HasNotClassStereotype(EA.Element elt)
        {
            string prov = elt.Name;
            bool ret = true;
            if (elt.StereotypeEx == "") ret = true;  // obvious
            foreach (string stereo in notpureclasses)
            {
                if (elt.StereotypeEx.Contains(stereo))
                {
                    ret = false;
                    break;
                }
            }
            //MessageBox.Show("hasnotclass elt=" + elt.Name + " , stereotypes=" + elt.StereotypeEx  + " => " + ret.ToString()); // pour test
            return ret;
        }
//---------------------
        string getAtrProfStereo(EA.Attribute atr){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {

                if (RDFLAutilitaires.StereoExContainsStereo(atr.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
        //---------------------
        string getEltProfStereo(EA.Element elt){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(elt.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
//----------------------------
        bool ThereIsLegitimateConnexion(EA.Element el,Dictionary<string, List<EA.Connector>> consubprofiles,string stereo)
        {
            bool ret=false;
            if (consubprofiles.ContainsKey(stereo) && consubprofiles[stereo].Count > 0)
            {
                foreach (EA.Connector con in consubprofiles[stereo])
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        string cardinality=getOtherEndCardinality(el, con);
                        EA.ConnectorEnd otherend = (ConnectorEnd)(RDFutilitaires.getOtherend(el, con)[0]);

                        if ((cardinality == "1") || (cardinality == "1..1") || (cardinality == "0..1") || (otherend.Navigable=="Navigable"))
                        {
                            ret = true;
                            break;
                        }
                    }
                }
            }
            return ret;
        }
        //----------------------

        string getOtherEndCardinality(EA.Element el, EA.Connector con)
        {
            string cardinality = "";
            if ((con.Type == "Association") || (con.Type == "Aggregation"))
            {
                EA.ConnectorEnd end=null;
                if (con.ClientID == el.ElementID) end = con.SupplierEnd;
                if (con.SupplierID == el.ElementID) end = con.ClientEnd;
                cardinality = end.Cardinality;
                string prov = end.Role; // pour test
            }
            return cardinality;
        }

        /****
        /// <summary>
        /// les stereosEx se prsentent sous la forme de listes de
        /// string.
        /// Ce programme redonne une chaine liste o tous les membres sont dans l'ordre alaphabtique
        /// </summary>
        /// <param name="stereos"></param>
        public string RedressStereo(string stereos){
            string ret ="";
            string[] ss = stereos.Split(',');
            List<string> lss = new List<string>(ss);
            lss.Sort();
            StringBuilder newstereos = new StringBuilder();
            foreach (string s in lss)
            {
                newstereos.Append( "," + s);
            }
            ret = newstereos.ToString().Trim(',');
            return ret ;
        }
        ****/ 
         
        /// <summary>
        /// les stereotype peuvent tre constitu d'une composition
        /// exemple "ShortCircuit,Entsoe"
        /// suivant la maniere dont on les range il faut les comparer
        /// </summary>
        /// <param name="stereos"></param>
        public bool CompareCompositeStereo(string stereo1, string stereo2)
        {

            if (stereo1.Length != stereo2.Length) return false;
            if (!stereo1.Contains(",") && !stereo2.Contains(",")) return stereo1 == stereo2;
            {// il s'agit bien de  chaines composees
                string[] ss1 = stereo1.Split(',');
                List<string> lss1 = new List<string>(ss1);
                lss1.Sort();
                string[] ss2 = stereo2.Split(',');
                List<string> lss2 = new List<string>(ss1);
                lss2.Sort();
                if (lss1.Count != lss2.Count) return false;
                for (int i = 0; i < lss1.Count; i++)
                {
                    if (lss1[i] != lss2[i]) return false;
                }
                return true;
            }
        }
        string removestereo(string stereo, string ss)
        {
            if(!ss.Contains(stereo)) return ss;
            int l = stereo.Length;
            int index = ss.IndexOf(stereo);
            return (ss.Remove(index, index)).Trim(',');
        }

        /**
        /// <summary>
        /// verifie si un StereoEx d'un element contient un stereo
        /// qui peutetre une chaine comme "Entsoe,ShortCircuit"
        /// </su<param name="stereo"></param>mmary>
        /// 
        /// <param name="stereoex"></param>
        /// <returns></returns>
        bool StereoExContainsStereo(string stereoex, string stereo)
        {
            bool ret = false;
            if (!stereo.Contains(","))
            {
                if (stereoex.Contains(stereo))
                {
                    ret = true;
                }
            }
            else
            {
                if (!stereoex.Contains(","))
                {
                    ret = false;
                }
                else
                {

                    stereo = RedressStereo(stereo);
                    stereoex = RedressStereo(stereoex);

                    if (stereoex.Contains(stereo))
                    {
                        ret = true;
                    }
                }
            }
            return ret;
        } 
          **/
        //--------------------------------
        static string addSignetTable()
        {
            string texte = "";
            rgtable++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;
            texte= "<a name=\"" + basesignet + compteursgnt.ToString() + rgtable.ToString()+ "\">";
            return texte;

        }
        static string addSignetFigure()
        {
            string texte = "";
            rgtable++;
           // rgfigure++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;// pour se distinguer d'une table dclare au meme moment
            texte = "<a name=\"" + basesignet + compteursgnt.ToString() + rgfigure.ToString() + "\">";
            return texte;

        }
        string getEnumCode( EA.Attribute at)
        {
            string resul = "";
            foreach (EA.AttributeTag tag in at.TaggedValues)
            {
                if (tag.Name == CD.GetEnumCodeTag())
                {
                    resul = tag.Value;
                }
            }
            return resul;
        }
        //---------------
        public bool isConElligible(EA.Element el, EA.Connector con)
        {
            //bool resul = false;
            if ((con.Type != "Association") && (con.Type != "Aggregation")) return false;
            if ((el.ElementID == con.SupplierID) && (con.SupplierEnd.Aggregation == 1)
                && (con.ClientEnd.Role != ""))
            {
                return true;
            }
            if ((el.ElementID == con.ClientID) && (con.ClientEnd.Aggregation == 1)
               && (con.SupplierEnd.Role != ""))
            {
                return true;
            }
            return false;
        }

        void crePackageImage(EA.Package pack)
        {
            string texte="";
            string packname=pack.Name;
            EA.Collection dialcol = pack.Diagrams;

            if (dialcol.Count > 0)
            {
                string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;
                string pathfile = nomrepimages;
                project.PutDiagramImageToFile(diagramguid, pathfile, 1);

                for (short i = 0; i < dialcol.Count; i++)
                {
                   // pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                    pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
                    if (XMLP.GetXmlValueConfig("ImageExt") == "emf")
                    {
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);
                    }
                    else
                    {
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                    }
                    repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    /**** ajout am september 2013    **/
                    pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".bmp";
                    project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                    repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    /**********************************/
                    string nomdiag=((EA.Diagram)dialcol.GetAt(i)).Name;
                    if (!(nomdiag.Contains("IsBasedOn")))
                    {
               
                        //texte = "<img src=\"" + nomrepimages + "\\" + packname + "_" + packname + ".png\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte.Replace(" ", "%20");
                        //ToDoc(texte, "0");
                         //texte = "<img class=\"myparagraph\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".png\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte = "<img class=\"myparagraph\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte = "<img class=\"myfigure\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        texte = "<img class=\"myfigure\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag  + XMLP.GetXmlValueConfig("ImageExt") + "\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        ToDoc(texte, "0"); 
                    }
                }
            }
        }
        //-------------------------------
        /// <summary>
        /// get the Package path  in which the object on which 
        /// the element  is situated
        /// </summary>
        /// <param name="el"></param>
        /// <returns>string path of Packages hierarchie
        ///          </returns>
        public  string GetPackageContainmentPath(EA.Element el)
        {
            string retour = "";

            try
            {

                if (el != null)
                {

                    List<String> chemin = new List<String>();
                    DirectPackageContainmentPath(repository.GetPackageByID(el.PackageID), chemin);
                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                    {
                        bchemin.Append("::" + name);
                    });

                    retour = bchemin.ToString().TrimStart(new char[]{':'});
                    return retour;
                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return retour;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Error  GetPackageBasedOnContainmentPath " + e.Message + "\n");
                return retour;
            }
        }
        //--------------------------------------------------------
        /// <summary>
        /// calculate the Package containment from a given Package
        /// the result is in the form of a string list in reverse order
        /// </summary>
        /// <param name="pa"></param>
        /// <param name="path"></param>
         void DirectPackageContainmentPath(EA.Package pa, List<String> path)
        {
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
            {
                DirectPackageContainmentPath(repository.GetPackageByID(pa.ParentID), path);

            }
        }
         public List<EA.Element> buildListPrimitive(EA.Package pack)
         {
             List<EA.Element> ret = new List<Element>();
             RDFutilitaires.getAllElements(pack, ret, "Primitive");
             return ret;
         }
//-------------------------------------------------------------------------------------------------------
    }
}
