using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using Microsoft.Win32;
using System.Reflection;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{

    class HtmlEsmpSpecificDocumentation
    {

       public  StreamWriter reportlog;  //for logs


        string nomfichier = ""; // file to write the documentation
	string nomrepimages=""; // directory for images for the documentation
        public StreamWriter docfile;
        static bool iec = false; // permet une edition sans datatype
        static List<EA.Element> ProfileClasses;
        static StringBuilder AbstractsBuffer = new StringBuilder();
        static EA.Package lepackage = null;
        static string basesignet = "ESMP_"; // entete de signets
        static int rgtable = 0;
        static int rgfigure = 0;
        static long compteursgnt = 0; // compteur pour signet
        StringWriter sw = new StringWriter(AbstractsBuffer);    
        Dictionary <string,List<long>> TypeList;// string, elementID
   
            Dictionary<long, string> dicNoteforClass;
        ConstantDefinition CD = new ConstantDefinition();
	Dictionary<long,string> dicPackim;
  	  Repository repository;
	EA.Project project;
    List<string> notpureclasses;  // to be used by find predicates
    List<string> notclassestereos; // sterotypes of objects different from classes (ex: enumeration or datattype)
    string subprofilestereotype;  // to be used by find predicates
    List<string> SubprofilesStereos; // list of non cim stereotypes
    List<long> dejatrouvee;// liste des  classes deja traitee (evite de dupliquer les traitement de multiples stereotypes)
    public List<EA.Element> listprimitives; // list des primitives 

    bool pourtest = false;
	XMLParser XMLP;
        private static string HTML_HEADER_FILE = @"DocHtmlEsmpHeader.txt";



        //---------------------------------------------------------
        /// <summary>
        /// constructor with several initialisations
        /// iec  allows complete or partial contextual class publication
        /// </summary>
        public HtmlEsmpSpecificDocumentation(EA.Repository repo,bool premierepasse)
        {
            iec =premierepasse;
            repository = repo;
            XMLP = new XMLParser(repo);
            CIMSchemaGenerator.Repos = repo;
            rgtable = 0;
	    project = repository.GetProjectInterface();

            EA.Package pack = repo.GetTreeSelectedPackage();
            lepackage = pack;
            //basesignet = pack.Name.Replace(' ', '_');
          
            try
            {
               // RegistryKey eaReg = Registry.CurrentUser.OpenSubKey("Software\\Sparx Systems\\EAAddins\\CimSyntaxGen");
               // string path = (string)eaReg.GetValue("RessourcesFolder");
                //string path;
                //nomfichier = RDFutilitaires.SelectFile("html");
                if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")
                {
                    nomfichier = XMLP.GetXmlValueProfData("HtmlEsmpSpecificDocumentationFilePath");
                    if ((nomfichier == null) || (nomfichier == "")) throw new Exception(" Error in the configfile for HtmlDocumentationFilePath ");
                }
                else
                {
                    nomfichier = RDFutilitaires.SelectFile("html");
                }
                //path = FileManager.GetParentDirPath(); ABA20230830
                //path = path + "\\DocHtmlEsmpHeader.txt";
                //System.IO.File.Copy(path, nomfichier, true);

                Assembly myAssembly = Assembly.GetExecutingAssembly(); // ABA20230830
                Stream stream = myAssembly.GetManifestResourceStream("CimSyntaxGen.Resources." + HTML_HEADER_FILE);
                FileManager.CopyStream(stream, nomfichier);

                docfile = System.IO.File.AppendText(nomfichier);
                 string [] split = Path.GetFileName(nomfichier).Split(new char[]{'.'});

                 nomrepimages = Path.GetDirectoryName(nomfichier) + "\\" + split[0] + "_images";
 		if(Directory.Exists(nomrepimages)) Directory.Delete(nomrepimages,true);
		Directory.CreateDirectory(nomrepimages);
          //18 reportlog = new StreamWriter(Path.GetDirectoryName(nomfichier) + "\\" + split[0] +"log.txt");
        reportlog = Main.reportlog;  
                RDFutilitaires.reportlog = reportlog;



                ProfileClasses = new List<EA.Element>();
                EA.Collection modellist = repo.Models;
                EA.Package toppack;
                toppack = null;
                foreach (EA.Package mod in modellist)
                {
                    toppack = mod;  // the root package
                }
                
                RDFutilitaires.buildDicsElem(toppack);
                listprimitives=buildListPrimitive(toppack);

     		dicPackim=new Dictionary<long,string>();
              AbstractsBuffer = new StringBuilder();
              sw = new StringWriter(AbstractsBuffer);
              TypeList= new Dictionary<string,List<long>>();
              TypeList.Add("datatype", new List<long>());
              TypeList.Add("enumeration", new List<long>());
              TypeList.Add("compound", new List<long>());
              TypeList.Add("primitive", new List<long>());
            }         

            catch (Exception e)
            {
                MessageBox.Show("An exception occured while reading the DocHtmlHeader.txt :" + e.Message);
            }

        }
        public void prodDoc(Repository repo,EA.Package pack)
        {
    
            docfile.WriteLine("<body>");
            ProfileClasses = new List<EA.Element>();
            RDFutilitaires.getTypedElements(pack, ProfileClasses, "Class");
           ProfileClasses.Sort(RDFutilitaires.CompareElementsbyName);
            //------------------- am novembre 2012 ---------------------------
            //  production de l'entete du document et preparation de l'insertion de l'image
            //  l'image est sauvegardee selon le nom du package
           docfile.WriteLine("<h2>" + pack.Name + "</h2>"); 
            docfile.WriteLine(" <h3> Overview of the model </h3>");
             docfile.WriteLine("<p class=\"myparagraph\">!# shows the model. </p> ");
             docfile.WriteLine("<p class=\"myfigure\">"); // pour que l'image prenne le style figure
            crePackageImage(pack);
            docfile.WriteLine("</p>");
            docfile.WriteLine("<p class=\"myparagraph\">  </p>"); // une ligne sous la figure
            docfile.WriteLine("<p class=\"myfigure-title\">" + addSignetFigure() + "Figure" + " !#</a>  - " + pack.Name + "</p>");
            //------------------------------------------------------------------
            //------------------
            // table des basedon
           string texte;
           docfile.WriteLine("<h3>" + " " + "IsBasedOn relationships from the European style market profile" + "</h3>");
           //-------------------- ajout am  aout 2012  --------------------------------- 
          // texte = "class=\"myparagraph\">" + "!#"  + " shows  the traceability dependency of the classes used in this package towards the upper level.";
           texte = "<p class=\"myparagraph\"> !#" + " shows  the traceability dependency of the classes used in this package towards the upper level." + "</p>";
            ToDoc(texte, "0");
           texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table" + " !#</a>"; 
           texte = texte + " -" + " IsBasedOn dependency</p>";
           ToDoc(texte, "0");
           //-----------------------------------------------------------------------------
           
           texte = "<table>";
           docfile.WriteLine(texte);
           prodBasedOnEntete("0");
           foreach (EA.Element elt in ProfileClasses)
           {
               prodBasedOn(repo, elt, "0");
           }

           texte = "</table>";
           docfile.WriteLine(texte);
	   texte = "<p class=\"myparagraph\">" + "##MXM##" + "</p>";
           docfile.WriteLine(texte);
            //--------
        notpureclasses = new List<string>();
        notpureclasses.Add(CD.GetEnumStereotype());
        notpureclasses.Add("Datatype");
        notpureclasses.Add(CD.GetDatatypeStereotype());
        notpureclasses.Add(CD.GetPrimitiveStereotype());
        notpureclasses.Add(CD.GetCompoundStereotype());
        

        List<EA.Element> classlists;
            texte=" List of stereotye to categorize subProfiles" +"\r\n";

   
        dejatrouvee = new List<long>();
     
            // classes concretes
             classlists = new List<EA.Element>();
             classlists = ProfileClasses.FindAll(HasNotClassStereotype);
             List<EA.Element> rootlist = new List<EA.Element>();
             List<long> todelete = new List<long>();
             foreach (EA.Element elt in classlists)
             {
                 if (elt.IsActive)
                 {
                     string prov = elt.Name;
                     rootlist.Add(elt); 
                 }
                
             }
            
             foreach (EA.Element el in rootlist)
             {
                 classlists.Remove(el);
             }
            


            classlists.Sort(RDFutilitaires.CompareElementsbyName);
           if(!iec)
		{
            if(pack.Name.Contains("contextual")) return; // pour le contextual on s'arrete au schema du modele
           }
	   docfile.WriteLine("<h3>" + "Detailed" + " "  + pack.Name  + "</h3>");
            foreach (EA.Element elt in rootlist)
            {
                // MessageBox.Show("avant traitement:" + elt.Name);// pour test

                prodClass(elt,true);
            }
           
            foreach (EA.Element elt in classlists)
            {
              // MessageBox.Show("avant traitement:" + elt.Name);// pour test
                if(!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return;
                prodClass(elt,false);
            }


            getAllProfilePrimitivesFromDatatype();

    /*************************************************
     * Datatypes
     * *********************************************/
            if (!pack.Name.Contains("contextual") && !pack.Name.Contains("Contextual"))
            {
                /******************************************
                           Primitives
                    ********************************************/
                if (iec)
                { // cas particulier du contextual and assembly
                    /*************************************************
                  * Primitive types types
                  * ***********************************************/
                    //docfile.WriteLine("<h1>Compound types</h1>");
                   

                    if ((TypeList["primitive"].Count > 0))
                    {
                        TypeList["primitive"].Sort(RDFutilitaires.CompareElementIDsbyName);// am avril 2016 
                        docfile.WriteLine("<h3>Primitives</h3>");
                    }
                    foreach (long primid in TypeList["primitive"])
                    {
                        EA.Element prim = repo.GetElementByID((int)primid);
                        if (prim.Name == "")
                        {
                            // prodPrimitiveType(prim);
                            continue;
                        }
                        else
                        {
                            prodPrimitiveType(prim);
                        }
                    }


                }
                // on traite  ce niveau les datatypes et compound locaux eventuels //
                // qui sinon sont produits automatiquement  partir des classifiers des attributs 

                foreach (EA.Element elt in ProfileClasses)
                {
                    //MessageBox.Show(elt.Name + " stereo " + elt.StereotypeEx);
                    string elttype = getTypeElt(elt);

                    {
                        if (TypeList.ContainsKey(elttype))
                        {
                            if (!TypeList[elttype].Contains(elt.ElementID)) TypeList[elttype].Add(elt.ElementID);
                        }

                    }
                }

                RDFLAutilitaires.wtest("TEST", " ligne 287 count" + TypeList.Count.ToString());
                /*************************************************
                * Compound types types
                * ***********************************************/
                 
                if ((TypeList["compound"].Count > 0) || (TypeList["datatype"].Count > 0))
                {
                   
                    RDFLAutilitaires.wtest("TEST", " avant maj nbcompound=" + TypeList["compound"].Count.ToString() + " nbdatatype=" + TypeList["datatype"].Count.ToString()    );
                    majDatatypeList(); //on explore la liste et on ajoute les compound appeles par d'aures compounds am avril 2016
                    RDFLAutilitaires.wtest("TEST", " apres maj nbcompound=" + TypeList["compound"].Count.ToString() + " nbdatatype=" + TypeList["datatype"].Count.ToString());
                   
                    if ((TypeList["compound"].Count > 0))
                    {
                        TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName);// am avril 2016 
                    }

                    if (TypeList["datatype"].Count > 0)
                    {
                 TypeList["datatype"].Sort(RDFutilitaires.CompareElementIDsbyName);//am avril 2016
                    }

                    docfile.WriteLine("<h3>Datatypes</h3>");
                    if (pack.Name.Contains("assembly"))
                    {
                        texte = "<p class=\"myparagraph\">" + "The list of datatypes  used for the " + pack.Name + " is as follows:</p>";//rootclassname
                        docfile.WriteLine(texte);
                    }

                   // TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName); // pmise en ordre alphabetique am avril 2016
                    {// il y a des compounds faire apparaitre comme des listes de nom
                        texte = "<ul type=\"disc\">";
                        docfile.WriteLine(texte);
                    }
                    // majCompoundList(); //on explore la liste et on ajoute les compound appeles par d'aures compounds am avril 2016
                    // TypeList["compound"].Sort(RDFutilitaires.CompareElementIDsbyName); am avril 2016
                    foreach (long comp in TypeList["compound"])
                    {
                        /*18
                        if (!RDFutilitaires.dicelembyid.ContainsKey(comp))
                        {
                            EA.Element pp = repo.GetElementByID((int)comp);
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error dans proddoc element " + repo.GetPackageByID((int)pp.PackageID).Name
                                       + "::" + pp.Name + "not in  dicelembyid");
                            MessageBox.Show(" Error element " + repo.GetPackageByID((int)pp.PackageID).Name
                                       + "::" + pp.Name + "not in  dicelembyid");
                        }
                         else
                       // {
                            */
                            if (pack.Name.Contains("assembly") && !iec)
                            {// traitement special pour assembly dans le cas de ENTSOEDocumentation
                               //18 texte = "<li>" + RDFutilitaires.dicelembyid[comp].Name + " compound" + "</li>";
                                texte = "<li>" + Main.Repo.GetElementByID((int)comp).Name + " compound" + "</li>";
                                docfile.WriteLine(texte);
                            }
                            else
                            {
                                if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return;
                                //18 prodCompoundtype(RDFutilitaires.dicelembyid[comp]);
                                prodCompoundtype(Main.Repo.GetElementByID((int)comp));
                            }
                        //18 }


                    }

                    //docfile.WriteLine("<h1>Datatypes</h1>");
                    RDFLAutilitaires.wtest("TEST", " datatype TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                    if (TypeList["datatype"].Count > 0)                  
                    {
                       // TypeList["datatype"].Sort(RDFutilitaires.CompareElementIDsbyName);//am avril 2016
                   //     RDFLAutilitaires.wtest("TEST", "apres sort TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                        foreach (long data in TypeList["datatype"])
                        {

                            RDFLAutilitaires.wtest("TEST", "TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());

                            if ((pack.Name.Contains("assembly")) && (!iec)) // on a juste besoin d'editer la liste des datattypes et compounds
                            {
                               //18  RDFLAutilitaires.wtest("TEST", " pour" + RDFutilitaires.dicelembyid[data].Name + " TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                                RDFLAutilitaires.wtest("TEST", " pour" + Main.Repo.GetElementByID((int)data).Name + " TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                                // traitement special pour assembly
                               //18  string codelist = getCodelist(RDFutilitaires.dicelembyid[data]);
                                string codelist = getCodelist(Main.Repo.GetElementByID((int)data));
                                if (codelist == "")
                                {
                                    texte = "<li>" + Main.Repo.GetElementByID((int)data).Name + " datatype" + "</li>";
                                }
                                else
                                {
                                   //18  texte = "<li>" + RDFutilitaires.dicelembyid[data].Name + " datatype" + ", codelist " + codelist +  "</li>";
                                    texte = "<li>" + Main.Repo.GetElementByID((int)data).Name + " datatype" + ", codelist " + codelist + "</li>";
                                }
                                docfile.WriteLine(texte);
                                if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return;
                               //18  prodDatatypeForAssembly(RDFutilitaires.dicelembyid[data]); // alimente TypeList[enumeration] si necessaire
                                prodDatatypeForAssembly(Main.Repo.GetElementByID((int)data)); // alimente TypeList[enumeration] si necessaire
                            }
                            else
                            {
                            //18  RDFLAutilitaires.wtest("TEST", " pour " + RDFutilitaires.dicelembyid[data].Name  +"TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                                RDFLAutilitaires.wtest("TEST", " pour " + Main.Repo.GetElementByID((int)data).Name + "TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());
                             if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return;
                                //18 prodDatatype(RDFutilitaires.dicelembyid[data]);
                             prodDatatype(Main.Repo.GetElementByID((int)data));
                            }
                           //18  RDFLAutilitaires.wtest("TEST", " apre trait " + RDFutilitaires.dicelembyid[data].Name + "TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());  
                            RDFLAutilitaires.wtest("TEST", " apre trait " + Main.Repo.GetElementByID((int)data).Name + "TypeList[datatype].Count" + TypeList["datatype"].Count.ToString());    
                        }

                    }
                    if (pack.Name.Contains("assembly")) // on a juste besoin d'editer la liste des datattypes et compounds
                    {
                        // traitement special pour assembly
                        texte = "</ul>";
                        docfile.WriteLine(texte);
                    }
                }
                RDFLAutilitaires.wtest("TEST", " apres traitement datatype");
                /*************************************************
               * Enumerations
               * ***********************************************/
                if (TypeList["enumeration"].Count > 0)
                {
                   
                    TypeList["enumeration"].Sort(RDFutilitaires.CompareElementIDsbyName);

                }

                List<string> typelists = new List<string>();
                bool avecenumeration = false;
                foreach (long kind in TypeList["enumeration"])
                {
                    //18 string nom = Main.Repo.GetElementByID((int)kind).Name;
                    string nom = Main.Repo.GetElementByID((int)kind).Name;
                    if ((!nom.Contains("TypeList"))
                      && (!(nom == "UnitMultiplier"))
                      && (!(nom == "UnitSymbol"))
                      )
                    {
                        avecenumeration = true;
                        continue;
                    }
                    else
                    {
                        if (!typelists.Contains(nom)) typelists.Add(nom);
                    }
                }

                if ((avecenumeration) && (iec))  // pas vrai pour ENTSOE doc
                {
                    docfile.WriteLine("<h3>Enumerations</h3>");
                    texte = "<p class=\"myparagraph\">" + "The list of enumerations used for the " + pack.Name + " is as follows:</p>";//rootclassname
                    docfile.WriteLine(texte);
                }else{
                    if ((typelists.Count > 0) && (iec))
                    {
                        docfile.WriteLine("<h3>Enumerations</h3>");
                        texte = "<p class=\"myparagraph\">" + "The list of enumerations used for the " + pack.Name + " is as follows:</p>";//rootclassname
                        docfile.WriteLine(texte);
                    }
                }
                
               // if ((TypeList["enumeration"].Count > 0) && (typelists.Count != TypeList["enumeration"].Count))          
                if (iec)
                {
                    foreach (long kind in TypeList["enumeration"])
                    {
                        //18 string nom = RDFutilitaires.dicelembyid[kind].Name;
                        string nom = Main.Repo.GetElementByID((int)kind).Name;
                        if ((!nom.Contains("TypeList"))
                          && (!(nom == "UnitMultiplier"))
                          && (!(nom == "UnitSymbol"))
                          )
                        {
                            if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return;
                            //18 prodEnumeration(RDFutilitaires.dicelembyid[kind]);
                            prodEnumeration(Main.Repo.GetElementByID((int)kind));
                        }

                    }
                }
     if (iec) // vrai si pas doc entso-E
     {
         if (typelists.Count > 0)
         {// il y a des enumerations de type codelist  faire apparaitre comme des listes de nom
             texte = "<ul type=\"disc\">";
             docfile.WriteLine(texte);
             foreach (string n in typelists)
             {
                 texte = "<li>" + n + "</li>";
                 docfile.WriteLine(texte);
             }

             texte = "</ul>";
             docfile.WriteLine(texte);

         }
     }
                 

            }// fin du test d'exclusion de contextual
            //--------
            //end of file
            /*
            docfile.WriteLine("</body>");
            docfile.WriteLine("</html>");
            docfile.Flush();
            docfile.Close();
            // reportlog.Flush();
            reportlog.Close();
             * */
}



        
        /// <summary>
        /// production of documentation for a class
        /// </summary>
        /// <param name="elt"></param>
        void prodClass(EA.Element elt, bool isroot)
        {
            string prov = elt.Name;
            /* ABA20230905 Makes no sense!!
            if (prov == "VoltageLevel")
            {
                prov = prov;
            }*/
            string texte = "";
            texte = "<div id=\"" + elt.Name + "\" class=\"group\">";
            ToDoc(texte, elt.Abstract);

            string addit = "";
            if (isroot) addit = " root class";
            texte = "<h4 class=\"concrete\">" + elt.Name + addit + "</h4>";
            docfile.WriteLine(texte);
            texte = brpNote(elt.Notes);
            ToDoc(texte, elt.Abstract);
            //-----------------------  ajout am aout 2012---------
            // prodBasedOn(repository, elt, elt.Abstract,true);
            //----------------------------------------------------
            //-----------new am
            prodClassConstraint(elt, elt.Abstract);
            //----------------
            if (elt.Connectors.Count > 0)
            {
                foreach (EA.Connector con in elt.Connectors)
                {
                    if (con.Type == "NoteLink")
                    {
                        prodNote(elt, con, elt.Abstract);
                    }


                }

            }
            List<long> atrids = new List<long>();
            /**********************
            *   natives attributes
            **********************/

            /****   pour test 
            if (elt.Name == "Terminal"){
                MessageBox.Show("element= terminal");
                pourtest = true;
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "trace de HtmlDocumentationSpecific " + DateTime.Now.ToString();
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "*********************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        }
            ************************/

            bool native = false;
            int needtable;


            List<EA.Attribute> atrlist = new List<EA.Attribute>();
            if (elt.Attributes.Count > 0)
            {
                prov = elt.Name;  // pour test

                //------------- end of declarations

               // atrlist = SortAttributesByName(elt.Attributes);
                atrlist = SortAttributesByOrder(elt.Attributes);
            }

            //-------------------------

            List<EA.Connector> cs = new List<EA.Connector>();

            foreach (EA.Connector cn in elt.Connectors)
            {
                if (isConElligible(elt, cn))
                    try
                    {
                        cs.Add(cn);
                    }
                    catch (Exception e)
                    {
                        MessageBox.Show(e.Message);
                    }

            }
          //  cs.Sort(RDFutilitaires.CompareEltConnectorsbyRoleName);
            cs.Sort(RDFutilitaires.CompareEltConnectorsbyOrder);

            if (elt.Attributes.Count > 0)
            {
                native = true;
                texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + elt.Name + ".";
                ToDoc(texte, elt.Abstract);

                texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
                string nompa = repository.GetPackageByID(elt.PackageID).Name;
                texte = texte + " -" + " Attributes of " + nompa + "::" + elt.Name; // +".";
                ToDoc(texte, elt.Abstract);
                //-----------------------------------------------------------------------------


                texte = "<table>";
                ToDoc(texte, elt.Abstract);
                prodAttributeEntete("0");

                foreach (EA.Attribute at in atrlist)
                {
                    atrids.Add(at.AttributeID);

                    prodAttribute(elt, at, elt.Abstract);
                }
                texte = "</table>";
                ToDoc(texte, elt.Abstract);
                texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>"; ;
                docfile.WriteLine(texte);
            }

            if (cs.Count > 0) // il y a des connecteurs valides
            {
                needtable = 0;
                foreach (EA.Connector con in cs)
                {

                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {

                        prodAssoc(repository, elt, con, elt.Abstract, ref needtable);
                    }
                }

                if (needtable > 0)
                {
                    texte = "</table>";
                    ToDoc(texte, elt.Abstract);
                    texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>"; ;
                    docfile.WriteLine(texte);
                }
            }
            texte = "</div>"; ;
            docfile.WriteLine(texte);
        }
//---------------
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sansordre"></param>
        void prodAttributeEntete(string sansordre)
        {
            string texte;
            texte = "<tr>";
             ToDoc(texte,"0");
             if (sansordre != "1")
             {
                 texte = "<td>";
                 ToDoc(texte, "0");
                 texte = "<p class=\"mytable-col-heading\">" + "Order" + " </p>";
                 ToDoc(texte, "0");
                 texte = "</td>";
                 ToDoc(texte, "0");
             }
            texte="<td>";
	      ToDoc(texte,"0");
        texte="<p class=\"mytable-col-heading\">" + "mult."  +   " </p>";
	  ToDoc(texte,"0");
          texte="</td>";
              ToDoc(texte, "0");
           texte="<td>";
	 ToDoc(texte,"0");
     texte = "<p class=\"mytable-col-heading\">" + "Attribute name / Attribute type" + " </p>";
	 ToDoc(texte,"0");
       texte="</td>";
	 ToDoc(texte,"0");
     
     texte = "<td>";
     ToDoc(texte, "0");
     texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
     ToDoc(texte, "0");
     texte = "</td>";
     ToDoc(texte, "0");
        }

        //---------------
        void prodRestrictEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
             ToDoc(texte,isabstract);
            texte="<td>";
	      ToDoc(texte,isabstract);
        texte="<p class=\"mytable-col-heading\">" + " Name "  +   " </p>";
	  ToDoc(texte,isabstract);
          texte="</td>";
              ToDoc(texte, isabstract);
           texte="<td>";
	 ToDoc(texte,isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Constraint " + " </p>";
	 ToDoc(texte,isabstract);
       texte="</td>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Type " + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"mytable-col-heading\">" + " Expression of constraint " + " </p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
     ToDoc(texte, isabstract);
        }



        void prodEnumEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Literal" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + " Code " + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"mytable-col-heading\">" + "Description" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
        }


//--------
        /// <summary>
        /// pour produire un attribut
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="at"></param>
        /// <param name="sansordre"></param> imprime les attributs sans ordre si = "1"
        void  prodAttribute(EA.Element elt, EA.Attribute at,string sansordre)
        {
            //MessageBox.Show("elt.Name=" + elt.Name + " at.name=" + at.Name + " at.type=" + at.Type);// + "at.notes=" + at.Notes);
            string texte;
            if(at.Type=="StreetAddress")
            { 
                string prov = at.Name;
            }
     texte="<tr>";
	 ToDoc(texte,"0");

    if(sansordre !="1")
            {
     texte = "<td>";
     ToDoc(texte, "0");
     texte = "<p class=\"mytable-cell\">" + RDFutilitaires.getAtRang(at).ToString() + "</p>";
     ToDoc(texte, "0");
     texte = "</td>";
     ToDoc(texte, "0");
        }
     texte = "<td>";
     ToDoc(texte, "0");
     texte = "<p class=\"mytable-cell\">" + "[" + at.LowerBound + ".."  + at.UpperBound  + "]" + "</p>";
     ToDoc(texte, "0");
     texte = "</td>";
     ToDoc(texte, "0");
texte="<td>";
	 ToDoc(texte,"0");
texte="<p class=\"mytable-cell\" id=\"" + elt.Name + "." + at.Name +"\">" + at.Name+ " </p>";
	 ToDoc(texte,"0");
     texte = "<p class=\"mytable-cell\">";
     ToDoc(texte, "0");
     if ((at.ClassifierID == 0)) // || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
     // attention dans certain cas un type non lie n'annule pas le ClassifierID
     {
         texte = at.Type;
     }
     else
     {

         EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
        // EA.Element claselt = repository.GetElementByID((int)at.ClassifierID);
         texte = claselt.Name;
         string type = getTypeElt(claselt);
         if (TypeList.ContainsKey(type))
         {
             if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);
         }
     }
     //texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
     // ToDoc(texte,"0");
     ToDoc(texte, "0");
     texte = "</p>";
     ToDoc(texte, "0");
texte="</td>";
	 ToDoc(texte,"0");
   
texte="<td>";
	 ToDoc(texte,"0");
texte="<p class=\"mytable-cell\">" + brNote(at.Notes) + "</p>";
	 ToDoc(texte,"0");
texte="</td>";
	 ToDoc(texte,"0");

texte="</tr>";
	 ToDoc(texte,"0");
        }
        //--------
        void prodAttributeForAssembly(EA.Element elt, EA.Attribute at, string isabstract)
        {
            //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
            // on se contente de nourrir TypeList[enumeration]
            if(at.Type=="StreetAddress")
            {
                string prov = at.Name;
            }
            string texte;
            if ((at.ClassifierID == 0)) //18 || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
            // attention dans certain cas un type non lie n'annule pas le ClassifierID
            {
                texte = at.Type;
            }
            else
            {
                
                EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
              //  EA.Element claselt = repository.GetElementByID((int)at.ClassifierID);
               //texte = claselt.Name;
                string type = getTypeElt(claselt);
                if (type == "enumeration") // on ne regarde que les ennulmeration car en cas de compound on pourrait tomber sur un datatype
                {
                    if (TypeList.ContainsKey(type))
                    {
                        if (!TypeList[type].Contains(claselt.ElementID)) TypeList[type].Add(claselt.ElementID);

                    }
                }
            }
        }
        //----------
        /// <summary>
        /// le programme prodAttribute met a jour les listes de datatypes au fur et  mesure
        /// seuls les compound peuvent avoir des attribut de type tant eux mme des compounds
        /// on ne peut pas explorer la typelist[compound] de maniere recursive 
        /// Ce sous programe est destine  explorer tous les compounds (et uniquement les compounds
        /// de manire recursive pour mettre  jour TypeList[compound]
        /// </summary>
        /// <param name="elt"></param>
        void majCompoundList()
        {
            int nbcompound = TypeList["compound"].Count;
            List<long> locallist = new List<long>(TypeList["compound"]);

            foreach (long elid in locallist)
            {
                EA.Element elt = repository.GetElementByID((int)elid);
                string prov = elt.Name; // pour test
                if (prov == "Action_Status")
                {
                    prov = elt.Name;
                }
                foreach (EA.Attribute at in elt.Attributes)
                {
                    if (at.ClassifierID != 0)
                    {
                        EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
                        string texte = claselt.Name;
                        string typp = getTypeElt(claselt);
                        if (typp != "")
                        {
                            if ((typp == "datatype") || (typp == "compound"))
                            {
                                if ((!TypeList[typp].Contains(claselt.ElementID)))
                                {
                                    TypeList[typp].Add(claselt.ElementID);
                                }
                                foreach (EA.Attribute att in claselt.Attributes)
                                {
                                    if (att.ClassifierID != 0)
                                    {
                                        string typ = getTypeElt(repository.GetElementByID((int)att.ClassifierID));
                                        if (typ != "")
                                        {
                                            if ((!TypeList[typ].Contains(att.ClassifierID)))
                                            {
                                                TypeList[typ].Add(att.ClassifierID);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            if (TypeList["compound"].Count != nbcompound)
            {
                majCompoundList(); // il faut tenir compte des cascadisations successives d'o la recursion
            }
        }
//--------------
        void majDatatypeList()
        {
            int nbcompound = TypeList["compound"].Count;
            int nbdatatype = TypeList["datatype"].Count;
            List<long> locallist = new List<long>(TypeList["compound"]);
            locallist.AddRange(TypeList["datatype"]); // on merge les datatypes et les compounds
            RDFLAutilitaires.wtest("TEST", " majDatatypeList locallist.count=" + locallist.Count.ToString());
            foreach (long elid in locallist)
            {
                EA.Element elt = repository.GetElementByID((int)elid);
                string prov = elt.Name; // pour test
                RDFLAutilitaires.wtest("TEST", " majDatatypeList elt.Name=" + elt.Name);
                if (prov == "Action_Status")
                {
                    prov = elt.Name;
                }
                foreach (EA.Attribute at in elt.Attributes)
                {
                    if (at.ClassifierID != 0)
                    {
                        EA.Element claselt = Main.Repo.GetElementByID((int)at.ClassifierID);
                        string texte = claselt.Name;
                        string typp = getTypeElt(claselt);
                        if (typp != "")
                        {
                            if ((typp == "datatype") || (typp == "compound"))
                            {
                                if ((!TypeList[typp].Contains(claselt.ElementID)))
                                {
                                    TypeList[typp].Add(claselt.ElementID);
                                }
                                foreach (EA.Attribute att in claselt.Attributes)
                                {
                                    if (att.ClassifierID != 0)
                                    {
                                        string typ = getTypeElt(repository.GetElementByID((int)att.ClassifierID));
                                        if (typ != "")
                                        {
                                            if ((!TypeList[typ].Contains(att.ClassifierID)))
                                            {
                                                TypeList[typ].Add(att.ClassifierID);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            if ((TypeList["compound"].Count != nbcompound) || (TypeList["datatype"].Count != nbdatatype)) 
            {
                RDFLAutilitaires.wtest("TEST", " majDatatypeList locallist.counts=" + nbcompound.ToString() + " " + nbdatatype.ToString());
                majDatatypeList(); // il faut tenir compte des cascadisations successives d'o la recursion
            }
        }
//-------------------------------

        void prodInheritedAttribute(EA.Element elt, EA.Attribute at,string isabstract)
        {
            string texte;
texte="<tr>";
	 ToDoc(texte,isabstract);
     texte = "<td>";
     ToDoc(texte, isabstract);
     texte = "<p class=\"cardinality\">" + at.LowerBound + ".." + at.UpperBound + "</p>";
     ToDoc(texte, isabstract);
     texte = "</td>";
texte="<td>";
	 ToDoc(texte,isabstract);
     string stereo = getAtrProfStereo(at);
     if (stereo == "")
     {
         texte = "<p class=\"name\">" + at.Name + " </p>";
     }
     else
     {
         texte = "<p class=\"name\">" + at.Name + " (" + stereo + ") " + " </p>";
     }
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);

texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td class=\"type\">";
	 ToDoc(texte,isabstract);
texte="<p class=\"type\">";
	 ToDoc(texte,isabstract);
     if ((at.ClassifierID == 0)) //18  || (!RDFutilitaires.dicelembyid.ContainsKey(at.ClassifierID)))
{
texte=at.Type;
}else{
    texte = Main.Repo.GetElementByID((int)at.ClassifierID).Name;
}
//texte="<a href=\"#" +  texte + "\">" + texte + "</a>";
	// ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p class=\"comment\">" + at.Notes + "</p>";
//	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="<td>";
ToDoc(texte,isabstract);
//texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name + "\">" + elt.Name + "</a>";
texte = "<p>" + "inherited from" +  elt.Name + "</p>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);
texte="</tr>";
	 ToDoc(texte,isabstract);
        }
        //---------------
        void prodAssocEntete(string isabstract)
        {
            string texte;
            texte = "<tr>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Order" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "mult." + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Class name / Role" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            /*
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Class type name" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
             * */
            texte = "<td>";
            ToDoc(texte, isabstract);
            texte = "<p class=\"name\" >" + "Description" + " </p>";
            ToDoc(texte, isabstract);
            texte = "</td>";
            ToDoc(texte, isabstract);
            texte = "</tr>";
            ToDoc(texte, isabstract);

        }
        void prodAssoc(Repository repo, EA.Element elt, EA.Connector con, string isabstract, ref int   needtable)
        {

            CIMSchemaGenerator.ConexesID = 0;
            /***********************************************************/
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.ConnectorEnd myend;
            EA.Element otherendelt;

            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string prov1 = otherendelt.Name;
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (myend.Aggregation != 0)
                
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                {// the association creates an effective memmber

                    string texte;

                    if (needtable == 0)
                    {
                        //------------  ajout am aout 2012
                          texte = "<p class=\"myparagraph\">" + " !#";
                          texte = texte + " shows all association ends of " + elt.Name + " with other classes.";
                          ToDoc(texte, elt.Abstract);

                          texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
                          string nompa = repository.GetPackageByID(elt.PackageID).Name;
                          texte = texte + " -" + " Association ends of " + nompa + "::" + elt.Name + " with other classes";  //+".";
                          ToDoc(texte, elt.Abstract);
                         

                          //-----------------------------------------------------------------------------    

                        texte = "<table>";
                        ToDoc(texte, elt.Abstract);
                        prodAssocEntete(elt.Abstract);
                        needtable++;
                    }

                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + RDFutilitaires.getAtRang(con).ToString() + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"cardinality\">" + "[" + cardinality + "]" + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherendelt.Name + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">";
                    ToDoc(texte, isabstract);
                    //texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                    texte = otherend.Role;
                    ToDoc(texte, isabstract);
                    texte = "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    
                    /*
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherendelt.Name + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                     * */
                    texte = "<td>";
                    ToDoc(texte, isabstract);
                    texte = "<p class=\"type\">" + brNote(otherend.RoleNote) ;                           
                    ToDoc(texte, isabstract);
                    texte = "<br/>";
                    ToDoc(texte, isabstract);
                    texte = " Association Based On : " + "<br/>";
                    ToDoc(texte, isabstract);
                    texte = prodAssocIsBasedOn(repo,con)[0] + "<br/>";
                    ToDoc(texte, isabstract);
                    texte =  "\t\t-----" + "<br/>";
                    ToDoc(texte, isabstract);
                    texte =  prodAssocIsBasedOn(repo, con)[1] + "</p>";
                    ToDoc(texte, isabstract);
                    texte = "</td>";
                    ToDoc(texte, isabstract);
                    texte = "</tr>";
                    ToDoc(texte, isabstract);

                }
            }
           
            /* ********************/
        }
//-------------------------------
      
        //-------------------------------
        void prodInheritedAssoc(EA.Element elt, EA.Connector con, string isabstract)
        {
            CIMSchemaGenerator.ConexesID = 0;
            CIMSchemaGenerator.Connexion connex = new CIMSchemaGenerator.Connexion(con);
            EA.ConnectorEnd otherend;
            EA.Element otherendelt;
            EA.ConnectorEnd myend;
            if (connex.Source_element.ElementID == elt.ElementID)
            {// the element is the Source
                otherend = connex.Target;
                otherendelt = connex.Target_element;
                myend = connex.Source;
                
            }
            else
            {
                otherend = connex.Source;
                otherendelt = connex.Source_element;
                myend = connex.Target;
            }
            string cardinality = otherend.Cardinality;
            bool eligible = false;
            if (cardinality == "1") cardinality = "1..1";
            if (myend.Aggregation != 0)
            {// the other end is eligible as member
                eligible = true;
            }
            if (eligible && (otherend.Role != ""))
            {
                string texte;
                texte = "<tr>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                texte = "<p class=\"cardinality\">" + cardinality + "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                string stereo = getEltProfStereo(otherendelt);
                if (stereo == "")
                {
                    texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + "</p>";
                }
                else
                {
              texte = "<p class=\"name\" id=\"" + elt.Name + "." + otherend.Role + "\">" + otherend.Role + " (" + stereo + ") " + "</p>";
                }
                    ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
                
                texte = "<td class=\"type\">";
                ToDoc(texte, isabstract);
                texte = "<p class=\"type\">";
                ToDoc(texte, isabstract);
                //texte = "<a href=\"#" + otherendelt.Name + "\">" + otherendelt.Name + "</a>";
                texte = otherendelt.Name;
                ToDoc(texte, isabstract);
                texte = "</p>";
                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
                texte = "<td>";
                ToDoc(texte, isabstract);
//                texte = "<p class=\"comment\">" + otherend.RoleNote + "</p>";
//                ToDoc(texte, isabstract);
                texte = "</td>";
                ToDoc(texte, isabstract);
texte="<td>";
	 ToDoc(texte,isabstract);
//texte="<p>see <a class=\"superclass\" href=\"#" + elt.Name  + "\">" + elt.Name + "</a>";
     texte = "<p>" + "inherited from" + elt.Name + "</a>";
	 ToDoc(texte,isabstract);
texte="</p>";
	 ToDoc(texte,isabstract);
texte="</td>";
	 ToDoc(texte,isabstract);

                texte = "</tr>";
                ToDoc(texte, isabstract);
            }
        }
//------------
   void prodEnumeration(EA.Element enumelt){
       string texte = "";
       string prov = removestereo(CD.GetEnumStereotype(), enumelt.Name);
       

           //MessageBox.Show(" enumeration " + enumelt.Name);// pour test
       
           //texte="<div id=\"" + enumelt.Name +"(" +  prov + ")" + "\" class=\"group\">";
           //     docfile.WriteLine(texte);
           //texte="<a href=\"#" + enumelt.Name + "\">";
           //   docfile.WriteLine(texte);
           //texte="<h2 class=\"enumerated\">" + enumelt.Name + " enumeration" + "</h2>";
           texte = "<h4 class=\"enumerated\">" + enumelt.Name + " enumeration" + "</h4>";
           docfile.WriteLine(texte);
           //texte="</a>";
           //  docfile.WriteLine(texte);
           //texte="<p class=\"package\">"+ (RDFutilitaires.dicpackbyid[enumelt.PackageID]).Name + "</p>";
           //          docfile.WriteLine(texte);
           //prodPackage(enumelt.PackageID,"0");
           //texte="<p class=\"comment\">" + brNote(enumelt.Notes) + "</p>";
          // texte = "<p class=\"myparagraph\">" + brNote(enumelt.Notes) + "</p>";
           texte =brpNote(enumelt.Notes);
           docfile.WriteLine(texte);

           //-------------------- ajout am  aout 2012  --------------------------------- 
           if (enumelt.Name.Contains("TypeList"))
           {
               texte = "<p class=\"myparagraph\">" + " !#" + " shows examples of literals for " + enumelt.Name + ".";
           }
           else
           {
               texte = "<p class=\"myparagraph\">" + " !#" + " shows all literals of " + enumelt.Name;
           }
           docfile.WriteLine(texte);

           texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
           string nompa = repository.GetPackageByID(enumelt.PackageID).Name;
           texte = texte + " -" + " Literals of " + nompa + "::" + enumelt.Name; // +".";
           docfile.WriteLine(texte);
           //-----------------------------------------------------------------------------


           texte = "<table>";
           docfile.WriteLine(texte);
           prodEnumEntete("0");
           foreach (EA.Attribute at in enumelt.Attributes)
           {
               prodMember(enumelt, at);
           }
           texte = "</table>";
           docfile.WriteLine(texte);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";; 
           docfile.WriteLine(texte);
           texte = "</div>";
           docfile.WriteLine(texte);
       
}
   //------------
   void prodDatatype(EA.Element dataelt)
   {
       //MessageBox.Show("datatype= " + dataelt.Name);// pour test
       string texte = "";
       //texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
      // docfile.WriteLine(texte);
       //texte = "<a href=\"#" + dataelt.Name + "\">";
      // docfile.WriteLine(texte);
       RDFLAutilitaires.wtest("TEST", "prodDatatype 1 count=" + dataelt.Name +  "  " + TypeList["datatype"].Count.ToString());

      // texte = "<h2>" + dataelt.Name + " datatype" + "</h2>";
       texte = "<h4>" + dataelt.Name + " datatype" + "</h4>";
       docfile.WriteLine(texte);

 //      texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";


       //texte = "<p class=\"myparagraph\">" + brNote(dataelt.Notes) + "</p>";
       texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);
       if (dataelt.Connectors.Count > 0)
       {
           foreach (EA.Connector con in dataelt.Connectors)
           {
               if (con.Type == "NoteLink")
               {
                   prodNote(dataelt, con, "0");
               }


           }

       }
      // docfile.WriteLine(texte);
       RDFLAutilitaires.wtest("TEST", "prodDatatype 2 count=" + TypeList["datatype"].Count.ToString());

       //-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------

       texte = "<table>";
       docfile.WriteLine(texte);
       prodAttributeEntete("1");
       List<EA.Attribute> listat = new List<EA.Attribute>();
       bool ilyacontraintes=false;
       foreach (EA.Attribute at in dataelt.Attributes)
       {
          // MessageBox.Show("datatype.name=" + dataelt.Name + " | at.name=" + at.Name + " | at.type=" + at.Type + " | at.notes=" + at.Notes);
           
           prodAttribute(dataelt, at, "1");
           if (at.Constraints.Count > 0) ilyacontraintes = true;
       }
       RDFLAutilitaires.wtest("TEST", "prodDatatype 3 count=" + TypeList["datatype"].Count.ToString());
       texte = "</table>";
       docfile.WriteLine(texte);
  	  texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
       if (!ilyacontraintes) return; // il n'y a pas de contraintes.
       //-------------------- ajout am  mai 2013  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all restrictions applied to the attributes  of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Restrictions of attributes for  " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<div>";
       docfile.WriteLine(texte);
       texte = "<table>";
       docfile.WriteLine(texte);
       prodRestrictEntete("0");
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           prodRestrict(dataelt, at, "0");
       }
       RDFLAutilitaires.wtest("TEST", "prodDatatype 4 count=" + TypeList["datatype"].Count.ToString());
       texte = "</table>";
       docfile.WriteLine(texte);
  	  texte =" <p class=\"myparagraph\">" + "##MXM##" + "</p>";;
           docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
   //------------
   void prodDatatypeForAssembly(EA.Element dataelt)
   {
       // on se contente d'explorer les attributs pour debusquer le enumeration existantes (telles les codelist)
       /* ABA20230905
       if (dataelt.Name == "MarketRoleKind")
       {
           string prov = "";
       }*/
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           // MessageBox.Show("datatype.name=" + dataelt.Name + " | at.name=" + at.Name + " | at.type=" + at.Type + " | at.notes=" + at.Notes);

           prodAttributeForAssembly(dataelt, at, "0");
       }
   }
    //------------
   void prodMember(EA.Element enumelt,EA.Attribute at)
   {
  docfile.WriteLine( "<tr>");
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"name\">" + at.Name +  "</p>");
docfile.WriteLine("</td>");
//---------------- ajout am september   2012  -------------------------------
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"cardinality\">" + " " + getEnumCode(at)+ " "  + "</p>");
docfile.WriteLine("</td>");
//---------------------------------------------------------------------------
docfile.WriteLine("<td>");
docfile.WriteLine("<p class=\"comment\">" + brNote(at.Notes) + "</p>");
docfile.WriteLine("</td>");
docfile.WriteLine("</tr>");


   }
//------------
   //------------
   void prodCompoundtype(EA.Element dataelt)
   {
       //MessageBox.Show(" compound =" + dataelt.Name);
       string texte = "";
     //  texte = "<div id=\"" + dataelt.Name + "\" class=\"group\">";
      // docfile.WriteLine(texte);
      // texte = "<a href=\"#" + dataelt.Name + "\">";
     //  docfile.WriteLine(texte);

      
      
      // texte = "<h2 class=\"concrete\">" + dataelt.Name + " compound" + "</h2>";
    texte = "<h4>" + dataelt.Name + " compound" + "</h4>";
       docfile.WriteLine(texte);
       //texte = "</a>";
       //docfile.WriteLine(texte);
       //     texte = "<p class=\"package\">" + (RDFutilitaires.dicpackbyid[dataelt.PackageID]).Name + "</p>";
       //  docfile.WriteLine(texte);

       
      // prodPackage(dataelt.PackageID, "0");
       


       //texte = "<p class=\"myparagraph\">" + brNote(dataelt.Notes) + "</p>";
       texte = brpNote(dataelt.Notes);
       docfile.WriteLine(texte);
       //-------------------- ajout am  aout 2012  --------------------------------- 
       texte = "<p class=\"myparagraph\">" + " !#" + " shows all attributes of " + dataelt.Name + ".";
       docfile.WriteLine(texte);

       texte = "<p class=\"mytable-title\">" + addSignetTable() + "Table " + " !#</a>";
       string nompa = repository.GetPackageByID(dataelt.PackageID).Name;
       texte = texte + " -" + " Attributes of " + nompa + "::" + dataelt.Name; // +".";
       docfile.WriteLine(texte);
       //-----------------------------------------------------------------------------
       texte = "<table>";
       docfile.WriteLine(texte);
       prodAttributeEntete("1");
       int ind = 0;
       Dictionary<int, int> dicordre = new Dictionary<int, int>();
       //int position = 0; // position dans le browser
       foreach (EA.Attribute at in dataelt.Attributes)
       {
           //Console.WriteLine("nom attribut=" + at.Name + "::pos=" +at.Pos);

          // position = at.Pos;
           /*
            if (at.Pos > dataelt.Attributes.Count - 1)
            {
                position = dataelt.Attributes.Count - 1;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the attribute position exceeds the maximumum index it is forced to the max index");
            }
            * */
             if(!dicordre.ContainsKey(at.Pos)) dicordre.Add(at.Pos,ind);
           
           // if (!dicordre.ContainsKey(position)) dicordre.Add(position, ind);

            ind++;   
       }
        /*** ajout am juin 2014 ***/
       List<int> positions = new List<int>(); //les positions sont recopiees de l'elementdu CIM 
                                              // et ne sont pas forcement daas l'ordre croissant a partir de 0
                                              
       for (short i = 0; i < dataelt.Attributes.Count; i++)
       {
           EA.Attribute atr=(EA.Attribute)dataelt.Attributes.GetAt(i);
           if (!positions.Contains((atr.Pos)))
           {
             positions.Add(atr.Pos);
           }
       }
        /*** ajout am juin 2014 ***/
      // for ( pos = 0; pos < dataelt.Attributes.Count; pos++)
       foreach (int pos in positions) //ajout am juin 2014 
       {
           if (dicordre[pos] < dataelt.Attributes.Count)
           {
               prodAttribute(dataelt, (EA.Attribute)dataelt.Attributes.GetAt((short)dicordre[pos]), "1");
           }
           else
           {
               // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the attribute position "
               //    + dicordre[pos].ToString() + "of " + dataelt.Name  + "exceeds the maximumum index");
           }
       }
       texte = "</table>";
       docfile.WriteLine(texte);
       texte = "<p class=\"myparagraph\">" + "##MXM##" + "</p>";
           docfile.WriteLine(texte);
       texte = "</div>";
       docfile.WriteLine(texte);

   }
        //--------------
  void prodNote(EA.Element elt,EA.Connector con,string isabstract){
      long eid = 0;
      if (elt.ElementID == con.ClientID)
      {
          eid = con.SupplierID; // note is on the otherend of the notelink
      }
      else
      {
          eid = con.ClientID; // note is at the source end of the notelink
      }
      string note="";
      if(eid != 0){
       //18 if(RDFutilitaires.dicelembyid.ContainsKey(eid)) {
            note=Main.Repo.GetElementByID((int)eid).Notes;
      //18 }
      }
      char[] pourtest = note.ToCharArray();
      string prov = note;

      string texte="<p class=\"note\">-" + brNote(note) + "</p>";
               ToDoc(texte, isabstract);

  }
//------------------------
  void prodBasedOnEntete(string isabstract)
  {
      string texte;
      texte = "<tr>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\"" + "\">" + "Name" + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\"" + "\">" + "Complete IsBasedOn Path" + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);
      
  }
        /// <summary>
        /// if isabstract=="classheader" on produit la ligne
       /// IsBasedOn: directory::class
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="elt"></param>
        /// <param name="isabstract"></param>
  void prodBasedOn(EA.Repository repo,EA.Element elt, string isabstract)
  {
      string prov = elt.Name;
            /* ABA20230905 Makes no sense!!
      if (prov == "MktGeneratingUnit")
      {
          prov = prov;
      }*/
       // MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test
      
      string texte = "";
      texte = "<tr>";
      ToDoc(texte, isabstract);
      texte = "<td>";
      ToDoc(texte, isabstract);
      texte = "<p class=\"name\" >" + elt.Name + " </p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);

     


      texte = "<td>";
      ToDoc(texte, isabstract);
      EA.Element basedon = RDFutilitaires.getElementOriginBasedonElement(elt);
     // texte = "<p class=\"name\" >" + GetPackageContainmentPath(basedon) + "::" + elt.Name + "</p>";
      texte = "<p class=\"name\" >" + GetPackageContainmentPath(basedon) + "::" + basedon.Name + "</p>";
      ToDoc(texte, isabstract);
      texte = "</td>";
      ToDoc(texte, isabstract);

      texte = "</tr>";
      ToDoc(texte, isabstract);


  }
        /// <summary>
        /// pour imprimer la ligne de basedon de la table de classe
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="elt"></param>
        /// <param name="isabstract"></param>
        /// <param name="classheader"></param>
  void prodBasedOn(EA.Repository repo, EA.Element elt, string isabstract,bool classheader)
  {
      //string prov = elt.Name;
      // MessageBox.Show("class= " + elt.Name +" | " + elt.ElementID +"|" + elt.StereotypeEx); //pour test

      string texte = "";
      if (!classheader) return; // on ne fait rien
      
      EA.Element basedon = RDFutilitaires.getElementBasedonElement(elt);
      texte = "<p class=\"name\" >" + " IsBasedOn: "; 
      EA.Package paparent=repo.GetPackageByID((int)basedon.PackageID);
      texte=texte +   paparent.Name + "::" + basedon.Name + " </p>";
      ToDoc(texte, isabstract);

  }
	void  prodPackage(long packid,string isabstract){
       
        // if a diagram exits and is not yet saved, it is then saved and refered to
        string prov = repository.GetPackageByID((int)packid).Name;
        if (!dicPackim.ContainsKey(packid))
        {

            //   string  pathfile = ".\\" + (RDFutilitaires.dicpackbyid[packid]).Name + ".png";
            string packname = (Main.Repo.GetPackageByID((int)packid)).Name;
           // MessageBox.Show(" prod " + packname);// pour test

           // string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + ".png";
            string pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();// am juin 20117
             pathfile = Path.GetFileName(nomrepimages) + "\\" + packname + ".bmp"; //ajout am sept 2013

            string prempathfile = pathfile;
            //pathfile = nomrepimages + "\\" + packname + ".png";
            pathfile = nomrepimages + "\\" + packname + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt() ;//am juin 2017
            pathfile = nomrepimages + "\\" + packname + ".bmp"; //ajout am sept 2013
            dicPackim.Add(packid, prempathfile);


            {// image does not yet exists
                EA.Collection dialcol = Main.Repo.GetPackageByID((int)packid).Diagrams;

                if (dialcol.Count > 0)
                {
                    string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;
                    if (pathfile.Contains(".emf"))
                    {
                        project.PutDiagramImageToFile(diagramguid, pathfile, 0);
                    }
                    else
                    {
                        project.PutDiagramImageToFile(diagramguid, pathfile, 1);
                    }

                    for (short i = 0; i < dialcol.Count; i++)
                    {
                        //pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();// am juin 2017
                        if(XMLP.GetXmlValueConfig("ImageExt")==".emf")
                        {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);
                        }
                        else {
                            project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        }

                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                        /*  ajout am september 2013*/
                        pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".bmp";
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                        repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                        /***************************/ 
                    }
                }
            }
        }
           // string texte = "<p class=\"name\">";
        string texte = " <h2>";
            texte = texte + "<a href=\"" + dicPackim[packid] + "\"" + " target=\"_blanc" + "\">";
            texte = texte + (Main.Repo.GetPackageByID((int)packid)).Name + " </a></h2>";
            ToDoc(texte, isabstract);

        
        }


//------------
        /// <summary>
        /// print a texte line in the correct buffer
        /// </summary>
        /// <param name="texte"></param>
        /// <param name="abstr"></param>
        ///  abstr=1  => 
        void ToDoc(string texte, string typbuf)
        {
            switch(typbuf) {
                case "1":  // typbuf=1 classe abstraite
                    sw.WriteLine(texte);
                    break;
 
                default:
            docfile.WriteLine(texte);
                    break;
            
            }
        }


//-----------------------------------------------
     List<EA.Attribute>  SortAttributesByName(EA.Collection col){
     List<EA.Attribute> retlist=new List<EA.Attribute>();
     
	Dictionary<string,EA.Attribute> dicAtrByName= new Dictionary<string,EA.Attribute>();
	foreach(EA.Attribute at in col){
	dicAtrByName.Add(at.Name,at);
	}

	Dictionary<string,EA.Attribute>.KeyCollection keysCol =dicAtrByName.Keys;
	string[] arkeys=new string[keysCol.Count];
	keysCol.CopyTo(arkeys,0);
	Array.Sort(arkeys);

	for(int i=0;i < arkeys.Length;i++){
	 retlist.Add(dicAtrByName[arkeys[i]]);		}
    return retlist;

 }

     List<EA.Attribute> SortAttributesByOrder(EA.Collection col)
     {
         List<EA.Attribute> retlist = new List<EA.Attribute>();

         Dictionary<int, EA.Attribute> dicAtrByOrder = new Dictionary<int, EA.Attribute>();
         foreach (EA.Attribute at in col)
         {
             dicAtrByOrder.Add(RDFutilitaires.getAtRang(at), at);
         }

         Dictionary<int, EA.Attribute>.KeyCollection keysCol = dicAtrByOrder.Keys;
         int[] arkeys = new int[keysCol.Count];
         keysCol.CopyTo(arkeys, 0);
         Array.Sort(arkeys);

         for (int i = 0; i < arkeys.Length; i++)
         {
             retlist.Add(dicAtrByOrder[arkeys[i]]);
         }
         return retlist;
     }
//-----------------------------------------------
        /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void OldprodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         texte = "<td>";
         ToDoc(texte, isabstract);
            string constante=at.IsConst ? "constant=true":"";
            string statique=at.IsStatic ? "static=true" : "";
            string pardefaut = "DefaultValue=";
            if (at.IsConst || at.IsStatic)
            {
                pardefaut = "FixedValue=";
            }
            if (at.Default != "")
            {
                texte = "<p class=\"mytable-cell\">" +  pardefaut + at.Default + "</p>";
                ToDoc(texte, isabstract);
            }

            if (at.Constraints.Count > 0)
            {
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    cont = ac.Notes;
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (contenu != "")
                    {
                        texte = "<p class=\"mytable-cell\">" + " Constraint=" + contenu + "</p>";
                        ToDoc(texte, isabstract);
                    }
                }
            }
         texte="</td>";
         ToDoc(texte, isabstract);
 
     }
     /// <summary>
     /// print a column for default name of attribute, name of constraint,type of constraint and expression
     /// </summary>
     /// <param name="elt"></param>
     /// <param name="at"></param>
     /// <param name="isabstract"></param>
        void prodRestrict(EA.Element elt, EA.Attribute at, string isabstract)
     {
         //   MessageBox.Show("at.name=" + at.Name + "at.type=" + at.Type + "at.notes=" + at.Notes);
         string texte;
         
         
         if (at.IsConst)
         {
             texte = "<tr>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Name + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "Constant" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
                 texte = "<p class=\"mytable-cell\">" + at.Default.ToString() + "</p>";
                 ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "</tr>";
             ToDoc(texte, isabstract);            
         }

         if (at.IsStatic)
         {
             texte = "<tr>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Name + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "Fixed" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + "" + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "<td>";
             ToDoc(texte, isabstract);
             texte = "<p class=\"mytable-cell\">" + at.Default.ToString() + "</p>";
             ToDoc(texte, isabstract);
             texte = "</td>";
             ToDoc(texte, isabstract);
             texte = "</tr>";
             ToDoc(texte, isabstract);
         }     
            if (at.Constraints.Count > 0)
            {
                
                string cont = "";
                string contenu = "";
                foreach (EA.AttributeConstraint ac in at.Constraints)
                {
                    texte = "<tr>";
                    ToDoc(texte, isabstract);
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + at.Name+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + ac.Name+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                    cont = ac.Notes;
                    texte = "<td>";
                   ToDoc(texte, isabstract);
                     texte = "<p class=\"mytable-cell\">" + ac.Type+ "</p>";
                        ToDoc(texte, isabstract);
                    texte = "</td>";
                     ToDoc(texte, isabstract);
                     texte = "<td>";
                     ToDoc(texte, isabstract);
                    
                    if (ac.Type == "OCL")
                    {
                        int pos1 = cont.IndexOf("->");
                        int pos2 = cont.IndexOf('(');
                        int pos3 = cont.IndexOf(')');
                        contenu = cont.Substring(pos1 + 1, pos3 - pos1);
                    }
                    else
                    {
                        if ((ac.Type == "INV") || (ac.Type == "Invariant"))
                        {
                            contenu = ">" + cont;
                        }
   
                    }
                    if (cont != "")
                    {
                        texte = "<p class=\"mytable-cell\">"  + cont + "</p>";
                        ToDoc(texte, isabstract);
                    }
                     texte="</td>";
                  ToDoc(texte, isabstract);
                  texte = "</tr>";
                  ToDoc(texte, isabstract);
                }
            }
        
  texte = "</tr>";
           ToDoc(texte, isabstract);
     }

        //---
        /// <summary>
        /// recupere le type d'un element
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string getTypeElt(EA.Element el)
        {
            string ret="";
            if ((el.StereotypeEx.Contains(CD.GetEnumStereotype())) || (el.Type=="Enumeration"))ret = "enumeration";
            if (el.StereotypeEx.Contains(CD.GetDatatypeStereotype())) ret = "datatype";
            if (el.StereotypeEx.Contains(CD.GetCompoundStereotype())) ret = "compound";
            if (el.StereotypeEx.Contains("datatype")) ret = "Datatype"; // legacy
            if ((iec) && (el.StereotypeEx.Contains(CD.GetPrimitiveStereotype()))) ret = "primitive";
            return ret;
        }
        /// <summary>
        /// print a column for default value, fix value and factet
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="at"></param>
        /// <param name="isabstract"></param>
        void prodClassConstraint(EA.Element elt,string isabstract)
        {
  
            string texte;
            foreach (EA.Constraint constr in elt.Constraints)
            {
                if (constr.Type =="Invariant")
                {
                   texte = "<p class=\"note\"><b>" + "constraint:</b>" + constr.Name + "={" + constr.Notes + "}" + "</p>";
                    ToDoc(texte, isabstract);
                }
            }

        }
        //---
        /// <summary>
        /// cree le commentaire de description sur l'AssocEnd
        /// </summary>
        /// <param name="con"></param>
        string[]  prodAssocIsBasedOn(EA.Repository repo,EA.Connector con)
        {
           
            string IBOGuid = RDFutilitaires.getBasedOnConnectoryGUID(repo,con.ConnectorGUID);
            
            EA.Connector IBOcon = repo.GetConnectorByGuid(IBOGuid);
             string[] texte={"",""};
             if (IBOcon != null)
             {
                 EA.Element source_element = repo.GetElementByID((int)IBOcon.ClientID);
                 EA.Element target_element = repo.GetElementByID((int)IBOcon.SupplierID);
                 EA.ConnectorEnd source = IBOcon.ClientEnd;
                 EA.ConnectorEnd target = IBOcon.SupplierEnd;



                 texte[0] = repo.GetPackageByID((int)source_element.PackageID).Name + "::" + source_element.Name + "." + source.Role;
                 texte[0] = texte[0] + "[" + source.Cardinality + "]";
                 texte[1] = repo.GetPackageByID((int)target_element.PackageID).Name + "::" + target_element.Name + "." + target.Role;
                 texte[1] = texte[1] + "[" + target.Cardinality + "]";
             }
             else
             {
              MessageBox.Show("WARNING there is a problem in the model the association de roles: " + "ClientRole=" + con.ClientEnd.Role + "," +"SupplierRole=" + con.SupplierEnd.Role+ "\n\r modele not build with CimSyntaxGen");
             }
            return texte;

        }
        //-------------------------------
        /// <summary>
        /// transform a string in an html string with linfeeds
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        string brNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<br/>" + split[i];
                }
                else
                {
                    ret = ret + split[i];
                }
               // ret = ret + split[i];
            }
            ret.Replace("\n"," ");
            return ret;
        }
        string brpNote(string ss)
        {
            string ret = "";
            string[] split = ss.Split(new Char[] { '\n' });
            for (int i = 0; i < split.Length; i++)
            {
                if (i != 0)
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                else
                {
                    ret = ret + "<p class=\"myparagraph\">" + split[i] + "</p>"; 
                }
                // ret = ret + split[i];
            }
            ret.Replace("\n", " ");
            return ret;
        }
        //---------------------------------------
        //-------------------------
        public bool HasClassStereotype(EA.Element elt)
        {
            // MessageBox.Show("dans HasClassStereotype: Element=" + elt.Name + " stereotypeex=" + elt.StereotypeEx + "\n" + " subprofilestereotype" + subprofilestereotype);
            bool ret = false;
            // true if element 

            if (subprofilestereotype == "Class")
            {
                if ((elt.StereotypeEx == "") || (elt.StereotypeEx.Contains("Class")))
                {
                    ret = true;
                }

            }
            if (!subprofilestereotype.Contains(","))
            {
                if (elt.StereotypeEx.Contains(subprofilestereotype))
                {
                    ret = true;
                    foreach (string stereo in notclassestereos)
                    {
                        if (elt.StereotypeEx.Contains(stereo))
                        {
                            ret = false;
                            break;
                        }
                    }
                   
                }
            }
            else
            {
                ArrayList subprofslist = new ArrayList(subprofilestereotype.Split(new char[] { ',' }));

                RDFutilitaires.setper(subprofslist);
                for (int j = 0; j < RDFutilitaires.resulpermutation.Count; j++)
                {
                    string res = "";
                    for (int i = 0; i < ((ArrayList)RDFutilitaires.resulpermutation[j]).Count; i++)
                    {
                        res = res + (string)((ArrayList)RDFutilitaires.resulpermutation[j])[i] + ",";

                    }
                    res = res.Trim(',');
                    if (elt.StereotypeEx.Contains(res))
                    {
                        ret = true;
                        foreach (string stereo in notclassestereos)
                        {
                            if (elt.StereotypeEx.Contains(stereo))
                            {
                                ret = false;
                                break;
                            }

                        }
                       
                        break;
                    }
                }
            }
                if (ret == true)
                {
                    if (!dejatrouvee.Contains(elt.ElementID))
                    {
                        dejatrouvee.Add(elt.ElementID);
                    }
                    else
                    {
                        ret = false;
                    }
                }            
            return ret;
        }
        //------------------------
        public  bool HasNotClassStereotype(EA.Element elt)
        {
            string prov = elt.Name;
            bool ret = true;
            if (elt.StereotypeEx == "")
            {
                ret = true;  // obvious
                return ret;
            }
            
            if (elt.Type == "Enumeration") // nov 2015
            {
                ret = false;
                return ret;
            }
            foreach (string stereo in notpureclasses)
            {
                if (elt.StereotypeEx.Contains(stereo))
                {
                    ret = false;
                    break;
                }
            }
           // MessageBox.Show("hasnotclass elt=" + elt.Name + " , stereotypes=" + elt.StereotypeEx  + " => " + ret.ToString()); // pour test
            return ret;
        }
//---------------------
        string getAtrProfStereo(EA.Attribute atr){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {

                if (RDFLAutilitaires.StereoExContainsStereo(atr.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
        //---------------------
        string getEltProfStereo(EA.Element elt){
            string ret="";
            foreach (string stereo in SubprofilesStereos)
            {
                if (RDFLAutilitaires.StereoExContainsStereo(elt.StereotypeEx, stereo))
                {
                    ret = stereo;
                    break;
                }
            }
            return ret;
        }
//----------------------------
        bool ThereIsLegitimateConnexion(EA.Element el,Dictionary<string, List<EA.Connector>> consubprofiles,string stereo)
        {
            bool ret=false;
            if (consubprofiles.ContainsKey(stereo) && consubprofiles[stereo].Count > 0)
            {
                foreach (EA.Connector con in consubprofiles[stereo])
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        string cardinality=getOtherEndCardinality(el, con);
                        EA.ConnectorEnd otherend = (ConnectorEnd)(RDFutilitaires.getOtherend(el, con)[0]);

                        if ((cardinality == "1") || (cardinality == "1..1") || (cardinality == "0..1") || (otherend.Navigable=="Navigable"))
                        {
                            ret = true;
                            break;
                        }
                    }
                }
            }
            return ret;
        }
        //----------------------

        string getOtherEndCardinality(EA.Element el, EA.Connector con)
        {
            string cardinality = "";
            if ((con.Type == "Association") || (con.Type == "Aggregation"))
            {
                EA.ConnectorEnd end=null;
                if (con.ClientID == el.ElementID) end = con.SupplierEnd;
                if (con.SupplierID == el.ElementID) end = con.ClientEnd;
                cardinality = end.Cardinality;
                string prov = end.Role; // pour test
            }
            return cardinality;
        }

        /****
        /// <summary>
        /// les stereosEx se prsentent sous la forme de listes de
        /// string.
        /// Ce programme redonne une chaine liste o tous les membres sont dans l'ordre alaphabtique
        /// </summary>
        /// <param name="stereos"></param>
        public string RedressStereo(string stereos){
            string ret ="";
            string[] ss = stereos.Split(',');
            List<string> lss = new List<string>(ss);
            lss.Sort();
            StringBuilder newstereos = new StringBuilder();
            foreach (string s in lss)
            {
                newstereos.Append( "," + s);
            }
            ret = newstereos.ToString().Trim(',');
            return ret ;
        }
        ****/ 
         
        /// <summary>
        /// les stereotype peuvent tre constitu d'une composition
        /// exemple "ShortCircuit,Entsoe"
        /// suivant la maniere dont on les range il faut les comparer
        /// </summary>
        /// <param name="stereos"></param>
        public bool CompareCompositeStereo(string stereo1, string stereo2)
        {

            if (stereo1.Length != stereo2.Length) return false;
            if (!stereo1.Contains(",") && !stereo2.Contains(",")) return stereo1 == stereo2;
            {// il s'agit bien de  chaines composees
                string[] ss1 = stereo1.Split(',');
                List<string> lss1 = new List<string>(ss1);
                lss1.Sort();
                string[] ss2 = stereo2.Split(',');
                List<string> lss2 = new List<string>(ss1);
                lss2.Sort();
                if (lss1.Count != lss2.Count) return false;
                for (int i = 0; i < lss1.Count; i++)
                {
                    if (lss1[i] != lss2[i]) return false;
                }
                return true;
            }
        }
        string removestereo(string stereo, string ss)
        {
            if(!ss.Contains(stereo)) return ss;
            int l = stereo.Length;
            int index = ss.IndexOf(stereo);
            return (ss.Remove(index, index)).Trim(',');
        }

        /**
        /// <summary>
        /// verifie si un StereoEx d'un element contient un stereo
        /// qui peutetre une chaine comme "Entsoe,ShortCircuit"
        /// </su<param name="stereo"></param>mmary>
        /// 
        /// <param name="stereoex"></param>
        /// <returns></returns>
        bool StereoExContainsStereo(string stereoex, string stereo)
        {
            bool ret = false;
            if (!stereo.Contains(","))
            {
                if (stereoex.Contains(stereo))
                {
                    ret = true;
                }
            }
            else
            {
                if (!stereoex.Contains(","))
                {
                    ret = false;
                }
                else
                {

                    stereo = RedressStereo(stereo);
                    stereoex = RedressStereo(stereoex);

                    if (stereoex.Contains(stereo))
                    {
                        ret = true;
                    }
                }
            }
            return ret;
        } 
          **/
        //--------------------------------
        static string addSignetTable()
        {
            string texte = "";
            rgtable++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;
            texte= "<a name=\"" + basesignet + compteursgnt.ToString() + rgtable.ToString()+ "\">";
            return texte;

        }
        static string addSignetFigure()
        {
            string texte = "";
            rgtable++;
           // rgfigure++;
            //compteursgnt++;
            compteursgnt = DateTime.Now.Ticks;// pour se distinguer d'une table dclare au meme moment
            texte = "<a name=\"" + basesignet + compteursgnt.ToString() + rgfigure.ToString() + "\">";
            return texte;

        }
        string getEnumCode( EA.Attribute at)
        {
            string resul = "";
            foreach (EA.AttributeTag tag in at.TaggedValues)
            {
                if (tag.Name == CD.GetEnumCodeTag())
                {
                    resul = tag.Value;
                }
            }
            return resul;
        }
        //---------------
        public bool isConElligible(EA.Element el, EA.Connector con)
        {
            //bool resul = false;
            if ((con.Type != "Association") && (con.Type != "Aggregation")) return false;
            if ((el.ElementID == con.SupplierID) && (con.SupplierEnd.Aggregation == 1)
                && (con.ClientEnd.Role != ""))
            {
                return true;
            }
            if ((el.ElementID == con.ClientID) && (con.ClientEnd.Aggregation == 1)
               && (con.SupplierEnd.Role != ""))
            {
                return true;
            }
            return false;
        }

        void crePackageImage(EA.Package pack)
        {
            string texte="";
            string packname=pack.Name;
            EA.Collection dialcol = pack.Diagrams;

            if (dialcol.Count > 0)
            {
                string diagramguid = ((EA.Diagram)dialcol.GetAt(0)).DiagramGUID;
                string pathfile = nomrepimages;
                /*
                if (pathfile.Contains(".emf"))// am juin 2017
                {
                    project.PutDiagramImageToFile(diagramguid, pathfile, 0);
                }
                else
                {
                    project.PutDiagramImageToFile(diagramguid, pathfile, 1);
                }
                */
                for (short i = 0; i < dialcol.Count; i++)
                {
                    //pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".png";
                    pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + XMLP.GetXmlValueConfig("ImageExt"); // CD.GetImageExt();
                    if (XMLP.GetXmlValueConfig("ImageExt") == ".emf")
                    {
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 0);//am juin 2017
                    }
                    else
                    {
                        project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                    }
                    repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    /**** ajout am september 2013    **/
                    pathfile = nomrepimages + "\\" + packname + "_" + ((EA.Diagram)dialcol.GetAt(i)).Name + ".bmp";
                    project.PutDiagramImageToFile(((EA.Diagram)dialcol.GetAt(i)).DiagramGUID, pathfile, 1);
                    repository.CloseDiagram(((EA.Diagram)dialcol.GetAt(i)).DiagramID);
                    /**********************************/
                    string nomdiag=((EA.Diagram)dialcol.GetAt(i)).Name;
                    if (!(nomdiag.Contains("IsBasedOn")))
                    {
               
                        //texte = "<img src=\"" + nomrepimages + "\\" + packname + "_" + packname + ".png\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte.Replace(" ", "%20");
                        //ToDoc(texte, "0");
                         //texte = "<img class=\"myparagraph\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".png\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte = "<img class=\"myparagraph\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        //texte = "<img class=\"myfigure\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + ".bmp\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        texte = "<img class=\"myfigure\" src=\"" + Path.GetFileName(nomrepimages) + "\\" + packname + "_" + nomdiag + XMLP.GetXmlValueConfig("ImageExt") + "\"" + " border=\"0\"  width=\"80%\"  alt=\"\">";
                        ToDoc(texte, "0"); 
                    }
                }
            }
        }
        //-------------------------------
        /// <summary>
        /// get the Package path  in which the object on which 
        /// the element  is situated
        /// </summary>
        /// <param name="el"></param>
        /// <returns>string path of Packages hierarchie
        ///          </returns>
        public  string GetPackageContainmentPath(EA.Element el)
        {
            string retour = "";

            try
            {

                if (el != null)
                {

                    List<String> chemin = new List<String>();
                    DirectPackageContainmentPath(repository.GetPackageByID(el.PackageID), chemin);
                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                    {
                        bchemin.Append("::" + name);
                    });

                    retour = bchemin.ToString().TrimStart(new char[]{':'});
                    return retour;
                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return retour;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Error  GetPackageBasedOnContainmentPath " + e.Message + "\n");
                return retour;
            }
        }
        //--------------------------------------------------------
        /// <summary>
        /// calculate the Package containment from a given Package
        /// the result is in the form of a string list in reverse order
        /// </summary>
        /// <param name="pa"></param>
        /// <param name="path"></param>
         void DirectPackageContainmentPath(EA.Package pa, List<String> path)
        {
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
            {
                DirectPackageContainmentPath(repository.GetPackageByID(pa.ParentID), path);

            }
        }
        /// <summary>
        /// retourne le nom du codelilist si c'est le type de value ou DomainQualification
        /// </summary>
        /// <param name="datatype"></param>
        /// <returns>nom du codelist ou ""</returns>
         public string getCodelist(EA.Element datelt)
         {

             string ret = "";
             EA.Element classifier = null;
             string prov="";
             prov = datelt.Name;
             string prov1 = datelt.StereotypeEx;
             bool bool1=!datelt.StereotypeEx.Contains(CD.GetDatatypeStereotype());
             bool bool2 = !(datelt.Type == "Enumeration");
             bool bool3 = !datelt.StereotypeEx.Contains("datatype");
             //EA.Element datelt= RDFutilitaires.dicelembyid[datatypeid];
             if((!datelt.StereotypeEx.Contains(CD.GetDatatypeStereotype()))
                 && (!datelt.StereotypeEx.Contains("datatype")))
             {
                 return ret;
             }
          
             foreach(EA.Attribute at in datelt.Attributes)
             {
                 if(at.ClassifierID != 0)
                 {
                     
                     classifier=Main.Repo.GetElementByID((int)at.ClassifierID);
                     prov1 = at.Name + "::" + classifier.Name;
                     if ( (!classifier.StereotypeEx.Contains(CD.GetEnumStereotype())) && !(classifier.Type=="Enumeration"))
                         
                     {
                         continue;
                     }
                     else
                     {
                        // if (classifier.Name.Contains("TypeList"))
                      if ((classifier.Name.Contains("TypeList"))
                     || ((classifier.Name == "UnitMultiplier"))
                     || ((classifier.Name == "UnitSymbol"))
                     )
                         {
                             ret = classifier.Name;
                             break;
                         }
                     }

                 }
             }
                 return ret;
         }
         public List<EA.Element> buildListPrimitive(EA.Package pack)
         {
             List<EA.Element> ret = new List<Element>();
             RDFutilitaires.getAllElements(pack, ret, "Primitive");
             return ret;
         }
         //------------
         void prodPrimitiveType(EA.Element dataelt)
         {
             //MessageBox.Show("datatype= " + dataelt.Name);// pour test
             string texte = "";
             if (dataelt.Name != "")
             {
                 texte = "<h4>" + dataelt.Name + " primitive" + "</h4>";
                 docfile.WriteLine(texte);
             }
             texte = brpNote(dataelt.Notes);
             docfile.WriteLine(texte);


             // texte = " <p class=\"myparagraph\">" + "##MXM##" + "</p>"; ;
             // docfile.WriteLine(texte);    
         }
        /// <summary>
        /// recupere le ou les primitives d'un compound en tenant compte 
        /// de la cascadisation eventuelle
        /// 
        /// </summary>
        /// <param name="compoundid"></param>
        /// <returns></returns>
         void GetPrimitiveFromCompound(long compoundid)
         {
             EA.Element dataelt = repository.GetElementByID((int)compoundid);
             string prov = dataelt.Name;
             foreach (EA.Attribute at in dataelt.Attributes)
             {
                 if (at.ClassifierID != 0)
                 {
                     EA.Element classifier = repository.GetElementByID((int)at.ClassifierID);
                     prov = classifier.Name;
                     string type = getTypeElt(classifier);
                     if (type == "primitive")
                     {
                         if (TypeList.ContainsKey(type))
                         {
                             if (!TypeList[type].Contains(classifier.ElementID)) TypeList[type].Add(classifier.ElementID);
                         }
                     }
                     else
                     {
                         if (type == "compound")
                         {
                             GetPrimitiveFromCompound(classifier.ElementID);
                         }
                     }
                 }
             }
         }
         
        /// <summary>
        /// recupere toutesles primitives des datatypes et compounds
        /// </summary>
         void getAllProfilePrimitivesFromDatatype()
         {
             
             // traitement des compounds
            foreach (long compid in TypeList["compound"])            
            {
                 GetPrimitiveFromCompound(compid);       
            }

            foreach (long dtid in TypeList["datatype"])
            {
                 EA.Element dataelt = repository.GetElementByID((int)dtid);
                 foreach (EA.Attribute at in dataelt.Attributes)
                 {
                     if (at.Name == "value")
                     {
                         if (at.ClassifierID != 0)
                         {
                             EA.Element classifier = repository.GetElementByID((int)at.ClassifierID);
                             string type = getTypeElt(classifier);
                             if (TypeList.ContainsKey(type))
                             {
                                 if (!TypeList[type].Contains(classifier.ElementID)) TypeList[type].Add(classifier.ElementID);
                             }
                         }
                         break;
                     }
                 }
             }
         }

//-------------------------------------------------------------------------------------------------------
    }
}
