﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.JsonGeneration
{
    public class JsonConfiguration
    {
        private string lastJsonExportedFile = @"";
        private string forWg = @"wg16";
        private string canonicalBaseURI = @"http://iec.ch/TC57/2020/";
        private string jsonNameSpace = @"http://iec.ch/TC57/2020/CIM-JsonProfiles/EndDeviceEvents# ";
        private string jsonSchemaID = @"https://iec.ch/TC57/2020.EndDeviceEvents.schema.json";
        private string jsonSchemaVersions = @"http://json-schema.org/draft-07/schema#|http://json-schema.org/draft/2019-09/schema#";
        private string jsonSchemaVersion = @"http://json-schema.org/draft-07/schema#";
        private string codeListModelURI = @"http://iec.ch/TC57/2010/62325-351-Ed3#";
        private string jsonCodeListSchemaLocation = @"@%AppData%\\ENTSO-E\\CimSyntaxGen\\wg16";
        private string jsonLocalCodeListSchemaLocation = @"@%AppData%\\ENTSO-E\\CimSyntaxGen\\wg16";
        private string rootModelURI = @"http://iec.ch/TC57/2010/CIM-schema-cim15#";
        private string envelopeName = "";
        private static JsonConfiguration jsonConfig = null;

        public static JsonConfiguration GetJsonConfiguration()
        {
            if(jsonConfig == null)
            {
                jsonConfig = new JsonConfiguration();
            }
            return jsonConfig;
        }

        public string EnvelopeName { get => envelopeName; set => envelopeName = value; }

        public string RootModelURI { get => rootModelURI; set => rootModelURI = value; }
        public string LastJsonExportedFile { get => lastJsonExportedFile; set => lastJsonExportedFile = value; }
        public string ForWg { get => forWg; set => forWg = value; }
        public string CanonicalBaseURI { get => canonicalBaseURI; set => canonicalBaseURI = value; }
        public string JsonNameSpace { get => jsonNameSpace; set => jsonNameSpace = value; }
        public string JsonSchemaID { get => jsonSchemaID; set => jsonSchemaID = value; }
        public string JsonSchemaVersions { get => jsonSchemaVersions; set => jsonSchemaVersions = value; }
        public string JsonSchemaVersion { get => jsonSchemaVersion; set => jsonSchemaVersion = value; }
        public string CodeListModelURI { get => codeListModelURI; set => codeListModelURI = value; }
        public string JsonCodeListSchemaLocation { get => jsonCodeListSchemaLocation; set => jsonCodeListSchemaLocation = value; }
        public string JsonLocalCodeListSchemaLocation { get => jsonLocalCodeListSchemaLocation; set => jsonLocalCodeListSchemaLocation = value; }
    }
}
