﻿/////////////////////////////////////////////////////////////////////////////////////////
// Author: Alexander Balka
// File: JsonKeyValue.cs
/////////////////////////////////////////////////////////////////////////////////////////


//using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Text.Json.Nodes;
using System.Threading.Tasks;

namespace CimSyntaxGen
{
    public class JsonKeyValue<TValue> : JsonBase
    {
        private readonly string QUOTES = "\"";
        private readonly string COLON = ": ";
        private string name;
        private TValue value;

        public JsonKeyValue(string key, TValue value) 
        {
            this.name = key;
            this.value = value;
        }

        public string GetName() { return name; }
        public TValue GetValue() { return value; }

        public string AsString()
        {
            Type valueType = typeof(TValue);
            string temp = QUOTES + name + QUOTES + COLON;

            if (valueType == typeof(string))
            {
                return temp + QUOTES + value + QUOTES;
            }
            else if (valueType == typeof(bool))
            {
                string val = "" + value;
                return temp + val.ToLower();
            } 
            else if(valueType == typeof(JsonBase))
            {
                return temp + ((JsonBase)value).AsString();
            }
            else
            {
                return temp + value;
            }
        }

    }
}
