using System;
using System.Windows.Forms;
using System.IO;
using System.IO.Compression;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
using CimSyntaxGen.Option;
//using CimExportImport;
//using CimExportImport.manageIBO;
using CimSyntaxGen.manageIBO;
using System.Threading;
using EA;
using System.Runtime.InteropServices;
using CimSyntaxGen.JsonGeneration;
using CimSyntaxGen.HtmlGen;
using CimSyntaxGen.Utilities;
using CimSyntaxGen.Configuration;
using CimSyntaxGen.CodeComp;
using CimSyntaxGen.AvroGeneration;
using CimSyntaxGen.AsciiDoc;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.ProgressBar;
using System.Security.Policy;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.8.23                                   *  december 2022        * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
	public class Main
	{
        public static bool DO_LOG = true; // toggle switch for logging ABA20231014 -> transfer to configuration
        public static string LOG_FILE = FileManager.GetParentDirPath() + "\\cimsyntaxgen.log"; //"C:\\EA_CIM_Support\\Log\\cimsyntaxgen.log";
        private static Logger logger = new Logger(Main.LOG_FILE, Main.DO_LOG);
        public static bool DO_REPORTLOG = false; // ABA20231129

        private static readonly string version = "4.0.15";
        public string filecontents = "";
        static public string typerdfexport = "2019";// may be equal to "2019" | "2020" | 501ed2
        static public int erreurs = 0; // marqueur des erreurs
        static public bool testperf = false;
        static public bool withlog = false;
		public bool readline = false;
		private bool m_ShowFullMenus = false;
		public Form1 theForm;
     	private EA.Repository ModelsContainer;
        static long parentid = 0;
        static ConstantDefinition CD = new ConstantDefinition();
        static public XMLParser XMLP;
        static public List<string> selectedCCFiles; // selected files for componentcodes
        // indicateurs pour la sortie selon les options choisies
        static public Dictionary<string, Dictionary<string, bool>> IndStereos=new Dictionary<string, Dictionary<string, bool>>(); // stereo /  xmlbase,NBS
        public static Dictionary<string, TextWriter> dicTwbyStereotype = new Dictionary<string, TextWriter>(); // dictionary of stream writers according to export stereotypes
        public static Dictionary<string, Dictionary<string, string>> dicEnums = new Dictionary<string, Dictionary<string, string>>(); // enumeration/ dic member/initialvalue
        public static EA.Repository Repo; //am juil 2013
        public static List<string> entsoeSelectedStereotypes;
        public static List<string> selectedstereotypes;//am mai 2019
        public static StreamWriter reportlog=null; // the stream to register logs
        private string licKey;
        public static bool DialjsonResponse;
        private static MsgBox msgBox = new MsgBox();

        private const string LIC_MENU                           = "Load License";
        private const string CONFIG_MENU                        = "-Configuration";
        private const string CONFIG_IMPORT_MENU                 = "Import Configuration";
        private const string CONFIG_EXPORT_MENU                 = "Export Configuration";
        private const string CONFIG_EDITOR_MENU                 = "Configuration Editor";
        private const string AVRO_MENU                          = "Avro Generation";
        private const string ASCIIDOC_MENU                      = "-AsciiDoc Documentation";
        private const string ASCIIDOC_CONTEXT_ASSEMBLY          = "AsciiDoc Contextual and Assembly";
        private const string ASCIIDOC_351                       = "AsciiDoc Creation 351";
        private const string ASCIIDOC_FULL_PKG                  = "AsciiDoc FullPackage";
        private const string ASCIIDOC_ENTSOE                    = "AsciiDoc ENTSO-E documentation";
        private const string ASCIIDOC_IEC61970                  = "AsciiDoc IEC 61970 documentation";
        private const string CODELIST_EXPORT_JSON_MENU          = "Export Codelists as JSON";
        private const string CODELIST_EXPORT_MENU               = "Export Codelists as XSD";
        private const string CODELIST_IMPORT_MENU               = "Import Codelists as XSD";
        private const string CODELIST_TEMPLATE_EXPORT_JSON_MENU = "Export Codelists JSON Template";

        // These are the Win32 error code for file not found or access denied.
        const int ERROR_FILE_NOT_FOUND = 2;
        const int ERROR_ACCESS_DENIED = 5;


        /************************************************************************************/
        /*            les dictionnaires des applications                                    */
        /************************************************************************************/
        public   class MyList<T> : List<T>
        {
           T retour;
           public MyList()
           {
               new List<T>();
           }
           public T First()
           {

               foreach (T t in this)
               {
                   retour = t;
                   break;
               }
               return retour;
           }
       }
       static public Dictionary<string, MyList<EA.Element>> dicElemByName;  //  name;ArrayList fo elements
       static public Dictionary<string, EA.Element> dicProfElemByName; // les elements du profile a creer
       static public Dictionary<string, EA.Element> dicCIMElemByName; // tous les elements de CIMM qui peuvent tre parent 
       static public Dictionary<string, EA.Element> dicCIMElemByGUID; // tous les elements de CIMM qui peuvent tre parent
       static public Dictionary<long, EA.Element> dicCIMElemByID;

    
        /************************************************************************************/
		//Called Before EA starts to check Add-In Exists
		public String EA_Connect(EA.Repository Repository)
		{
                return "a string";
          
			//No special processing required.
			
		}//C:\Users\andre\Documents\zamiren\CimSyntaxGen\CimSyntaxGen\Option\XMLProfileParameters.cs

        public void EA_FileOpen(EA.Repository Repository) // am aout2018
        {
            FileManager.CreateParentDirectory(); // ABA20221020
        }

        //Called when user Click Add-Ins Menu item from within EA.
        //Populates the Menu with our desired selections.
        public object EA_GetMenuItems(EA.Repository Repository, string Location, string MenuName) 
		{
            Repo = Repository; //am juil 2013
            try
            {
                XMLP = new XMLParser(Repo);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ErrorCodes.ERROR_042[0] + ": " + ErrorCodes.ERROR_042[1] + "\n" + ex.StackTrace,
                                "Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                return "";
            }

            try
            {
                EA.Package aPackage = Repository.GetTreeSelectedPackage();
                switch (MenuName)
                {
                    case "":
                        return "-CimSyntaxGen";
                    case "-CimSyntaxGen":
                        string[] ar;
                        if (IsProjectOpen(Repository))
                        {
                            RDFLAutilitaires.wtest("TEST", "EntsoeManageCodeList=" + XMLP.GetXmlValueConfig("EntsoeManageCodeList"));
                            if (XMLP.GetXmlValueConfig("EntsoeManageCodeList") == "Checked")  // am june 2015
                            {
                                if (ConstantDefinition.GetExpirationCheckState())
                                {
                                    RDFLAutilitaires.wtest("TEST", " should see managecodelist");
                                    ar = new string[] { LIC_MENU, CONFIG_MENU, "-RDF", "-XSD", "-HtmlDocumentation", ASCIIDOC_MENU,"-ManageCodeLists", "-Json", AVRO_MENU, "CodeComponent", "options...", "About" }; // "perf" };
                                }
                                else
                                {
                                    RDFLAutilitaires.wtest("TEST", " should see managecodelist");
                                    ar = new string[] { CONFIG_MENU, "-RDF", "-XSD", "-HtmlDocumentation", ASCIIDOC_MENU, "-ManageCodeLists", "-Json", AVRO_MENU, "CodeComponent", "options...", "About" }; // "perf" };
                                }
                            }
                            else
                            {
                                if (ConstantDefinition.GetExpirationCheckState())
                                {
                                    RDFLAutilitaires.wtest("TEST", " should not see managecodelist");
                                    ar = new string[] { LIC_MENU, CONFIG_MENU, "-RDF", "-XSD", "-HtmlDocumentation", ASCIIDOC_MENU, "-Json", AVRO_MENU, "CodeComponent", "options...", "About" };
                                }
                                else
                                {
                                    RDFLAutilitaires.wtest("TEST", " should not see managecodelist");
                                    ar = new string[] { CONFIG_MENU, "-RDF", "-XSD", "-HtmlDocumentation", ASCIIDOC_MENU, "-Json", AVRO_MENU, "CodeComponent", "options...", "About" };
                                }
                            }
                        } 
                        else
                        {
                            ar = new string[] { LIC_MENU, CONFIG_MENU, "-RDF", "-XSD", "-HtmlDocumentation", ASCIIDOC_MENU, "-Json", AVRO_MENU, "CodeComponent", "options...", "About" };
                        }
                        return ar;

                    case CONFIG_MENU:
                        string[] configs = {CONFIG_IMPORT_MENU, CONFIG_EXPORT_MENU, CONFIG_EDITOR_MENU };
                        return configs; 
                    case "-RDF":
                        string[] br = { "IEC 61970-501:2006", "IEC 61970-501:2006 augmented (2019)", "IEC 61970-501:2006 augmented (2020)", "IEC 61970-501:Ed2" };
                        return br;
                    case "OWL":
                        string cr = "OWL";
                        return cr;
                    case "-XSD":
                        //string[] dr = { "XSD WG19", "XSD WG19 byref","XSD WG14", "XSD WG16", "XsdToProf" };
                        string[] dr = { "XSD WG19", "XSD WG19 byref", "XSD WG16", "XsdToProf" };
                        return dr;
                    case "-HtmlDocumentation":
                        if (IsProjectOpen(Repository))
                        {
                            //XMLP = new XMLParser(Repo);
                            if (XMLP.GetXmlValueConfig("HarmonisationEnabled") == "Checked")  // am june 2013
                            {
                                string[] er = { "HtmlDocumentation", "-ESMPHtmlDocumentation", "HtmlENTSOEDocumentation", "HtmlHarmonisationDocumentation" };
                                return er;
                            }
                            else
                            {
                                string[] er = { "HtmlDocumentation", "-ESMPHtmlDocumentation", "HtmlENTSOEDocumentation" };
                                return er;
                            }
                        }
                        else
                        {
                            string[] er = { "HtmlDocumentation", "-ESMPHtmlDocumentation", "HtmlENTSOEDocumentation", "HtmlHarmonisationDocumentation" };
                            return er;
                        }

                    case "-ESMPHtmlDocumentation":
                        string[] era = { "Contextual and Assembly", "Creation 351", "FullPackage", "ENTSO-E documentation", };
                        return era;
                    case ASCIIDOC_MENU:
                        string[] asciiDoc = { ASCIIDOC_CONTEXT_ASSEMBLY, ASCIIDOC_351, ASCIIDOC_FULL_PKG, ASCIIDOC_ENTSOE, ASCIIDOC_IEC61970};
                        return asciiDoc;
                    case "options...":
                        string es = "options...";
                        return es;
                    case "-ManageCodeLists":

                        string[] et = { CODELIST_IMPORT_MENU, CODELIST_EXPORT_MENU, CODELIST_EXPORT_JSON_MENU, CODELIST_TEMPLATE_EXPORT_JSON_MENU };
                        return et;
                    case "CodeComponent":
                        string eu = "CodeComponent";
                        return eu;
                    case "-Json":
                        string[] fa = { "json WG19", "json WG16" };
                        return fa;
                }

            }
            catch (Exception e)
            {
                ErrorCodes.ShowException(ErrorCodes.ERROR_037, e);
            }
            return "";

        }

        //Sets the state of the menu depending if there is an active project or not
        bool IsProjectOpen(EA.Repository Repository)
		{
			try
			{
				EA.Collection c = Repository.Models;
				//ModelsContainer=Repository; ABA20230922
				return true;
			}
			catch
			{
				return false;
			}
		}

		//Called once Menu has been opened to see what menu items are active.
		public void EA_GetMenuState(EA.Repository Repository, string Location, string MenuName, string ItemName, ref bool IsEnabled, ref bool IsChecked)
		{
			if( IsProjectOpen(Repository) )
			{
                if (ItemName == "-RDF")
					IsChecked = m_ShowFullMenus;
				else if( ItemName == "-XSD")
					IsEnabled = m_ShowFullMenus;
			}
			else
				IsEnabled = false;
        }

        //Called when user makes a selection in the menu.
        //This is your main entry point to the rest of your Add-in
        public void EA_MenuClick(EA.Repository Repository, string Location, string MenuName, string ItemName)
		{
            if (!IsProjectOpen(Repository))
            {
                return;
            }

            // set stereotypes if they don't exist yet
            ConfigurationManager confMgmter = ConfigurationManager.GetConfigurationManager(Repository);
            confMgmter.MatchConfiguration();

            confMgmter.DefineStereotypes();

            if (ConstantDefinition.GetExpirationCheckState())
            {
                bool loadingLicense = false;

                if (ItemName == LIC_MENU)
                {
                    loadingLicense = true;
                    Utilities.LicenseDialog licDialog = new Utilities.LicenseDialog();
                    licDialog.Show();
                }


                if (!loadingLicense)
                {
                    Utilities.LicenseManager licenseManager = new Utilities.LicenseManager();
                    if (licenseManager.LicenseExists())
                    {
                        licKey = licenseManager.LoadLicense();
                        if (licenseManager.IsValidLicenseKey(licKey))
                        {
                            int diffDays = licenseManager.GetDateDiff(licKey);
                            if (diffDays == 0)
                            {
                                MessageBox.Show("Your license expires tomorrow!", "License Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else if ((0 < diffDays) && (diffDays <= Utilities.LicenseManager.WARNING_DAYS))
                            {
                                MessageBox.Show("Your license will expire in " + diffDays + " days!", "License Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else if (diffDays < 0)
                            {
                                MessageBox.Show("Your license is expired!", "License Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                return;
                            }
                        }
                        else
                        {
                            MessageBox.Show("Invalid License: " + licKey, "License Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                    }
                    else
                    {
                        MessageBox.Show("License file not found! Load a valid license.", "License Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
            }


            try
            {               
                //reportlog = new StreamWriter(CD.ReportGen,true);// append on an existing log file
                //reportlog.AutoFlush = true;
        
                switch (ItemName)
                {
                    case CONFIG_MENU:
                        MessageBox.Show("Configuration");
                        break;
                    case CONFIG_IMPORT_MENU:
                        ConfigurationManager.GetConfigurationManager(Repository).ImportConfiguration();
                        break;
                    case CONFIG_EXPORT_MENU:
                        ConfigurationManager.GetConfigurationManager(Repository).ExportConfiguration();
                        break;
                    case CONFIG_EDITOR_MENU:
                        ConfigurationEditor configurationEditor = new ConfigurationEditor(Repository);
                        configurationEditor.ShowDialog();
                        configurationEditor.Dispose();
                        break;
                    case "-RDF":
                        MessageBox.Show(" RDF");
                        break;
                    case "IEC 61970-501:2006":
                        MontraitementRDF(Repository);
                        break;
                    case "IEC 61970-501:2006 augmented (2019)":
                        // MessageBox.Show("Non yet implemented RDFS (augmented)");
                        MontraitementRDFLA(Repository);
                        break;
                    case "IEC 61970-501:2006 augmented (2020)":
                        MontraitementRDF2020(Repository);
                        break;
                    case "IEC 61970-501:Ed2":
                        // MessageBox.Show("Non yet implemented RDFS (augmented)");
                        Montraitement501Ed2(Repository);
                        break;
                    case "OWL":
                        MessageBox.Show("Not yet implemented OWL");
                        /*
                           ConstDefinition constantes = new ConstDefinition();
                           try
                           {
                               RDFLAutilitaires.reportlog = new StreamWriter(constantes.ReportGen); //  the report file
                               RDFutilitaires.reportlog = (StreamWriter)RDFLAutilitaires.reportlog;
                               Thread t = new Thread(WriteY);
                               t.Start();
                               // simultaneously, do something
                               for (int i = 0; i < 1000; i++)
                               {
                                   RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("x");
                               }
                                return;
                           }
                           catch (Exception e)
                           {
                               MessageBox.Show(" Error when opening file " + constantes.ReportGen);
                               return;
                           }
                        */
                        break;
                    case "-XSD":
                        MessageBox.Show("to XML schemas");
                        break;
                    case "XSD WG19":
                        MonTraitementXSD(Repository, "wg19");
                        break;
                    case "XSD WG19 byref":
                        MonTraitementXSD(Repository, "wg19byref");
                        break;
                    case "XSD WG14":
                        //MessageBox.Show("Not yet implemented");
                        MonTraitementXSD(Repository, "wg14");
                        break;
                    case "XSD WG16":
                        // MessageBox.Show("Not yet implemented  XSD WG16");
                        MonTraitementXSD(Repository, "wg16");
                        break;
                    case "XsdToProf":
                        // MessageBox.Show(" not yet implemented");
                        /*********/
                        EA.Package package = Repository.GetTreeSelectedPackage();
                        try
                        {
                            DialFile dfil = new DialFile(Repository);
                            dfil.ShowDialog();
                            dfil.Dispose(); // ABA20230730
                            GenerprofilesFromXSD gxsd = new GenerprofilesFromXSD(Repository, "");
                        }
                        catch (Exception)
                        {
                            erreurs = erreurs + 1;
                        }
                        if (erreurs > 0)
                        {
                            MessageBox.Show("There were " + erreurs + " errors!");
                            MessageBox.Show("the end  some errors or warnings can be found in file " + CD.ReportGen) ;//GenerprofilesFromXSD.log");
                        }
                        else
                        {
                            if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                            {
                                MessageBox.Show("Finished.");
                            }
                        }
                        break;
                    case "-HtmlDocumentation":
                        MessageBox.Show("-HtmlDocumentation");
                        break;
                    case "HtmlDocumentation":
                        //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                        prodHtmlDocumentation(Repository, "HtmlDocumentation");
                        break;
                    case "HtmlENTSOEDocumentation":
                        //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                        prodHtmlDocumentation(Repository, "HtmlENTSOEDocumentation");
                        break;
                    case "HtmlHarmonisationDocumentation":
                        //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                        prodHtmlDocumentation(Repository, "HtmlHarmonisationDocumentation");
                        break;
                    case "-ESMPHtmlDocumentation":
                        //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                        break;
                    case "Contextual and Assembly":
                        //MessageBox.Show(" not yet implemented");
                        prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationAC");
                        break;
                    case "Creation 351":
                        prodHtmlDocumentation(Repository, "ESMPHtmlDocumentation");
                        break;
                    case "Contextual an Assembly for IEC":
                        prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationACForIEC");
                        break;
                    case "FullPackage":
                        //MessageBox.Show("not yet implemented");
                        prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationall");
                        break;
                    case "ENTSO-E documentation":
                        //MessageBox.Show("not yet implemented");
                        prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationSpecific");
                        break;
                    case ASCIIDOC_MENU:
                        break;
                    case ASCIIDOC_CONTEXT_ASSEMBLY:
                        GenAsciiDocDocumentation(Repository, "ESMPAsciiDocDocumentationAC"); //AsciiDocEsmpSpecificDocumentation
                        break;
                    case ASCIIDOC_351:
                        GenAsciiDocDocumentation(Repository, "ESMPAsciiDocDocumentation"); // AsciiDocESMPDocu
                        break;
                    case ASCIIDOC_FULL_PKG:
                        GenAsciiDocDocumentation(Repository, "ESMPAsciiDocDocumentationall"); //AsciiDocEsmpSpecificDocumentation
                        break;
                    case ASCIIDOC_ENTSOE:
                        GenAsciiDocDocumentation(Repository, "ESMPAsciiDocDocumentationSpecific"); // AsciiDocEsmpSpecificDocumentation
                        break;
                    case ASCIIDOC_IEC61970:
                        GenAsciiDocDocumentation(Repository, "IEC61970AsciiDocDocumentation"); // IEC 61970
                        break;
                    case "CodeComponent":
                        codecomponentForm codeCompForm = new codecomponentForm();
                        codeCompForm.ShowDialog();
                        codeCompForm.Dispose();
                        //string path = Environment.GetEnvironmentVariable("APPDATA");// 
                        //Process.Start(path + "\\CodeComponent.exe");  
                        break;
                    case "options...":
                        //    MessageBox.Show("Not yet implemented Options");
                        XMLProfileParameters profparam = new XMLProfileParameters();
                        OptionForm oform = new OptionForm(profparam);
                        oform.Show();
                        break;
                    case "About":
                        Option.AboutForm anAbout = new Option.AboutForm();
                        anAbout.FillForm(version, ConstantDefinition.GetExpirationCheckState(), licKey);
                        anAbout.ShowDialog();
                        anAbout.Dispose(); // ABA20230730
                        break;
                    case "perf":
                        MesurePerf mpf = new MesurePerf();
                        mpf.PackageMesurePerf();
                        MessageBox.Show("Finished.");
                        break;
                    case "-ManageCodeLists":
                        MessageBox.Show("-ManageCodeLists");
                        break;
                    case CODELIST_IMPORT_MENU:
                        //    MessageBox.Show("Not yet implemented   import codelists");
                        //DialCodeList di = new DialCodeList("import");
                        //di.ShowDialog();
                        //di.Dispose(); // ABA20230728
                        DialogResponse dialogResponseImp = new DialogResponse(true);
                        DialCodelistImport dialCodelistImport = new DialCodelistImport(Repo, dialogResponseImp);
                        dialCodelistImport.ShowDialog();
                        dialCodelistImport.Dispose();
                        if(dialogResponseImp.Canceled) return;

                        CodeLists cli = new CodeLists(Repository, "import");
                        cli.import();
                        if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                        {
                            MessageBox.Show("Finished.");
                        }
                        break;
                    case CODELIST_EXPORT_MENU:
                        //DialCodeList de = new DialCodeList("export");
                        //de.ShowDialog();
                        //de.Dispose(); // ABA20230728
                        DialogResponse dialogResponseExp = new DialogResponse(true);
                        DialCodelistExport dialCodelistExport = new DialCodelistExport(Repo, dialogResponseExp);
                        dialCodelistExport.ShowDialog();
                        dialCodelistExport.Dispose();
                        if (dialogResponseExp.Canceled) return;

                        try
                        {
                            MsgBox msgBox = new MsgBox();
                            msgBox.ShowProcessing();
                            CodeLists cle = new CodeLists(Repository, "export");
                            cle.export();
                            cle.exportstd();
                            cle.exportext();
                            cle.toHtml();
                        }
                        catch (Exception e)
                        {
                            ErrorCodes.ShowException(ErrorCodes.ERROR_058, e);
                        }
                        finally
                        {
                            msgBox.CloseBox();
                        }
                        //if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                        //{
                        //    MessageBox.Show("Finished.");
                        //}
                        break;
                    case CODELIST_EXPORT_JSON_MENU:
                        EA.Package selectedPkg = Repository.GetTreeSelectedPackage();
                        DialogResponse dialogResponseExpJson = new DialogResponse(true);
                        DialCodelistExportToJson dialCodelistExportToJson = new DialCodelistExportToJson(Repo, dialogResponseExpJson);
                        dialCodelistExportToJson.ShowDialog();
                        dialCodelistExportToJson.Dispose();
                        if (dialogResponseExpJson.Canceled) return;
                        JsonMapper jsonMapper = new JsonMapper();
                        string jsonCodelistString = null;
                        try
                        {
                            string localCodelistFilename = XMLP.GetXmlValueJsonData(DialExportCodelistToJsonTemplate.LASTJSONLOCALCODELIST_EXPORT_FILENAME);
                            //logger.Log("Main() - JsonCodelistSchemaID: " + XMLP.GetXmlValueJsonData(DialCodelistExportToJson.JSONCODELIST_SCHEMA_ID));
                            jsonCodelistString = jsonMapper.GenerateJsonCodelist(selectedPkg,
                                                                                 Repo,
                                                                                 XMLP.GetXmlValueJsonData(DialCodelistExportToJson.JSONCODELIST_SCHEMA_ID),
                                                                                 localCodelistFilename,
                                                                                 XMLP.GetXmlValueJsonData(DialCodelistExportToJson.JSONCODELIST_SCHEMA_REF),
                                                                                 dialogResponseExpJson.DirName);
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                            return;
                        }

                        if(jsonCodelistString != null &&  jsonCodelistString.Length > 0)
                        {
                            JsonGenerationUtilities.SaveJsonFile(jsonCodelistString, jsonMapper.GetCodelistOutputFileName());
                        }
                        break;
                    case CODELIST_TEMPLATE_EXPORT_JSON_MENU:
                        EA.Package selectedPackage = Repository.GetTreeSelectedPackage();
                        DialogResponse dialogResponseExpTmplJson = new DialogResponse(true);
                        DialExportCodelistToJsonTemplate dialExportCodelistToJsonTemplate = new DialExportCodelistToJsonTemplate(Repo, dialogResponseExpTmplJson);
                        dialExportCodelistToJsonTemplate.ShowDialog();
                        dialExportCodelistToJsonTemplate.Dispose();
                        if (dialogResponseExpTmplJson.Canceled) return;
                        jsonMapper = new JsonMapper();
                        string jsonCodelistTmplString = null;
                        try
                        {
                            string fullFileName = dialogResponseExpTmplJson.DirName + dialogResponseExpTmplJson.FileName;
                            jsonCodelistTmplString = jsonMapper.GenerateJsonCodelistTemplate(selectedPackage, Repo, fullFileName);
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                            return;
                        }

                        if (jsonCodelistTmplString != null && jsonCodelistTmplString.Length > 0)
                        {
                            JsonGenerationUtilities.SaveJsonFile(jsonCodelistTmplString, jsonMapper.GetCodelistTemplateOutputFileName(dialogResponseExpTmplJson));
                        }
                        break;
                    case "-Json":
                        MessageBox.Show("Json");
                        break;
                    case "json WG19":
                        try
                        {
                            MonTraitementJson(Main.Repo, JsonMapper.SCHEMA_TYPE_WG19);
                        } catch(Exception ex)
                        {
                            ErrorCodes.ShowException(ErrorCodes.ERROR_056, ex);
                        }
                        break;
                    case "json WG16":
                        try
                        {
                            MonTraitementJson(Main.Repo, JsonMapper.SCHEMA_TYPE_WG16);
                        }
                        catch (Exception ex)
                        {
                            ErrorCodes.ShowException(ErrorCodes.ERROR_057, ex);
                        }
                        break;
                    case AVRO_MENU:
                        CreateAvro(Main.Repo);
                        break;
                    /* ABA20231014
                    case "LastExportWg16ToAvro":
                        MonTraitementJson(Main.Repo, "avro");
                        break;
                    */
                }
                if (!(RDFutilitaires.Barre != null)) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                //try{//catches reportlog interrupts 
                //if (reportlog != null) // reportlog.Flush(); reportlog.Close();//am aout 2018
                //}  catch(Exception e)
                //{
                //    string prov=e.Message;
                //}
            }
            catch (Exception e)
            {
                ErrorCodes.ShowException(ErrorCodes.ERROR_060, e);
                //MessageBox.Show(" erreur main " + e.Message);
                //try{// in case of reortlog alread closed raises an interrupt
                //if (reportlog != null) // reportlog.Flush(); reportlog.Close();//am aout 2018
                //          }  catch(Exception ee)
                //{
                //    string prov=ee.Message;
                //}
            }
		}

        private void Montraitement501Ed2(Repository repository)
        {
            Thread t = new Thread(LancBar);
            try
            {
                typerdfexport = "501Ed2";
                EA.Package aPackage;
                aPackage = repository.GetTreeSelectedPackage();
                ConstDefinition constantes = new ConstDefinition();
                XMLProfileParameters profparameters = new XMLProfileParameters();
                RDFLAutilitaires rdflautilitaires = new RDFLAutilitaires(profparameters, repository);
                RDFLAutilitaires.reportlog = reportlog;
                RDFutilitaires.reportlog = reportlog;
                DialExport aDialstereosExport = new DialExport(profparameters);
                List<EA.Element> ElemList = new List<EA.Element>();
                List<EA.Package> ListPackageProfiles = new List<Package>();
                string provdir = FileManager.GetParentDirPath();
                XMLP = new XMLParser(Repo);
                // ABA20231220 RDFutilitaires.ongoing = true;
                // we initialize the necessary dictionaries
                EA.Collection modellist;
                modellist = repository.Models;
                EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, repository);
                /*
                //-------------------------------- provisoire ------------------
                string Entet = rdflautilitaires.GenerEntete(aPackage, toppack);
                Shaclgraph sg = new Shaclgraph(profparameters);
                throw new Exception(" THE  END  provisoire ");
                //----------------------------------------------------
                */
               
                try
                {
                    if (XMLP.GetXmlValueConfig("ModeTest") != "True")
                    {
                        t.Start();
                    }
                    if (XMLP.GetXmlValueConfig("Log") == "True")
                    {
                        Main.withlog = true;
                    }
                    else
                    {
                        Main.withlog = false;
                    }
                    // ABA20231220 RDFLAutilitaires.ongoing = true;
                    // ABA20231220 if ((RDFutilitaires.Barre != null) && (t.IsAlive)) RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;
                    
                    // // ABA20231220 
                    //if (!checkgo())
                    //{
                    //    //ta.stop();
                    //    //ta.quit();
                    //    return;
                    //}
                }
                catch (Exception e)
                {
                    MessageBox.Show(" Issue in building the dictionart DicsElem" + e.Message + "," + e.GetType().ToString());
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Issue in building the dictionart DicsElem" + e.Message + "," + e.GetType().ToString());
                    //reportlog.Close();
                    //ta.stop();
                    //ta.quit();
                    return;
                }
                RDFLAutilitaires.getStereotypedElements(aPackage, ElemList, ConstantDefinition.Cimstereos);
                if (XMLP.GetXmlValueConfig("ModeBatch") == "Unchecked")
                {
                    Dialrdf aDialrdf = new Dialrdf(profparameters, aPackage,"EU");
                    aDialrdf.ShowDialog();

                    // ABA20231220 
                    //if (RDFutilitaires.ongoing == false)
                    //{
                    //    //RDFLAutilitaires.// reportlog.Flush();
                    //    //RDFLAutilitaires.reportlog.Close();
                    //    return; // aborted treatment
                    //}

                    if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
                    {
                        //Option.Dialstereos aDialstereos = new Option.Dialstereos(profparameters);
                        //aDialstereos.ShowDialog();
                        //aDialstereos.Dispose(); // ABA20230729
                        DialogResponse dialogResponse = new DialogResponse(false);
                        Option.DialStereosNamespaces aDialstereosNamespaces = new Option.DialStereosNamespaces(profparameters, dialogResponse);
                        aDialstereosNamespaces.ShowDialog();
                        aDialstereosNamespaces.Dispose();
                        if (dialogResponse.Canceled) return;

                        // ABA20231220 
                        //if (RDFutilitaires.ongoing == false)
                        //{
                        //    //RDFLAutilitaires.// reportlog.Flush();
                        //    //RDFLAutilitaires.reportlog.Close();
                        //    //ta.stop();
                        //    //ta.quit();
                        //    return; // aborted treatment
                        //}
                        //--------------------------------------------------------------------
                        RDFutilitaires.ongoing = true;
                        selectedstereotypes = new List<string>();//am mai 2019
                        aDialstereosExport.selectedStereotypes = selectedstereotypes;
                        if (aPackage.Name == XMLP.GetXmlValueProfData("EntsoeEquipmentProfile"))
                        {
                            aDialstereosExport.ShowDialog();
                            selectedstereotypes = aDialstereosExport.selectedStereotypes;

                        }
                        //--------------------------------------------------------------------------------------
                        if (RDFutilitaires.ongoing == false)
                        {
                            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("  Process Interrupted  ongoing=false");
                            // reportlog.Flush();
                            //reportlog.Close();
                            //ta.stop(); ta.quit();
                            return; // aborted treatment
                        }
                    }
                    if (!ListPackageProfiles.Contains(aPackage)) ListPackageProfiles.Add(aPackage);
                }
                else
                {// mode batch
                    foreach (EA.Package pack in aPackage.Packages)
                    {
                        if (!ListPackageProfiles.Contains(pack)) ListPackageProfiles.Add(pack);
                    }
                }
                // mode batch et non batch
                LoadProfparametersfromConfig(profparameters);
                rdflautilitaires.NS_J0 = profparameters.RootModelURI;
                string nomfichier = " ";
                rdflautilitaires.DatatypePackageName = XMLP.GetXmlValueProfData("DataTypesDomain"); //"Domain"; // by default all the datatype may be  defined in a package Domain
                foreach (EA.Package package in ListPackageProfiles)
                {
                    RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 15
                    if (!checkgo())
                    {
                        // ta.stop();
                        // ta.quit(); 
                        return;
                    }
                    if (package.Name == rdflautilitaires.DatatypePackageName) continue;
                    aPackage = package;
                    /* repertoire ou se trouve le fichier  */
                    // Open an existing file, or create a new one.                  
                    FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");
                    if (System.IO.File.Exists(aPackage.Name.ToString())) System.IO.File.Delete(aPackage.Name.ToString());
                    Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                    TextWriter tw = new StreamWriter(Nomfic);
                    
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf augmented 2020  for Profile {0}", rdflautilitaires.NS_J0);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \n\t  The configuration file is in directory: " + XMLP.ActiveFilePath);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                    // ======================
                    List<long> packlist = new List<long>();
                    //ta.elapsetime("avant getAllPackID");
                    RDFLAutilitaires.getAllPackID(aPackage.PackageID, packlist);
                    /**********************************************************************/
                    string Finale = "</rdf:RDF>";
                    string Entete = "";
                    string header = "";
                    Entete = rdflautilitaires.GenerEntete(Repo, aPackage, toppack,"501Ed2");
                    header = rdflautilitaires.GenerHeader(aPackage, toppack,"501Ed2");
                    
                    /************************************************************************/
                    rdflautilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
                    rdflautilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
                    rdflautilitaires.nomsRoles = new List<RDFLAutilitaires.Nomrole>(); // avoid duplicates roles name
                    RDFLAutilitaires.LocalClassNames = new List<string>();
                    RDFLAutilitaires.buildLocalClassNames(aPackage, RDFLAutilitaires.LocalClassNames);
                    rdflautilitaires.NoDoublons = new List<string>();
                    rdflautilitaires.LocalDatatypeNames = new List<string>();
                    rdflautilitaires.LocalDatatypeIDs = new List<long>();
                    RDFutilitaires.buildLocalDatatypeNames(aPackage, rdflautilitaires.LocalDatatypeNames, rdflautilitaires.LocalDatatypeIDs);
                    // impression entete

                    //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile wit all the stereotypes for package=" + aPackage.Name);
                        tw.Write(Entete);
                        tw.Write(header);
                    Schema501 s501 = new Schema501(aPackage, profparameters,reportlog, tw);
                    foreach (long pid in packlist)
                    {
                        EA.Package p = Main.Repo.GetPackageByID((int)pid);
                        RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am janv 2016
                        //rdflautilitaires.serialize(p, tw);
                        s501.serialize(p);
                       
                    }
                    if (!checkgo()) return;  // am janv 2016
                    tw.WriteLine(Finale);
                    tw.Flush();
                    tw.Close();
                    // 
                    //-------------
                    Dictionary<string, string> dicIntermediatebyStereotype = new Dictionary<string, string>(); // dictionary of stream writers according to export stereotypes
                    Dictionary<string, TextReader> dicRwbyStereotype = new Dictionary<string, TextReader>();

                    //-----------------  
                    string newnomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                    string intermediate = "";
                    
                        TextReader rw = new StreamReader(Nomfic);
                        intermediate = rw.ReadToEnd();
                        rw.Close();
                        if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                    
                    Dictionary<string, string> entities = new Dictionary<string, string>();
                    // entities.Add("&ndash;", "&#x2013;");
                    for (int i = 0; i < CD.EntityToCodes.Length; i = i + 2)
                    {
                        entities.Add(CD.EntityToCodes[i], CD.EntityToCodes[i + 1]);
                    }
                    string newinter = "";
                    string newfic = "";
                    try
                    {
                        
                            newinter = RDFutilitaires.filterNotes(intermediate, entities);
                            newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                            Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                            if (System.IO.File.Exists(newfic)) System.IO.File.Delete(newfic);
                            System.IO.File.AppendAllText(newfic, newinter);
                        
                       
                    }
                    catch (Exception e)
                    {
                        RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);
                        MessageBox.Show("Problem in accessing some files " + e.Message);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation with error:" + DateTime.Now + "\n");
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                        // reportlog.Flush();
                        //RDFLAutilitaires.reportlog.Close();
                        return;
                    }
                    XMLP = new XMLParser(Repo);
                    if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")
                    {
                        nomfichier = System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + setNomFichier(aPackage, "rdf");
                        if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                        System.IO.File.Copy(Nomfic, nomfichier);
                        if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                    }
                    else
                    {
                        nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
                        //sept 20 nomfichier= System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + aPackage.Name + ".rdf";
                        //sept 20if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                        //sept 20 System.IO.File.Copy(Nomfic, nomfichier);
                        if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                        //MessageBox.Show("The rdf file is  " + nomfichier);
                        XMLP.SetXmlValueProfData("LastExportedProfile", nomfichier);
                        System.IO.File.Delete(Nomfic);
                    }
                    /*
                    if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))
                    {
                        foreach (string stereo in aDialstereosExport.selectedStereotypes)
                        {
                            string nf;
                            if (stereo != "")
                            {
                                nf = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";
                                string newnomfich = nomfichier.Remove(nomfichier.Length - 4) + "-" + stereo + ".rdf";
                                try
                                {
                                    if (System.IO.File.Exists(newnomfich))
                                    {
                                        System.IO.File.Delete(newnomfich);
                                    }
                                    System.IO.File.Copy(nf, newnomfich);
                                    System.IO.File.Delete(nf);
                                }
                                catch (Exception e)
                                {
                                    if (XMLP.GetXmlValueConfig("Log") == "Checked") XMLP.AddXmlLog("ISSUE", " Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                    MessageBox.Show(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                    RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                }
                            }

                        }
                    }
                    */
                    // the shacl constraints
                    Shaclgraph sg = new Shaclgraph(profparameters);

                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                    // reportlog.Flush();
                  
                } // end loop on profiles package
                  // Ensure that the target does not exist.
                //reportlog.Close();
                // MessageBox.Show(Path.GetDirectoryName(nomfichier) + "|" + Path.GetFileName(constantes.ReportGen));

                //-----------------  SHACL  -----------------------------------//
                // Shaclgraph sg = new Shaclgraph(profparameters);
                if (RDFutilitaires.Barre != null) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end"); ;
                MessageBox.Show(" the end");
                aDialstereosExport.Dispose(); // ABA20230730
            }
            catch (Exception e)
            {
              if (RDFutilitaires.Barre != null) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                ErrorCodes.ShowException(ErrorCodes.ERROR_054, e);
              //MessageBox.Show(" Exception dans le main " + e.Message) ;
              //if (reportlog != null)
              //{
              //  // reportlog.Flush();
              //  reportlog.Close();
              //}
              
            }
           
        }

        /// <summary>
        /// serialization of UML compatible with 2006 rdf augmented 
        /// but with the ontology header added
        /// </summary>
        /// <param name="repository"></param>
         void MontraitementRDF2020(Repository repository)
        {
            logger.Log("Start: " + DateTime.Now);
            //Ta ta = new Ta("MontraitementRDFLA");
            try
            {
                typerdfexport = "2020";
                EA.Package aPackage;
                aPackage = repository.GetTreeSelectedPackage();
                ConstDefinition constantes = new ConstDefinition();
                XMLProfileParameters profparameters = new XMLProfileParameters();
                RDFLAutilitaires rdflautilitaires = new RDFLAutilitaires(profparameters, repository);
                RDFLAutilitaires.reportlog = reportlog;
                RDFutilitaires.reportlog = reportlog;
                DialExport aDialstereosExport = new DialExport(profparameters);
                List<EA.Element> ElemList = new List<EA.Element>();
                List<EA.Package> ListPackageProfiles = new List<Package>();
                string provdir = FileManager.GetParentDirPath();
                XMLP = new XMLParser(Repo);
                RDFutilitaires.ongoing = true;
                // we initialize the necessary dictionaries
                EA.Collection modellist;
                modellist = repository.Models;
                EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, repository);
                logger.Log("Got model package: " + DateTime.Now);

                Thread t = new Thread(LancBar);
                try
                {
                    if (XMLP.GetXmlValueConfig("ModeTest") != "True")
                    {
                        t.Start();
                    }
                    if (XMLP.GetXmlValueConfig("Log") == "True")
                    {
                        Main.withlog = true;
                    }
                    else
                    {
                        Main.withlog = false;
                    }
                    RDFLAutilitaires.ongoing = true;
                    if ((RDFutilitaires.Barre != null) && (t.IsAlive)) RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;
                    if (!checkgo())
                    {
                        //ta.stop();
                        //ta.quit();
                        logger.Log("Return by checkgo 1: " + DateTime.Now);
                        return;
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(" Issue in building the dictionart DicsElem" + e.Message + "," + e.GetType().ToString());
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Issue in building the dictionart DicsElem" + e.Message + "," + e.GetType().ToString());
                    //reportlog.Close();
                    //ta.stop();
                    //ta.quit();
                    return;
                }
                RDFLAutilitaires.getStereotypedElements(aPackage, ElemList, ConstantDefinition.Cimstereos);
                logger.Log("Got stereotyped elements: " + DateTime.Now);

                if (XMLP.GetXmlValueConfig("ModeBatch") == "Unchecked")
                {
                    RDFutilitaires.ongoing = true;
                    logger.Log("Start aDialrdf dialogue: " + DateTime.Now);
                    Dialrdf aDialrdf = new Dialrdf(profparameters,aPackage,"EU");
                    logger.Log("Loaded aDialrdf dialogue: " + DateTime.Now);
                    aDialrdf.ShowDialog();
                    aDialrdf.Dispose();// ABA20230729
                    if (RDFutilitaires.ongoing == false)
                    {
                        //RDFLAutilitaires.// reportlog.Flush();
                        //RDFLAutilitaires.reportlog.Close();
                        logger.Log("RDFutilitaires.ongoing is false: " + DateTime.Now);
                        return; // aborted treatment
                    }
                    if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
                    {
                        DialogResponse dialogResponse = new DialogResponse(false);
                        logger.Log("Start dialStereosNamespaces dialogue: " + DateTime.Now);
                        Option.DialStereosNamespaces dialStereosNamespaces = new Option.DialStereosNamespaces(profparameters, dialogResponse);
                        logger.Log("Loaded dialStereosNamespaces dialogue: " + DateTime.Now);
                        dialStereosNamespaces.ShowDialog();
                        dialStereosNamespaces.Dispose(); // ABA20230730
                        if (dialogResponse.Canceled) return;

                        //if (RDFutilitaires.ongoing == false)
                        //{
                        //    //RDFLAutilitaires.// reportlog.Flush();
                        //    //RDFLAutilitaires.reportlog.Close();
                        //    //ta.stop();
                        //    //ta.quit();
                        //    return; // aborted treatment
                        //}
                        //--------------------------------------------------------------------
                        selectedstereotypes = new List<string>();//am mai 2019
                        aDialstereosExport.selectedStereotypes = selectedstereotypes;
                        if (aPackage.Name == XMLP.GetXmlValueProfData("EntsoeEquipmentProfile"))
                        {
                            aDialstereosExport.ShowDialog();
                            selectedstereotypes = aDialstereosExport.selectedStereotypes;

                        } /*else ABA20241110
                        {
                            MessageBox.Show("The selected package '" + aPackage.Name + "' does not match the package specified by the configuration parameter 'EntsoeEquipmentProfile'!");
                        }*/
                        //--------------------------------------------------------------------------------------
                        if (RDFutilitaires.ongoing == false)
                        {
                            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("  Process Interrupted  ongoing=false");
                            // reportlog.Flush();
                            //reportlog.Close();
                            //ta.stop(); ta.quit();
                            logger.Log("RDFutilitaires.ongoing is false, 2: " + DateTime.Now);
                            return; // aborted treatment
                        }
                    }
                    if (!ListPackageProfiles.Contains(aPackage)) ListPackageProfiles.Add(aPackage);
                }
                else
                {// mode batch
                    foreach (EA.Package pack in aPackage.Packages)
                    {
                        if (!ListPackageProfiles.Contains(pack)) ListPackageProfiles.Add(pack);
                    }
                }
                logger.Log("Mode batch done: " + DateTime.Now);

                // mode batch et non batch
                LoadProfparametersfromConfig(profparameters);
                rdflautilitaires.NS_J0 = profparameters.RootModelURI;
                string nomfichier = " ";
                rdflautilitaires.DatatypePackageName = XMLP.GetXmlValueProfData("DataTypesDomain"); //"Domain"; // by default all the datatype may be  defined in a package Domain
                logger.Log("Loop thru listPackageProfiles: " + DateTime.Now);
                foreach (EA.Package package in ListPackageProfiles)
                {
                    RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 15
                    if (!checkgo()) {
                        // ta.stop();
                        // ta.quit(); 
                        logger.Log("Return by checkgo 2: " + DateTime.Now);
                        return; 
                    } 
                    if (package.Name == rdflautilitaires.DatatypePackageName) continue;
                    aPackage = package;
                    /* repertoire ou se trouve le fichier  */
                    // Open an existing file, or create a new one.                  
                    FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");
                    if (System.IO.File.Exists(aPackage.Name.ToString())) System.IO.File.Delete(aPackage.Name.ToString());
                    Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                    TextWriter tw = new StreamWriter(Nomfic);
                    dicTwbyStereotype = new Dictionary<string, TextWriter>(); // dictionary of stream writers according to export stereotypes
                    if ((profparameters.ListStereoNamespaceExport.Count > 0) && ((XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name)))
                    {
                        foreach (string stereo in aDialstereosExport.selectedStereotypes)
                        {
                            if (stereo == "")
                            {
                                if (tw != null) tw.Close();
                                dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                            }
                            else
                            {
                                dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine("***** entsoe export by stereos added stereotype=" + stereo);
                            }
                        }
                    }
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf augmented 2020  for Profile {0}", rdflautilitaires.NS_J0);
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \n\t  The configuration file is in directory: " + XMLP.ActiveFilePath);
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                        // ======================
                      List<long> packlist = new List<long>();
                      //ta.elapsetime("avant getAllPackID");
                      RDFLAutilitaires.getAllPackID(aPackage.PackageID, packlist);
                    logger.Log("Got all packIds: " + DateTime.Now);

                    /**********************************************************************/
                    string Finale = "</rdf:RDF>";
                      string Entete = "";
                    string header = "";
                      Entete = rdflautilitaires.GenerEntete(Repo, aPackage, toppack,"2020");
                      header=rdflautilitaires.GenerHeader(aPackage, toppack,"2020");

                    /************************************************************************/
                      rdflautilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
                      rdflautilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
                      rdflautilitaires.nomsRoles = new List<RDFLAutilitaires.Nomrole>(); // avoid duplicates roles name
                      RDFLAutilitaires.LocalClassNames = new List<string>();
                      RDFLAutilitaires.buildLocalClassNames(aPackage, RDFLAutilitaires.LocalClassNames);
                      rdflautilitaires.NoDoublons = new List<string>();
                      rdflautilitaires.LocalDatatypeNames = new List<string>();
                      rdflautilitaires.LocalDatatypeIDs = new List<long>();
                      RDFutilitaires.buildLocalDatatypeNames(aPackage, rdflautilitaires.LocalDatatypeNames, rdflautilitaires.LocalDatatypeIDs);
                        // impression entete
                      if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  
                      {
                        foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                            {
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile with stereotype= " + kv.Key.ToString() + "for package=" + aPackage.Name);
                                dicTwbyStereotype[kv.Key].Write(Entete);
                                dicTwbyStereotype[kv.Key].Write(header);
                        }
                        }
                      else
                      {
                        //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile wit all the stereotypes for package=" + aPackage.Name);
                        tw.Write(Entete);
                        tw.Write(header);
                        logger.Log("Wrote Entete and header: " + DateTime.Now);

                    }
                    logger.Log("Loop thru packlist: " + DateTime.Now);
                    foreach (long pid in packlist)
                      {
                        EA.Package p = Main.Repo.GetPackageByID((int)pid);
                        RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am janv 2016
                            if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                            {
                                rdflautilitaires.serialize(p, dicTwbyStereotype);
                            }
                            else
                            {
                                rdflautilitaires.serialize(Main.Repo, p, tw);
                            }
                            if (!checkgo()) return;  // am janv 2016
                      }
                    logger.Log("Loop findished: " + DateTime.Now);
                    if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                        {
                          foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                          {
                            dicTwbyStereotype[kv.Key].WriteLine(Finale);
                            dicTwbyStereotype[kv.Key].Flush();
                            dicTwbyStereotype[kv.Key].Close();
                          }
                          if (tw != null) tw.Close(); 
                        }
                        else
                        {
                            tw.WriteLine(Finale);
                            tw.Flush();
                            tw.Close();
                            logger.Log("Closed file: " + DateTime.Now);

                        }

                    // 
                    //-------------
                    Dictionary<string, string> dicIntermediatebyStereotype = new Dictionary<string, string>(); // dictionary of stream writers according to export stereotypes
                        Dictionary<string, TextReader> dicRwbyStereotype = new Dictionary<string, TextReader>();

                        //-----------------  
                        string newnomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                        string intermediate = "";
                        if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                        {

                          foreach (string stereo in aDialstereosExport.selectedStereotypes)
                          {
                            if (stereo == "")
                            {
                              dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                            }
                            else
                            {
                              dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                            }
                          }
                          foreach (string stereo in aDialstereosExport.selectedStereotypes)
                          {
                            dicIntermediatebyStereotype.Add(stereo, dicRwbyStereotype[stereo].ReadToEnd());
                          }
                          foreach (KeyValuePair<string, TextReader> kv in dicRwbyStereotype)
                          {
                            dicRwbyStereotype[kv.Key].Close();
                          }
                        }
                        else
                        {
                          TextReader rw = new StreamReader(Nomfic);
                          intermediate = rw.ReadToEnd();
                          rw.Close();
                          if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                        }
                        Dictionary<string, string> entities = new Dictionary<string, string>();
                        // entities.Add("&ndash;", "&#x2013;");
                        for (int i = 0; i < CD.EntityToCodes.Length; i = i + 2)
                        {
                          entities.Add(CD.EntityToCodes[i], CD.EntityToCodes[i + 1]);
                        }
                        string newinter = "";
                        string newfic = "";
                        try
                        {
                            if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                            {
                                foreach (string stereo in aDialstereosExport.selectedStereotypes)
                                {
                                    newinter = RDFutilitaires.filterNotes(dicIntermediatebyStereotype[stereo], entities);
                                    if (stereo == "")
                                    {
                                        newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                                        Nomfic = newfic;// legacy
                                    }
                                    else
                                    {
                                        newfic = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";
                                    }
                                    if (System.IO.File.Exists(newfic)) System.IO.File.Delete(newfic);
                                    System.IO.File.AppendAllText(newfic, newinter);
                                }

                            }
                            else
                            {
                                newinter = RDFutilitaires.filterNotes(intermediate, entities);
                                newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                                Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                                if (System.IO.File.Exists(newfic)) System.IO.File.Delete(newfic);
                                System.IO.File.AppendAllText(newfic, newinter);
                            }
                       
                        }
                        catch (Exception e)
                        {
                          RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);  
                          MessageBox.Show("Problem in accessing some files " + e.Message);
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation with error:" + DateTime.Now + "\n");
                          // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                          // reportlog.Flush();
                          //RDFLAutilitaires.reportlog.Close();
                          return;
                        }
                        XMLP = new XMLParser(Repo);
                        if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")
                        { 
                          nomfichier = System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + setNomFichier(aPackage, "rdf");
                          if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                          System.IO.File.Copy(Nomfic, nomfichier);
                          if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                        }
                        else
                        {
                        nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
                        //sept 20 nomfichier= System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + aPackage.Name + ".rdf";
                        //sept 20if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                        //sept 20 System.IO.File.Copy(Nomfic, nomfichier);
                        if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                        //MessageBox.Show("The rdf file is  " + nomfichier);
                        XMLP.SetXmlValueProfData("LastExportedProfile", nomfichier);
                          System.IO.File.Delete(Nomfic);
                        }
                        if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  
                        {
                          foreach (string stereo in aDialstereosExport.selectedStereotypes)
                          {
                            string nf;
                            if (stereo != "")
                            {
                              nf = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";
                                    string newnomfich = nomfichier.Remove(nomfichier.Length - 4) + "-" + stereo + ".rdf";
                                    try
                                    {
                                    if (System.IO.File.Exists(newnomfich))
                                    {
                                      System.IO.File.Delete(newnomfich);
                                    }
                                    System.IO.File.Copy(nf, newnomfich);
                                    System.IO.File.Delete(nf);
                                    }
                                    catch (Exception e)
                                    {
                                        if (XMLP.GetXmlValueConfig("Log") == "Checked") XMLP.AddXmlLog("ISSUE", " Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                        MessageBox.Show(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                        //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                    }
                            }

                          }
                        }
                        aDialstereosExport.Dispose(); // ABA20230729
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                        // reportlog.Flush();
                       // Shaclgraph sg = new Shaclgraph(profparameters);
                } // end loop on profiles package
                      // Ensure that the target does not exist.
                    //reportlog.Close();
                    // MessageBox.Show(Path.GetDirectoryName(nomfichier) + "|" + Path.GetFileName(constantes.ReportGen));
                
            }
            catch (Exception e)
            {
              if (RDFutilitaires.Barre != null) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
              //MessageBox.Show(" Exception dans le main " + e.Message) ;
                ErrorCodes.ShowException(ErrorCodes.ERROR_061, e);
              //if (reportlog != null)
              //{
              //  // reportlog.Flush();
              //  reportlog.Close();
              //}
            }
            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");// am janv 2016
            //ta.stop();
            //ta.quit();
            MessageBox.Show(" the End");
        }

        /// <summary>
        ///     creation d'un codecomponent a partir des fichiers selectiones par codecomponentForm
        ///     selectedCCFiles
        /// </summary>
        private void prodCodeComponent()
        {
            try
            {
                // creating the directory for the code component
                
            }
            catch(Exception ex)
            {
                XMLP.AddXmlLog("prodComponent", ex.Message);
            }
        }

        static string nomfic; // name of the file
            public static string Nomfic  //public property
            {
                get { return nomfic; }
            
            
                set { nomfic= value; }
            }
        
        
     //traitement pour produire un fichier RDF selon l'algorithme du document 501
        /// <summary>
        ///  attention a l ordre des traitements
       ///   on cree dabord les dicos by id et by name de tous les elements du package initial
       ///   a cette occasion on  recupree tous les elements recursivement de ce package
       ///   a la volee on cree le dico by id des packages correspondants
       ///   puis on traite les classes en creant  l'entree du package la category correspondante
        /// </summary>
        /// <param name="Repository"></param>
        public void MontraitementRDF(EA.Repository Repository)

        {
            EA.Package aPackage;
            aPackage = Repository.GetTreeSelectedPackage();
     	    ConstDefinition constantes = new ConstDefinition();
           RDFutilitaires rdfutilitaires = new RDFutilitaires();
           List <EA.Element> ElemList= new List<EA.Element>();
           List<string> NoDoublons = new List<string>();

           


	   //18 Open an existing file, or create a new one.
         FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");
            //18 Determine the full path of the file just created and show it
            //18 DirectoryInfo di = fi.Directory;
            //18  MessageBox.Show(di.ToString()+ "\\" + aPackage.Name.ToString() + ".rdf");
            string provdir = FileManager.GetParentDirPath();
            Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf"; // am out 2018  ATTENTION a envoyer en appdata

            // ===report file =====
            try
            {
                //am aout 2018RDFutilitaires.reportlog= new StreamWriter(constantes.ReportGen); //  the report file
                if (RDFutilitaires.ongoing == false) return;
            }
            catch (Exception)
            {
                MessageBox.Show(" Error when opening file " + constantes.ReportGen);
                return;
            }
            //=====================
            RDFutilitaires.reportlog = reportlog;
            //if (Main.DO_REPORTLOG) RDFutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
            //   RDFutilitaires.reportlog.Write(stringtowrite);
            //   RDFutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t{0}", profparameters.TargetNamespace);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf for {0}", aPackage.Name);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            // ======================

            //StreamWriter tw = new StreamWriter(Nomfic); ABA20230730
            using (StreamWriter tw = new StreamWriter(Nomfic)) // ABA20230730
            {
                // we initialize the necessary dictionaries
                EA.Collection modellist;
                modellist = Repository.Models;
                EA.Package toppack;
                toppack = RDFutilitaires.GetModelPackage(aPackage, Repository);

                RDFutilitaires.buildDicsElem(toppack);
                RDFutilitaires.getStereotypedElements(aPackage, ElemList, ConstantDefinition.Cimstereos);
                List<long> packlist = new List<long>();
                RDFutilitaires.getAllPackID(aPackage.PackageID, packlist);
                string Entete = "";
                Entete = Entete + "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n";
                Entete = Entete + "<rdf:RDF xmlns:cims=\"http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#\" ";
                Entete = Entete + "xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" ";
                Entete = Entete + "xmlns:rdfs=\"http://www.w3.org/2000/01/rdf-schema#\">";
                string Finale = "</rdf:RDF>";
                rdfutilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
                rdfutilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
                rdfutilitaires.nomsRoles = new List<RDFutilitaires.Nomrole>();
                RDFutilitaires.LocalClassNames = new List<string>();
                RDFutilitaires.buildLocalClassNames(aPackage, RDFutilitaires.LocalClassNames);
                rdfutilitaires.NoDoublons = new List<string>();
                rdfutilitaires.LocalDatatypeNames = new List<string>();
                rdfutilitaires.LocalDatatypeIDs = new List<long>();
                RDFutilitaires.buildLocalDatatypeNames(aPackage, rdfutilitaires.LocalDatatypeNames, rdfutilitaires.LocalDatatypeIDs);
                // impression entete
                tw.WriteLine(Entete);
                rdfutilitaires.DatatypePackageName = "Domain"; // by default all the datatype are defined in a package Domain
                foreach (long pid in packlist)
                {
                    //18 EA.Package p = RDFutilitaires.dicpackbyid[pid];
                    EA.Package p = Main.Repo.GetPackageByID((int)pid);
                    if (p.Name == "PDomain") rdfutilitaires.DatatypePackageName = "PDomain"; // in a profile the datatypes may be defined in Pdomain
                }
                foreach (long pid in packlist)
                {
                    EA.Package p = Main.Repo.GetPackageByID((int)pid);


                    rdfutilitaires.serialize(p, tw);
                }

                tw.WriteLine(Finale);
                // close the stream
                tw.Flush();
                //tw.Close(); ABA20230730

            }

            //-----------------------------
            string nomfichier="";
            XMLP = new XMLParser(Repo);
            if (XMLP.GetXmlValueConfig("ModeBatch")=="Checked")  // am june 2013
            {
                nomfichier = setNomFichier(aPackage, "rdf");
                System.IO.File.Copy(Nomfic, nomfichier);
            }
            else
            {
                 nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
            }//am june 2013
          //   theForm = new Form1();
           //  theForm.ShowDialog();
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            // reportlog.Flush();
            //reportlog.Close();
            /* //am aout 2018
              try
            {
                string nomcible= Path.GetDirectoryName(nomfichier) + "\\" + Path.GetFileName(constantes.ReportGen);
		if(constantes.ReportGen != nomcible) {
                System.IO.File.Delete(nomcible);
                System.IO.File.Copy(constantes.ReportGen, nomcible);
		System.IO.File.Delete(constantes.ReportGen);
              }

            }
            catch (Exception e)
            {
                MessageBox.Show("Report file copy error  " + e.Message + "\n from:" + constantes.ReportGen );
            }
            */
            if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
            {
                MessageBox.Show(" the End");
            }
        }
        
       static   bool isparent(EA.Element e)
        { if (e.ParentID ==  parentid) return true; else return false; }
		
        public bool readLine(StreamReader sreader)
		{
			bool answer;
			answer = false;
			
			try
			{
				filecontents = filecontents + "\n" + sreader.ReadLine();
			}
			catch
			{
				answer = true;
			}

			return answer;}
/// <summary>
/// start a process or open a document if 
/// the filename is without extent .exe
/// </summary>
/// <param name="Path"></param>
/// <param name="filename"></param>
        public static void StartProcess(string Path ,string filename,string args)
        {
            Process myProcess = new Process();

            try
            {
              if(Path != "")
                myProcess.StartInfo.FileName = Path + "\\" + filename ;
              else myProcess.StartInfo.FileName = filename;
              //  myProcess.StartInfo.Verb = verb;
                myProcess.StartInfo.CreateNoWindow = false;
                myProcess.Start();
            }
            catch (Win32Exception e)
            {
                if (e.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                {
                    Console.WriteLine(e.Message + ". Check the path.");
                }

                else if (e.NativeErrorCode == ERROR_ACCESS_DENIED)
                {
                    // Note that if your word processor might generate exceptions
                    // such as this, which are handled first.
                    Console.WriteLine(e.Message +
                        ". You do not have permission to read this file.");
                }
            }


            // On libre les ressources dont on n'a plus besoin.
            myProcess.Close(); // Attention Close ne met pas fin au processus.
        }

        public void CreateAvro(EA.Repository repo)
        {
            EA.Package aPackage = repo.GetTreeSelectedPackage();
            if(aPackage == null)
            {
                MessageBox.Show("Please select a package for Avro generation.");
                return;
            }
            DialogResponse dialogResponse = new DialogResponse(true);
            AvroGenDialog avroGenDialog = new AvroGenDialog(Repo, aPackage, dialogResponse);
            avroGenDialog.ShowDialog();
            avroGenDialog.Dispose();
            if (!dialogResponse.Canceled)
            {
                try
                {
                    AvroMapper avroMapper = new AvroMapper(Repo);
                    string avroString = avroMapper.CreateMapping(aPackage, dialogResponse.NameSpace);
                    if(avroString != null)
                    {
                        JsonGenerationUtilities.SaveJsonFile(avroString, dialogResponse.FileName);
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                    return;
                }
            }
        }

        public void CreateAsciiDoc(EA.Repository repo)
        {
            EA.Package aPackage = repo.GetTreeSelectedPackage();
            if (aPackage == null)
            {
                MessageBox.Show("Please select a package for AsciiDoc generation.");
                return;
            }
            DialogResponse dialogResponse = new DialogResponse(true);
            AsciiDocExportDialog asciiDocExportDialog = new AsciiDocExportDialog(Repo, aPackage, dialogResponse);
            asciiDocExportDialog.ShowDialog();
            asciiDocExportDialog.Dispose();
            if (!dialogResponse.Canceled)
            {
                try
                {
                    AsciiDocGenerator asciiDocExporter = new AsciiDocGenerator(Repo);
                    string asciiDoc = asciiDocExporter.CreateDocu(aPackage, dialogResponse.DirName);
                    asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, asciiDoc);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                    return;
                }
            }
        }

        //---------------------------------------------------------------------------
        public void MonTraitementJson(EA.Repository Repository, string wg)
        {
            XMLProfileParameters profparameters;
            EA.Package apackage;

            if (XMLP.GetXmlValueConfig("Log") == "True") Main.withlog = true;
            else Main.withlog = false;

            try
            {
                apackage = Repository.GetTreeSelectedPackage();
                profparameters = new XMLProfileParameters();
            }
            catch (Exception e1)
            {
                throw new Exception("Error on loading ProfileParameters: " + e1.Message + "\n" + e1.StackTrace);
            }

            try
            {
                {
                    DialogResponse dialogResponse = new DialogResponse(true);
                    try
                    {
                        Dialjson dj = new Dialjson(wg, dialogResponse);
                        dj.ShowDialog();
                        dj.Dispose(); // ABA20230730
                    }
                    catch (Exception e4)
                    {
                        ErrorCodes.ShowException(ErrorCodes.ERROR_001, e4);
                        return;
                    }
                    if(!dialogResponse.Canceled)
                    {
                        try
                        {
                            XMLP.SetXmlValueProfData("SelectedProfileForJson", apackage.PackageID.ToString());
                        }
                        catch (Exception e6)
                        {
                            ErrorCodes.ShowException(ErrorCodes.ERROR_002, e6);
                            return;
                        }
                        JsonMapper jsonMapper = new JsonMapper();
                        string jsonString = "";
                        try
                        {
                            jsonString = jsonMapper.CreateMapping(Repo, apackage, wg, dialogResponse.CheckBoxTicked);
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                            return;
                        }
                        JsonGenerationUtilities.SaveJsonFile(jsonString, jsonMapper.GetOutputFileName());
                        EA.Package codelistPackage = jsonMapper.CodelistPackage;
                        if(codelistPackage != null)
                        {
                            string jsonCodelistString = null;
                            string localCodelistDir = XMLP.GetXmlValueJsonData(DialExportCodelistToJsonTemplate.LASTJSONLOCALCODELIST_EXPORT_DIRECTORY);
                            string localCodelistFilename = XMLP.GetXmlValueJsonData(DialExportCodelistToJsonTemplate.LASTJSONLOCALCODELIST_EXPORT_FILENAME);
                            if (!localCodelistFilename.EndsWith("\\")) localCodelistDir += "\\";
                            string localCodelistFullFilename = localCodelistDir + localCodelistFilename;

                            try
                            {
                                jsonCodelistString = jsonMapper.GenerateJsonCodelist(codelistPackage,
                                                                                     Repo,
                                                                                     XMLP.GetXmlValueJsonData(DialCodelistExportToJson.JSONCODELIST_SCHEMA_ID),
                                                                                     localCodelistFullFilename,
                                                                                     XMLP.GetXmlValueJsonData(DialCodelistExportToJson.JSONCODELIST_SCHEMA_REF),
                                                                                     dialogResponse.DirName);
                            }
                            catch (Exception e)
                            {
                                MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                                return;
                            } finally
                            {
                                // reportlog.Flush();
                                //reportlog.Close();
                            }

                            if (jsonCodelistString != null && jsonCodelistString.Length > 0)
                            {
                                string dir = dialogResponse.DirName;
                                if (!dir.EndsWith("\\")) dir += "\\";
                                string filename = dir + XMLP.GetXmlValueJsonData(DialCodelistExportToJson.LASTJSONCODELIST_EXPORT_FILENAME);
                                try
                                {
                                    JsonGenerationUtilities.SaveJsonFile(jsonCodelistString, filename);
                                } catch(Exception e)
                                {
                                    MessageBox.Show(e.Message + ":\n" + e.StackTrace);
                                }
                            }

                        }
                    }
                }
            }
            catch (Exception e)
            {
                MessageBox.Show(" Error json " + e.Message + "\n" + e.StackTrace); 
            } finally
            {
                // reportlog.Flush();
                //reportlog.Close();
            }

        }
        //----------------------------------------------------
        /// <summary>
        /// this will explore the profile
        /// starting with the package apackage
        /// and produce the XSD schemas
        /// according to WG19 NDR specs
        /// </summary>
        /// <param name="Repository"></param>
        /// <param name="?"></param>
        public void MonTraitementXSD(EA.Repository Repository,string wg)
        {
            try
            {
                Thread t = new Thread(LancBar);//am dec 2016
                string prov = XMLP.GetXmlValueConfig("ModeTest");
                if (XMLP.GetXmlValueConfig("ModeTest")!="True")
                {
                    t.Start();//am dec 2016
                }
                if (XMLP.GetXmlValueConfig("Log") == "True")
                {
                    Main.withlog = true;
                }
                else
                {
                    Main.withlog = false;
                }
                RDFLAutilitaires.ongoing = true;//am dec 2016
                if ((RDFutilitaires.Barre != null) && (t.IsAlive)) RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;//am dec 2016

                if (!checkgo()) return;   //am dec 2016
                EA.Package apackage = Repository.GetTreeSelectedPackage();

                if (CIMSchemaGenerator.fluxdata != null)
                {
                    CIMSchemaGenerator.fluxdata.Close();
                    try
                    {
                        System.IO.File.Delete(CIMSchemaGenerator.nomfic);
                    } catch(Exception) { /* ignore */}
                }
                //if (CIMSchemaGenerator.reportlog != null)
                //{
                //    CIMSchemaGenerator.reportlog.Close();
                //}
            
           
                if((wg=="wg19") || (wg=="wg19byref")) {
                    CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage,wg);
                }
                if (wg == "wg14")
                {
                    CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg14");
                    //CIMSchemaGenerator.GenerXSD genxsd = new CIMSchemaGenerator.GenerXSD(Repository, apackage, "wg14");
                    //genxsd.Close();
                }

                if (wg == "wg16")
                {
                    // CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage);
                    CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg16");
                    RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                }
                if (RDFutilitaires.ongoing == true)
                {

                    if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                    {
                        MessageBox.Show("The End");
                    }
              
                }
                else
                {
                    MessageBox.Show("Generation stopped.");
                }
            }
            catch (Exception e)
            {
                ErrorCodes.ShowException(ErrorCodes.ERROR_063, e);
            }
          //am aout 2018   if (CIMSchemaGenerator.reportlog != null)
          //  {

               //am aout 2018  CIMSchemaGenerator.// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");

                // reportlog.Flush();
                //reportlog.Close();
               RDFutilitaires.ongoing = true;
            // }

        }
//----------------------------------------------------
  
        //---------------------------------------------------------------------------

        public void MonTraitementXSDWG14(EA.Repository Repository)
        {
            EA.Package apackage = Repository.GetTreeSelectedPackage();
            CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg14");
           // CIMSchemaGenerator.GenerXSD genxsd = new CIMSchemaGenerator.GenerXSD(Repository, apackage, "wg14");
            if (RDFutilitaires.ongoing == true)
            {
                if (CIMSchemaGenerator.fluxdata != null)
                {
                    CIMSchemaGenerator.fluxdata.Close();
                    System.IO.File.Delete(CIMSchemaGenerator.nomfic);
                }
                if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                {
                    MessageBox.Show("The End");
                }
            }
            else
            {
                MessageBox.Show("volontarily canceled");
                RDFLAutilitaires.ongoing = true;
            }
         //am aout 2018  CIMSchemaGenerator.// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");

            // reportlog.Flush();
            //reportlog.Close();
        }
        //---------------------------------------------------------------------------
      public void 
          
          
          MontraitementRDFLA(EA.Repository Repository)
        {

           
            //Ta ta = new Ta("MontraitementRDFLA");
          try{

                typerdfexport = "2019";
        
           
            EA.Package aPackage;
            aPackage = Repository.GetTreeSelectedPackage();
       
            ConstDefinition constantes = new ConstDefinition();
            XMLProfileParameters profparameters = new XMLProfileParameters();
           RDFLAutilitaires rdflautilitaires = new RDFLAutilitaires(profparameters, Repository);
           RDFLAutilitaires.reportlog = reportlog;
           RDFutilitaires.reportlog = reportlog;
           DialExport aDialstereosExport = new DialExport(profparameters);
           List <EA.Element> ElemList= new List<EA.Element>();
           List<EA.Package> ListPackageProfiles = new List<Package>();

                string provdir = FileManager.GetParentDirPath(); // ABA20230301

           // ===report file =====
          
           try
           {   
              //am aout 2018  RDFLAutilitaires.reportlog = new StreamWriter(Path.GetDirectoryName(XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt");
               RDFLAutilitaires.wtest("TEST"," the report file is=" + Path.GetDirectoryName(XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt"); 
               //am aout 2018 RDFutilitaires.reportlog = (StreamWriter)RDFLAutilitaires.reportlog;
               /* pour essai
               EA.Element elt = RDFutilitaires.GetElementById(-1);
               if(elt==null)
               {
              MessageBox.Show("elt null");
               }else{
                   MessageBox.Show("elt " + elt.Name);
               }
                * */
           }
           catch (Exception e)
           {
               MessageBox.Show(" Error when opening file " +Path.GetDirectoryName( XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt  " + e.Message) ;
               //ta.stop();
               //ta.quit();
               return;
           }
           //=====================	
          /* lancement dialogue initial  */
              XMLP = new XMLParser(Repo);
           RDFutilitaires.ongoing = true;

           // we initialize the necessary dictionaries
           EA.Collection modellist;
           modellist = Repository.Models;
           EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, Repository);
           Thread t = new Thread(LancBar);
           try
           {
               if (XMLP.GetXmlValueConfig("ModeTest") != "True")
               {
                   t.Start();
               }
               if (XMLP.GetXmlValueConfig("Log") == "True")
               {
                   Main.withlog = true;
               }else{
                   Main.withlog = false;
               }
               
               RDFLAutilitaires.ongoing = true;
               
              // RDFLAutilitaires.wtest("TEST", " debut construction dictionnaires");
              //am aout 2018  RDFLAutilitaires.buildDicsElem(toppack);
              // RDFLAutilitaires.wtest("TEST", " fin construction dictionnaire");

             if((RDFutilitaires.Barre != null) && (t.IsAlive))   RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;
              //18 RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" After building DicsElem  nb elements=" + RDFLAutilitaires.dicelembyid.Count.ToString() + " ongoing=" + RDFLAutilitaires.ongoing.ToString());
               if (!checkgo())
               {
                  // ta.stop();
                  // ta.quit();
                   return;
               }
           }catch(Exception e)
           {
               
               MessageBox.Show(" Issue in building the dictionart DicsElem" + e.Message + ","  +e.GetType().ToString());
             //am aout 2018   RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" Issue in building the dictionart DicsElem" + e.Message +"," + e.GetType().ToString());
               // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Issue in building the dictionart DicsElem" + e.Message + "," + e.GetType().ToString());
               //reportlog.Close();
              // ta.stop();
              // ta.quit();
               return;
           }

           

           RDFLAutilitaires.getStereotypedElements(aPackage, ElemList, ConstantDefinition.Cimstereos);
   
           if (XMLP.GetXmlValueConfig("ModeBatch") == "Unchecked")
           { // am june 2013

               Dialrdf aDialrdf = new Dialrdf(profparameters,aPackage,"EU");
               aDialrdf.ShowDialog();
               aDialrdf.Dispose(); // ABA20230730
               if (RDFutilitaires.ongoing == false)
               {
                   //RDFLAutilitaires.// reportlog.Flush();
                   //RDFLAutilitaires.reportlog.Close();
                   if (RDFutilitaires.Barre != null) RDFutilitaires.Barre.Close();
                   return; // aborted treatment
               }


               if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
               {
                   DialogResponse dialogResponse = new DialogResponse(false);
                   Option.DialStereosNamespaces dialStereosNamespaces = new Option.DialStereosNamespaces(profparameters, dialogResponse);
                   dialStereosNamespaces.ShowDialog();
                   dialStereosNamespaces.Dispose(); // ABA20230729
                   if (dialogResponse.Canceled) return;

                   //if (RDFutilitaires.ongoing == false)
                   //{
                   //    //RDFLAutilitaires.// reportlog.Flush();
                   //    //RDFLAutilitaires.reportlog.Close();
                   //  //  ta.stop();
                   //  //  ta.quit();
                   //    return; // aborted treatment
                   //}
                        //--------------------------------------------------------------------

                        //List<string> selectedstereotypes = new List<string>();//am mai 2019
                        selectedstereotypes = new List<string>();//am mai 2019
                        aDialstereosExport.selectedStereotypes = selectedstereotypes;
                   // List<string> l = aDialstereosExport.selectedStereotypes;
                   if (aPackage.Name == XMLP.GetXmlValueProfData("EntsoeEquipmentProfile"))
                   {
                       aDialstereosExport.ShowDialog();
                       selectedstereotypes = aDialstereosExport.selectedStereotypes;                      
                   }



                   //--------------------------------------------------------------------------------------
                   if (RDFutilitaires.ongoing == false)
                   {
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                       //am aout 2018 RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("  Process Interrupted  ongoing=false");
                       // if(Main.DO_REPORTLOG) reportlog.WriteLine("  Process Interrupted  ongoing=false");
                       // reportlog.Flush();
                       //reportlog.Close();
                      // ta.stop(); ta.quit();
                       return; // aborted treatment
                   }
               }
               if (!ListPackageProfiles.Contains(aPackage)) ListPackageProfiles.Add(aPackage);
           }// am june 2013
           else
           {// mode batch
               foreach (EA.Package pack in aPackage.Packages)
               {
                   if(!ListPackageProfiles.Contains(pack)) ListPackageProfiles.Add(pack);
               }
           }
          // mode batch et non batch
           LoadProfparametersfromConfig(profparameters); // am june 2013
               rdflautilitaires.NS_J0 = profparameters.RootModelURI;// +"#";
               string nomfichier = " ";
               rdflautilitaires.DatatypePackageName = XMLP.GetXmlValueProfData("DataTypesDomain"); //"Domain"; // by default all the datatype are defined in a package Domain
               foreach (EA.Package package in ListPackageProfiles)
               {
                   RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 15
                   if (!checkgo()) { 
                       // ta.stop(); 
                       // ta.quit(); 
                        return; } // am  janv 2016 aout 2018
                   if (package.Name == rdflautilitaires.DatatypePackageName) continue;
                   aPackage = package;

                   /* repertoire ou se trouve le fichier  */
                   // Open an existing file, or create a new one.                  
                   FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");
                   if (System.IO.File.Exists(aPackage.Name.ToString())) System.IO.File.Delete(aPackage.Name.ToString());
                   // Determine the full path of the file just created and show it
                  // DirectoryInfo di = fi.Directory;  //am nov 2015
                   // MessageBox.Show(di.ToString()+ "\\" + aPackage.Name.ToString() + ".rdf");

                   Nomfic = provdir+ "\\" + aPackage. Name.ToString() + "_prov.rdf";

                   TextWriter tw = new StreamWriter(Nomfic);
                   dicTwbyStereotype = new Dictionary<string, TextWriter>(); // dictionary of stream writers according to export stereotypes

                   if ((profparameters.ListStereoNamespaceExport.Count > 0) && ((XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name)))
                   {

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           if (stereo == "")
                           {
                               if (tw != null) tw.Close();
                               dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir+ "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                           }
                           else
                           {
                               dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                           }
                          // RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("***** entsoe export by stereos added stereotype=" + stereo);
                           // if(Main.DO_REPORTLOG) reportlog.WriteLine("***** entsoe export by stereos added stereotype=" + stereo);

                       }
                       // dicTwbyStereotype.Add("", tw);
                   }
                   
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
                   //   RDFLAutilitaires.reportlog.Write(stringtowrite);
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf augmented for Profile {0}", rdflautilitaires.NS_J0);
                   //RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t rdf for {0}",aPackage.Name);
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \n\t  The configuration file is in directory: " + XMLP.ActiveFilePath);
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // ======================

                   List<long> packlist = new List<long>();
                  // ta.elapsetime("avant getAllPackID");
                   RDFLAutilitaires.getAllPackID(aPackage.PackageID, packlist);
                   string Entete = "";
                   Entete = Entete + "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n";
                   Entete = Entete + "<rdf:RDF xmlns:cims=\"" + constantes.NS_CIMS + "\" ";
                   Entete = Entete + "xmlns:rdf=\"" + constantes.NS_RDF + "\" ";
                   Entete = Entete + "xmlns:xsd=\"" + constantes.NS_XSD + "\" ";
                   //Entete = Entete + "xmlns:" + profparameters.Prefix + "=\"" + rdflautilitaires.NS_J0 + "\" ";
                   Entete = Entete + "xmlns:rdfs=\"" + constantes.NS_RDFS + "\"";
                    Entete = Entete + " xmlns:" + XMLP.GetXmlValueProfData("Prefix") + "=\"" +  XMLP.GetXmlValueProfData("ProfileNamespace")+"\"";
                    if (typerdfexport == "2019")
                    { //am2022
                        if (!RDFLAutilitaires.namespaces.ContainsKey(XMLP.GetXmlValueProfData("Prefix")))
                        {
                            if (!RDFLAutilitaires.namespaces.ContainsKey(XMLP.GetXmlValueProfData("Prefix")))
                            {
                                RDFLAutilitaires.namespaces.Add(XMLP.GetXmlValueProfData("Prefix"), XMLP.GetXmlValueProfData("ProfileNamespace"));
                            }
                        }
                    }
                   if (XMLP.GetXmlValueConfig("Xmlbase") == "Checked")
                   {
                       Entete = Entete + " xml:base=\"" + XMLP.GetXmlValueProfData("DefaultRootModelURI").Trim('#') + "\"";
                   }

                   //Entete = Entete + ">"; //am fev 2012
                   if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
                   {
                       string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                       string[] stereos = liststereos.Split(new char[] { '|' });
                       // verifier si les indicateurs de stereos sont positionnes
                       if (IndStereos.Count == 0)
                       {
                           //MessageBox.Show("it seems that you want to introduce classifying stereos but you do not have saved your choices \n\r (menu option)");
                           RDFLAutilitaires.InitIndStereos(stereos,XMLP);
                       }

                       string nsextensions = "";
                       List<string> prefixies = new List<string>();
                       prefixies.Add(profparameters.Prefix); // ne pas oublier le name space par default dans le test de redondance
                       foreach (string stereo in stereos)
                       {
                           string prefix = profparameters.urisbystereo[stereo][0];

                           if (!prefixies.Contains(prefix))
                           {
                               nsextensions = nsextensions + " xmlns:" + prefix + "=\"" + profparameters.urisbystereo[stereo][1] + "\" ";
                               prefixies.Add(prefix);
                           }
                       }
                       Entete = Entete + nsextensions;  // +">";
                   }
                   Entete = Entete + ">\n"; //am fev 2012
                   Entete = Entete + profparameters.copyrightnotice;
                   string Finale = "</rdf:RDF>";
                   rdflautilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
                   rdflautilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
                   rdflautilitaires.nomsRoles = new List<RDFLAutilitaires.Nomrole>(); // avoid duplicates roles name
                   RDFLAutilitaires.LocalClassNames = new List<string>();
                   RDFLAutilitaires.buildLocalClassNames(aPackage, RDFLAutilitaires.LocalClassNames);
                   rdflautilitaires.NoDoublons = new List<string>();
                   rdflautilitaires.LocalDatatypeNames = new List<string>();
                   rdflautilitaires.LocalDatatypeIDs = new List<long>();
                   RDFutilitaires.buildLocalDatatypeNames(aPackage, rdflautilitaires.LocalDatatypeNames, rdflautilitaires.LocalDatatypeIDs);
                   // impression entete
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
                       foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                       {
                           //RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile with stereotype= " + kv.Key.ToString() + "for package=" + aPackage.Name);
                           // if(Main.DO_REPORTLOG) reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile with stereotype= " + kv.Key.ToString() + "for package=" + aPackage.Name); 
                           dicTwbyStereotype[kv.Key].WriteLine(Entete);
                       }
                   }
                   else
                   {
                        //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile wit all the stereotypes for package=" + aPackage.Name);
                       tw.WriteLine(Entete);
                   }
 
                   foreach (long pid in packlist)
                   {
                      //18  EA.Package p = RDFLAutilitaires.dicpackbyid[pid];
                       EA.Package p = Main.Repo.GetPackageByID((int)pid);
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am janv 2016
                       if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                      
                       {

                           rdflautilitaires.serialize(p, dicTwbyStereotype);


                       }
                       else
                       {
                           rdflautilitaires.serialize(Main.Repo, p, tw);

                       }
                       if (!checkgo()) return;  // am janv 2016
                   }
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
                       foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                       {
                           dicTwbyStereotype[kv.Key].WriteLine(Finale);
                           dicTwbyStereotype[kv.Key].Flush();
                           dicTwbyStereotype[kv.Key].Close();
                       }
                       if (tw != null) tw.Close(); // am 061115 
                   }
                   else
                   {
                       tw.WriteLine(Finale);
                       tw.Flush();
                       tw.Close();
                   }

                  // 
                   //-----------------  am oct 2015
                   Dictionary<string, string> dicIntermediatebyStereotype = new Dictionary<string, string>(); // dictionary of stream writers according to export stereotypes
                   Dictionary<string, TextReader> dicRwbyStereotype = new Dictionary<string, TextReader>();

                   //-----------------  am fev 2012
                   string newnomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                   // TextReader rw = new StreamReader(Nomfic);
                   string intermediate = "";
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {

                       //foreach (string stereo in profparameters.ListStereoNamespaceExport)
                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           if (stereo == "")
                               
                           {
                             //  RDFLAutilitaires.wtest("TEST", "1-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                               dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                           }
                           else
                           {
                              // RDFLAutilitaires.wtest("TEST", "2-" + provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf");
                               dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                           }
                       }
                       // dicRwbyStereotype.Add("", rw);

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           dicIntermediatebyStereotype.Add(stereo, dicRwbyStereotype[stereo].ReadToEnd());
                       }
                       // dicIntermediatebyStereotype.Add("", dicRwbyStereotype[""].ReadToEnd());
                       foreach (KeyValuePair<string, TextReader> kv in dicRwbyStereotype)
                       {
                           dicRwbyStereotype[kv.Key].Close();

                       }
                       //   if (tw != null) tw.Close(); 
                   }
                   else
                   {
                     //  RDFLAutilitaires.wtest("TEST", "3-" + Nomfic);
                       TextReader rw = new StreamReader(Nomfic);
                       intermediate = rw.ReadToEnd();
                     //  RDFLAutilitaires.wtest("TEST", "4-" + Nomfic);
                       rw.Close();
                       if(System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);

                   }
                   Dictionary<string, string> entities = new Dictionary<string, string>();
                   // entities.Add("&ndash;", "&#x2013;");
                   for (int i = 0; i < CD.EntityToCodes.Length; i = i + 2)
                   {
                       entities.Add(CD.EntityToCodes[i], CD.EntityToCodes[i + 1]);
                   }

                   string newinter = "";
                   string newfic = "";
                   try
                   {


                       if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                       {
                           foreach (string stereo in aDialstereosExport.selectedStereotypes)
                           {
                               newinter = RDFutilitaires.filterNotes(dicIntermediatebyStereotype[stereo], entities);
                               newinter= RDFutilitaires.filterNotes(newinter, CD.types2019);
                                if (stereo == "")
                               {
                                   newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                                   Nomfic = newfic;// legacy
                               }
                               else
                               {
                                   newfic = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";
                               }

                               if (System.IO.File.Exists(newfic)) System.IO.File.Delete(newfic);
                               System.IO.File.AppendAllText(newfic, newinter);                                
                           }
  
                       }
                       else
                       {
                        //   RDFLAutilitaires.wtest("TEST", "4-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                           newinter = RDFutilitaires.filterNotes(intermediate, entities);
                           newinter = RDFutilitaires.filterNotes(newinter, CD.types2019);
                            newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                           Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                          if(System.IO.File.Exists(newfic))  System.IO.File.Delete(newfic);
                           System.IO.File.AppendAllText(newfic, newinter);
                          RDFLAutilitaires.wtest("TEST", "5-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                       }
                   }
                   catch (Exception e)
                   {
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);  // am janv 2016
                   MessageBox.Show("Problem in accessing some files " + e.Message); 
                   //RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation with error:" + DateTime.Now + "\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // reportlog.Flush();
                   //RDFLAutilitaires.reportlog.Close();
                   return;
                   }
                  
                   XMLP = new XMLParser(Repo);
                   if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")  // am june 2013
                   {
                      
                       nomfichier = System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + setNomFichier(aPackage, "rdf");
                    //   RDFLAutilitaires.wtest("TEST", "6-" + nomfichier);
                       if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                       System.IO.File.Copy(Nomfic, nomfichier);
                       if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                     //  RDFLAutilitaires.wtest("TEST", "7-" + nomfichier);

                   }
                   else
                   {
                       nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
                       System.IO.File.Delete(Nomfic);
                   }//am june 2013
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
     

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {

                           string nf;
                           if (stereo != "")
                           {
                               nf = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";

                               string newnomfich = nomfichier.Remove(nomfichier.Length - 4) + "-" + stereo + ".rdf";
                               try
                               {
                                   if (System.IO.File.Exists(newnomfich))
                                   {

                                       System.IO.File.Delete(newnomfich);


                                   }
                                   System.IO.File.Copy(nf, newnomfich);
                                   System.IO.File.Delete(nf);
                               }
                               catch (Exception e)
                               {
                                   if (XMLP.GetXmlValueConfig("Log") == "Checked") XMLP.AddXmlLog("ISSUE", " Pb in dealinf with files  "+ nf + "  ;   " + newnomfich + "   " + e.Message);
                                   MessageBox.Show(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                   //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                               }
                           }

                       }
                   }
                  // RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);  // am janv 2016
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                   // if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");

                   // reportlog.Flush();
  
               } // end loop on profiles package
            // Ensure that the target does not exist.
               //reportlog.Close();
                // MessageBox.Show(Path.GetDirectoryName(nomfichier) + "|" + Path.GetFileName(constantes.ReportGen));
                aDialstereosExport.Dispose(); // ABA20230729

            }
            catch (Exception e)
    {
        if(RDFutilitaires.Barre !=null) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");// am janv 2016
        //MessageBox.Show(" Exception dans le main " + e.Message + "," + e.InnerException.Message);
        ErrorCodes.ShowException(ErrorCodes.ERROR_062, e);
        //if (reportlog != null)
        //{
        //    // reportlog.Flush();
        //    //reportlog.Close();
        //}
    }
          RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");// am janv 2016
          //ta.stop();
         // ta.quit();
          MessageBox.Show("Finished!");
       
          //   theForm = new Form1();
           //  theForm.ShowDialog();
        }

//---------------------------------------------
      static void  prodHtmlDocumentation(EA.Repository repo,string type)
      {
          try { 
         // MessageBox.Show(" debut de prodHtmlDocumentation"); // pour test
          XMLParser xmlp = new XMLParser(Repo);
          Thread t = new Thread(LancBarProd);
          if (XMLP.GetXmlValueConfig("ModeTest") != "True")
          {
              t.Start();
          }
          switch(type)
          {
              case "ESMPHtmlDocumentation":
         //if(xmlp.GetXmlValueConfig("Esmp")=="Checked")
         // {
         HtmlEsmpDocumentation Esmphtmldoc = new HtmlEsmpDocumentation(repo,false);
              //HtmlDocumentation htmldoc = new HtmlDocumentation(repo);
         EA.Package pac = repo.GetTreeSelectedPackage();
         if (pac.Name == "ESMPClasses") // cas particulier du 351
         {
             EA.Package packdatatype=null;
             EA.Package pa351=null;
             pa351 = repo.GetPackageByID((int)pac.ParentID);
             foreach (EA.Package pa in pa351.Packages)
             {
                 if (pa.Name == "ESMPDataTypes")
                 {
                     packdatatype = pa;
                     break;
                 }
             }
             Esmphtmldoc.is351 = true;
             if (Esmphtmldoc.is351) // cas du 351
             {
                 Esmphtmldoc.TypeList.Add("primitive", new List<long>());

                 Esmphtmldoc.listprimitive = Esmphtmldoc.buildListPrimitive(packdatatype);
             }
         }else{
             Esmphtmldoc.is351 = false;
         }
         Esmphtmldoc.prodDoc(repo,pac);
         Esmphtmldoc.docfile.WriteLine("</body>");
         Esmphtmldoc.docfile.WriteLine("</html>");
         Esmphtmldoc.docfile.Flush();
         Esmphtmldoc.docfile.Close();
         // reportlog.Flush();
         //reportlog.Close();
         break;
              case "ESMPHtmlDocumentationAC" :
        // HtmlEsmpDocumentation Esmphtmldocac = new HtmlEsmpDocumentation(repo,false);
         HtmlEsmpSpecificDocumentation Esmphtmldocac = new HtmlEsmpSpecificDocumentation(repo, true);

         EA.Package packselect = repo.GetTreeSelectedPackage();
         
         foreach (EA.Package pack in packselect.Packages)
         {
             Esmphtmldocac.prodDoc(repo, pack);
         }
         Esmphtmldocac.docfile.WriteLine("</body>");
         Esmphtmldocac.docfile.WriteLine("</html>");
         Esmphtmldocac.docfile.Flush();
         Esmphtmldocac.docfile.Close();
        // Esmphtmldocac.// reportlog.Flush();
         // reportlog.Flush();
         //reportlog.Close();
              break;
              case "ESMPHtmlDocumentationACForIEC":
         HtmlEsmpDocumentation Esmphtmldocaciec = new HtmlEsmpDocumentation(repo,true);
         EA.Package packselectiec = repo.GetTreeSelectedPackage();
         
         foreach (EA.Package pack in packselectiec.Packages)
         {
             Esmphtmldocaciec.prodDoc(repo, pack);
         }
         Esmphtmldocaciec.docfile.WriteLine("</body>");
         Esmphtmldocaciec.docfile.WriteLine("</html>");
         Esmphtmldocaciec.docfile.Flush();
         Esmphtmldocaciec.docfile.Close();
        // Esmphtmldocaciec.// reportlog.Flush();
         // reportlog.Flush();
         //reportlog.Close();
              break;
                  
              case "ESMPHtmlDocumentationall":
             // HtmlEsmpDocumentation Esmphtmldocall = new HtmlEsmpDocumentation(repo,false);
              HtmlEsmpSpecificDocumentation Esmphtmldocall = new HtmlEsmpSpecificDocumentation(repo, true);// correspond  contextual and assembly
              EA.Package packselecte = repo.GetTreeSelectedPackage();
                  string prov = packselecte.Name;
              foreach (EA.Package pack in packselecte.Packages)
              {

                  prov = pack.Name;
                  foreach (EA.Package pa in pack.Packages)
                  {
                      prov = pa.Name;
                     // MessageBox.Show("pa=" + prov);
                      if (pa.Name != "Business Process")
                      {
                          Esmphtmldocall.prodDoc(repo, pa);
                      }
                  }
              }
              Esmphtmldocall.docfile.WriteLine("</body>");
              Esmphtmldocall.docfile.WriteLine("</html>");
              Esmphtmldocall.docfile.Flush();
              Esmphtmldocall.docfile.Close();
             // Esmphtmldocall.// reportlog.Flush();
              // reportlog.Flush();
              //reportlog.Close();
              break;

              case "ESMPHtmlDocumentationSpecific":
         // ce cas est specific  l'edition de document pour ENTSOE
         // il suppose une organisation en documet, contextual document, et assembly
      // on verifie initialemment que le repertoire d'appel  contient 2 packages
        // qui contiennent l'un le mot "assembly" et l'autre le mot contextual"
       // ou bien que nous sommes dans le cas particulier du 351  package   "ESMPClasses"
              
              EA.Package pacc = repo.GetTreeSelectedPackage();
              Boolean bon = true;
              if ((pacc.Packages.Count != 2)) // il y a bien deux documents
              {
                  MessageBox.Show(" Error: the selected directory " + "::"+ pacc.Name + " doest not contain exactly 2 documents (contextual and assembly)");
                  //Esmpspecifichtmldoc.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error: the selected directory " + "::" + pacc.Name + " doest not contain exactly 2 documents (contextual and assembly) or not 351-ESMPClasses");
                bon=false;
              }
              else
              {

                  foreach (EA.Package pa in pacc.Packages)// dans chaque package on doit trouver assembly ou contectual
                  {
                      if((!pa.Name.Contains("assembly")) &&  (!pa.Name.Contains("contextual"))
                          && (!pa.Name.Contains("Assembly")) && (!pa.Name.Contains("Contextual"))
                          )
                      {// il faut que les packages contiennent "assembly" ou "contextual"
                          MessageBox.Show(" Error: the selected directory " + "::" + pa.Name + " doest not contain A(a)ssembly or C(c)ontextual) ");
                         // Esmpspecifichtmldoc.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error: the selected directory " + "::" + pa.Name + " doest not contain Creation 351)");
                          bon=false;
                          break;
                      }
                  }
                  
              }
              if (!bon)
              {
                 // Esmpspecifichtmldoc.// reportlog.Flush();
                //  Esmpspecifichtmldoc.reportlog.Close();
              }else{
              HtmlEsmpSpecificDocumentation Esmpspecifichtmldoc = new HtmlEsmpSpecificDocumentation(repo, false);
             
                  foreach (EA.Package pa in pacc.Packages)
              {
                  Esmpspecifichtmldoc.prodDoc(repo, pa);
              }
              Esmpspecifichtmldoc.docfile.WriteLine("</body>");
              Esmpspecifichtmldoc.docfile.WriteLine("</html>");
              Esmpspecifichtmldoc.docfile.Flush();
              Esmpspecifichtmldoc.docfile.Close();
              //Esmpspecifichtmldoc.// reportlog.Flush();
              //Esmpspecifichtmldoc.reportlog.Close();
          }
          break;
                  case "HtmlENTSOEDocumentation":
          HtmlENTSOEDocumentation htmlENTSOEdoc = new HtmlENTSOEDocumentation(repo);
          htmlENTSOEdoc.prodDoc(repo);
         
          break;
                  case "HtmlHarmonisationDocumentation":
          HtmlHarmonisationDocumentation htmlharmonisationdoc = new HtmlHarmonisationDocumentation(repo);
          htmlharmonisationdoc.prodDoc(repo);

          break;
              default:
          HtmlDocumentation dhtmldoc = new HtmlDocumentation(repo);
          dhtmldoc.prodDoc(repo);
          break;
          
      }
          if (RDFutilitaires.Barre != null) RDFutilitaires.Barre.Close();

          MessageBox.Show("The end");
      }catch(Exception e){
          MessageBox.Show(" ERROR in doc production " + e.Message);
    }
      }

        static void GenAsciiDocDocumentation(EA.Repository repo, string type)
        {
            EA.Package aPackage = repo.GetTreeSelectedPackage();
            if (aPackage == null)
            {
                MessageBox.Show("Please select a package for AsciiDoc generation.");
                return;
            }
            DialogResponse dialogResponse = new DialogResponse(true);
            AsciiDocExportDialog asciiDocExportDialog = new AsciiDocExportDialog(Repo, aPackage, dialogResponse);
            asciiDocExportDialog.ShowDialog();
            asciiDocExportDialog.Dispose();
            if (dialogResponse.Canceled) return;

            try
            {
                msgBox.ShowBox("Processing ...");
                AsciiDocGenerator asciiDocExporter = new AsciiDocGenerator(Repo);
                switch (type)
                {
                    case "IEC61970AsciiDocDocumentation":
                        AsciiDocIEC61970Documentation iec61970AsciiDoc = new AsciiDocIEC61970Documentation(repo, aPackage);
                        string coverIntro61970 = AsciiDocIEC61970Documentation.GenerateCoverIntro_61970(repo, aPackage, dialogResponse.DirName);
                        string iec61870AsciiDocString = iec61970AsciiDoc.GenerateDocu(dialogResponse.DirName);
                        asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, coverIntro61970 + iec61870AsciiDocString);
                        break;
                    case "ESMPAsciiDocDocumentation":
                        AsciiDocESMPDocumentation esmpAsciiDoc = new AsciiDocESMPDocumentation(repo, false, aPackage);
                        string coverIntro = AsciiDocESMPSpecificDocumentation.GenerateCoverIntro(repo, aPackage, dialogResponse.DirName);
                        if (aPackage.Name == "ESMPClasses") // special case of the 351
                        {
                            EA.Package packdatatype = null;
                            EA.Package pa351 = null;
                            pa351 = repo.GetPackageByID((int)aPackage.ParentID);
                            foreach (EA.Package pa in pa351.Packages)
                            {
                                if (pa.Name == "ESMPDataTypes")
                                {
                                    packdatatype = pa;
                                    break;
                                }
                            }
                            esmpAsciiDoc.is351 = true;
                            esmpAsciiDoc.GetTypelist().Add("primitive", new List<long>());
                            esmpAsciiDoc.BuildListPrimitive(packdatatype);
                        }
                        else
                        {
                            esmpAsciiDoc.is351 = false;
                        }
                        string asciiDocString = esmpAsciiDoc.GenerateDocu(dialogResponse.DirName);
                        asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, coverIntro + asciiDocString);
                        break;
                    case "ESMPAsciiDocDocumentationAC":
                        string asciiDocACString = "";
                        string coverIntroSpecific = AsciiDocESMPSpecificDocumentation.GenerateCoverIntro(repo, aPackage, dialogResponse.DirName);
                        foreach (EA.Package pack in aPackage.Packages)
                        {
                            AsciiDocESMPSpecificDocumentation esmpAsciiDocAC = new AsciiDocESMPSpecificDocumentation(repo, true, pack);
                            asciiDocACString += esmpAsciiDocAC.GenerateDocu(dialogResponse.DirName);
                            //esmpAsciiDocAC.CloseProgressWindow();
                        }
                        asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, coverIntroSpecific + asciiDocACString);
                        break;
                    case "ESMPAsciiDocDocumentationall":
                        string asciiDocAllString = "";
                        EA.Package packSelected = repo.GetTreeSelectedPackage();
                        string coverIntroForAll = AsciiDocESMPSpecificDocumentation.GenerateCoverIntro(repo, packSelected, dialogResponse.DirName);
                        if(packSelected.Packages.Count <= 0)
                        {
                            MessageBox.Show("No subpackes. Finished!");
                            return;
                        }
                        foreach (EA.Package pack in packSelected.Packages)
                        {
                            foreach (EA.Package pa in pack.Packages)
                            {
                                if (pa.Name != "Business Process")
                                {
                                    AsciiDocESMPSpecificDocumentation esmpAsciiDocAll = new AsciiDocESMPSpecificDocumentation(repo, true, pa);
                                    asciiDocAllString += esmpAsciiDocAll.GenerateDocu(dialogResponse.DirName);
                                } 
                            }
                        }
                        asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, coverIntroForAll + asciiDocAllString);
                        break;

                    case "ESMPDocuAsciiDocmentationSpecific":
                        // this case is specific to document editing for ENTSOE
                        // it assumes an organisation into document, contextual document, and assembly
                        // we initially check that the call directory contains 2 packages
                        // one of which contains the word "assembly" and the other the word "contextual".
                        // or that we are in the particular case of the 351 "ESMPClasses" package
                        EA.Package pacc = repo.GetTreeSelectedPackage();
                        Boolean bon = true;
                        if ((pacc.Packages.Count != 2)) // there are two documents
                        {
                            MessageBox.Show(" Error: the selected directory " + "::" + pacc.Name + " doest not contain exactly 2 documents (contextual and assembly)");
                            bon = false;
                        }
                        else
                        {
                            foreach (EA.Package pa in pacc.Packages)// dans chaque package on doit trouver assembly ou contectual
                            {
                                if ((!pa.Name.Contains("assembly")) && (!pa.Name.Contains("contextual"))
                                    && (!pa.Name.Contains("Assembly")) && (!pa.Name.Contains("Contextual"))
                                    )
                                {// Packages must contain "assembly" or "contextual".
                                    MessageBox.Show(" Error: the selected directory " + "::" + pa.Name + " doest not contain A(a)ssembly or C(c)ontextual) ");
                                    bon = false;
                                    break;
                                }
                            }

                        }
                        if (bon)
                        {
                            string coverIntroString = AsciiDocESMPSpecificDocumentation.GenerateCoverIntro(repo, pacc, dialogResponse.DirName);
                            string asciiDocSpec = "";
                            foreach (EA.Package pa in pacc.Packages)
                            {
                                AsciiDocESMPSpecificDocumentation esmpAsciiDocSpec = new AsciiDocESMPSpecificDocumentation(repo, false, pa);
                                asciiDocSpec += esmpAsciiDocSpec.GenerateDocu(dialogResponse.DirName);
                            }
                            asciiDocExporter.SaveAsciiDoc(dialogResponse.FileName, dialogResponse.DirName, coverIntroString + asciiDocSpec);
                        }
                        break;
                    default:
                        break;

                }
            }
            catch (Exception e)
            {
                ErrorCodes.ShowException(ErrorCodes.ERROR_052, e);
            } finally
            {
                msgBox.CloseBox();
            }
        }


        /// <summary>
        /// donne le nom complet du ficher(rdf ou xcd) qui sera cr localement
        /// incremente un indice si le fichier existe dj
        /// </summary>
        /// <param name="pack"></param>
        /// <param name="type"> rdf or xsd </param> 
        /// <returns>nom du fichier</returns>
        string setNomFichier(EA.Package pack,string type)
      {
          string nomfichier = pack.Name + "." + type;
            if(System.IO.File.Exists(nomfichier))
            {
            int index=1;
              while(System.IO.File.Exists(nomfichier+"(" + index.ToString() + ")"))
              {
                  index++;
            }
              nomfichier = nomfichier + "(" + index.ToString() + ")";
            }
            return nomfichier;
      }
        /*
        static void LancBar(Object obj)
        {
            try
            {
               // RDFutilitaires.Barre = new DialGenerXSD(" be patient ....");
                
                RDFutilitaires.Barre = (DialGenerXSD)obj;
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        */
        static void LancBar()
        {
            try
            {
                 RDFutilitaires.Barre = new DialGenerXSD(" patience ....");

                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                //RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        static void LancBarProd()
        {
            try
            {
                RDFutilitaires.Barre = new DialGenerXSD(" patience ....",false);

                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                //RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        
        static void WriteY(Object obj)
        {
            EA.Package toppack = (EA.Package)obj;
            try
            {
                //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" lancement build sur le package " + toppack.Name);
                RDFLAutilitaires.buildDicsElem(toppack);
                //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" fin  build sur le package " + toppack.Name);
                /*
                int j = 0;
                for (int i = 0; i < 10000; i++)
                {

                    if (RDFLAutilitaires.reportlog != null)
                    {
                       // RDFLAutilitaires.reportlog.Write("y");
                       // RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress", 1);
                       

                    }
                    Thread.Sleep(100);
                
                }
                 *  */
            }
            catch(Exception e)
            {
                //RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
            }
        }
        void LoadProfparametersfromConfig(XMLProfileParameters profparameters) // am june 2013
        {
            XMLParser XMLP = new XMLParser(Repo);
            try{

    if (XMLP.GetXmlValueConfig("DefaultXSDFilePath") != null) profparameters.DefaultXSDFilePath = XMLP.GetXmlValueConfig("DefaultXSDFilePath");
    if (XMLP.GetXmlValueConfig("CurrentXSDFilePath") != null) profparameters.CurrentXSDFilePath = XMLP.GetXmlValueConfig("CurrentXSDFilePath");
    if (XMLP.GetXmlValueConfig("DefaultProfileNamespace") != null) profparameters.DefaultProfileNamespace = XMLP.GetXmlValueConfig("DefaultProfileNamespace");
    if (XMLP.GetXmlValueConfig("DefaultTargetNamespace") != null) profparameters.DefaultTargetNamespace = XMLP.GetXmlValueConfig("DefaultTargetNamespace");
    if (XMLP.GetXmlValueConfig("ProfileNamespace") != null) profparameters.ProfileNamespace = XMLP.GetXmlValueConfig("ProfileNamespace");
    if (XMLP.GetXmlValueConfig("TargetNamespace") != null) profparameters.TargetNamespace = XMLP.GetXmlValueConfig("TargetNamespace");
    if (XMLP.GetXmlValueConfig("DefaultRootModelURI") != null) profparameters.DefaultRootModelURI = XMLP.GetXmlValueConfig("DefaultRootModelURI");
    if (XMLP.GetXmlValueConfig("RootModelURI") != null) profparameters.RootModelURI = XMLP.GetXmlValueConfig("RootModelURI");
    if (XMLP.GetXmlValueConfig("Prefix") != null) profparameters.Prefix = XMLP.GetXmlValueConfig("Prefix");
    if (XMLP.GetXmlValueConfig("RootModelPrefixPrefix") != null) profparameters.Prefix = XMLP.GetXmlValueConfig("RootModelPrefix");
    if (XMLP.GetXmlValueConfig("EnvelopName") != null) profparameters.EnvelopName = XMLP.GetXmlValueConfig("EnvelopName");
    //if (XMLP.GetXmlValueConfig("URICodelist") != null) profparameters.URICodelist = XMLP.GetXmlValueConfig("URICodelist");
   // if (XMLP.GetXmlValueConfig("URISchemaLocation") != null) profparameters.URISchemaLocation = XMLP.GetXmlValueConfig("URISchemaLocation");
    //if (XMLP.GetXmlValueConfig("PrefixCodelist") != null) profparameters.PrefixCodelist = XMLP.GetXmlValueConfig("PrefixCodelist");
    if (XMLP.GetXmlValueConfig("Version") != null) profparameters.Version = XMLP.GetXmlValueConfig("Version");
    if (XMLP.GetXmlValueConfig("ListStereoNamespace") != null)
    {
        string liste = XMLP.GetXmlValueConfig("ListStereoNamespace");
        string[] listns = liste.Split('|');
        foreach (string ns in listns)
        {
            if (!profparameters.ListStereoNamespace.Contains(ns))
            {
                profparameters.ListStereoNamespace.Add(ns);
            }
        }
    }
            }catch(Exception e)
            {
                // MessageBox(" Problem in reading configuration file " + e.Message);
                //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" Problem in reading configuration file " + e.Message);
            }
        }
        //--------------------
        //--------------- differentes receptions d'vnement -------------------------------------------
        public void EA_OnContextItemChanged(EA.Repository repo, String sguid, EA.ObjectType ot)
        {
            // MessageBox.Show(" Reception evt chgt contexte guid=" + sguid + "ot=" + ot.ToString());
            if (XMLP != null)
            {
                //XMLP.AddXmlLog("EVTCONTEXT", " Reception evt chgt contexte guid=" + sguid + "ot=" + ot.ToString());
            }
        }
 //-----------------------------------------------------

        public bool  checkgo()
        {
            bool res = true;
            if ((RDFutilitaires.Barre != null) && (!RDFutilitaires.Barre.go))
            {
                //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" the treatment has been canceled");
                RDFutilitaires.Barre.Close();
                //RDFLAutilitaires.// reportlog.Flush();
                //RDFLAutilitaires.reportlog.Close();
                RDFLAutilitaires.ongoing = false;
                res = false;
                MessageBox.Show(" interrupted");
            }
            return res;
        }

        
            public void run_cmd(string pathToPython, string args)
            {
                try
                {
                //MessageBox.Show(string.Format("please check these files which are the only file to be accessed at this stage {0}\n\t {1}\n\t", pathToPython,args));
                    ProcessStartInfo start = new ProcessStartInfo();
                    start.FileName = pathToPython;
                    start.Arguments = string.Format("{0}", args);
                    start.UseShellExecute = false;// Do not use OS shell
                    start.CreateNoWindow = false; // We don't need new win
                    start.RedirectStandardOutput = false;// Any t, generated by application will be redirected back
                    start.RedirectStandardError = false; // Any error in standard output will be redirected back (for example exceptions)
                    Process process = Process.Start(start);
                }
                catch(Exception ee)
                {
                    throw new Exception("run_cmd " + ee.Message);
                }
            }
        
        /// <summary>
        /// transfert le reportlog vers le repertoire cible
        /// on suppose le fichier reportlog ferme
        /// </summary>
        /// <param name="nomficher"></param>
        /// <param name="provdir"></param>
        /// <param name="constantes"></param>
        public void publishReportlog(string nomficher,string provdir,ConstDefinition  constantes)
        {
            try
            {

                string nomcible = Path.GetDirectoryName(nomficher) + "\\" + Path.GetFileName(constantes.ReportGen);

                //  if (constantes.ReportGen != nomcible)
                string reportgen = provdir + "\\" + Path.GetFileName(constantes.ReportGen);
                if (reportgen != nomcible)
                {
                    if (System.IO.File.Exists(nomcible)) System.IO.File.Delete(nomcible);
                    System.IO.File.Copy(reportgen, nomcible);
                    System.IO.File.Delete(reportgen);
                }

            }
            catch (Exception e)
            {
                string nomcible = Path.GetDirectoryName(nomficher) + "\\" + Path.GetFileName(constantes.ReportGen);
                MessageBox.Show("Report file copy error  " + e.Message + "\n from:" + constantes.ReportGen + "\n to: " + nomcible);
                //RDFLAutilitaires.// reportlog.Flush();
                //RDFLAutilitaires.reportlog.Close();
            }                
        }

        /// <summary>
        /// some old versions of sparx lock the access db and necessitates a copy of the base
        /// </summary>
        string  transferForjson()
        {

            string res = "";
            try
            {
                string db= Repo.ConnectionString;
                if (XMLP.GetXmlValueConfig("TransferForJsonEnabled") != "Checked")
                {
                    res = db;
                }
                else
                {
                  
                    EA.Project proj = Repo.GetProjectInterface(); 
                    int ind = db.IndexOf(".eap");
                    string newdb = db.Substring(0,ind) + "_json.eap";
                    if (System.IO.File.Exists(newdb)) System.IO.File.Delete(newdb);
                    Repo.CloseFile();
                    System.IO.File.Copy(db, newdb);
                    // proj.ProjectTransfer(db, db.Substring(0,ind) + "_json.eap", "log.log");
                    Repo.OpenFile(db);
                    string packidstring = XMLP.GetXmlValueProfData("SelectedProfileForJson");
                    EA.Package pack = Repo.GetPackageByID(int.Parse(packidstring));
                    Repo.ShowInProjectView(pack);
                   // Repo.RefreshModelView(int.Parse(packidstring));
                    res = newdb;
                }
                return res;
            }
            catch(Exception ee)
            {
                throw new Exception(String.Format("transferForjson err={0} ", ee.Message));
            }
        }
        //-----------------------------------------------------------------------------------
        public string newnomfichier { get; set; }

//----------------------------------------------------------------------------------------------------




 //------------------------------------------------------------------------------------------------------
    }
}
		
		
	

