﻿using CimSyntaxGen.Configuration;
using CimSyntaxGen.Utilities;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CimSyntaxGen.Option
{
    public partial class DialCodelistExport : Form
    {
        private XMLParser xmlp;
        private DialogResponse dialogResponse;
        public static string LAST_CODELISTS_DIRECTORY = "LastCodeListsDirectory";
        public DialCodelistExport(EA.Repository repo, DialogResponse dialogResponse)
        {
            InitializeComponent();
            this.dialogResponse = dialogResponse;
            xmlp = new XMLParser(repo);
            this.buttonExp.Enabled = false;
            this.textBoxPrefix.Text = xmlp.GetXmlValueProfData("PrefixCodelist");
            this.textBoxDir.Text = xmlp.GetXmlValueProfData(LAST_CODELISTS_DIRECTORY);
            if((this.textBoxDir.Text != null && this.textBoxDir.Text.Length > 0) &&
               (this.textBoxPrefix.Text != null && this.textBoxPrefix.Text.Length > 0)) 
            {
                this.buttonExp.Enabled = true;
            }
        }

        private void buttonDir_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folderBrowserDialog = new FolderBrowserDialog();
            folderBrowserDialog.SelectedPath = this.textBoxDir.Text;
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
            {
                this.textBoxDir.Text = folderBrowserDialog.SelectedPath;
            }
            folderBrowserDialog.Dispose();
            if(EnableExportButton()) this.buttonExp.Enabled = true;
            else this.buttonExp.Enabled = false;
        }

        private bool EnableExportButton()
        {
            return ((this.textBoxDir.Text != null && this.textBoxDir.Text.Trim().Length > 0) &&
                    (this.textBoxPrefix.Text != null && this.textBoxPrefix.Text.Trim().Length > 0));
        }

        private void textBoxPrefix_TextChanged(object sender, EventArgs e)
        {
            if (EnableExportButton()) this.buttonExp.Enabled = true;
            else this.buttonExp.Enabled = false;
        }


        private void buttonExp_Click(object sender, EventArgs e)
        {
            xmlp.SetXmlValueProfData("PrefixCodelist", this.textBoxPrefix.Text);
            xmlp.SetXmlValueProfData(LAST_CODELISTS_DIRECTORY, this.textBoxDir.Text);

            dialogResponse.Canceled = false;
            dialogResponse.DirName = this.textBoxDir.Text;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            dialogResponse.Canceled = true;
            this.Dispose();
        }
    }
}
