 using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                          november 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class Dialrdf : Form
    {
        EA.Package profpack = null;
        private XMLProfileParameters profparams;
        XMLParser XMLP = null;
        Dictionary<string, int> indexdic = new Dictionary<string, int>(); //stereo/index
        Dictionary<string, CheckState> initialstate = new Dictionary<string, CheckState>(); // stereo/checkstate
        string versionIRI = "";
        string versioninfo = "";
        string issued = "";
        string license = "";
        string modified = "";
        public Dialrdf(XMLProfileParameters profparameters)
        {
            InitializeComponent();
            if(Main.typerdfexport != "501Ed2")
            {
                this.CBFlat.Hide();
            }
//-------------------------------the dialog code 
            this.profparams = profparameters;
            this.XMLP = new XMLParser(Main.Repo);
            this.textBox2.Text = profparameters.RootModelURI;
            this.textBox3.Text = profparameters.DefaultRootModelPrefix;
         
//---------------------------------------------

        }
        public Dialrdf(XMLProfileParameters profparameters,EA.Package profp,string type)
        {
            XMLP = new XMLParser(Main.Repo);
            InitializeComponent();
            this.profparams = profparameters;
            if (Main.typerdfexport == "501Ed2")
            {
                this.CBFlat.Show();
                this.CBSpecial.Checked = true;
                this.CBSpecial.Hide();
            }
            else
            {
                this.CBFlat.Hide();
                this.CBSpecial.Show();
                if (Main.typerdfexport == "2019")
                {
                    this.groupBox1.Text = this.groupBox1.Text + " (Check validity and, if needed, edit the URI and Prefix manually) ";
                }
            }
            this.profpack = profp;
            string prefix = "";
            if (profpack == null) throw new Exception(" profile parameter not positionned");
            if (Main.typerdfexport != "2019")
            {
                string ontology = profpack.Name.Replace("Profile", "") + "-" + type + "_Ontology";
                EA.Element ontologyclass = null;
                foreach (EA.Element el in profpack.Elements)
                {
                    if (el.Name != ontology) continue;
                    ontologyclass = el;
                }
                if (ontologyclass == null) throw new Exception(" dialrdf ontology class not found");
                foreach (EA.Attribute at in ontologyclass.Attributes)
                {
                    string nom = at.Name;
                    switch (nom)
                    {
                        case "versionIRI":
                            versionIRI = at.Default;
                            break;
                        case "versionInfo":
                            versioninfo = at.Default;
                            break;
                        case "issued":
                            at.Default = DateTime.UtcNow.ToString("yyyy-MM-ddTHH:mm:ssZ");
                            issued = at.Default;
                            break;
                        case "license":
                            license = at.Default;
                            break;
                        case "modified":
                            modified = at.Default.ToString();
                            break;
                        case "keyword":
                            prefix = at.Default.ToLower();
                            break;
                        default:
                            break;

                    }
                }
            }
            
            this.comboBox1.Text = XMLP.GetXmlValueProfData("CCTypeOfDocument");
            this.comboBox2.Text = XMLP.GetXmlValueProfData("CCStandardNumber");
            this.comboBox3.Text = XMLP.GetXmlValueProfData("CCCodeComponentName");
            this.comboBox5.Text = XMLP.GetXmlValueProfData("CCDiffusionState");
            
            //this.textBox1.Text = XMLP.GetXmlValueProfData("CCProfileName");
            this.textBox1.Text = profp.Name;
            //this.textBox2.Text = XMLP.GetXmlValueProfData("CCVersionStateInfo");
            this.textBox4.Text = versioninfo;
            //this.textBox3.Text = XMLP.GetXmlValueProfData("CCPublicationDate");
            if (modified != "")
            {
                this.textBox5.Text = modified;
            }
            else
            {
                this.textBox5.Text = issued;
            }
            
            
            //-------------------------------the dialog code 
            

            if (profpack == null)
            {
                this.textBox2.Text = profparameters.RootModelURI;
                this.textBox3.Text = profparameters.Prefix;
                //this.textBox3.Hide();
                this.GBDesc.Hide();
            }
            else
            {
                this.GBDesc.Show();

                
                    if ((Main.typerdfexport == "2020") || (Main.typerdfexport == "501Ed2"))
                {
                    
                    int ind = versionIRI.LastIndexOf('/');
                    // this.textBox2.Text = versionIRI;
                    this.textBox2.Text= versionIRI.Substring(0, ind) + "#";
                    //  this.textBox3.Text = ""; 
                    this.textBox3.Text = prefix;
                }
                if(Main.typerdfexport=="2019")
                {
                    // this.textBox2.Text = profparameters.RootModelURI;
                    this.textBox2.Text = profparameters.ProfileNamespace;
                    this.textBox3.Text = profparameters.Prefix;
                }

                // init indic for keeping full text
                if (XMLP.GetXmlValueProfData("CCLightFull") == ("full"))
                { 
                    CBFull.CheckState =CheckState.Checked;
                    this.CBLKeep.Hide();
                    this.comboBox4.Items.Clear();
                    this.comboBox4.Items.Add("full");
                    this.comboBox4.Text="full";
                }
                else
                {
                    CBFull.CheckState = CheckState.Unchecked;
                    this.comboBox4.Items.Clear();
                    this.comboBox4.Items.Add("light");
                    this.comboBox4.Text = "light";
                    this.CBLKeep.Show();
                    string stereoslist = XMLP.GetXmlValueProfData("ListStereoNamespace");
                    string[] stereos = stereoslist.Split(new char[] { '|' });
                    CBLKeep.Items.AddRange(stereos);
                    for (int i = 0; i < stereos.Length; i++)
                    {
                        indexdic[CBLKeep.Items[i].ToString()] = i;
                    }
                    for(int i=0;i < stereos.Length;i++)
                    {
                        string stereo = CBLKeep.Items[i].ToString();
                        ArrayList arl = XMLP.GetXmlProfstereo(stereo);
                        string state = (string)arl[4];
                        
                        if(state=="Checked")
                        {
                            CBLKeep.SetItemCheckState(i, CheckState.Checked);
                            initialstate[stereo] = CheckState.Checked;
                        }
                        else
                        {
                            CBLKeep.SetItemCheckState(i, CheckState.Unchecked);
                            initialstate[stereo] = CheckState.Unchecked;
                        }
                    }
                }
                
            }

            

            //---------------------------------------------

        }

        

        private void Dialrdf_Load(object sender, EventArgs e)
        {
         
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
        
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            MessageBox.Show("le nom du fichier est valide");
        }

        private void button2_Click(object sender, EventArgs e)
        {

            //XMLParser xmlp = new XMLParser();
            Button but = (Button)sender;
            string prov = but.Name;
            
            // this.profparams.CurrentXSDFilePath= this.label9.Text + "\\" + this.textBox1.Text ;
            if (!this.textBox2.Text.Contains("#")) this.textBox2.Text = this.textBox2.Text + "#";
            //this.profparams.RootModelURI = this.textBox2.Text;
            this.profparams.ProfileNamespace = this.textBox2.Text;
            this.profparams.Prefix = this.textBox3.Text;
            CIMSchemaGenerator.profparameters = this.profparams;
            XMLP.SetXmlValueConfig("VersionConfig", DateTime.Today.ToString("yyyy-MM-dd"));
            XMLP.SetXmlValueProfData("ProfileNamespace", this.textBox2.Text);
                
            XMLP.SetXmlValueProfData("Prefix", this.textBox3.Text);
            this.profparams.Prefix = this.textBox3.Text;
            XMLP.SetXmlValueProfData("CCTypeOfDocument", this.comboBox1.Text);
            XMLP.SetXmlValueProfData("CCStandardNumber", this.comboBox2.Text);
            XMLP.SetXmlValueProfData("CCCodeComponentName", this.comboBox3.Text);
            XMLP.SetXmlValueProfData("CCDiffusionState", this.comboBox5.Text);
            XMLP.SetXmlValueProfData("CCLightFull", this.comboBox4.Text);
            XMLP.SetXmlValueProfData("CCProfileName", this.textBox1.Text);
            XMLP.SetXmlValueProfData("CCVersionStateInfo", this.textBox4.Text);
            XMLP.SetXmlValueProfData("CCPublicationDate", this.textBox5.Text);
            

            if (this.CBSpecial.Checked)
            {
                profparams.forXml = true;
            }
            else
            {
                profparams.forXml = false;
            }
            
            if (!CBFull.Checked)
            {
                XMLP.SetXmlValueProfData("CCLightFull", "light");
                foreach(string stereo in indexdic.Keys)
                {
                    CheckState state = CBLKeep.GetItemCheckState(indexdic[stereo]);
                    if(state != initialstate[stereo])
                    {
                        if(state==CheckState.Checked)
                        {
                            XMLP.AddXmlProfstereo(stereo, null, null, null, null, "Checked");
                        }
                        else
                        {
                            XMLP.AddXmlProfstereo(stereo, null, null, null, null, "Unchecked");
                        }
                        
                    }
                }
            }
            else
            {
                XMLP.SetXmlValueProfData("CCLightFull", "full");
            }
            if(CBFlat.Checked)
            {
                profparams.FlatDatatypes = true;
            }
            else
            {
                profparams.FlatDatatypes = false;
            }
            profparams.majIndicateurs();
            profparams.copyrightnotice = RDFLAutilitaires.generCopyright(true);
            this.Close();
        }



        private void label7_Click(object sender, EventArgs e)
        {
           // MessageBox.Show("directory="  +  this.label9.Text);
        }

        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.TargetNamespace =  this.textBox2.Text;

                MessageBox.Show("selected name="
                    + this.profparams.TargetNamespace);
                RDFutilitaires.ongoing = true;
            }
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.Prefix = this.textBox3.Text;

                MessageBox.Show("selected name="
                    + this.profparams.Prefix);
            }
        }
         
 

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            RDFutilitaires.ongoing = false;
            this.Close();
        }

        private void CBFull_CheckStateChanged(object sender, EventArgs e)
        {
            if(CBFull.Checked)
            {

                this.CBLKeep.Hide();
                this.comboBox4.Items.Clear();
                this.comboBox4.Items.Add("full");
                this.comboBox4.Text = "full";
            }
            else
            {
                this.comboBox4.Items.Clear();
                this.comboBox4.Items.Add("light");
                this.comboBox4.Text = "light";
                this.CBLKeep.Show();
                string stereoslist = XMLP.GetXmlValueProfData("ListStereoNamespace");
                string[] stereos = stereoslist.Split(new char[] { '|' });
                if (CBLKeep.Items.Count == 0)
                { 
                    CBLKeep.Items.AddRange(stereos);
                }
                for (int i = 0; i < stereos.Length; i++)
                {
                    indexdic[CBLKeep.Items[i].ToString()] = i;
                }
                for (int i = 0; i < stereos.Length; i++)
                {
                    string stereo = CBLKeep.Items[i].ToString();
                    ArrayList arl = XMLP.GetXmlProfstereo(stereo);
                    string state = (string)arl[4];

                    if (state == "Checked")
                    {
                        CBLKeep.SetItemCheckState(i, CheckState.Checked);
                        initialstate[stereo] = CheckState.Checked;
                    }
                    else
                    {
                        CBLKeep.SetItemCheckState(i, CheckState.Unchecked);
                        initialstate[stereo] = CheckState.Unchecked;
                    }
                }
            }
        
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}
