using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using CimSyntaxGen;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                     *    november 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class Dialxsd : Form
    {
	
        public Dialxsd(XMLProfileParameters profparameters,string wg)
        {
            this.WG = wg;
            XMLParser xmlp=new XMLParser(Main.Repo);
            InitializeComponent();
            string prov = this.label9.Text;
            if(Main.XMLP.GetXmlValueConfig("CodeComponent")=="Checked")
            {
                this.label13.Visible = true;
                this.textBox10.Visible = true;
            }
            else
            {
                this.label13.Visible = false;
                this.textBox10.Visible = false;
            }
            if (wg == "wg14")
            {
                this.textBox4.Visible = false;
                this.textBox6.Visible = false;

               
            }
            if (wg == "wg16")
            {
                this.textBox4.Visible = false;
                this.textBox6.Visible = false;
                this.textBox4.Visible = false;
                this.label4.Visible = false;
                this.label8.Visible = false;

                this.textBox7.Text = xmlp.GetXmlValueProfData("URICodelist");
                this.textBox7.Visible = true;
                this.textBox7.Enabled = true;

                this.textBox8.Text = xmlp.GetXmlValueProfData("PrefixCodelist");
                
                this.textBox9.Text = xmlp.GetXmlValueProfData("URISchemaLocation");
                this.textBox9.Visible = true;
                this.textBox9.Enabled = true;
                
                this.label5.Visible = true;
                this.label6.Visible = true;
                this.checkBox1.Visible = true;
                this.checkBox1.Enabled = true;
                this.checkImport.Visible = true;
                this.checkImport.Enabled = true;

               

                   if (checkImport.CheckState == CheckState.Checked)
                   {
                    profparameters.import = true;
                    this.textBox7.Visible = true;
                    this.textBox7.Enabled = true;
                    this.textBox8.Visible = true;
                    this.textBox8.Enabled = true;
                    this.label11.Text = "SchemaLocation";
                }
                else
                {
                    profparameters.import = false;
                    this.textBox7.Visible = false;
                    this.textBox7.Enabled = false;
                    this.textBox8.Visible = false;
                    this.textBox8.Enabled =  false;
                    this.label11.Text = "CodeListLocation";
                }
               
            }
            if ((wg == "wg19") || (wg=="wg19byref"))
            {
                this.textBox7.Visible = false;
                this.textBox7.Enabled = false;
                this.textBox7.Text = xmlp.GetXmlValueProfData("URICodelist");
                this.textBox8.Visible = false;
                this.textBox8.Enabled = false;
                this.textBox8.Text = xmlp.GetXmlValueProfData("PrefixCodelist");
               
                this.label5.Visible = false;
                this.label6.Visible = false;
                this.label11.Visible = false;
                this.textBox9.Visible = false;

            }
             if(wg=="wg19byref")
            {
                 EA.Package aPackage = Main.Repo.GetTreeSelectedPackage(); // the selected package
                 profparameters.EnvelopName = aPackage.Name;
            }
//-------------------------------the dialog code 
            this.profparams = profparameters;
            /* ABA20240201
            if(profparameters.DefaultXSDFilePath.StartsWith(".\\"))
            {
                this.textBox1.Text = FileManager.GetUserDirPath() + profparameters.DefaultXSDFilePath.Replace(".\\\\", "\\");
            } else
            {
                this.textBox1.Text = profparameters.DefaultXSDFilePath;
            }*/
            // ABA20240201
            this.textBox1.Text = "";
            this.textBox2.Text = profparameters.TargetNamespace;
            this.textBox3.Text = profparameters.Prefix;
            this.textBox5.Text = profparameters.RootModelURI;
            this.textBox6.Text = profparameters.EnvelopName;
            this.textBox4.Text = profparameters.Version;
//---------------------------------------------
            this.button2.Enabled = false;
           
        }

        private XMLProfileParameters profparams;
        private string WG;

        private void Dialxsd_Load(object sender, EventArgs e)
        {
         
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
        
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            MessageBox.Show("le nom du fichier est valide");
        }

        private void button1_Click(object sender, EventArgs e)
        {
          
            saveFileDialog1.Filter = "xsd files (*.xsd)|*.xsd|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
               // MessageBox.Show(saveFileDialog1.FileName);
                this.profparams.CurrentXSDFilePath = saveFileDialog1.FileName;
                this.label9.Text = Path.GetDirectoryName(this.profparams.CurrentXSDFilePath);
                this.textBox1.Text = Path.GetFileName(this.profparams.CurrentXSDFilePath);
                //MessageBox.Show("fichier selectionne=" + Path.GetFileName(this.profparams.CurrentXSDFilePath));  
            }





        }

        private void button2_Click(object sender, EventArgs e)
        {
            XMLParser xmlp = new XMLParser(Main.Repo);
            
            if (this.textBox1.Text.Contains(":")) // le chemin complet est donne dans textbox1 (en generall C:)
            {
                this.profparams.CurrentXSDFilePath = this.textBox1.Text;
            }
            else
            {
                this.profparams.CurrentXSDFilePath = this.label9.Text + "\\" + this.textBox1.Text;
            }
           this.profparams.TargetNamespace = this.textBox2.Text;
           this.profparams.Prefix = this.textBox3.Text;
           this.profparams.RootModelURI = this.textBox5.Text;
           if (this.WG == "wg19")
           {
               this.profparams.EnvelopName = this.textBox6.Text;
               this.profparams.Version = this.textBox4.Text;
               xmlp.SetXmlValueProfData("EnvelopName", this.profparams.EnvelopName);
               xmlp.SetXmlValueProfData("Version", this.profparams.Version);
           }

           if (this.WG == "wg19byref")
           {
               this.profparams.EnvelopName = this.textBox6.Text;
               this.profparams.Version = this.textBox4.Text;
               if(xmlp.GetXmlValueConfig("XSDByRef")=="Checked")
               {
                   this.profparams.XSDByRef = "Checked";
               }else{
                   this.profparams.XSDByRef = "Unchecked";
               }
               xmlp.SetXmlValueProfData("EnvelopName", this.profparams.EnvelopName);
               xmlp.SetXmlValueProfData("Version", this.profparams.Version);
           }


           if (this.WG == "wg16")
           {
               if (checkBox1.CheckState == CheckState.Checked)
               {
                   this.profparams.WithAnnotations = true;
               }
               else
               {
                   this.profparams.WithAnnotations = false;
               }
            
               if (checkImport.CheckState == CheckState.Checked)
               {
                   this.profparams.import = true;
                   this.textBox7.Visible = true;
                   this.textBox7.Enabled = true;
               }
               else
               {
                   this.profparams.import = false;
                   this.textBox7.Visible = false;
                   this.textBox7.Enabled = false;
               }
           }
          
             

           //-------  sauve tout ---------------------
          
           xmlp.SetXmlValueProfData("DefaultXSDFilePath", this.profparams.DefaultXSDFilePath);
           xmlp.SetXmlValueProfData("CurrentXSDFilePath", this.profparams.CurrentXSDFilePath);

          // xmlp.SetXmlValueProfData("DefaultProfileNamespace", this.profparams.DefaultProfileNamespace);
          // xmlp.SetXmlValueProfData("DefaultTargetNamespace", this.profparams.DefaultTargetNamespace);
           xmlp.SetXmlValueProfData("ProfileNamespace", this.profparams.ProfileNamespace);
           xmlp.SetXmlValueProfData("TargetNamespace", this.profparams.TargetNamespace);
           //xmlp.SetXmlValueProfData("DefaultRootModelURI", this.profparams.DefaultRootModelURI);

           xmlp.SetXmlValueProfData("RootModelURI", this.profparams.RootModelURI);
           xmlp.SetXmlValueProfData("Prefix", this.profparams.Prefix);

           xmlp.SetXmlValueProfData("URICodelist",this.textBox7.Text);
           xmlp.SetXmlValueProfData("URISchemaLocation", this.textBox9.Text);
           xmlp.SetXmlValueProfData("PrefixCodelist",this.textBox8.Text);
           if(xmlp.GetXmlValueConfig("CodeComponent")=="Checked")
            {
                xmlp.SetXmlValueProfData("CCPublicationDate", this.textBox10.Text);
            }
            xmlp.SetXmlValueConfig("VersionConfig", DateTime.Today.ToString("yyyy-MM-dd"));

            //-----------------------------------------
            CIMSchemaGenerator.profparameters = this.profparams;

            RDFutilitaires.ongoing = true;
            this.Close();
        }

     
        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void textBox5_enter(object sender, EventArgs e)
        {
       

        }

        private void button3_Click(object sender, EventArgs e)
        {
            //this.profparams.CurrentXSDFilePath = this.label9.Text + "\\" + this.textBox1.Text;
            this.profparams.CurrentXSDFilePath = this.textBox1.Text;
            this.profparams.TargetNamespace = this.textBox2.Text;
            this.profparams.Prefix = this.textBox3.Text;
            this.profparams.RootModelURI = this.textBox5.Text;
            this.profparams.EnvelopName = this.textBox6.Text;
            this.profparams.Version = this.textBox4.Text;

            
            CIMSchemaGenerator.profparameters = this.profparams;
            RDFutilitaires.ongoing = false;
            this.Close();
          
        }

        private void label7_Click(object sender, EventArgs e)
        {
            MessageBox.Show("directory="  +  this.label9.Text);
        }

        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      

        private void textBox1_enter(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.CurrentXSDFilePath = this.label9.Text;
     this.profparams.CurrentXSDFilePath= this.profparams.CurrentXSDFilePath + "\\" + this.textBox1.Text
;

                //MessageBox.Show("selected file="  + Path.GetFileName(this.profparams.CurrentXSDFilePath));
            }
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.TargetNamespace =  this.textBox2.Text;

                //MessageBox.Show("selected name=" + this.profparams.TargetNamespace);
            }
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.Prefix = this.textBox3.Text;

                //MessageBox.Show("selected name=" + this.profparams.Prefix);
            }
        }

        private void textBox6_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.EnvelopName = this.textBox6.Text;

               // MessageBox.Show("selected name=" + this.profparams.EnvelopName);
            }
        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.Version = this.textBox4.Text;

               // MessageBox.Show("selected name=" + this.profparams.Version);
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox5_enter(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.RootModelURI = this.textBox5.Text;

                // MessageBox.Show("selected name=" + this.profparams.RootModelURI);
            }
        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void label11_Click(object sender, EventArgs e)
        {

        }

        private void checkbox2_click(object sender, EventArgs e)
        {
            if (checkImport.CheckState == CheckState.Checked)
            {
                this.profparams.import = true;
            }
            else
            {
                this.profparams.import = false;
            }
                if (checkImport.CheckState == CheckState.Checked)
               {
                   this.profparams.import = true;
                   this.textBox7.Visible = true;
                   this.textBox7.Enabled = true;
                   this.textBox8.Visible = true;
                   this.textBox8.Enabled = true;
                   this.label11.Text = "SchemaLocation";
               } 
               else
               {
                   this.profparams.import = false;
                   this.textBox7.Visible = false;
                   this.textBox7.Enabled = false;
                   this.textBox8.Visible = false;
                   this.textBox8.Enabled = false;
                   this.label11.Text = "CodelistsLocation";
               }
            
        }

        private void textBox8_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox10_TextChanged(object sender, EventArgs e)
        {

        }

        private void label12_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            // ABA20240201
            if (this.textBox1.Text != null && this.textBox1.Text.Length > 0)
            {
                this.button2.Enabled = true;
            }
        }
    }
}
