﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Configuration;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.1.8                                     *    september 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{

    public partial class OptionForm : Form
    {
        public XMLParser XMLP;
        Dictionary<string, MonGroup> groupesparnom = new Dictionary<string, MonGroup>(); // nom, groupbox
        List<string> groupestodelete = new List<string>();

        int index = 0;

        public class MonGroup
        {
            public GroupBox mygroupbox;
            public Label mylabel;
            public CheckBox mycheckboxlabel;
            public CheckBox mycheckboxhtml;
            public CheckBox mycheckboxrdfs;


            public MonGroup(OptionForm optionform, GroupBox groupparent, string stereotype)
            {

                XMLParser xmlp = new XMLParser(Main.Repo);
                ArrayList stereodetails = xmlp.GetXmlProfstereo(stereotype);

                //initialisation
                mygroupbox = new GroupBox();
                mylabel = new Label();
                mycheckboxlabel = new CheckBox();
                mycheckboxhtml = new CheckBox();
                mycheckboxrdfs = new CheckBox();
                mygroupbox.SuspendLayout();
                //creation
                groupparent.Controls.Add(mygroupbox);
                mygroupbox.Controls.Add(mylabel);
                mygroupbox.Controls.Add(mycheckboxhtml);
                mygroupbox.Controls.Add(mycheckboxrdfs);
                mygroupbox.Controls.Add(mycheckboxlabel);
                mygroupbox.Location = new System.Drawing.Point(3, 25 + 30 * optionform.index);
                mygroupbox.Name = "";// stereotype;// "groupBox" + optionform.index.ToString();
                mygroupbox.Size = new System.Drawing.Size(optionform.label3.Location.X + 100, 30);
                mygroupbox.TabIndex = 23;
                mygroupbox.TabStop = false;

                // 
                // label
                // 
                mylabel.AutoSize = true;
                mylabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                mylabel.Location = new System.Drawing.Point(optionform.label1.Location.X, 9);
                mylabel.Name = stereotype;// +optionform.index.ToString();
                mylabel.Size = new System.Drawing.Size(optionform.label1.Size.Width + 50, 25);
                mylabel.TabIndex = 22;
                mylabel.Text = stereotype;
                // 
                // checkBoxlabel
                // 
                mycheckboxlabel.AutoSize = true;
                mycheckboxlabel.CheckState = CheckState.Unchecked;
                mycheckboxlabel.Location = new System.Drawing.Point(3, 9);
                mycheckboxlabel.Name = "CBLabel";//+ optionform.index.ToString();
                mycheckboxlabel.Size = new System.Drawing.Size(25, 25);
                mycheckboxlabel.TabIndex = 27;
                mycheckboxlabel.UseVisualStyleBackColor = true;
                mycheckboxlabel.CheckedChanged += new System.EventHandler(optionform.CheckBoxGroup_Click);
                if (!optionform.groupesparnom.ContainsKey(mycheckboxlabel.Name)) optionform.groupesparnom.Add(mycheckboxlabel.Name, this);

                // checkBoxhtml
                // 
                mycheckboxhtml.AutoSize = true;
                mycheckboxhtml.CheckState = CheckState.Checked;
                int prov1 = optionform.label2.Location.X;
                mycheckboxhtml.Location = new System.Drawing.Point(optionform.label2.Location.X + 20, 9);
                // mycheckboxhtml.Location = new System.Drawing.Point(400, 9);
                mycheckboxhtml.Name = "html";// +optionform.index.ToString();
                mycheckboxhtml.Size = new System.Drawing.Size(25, 25);
                mycheckboxhtml.TabIndex = 21;
                mycheckboxhtml.UseVisualStyleBackColor = true;
                if ((stereodetails.Count != 0) && (((string)stereodetails[2]) == "Checked"))
                {
                    mycheckboxhtml.CheckState = CheckState.Checked;
                }
                else
                {
                    mycheckboxhtml.CheckState = CheckState.Unchecked;

                }
                mycheckboxhtml.CheckedChanged += new System.EventHandler(optionform.CheckBoxGroup_Click);
                //      if (!optionform.groupesparnom.ContainsKey(mycheckboxhtml.Name)) optionform.groupesparnom.Add(mycheckboxhtml.Name, this);
                // checkBoxrdfs
                // 
                mycheckboxrdfs.AutoSize = true;
                mycheckboxrdfs.CheckState = CheckState.Checked;
                mycheckboxrdfs.Location = new System.Drawing.Point(optionform.label3.Location.X + 20, 9);
                //   mycheckboxrdfs.Location = new System.Drawing.Point(672, 9);
                mycheckboxrdfs.Name = "rdfs"; // +optionform.index.ToString();
                mycheckboxrdfs.Size = new System.Drawing.Size(25, 25);
                mycheckboxrdfs.TabIndex = 3;
                mycheckboxrdfs.UseVisualStyleBackColor = true;
                if ((stereodetails.Count != 0) && (((string)stereodetails[3]) == "Checked"))
                {
                    mycheckboxrdfs.CheckState = CheckState.Checked;
                }
                else
                {
                    mycheckboxrdfs.CheckState = CheckState.Unchecked;
                }
                mycheckboxrdfs.CheckedChanged += new System.EventHandler(optionform.CheckBoxGroup_Click);
                if (!optionform.groupesparnom.ContainsKey(stereotype)) optionform.groupesparnom.Add(stereotype, this);

                //
                optionform.index++;
                mygroupbox.PerformLayout();


            }
        }

        public OptionForm(XMLProfileParameters profparameters)
        {
            InitializeComponent();
            XMLP = new XMLParser(Main.Repo);
            // initialisation de la partie groupes

            foreach (string s in profparameters.ListStereoNamespace)
            {
                MonGroup mg = new MonGroup(this, GBDataProfile, s);
            }

            if (XMLP.GetXmlValueConfig("Log") == ("Checked"))
            { CBLog.CheckState = CheckState.Checked; }
            else
            { CBLog.CheckState = CheckState.Unchecked; }


            if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == ("Checked"))
            { CBSNS.CheckState = CheckState.Checked; }
            else
            { CBSNS.CheckState = CheckState.Unchecked; }


            if (XMLP.GetXmlValueConfig("Xmlbase") == ("Checked"))
            { CBXmlbase.CheckState = CheckState.Checked; }
            else
            { CBXmlbase.CheckState = CheckState.Unchecked; }

            if (XMLP.GetXmlValueConfig("ModeBatch") == ("Checked"))
            { CBModeBatch.CheckState = CheckState.Checked; }
            else
            { CBModeBatch.CheckState = CheckState.Unchecked; }

            if (XMLP.GetXmlValueConfig("XSDByRef") == ("Checked"))
            { CBXref.CheckState = CheckState.Checked; }
            else
            { CBXref.CheckState = CheckState.Unchecked; }

            CBCC.Visible = false; // for this version the code component Checkbox is ignored
            if (XMLP.GetXmlValueConfig("CodeComponent") == ("Checked"))
            { CBCC.CheckState = CheckState.Checked; }
            else
            { CBCC.CheckState = CheckState.Unchecked; }

            // logging
            this.textBoxLogFile.Text = Main.LOG_FILE;
            this.checkBoxLog.Checked = Main.DO_LOG;

            this.PerformLayout();
            this.BringToFront();

        }


        private void ButSave_Click(object sender, EventArgs e)
        {

            XMLP.SetXmlValueConfig("Log", CBLog.CheckState.ToString());
            XMLP.SetXmlValueConfig("Xmlbase", CBXmlbase.CheckState.ToString());
            XMLP.SetXmlValueConfig("StereotypeNameSpaces", CBSNS.CheckState.ToString());
            XMLP.SetXmlValueConfig("ModeBatch", CBModeBatch.CheckState.ToString());
            XMLP.SetXmlValueConfig("XSDByRef", CBXref.CheckState.ToString());
            XMLP.SetXmlValueConfig("CodeComponent", CBCC.CheckState.ToString());
            XMLP.SetXmlValueConfig("VersionConfig", DateTime.Today.ToString("yyyy-MM-dd"));
            // sauvegarde des indicateurs des groupes
            List<string> newliststereos = new List<string>();
            Dictionary<string, Dictionary<string, bool>> newindstereos = new Dictionary<string, Dictionary<string, bool>>();
            Dictionary<string, bool> dcb = null;
            foreach (Control ctl in this.GBDataProfile.Controls)
            {
                string prov = ctl.GetType().ToString(); //pour test
                if (typeof(GroupBox) == ctl.GetType())
                {
                    foreach (Control contr in ctl.Controls)
                    {
                        if ((this.groupesparnom.ContainsKey(contr.Name)) && (!contr.Name.Contains("CBLabel")))
                        {// on exclut les checkbox
                            MonGroup mongroup = this.groupesparnom[contr.Name];
                            if (!newliststereos.Contains(contr.Name)) {
                                newliststereos.Add(contr.Name);
                                dcb = new Dictionary<string, bool>();
                                dcb.Add("HtmlDoc", (mongroup.mycheckboxhtml.CheckState == CheckState.Checked) ? true : false);
                                dcb.Add("RDFS", (mongroup.mycheckboxrdfs.CheckState == CheckState.Checked) ? true : false);
                                newindstereos.Add(contr.Name, dcb);
                                XMLP.AddXmlProfstereo(contr.Name, null, null, dcb["HtmlDoc"] == true ? "Checked" : "Unchecked", dcb["RDFS"] == true ? "Checked" : "Unchecked", null);
                            }
                        }
                    }
                }
            }

            List<string> oldstereos = XMLP.GetXmlAllProfstereo();
            string newns = "";
            foreach (string stereo in newliststereos)
            {
                newns = newns + stereo + "|";
            }
            XMLP.SetXmlValueProfData("ListStereoNamespace", newns.Trim('|'));
            Main.IndStereos = newindstereos;

            foreach (string stereo in oldstereos)
            {
                if (!newliststereos.Contains(stereo))
                {
                    // il faut enlever ce strereo
                    XMLP.DeleteXmlProfstereo(stereo);
                }
            }

            // log file
            if (checkBoxLog.Checked)
            {
                Main.DO_LOG = true;
            }
            else
            {
                Main.DO_LOG = false;
            }

            if(this.textBoxLogFile.Text != null &&
               this.textBoxLogFile.Text.Trim().Length > 0)
            {
                Main.LOG_FILE = this.textBoxLogFile.Text + "\\log.txt"; 
            }
            this.Dispose();
        }



        private void CheckBoxGroup_Click(object sender, EventArgs e)
        {

            CheckBox cb = (CheckBox)sender;
            // MonGroup mongroup = this.groupesparnom[cb.Name];
            if (cb.CheckState == CheckState.Checked)
            {
                if (!groupestodelete.Contains(cb.Name))
                {
                    groupestodelete.Add(cb.Name);
                }
            }
            else
            {
                if (groupestodelete.Contains(cb.Name)) {
                    groupestodelete.Remove(cb.Name);
                }
            }

        }





        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void GBAddinSettings_Enter(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged_1(object sender, EventArgs e)
        {

        }

        private void ButNew_Click(object sender, EventArgs e)
        {
            string ss = newtextbox.Text;
            if (!groupesparnom.ContainsKey(ss))
            {
                MonGroup mg = new MonGroup(this, GBDataProfile, ss);
            }

        }

        private void ButDelete_Click(object sender, EventArgs e)
        {
            groupestodelete = new List<string>();
            foreach (string cbname in this.groupesparnom.Keys)
            {
                if (groupesparnom[cbname].mycheckboxlabel.Checked)
                {
                    if (!groupestodelete.Contains(cbname))
                    {
                        groupestodelete.Add(cbname);
                    }
                }
            }
            foreach (string cbname in groupestodelete)
            {
                groupesparnom[cbname].mygroupbox.Dispose();
                groupesparnom.Remove(cbname);
            }
        }

    
     
        

        private void CBLog_Click(object sender, EventArgs e)
        {
            /*
            if (CBLog.CheckState == CheckState.Checked)
            {
                CBLog.CheckState = CheckState.Checked;
            }
            else{
            CBLog.CheckState = CheckState.Checked;
         }
             * */
        }

        private void CBXmlbase_Click(object sender, EventArgs e)
        {
            /*
     if (CBXmlbase.CheckState == CheckState.Checked)
            {
                CBXmlbase.CheckState = CheckState.Unchecked;
            }
            else{
            CBLog.CheckState = CheckState.Checked;
           }
             * */
        }

        

       
        private void CBSNS_Click(object sender, EventArgs e)
        {
            /*
            if (CBSNS.CheckState == CheckState.Checked)
            {
                CBSNS.CheckState = CheckState.Unchecked;
            }
            else
            {
                CBLog.CheckState = CheckState.Checked;
            }          
   */
        }
//-------------------
        /*
        private void OptionForm_Load(object sender, System.EventArgs e)
        {
            // Create the ToolTip and associate with the Form container.
            ToolTip toolTip1 = new ToolTip();

            // Set up the delays for the ToolTip.
            toolTip1.AutoPopDelay = 5000;
            toolTip1.InitialDelay = 1000;
            toolTip1.ReshowDelay = 500;
            // Force the ToolTip text to be displayed whether or not the form is active.
            toolTip1.ShowAlways = true;

            // Set up the ToolTip text for the Button and Checkbox.
            toolTip1.SetToolTip(this.newtextbox, "My bulle");
        }
        */

//--------------

        void majIndicateurs(Dictionary<string, Dictionary<string, bool>> IndStereos,XMLProfileParameters profparameters)
        {// on met a jour le dictionnaire indicateurs
            Dictionary<string, Dictionary<string, bool>> newindstereos = new Dictionary<string, Dictionary<string, bool>>();
            foreach (string stereo in profparameters.ListStereoNamespace)
            {
                if (!newindstereos.ContainsKey(stereo))
                {
                    Dictionary<string, bool> dcb = new Dictionary<string, bool>();
                    dcb.Add("HtmlDoc", false);
                    dcb.Add("RDFS", false);
                }
            }
        }

        private void OptionForm_Load(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged_2(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged_3(object sender, EventArgs e)
        {

        }

        private void CBXSDByRef_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void CBCC_Click(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged_4(object sender, EventArgs e)
        {

        }

        private void cancelBtn_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void checkBoxLog_CheckedChanged(object sender, EventArgs e)
        {
        }

        private void buttonLogFileDir_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folderBrowserDialog = new FolderBrowserDialog();
            folderBrowserDialog.SelectedPath = this.textBoxLogFile.Text;
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
            {
                this.textBoxLogFile.Text = folderBrowserDialog.SelectedPath;
            }
            folderBrowserDialog.Dispose();

        }
        //-------------------------------
    }
}
 

