using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using CimSyntaxGen.Option;
using EA;
using System.Security.Cryptography.X509Certificates;
using System.Xml;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                          november 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public class XMLProfileParameters
    {
        XMLParser xmlp = new XMLParser(Main.Repo);

        public string DefaultXSDFilePath = FileManager.GetUserDirPath() + "\\essai.xsd";
        public string CurrentXSDFilePath = FileManager.GetUserDirPath() + "\\essai.xsd";
        public string DefaultProfileNamespace = "http://iec/tc57/Profil1#";
        public string DefaultTargetNamespace = "http://iec/tc57/Profil1#";
        public string ProfileNamespace = "urn:entsoe.eu:wgedi:acknowledgementdocument:5:0";
        public string TargetNamespace = "urn:entsoe.eu:wgedi:acknowledgementdocument:5:0";
        public string DefaultRootModelURI = "http://iec.ch/tc57"; // beginning of Model's URI
        public string RootModelURI = "http://iec.ch/tc57"; // beginning of Model's URI
        public string URICodelist = "urn:entsoe.eu:wgedi:codelists";  // pointe sur l'espace des codelists
        public string CodeListLocation = "urn:entsoe.eu:wgedi:codelists";
        public string URISchemaLocation = "urn-entsoe-eu-local-extension-types.xsd";
        public string Prefix = "m";
        public string DefaultRootModelPrefix = "cim";
        public string EnvelopName = "ProfileEnvelop";
        public string Version = "1.0";
        public string XSDByRef = "XSDByRef";
        public string NewJasonCodelistFile = "Unchecked";// in case its nessessary to reset the JasonCodeListFile
        //public string PackageExtension = "Extension";
        public bool WithAnnotations = false;
        public bool import = true;
        public const string Referencetype = "referenceType";
        public const string Referencetypes = "referenceTypes";
        public const string CodeListValueType = "CodeListValueType";
        public List<string> TagValuesToFiler = new List<string>() { (new ConstantDefinition()).GetIBOTagValue(), "oldguid" }; //Referencetype,Referencetypes };
        public List<string> ListStereoNamespace = new List<string>();//{"Entsoe","Entsoe,Shortcircuit","ShortCircuit"};
        public List<string> ListStereoNamespaceExport = new List<string>();//{"Shortcircuit","Operation","Shortcircuit,Operation"};
        public List<string> ListCimstereos = new List<string>()
                                      {
                                        "CIMDatatype",
                                        "Datatype",
                                        "Primitive",
                                        "Compound",
                                        "enumeration",
                                        "Enumeration",
                                        "enum"
                                       };
        public Dictionary<string, string[]> urisbystereo = new Dictionary<string, string[]>();// stereo,(prefix,uri)
        public Dictionary<string, string> fulldescdic = new Dictionary<string, string>(); //stereo/state
        public string fulldesc = "Checked";
        bool _FlatDatatypes;
        public bool FlatDatatypes
        {
            get
            {
                return _FlatDatatypes;
            }
            set
            {
                _FlatDatatypes = value;
            }
        }
        bool _forXml = false;
        public bool forXml
        {
            get { return _forXml; }
            set { _forXml = value; }
        }
        public string _copyrightnotice;
        public string  copyrightnotice
            {
                get
                {
                return _copyrightnotice;
                }
                set
                {
                _copyrightnotice = value;
                }
            }
        public XMLProfileParameters( string filepath)
        {
            this.CurrentXSDFilePath= filepath;
            foreach (string s in ListStereoNamespace)
            {
                if (!urisbystereo.ContainsKey(s)) urisbystereo.Add(s, new string[2] { Prefix, RootModelURI });
            }
           
        }
        public XMLProfileParameters()
        {
            //XMLParser xmlp = new XMLParser();  
            DefaultXSDFilePath=xmlp.GetXmlValueProfData("DefaultXSDFilePath");
            CurrentXSDFilePath=xmlp.GetXmlValueProfData("CurrentXSDFilePath");        
            DefaultProfileNamespace=xmlp.GetXmlValueProfData("DefaultProfileNamespace");
            DefaultTargetNamespace=xmlp.GetXmlValueProfData("DefaultTargetNamespace"); 
            ProfileNamespace=xmlp.GetXmlValueProfData("ProfileNamespace");
            TargetNamespace=xmlp.GetXmlValueProfData("TargetNamespace");
            DefaultRootModelURI=xmlp.GetXmlValueProfData("DefaultRootModelURI");
            URICodelist = xmlp.GetXmlValueProfData("URICodelist");
            RootModelURI=xmlp.GetXmlValueProfData("RootModelURI"); 
            CodeListLocation=xmlp.GetXmlValueProfData("CodeListLocation");
            URISchemaLocation =xmlp.GetXmlValueProfData("URISchemaLocation") ;
            Prefix=xmlp.GetXmlValueProfData("Prefix");
            DefaultRootModelPrefix = xmlp.GetXmlValueProfData("DefaultRootModelPrefix");

              EnvelopName =xmlp.GetXmlValueProfData("EnvelopName");
            Version = xmlp.GetXmlValueProfData("Version");
            //PackageExtension=xmlp.GetXmlValueProfData("PackageExtension");
            XSDByRef = xmlp.GetXmlValueConfig("XSDByRef");
            string ss = xmlp.GetXmlValueProfData("FlatDatatypes");
           
           //on innitialise les parametres du profil avec les valeurs par default
           string  ns = xmlp.GetXmlValueProfData("ListStereoNamespace");
           if (!(ns == null))
           {
               string[] split = ns.Split('|');
               for (int i = 0; i < split.Length; i++)
               {
                  if(!ListStereoNamespace.Contains(split[i])) ListStereoNamespace.Add(split[i]);
               }
           }
            foreach (string s in ListStereoNamespace)      
            {
                ArrayList indicateurs = xmlp.GetXmlProfstereo(s);
                if (!urisbystereo.ContainsKey(s)) urisbystereo.Add(s, new string[2] { (string)indicateurs[0],(string)indicateurs[1] });
            }

            ns = xmlp.GetXmlValueProfData("ListStereoNamspaceExportable");
            if (!(ns == null))
            {
                string[] split = ns.Split('|');
                for (int i = 0; i < split.Length; i++)
                {
                    if(split[i]!="")  // cela arrive si la liste dans le fichier config se termine avec un separateur suivi de rien
                    { 
                    if (!ListStereoNamespaceExport.Contains(split[i])) ListStereoNamespaceExport.Add(split[i]);
                }
                }
            }
           // ----  partie CodeComponent
          
        }
 //-----------------------

              public XMLProfileParameters(XMLParser xmlp)
              {
            this.xmlp = xmlp;
                 // XMLParser xmlp = new XMLParser();
                   /*   
    DefaultXSDFilePath=xmlp.GetXmlValueProfData("DefaultXSDFilePath");
    CurrentXSDFilePath=xmlp.GetXmlValueProfData("CurrentXSDFilePath");  
        
     DefaultProfileNamespace=xmlp.GetXmlValueProfData("DefaultProfileNamespace");
     DefaultTargetNamespace=xmlp.GetXmlValueProfData("DefaultTargetNamespace"); 
     ProfileNamespace=xmlp.GetXmlValueProfData("ProfileNamespace");
     TargetNamespace=xmlp.GetXmlValueProfData("TargetNamespace");
     DefaultRootModelURI=xmlp.GetXmlValueProfData("DefaultRootModelURI");
        
     RootModelURI=xmlp.GetXmlValueProfData("RootModelURI"); 
     Prefix=xmlp.GetXmlValueProfData("Prefix");
        
  	 EnvelopName=xmlp.GetXmlValueProfData("EnvelopName");
      Version = xmlp.GetXmlValueProfData("Version");
        */
                  
                 //on innitialise les parametres du profil avec les valeurs par default
           string  ns = xmlp.GetXmlValueProfData("ListStereoNamespace");
           if (!(ns == null))
           {
               string[] split = ns.Split('|');
               for (int i = 0; i < split.Length; i++)
               {
                  if(!ListStereoNamespace.Contains(split[i])) ListStereoNamespace.Add(split[i]);
               }
           }
 //   public List<string> ListStereoNamespace=new List<string>(){"Entsoe","Entsoe,Shortcircuit"};

            foreach (string s in ListStereoNamespace)
            {
                if (!urisbystereo.ContainsKey(s)) urisbystereo.Add(s, new string[2] { Prefix, RootModelURI });
            }
            
        }
        public void majIndicateurs()
        {
            fulldesc=xmlp.GetXmlValueProfData("CCLightFull");
             string stereolist = xmlp.GetXmlValueProfData("ListStereoNamespace");
            string[] stereos = stereolist.Split(new char[] { '|' });
            for(int i=0;i < stereos.Length;i++)
            {
                string stereo = stereos[i];
                ArrayList indics = xmlp.GetXmlProfstereo(stereo);
                fulldescdic[stereo] = (string)indics[4];
            }


        }
        public bool hasFullDesc(string stereoex)
        {
            bool ret = false;
            if (fulldesc == "full") return true;
            if (stereoex == "") return false;
            if (!stereoex.Contains(","))
            {
                foreach (string stereo in fulldescdic.Keys)
                {
                    if (!stereoex.Contains(stereo)) continue;
                    if (fulldescdic[stereo] == "Checked")
                    {
                        ret = true;
                        break;
                    }
                }
            }
            else
            {
                string[] split = stereoex.Split(new char[] { ',' });
                foreach (string st in split)
                {
                    if ( (fulldescdic.ContainsKey(st)) && (fulldescdic[st] == "Checked")) ret = true;
                }
            }
            return ret;
        }
        
  //--------------------------------------------------------------- 
   
    }
}
