﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company : Zamiren (Joinville-le-Pont France)  *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.10                                     *    decembre 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/

namespace CimSyntaxGen.Option
{
    public partial class codecomponentForm : Form
    {
        XMLParser XMLP;
        string[] selectedFiles;
        public codecomponentForm()
        {
            XMLP = Main.XMLP;
            InitializeComponent();
            InitializeOpenFileDialog();
            this.comboBox1.Text = XMLP.GetXmlValueProfData("CCTypeOfDocument");
            this.comboBox2.Text = XMLP.GetXmlValueProfData("CCStandardNumber");
            this.comboBox3.Text = XMLP.GetXmlValueProfData("CCCodeComponentName");
            this.comboBox5.Text = XMLP.GetXmlValueProfData("CCDiffusionState");
            this.comboBox4.Text = XMLP.GetXmlValueProfData("CCLightFull");
            this.textBox1.Text = XMLP.GetXmlValueProfData("CCProfileName");
            this.textBox2.Text = XMLP.GetXmlValueProfData("CCVersionStateInfo");
            this.label9.Text = makePackageName();
            string ss = XMLP.GetXmlValueProfData("CCSelectedFiles");
            Main.selectedCCFiles = new List<string>();
            this.label11.Text = "";
            if ( ss!= "")
            {
                string[] split = ss.Split(new char[] { ',' });
                for(int i=0;i < split.Length;i++)
                {
                    if (split[i] != "")
                    {
                        if (!Main.selectedCCFiles.Contains(split[i])) Main.selectedCCFiles.Add(split[i]);

                        this.label11.Text = this.label11.Text + "::" + System.IO.Path.GetFileName(split[i]);
                    }
                }
              
            }
        }
        
        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }


        private void InitializeOpenFileDialog()
        {
            // Set the file dialog to filter for graphics files.
            this.openFileDialog1.Filter =
                "Profiles (*.XSD;*.RDFS;|"; //+ "All files (*.*)|*.*";

            // Allow the user to select multiple images.
            this.openFileDialog1.Multiselect = true;
            this.openFileDialog1.Title = "ProfileFiles select";
        }

        private void BUTSelectFiles_Click(object sender, EventArgs e)


        {
            DialogResult dr = this.openFileDialog1.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                // Read the files
                Main.selectedCCFiles = new List<string>();

                foreach (String file in openFileDialog1.FileNames)
                {
                    // memorize he fies.
                    try
                    {
                        if (!Main.selectedCCFiles.Contains(file)) Main.selectedCCFiles.Add(file);
                    }

                    catch (Exception ex)
                    {
                        // Could not load the image - probably related to Windows file system permissions.
                        MessageBox.Show("codecomponent openFileDialog " + ex.Message);
                        XMLP.AddXmlLog("codecomponent openFileDialog ", ex.Message);
                    }
                }
            }
        }

        private void taus(object sender, EventArgs e)
        {

        }

        private void BUTOK_Click(object sender, EventArgs e)
        {
            XMLP.SetXmlValueProfData("CCTypeOfDocument", this.comboBox1.Text);
            XMLP.SetXmlValueProfData("CCStandardNumber", this.comboBox2.Text);
            XMLP.SetXmlValueProfData("CCCodeComponentName", this.comboBox3.Text);
            XMLP.SetXmlValueProfData("CCDiffusionState", this.comboBox5.Text);
            XMLP.SetXmlValueProfData("CCLightFull", this.comboBox4.Text);
            XMLP.SetXmlValueProfData("CCProfileName", this.textBox1.Text);
            XMLP.SetXmlValueProfData("CCVersionStateInfo", this.textBox2.Text);
            /*
            string ccfilename = "IEC_";
            if (this.comboBox1.Text != "IS")
            {
                ccfilename=ccfilename + this.comboBox1.Text + "_";
            }
         
            ccfilename = ccfilename + this.comboBox2.Text + this.textBox1.Text;
            ccfilename = ccfilename + "." + this.comboBox3.Text + "." + this.textBox2.Text;
            ccfilename = ccfilename + "." + this.comboBox4.Text;
            if(this.comboBox5.Text !="IEC")
            {
                ccfilename = ccfilename + "." + this.comboBox5.Text;

            }
            XMLP.SetXmlValueProfData("CCVersionStateInfo", this.textBox2.Text);

     */
            XMLP.SetXmlValueProfData("CCPackageName",makePackageName());
            if(Main.selectedCCFiles.Count==0)
            {
                MessageBox.Show(" you must select some profile files");
            }
            else
            {
                string ss = "";
                foreach (string file in Main.selectedCCFiles)
                {
                    ss = ss + "," + file;
                }
                XMLP.SetXmlValueProfData("CCSelectedFiles",ss );
                this.Dispose();
            }

            
            
        }

        private void BUTCancel_Click(object sender, EventArgs e)
        {
            Main.selectedCCFiles = new List<string>();
            this.Dispose();
        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        string makePackageName()
        {
            
            string ccfilename = "IEC_";
            if (this.comboBox1.Text != "IS")
            {
                ccfilename = ccfilename + this.comboBox1.Text + "_";
            }

            ccfilename = ccfilename + this.comboBox2.Text //+ this.textBox1.Text;
            ccfilename = ccfilename + "." + this.comboBox3.Text + "." + this.textBox2.Text;
            ccfilename = ccfilename + "." + this.comboBox4.Text;
            if (this.comboBox5.Text != "IEC")
            {
                ccfilename = ccfilename + "." + this.comboBox5.Text;

            }
                 return ccfilename;
        }

        private void comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.label9.Text = makePackageName();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.label9.Text = makePackageName();
        }
    }
    
}
