﻿
using EA;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net.NetworkInformation;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using System.Xml.Serialization;
/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                     *  november 2020   * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/


namespace CimSyntaxGen
{
    /// <summary>
    /// class for serialisation of a profile package
    /// conforming to IECTC57/61970-501Ed2
    /// </summary>
    class Schema501
    {
        StreamWriter reportlog = null;
        XMLProfileParameters profparameters;
        List<string> NoDoublons = new List<string>();
        RDFLAutilitaires util;
        TextWriter tw;
        ConstantDefinition CD;
        public List<long> datatypedone;
        public List<string> createdConcept = new List<string>(); // when a concept is created in he scheme
        public List<string> LocalDatatypeNames = new List<string>();
        public List<long> LocalDatatypeIDs = new List<long>();
        List<string> conceptdic = new List<string>(); // to ensure that only one of each concept is created 
        List<string> resourcelist = new List<string>(); //to ensure that only one of each localresource is created
        List<long> dejatraite;// for connectorsID
        public string Prefix;
        string uri = ""; // the profile uri
        public struct Nomrole
        {
            public long elemid;
            public string rolename;

        }
        public List<Nomrole> nomsRoles;
        public Schema501(EA.Package package, XMLProfileParameters profparams, StreamWriter reportlog, TextWriter TW)
        {
            try
            {
                //Ta tb = new Ta("serialize pour package=" + package.Name);
                this.tw = TW;
                XMLParser XMLP = new XMLParser(Main.Repo);
                uri = XMLP.GetXmlValueProfData("ProfileNamespace").Trim('#');
                CIMSchemaGenerator.mapforprimitivetypes = new Dictionary<string, string>();
                CIMSchemaGenerator.BuildMapforprimitivetypes(CIMSchemaGenerator.mapforprimitivetypes);
                this.CD = new ConstantDefinition();
                this.nomsRoles = new List<Nomrole>();
                this.datatypedone = new List<long>();
                this.dejatraite = new List<long>();
                RDFLAutilitaires.buildLocalDatatypeNames(package, LocalDatatypeNames, LocalDatatypeIDs);
                this.reportlog = reportlog;
                RDFLAutilitaires.reportlog = reportlog;
                profparameters = profparams;
                this.util = new RDFLAutilitaires(profparameters, Main.Repo);
                List<EA.Element> elemliste = new List<EA.Element>();
                List<string> datanamelist = new List<string>();
                List<long> dataidlist = new List<long>();
                this.Prefix = profparams.Prefix;


            }
            catch (Exception ee)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Schem501 " + ee.Message);
                throw new Exception(" Schem501 " + ee.Message);
            }
            return;
        }
        public bool serialize(EA.Package package)
        {
            //Ta tb = new Ta("serialize pour package=" + package.Name);
            generLocalResources();
            List<EA.Element> elemliste = new List<EA.Element>();
            traitpackage(package, tw);
            //traitement des classes
            foreach (EA.Element e in package.Elements)
            {
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
                /* ABA20230905
                if ((package.Name == "Core") && (e.Name == "Name"))
                {
                    int prov = 1;
                }*/
                if (e.Type == "Class")
                {
                    if (e.Name != "")
                    { // on ne traite pas les elements sans nom
                        {
                            if (!NoDoublons.Contains(e.Name))
                            {
                                NoDoublons.Add(e.Name);
                            }
                            else
                            {
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING there are at least two classes of the same name {" + e.Name + "} in the profile");
                                MessageBox.Show(" WARNING  there are at least two classes of the same name {" + e.Name + "} in the profile ");
                                //tb.stop();
                                return false;
                            }
                            if (e.Name == "ActivePower")
                            {
                                string prov = e.Name;
                            }
                            traitclass(e, tw);
                        }
                    }
                    else
                    {
                        //  // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING an element without name of GUI" + e.ElementGUID + "has been encountered and zapped");
                    }
                }
            }
            generConcepts();
            //tb.stop();
            return true;
        }

        private bool traitclass(Element elem, TextWriter tw)
        {
            bool answer = false;

            try
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Treatment of Element " + elem.Name);

                //Ta tb = new Ta("traitclass pour elem=" + elem.Name);//18

                if (Main.typerdfexport == "501Ed2")
                {
                    if (elem.Name.Contains("Version")) return false;//  Version class is eliminated
                    if (elem.Name.Contains("Ontology")) return false; // Ontology class is eliminated (beeing in header)
                }
                if (Main.typerdfexport == "2019")
                {
                    if (elem.Name.Contains("Ontology"))
                    {
                        elem.Name = "Ontology";
                    }
                }
                /* ABA20230905
                if (elem.Name == "LimitKind")
                {
                    string prov = "";
                }*/
                if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
                           || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitclass " + elem.Name + " not  publishabled");
                    return false;//am mai 2020
                }
                ConstDefinition constantes = new ConstDefinition();
                answer = false;
                bool datatype = false;
                if ((elem.Type == "Class") || (elem.MetaType == "Enumeration") || (elem.Type == "Enumeration"))
                {
                    if ((elem.Stereotype != CD.GetEnumStereotype()) && (elem.MetaType != "Enumeration") && (elem.Type != "Enumeration"))  // not an enumeration //am mai 2018
                    {
                        bool todo = true;
                        if (RDFLAutilitaires.StereoExContainsStereo(elem.StereotypeEx, "Datatype")
                          || RDFLAutilitaires.StereoExContainsStereo(elem.StereotypeEx, CD.GetPrimitiveStereotype())
                          || RDFLAutilitaires.StereoExContainsStereo(elem.StereotypeEx, CD.GetCompoundStereotype())
                          || RDFLAutilitaires.StereoExContainsStereo(elem.StereotypeEx, CD.GetDatatypeStereotype()))
                        {
                            datatype = true;
                            if (datatypedone.Contains(elem.ElementID))
                            { // the datatype have already been treated
                                todo = false;
                            }
                            else
                            {
                                if (LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID)) todo = false;// the datatype is already   part of the profile	
                            }
                        }
                        if (todo == true)
                        {
                             // to avoid duplication of identifier name references
                            tw.WriteLine("<rdf:Description rdf:about=\""+ getURI(elem,"501") + elem.Name + "\">");
                            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");
                            tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#Class\"/>");
                            // is there a superclass?
                            EA.Element superclass = RDFLAutilitaires.getElementSuperclass(elem);
                            if (superclass != null)
                            {
                                tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"" + getURI(superclass,"501") + superclass.Name + "\"/>");
                            }
                            if ((elem.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
                            {
                                twNotes(elem.Notes, tw,"skos");
                            }
                            if (elem.StereotypeEx != "")
                            {
                                string[] split = elem.StereotypeEx.Split(',');
                                for (int i = 0; i < split.Length; i++)
                                {                           
                                    insertConcept(split[i]);
                                }
                            }

                            if (datatype == true)
                            {
                                datatypedone.Add(elem.ElementID);
                                if(!!LocalDatatypeNames.Contains(elem.Name)) LocalDatatypeNames.Add(elem.Name);
                                if (!LocalDatatypeIDs.Contains(elem.ElementID))
                                {                        
                                    tw.WriteLine("\t<" + Prefix + ":Package>" + getURI(Main.Repo.GetPackageByID((int)elem.PackageID),"501") + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "</" + Prefix + ":Package>");
                                }
                                else
                                {
                                    tw.WriteLine("\t<" + Prefix + ":Package>" + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "</" + Prefix + ":Package>");
                                }
                                
                                if ((util.getEltType(elem) == "CIMDatatype") && (profparameters.FlatDatatypes))
                                {
                                    
                                    tw.WriteLine("\t<owl:EquivalentProperty rdf:resource = \"" + RDFLAutilitaires.namespaces[profparameters.Prefix] + elem.Name + "." + "value" + "\" />");
                                }
                            }
                            else
                            {
 
                                tw.WriteLine("\t<" + Prefix + ":Package>" + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "</" + Prefix + ":Package>");
                            }
                            if ((elem.Abstract == "1") && (datatype == false))
                            {
                                tw.WriteLine("\t<" + Prefix + ":isAbstract>True</" + Prefix + ":isAbstract>");
                            }
                            tw.WriteLine("</rdf:Description>");  // augmented

                            // traitement des attributs
                            foreach (EA.Attribute att in elem.Attributes)
                            {
                                traitAttribute(elem, att, tw);

                            }
                            // traitement des associations
                            EA.Collection connectors = elem.Connectors;
                            foreach (EA.Connector con in connectors)
                            {
                                // on verifie que le connector n'a pas ete deja traite dans un autre package
                                if (!dejatraite.Contains(con.ConnectorID))
                                {
                                    if (con.ConnectorID != 0) dejatraite.Add(con.ConnectorID);
                                    traitConnector(con, tw);
                                }

                                //tb.stop();
                                answer = true;
                                //return answer;
                            }
                        }
                    }
                    else
                    { // is an enumeration

                        if (datatypedone.Contains(elem.ElementID))
                        {  // the datatype have already been treated
                            return false;
                        }
                        else
                        {
                            if (LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID)) return false;// the datatype is already   part of the profile
                        }

                        datatypedone.Add(elem.ElementID);
                        LocalDatatypeNames.Add(elem.Name); // to avoid duplication of identifier name references // am june 2011     
                        tw.WriteLine("<rdf:Description rdf:about=\"" +getURI(elem,"501")+ elem.Name + "\">");
                        tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");
                        tw.WriteLine("\t<rdf:type rdf:resource=\"" + RDFLAutilitaires.namespaces["owl"] + "Class\"/>");

                        if ((elem.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
                        {

                            twNotes(elem.Notes, tw,"skos");
                        }
                        if (!LocalDatatypeIDs.Contains(elem.ElementID))
                        {  // it is a datatype copied from above level
                            tw.WriteLine("\t<" + Prefix + ":Package>" + util.getURI(Main.Repo.GetPackageByID((int)elem.PackageID)) + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "</" + Prefix + ":Package>");
                        }
                        else
                        {
                          
                            tw.WriteLine("\t<" + Prefix + ":Package>" + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "</" + Prefix + ":Package>");
                        }

                        tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"#Enumeration\"/>");

                        if (elem.StereotypeEx != "")
                        {
                            string[] split = elem.StereotypeEx.Split(',');
                            for (int i = 0; i < split.Length; i++)
                            {
                                if ((split[i] != "enumeration") && (split[i] != "Enumeration"))
                                {
                                    //string texte = " ATTENTION waiting for stereo specs";
                                    tw.WriteLine("<cims:stereotype>" + split[i] + "</cims:stereotype>");
                                   // tw.WriteLine("<!-- " + texte + " -->");
                                }
                            }
                        }
                        tw.WriteLine("\t<owl:oneOf rdf:parseType=\"Collection\">");
                        foreach (EA.Attribute member in elem.Attributes)
                        {
                            //tw.WriteLine("\t\t<owl:Thing rdf:about=\"#" + elem.Name + "." + member.Name + "\"/>");
                            tw.WriteLine("\t\t<owl:Thing rdf:about=\"" + getURI(elem,member,"501") + elem.Name + "." + member.Name + "\"/>");
                        }
                        tw.WriteLine("\t</owl:oneOf >");
                        tw.WriteLine("</rdf:Description>");  // augmented
                        foreach (EA.Attribute att in elem.Attributes)
                        {
                            traitEnummember(elem, att, tw);

                        }

                        // tb.stop();
                        answer = true;
                        //return answer;

                    }

                }
                return answer;
            }
            //tb.stop();     
            catch (Exception ee)
            {
                throw new Exception(" traitclass " + ee.Message);
            }
        }

        private bool traitConnector(Connector con, TextWriter tw)
        {
            try
            {

                //Ta tb = new Ta("traitConnector pour id=" + con.ConnectorID.ToString() + " source=" + con.ClientEnd.Role + " target=" + con.SupplierEnd.Role);//18
                if (con.Type != "Association") return false;
                EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
                EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                EA.ConnectorEnd source = con.ClientEnd;
                EA.ConnectorEnd target = con.SupplierEnd;
                if (
                    (!util.IsInProfile(Main.Repo, source_element, Main.Repo.GetTreeSelectedPackage()))
                    ||
                    (!util.IsInProfile(Main.Repo, target_element, Main.Repo.GetTreeSelectedPackage()))
                    )
                {// one end is not part of the profile
                    string texte = "WARNING one  end  of an association between " + Main.Repo.GetElementByID((int)con.ClientID).Name + " and " + Main.Repo.GetElementByID((int)con.SupplierID).Name;
                    texte = texte + "\n seems not to be part of the profile.  That is not correct";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    MessageBox.Show(texte);
                    return false;
                }
                bool isAggregatesource = false;
                bool isAggregatetarget = false;

                if (
                      ((RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 2))
                     ||
                     ((RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 2))
                     ||
                      ((RDFLAutilitaires.getPublishable(con.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(con.StereotypeEx) == 2))
                    )
                {
                    return false;
                }


                //string EntsoeExpStereo = XMLP.GetXmlValueProfData("EntsoeExpStereo");


                // -----       ajout juillet 2012  ------------------- //
                // en cas d'ambiguite sur le lien 
                // les 2 cardinalités à [0,1] ou a [1] ou bien à [x,*]
                // on teste la navigabilite pour lever le'ambiguite et marquer 
                // la bonne association comme utilisee el l'autre non
                // avec <cims:AssociationUsed
                //
                //bool ambiguite = true;

                // ------------------------------------
                if (/*con.Type == "Aggregation" || */ source.Aggregation == 1)
                {
                    isAggregatesource = true;
                }
                if (/* con.Type == "Aggregation" || */ target.Aggregation == 1) // achtoung doute
                {
                    isAggregatetarget = true;
                }

                Nomrole rname = new Nomrole();

                // COTE SOURCE

                if (target.Role != "")
                { //there must be a non empty rolename		
                    rname.elemid = target_element.ElementID;
                    rname.rolename = target.Role;

                    if (nomsRoles.Contains(rname))
                    {
                        /**************************
                            MessageBox.Show("WARNING this Role name " + target.Role
                            + " associated with "
                            + target_element.Name
                            + " has already been used\n"
                            + " verify if this is licit in your model");
                        ********************************/
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
                            //+ " associated with "
                            //+ target_element.Name
                            //+ " has already been used\n"
                            //+ " verify if this is licit in your model"
                            //+ "\n");
                    }
                    else
                    {
                        nomsRoles.Add(rname);
                    }

                   // tw.WriteLine("<rdf:Description rdf:about = \"#" + source_element.Name + "." + target.Role + "\" >");
                    tw.WriteLine("<rdf:Description rdf:about = \"" +getURI(source_element,"501")+ source_element.Name + "." + target.Role + "\" >");
                    tw.WriteLine("\t<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "ObjectProperty\" />");
                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + target.Role + "</rdfs:label>");

                    bool fdesc = (profparameters.hasFullDesc(target_element.StereotypeEx) || profparameters.hasFullDesc(source_element.StereotypeEx));

                    if ((target.RoleNote != "") && fdesc)
                    {
                        twNotes(target.RoleNote, tw,"skos");
                    }
                    if (con.StereotypeEx != "")
                    {
                        string[] split = con.StereotypeEx.Split(',');
                        for (int i = 0; i < split.Length; i++)
                        {
                            insertConcept(split[i]);
                        }
                    }

                    tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(source_element,"501") + source_element.Name + "\"/>");
                    tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(target_element,"501") + target_element.Name + "\"/>");// 
                    if (source.Role != "")
                    {
                        rname.elemid = source_element.ElementID;
                        rname.rolename = source.Role;
                        if (nomsRoles.Contains(rname))
                        {
                            /*******************
                                MessageBox.Show( "WARNING this Role name " + source.Role
                                + " associated with " 
                                + source_element.Name 
                                + " has already been used\n"
                                + " verify if this is licit in your model");
                            *******************/
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
                                            //+ " associated with "
                                            //+ target_element.Name
                                            //+ " has already been used\n"
                                            //+ " verify if this is licit in your model"
                                            //+ "\n");
                        }
                        else
                        {
                            nomsRoles.Add(rname);
                        }
                        tw.WriteLine("\t<owl:inverseOf rdf:resource=\"" + getURI(target_element,"501") + target_element.Name + "." + source.Role + "\"/>");
                        if (target.Cardinality != "")
                        {
                            string cardinality = target.Cardinality.Trim(); // am 2011
                            cardinality = cardinality.Replace('*', 'n'); // am 2011
                            string[] split = cardinality.Split(new string[] { ".." }, StringSplitOptions.RemoveEmptyEntries);
                            if ((split[0] == "0") && (split[1] == "1"))
                            {
                                tw.WriteLine("<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "FunctionalProperty\"/>");
                            }
                        }

                    }
                    tw.WriteLine("</rdf:Description >");
                }
                // COTE TARGET

                if (source.Role != "")
                { //there must be a non empty rolename		
                    rname.elemid = source_element.ElementID;
                    rname.rolename = source.Role;

                    if (nomsRoles.Contains(rname))
                    {
                        /**************************
                            MessageBox.Show("WARNING this Role name " + target.Role
                            + " associated with "
                            + target_element.Name
                            + " has already been used\n"
                            + " verify if this is licit in your model");
                        ********************************/
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + source.Role
                            //+ " associated with "
                            //+ source_element.Name
                            //+ " has already been used\n"
                            //+ " verify if this is licit in your model"
                            //+ "\n");
                    }
                    else
                    {
                        nomsRoles.Add(rname);
                    }

                    tw.WriteLine("<rdf:Description rdf:about = \"" +getURI(target_element,"501")+ target_element.Name + "." + source.Role + "\" >");
                    tw.WriteLine("\t<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "ObjectProperty\" />");
                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + source.Role + "</rdfs:label>");
                    bool fdesc = (profparameters.hasFullDesc(target_element.StereotypeEx) || profparameters.hasFullDesc(source_element.StereotypeEx));
                    // if ((source.RoleNote != "") && (profparameters.hasFullDesc(source_element.StereotypeEx)))
                    if ((source.RoleNote != "") && fdesc)
                     {
                        // string texte = RDFutilitaires.RemoveRc(source.RoleNote);
                        //tw.WriteLine("\t<skos:definition xml:lang = \"en\" >" + source.RoleNote + "</skos:definition>");
                        twNotes(source.RoleNote, tw,"skos");
                    }


                    //tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + "#" + target_element.Name + "\"/>");
                    tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(target_element,"501") + target_element.Name + "\"/>");
                   // tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + "#" + source_element.Name + "\"/>");// 
                    tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(source_element,"501") + source_element.Name + "\"/>");// 
                    if (target.Role != "")
                    {
                        rname.elemid = target_element.ElementID;
                        rname.rolename = target.Role;
                        if (nomsRoles.Contains(rname))
                        {
                            /*******************
                                MessageBox.Show( "WARNING this Role name " + source.Role
                                + " associated with " 
                                + source_element.Name 
                                + " has already been used\n"
                                + " verify if this is licit in your model");
                            *******************/
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + source.Role
                                            //+ " associated with "
                                            //+ source_element.Name
                                            //+ " has already been used\n"
                                            //+ " verify if this is licit in your model"
                                            //+ "\n");
                        }
                        else
                        {
                            nomsRoles.Add(rname);
                        }
                        tw.WriteLine("\t<owl:inverseOf rdf:resource=\"" + getURI(source_element,"501") + source_element.Name + "." + target.Role + "\"/>");
                        if (source.Cardinality != "")
                        {
                            string cardinality = source.Cardinality.Trim(); // am 2011
                            cardinality = cardinality.Replace('*', 'n'); // am 2011
                            string[] split = cardinality.Split(new string[] { ".." }, StringSplitOptions.RemoveEmptyEntries);
                            if ((split[0] == "0") && (split[1] == "1"))
                            {
                                tw.WriteLine("<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "FunctionalProperty\"/>");
                            }
                        }

                    }
                    tw.WriteLine("</rdf:Description >");
                }


                //tb.stop();


                return true;
            }

            catch (Exception ee)
            {
                throw new Exception(" traitConnectors " + ee.Message);
            }
        }



        private bool traitEnummember(EA.Element elem, EA.Attribute att, TextWriter tw)
        {
            bool answer = false;
            try
            {
                if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
                   || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitEnummember " + elem.Name + "." + att.Name + "not  publishabled");
                    return false;//am mai 2020Ta 
                }
                //tw.WriteLine("<rdf:Description rdf:about = \"" + "#" + elem.Name + "." + att.Name + "\">");
                tw.WriteLine("<rdf:Description rdf:about = \"" + getURI(elem,att,"501") + elem.Name + "." + att.Name + "\">");
                if (att.Notes == null) att.Notes = "";
 
                if (profparameters.hasFullDesc(att.StereotypeEx))
                {
                    twNotes(att.Notes, tw,"skos");
                }
                if (att.StereotypeEx != "")
                { // am may 2011
                    string[] stereos = att.StereotypeEx.Split(',');
                    foreach (string stereo in stereos)
                    {
                        insertConcept(stereo);
                    }
                }
                tw.WriteLine("\t<rdfs:label xml:lang = \"en\">" + att.Name + " </rdfs:label>");
                tw.WriteLine("\t<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "NamedIndividual\" />");
                tw.WriteLine("\t<rdfs:domain rdf:resource = \"" + getURI(elem,"501") + elem.Name + "\"/>");
                tw.WriteLine("</rdf:Description>");
            }
            catch (Exception ee)
            {
                throw new Exception(" traitEnumMember " + ee.Message);
            }
            return answer;
        }

        /// <summary>
        /// genere le schema d'un package 
        /// <rdf:Description rdf:about="#Package_Core">
        ///<rdf:type rdf:resource="#Package"/>
        ///<rdfs:labe xml:lang="en">Core</rdfs:label>
        ////<rdfs:comment xml:lang="en">comment</rdf:Description>
        /// </summmary>
        /// <param name="p"></param>
        /// <param name="tw"></param>
        /// <returns></returns>
        //--------------------------------------------------------------------------------------------------------
        public bool traitpackage(EA.Package p, TextWriter tw)
        {
            bool answer = false;
            //Ta tb = new Ta("traitpackage pour package=" + p.Name);
            try
            {
                if (
                    (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 0)
                                ||
                                (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 2)
                                )
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\tInfo traitpackage not publishabled " + p.Name);
                    return false;//am mai 2020
                }
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Treatment of Package " + p.Name);
                ConstDefinition constantes = new ConstDefinition();
                answer = true;
                EA.Package Profpack = Main.Repo.GetTreeSelectedPackage();

                // ABA20241008 tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#" + "Package_" + p.Name + "\">");
                tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#" + p.Name + "\">");
                tw.WriteLine("\t<rdf:type rdf:resource=\""+ uri + "#Package\"/>");
                if ((p.Notes == "") || (!profparameters.hasFullDesc(p.StereotypeEx)))
                {
                    //    tw.WriteLine("\t<rdfs:comment>" + "</rdfs:comment>");
                }
                else
                {
                    twNotes(p.Notes, tw,"comment");
                }
                tw.WriteLine("</rdf:Description>");
                //tb.stop();
            }
            catch (Exception ee)
            {
                throw new Exception("traitpackage " + ee.Message);
            }
            return answer;
        }



        private bool traitAttribute(Element elem, EA.Attribute attribute, TextWriter tw)
        {
            bool answer = false; // will be true => elm is unique
            /* ABA20230905
            if ((elem.Name == "IdentifiedObject") && (attribute.Name == "energyIdentCodeEic"))
            {
                string tt = "";
            }*/
            try
            {
                //Ta tb = new Ta("traitAttribute pour attribute=" + elem.Name + "." + attribute.Name);
                if ((RDFLAutilitaires.getPublishable(attribute.StereotypeEx) == 0)
             || (RDFLAutilitaires.getPublishable(attribute.StereotypeEx) == 2))
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitAttribute " + elem.Name + "." + attribute.Name + "not  publishabled");
                    return false;
                }
                int classifierid = (int)attribute.ClassifierID;//18
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t\t Treatment of Attribute " + attribute.Name);
                tw.WriteLine("<rdf:Description rdf:about=\"" + getURI(elem,attribute,"501") + elem.Name + "." + attribute.Name + "\">");
                tw.WriteLine("\t<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "DatatypeProperty\" />");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + attribute.Name + "</rdfs:label>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"" + getURI(elem,attribute,"501")+ elem.Name + "\"/>");

                if (classifierid != 0)
                {
                    EA.Element classifier = Main.Repo.GetElementByID(classifierid);
                    string type = util.getEltType(classifier);
                    switch (type)
                    {
                        case "enumeration":
                            tw.WriteLine("\t<rdfs:range rdf:resource = \"" + getURI(classifier,"501")+ classifier.Name + "\" />");
                            break;
                        case "CIMDatatype":
                            tw.WriteLine("\t<rdfs:range rdf:resource = \"" + getURI(classifier, "501") + classifier.Name + "\" />");
                            break;
                        case "primitive":
                            string xmltype = CIMSchemaGenerator.mapforprimitivetypes[classifier.Name];
                            tw.WriteLine("\t<rdfs:range rdf:resource = \"" + RDFLAutilitaires.namespaces["xsd"] + xmltype + "\" />");
                            break;
                        case "compound":
                            tw.WriteLine("\t<rdfs:range rdf:resource = \"" + getURI(classifier, "501") + classifier.Name + "\" />");
                            break;

                        default:
                            tw.WriteLine("<!-- " + " ISSUE wrong classifier type " + " -->");
                            break;
                    }

                }
                //--  multiplicity  ---------------
                if (
                    (attribute.LowerBound == "0")
                    &&
                    (attribute.UpperBound == "1")
                    )
                {
                    tw.WriteLine("\t<rdf:type rdf:resource = \"" + RDFLAutilitaires.namespaces["owl"] + "FunctionalProperty\" />");
                }
                if (attribute.Default != "")
                {
                    tw.WriteLine("\t<rdf:value>" + attribute.Default + "</rdf:value>");
                    if (
                         (attribute.IsConst)
                         &&
                          (attribute.IsStatic)
                        )
                    {
                        tw.WriteLine("\t<" + Prefix + ":isFixed>True </" + Prefix + ":isFixed>");
                    }
                    else
                    {
                        if (attribute.IsConst)
                        {
                            tw.WriteLine("\t<" + Prefix + ":isConst>True</" + Prefix + ":isConst>");
                        }
                        else
                        {

                        }
                    }
                }
                if (attribute.IsID) // the class is unique
                {
                    tw.WriteLine("\t<" + Prefix + ":isUnique>True</" + Prefix + ":isUnique>");
                }

                if (attribute.StereotypeEx != "")
                { // am may 2011
                    string[] stereos = attribute.StereotypeEx.Split(',');
                    foreach (string stereo in stereos)
                    {
                            insertConcept(stereo);
                    }
                }
                /*************************************************/
                if ((attribute.Notes != "") && (profparameters.hasFullDesc(attribute.StereotypeEx)))
                {
                    twNotes(attribute.Notes, tw,"skos");
                }
                tw.WriteLine("</rdf:Description>");

                if ((classifierid != 0) && (!datatypedone.Contains(attribute.ClassifierID)))
                {
                    // the datatype hasnot  been already generated ?  
                    traitclass(Main.Repo.GetElementByID(classifierid), tw);
                    datatypedone.Add((long)classifierid);
                }

                //tb.stop();
                return answer;
            }
            catch (Exception ee)
            {
                throw new Exception(" traitAttribute " + ee.Message);
            }
        }


        /// <summary>
        /// create the necessary local resouces
        /// </summary>
        void generLocalResources()
        {
            //-----------   package ----------------
            /*
            XMLParser XMLP = new XMLParser();
            string uri = XMLP.GetXmlValueProfData("ProfileNamespace");
            int ind = uri.LastIndexOf('/');
            uri = uri.Substring(0, ind);
            */
            if (!resourcelist.Contains("#Package"))
            {
                resourcelist.Add("#Package");
                tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#Package\" >");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\" />");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">MOF Package</rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\">Declaration that this is a MOF Package.</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Class\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#string\" />");
                tw.WriteLine("</rdf:Description>");
            }
            // -----------  CIMDatatype
            /*
             if (!resourcelist.Contains("#isCIMDataType"))
            {
            tw.WriteLine("<rdf:Description rdf:about=\"" +uri + "#isCIMDataType\">");
            tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\"/>");
            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">isCimDatatype</rdfs:label>");
            tw.WriteLine("\t<rdfs:comment xml:lang=\"en\">Flag indicating whether the class is a CIMDataType.</rdfs:comment>");
            tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Class\" />");
            tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
            tw.WriteLine("</rdf:Description>");
            }
            */
            // --------  Enumerator  ---------------
            if (!resourcelist.Contains("#Enumeration"))
            {
                resourcelist.Add("#Enumeration");
                tw.WriteLine("<rdf:Description rdf:about = \"" + uri + "#Enumeration\" >");
                tw.WriteLine("\t<rdfs:comment xml:lang = \"en\" > An abstract superclass for all Enumerators. </rdfs:comment>");
                tw.WriteLine("\t<rdfs:label xml:lang= \"en\"> enumeration </rdfs:label>");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#Class\" />");
                tw.WriteLine("\t<" + Prefix + ":isAbstract>true</" + Prefix + ":isAbstract>");
                tw.WriteLine("</rdf:Description>");
            }
            // ---------------  Abstract --------------------
            if (!resourcelist.Contains("#isAbstract"))
            {
                resourcelist.Add("#isAbstract");
                tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#isAbstract\">");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\"/>");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is abstract</rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\">Flag indicating whether the class is permitted to have any direct instances.</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Class\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                tw.WriteLine("</rdf:Description > ");
            }
            //---------------- isenum ------------------
            if (!resourcelist.Contains("#isenum"))
            {
                resourcelist.Add("#isenum");
                tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#isenum\">");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\"/>");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is" + "enum" + "\t</rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\">Flag indicating whether the enumerated literal is an " + "enum" + ".</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Property\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                tw.WriteLine("</rdf:Description>");
            }

            // ------   isUnique  -------------------
            if (!resourcelist.Contains("#isUnique"))
            {
                resourcelist.Add("#isUnique");
                tw.WriteLine("<rdf:Description rdf:about= \"" + uri + "#isUnique\" >");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\" />");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is unique </rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\"> Flag indicating whether the property for a specific object can contain the same value more than once.</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Property\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                tw.WriteLine("</rdf:Description > ");
            }

            // ---------   isFixed --------------------
            if (!resourcelist.Contains("#isFixed"))
            {
                resourcelist.Add("#isFixed");
                tw.WriteLine("<rdf:Description rdf:about= \"" + uri + "#isFixed\" >");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\" />");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is fixed property</rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\"> Flag indicating whether the property for a specific object can be updated.</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Property\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                tw.WriteLine("</rdf:Description> ");
            }

            // ---------   isConst --------------------
            if (!resourcelist.Contains("#isConst"))
            {
                resourcelist.Add("#isConst");
                tw.WriteLine("<rdf:Description rdf:about= \"" + uri + "#isConst\" >");
                tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\" />");
                tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is fixed property</rdfs:label>");
                tw.WriteLine("\t<rdfs:comment xml:lang=\"en\"> Flag indicating whether the property for a specific object can be updated.</rdfs:comment>");
                tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Property\" />");
                tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                tw.WriteLine("</rdf:Description > ");
            }
        }
        /// <summary>
        /// print the notes of an element after removing
        /// the superflous charactere nl and rc
        /// si kind == use of rdfs comment in place of skos
        /// </summary>
        /// <param name="description"></param>
        /// <param name="tw"></param>
        void twNotes(string Notes, TextWriter tw,string kind)
        {
            string balise = "skos:definition";
            if (kind=="comment")
            {
                balise = "rdfs:comment";
            }


            if (!Notes.Contains("\n"))
            {
                if (kind == "comment")
                {

                    tw.WriteLine("\t<" + balise + "  xml:lang=\"en\">" + RDFLAutilitaires.cleanSS(util.ReplaceSpecialCharacters(Notes)) + "</rdfs:comment>");
                }
                else
                {
                    tw.WriteLine("\t<" + balise + "  xml:lang=\"en\">" + RDFLAutilitaires.cleanSS(util.ReplaceSpecialCharacters(Notes)) + "</skos:definition>");
                }
            }
            else
            {
                tw.WriteLine("\t<" + balise +"  xml:lang=\"en\">");
                string description = "";
                string[] split = Notes.Split(new char[] { '\n' });
                for (int i = 0; i < split.Length; i++)
                {
                    description = split[i];
                    tw.WriteLine(RDFLAutilitaires.cleanSS(util.ReplaceSpecialCharacters(description)));
                }
                if (kind == "comment")
                {
                    tw.WriteLine("\t</rdfs:comment>");
                }
                else
                {
                    tw.WriteLine("\t</skos:definition>");
                }

            }
        }

       void  insertConcept(string stereo)
        {
            if(!createdConcept.Contains(stereo)) createdConcept.Add(stereo);
            tw.WriteLine("\t<" + Prefix + ":is" + stereo+">True</" + Prefix + ":is" + stereo+">");
        }

        void generConcepts()
        {
            try
            {
               
                List<string> cimdatatypes = new List<string>();
                cimdatatypes.Add("CIMDatatype");
                cimdatatypes.Add("Compound");
                cimdatatypes.Add("Primitive");
                foreach (string stereo in createdConcept)
                {
                    if (stereo == "enum") continue;
                    if (!conceptdic.Contains(stereo))
                    {
                        conceptdic.Add(stereo);
                        tw.WriteLine("<rdf:Description rdf:about=\"" + uri + "#is" + stereo + "\">");
                        tw.WriteLine("\t<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#AnnotationProperty\"/>");
                        tw.WriteLine("\t<rdfs:label xml:lang=\"en\">is" + stereo + "\t</rdfs:label>");
                        tw.WriteLine("\t<rdfs:comment xml:lang=\"en\">Flag indicating whether the class is a " + stereo + ".</rdfs:comment>");
                        if (!cimdatatypes.Contains(stereo))
                        {
                            tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Property\" />");
                        }
                        tw.WriteLine("\t<rdfs:domain rdf:resource=\"http://www.w3.org/2000/01/rdf-schema#Class\" />");
                        tw.WriteLine("\t<rdfs:range rdf:resource=\"http://www.w3.org/2001/XMLSchema#boolean\" />");
                        tw.WriteLine("</rdf:Description>");
                    }
                }
            }
            catch (Exception ee)
            {
                throw new Exception(" generConcepts " + ee.Message);
            }
        }

        //------------------------

        public string getURI(EA.Element elt,string kind)
        {
            string prov = elt.Name;

            // XMLParser xmlp = new XMLParser();
            XMLParser xmlp = Main.XMLP;
            string ret = "";
            string stereoex = elt.StereotypeEx;
            string liststereos = xmlp.GetXmlValueProfData("ListStereoNamespace");
            string uridebase;
            if (kind == "shacl")
            {
                uridebase = profparameters.ProfileNamespace.Trim('#') + "/Constraints#";
            }
            else
            {
                uridebase = profparameters.ProfileNamespace;
            }
            if (xmlp.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
            {
                string eligible = "";
                string[] splitns = liststereos.Split('|');
                for (int i = 0; i < splitns.Length; i++)
                {

                    if (splitns[i].Contains(","))
                    {
                        eligible = splitns[i];
                        string[] split = splitns[i].Split(',');
                        for (int j = 0; j < split.Length; j++)
                        {
                            if (!RDFLAutilitaires.StereoExContainsStereo(stereoex, split[j]))
                            {
                                eligible = "";
                                break;
                            }

                        }
                    }
                    else
                    {
                        if (RDFLAutilitaires.StereoExContainsStereo(stereoex, splitns[i]))
                        {
                            eligible = splitns[i];
                            break;
                        }

                    }

                }
                if (eligible != "")
                {// on a trouve un stereotype qui convient
                    if (Main.IndStereos[eligible]["RDFS"])
                    {
                        string[] prefuri = profparameters.urisbystereo[eligible];
                        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                        {
                            if (prefuri[0] != profparameters.Prefix)
                            {
                                if (kind == "shacl")
                                {
                                    ret = uridebase;
                                }
                                else
                                {
                                    ret = prefuri[1]; // +"#";
                                }
                            }
                            else
                            {
                                ret = "#";
                            }
                        }
                    }
                    else
                    {
                        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                        {
                            if (kind == "shacl")
                            {
                                ret = uridebase;
                            }
                            else
                            {
                                ret = "#";
                            }
                        }

                        else
                        {
                            ret = xmlp.GetXmlValueConfig("DefaulRootModelURI") ;
                        }
                    }

                }
                else
                {
                    if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                    {
                        if (kind == "shacl")
                        {
                            ret = uridebase;            
                        }
                        else
                        {
                            ret = "#";
                        }
                    }

                    else
                    {
                        ret = xmlp.GetXmlValueConfig("DefaulRootModelURI");
                    }
                }
            }
            else
            {
                if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                {
                    if (kind == "shacl")
                    {
                        ret = uridebase;
                    }
                    else
                    {
                        ret = "#";
                    }
                }

                else
                {
                    ret = xmlp.GetXmlValueConfig("DefaulRootModelURI");
                }
            }
            return ret;
        }
        /// <summary>
        /// recherche le bon URI pour un attribut
        /// attention le choix aujourd'hui est de privilegier
        /// l'extension sur la classe a l'extension sur l'attribut
        /// </summary>
        /// <param name="elt"></param>
        /// <param name="atr"></param>
        /// <returns></returns>
        string getURI(EA.Element elt, EA.Attribute atr, string kind)
        {
            string ret = "";
            string prov = elt.Name;
            string prov1 = atr.Name;
            XMLParser xmlp = new XMLParser(Main.Repo);
            string stereoex = elt.StereotypeEx;
            string atrstereoex = atr.StereotypeEx;
            string liststereos = xmlp.GetXmlValueProfData("ListStereoNamespace");

            string uridebase = profparameters.ProfileNamespace;
            if (kind == "shacl")
            {
                uridebase = profparameters.ProfileNamespace.Trim('#') + "/Constraints#";
            }

            if (xmlp.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
            {
                string eligible = "";
                string[] splitns = liststereos.Split('|');
                for (int i = 0; i < splitns.Length; i++)
                {

                    if (splitns[i].Contains(","))
                    {
                        eligible = splitns[i];
                        string[] split = splitns[i].Split(',');
                        for (int j = 0; j < split.Length; j++)
                        {
                            if (!RDFLAutilitaires.StereoExContainsStereo(stereoex, split[j]) && !RDFLAutilitaires.StereoExContainsStereo(atrstereoex, split[j]))
                            {
                                eligible = "";
                                break;
                            }
                        }
                    }
                    else
                    {
                        if (RDFLAutilitaires.StereoExContainsStereo(stereoex, splitns[i]) || RDFLAutilitaires.StereoExContainsStereo(atrstereoex, splitns[i]))
                        {
                            eligible = splitns[i];
                            break;
                        }
                    }
                }
                if (eligible != "")
                {// on a trouve un stereotype qui convient
                    if (Main.IndStereos[eligible]["RDFS"])
                    {
                        string[] prefuri = profparameters.urisbystereo[eligible];
                        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                        {
                            if (kind == "shacl")
                            {
                                ret = "#";
                            }
                            else
                            {
                                if (prefuri[0] != profparameters.Prefix)
                                {
                                    ret = prefuri[1]; //+ "#";
                                }
                                else
                                {
                                    ret = "#";
                                }
                            }
                        }
                        else
                        {
                            if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                            {
                                ret = "#";
                            }

                            else
                            {
                                ret = profparameters.DefaultRootModelURI;
                            }
                        }

                    }
                    else
                    {
                        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                        {
                            ret = "#";
                        }

                        else
                        {
                            ret = profparameters.DefaultRootModelURI;
                        }
                    }
                }
                else
                {

                    if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                    {
                        ret = "#";
                    }

                    else
                    {
                        ret = profparameters.DefaultRootModelURI;
                    }
                }
            }
            return ret;
        }
        public  string getURI(EA.Package pack,string kind)
        {
            string ret = "";
            XMLParser xmlp = new XMLParser(Main.Repo);
            if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
            {
                if (kind == "sahcl")
                {
                    ret = "#";
                }
                else 
                {
                    ret = profparameters.ProfileNamespace;
                }
            }

            else
            {
                ret = profparameters.DefaultRootModelURI;
            }


            return ret;
        }

        //-------------------------------------------------------------------------------
    }
}

     

