﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
//using System.Linq;
using System.Xml;
using System.Windows.Forms;
using System.IO;
using CimSyntaxGen;
/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                                         *  
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.manageIBO
{
    /// <summary>
    /// this is a set of program to copy  the elements from a base 
    /// to a profile with some filters (set of attributes)
    /// </summary>
    class CopyLibrary
    {
        ConstantDefinition CD;
        Dictionary<long, EA.Package> dicPackPack;  // packid/package   parent/fi
        List<long> Elementdejatraite;
        EA.Repository repo; // le reposito
        public TextWriter reportlog;
        Dictionary<string, long> dicParentSonID; // parentguid/profileid


        public CopyLibrary(EA.Repository repo,TextWriter reportlog)
        {
            CD = new ConstantDefinition();
            dicPackPack = new Dictionary<long, EA.Package>();
            Elementdejatraite = new List<long>();
            dicParentSonID = new Dictionary<string, long>();
            this.repo = repo;
            this.reportlog = reportlog;
        }

        public CopyLibrary()
        {
            // TODO: Complete member initialization
        }
        //--------------------------
   
       public EA.Package CopyPackage(EA.Package frompack, EA.Package topack)
       {
           // create a package  

           EA.Package newpack = (EA.Package)topack.Packages.AddNew(frompack.Name, "Package");
           newpack.Update();
           topack.Packages.Refresh();
           newpack.Name = frompack.Name;
           newpack.Notes = frompack.Notes;

           EA.Element newasel = (EA.Element)newpack.Element; // the element associated with the package and which holds the associations
           EA.Element fromasel = (EA.Element)frompack.Element;
           newasel.Stereotype = fromasel.Stereotype;
           newasel.Multiplicity = fromasel.Multiplicity;
           newasel.Tag = fromasel.Tag;
           newasel.Abstract = fromasel.Abstract;
           newasel.IsActive = fromasel.IsActive;
           newasel.Type = fromasel.Type;
           newasel.Subtype = fromasel.Subtype;
           newasel.Status = fromasel.Status;
           bool aGuid = false;
           foreach (EA.TaggedValue tgv in fromasel.TaggedValues)
           {

               if (tgv.Name == CD.GetIBOTagValue())
               {
                   aGuid = true;
               }
               CopyTaggedValue(tgv, newasel);

           }
           if (!aGuid)
           {

               // mark the IBO elemnt with parent GUID
               EA.TaggedValue guid = (EA.TaggedValue)newasel.TaggedValues.AddNew(CD.GetIBOTagValue(), fromasel.ElementGUID);
               guid.Update();
               newasel.TaggedValues.Refresh();
               newasel.Update();
           }

           if (!dicPackPack.ContainsKey(frompack.PackageID)) dicPackPack.Add(frompack.PackageID, newpack);

           foreach (EA.Constraint constr in fromasel.Constraints)
           {
               CopyConstraint(constr, newasel);
           }
           topack.Update();
           newasel.Update();
           return newpack;
       }
 //----------------------------------------------------
        //-----------
      public  void CopyTaggedValue(EA.TaggedValue fromtag, EA.Element toel)
        {
            // creat atvalue and copy simple attributes
            EA.TaggedValue tgv = (EA.TaggedValue)toel.TaggedValues.AddNew(fromtag.Name, fromtag.Value);
            tgv.Update();
            toel.TaggedValues.Refresh();
            tgv.Name = fromtag.Name;
            tgv.Name = fromtag.Value;
            tgv.Notes = fromtag.Notes;
        }

//---------------------------------------------------
     public   EA.Constraint CopyConstraint(EA.Constraint fromconst, EA.Element toel)
        {
            EA.Constraint newconst = (EA.Constraint)toel.Constraints.AddNew(fromconst.Name, fromconst.Type);
            newconst.Update();
            toel.Constraints.Refresh();
            newconst.Name = fromconst.Name;
            newconst.Type = fromconst.Type;
            newconst.Notes = fromconst.Notes;
            return newconst;
        }
//-----------------------------------
        //----
    public    EA.Element CopyElement(EA.Element fromel, EA.Package topack)
        {
            // create an element 
            if (!Elementdejatraite.Contains(fromel.ElementID)) Elementdejatraite.Add(fromel.ElementID); // donot treat something already done

            EA.Element newel = (EA.Element)topack.Elements.AddNew(fromel.Name, fromel.Type);
            newel.Update();
            topack.Elements.Refresh();
            string texte = "CreatEL from " + ((EA.Package)repo.GetPackageByID((int)fromel.PackageID)).Name + "::" + fromel.Name + "  " + ((EA.Package)repo.GetPackageByID((int)newel.PackageID)).Name + "::" + newel.Name;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            newel.Name = fromel.Name;
            newel.Stereotype = fromel.Stereotype;
            newel.Notes = fromel.Notes;
            newel.Multiplicity = fromel.Multiplicity;
            newel.Tag = fromel.Tag;
            newel.Abstract = fromel.Abstract;
            newel.IsActive = fromel.IsActive;
            newel.Type = fromel.Type;
            newel.Subtype = fromel.Subtype;
            newel.Status = fromel.Status;


            topack.Update();


            // copy simple attributes ne
            foreach (EA.Attribute atr in fromel.Attributes)
            {
                CopyAttribute(atr, newel);

            }

            foreach (EA.TaggedValue tgv in fromel.TaggedValues)
            {
                CopyTaggedValue(tgv, newel);
            }

            // mark the IBO elemnt with parent GUID
            EA.TaggedValue guid = (EA.TaggedValue)newel.TaggedValues.AddNew(CD.GetIBOTagValue(), fromel.ElementGUID);
            guid.Update();
            newel.TaggedValues.Refresh();
            newel.Update();

            if (!dicParentSonID.ContainsKey(fromel.ElementGUID)) dicParentSonID.Add(fromel.ElementGUID, newel.ElementID);

            foreach (EA.Constraint constr in fromel.Constraints)
            {
                CopyConstraint(constr, newel);

            }

            //traitConnectors(newel,fromel); // treat recursively the links of newel
            newel.Update();
            topack.Update();
            return newel;

        }
    //-----------------------------------
    //----
    public EA.Element CopyElement(EA.Element fromel,EA.Package topack, string qualifier)
    {
        // create an element 

        EA.Element newel = (EA.Element)topack.Elements.AddNew(fromel.Name + "_" + qualifier, fromel.Type);
        newel.Update();
        topack.Elements.Refresh();
        string texte = "CreatEL from " + ((EA.Package)repo.GetPackageByID((int)fromel.PackageID)).Name + "::" + fromel.Name + "  " + ((EA.Package)repo.GetPackageByID((int)newel.PackageID)).Name + "::" + newel.Name;
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        newel.Name = fromel.Name;
        newel.Stereotype = fromel.Stereotype;
        newel.Notes = fromel.Notes;
        newel.Multiplicity = fromel.Multiplicity;
        newel.Tag = fromel.Tag;
        newel.Abstract = fromel.Abstract;
        newel.IsActive = fromel.IsActive;
        newel.Type = fromel.Type;
        newel.Subtype = fromel.Subtype;
        newel.Status = fromel.Status;


        topack.Update();


        // copy simple attributes ne
        foreach (EA.Attribute atr in fromel.Attributes)
        {
            CopyAttribute(atr, newel);

        }

        foreach (EA.TaggedValue tgv in fromel.TaggedValues)
        {
            CopyTaggedValue(tgv, newel);
        }

        // mark the IBO elemnt with parent GUID
        EA.TaggedValue guid = (EA.TaggedValue)newel.TaggedValues.AddNew(CD.GetIBOTagValue(), fromel.ElementGUID);
        guid.Update();
        newel.TaggedValues.Refresh();
        newel.Update();

        if (!dicParentSonID.ContainsKey(fromel.ElementGUID)) dicParentSonID.Add(fromel.ElementGUID, newel.ElementID);

        foreach (EA.Constraint constr in fromel.Constraints)
        {
            CopyConstraint(constr, newel);

        }

        //traitConnectors(newel,fromel); // treat recursively the links of newel
        newel.Update();
        topack.Update();
        return newel;

    }
        //--
     public   void CopyAttribute(EA.Attribute fromat, EA.Element elt)
        {
            // create newat and  copy simple attributes

            EA.Attribute newat = (EA.Attribute)elt.Attributes.AddNew(fromat.Name, fromat.Type);
            newat.Update();
            elt.Attributes.Refresh();
            newat.Name = fromat.Name;
            newat.Type = fromat.Type;
            newat.Notes = fromat.Notes;
            newat.LowerBound = fromat.LowerBound;
            newat.UpperBound = fromat.UpperBound;
            newat.Pos = fromat.Pos;
            newat.IsConst = fromat.IsConst;
            newat.Default = fromat.Default;
            newat.Type = fromat.Type;
            newat.Stereotype = fromat.Stereotype;
            newat.Precision = fromat.Precision;

            foreach (EA.AttributeTag atgv in fromat.TaggedValues)
            {
                CopyAtTaggedValue(atgv, newat);
            }
            // mark the IBO attribute with parent GUID
            EA.AttributeTag guid = (EA.AttributeTag)newat.TaggedValues.AddNew(CD.GetIBOTagValue(), fromat.AttributeGUID);
            guid.Update();
            newat.TaggedValues.Refresh();
            newat.Update();

            foreach (EA.AttributeConstraint atconst in fromat.Constraints)
            {
                CopyAtConstraint(atconst, newat);
            }
        }
        //----
        //----
      public  void CopyAtTaggedValue(EA.AttributeTag fromatgv, EA.Attribute newat)
        {
            // creat atvalue and copy simple attributes
            EA.AttributeTag atgv = (EA.AttributeTag)newat.TaggedValues.AddNew(fromatgv.Name, fromatgv.Value);
            atgv.Update();
            newat.TaggedValues.Refresh();
            atgv.Name = fromatgv.Name;
            atgv.Value = fromatgv.Value;
            atgv.Notes = fromatgv.Notes;
        }
        //--
     public   EA.AttributeConstraint CopyAtConstraint(EA.AttributeConstraint fromatconst, EA.Attribute newat)
        {
            // creat atconstraint and copy simple attributes
            EA.AttributeConstraint atconst = (EA.AttributeConstraint)newat.Constraints.AddNew(fromatconst.Name, fromatconst.Type);
            atconst.Update();
            newat.Constraints.Refresh();
            atconst.Name = fromatconst.Name;
            atconst.Type = fromatconst.Type;
            atconst.Notes = fromatconst.Notes;
            return atconst;
        }

//----------------------------------------------------------------
    }
}