﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
using EA;
//using CimExportImport.manageIBO;
using CimSyntaxGen;
using CimSyntaxGen.manageIBO;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    /// this class will update the tagvalues GUIDBasedOn according to the dependency association (if it does not exists)
    /// the IsBasedOn dependency between classes
    /// </summary>
    class GetIBOFromDependency
    {
        //18 public TextWriter reportlog=null; // to report details of recreation
        public StreamWriter reportlog = null; // to report details of recreation
       // public Dictionary<long, EA.Package> dicpackbyid; // packageid,package
       // public List<long> listpackids; // list of all packages in a given package
       // public Dictionary<long, List<long>> dicIBOpackbyid; // packageid, list of packageid (from which it depends)
        static EA.Package aPackage; // selected top package
        //public static List<EA.Element> ListElem = null; // list of all model elements
       // public static Dictionary<long, long> DicPackElem = null; // dictionay of all elements tied with package elemid/packid
        //public static Dictionary<string, List<long>> dicElems = null; // dictionnaire par nom et liste de ID
        EA.Repository repo;
    
        static public List<string> Cimstereos = new List<string>()
                                      {
	                                    "Class",
	                                    "Datatype",
                                        "Primitive",
	                                    "Compound",
	                                    "enumeration",
                                        "ACC",
                                        "ABIE",
                                        "MBIE",
                                        "Entsoe",
                                        "Shortcircuit",
                                        "Operation"
                                       };


        
/// <summary>
/// dele from a given package all <<IsBasedOn>> Dependency
/// </summary>
/// <param name="repository"></param>
       public GetIBOFromDependency(EA.Repository repository)
        {
            repo = repository;
            ConstantDefinition constantes=new ConstantDefinition();
            //string IBOtgv =constantes.GetIBOTagValue();
            aPackage = repository.GetTreeSelectedPackage();
              //18 reportlog=new StreamWriter("GetIBODependency.log"); //  the report  filePath
            reportlog = Main.reportlog;//  the report 
           ManageIBOUtilitaires miboutilitaires=new ManageIBOUtilitaires (reportlog); 
            List<EA.Element> ElemList = new List<EA.Element>();
            ManageIBOUtilitaires.getAllElements(aPackage, ElemList, Cimstereos);

           ConstantDefinition CD=new ConstantDefinition();
            Dictionary<long, EA.Package> dicpackbyid = new Dictionary<long, EA.Package>();
            CimSyntaxGen.RDFutilitaires.buildDicrepobyid(repo, dicpackbyid);
            /******** pour test *************/
            EA.Package patest = GetPackagebyName(repo, dicpackbyid, aPackage.Name);
          //  miboutilitaires.PrintIBOElements(repo,patest);

             

            /*****************************************************/
            
            foreach (EA.Element el in ElemList)
            {
                try
                {
                    for (short i=0;i <el.Connectors.Count;i++)
                    {
                         EA.Connector con=(EA.Connector)el.Connectors.GetAt(i);
                        if (con.Stereotype == constantes.GetIsBasedOnStereotype())
                        {
                            if (con.ClientID == el.ElementID)
                            {// il s'agit bien de la source de la dependance
                                EA.Element parent = repo.GetElementByID(con.SupplierID);
                                bool tagfound = false;
                                foreach (EA.TaggedValue tag in el.TaggedValues)
                                {
                                    if (tag.Name == CD.GetIBOTagValue())
                                    {
                                        tag.Value = parent.ElementGUID;
                                        tag.Update();
                                        tagfound = true;
                                        break;
                                    }
                                }
                                if (!tagfound)
                                {
                                    EA.TaggedValue tag = (EA.TaggedValue)el.TaggedValues.AddNew(CD.GetIBOTagValue(), parent.ElementGUID);
                                    tag.Update();
                                    el.TaggedValues.Refresh();
                                    el.Update();
                                }
                                break;
                            }
                        }
                    }
                  
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }
               
            }
            MessageBox.Show(" fin traitement de tous les elements debut log");
            miboutilitaires.PrintIBOElements(repo, patest);

        }
       /// <summary>
       /// obtient le premier package ayant un nom donne
       /// </summary>
       EA.Package GetPackagebyName(EA.Repository repo, Dictionary<long, EA.Package> dicpackbyid, string paname)
       {
           EA.Package ret = null;
           foreach (EA.Package pa in dicpackbyid.Values)
           {
               if (pa.Name == paname)
               {
                   ret = pa;
                   break;
               }
           }
           return ret;

       }

//- - - - - - - - - - - - - - - - - - - - - 
    }
}
