﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
using CimSyntaxGen;
using EA;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.manageIBO
{
   public  class ManageIBOUtilitaires
    {
       // public static TextWriter reportlog;
       public static StreamWriter reportlog;
        static public EA.Repository repo;
       

         public Dictionary<string, ArrayList> dicElemByName;
        public List<EA.Element> listelem;
       public static  ConstantDefinition CD = new ConstantDefinition();

        public ManageIBOUtilitaires(StreamWriter reportlg)
        {
            reportlog = reportlg;
        }
        public ManageIBOUtilitaires(StreamWriter reportlg,EA.Repository repos )
        {
            reportlog = reportlg;
            repo = repos;
        }

        




       

        /// <sUMM2ary>
        /// retrieves recursively elements with a stereotype in a list of  stereotypes or all elements
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public static List<EA.Element> getAllElements(EA.Package package, List<EA.Element> resultList, List<string> stereotypes)
        {
            string texte = "";
            string prov = package.Name;
            if(((package== null) || stereotypes==null) || (resultList==null)){
            texte="Error pb in parameters call of ManageIBIutilitaires.getAllElements";
                MessageBox.Show(texte);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return resultList;
            }
            texte="************************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = " getAllElements(" + package.Name + ")" + DateTime.Now;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte = "************************************************************************";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            foreach (EA.Element e in package.Elements)
            {
                prov = e.Name;
                texte = " => processing ... element " + package.Name + "::" + e.Name;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                // reportlog.Flush();
                bool ok = true;
                if (stereotypes.Count > 0)
                { // not all
                    foreach (string s in stereotypes)
                    {
                        ok = false;
                        if ((e.StereotypeEx.Contains(s)) || (e.Stereotype == "") || (e.Type=="Enumeration") || (e.MetaType=="Enumeration") )
                        {
                            ok = true;
                            break;
                        }
                    }
                }
                        if (ok)
                        {
                            resultList.Add(e);
                        }
                    
                }
            
            foreach (EA.Package p in package.Packages)
            {
                getAllElements(p, resultList, stereotypes);
            }
            return resultList;
        }
   static   public  EA.Element getTheotherend(EA.Element el, EA.Connector con)
        {
            string prov = con.ConnectorID.ToString();
            EA.Element theotherend=null;
            string texte;
            if (con.ClientID == el.ElementID)
            { // theother end is target
                try
                {
                    theotherend = repo.GetElementByID((int)con.SupplierID);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }
            }
            else
            {
                try
                {
                    theotherend = (EA.Element)repo.GetElementByID(con.ClientID);
                }
                catch (Exception e)
                {
                    texte=" Probleme dans getTheotherend " + el.Name + " con.stereotype=" + con.Stereotype + " " +  e.Message;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
            }
            return theotherend;
        }

//---------------------
  /// <summary>
  /// 
  /// </summary>
  /// <param name="el"></param>
  /// <param name="con"></param>
  /// <returns>arrayList</returns> arraylist[0]=theotheren_element (EA.Element)
  ///                              arraylist[1]=TARGET ou SOURCE    (short)
  ///                              arraylist[2]= role                (string)
       static public ArrayList getOtherend(EA.Element el, EA.Connector con)
   {
       string prov = con.ConnectorID.ToString();
       string texte;
       ArrayList res = new ArrayList();
       if (con.ClientID == el.ElementID)
       { // theother end is target
           try
           {
               res.Add(repo.GetElementByID((int)con.SupplierID));
               res.Add(CD.TARGET);
               res.Add(con.SupplierEnd.Role);
           }
           catch (Exception e)
           {
               MessageBox.Show(e.Message);
           }
       }
       else
       {
           try
           {
               res.Add(repo.GetElementByID(con.ClientID));
               res.Add(CD.SOURCE);
               res.Add(con.ClientEnd.Role);
           }
           catch (Exception e)
           {
               texte = " Probleme dans getTheotherend " + el.Name + " con.stereotype=" + con.Stereotype + " " + e.Message;
               // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           }
       }
       return res;
   }
//--------------------
   static public EA.Element getTheotherend(EA.Repository repo,EA.Element el, EA.Connector con)
   {
       string prov = con.ConnectorID.ToString();
       EA.Element theotherend = null;
       string texte;
       if (con.ClientID == el.ElementID)
       { // theother end is target
           try
           {
               theotherend = repo.GetElementByID((int)con.SupplierID);
           }
           catch (Exception e)
           {
               MessageBox.Show(e.Message);
           }
       }
       else
       {
           try
           {
               theotherend = (EA.Element)repo.GetElementByID(con.ClientID);
           }
           catch (Exception e)
           {
               texte = " Probleme dans getTheotherend " + el.Name + " con.stereotype=" + con.Stereotype + " " + e.Message;
               // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           }
       }
       return theotherend;
   }

     static public   string getParentGuid(EA.Element elt)
        {
            ConstantDefinition constantes = new ConstantDefinition();
            string IBOguid = "";
            foreach (EA.TaggedValue tgv in elt.TaggedValues)
            {
                if (tgv.Name == constantes.GetIBOTagValue())
                {
                    IBOguid = tgv.Value;
                    break;
                }
            }
            return IBOguid;
        }
        //--------------

     static public string getConGuid(EA.Connector con)
     {
         ConstantDefinition constantes = new ConstantDefinition();
         string IBOguid = "";
         foreach (EA.ConnectorTag tgv in con.TaggedValues)
         {
             if (tgv.Name == constantes.GetIBOTagValue())
             {
                 IBOguid = tgv.Value;
                 break;
             }
         }
         return IBOguid;
     }
               //--------------

     static public string getAttributeIBOGuid(EA.Attribute at)
     {
         ConstantDefinition constantes = new ConstantDefinition();
         string IBOguid = "";
         foreach (EA.AttributeTag tgv in at.TaggedValues)
         {
             if (tgv.Name == constantes.GetIBOTagValue())
             {
                 IBOguid = tgv.Value;
                 break;
             }
         }
         return IBOguid;
     }
     //--------------

     static public string getElementIBOGuid(EA.Element el)
     {
         ConstantDefinition constantes = new ConstantDefinition();
         string IBOguid = "";
         foreach (EA.TaggedValue tgv in el.TaggedValues)
         {
             if (tgv.Name == constantes.GetIBOTagValue())
             {
                 IBOguid = tgv.Value;
                 break;
             }
         }
         return IBOguid;
     }
    /****************************************************************************    
       public void Import(EA.Repository repo, EA.Package pack, string profilename) // the constructor 
        {
            bool profileFilePresent = false;
                ConstantDefinition constantes =new ConstantDefinition();
            try
            {
                string[] files = Directory.GetFiles(savDirpackage, "*.xml");
                if (files.Length > 0)
                {
                    string[] packagesname = new string[files.Length];
                    if (files.Length > 1)
                    {
                        Array.Resize(ref packagesname, files.Length - 1);
                    }

                    int j = 0;
                    for (int i = 0; i < files.Length; i++)
                    {
                        if (Path.GetFileName(files[i]) == (profilename + ".xml"))
                        {
                            profileFilePresent = true;
                        }
                        else
                        {
                            if (files.Length > 1) packagesname[j] = Path.GetFileName(files[i]);
                            j++;
                        }
                    }

                }



                if (profileFilePresent == false)
                {
                    MessageBox.Show("Error the profile's directory must contain a xmi file of the same name \n wich will be the root package for the profile");
                    return;
                }
                else
                {
                    EA.Project project = repo.GetProjectInterface();// we get project interface

                    int ExportImages = 1;
                    int ImportDiagram = 1;
                    int StripGUID = 1;
                    // first import of the packge root profile
                    string XmiFileName = savDirpackage + "\\" + profilename + ".xml";
                    string intoguid = pack.PackageGUID;
                    project.ImportPackageXMI(intoguid, XmiFileName, ImportDiagram, StripGUID);
                    repo.SaveAllDiagrams();
                    bool ret = pack.Update();
                    string erreur = "";
                    if (ret == false)
                    {
                        erreur = repo.GetLastError();
                        MessageBox.Show("Error in importing file \n" + XmiFileName + erreur);
                        return;
                    }
                    repo.RefreshModelView(pack.PackageID);



                    intoguid = "";
                    pack = repo.GetPackageByGuid(pack.PackageGUID);//oups l'objet initial n'est pas raffraichi

                    EA.Package profilepa = null; // the package of the profile
                    foreach (EA.Package pa in pack.Packages)
                    {
                        if (pa.Name == profilename)
                        {
                            intoguid = pa.PackageGUID;
                            profilepa = pa;
                            break;
                        }
                    }

                    if (intoguid != "")
                    {
                        profilepa.Name = "P_" + profilepa.Name; // the profile name will be prefixed by P_
                        profilepa.Update();
                        foreach (string paname in selectedpackages)
                        {// import  selected packages
                            XmiFileName = savDirpackage+ "\\" + paname + ".xml"; // savDirectory + "\\" + paname;
                            project.ImportPackageXMI(intoguid, XmiFileName, ImportDiagram, StripGUID);
                            repo.SaveAllDiagrams();
                        }

                        ret = pack.Update();
                        if (ret == false)
                        {
                            erreur = repo.GetLastError();
                            MessageBox.Show("Error in importing files \n" + erreur);
                            return;
                        }
                    }
                    //----------- rebuild of ClassifierIDs ---------------------
                    
                    buidDics(repo.GetPackageByGuid(intoguid));
                    foreach (EA.Element ell in listelem)
                    {
                       // MessageBox.Show("traite element " + ell.Name );
                        RecoverIdentifier(ell);
                        
                    }
                    //---------------------   create IBOs ----------------------------
                   // create a dependency "IsbasedOn" betwween the profile and its parent
                    EA.Package profpa=(EA.Package)repo.GetPackageByGuid(intoguid);
                    string prov = profpa.Name;
                    EA.Package parentpa = (EA.Package)repo.GetPackageByGuid(aPackageGuid);
                    prov = parentpa.Name;
                    EA.Element profelt = profpa.Element;
                    EA.Element parentelt = parentpa.Element;

                    EA.Connector con = (EA.Connector)profelt.Connectors.AddNew("", "Dependency");
                    con.ClientID = profelt.ElementID;
                    con.SupplierID = parentelt.ElementID;
                    con.Stereotype = constantes.GetIsBasedOnStereotype();
                    con.Update();
                    profelt.Connectors.Refresh();
                    profelt.Update();   
                  //  RecreateIBO recreate = new RecreateIBO(repo, profpa);
                }
                
            }

            catch (Exception e)
            {
                MessageBox.Show("Error in dealing with  profile's directory \n" + e.Message);

            }
             

        }
        *********************************************************/
///---
     static void DeletePackage(EA.Repository repo, EA.Package pack)
        {
            long packid = pack.PackageID;
            int parentid = pack.ParentID;
            if ((parentid != 0) && (packid != 0))
            {

                // the package should be deleted from its parent package
                EA.Package parent = repo.GetPackageByID(parentid);
                EA.Collection packages = parent.Packages;
                short index = new int();
                try
                {
                    for (short i = 0; i < packages.Count; i++)
                    {
                        EA.Package pa = (EA.Package)packages.GetAt(i);
                        if (pa.PackageID == packid)
                        { // we found the index of the package to delete
                            index = i;
                            break;
                        }
                    }
                    packages.Delete(index);
                    packages.Refresh();
                    repo.SaveAllDiagrams();
                    repo.RefreshOpenDiagrams(true);
                }
                catch (Exception e)
                {
                    MessageBox.Show(" Error in deleting a package " + e.Message);
                }
                try
                {
                    repo.RefreshModelView(parentid);
                    parent.Update();

                }
                catch (Exception e)
                {
                    MessageBox.Show(" Error in deleting a package " + e.Message);
                }
            }
        }
     public static List<EA.Package> getAllPackages(EA.Package package, List<EA.Package> resultList)
     {
         string prov;
         // // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-1 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
         if (!resultList.Contains(package))
         {
             prov = package.Name;
             resultList.Add(package);
             //     // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-2 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
         }
         foreach (EA.Package pack in package.Packages)
         {
             //   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-3 " + pack.Name + " | " + pack.PackageID + "| count " + resultList.Count);
             if (!resultList.Contains(pack))
             {

                 prov = pack.Name;
                 resultList.Add(pack);
                
             }
         }

         /***************************
         foreach (EA.Package p in package.Packages)
         {
             //  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-5 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
             getAllPackages(p, resultList);
             //    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-6 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
         }
          ********************************/
         return resultList;
     }
     public static List<long> getAllPackagesID(EA.Package package, List<long> resultList)
     {
         string prov;
       
         if (!resultList.Contains(package.PackageID))
         {
             prov = package.Name;
             resultList.Add(package.PackageID);
         
         }
         foreach (EA.Package pack in package.Packages)
         {
        
             if (!resultList.Contains(pack.PackageID))
             {

                 prov = pack.Name;
                 resultList.Add(pack.PackageID);
      
             }
         }


         foreach (EA.Package p in package.Packages)
         {
       
             getAllPackagesID(p, resultList);
      
         }
         return resultList;
     }
        /// <summary>
        /// get rid of the qualifier
        /// </summary>
        /// <param name="?"></param>
        /// <returns></returns>
        static public string removequalifier(string s){
            string ret = "";
            if (s.Contains("_"))
            {
                Char[] car = { '_' };
                string[] splitname = s.Split(car);
                ret = splitname[1]; // the rightside of the name
            }
            else
            {
                ret = s;
            }
            return ret;
        }

//----------------------------
        public static List<EA.Element> getAllElementsByType(EA.Package package, List<EA.Element> resultList, List<string> types)
        {
            string texte = "";
            string prov = package.Name;
            if(((package== null) || types==null) || (resultList==null)){
            texte="Error pb in parameters call of ManageIBIutilitaires.getAllElements";
                MessageBox.Show(texte);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return resultList;
            }

            foreach (EA.Element e in package.Elements)
            {
                prov = e.Name;
                bool ok = true;
                if (types.Count > 0)
                { // not all
                    foreach (string s in types)
                    {
                        ok = false;
                        if (e.Type == s)
                        {
                            ok = true;
                            break;
                        }
                    }
                }
                        if (ok)
                        {
                            resultList.Add(e);
                        }
                    
                }
            
            foreach (EA.Package p in package.Packages)
            {
                getAllElementsByType(p, resultList, types);
            }
            return resultList;
        }
        //--------------------------------------------------------------------------
        /// <summary>
        /// remove the qualifier from  a name 
        /// </summary>
        /// <param name="s"></param>
        static public string RemoveQual(string s)
        {
            Int32 ind = s.IndexOfAny(new char[] { '_' });
            string ss = s.Substring(ind + 1);
            return ss;
        }
        /// <summary>
        /// collectionne tous les elements en relation avec un element , y compris a travers des heritages
        /// </summary>
        /// <param name="elt"></param>
        /// <returns></returns>
      void  getAllRelatedparentElements(EA.Element elt,List<EA.Element> resultlist)
        {
            string texte = elt.Name;
            List<EA.Element> ancesters = new List<EA.Element>();
            getAllParents(elt, ancesters);
          if(!ancesters.Contains(elt)) ancesters.Add(elt);
          foreach (EA.Element el in ancesters)
          {
              foreach (EA.Connector con in el.Connectors)
              {
                  EA.Element otherend = getTheotherend(el, con);
                  texte = otherend.Name;
                  if (!resultlist.Contains(otherend))
                  {
                      resultlist.Add(otherend);
                  }
              }

          }
        }
        //
      static  public void  getAllParents(EA.Element elt,List<EA.Element> ancesters){
          string texte = elt.Name;
          if (!ancesters.Contains(elt)) ancesters.Add(elt);
              
            
            EA.Element ancester=getAncester(elt);
            
            if (ancester != null)
            {
                texte = ancester.Name;
                if (!ancesters.Contains(ancester)) ancesters.Add(ancester);
                getAllParents(ancester, ancesters);
            }
        }
//-----
      static EA.Element getAncester(EA.Element elt)
      {
          string texte = elt.Name;
          EA.Element ret = null;
          foreach (EA.Connector con in elt.Connectors)
          {
              if (con.Type == "Generalization")
              {
                  if (con.SupplierID != elt.ElementID)
                  { // on n'herite pas de soi même
                      ret = repo.GetElementByID((int)con.SupplierID);
                      texte = ret.Name;
                  }
              }
          }
          return ret;
      }
//---
        /// <summary>
        /// tell if two elements are related 
        /// </summary>
        /// <param name="fromel"></param>
        /// <param name="toel"></param>
        /// <returns>retourne un dictionnare donnant une conid et un role</returns>
    public static   Dictionary<long, string> IsRelated(EA.Element fromel, EA.Element toel)
       {
           string texte;
           texte = " Isrelated fromel=" + fromel.Name + " , toel=" + toel.Name;
           // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           Dictionary<long, string> liens = new Dictionary<long, string>();
           string role = "";
           List<EA.Element> ancesters=new List<EA.Element>();
           getAllParents(fromel, ancesters);
           string prov = fromel.Name + "," + fromel.ElementID.ToString();
                
           foreach (EA.Element elt in ancesters)
           {
               prov = elt.Name + "," + elt.ElementID;
               foreach (EA.Connector con in elt.Connectors)
               {
                   if ((con.Type == "Association") || (con.Type == "Aggregation") )
                   {
                       EA.Element theotherend = getTheotherend(fromel, con);
                       texte = theotherend.Name;
                       if (theotherend.ElementID==toel.ElementID)
                       { // connexion eligible
                           if (con.ClientID == theotherend.ElementID)
                           {
                               role = con.ClientEnd.Role;
                           }
                           else
                           {
                               role = con.SupplierEnd.Role;
                           }
                           if (!liens.ContainsKey(con.ConnectorID))
                           {
                               liens.Add(con.ConnectorID, role);
                               texte = " pour con.ConnectorID role retenu=" + role;
                               // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                           }
                       }
                   }
               } 
           }
           ancesters = new List<EA.Element>();
           getAllParents(toel, ancesters);
           foreach (EA.Element elt in ancesters)
           {
               texte = elt.Name;
               foreach (EA.Connector con in elt.Connectors)
               {
                   if ((con.Type == "Association") || (con.Type == "Aggregation"))
                   {
                       EA.Element theotherend = getTheotherend(toel, con);
                       texte = theotherend.Name;
                       if (theotherend.ElementID == fromel.ElementID)
                       { // connexion eligible
                           if (con.ClientID == theotherend.ElementID)  
                           {
                               role = con.SupplierEnd.Role;  // c'est toujours le role du cote toel qui nous interesse
                           }
                           else
                           {
                               role = con.ClientEnd.Role;
                           }
                           if (!liens.ContainsKey(con.ConnectorID))
                           {
                               liens.Add(con.ConnectorID, role);
                               texte = " pour con.ConnectorID(cote ancetres detoel)  role retenu=" + role;
                               // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                           }
                       }
                   }
               }
           }


           return liens;
       }
//--------------------------------------------------------
   /// <summary>
   /// print all elements of a package with name  id guid and parentIBO element
   /// </summary>
   /// <param name="repo"></param>
   /// <param name="thepackage"></param>
      public  void PrintIBOElements( EA.Repository repo,EA.Package thepackage)
            
    {
        string texte = "";
        List<EA.Element> IBOElements = new List<EA.Element>();
            List<string> types=new List<string>(){"Class",};
        getAllElementsByType(thepackage, IBOElements,types);
        texte = "**********************************************************************";
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        texte = "!!! print de tous les elements IBO Elements (de type class)  d'un package et de son IBOparent !!!" + DateTime.Now;
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        texte = "**********************************************************************";
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        EA.Package lepack;
        foreach (EA.Element el in IBOElements)
            if(el.Name != ""){
        {
           //  MessageBox.Show(" traitement element " + el.Name); pour test
            lepack = repo.GetPackageByID((int)el.PackageID);
            texte = "\r--------------------------    element: " + lepack.Name + "::" + el.Name +" -----------------------------------\n";
            texte = texte + "| elementid=" + el.ElementID.ToString() + "| elementguid=" + el.ElementGUID.ToString() ;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            if (GetIBOParent(repo,el) != null) // il y a un element base
            {
                //--------------- partie element -----------------------
                EA.Element eltparent=GetIBOParent(repo,el);
                EA.Package packparent = repo.GetPackageByID((int)eltparent.PackageID);
                texte = "|" + " GUIDBasedOn=" + getParentGuid(el).ToString() + "|";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                texte ="|" +  " element parent " + packparent.Name + "::"  + el.Name  + "| eltparentid=" + eltparent.ElementID.ToString()+ "|"  + " eltparentguid=" + eltparent.ElementGUID.ToString();
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                if (getParentGuid(el) != eltparent.ElementGUID)
                {
                    texte = "=============  ATTENTION   ==========================================================\n";
                    texte = texte + " le GUID BasedOn tagvalue n'est pas egal au GUID de l'element parent\n";
                    texte = texte + "===============================================================================";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }


                //--------------------- partie attributs -------------------------------------------
                Dictionary<string, string> dicatt = new Dictionary<string, string>();
                
                foreach (EA.Attribute at in eltparent.AttributesEx)
                {
                    if (!dicatt.ContainsKey(at.Name))
                    {
                        dicatt.Add(at.Name, at.AttributeGUID);
                    }
                }
                texte = "------------------------------------------\n";
                texte = texte + " Attributs:";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                foreach (EA.Attribute at in el.Attributes)
                {
                    texte = "| \t attribut=" + at.Name + " IBOguid=" + getAttributeIBOGuid(at) + " dont l'attribut parent a  ParentGUID=";
                    string ss = "";
                    if (dicatt.ContainsKey(at.Name)) { ss = dicatt[at.Name]; }else{
                        texte = "=============  ATTENTION   ==========================================================\n";
                        texte = texte + " il y a une difference de nom d'attribut entre mere et fille \n";
                        texte = texte + "===============================================================================";
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                    texte = texte + ss;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    if (getAttributeIBOGuid(at) != ss)
                    {
                        texte = "=============  ATTENTION   ==========================================================\n";
                        texte = texte + " le GUID BasedOn tagvalue n'est pas egal au GUID de l'attribut parent\n";
                        texte = texte + "===============================================================================";
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    }
                }
                //---------------- partie connectors -----------------------------------
                foreach (EA.Connector con in el.Connectors)
                {
                    if ((con.Type == "Association") || (con.Type == "Aggregation"))
                    {
                        EA.Element theotherend=getTheotherend(repo,el, con);
                        // necessary for report: texte = "--------------------------\n\r";
                        // necessary for report: texte = texte + "| association " + lepack.Name + "::" + el.Name + " -> ";
                        // necessary for report: texte=texte + repo.GetPackageByID((int)theotherend.PackageID).Name + "::" + theotherend.Name;
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        // necessary for report: texte= "| conguid=" + con.ConnectorGUID + "| GUIDBasedOn=" + getConGuid(con) + " |";
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        try
                        {
                            EA.Connector parentcon = repo.GetConnectorByGuid(getConGuid(con));
                            //texte = " association parente pointee : ";
                            EA.Element client = repo.GetElementByID((int)parentcon.ClientID);
                            EA.Element supplier = repo.GetElementByID((int)parentcon.SupplierID);
                            EA.Package clientpack = repo.GetPackageByID((int)client.PackageID);
                            EA.Package supplierpack = repo.GetPackageByID((int)supplier.PackageID);
                            // ABA20240116 texte = texte + clientpack.Name + "::" + client.Name + " -> " + supplierpack.Name + "::" + supplier.Name;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                        catch (Exception)
                        {
                            // necessary for report: texte= " pas possible d'acceder a un connector de guid =" + getConGuid(con);
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                    }
                }
                // reportlog.Flush();
            }
        }
        }
    }
//----
        EA.Element GetIBOParent( EA.Repository repo,EA.Element elt)
        {
            EA.Element ret = null;
            foreach (EA.Connector con in elt.Connectors)
            {
                if (con.Type == "Dependency")
                {
                    if (con.ClientID == elt.ElementID)
                    {
                        try
                        {
                            ret = repo.GetElementByID(con.SupplierID);
                            return ret;
                        }
                        catch (Exception e)
                        {
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Error acces au repository pour un connexion de " + elt.Name + e.Message);
                        }

                    }
                }
            }
            return ret;
        }
///// <summary>
        /// build necessary dictionaries
        ///     dicElemByName
        /// </summary>
        public void buildDics(EA.Package pack,List<EA.Element> listelem)
        {
            dicElemByName = new Dictionary<string, ArrayList>();
            string prov = pack.Name + "::" + pack.Packages.Count.ToString();
            List<string> types=new List<string>();
            types.Add("Class");
            ManageIBOUtilitaires.getAllElementsByType(pack, listelem,types );
            bool eligible = false;
            CimSyntaxGen.XMLParser xmlp = new CimSyntaxGen.XMLParser(Main.Repo);
            string classificationstereotypes = xmlp.GetXmlValueProfData("ListStereoNamespace");
            List<string> cimstereotypes = ConstantDefinition.Cimstereos;
            if(!cimstereotypes.Contains(CD.GetPrimitiveStereotype()))cimstereotypes.Add(CD.GetPrimitiveStereotype());
            foreach (EA.Element el in listelem)
            {         
                 prov = el.Name; // pour test        
                string stereos = el.StereotypeEx;
                if (stereos == "") stereos = "Class";
                eligible = false;
                string[] split = stereos.Split(new char[]{','});
                foreach (string stereo in split)
                {
                    if (cimstereotypes.Contains(stereo) || classificationstereotypes.Contains(stereo))
                    {
                        eligible = true;
                        break;
                    }
                }
                if (eligible)
                {
                    if (dicElemByName.ContainsKey(el.Name))
                    {
                        dicElemByName[el.Name].Add(el);
                    }
                    else
                    {
                        ArrayList ar = new ArrayList();
                        ar.Add(el);
                        dicElemByName.Add(el.Name, ar);
                    }


                }
            }
        }

       //-----------------------------------
        public void buidDics(EA.Package pack)
        {
            dicElemByName = new Dictionary<string, ArrayList>();
            string prov = pack.Name + "::" + pack.Packages.Count.ToString();
            ManageIBOUtilitaires.getAllElements(pack, listelem, ConstantDefinition.Cimstereos);
            foreach (EA.Element el in listelem)
            {

                if (dicElemByName.ContainsKey(el.Name))
                {
                    dicElemByName[el.Name].Add(el);
                }
                else
                {
                    ArrayList ar = new ArrayList();
                    ar.Add(el);
                    dicElemByName.Add(el.Name, ar);
                }


            }
        }
//-------------------------------
//--------------

      long  getNewIdentifierID(string type) {
          long ret=-1;
          ArrayList ar=new ArrayList();
          if (dicElemByName.ContainsKey(type))
          {
              ar = dicElemByName[type];
              if (ar.Count == 1)
              {//ok
                  ret = ((EA.Element)(dicElemByName[type])[0]).ElementID;
              }
              else
              {
                  // there is more than one response
                  MessageBox.Show("there are more than one identifier  for identifier" + type);
                  ret = 0;
              }
          }
          else
          {// there is no identifier in the profiles
              if (type != "")
              {
                  EA.Collection col = null;
                  try
                  {
                      col = repo.GetElementsByQuery("Simple", type);
               
                  if (col.Count == 1)
                  {
                      ret = ((EA.Element)col.GetAt(0)).ElementID;
                  }
                  else
                  {
                      MessageBox.Show("there are no identifier '" + type + "' in the profile and more than one else where");
                      ret = 0;
                  }
                  }
                  catch (Exception e)
                  {
                      MessageBox.Show("warning for " + type + " " + e.Message);
                  }
              }
          }
          return ret;
      }
       //------------------
      long getPotentialIdentifierID(string type)
      {
          long ret = -1;
          ArrayList ar = new ArrayList();
          if (dicElemByName.ContainsKey(type))
          {
              ar = dicElemByName[type];
              if (ar.Count == 1)
              {//ok
                  ret = ((EA.Element)(dicElemByName[type])[0]).ElementID;
              }
              else
              {
                  // there is more than one response
                  MessageBox.Show("there are more than one identifier  for identifier" + type);
                  ret = 0;
              }
          }
          return ret;
      }
//----------------------------------
/// <summary>
/// recover each identifier for each attribute
/// in an element
/// </summary>
/// <param name="elt"></param>
     public  void RecoverIdentifier(EA.Element elt)
      {
          long identifier = 0;
          foreach (EA.Attribute atr in elt.Attributes)
          {
              string prov = elt.Name + "|" + atr.Name;
              identifier = getPotentialIdentifierID(atr.Type);
              if (identifier > 0)
              {
                  if (atr.ClassifierID != identifier)
                  {
                      atr.ClassifierID = (int)identifier;
                      atr.Update();
                      PrintLog(reportlog," new identifier " + repo.GetElementByID((int)identifier).Name + " for " + elt.Name + "." + atr.Name);
                  }
              }
              else
              {

                  if (identifier == 0)
                  {
                      MessageBox.Show(" problem with classifierID for " + elt.Name + "." + atr.Name);
                PrintLog(reportlog,"problem in trying to recover profile  classifierID for " + elt.Name + "." + atr.Name);
                  }
              }
          }
      }

//-----------------------
     public void PrintLog(TextWriter reportlog, string texte)
     {
         try
         {
             // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
         }catch(Exception e)
         {
             MessageBox.Show("error printlog " + e.Message);
         }
     }

//------------------------------------------------------------------------------
    }
}
