﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
using EA;
//using CimExportImport.manageIBO;
using CimSyntaxGen;
using CimSyntaxGen.manageIBO;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    /// this class will update the tagvalues GUIDBasedOn according to the dependency association (if it does not exists)
    /// the IsBasedOn dependency between classes
    /// </summary>
    class PrintPackageData
    {
        //18 public TextWriter reportlog=null; // to report details of recreation
        public StreamWriter reportlog = null; // to report details of recreation

       // public Dictionary<long, EA.Package> dicpackbyid; // packageid,package
       // public List<long> listpackids; // list of all packages in a given package
       // public Dictionary<long, List<long>> dicIBOpackbyid; // packageid, list of packageid (from which it depends)
        static EA.Package aPackage; // selected top package
        //public static List<EA.Element> ListElem = null; // list of all model elements
       // public static Dictionary<long, long> DicPackElem = null; // dictionay of all elements tied with package elemid/packid
        //public static Dictionary<string, List<long>> dicElems = null; // dictionnaire par nom et liste de ID
        EA.Repository repo;
    
        static public List<string> Cimstereos = new List<string>()
                                      {
	                                    "Class",
	                                    "Datatype",
                                        "Primitive",
	                                    "Compound",
	                                    "enumeration",
                                        "ACC",
                                        "ABIE",
                                        "MBIE",
                                        "Entsoe",
                                        "Shortcircuit",
                                        "Operation"
                                       };


        
/// <summary>
/// dele from a given package all <<IsBasedOn>> Dependency
/// </summary>
/// <param name="repository"></param>
       public PrintPackageData(EA.Repository repository)
        {
            repo = repository;
            //string texte = ""; // pour report
            ConstantDefinition constantes=new ConstantDefinition();
            string IBOtgv =constantes.GetIBOTagValue();
            aPackage = repository.GetTreeSelectedPackage();
              // reportlog=new StreamWriter("PrintPackageData.log"); //  the report  filePath
            reportlog = Main.reportlog; // report
           ManageIBOUtilitaires miboutilitaires=new ManageIBOUtilitaires (reportlog); 
            List<EA.Element> ElemList = new List<EA.Element>();
            CimSyntaxGen.XMLParser xmlp = new CimSyntaxGen.XMLParser(repository);
            string classificationstereotypes = xmlp.GetXmlValueProfData("ListStereoNamespace");
            List<string> cimstereotypes = ConstantDefinition.Cimstereos;
   
            ManageIBOUtilitaires.getAllElementsByType(aPackage, ElemList, new List<string>(){"Class"});

           ConstantDefinition CD=new ConstantDefinition();
           if (!cimstereotypes.Contains(CD.GetPrimitiveStereotype())) cimstereotypes.Add(CD.GetPrimitiveStereotype());

           //Dictionary<long, EA.Package> dicpackbyid = new Dictionary<long, EA.Package>();
            //CimSyntaxGen.RDFutilitaires.buildDicrepobyid(repo, dicpackbyid);
            /******** pour test *************/
           // EA.Package patest = GetPackagebyName(repo, dicpackbyid, aPackage.Name);
          //  miboutilitaires.PrintIBOElements(repo,patest);

             

            /*****************************************************/
            
            miboutilitaires.PrintIBOElements(repo, aPackage);

        }
       /// <summary>
       /// obtient le premier package ayant un nom donne
       /// </summary>
       EA.Package GetPackagebyName(EA.Repository repo, Dictionary<long, EA.Package> dicpackbyid, string paname)
       {
           EA.Package ret = null;
           foreach (EA.Package pa in dicpackbyid.Values)
           {
               if (pa.Name == paname)
               {
                   ret = pa;
                   break;
               }
           }
           return ret;

       }

//- - - - - - - - - - - - - - - - - - - - - 
    }
}
