using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
//using CimExportImport.manageIBO;
using CimSyntaxGen;
using CimSyntaxGen.manageIBO;
using EA;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
/* L'algorithme pour recrer le IsBasedOn est le suivant:
 On se base sur le nom des elements et sur les relations de dependance des packages 
un package est selectionne dans l'arborescense package
on descend la hierarchie des packages
un package est soit "IsBasedon" un package soit compris dans un package lui-meme "IsBasedOn" un autre package. (dans ce cas il peut ete "IsBasedOn" e n'importe lequel des elements du package meme compris dans un sous package
   
on associe  chacun des elements de ce package les packages dont il est potentiellement "IsBasedOn"
alors l'algorithme est le  suivant
pour chaque elements du package selectionne
reduire son nom e l'element principal (e droite de 'undescore)
rechercher tous les elements de meme type des packages dont il peut dependre portant ce nom
   une classe peut dependre d'une classe , un datatype d'un Primitive ou Datatype, un Enumeration d'un Primitive ou Enumeration, un Compound d'un Compound
si on trouve un seul nom on cree dans l'element la tagvalue GUIDBasedOn avec le GUID de cet element du package  trouve dans l'element
si on trouve plusieur noms on cree dans l'elemnt une tagvalue GUIDBasedOn vide et on ecrit dans le rapport un conflit avec les noms possibles e resoudre manuellement (ulterieurement on pourra creer un dialogue correspondant)

*/

	


    class RecreateIBO
    {
       	public StreamWriter   reportlog; // to report details of recreation

	public   Dictionary<long,EA.Package>  dicpackbyid; // packageid,package
    public List<long> listpackids; // list of all packages in a given package
    public   Dictionary<long,List<long>>  dicIBOpackbyid; // packageid, list of packageid (from which it depends)
	static EA.Package aPackage; // selected top package
     public    static List<EA.Element> ListElem = null; // list of all model elements
        public static Dictionary<long,long> DicPackElem =null; // dictionay of all elements tied with package elemid/packid
     public static Dictionary<string,List<long>> dicElems=null; // dictionnaire par nom et liste de ID
	EA.Repository repo;
    public static List<long> condejatraite=null;
   public static Dictionary<long,List<long>> dicLinks=null; // links of an element elid /liste de elid
    
	static public  List<string> Cimstereos = new List<string>()
                                      {
	                                    "Class",
	                                    "Datatype",
                                        "Primitive",
	                                    "Compound",
	                                    "enumeration",
                                        "ACC",
                                        "ABIE",
                                        "MBIE",
                                       };

    static public string selectedobject; // selected objectto chose in case of conflict of names


//----------------------------------------------------------
       /// <summary>
       /// constructor
       /// </summary>
       /// <param name="repository"></param>
        public  RecreateIBO(EA.Repository repository,EA.Package SelectedPackage)
        {
	repo=repository;
    ManageIBOUtilitaires.repo = repository;
    
    //string texte = ""; // pour report
	dicpackbyid =new  Dictionary<long,EA.Package>();
    listpackids = new List<long>();
        condejatraite = new List<long>(); // conectorids
        dicIBOpackbyid =new Dictionary<long,List<long>>(); // ElementID,PackageID
        aPackage = SelectedPackage; // repository.GetTreeSelectedPackage();
      //18  reportlog = new StreamWriter("recreationIBO.txt"); //  the report  filePath.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen)
        reportlog = Main.reportlog; //  the report  
       buildDicPackElem(repo);
       buildElemList(repo);	
    // debut de l'algorithme
     // on verifie que lz package est IsBasedOn 
       EA.Element elempac = aPackage.Element;
      
       bool isbased = false;
       if ((elempac.Connectors.Count != 0))
       {
           foreach (EA.Connector con in elempac.Connectors)
           {
               if (((con.Type == "Dependency") && (con.Stereotype == "IsBasedOn")))
               {
                   isbased = true;
               }
           }
       }
       if (!isbased)
       {
           MessageBox.Show(" Did you forgot to link your package with an 'IsBasedOn' dependency?");
           // if(Main.DO_REPORTLOG) reportlog.WriteLine(" there is no IsBasedOn dependency with package: " + aPackage.Name + DateTime.Now);
           reportlog.Close();
           return;
       }
       List<EA.Element> EList= new List<EA.Element>();
        getAllElements(aPackage, EList, "all");
        builddicIBOpackid(listpackids);
            /*****************  pour test *********************************
        texte = " Test de construction des dictionnaires ";
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
          DumpList(listpackids, "packid");// pour test
        // DumpdicIBOpackbyid();// pour test
          DumpList(EList, "eltid");
         ******************************************************************/
        List<EA.Element> EligibleEltList = new List<EA.Element>();
    	 foreach(EA.Element elt in EList){ 
             
		if(getType(elt) == "") continue; //not an eleigible element
             
             if(!EligibleEltList.Contains(elt)) EligibleEltList.Add(elt);
              
		traitelement(elt);
         }
            /****************************************************************/
            //-----------  treatment of all  connectors --------------------------------//
         condejatraite = new List<long>();
         foreach (EA.Element elt in EligibleEltList)
         {
           
            traitElConnectors(elt); // we have to do it after all elements have been ttreated
                                  // in order to be sure that all IBO dependencies are in place
	
         }
                  /***************************************************/
         // reportlog.Flush();
        //18  reportlog.Close();
       }  
     	   /// retrieves recursively elements with a given stereotype or all elements
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public  List<EA.Element>  getAllElements(EA.Package package, List<EA.Element> resultList, String stereotype)
        {
            string inter;
            if (stereotype == "all") // building of package containement
            {
                if (!dicpackbyid.ContainsKey(package.PackageID))
                {
                    dicpackbyid.Add(package.PackageID, package);
                    string prov = package.Name;
                    listpackids.Add(package.PackageID);

                }
            }
            foreach (EA.Element e in package.Elements)
            {
                inter = e.Stereotype;
                if (e.Stereotype.Equals(stereotype) || e.Stereotype == "" || stereotype == "all")
                {
                    resultList.Add(e);
                }
                
            }
            foreach (EA.Package p in package.Packages)
            {
               getAllElements(p, resultList, stereotype);
            }
          return resultList;
        }

        public static List<EA.Element> getAllElements(EA.Package package, List<EA.Element> resultList)
        {

            foreach (EA.Element e in package.Elements)
            {
                if (e == null) MessageBox.Show("un element est nul");
                if (!resultList.Contains(e)) resultList.Add(e);

            }
            foreach (EA.Package p in package.Packages)
            {
                getAllElements(p, resultList);
            }
            return resultList;
        }

/// <summary>
/// get the type of element
/// </summary>
/// <param name="el"></param>
/// <returns></returns>
      string getType(EA.Element el){
          /****** pour Test ***************/
          string texte="Element:="+ el.Name + " type=" + el.Type + " stereoex=" + el.StereotypeEx ;
          // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
         // MessageBox.Show(texte);
          /*******************************/
       string cas="";
	foreach(string ss in Cimstereos){
        if (el.StereotypeEx.Contains(ss))
        {
                     cas = ss;
         
		break;
		}
		}
	if(  (cas=="") && (el.Type=="Class") ){
       cas="Class";
	}
    if (el.Name == "") cas = "";
	return cas;
	}

/// <summary>
/// building the dictionary dicIBOpackid
/// </summary>
/// <param name="repo"></param>
/// <param name="packids"></param>
     void builddicIBOpackid(List<long> packids){

    
		//List <long> IBOids; // list of packages isBasedOn
  
		foreach(long packid in packids){
		
		dicIBOpackbyid.Add(packid,GetIsbasedOnPackids(packid));
                    }
		}

        /// <summary>
        /// report a problem
        /// </summary>
        /// <param name="el"></param>
        ///  <param name="reason"></param>
       void PrintProblem(EA.Element el,string reason){ // print some report about the problem
      string tab="\t";
          

	}
        /// <summary>
        /// find a list of all packages
        /// to which a package is Basedon 
        /// by ascending the "isbasedOn" hierarchy
        /// // and stopping as soon as a parent package is basedon a set of other packages
        /// including onself
        /// </summary>
       List<long> GetIsbasedOnPackids(long packid)
       {
     
           List<long> IBOids = new List<long>();
           EA.Package pack = repo.GetPackageByID((int)packid);
           string prov = pack.Name;  // pour test
           try
           {   
               List<long> packids= new List<long>(); // list of packages id
               foreach (EA.Connector con in pack.Connectors)
               {
                   if ((con.Type == "Dependency") 
                       && (con.Stereotype == "IsBasedOn")
                       && (pack.Element.ElementID != con.SupplierID)) //only up  dependency         
                   {
                      // EA.Element elforpa= repo.GetElementByID(con.SupplierID);
            
                       long packagid = DicPackElem[con.SupplierID];
             prov = repo.GetPackageByID((int)packagid).Name; // pour test
                       if (!IBOids.Contains(packagid)) {
				IBOids.Add(packagid);
                getAllNonBasedOnPackages(repo.GetPackageByID((int)packagid), packids);

			}
              }
               }
        
                  
			foreach(long pid in packids){
			if(!IBOids.Contains(pid)) IBOids.Add(pid);
			}		
               if (IBOids.Count != 0)
               {//a Package package with isbasedon dependency has been reached
		
                   return IBOids;
               }
               //there is no direct dependency
               // ascend the hierarchy isBesedOn to find a dependant package
               if (pack.ParentID != 0)
               {
                   IBOids = GetIsbasedOnPackids(pack.ParentID); // recursive call to the methods 
               }
           }
           catch (Exception e)
           {
               MessageBox.Show("Pb in build dependencies " + e.Message);
           }
           /*******pour test ******************************/
           string texte = "";
           texte=" Dump de la liste   IBOids pour le package" + packid.ToString() + " name=" + repo.GetPackageByID((int)packid).Name;
           // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
           DumpList(IBOids, "packid");
           /***********************************************/
        return IBOids;
       }


   static public void buildElemList(EA.Repository repo){	
          EA.Collection modellist;
                modellist = repo.Models;
                EA.Package toppack;
                toppack = null;
                foreach (EA.Package mod in modellist)
                {
                    toppack = mod;  // the root package
                }
		
		if(dicElems == null){// the dictionary does not exist yet

            dicElems = new Dictionary<string, List<long>>();
		
		List<EA.Element> listelems =new List<EA.Element>();
               getAllElements(toppack,listelems);
               foreach(EA.Element el in listelems){
                   if (el == null) MessageBox.Show("un element de listelems est nul");// pour test
                        string cas="";
	                foreach(string ss in Cimstereos){	
              if(el.StereotypeEx.Contains(ss)){
		            cas=ss;
		            break;
		        }
		            }
	        if(  (cas=="") && (el.Type=="Class") ){
           cas="Class";
	        }
             if(cas != ""){
                 
                 if (el.Name != "")
                 {
                     string name =el.Name;
                     if(!dicElems.ContainsKey(name)){
                     List<long> gids= new List<long>();
                     dicElems.Add(name,gids);    
                     }

                     List<long> ll = dicElems[name];
                     if (!ll.Contains(el.ElementID))
                     {
                         ll.Add(el.ElementID);
                         dicElems[name] = ll;
                     }
                 }
			}
		}
		
		}
		}
        /// <summary>
        /// apply treatment for a Class
        /// </summary>
        /// <param name="el"></param>
   void traitelement(EA.Element el)
   {
 
       string name = "";
       string texte = "";
       string problem = "";
       EA.TaggedValue tagv = null;
       ConstantDefinition constantes = new ConstantDefinition();


       /*********** pour test **************/
       texte = "Appel fonction traitelement avec " + repo.GetPackageByID(el.PackageID).Name + "::" + el.Name;
       // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
       /************************************/


       //long packid=el.PackageID;
	List<long> possiblepackages=dicIBOpackbyid[el.PackageID];// the hierarchy of package on which this package is based
      
    name = el.Name;
       List<long> elements = null;
	List<EA.Element> EligibleElements=new List<EA.Element>();
       try
       {
	     
           if(dicElems.ContainsKey(name)) elements = dicElems[name]; // search of elligible elements by their name
       }
       catch (Exception e)
       {
           MessageBox.Show("PB in searching " + name + "  " + e.Message);
       }
       //string problem = "there is more than one eligible element with the same root name"; // if there is no problem or conflict to be reported
       EA.Element elt = null;
   
 	if(elements.Count > 0){
       foreach(long gid in elements){
           elt= repo.GetElementByID((int)gid);
           if (dicIBOpackbyid[el.PackageID].Count != 0)
           {
               if (dicIBOpackbyid[el.PackageID].Contains(elt.PackageID))
               {
		if(el.ElementID != elt.ElementID) EligibleElements.Add(elt);
		}
           }
	}
	}
    if (EligibleElements.Count == 0)
    {// search elements with name without qualifier
        
        name = ManageIBOUtilitaires.removequalifier(name);
        if (dicElems.ContainsKey(name)) elements = dicElems[name];
        if (elements.Count > 0)
        {
            foreach (long gid in elements)
            {
                elt = repo.GetElementByID((int)gid);
                if (dicIBOpackbyid[el.PackageID].Count != 0)
                {
                    if (dicIBOpackbyid[el.PackageID].Contains(elt.PackageID))
                    {
                        EligibleElements.Add(elt);
                    }
                }
            }
        }

    }
    if (EligibleElements.Count == 1)
    {
        foreach(EA.Element ell in EligibleElements){
            elt=ell;
        }
	problem="";
        texte = "create tag value for element=" + el.Name + " in '" + repo.GetPackageByID(el.PackageID).Name;
        texte=texte+  "' from element=" + elt.Name + " in '" + repo.GetPackageByID(elt.PackageID).Name ;
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte); // for test
        // the package of the element is based on the the pacjkage of the found element
        /****************************************************
         foreach (EA.TaggedValue tag in el.TaggedValues)
         {
             texte = "tag value of element=" + el.Name + "=> " + tag.Name + "," + tag.Value ;
             // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte); // for test
         }
         ****************************************************/
        try
        {

            tagv = (EA.TaggedValue)el.TaggedValues.AddNew(constantes.GetIBOTagValue(), elt.ElementGUID);
            tagv.Update(); // NE PAS OUBLIER
            //el.Update();
            el.TaggedValues.Refresh();
            //MessageBox.Show("lastrefresh error on taggedvalues an nb of tags " + el.TaggedValues.GetLastError().ToString() + "|" + el.TaggedValues.Count.ToString());
            el.Refresh();
            el.Update();
            //-----------  treatment of all attributes --------------------------------//
            Dictionary<string, EA.Attribute> dicatrname = new Dictionary<string, EA.Attribute>(); // atr.name/atr
            foreach (EA.Attribute at in elt.Attributes)
            {
                if(!dicatrname.ContainsKey(at.Name)){
                    dicatrname.Add(at.Name, at);
                }else{
                    problem="There are at least two attributes with the same name in" + repo.GetPackageByID(elt.PackageID).Name + "::" + elt.Name;
                break;
                }
            }
            EA.AttributeTag attag=null;
            foreach (EA.Attribute atr in el.Attributes)
            {
                if(dicatrname.ContainsKey(atr.Name) ){
                    attag=(EA.AttributeTag)atr.TaggedValues.AddNew(constantes.GetIBOTagValue(),dicatrname[atr.Name].AttributeGUID);
                    attag.Update();
                    atr.TaggedValues.Refresh();
                    atr.Update();
                    el.Update();
                }else{
                    problem=problem="the attribute of name "+ atr.Name + " in " + repo.GetPackageByID(el.PackageID).Name + "::" + el.Name + " has no correspondant in " +
                repo.GetPackageByID(elt.PackageID).Name + "::" + elt.Name;
                    break;  // no reason to continue
                }
                }

            
            }
        
        catch (Exception e)
        {
            MessageBox.Show("Error insert tag" + e.Message);
	problem="Error insert tag" + e.Message;
        }

        // MessageBox.Show("result de el.update:" + (el.Update()).ToString());
        /******************* pour test ***************************
            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                texte = "relecture apres refresh et el.update tag value of element=" + el.Name + "=> " + tag.Name + "," + tag.Value;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte); // for test
            }
         **********************************************************/
    

      
 

    }
    else
    {
	if(EligibleElements.Count == 0){
	problem="there is no possible IBOparent for " + repo.GetPackageByID(el.PackageID).Name +"::" + el.Name;
       MessageBox.Show("WARNING " + problem);
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Dump of the list of possible parent elements for the element " +  repo.GetPackageByID(el.PackageID).Name +"::" + el.Name);
	}else{
        
        
       problem="there is more than on possible IBOparent for " + repo.GetPackageByID(el.PackageID).Name +"::" + el.Name ;
       MessageBox.Show("WARNING " + problem);
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(" Dump of the list of possible parent elements for the element " +  repo.GetPackageByID(el.PackageID).Name +"::" + el.Name);
        DumpList(EligibleElements, "guid");
        // choice of one of the possible element
        DialMultipleRef dialog = new DialMultipleRef();

        // Sets up the initial objects in the CheckedListBox.
        string[] elementnames = new string[100];// a priori   
        //EA.Element ell=null;
        Dictionary<string,string> dicSelectedObjectGuid=new Dictionary<string,string>();// gives the guid associated cith the selected line
        int i=0;
        EA.Package parentpack = null;
        foreach (EA.Element ellt in  EligibleElements)
        {
         parentpack = (EA.Package)repo.GetPackageByID(ellt.PackageID);

            elementnames[i] = parentpack.Name + "::" + ellt.Name;
            dicSelectedObjectGuid.Add(elementnames[i],ellt.ElementGUID);
          i++;
        }

        if (elementnames.Length > 0)
        {
            int dim = Array.IndexOf(elementnames, null);
            if (dim > 0)
            {
                Array.Resize(ref elementnames, dim);

                dialog.dialbox.Items.AddRange(elementnames);
            }
        }

        dialog.ShowDialog();
        dialog.Dispose(); // ABA20230730
        tagv = (EA.TaggedValue)el.TaggedValues.AddNew("GUIDBasedOn", dicSelectedObjectGuid[selectedobject]);
        tagv.Update(); // NE PAS OUBLIER
        //el.Update();
        el.TaggedValues.Refresh();
        //MessageBox.Show("lastrefresh error on taggedvalues an nb of tags " + el.TaggedValues.GetLastError().ToString() + "|" + el.TaggedValues.Count.ToString());
        el.Refresh();
        el.Update();

       }
    }


       if (problem != "")
       { // a problem has to be reported
           PrintProblem(el,problem);
       }
   }
        /// <summary>
        /// treat ment of all conectoors of an element
        /// a connector must be of type association or aggregation or generalisation
        /// if the class is basedon 
        /// we find the otherend element
        /// the we get ist IBO parent which must be in the same relationship with the IBO parent of this element.
        /// this applied only for classes
        /// </summary>
        /// <param name="el"></param>
        void traitElConnectors(EA.Element el)
          {
           
 
       //string name = "";
       string texte = "";
       ConstantDefinition constantes = new ConstantDefinition();
            if(//(el.Type=="Class")  &&
                                   (el.StereotypeEx!=constantes.GetDatatypeStereotype())
                                   &&  (el.StereotypeEx != constantes.GetCompoundStereotype())
                                   &&  (el.StereotypeEx !=constantes.GetEnumStereotype())
                                   && (el.StereotypeEx !=constantes.GetPrimitiveStereotype())){
            
            // this is a legitimate class
                                       string IBOguid = "";
                                       EA.ConnectorTag contag = null;
                foreach(EA.Connector con in el.Connectors){
                    if (!condejatraite.Contains(con.ConnectorID))
                    {
                        condejatraite.Add(con.ConnectorID);
                    IBOguid = LegitimateCon(el, con);
                    if (IBOguid != "")
                    {
                        contag = (EA.ConnectorTag)con.TaggedValues.AddNew(constantes.GetIBOTagValue(), IBOguid);
                        contag.Update();
                        el.Connectors.Refresh();
                        el.Update();
                        el.Refresh();
                        /**********   pour test ***********************/
                        texte = "creation tag  GUID for connector ID " + con.ConnectorID.ToString() + "between" + repo.GetElementByID(con.ClientID).Name + " and " + repo.GetElementByID(con.SupplierID).Name;
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        /**********************************************/
                    }
                    else
                    {
                      
                       string problem = "there is a problem in adding a conector tagvalue" ;
                        PrintProblem(el, problem);
                    }
                }
                }
            }
           }
       /// <summary>
        /// get all packages of an eligible base package 
       /// which are not themselves basedon another package 
        /// </summary>
        /// <param name="pack"></param>
    void getAllNonBasedOnPackages(EA.Package pack,List<long> listpackid){
        /***********pour test *******************
        string texte = " Appel getAllNonBasedOnPackages pour pack " + pack.PackageID.ToString() + "," + pack.Name;
        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        DumpList(listpackid, "packid");
        
        ****************************************/
            foreach(EA.Package pa  in pack.Packages){
                bool ok = true;
		     foreach(EA.Connector con in pa.Connectors){
                      if((con.Type=="Dependency") && (con.StereotypeEx.Contains("IsBasedOn"))){
                       ok=false; // this package is not eligible
                       break;
				}
			}
		   if(ok) {
		listpackid.Add(pa.PackageID);
        getAllNonBasedOnPackages(pa,listpackid);
			}
			}
    
		}
        /// <summary>
        /// dump one dictionary
        /// </summary>
        /// <param name="dic"></param>
    void DumpdicIBOpackbyid()
    {
        foreach (long k in dicIBOpackbyid.Keys)
        {
            DumpList(dicIBOpackbyid[k], "packid");
        }
        // reportlog.Flush();
    }

/// <summary>
/// dump de liste
/// </summary>
/// <param name="liste"></param>
/// <param name="type">
/// "packid"  pour Packages
/// "eltid"   pour elements
/// </param>
    void DumpList(List<long> liste, string type)
    {

        string texte = "";
        texte = liste.ToString();
        //// if(Main.DO_REPORTLOG) reportlog.WriteLine("Dump liste " + liste);
         switch(type){
             case "packid":
        foreach(long ll in liste){
            texte = "\t" + type + "=" + ll.ToString() + "\tname=" + repo.GetPackageByID((int)ll).Name;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
        }
                 break;
             case "eltid":
                 foreach (long ll in liste)
                 {
                     texte = "\t" + type + "=" + ll.ToString() + "\tname=" + repo.GetElementByID((int)ll).Name;
                     // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                 }
                 break;
             case "string":
           
                 break;
             default:
              break;
    }
    }
    /// <summary>
    /// dump de liste elements
    /// </summary>
    /// <param name="liste"></param>
    /// <param name="type">
    /// "packid"  pour Packages
    /// "eltid"   pour elements
    /// </param>
    void DumpList(List<EA.Element> liste, string type)
    {
        string texte = "";
        switch (type)
        {
  
            case "eltid":
                foreach (EA.Element ll in liste)
                {
                    texte = "\t" + type + "=" + ll.ElementID.ToString() + "\tname=" + repo.GetPackageByID(ll.PackageID).Name + "::" + ll.Name;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                break;
            case "guid":
                foreach (EA.Element ll in liste)
                {

                    texte = "\t" + type + "=" + ll.ElementID.ToString() + "\tname=" + repo.GetPackageByID(ll.PackageID).Name + "::" + ll.Name + " guid=" + ll.ElementGUID;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                break;
            case "string":

                break;
            default:
                break;
        }
    }
        /// <summary>
        /// build dictionary
        /// </summary>
        /// <param name="repo"></param>
    public static void buildDicPackElem(EA.Repository repo)
    {
        EA.Collection modellist;
        modellist = repo.Models;
        EA.Package toppack;
        toppack = null;
        foreach (EA.Package mod in modellist)
        {
            toppack = mod;  // the root package
        }

        if (DicPackElem == null)
        {// the dictionary does not exist yet
            DicPackElem = new Dictionary<long,long>();
            List<EA.Package> listpack = new List<EA.Package>();
            getAllPackages(toppack, listpack);
            foreach (EA.Package pa in listpack)
            {
                if(pa.Element!=null){
                    long elid=pa.Element.ElementID;
                    string prov = pa.Element.Name + "|" + pa.Name; // pour test
                if(!DicPackElem.ContainsKey(elid)) DicPackElem.Add(elid, pa.PackageID);
            }

            }

        }
    }

        /// <summary>
        /// collect all internal packages of a package
        /// </summary>
        /// <param name="package"></param>
        /// <param name="resultList"></param>
        /// <returns></returns>
       public static List<EA.Package>  getAllPackages(EA.Package package, List<EA.Package> resultList)
        {
            string prov;
            // // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-1 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
	         if(!resultList.Contains(package))
             {
                 prov = package.Name;   
                 resultList.Add(package);
            //     // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-2 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
             }
             foreach (EA.Package pack in package.Packages)
             {
              //   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-3 " + pack.Name + " | " + pack.PackageID + "| count " + resultList.Count);
                 if (!resultList.Contains(pack))
                 {

                     prov = pack.Name;
                     resultList.Add(pack);
               //      // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-4 " + pack.Name + " | " + pack.PackageID + "| count " + resultList.Count);
                 }
             }
                
            
            foreach (EA.Package p in package.Packages)
            {
              //  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-5 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
               getAllPackages(p, resultList);
           //    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-6 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
            }
          return resultList;
        }
        /// <summary>
        /// get the id of the otherend element in a connection
        /// </summary>
        /// <param name="el"></param>
        /// <param name="Con"></param>
        /// <returns></returns>
     string LegitimateCon(EA.Element el, EA.Connector con){
           string guid="";
           EA.Element theotherend;
           EA.Element thisendparent;
           try
           {
               string prov = con.ConnectorID.ToString();
               theotherend = ManageIBOUtilitaires.getTheotherend(el, con);
               /********* pour test ****************/
               string texte = " Legitimate " + repo.GetPackageByID(el.PackageID).Name + "::" + el.Name;
               texte = texte + " theotherend " + repo.GetPackageByID(theotherend.PackageID).Name + "::" + theotherend.Name ;
               // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
               /************************************/
               string pguid = ManageIBOUtilitaires.getParentGuid(el);
               if (pguid == "") return pguid;
               thisendparent = repo.GetElementByGuid(pguid);
               pguid = ManageIBOUtilitaires.getParentGuid(theotherend);
               if (pguid == "") return pguid;
               // theotherendparent = repo.GetElementByGuid(pguid);

               foreach (EA.Connector conn in thisendparent.Connectors)
               {
                   if (ManageIBOUtilitaires.getTheotherend(thisendparent, conn).ElementGUID == pguid)
                   {
                       guid = conn.ConnectorGUID;
                       //return guid;
                       break;
                   }

               }
           }
           catch (Exception e)
           {
               MessageBox.Show(e.Message);
           }
            return guid;
        }
/// <summary>
/// get the parent IBO guid
/// of an element
/// </summary>
/// <param name="elt"></param>
/// <returns>guid or ""</returns>
   
        /// <summary>
        /// get the otherend of a connexion
        /// from an element
        /// </summary>
        /// <param name="el"></param>
        /// <param name="con"></param>
        /// <returns></returns>
  
//------------------------------------------------------------
    }
}
