﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
//using CimExportImport;
using EA;
//using CimExportImport.manageIBO;
using CimSyntaxGen;
using CimSyntaxGen.manageIBO;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    /// this class will create (if it does not exists)
    /// the IsBasedOn dependency betweel classes according tho the tag value
    /// GUIDBasedOn found in the class
    /// </summary>
    public class WithIBODependency
    {
        //18 public TextWriter reportlog=null; // to report details of recreation
        public StreamWriter reportlog = null; // to report details of recreation

       // public Dictionary<long, EA.Package> dicpackbyid; // packageid,package
       // public List<long> listpackids; // list of all packages in a given package
       // public Dictionary<long, List<long>> dicIBOpackbyid; // packageid, list of packageid (from which it depends)
        static EA.Package aPackage; // selected top package
        //public static List<EA.Element> ListElem = null; // list of all model elements
       // public static Dictionary<long, long> DicPackElem = null; // dictionay of all elements tied with package elemid/packid
        //public static Dictionary<string, List<long>> dicElems = null; // dictionnaire par nom et liste de ID
        EA.Repository repo;
    
        static public List<string> Cimstereos = new List<string>()
                                      {
	                                    "Class",
	                                    "Datatype",
                                        "Primitive",
	                                    "Compound",
	                                    "enumeration",
                                        "ACC",
                                        "ABIE",
                                        "MBIE",
                                       };

        ConstantDefinition constantes = new ConstantDefinition();
        

        public WithIBODependency(EA.Repository repository)
        {
            repo = repository;
            string texte = ""; // pour report
           
            string IBOtgv =constantes.GetIBOTagValue();
            aPackage = repository.GetTreeSelectedPackage();
         //   reportlog=new StreamWriter("WithIBODependency.txt"); //  the report  filePath
            reportlog = Main.reportlog;
            ManageIBOUtilitaires miboutilitaires=new ManageIBOUtilitaires (reportlog); 
            List<EA.Element> ElemList = new List<EA.Element>();
            //ManageIBOUtilitaires.getAllElements(aPackage, ElemList, Cimstereos);
            ManageIBOUtilitaires.getAllElementsByType(aPackage, ElemList, new List<string> { "Class" });
            EA.TaggedValue tgvfrom = null;
            //EA.TaggedValue tgvto = null;
            texte = "============================================================";
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);

            texte = " recreer les données IBO (les tagvalues sont positionnees) " + DateTime.Now;
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            texte = "===========================================================";
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
            // reportlog.Flush();

            foreach (EA.Element el in ElemList)
            {
                string  prov = el.Name;
                try
                {
                    tgvfrom = (EA.TaggedValue)el.TaggedValues.GetByName(IBOtgv);
                   
                }
                catch (Exception e)
                {
                    MessageBox.Show("Warning there is an error with  IBO tabvalue for element " + el.Name
                            + "  are you should you build your profile with CimSyntaxGen?");
                    tgvfrom = null;
                    MessageBox.Show(e.Message);
                }
                if (tgvfrom != null)
                {// thereis a baseddon element
                    texte = "  element " + repository.GetPackageByID(el.PackageID).Name + "::" + el.Name;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    // reportlog.Flush();
                    /***********  pour test
                    if (el.Name == "MarketRole")
                    {
                        string prov = "";
                    }
                     ************/
                      
                    if (!thereisIBODependency(el))
                    {
                        EA.Connector con = (EA.Connector)el.Connectors.AddNew("", "Dependency");
                        con.ClientID = el.ElementID;
                        try
                        {
                            EA.Element eltbase = repo.GetElementByGuid(tgvfrom.Value);
                            // ABA20240116 texte = " association  avec element parent " + repo.GetPackageByID(eltbase.PackageID).Name + "::" + eltbase.Name;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            // reportlog.Flush();
                            con.SupplierID = eltbase.ElementID;

                            con.Stereotype = constantes.GetIsBasedOnStereotype();
                            con.Update();
                            el.Connectors.Refresh();
                            el.Update();
                        }
                        catch (Exception e)
                        {
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error" + e);
                            // reportlog.Flush();
                        }
                    }
                }
            }
            

        }
        /// <summary>
        /// teste si il y a deja un lien IsBasedOn 
        /// </summary>
        bool thereisIBODependency(EA.Element  el)
        {
            bool resul = false;
            foreach (EA.Connector con in el.Connectors)
            {
                if((con.Type=="Dependency") &&   (con.Stereotype == constantes.GetIsBasedOnStereotype()))
                {
                    if (con.ClientID == el.ElementID)
                    {
                        resul = true;
                        break;
                    }
                }
            }
            return resul;
        }
  
//- - - - - - - - - - - - - - - - - - - - - 
    }
}
