using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Xml.XPath;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using System.Diagnostics;
using System.Threading;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.10.3                                     *    december 2021 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/

namespace CimSyntaxGen
{

    public class MesurePerf
    {
        
        

        static public TextWriter fluxdata;

         public  static EA.Repository Repos;
        
        public static Ta td = new Ta(); //am 2021 pour analyse du temps
        public static long ConexesID;
        public MesurePerf()
        {
            /* ABA20230301
            string filepath = ".";// System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString);
            if (!System.IO.File.Exists(filepath + "\\" + "CimSyntaxgen-Config.xml"))
            {
                filepath = Environment.GetEnvironmentVariable("APPDATA");// am march  2017
            }
            */
            string fluxpath = FileManager.GetParentDirPath() + "\\flux.log";
            fluxdata = new StreamWriter(fluxpath);
        }
        

        /**************************************************************************/
       
        public  void PackageMesurePerf()
        {
            td.start("MesurePerf");
            td.elapsetime("MesurePerf");
            Repos = Main.Repo;
            try
            {

                EA.Package pa = Main.Repo.GetTreeSelectedPackage();

                td.elapsetime("start loop on elements");
                foreach (EA.Element nel in pa.Elements)
                {
                    if (nel.Name == "") continue;
                    td.elapsetime(String.Format("start loop on attributes for {0}",nel.Name));
                    foreach (EA.Attribute atr in nel.Attributes)
                    {
                        fluxdata.WriteLine(String.Format("Attribute {0}.{1}", atr.Name, nel.Name));

                    }
                    td.elapsetime(String.Format("end loop on attributes for {0}", nel.Name));
                    td.elapsetime(String.Format("start loop on connectors for {0}", nel.Name));
                    foreach (EA.Connector con in nel.Connectors)
                    {
                        if (con.Type != "Association") continue;

                        EA.Element client = Repos.GetElementByID((int)con.ClientID);
                        EA.Element supplier = Repos.GetElementByID((int)con.SupplierID);
                        fluxdata.WriteLine(String.Format("Connector client={0} supplier={0} ", client.Name, supplier.Name));
                    }
                    td.elapsetime(String.Format("end loop on connectors for {0}", nel.Name));
                }
                td.elapsetime("end loop on elements");
                
                td.elapsetime("MesurePerf");
                fluxdata.Flush();
                fluxdata.Close();
                    td.stop();
                    td.quit();

            }
            catch(Exception ee)
            {
                Console.WriteLine("Error " + ee.Message);
            }
        }
        //--------------------------------------------
//--------------------------------------------------------
     

    }
}



