/*******************************************************************************
Ce fichier est un ensmble de programes pour produire un fichier RDF selon l'agorithme du document CEI61970-501

Attention on supposNS ici qu'il n'y a qu'un niveau de package:
 on itere sur les classes a un niveau de package
*******************************************************************************/
using EA;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Windows.Forms;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                      * november 2020  * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen

{
    class RDFLAutilitaires 
    {
 
         
 public static volatile bool ongoing = true; // tells after each message if we should continue to generate
 public static EA.Repository repository;
 static public StreamWriter reportlog; // to report details of generation
 public static Dictionary<long,EA.Element>  dicelembyid =new  Dictionary<long,EA.Element>();
 public static Dictionary<string,EA.Element>  dicelembyname =new  Dictionary<string,EA.Element>();
 public static ConstantDefinition CD = new ConstantDefinition();
 public static Dictionary<long, EA.Element> dicdatabyid = new Dictionary<long, EA.Element>();
 public static Dictionary<string, EA.Element> dicdatabyname = new Dictionary<string, EA.Element>();
 //public static XMLParser XMLP = new XMLParser();
 public static Dictionary<long,EA.Package>  dicpackbyid =new  Dictionary<long,EA.Package>();
 public static Dictionary<long,EA.Package>  dicrepobyid =new  Dictionary<long,EA.Package>();
 public static Dictionary<long, List<long>> dicconstbycon = new Dictionary<long,List<long>>(); // dic of const elements attached to a connector
 
public List<long> dejatraite ; 
 public List<long> datatypedone;
public string NS_J0;
XMLProfileParameters profparameters;
public  static Dictionary<string, string> namespaces = new Dictionary<string, string>();  //string/uri
public static Dictionary<string, Dictionary<string, bool>> newindstereos; // indicateurs de selections de stereotype pour les editions
 public struct Nomrole
 {
     public long elemid;
     public string rolename;
     
 }
 public List<Nomrole> nomsRoles; // for avoiding duplication of roles name
        internal static bool DEBUG;
        static List<EA.Element> elements=new List<EA.Element>();
        public static List<string> LocalClassNames;
	public List<string> NoDoublons;
       public  List<string> LocalDatatypeNames;
       public  List<long> LocalDatatypeIDs;
    private  string datatypepackagename;
    public string DatatypePackageName { get { return datatypepackagename; } set { datatypepackagename = value; } }
        private EA.Repository repo;
        private static XMLParser XMLP = new XMLParser(Main.Repo);
//---- constructeur -------
        public RDFLAutilitaires(XMLProfileParameters profparams, Repository repo)
        {
            profparameters = profparams;
            profparameters.majIndicateurs();
            this.repo = repo;
        }

        // ABA20230903 
        // To fix the category prefix issue for packages. 
        private static string GetCategoryName(string packageName)
        {
            // return "Package_" + packageName; old version
            return packageName; // fixed version
        }
//----------------------------------------------- 
/// <summary>
/// construction des dicos pour elements d'un Package
/// </summary>
/// <param name="package"></param>
        public static void buildDicsElem(EA.Package package)
        {
            //Ta tb = new Ta("buildDicsElem pour package=" + package.Name);
            if (dicelembyid.Count == 0) //first time
            {
                List<EA.Element> elist = new List<EA.Element>();
                getAllElements(package, elist, "all");
                foreach (EA.Element e in elist)
                {               
                    if (!dicelembyid.ContainsKey(e.ElementID))
                    {
                        dicelembyid.Add(e.ElementID, e);
                    }
                    if (e.Name != "")
                    {
                        if (!dicelembyname.ContainsKey(e.Name))
                        {
                            dicelembyname.Add(e.Name, e);
                        }
                    }
                    else
                    {
                        if ((e.Type == "Constraint") && (e.Notes=="XOR"))  // we treat only the XOR constraints
                        {
                            char[] separateurs = { '=', ';' };
                            string[] split = (e.get_MiscData(3)).Split(separateurs);
                            List<string> lscons = new List<string>();
                            List<long> lcons= new List<long>();
                                for(short i=0;i < split.Length;i++){
                                    if((split[i] != "") && (isnumeric(split[i])))
                                    { lcons.Add((long) Convert.ToUInt64(split[i]));}
                                }
                                foreach(long conid in lcons)
                                {
                                        if(!dicconstbycon.ContainsKey(conid)){
                                    dicconstbycon.Add(conid, new List<long>());
                                            dicconstbycon[conid].Add(e.ElementID);
                                            // 
                                        }else{
                                            dicconstbycon[conid].Add(e.ElementID);
                                        }
                                }
                            
                        }

                    }

                }
            }
           // tb.stop();
        }


        public static void buildDicsElem(object opackage)
        {
            /*
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" INFO using buildDicsElem(object)");
            EA.Package package = (EA.Package)opackage;
            if (dicelembyid.Count == 0) //first time
            {
                List<EA.Element> elist = new List<EA.Element>();
                getAllElements(package, elist, "all");
                foreach (EA.Element e in elist)
                {
                    if (!dicelembyid.ContainsKey(e.ElementID))
                    {
                        dicelembyid.Add(e.ElementID, e);
                    }
                    if (e.Name != "")
                    {
                        if (!dicelembyname.ContainsKey(e.Name))
                        {
                            dicelembyname.Add(e.Name, e);
                        }
                    }
                    else
                    {
                        if ((e.Type == "Constraint") && (e.Notes == "XOR"))  // we treat only the XOR constraints
                        {
                            char[] separateurs = { '=', ';' };
                            string[] split = (e.get_MiscData(3)).Split(separateurs);
                            List<string> lscons = new List<string>();
                            List<long> lcons = new List<long>();
                            for (short i = 0; i < split.Length; i++)
                            {
                                if ((split[i] != "") && (isnumeric(split[i])))
                                { lcons.Add((long)Convert.ToUInt64(split[i])); }
                            }
                            foreach (long conid in lcons)
                            {
                                if (!dicconstbycon.ContainsKey(conid))
                                {
                                    dicconstbycon.Add(conid, new List<long>());
                                    dicconstbycon[conid].Add(e.ElementID);
                                    // 
                                }
                                else
                                {
                                    dicconstbycon[conid].Add(e.ElementID);
                                }
                            }

                        }

                    }

                }
            }
             * */
        }
//-----------------------------------------------------------

/// <summary>
/// construction des dicos pour packages d'un Repository
/// </summary>
/// <param name="repository"></param>
        public static void buildDicsrepo(EA.Repository repo)
        {
            //Ta tb = new Ta("buildDicsrepo");
            if (dicrepobyid.Count == 0) //first time
            {
               
                       EA.Package model=(EA.Package)(repo.Models).GetAt(0);
                      
		List<EA.Package>  Lpa = new List<EA.Package>();
     		  getAllPackages(model,Lpa);
                foreach (EA.Package pa in Lpa)
                {
                 //   MessageBox.Show("name= " + pa.Name + " ID=" + pa.PackageID );
		 if (!dicrepobyid.ContainsKey(pa.PackageID))
            	{
                    dicrepobyid.Add(pa.PackageID, pa);
		}
                }

            }
            //tb.stop();
        }
        
        /// <summary>
        /// this program provide the first line of the RDF file
        /// the declaration of the namespaces 
        /// /// </summary>
        /// <param name="package"></param>
        /// <returns></returns>
        public string GenerEntete(EA.Repository repo, EA.Package package,EA.Package toppack,string kind)
        {
            string ret = "";
          try
          {
                /**********************************************************************/
                
                EA.Package confpack = null;
                EA.Package profilespackage = null;
                RDFLAutilitaires.namespaces = new Dictionary<string, string>();
                foreach(EA.Package pa in toppack.Packages)
                {
                    if(pa.Name== "TC57CIMProfiles")
                    {
                        profilespackage = pa;
                        break;
                    }
                }
                if(profilespackage==null)
                {
                    throw new Exception(" directory TC57CIMProfiles not found");
                }
                foreach(EA.Package pa in profilespackage.Packages)
                {
                    if (pa.Name == "InfConfiguration")
                    {
                        confpack = pa;
                        break;
                    }
                }
                if(confpack==null)
                {
                    throw new Exception(" impossible to access to Configuration_Resource \n\t inConfiguration package not found");
                }
                EA.Element confres = null;
                foreach(EA.Element elt in confpack.Elements)
                    // look for Configuration_Ressources
                {
                    if(elt.Name=="Configuration_Resource")
                    {
                        confres = elt;
                        break;
                    }
                }
                if(confres==null)
                {
                    throw new Exception("Configuration_Resource class not found in InfConfiguration package ");
                }
                string prefix = "";
                foreach(EA.TaggedValue tag in confres.TaggedValues)
                {
                    if(tag.Name.Contains("nsprefix:"))
                    {
                        prefix = tag.Value;
                        if (!namespaces.ContainsKey(prefix))
                        {
                            namespaces.Add(prefix, "");
                        }
                    }
                }
                string nsuri = "";
                foreach (EA.TaggedValue tag in confres.TaggedValues)
                {
                    if (tag.Name.Contains("nsuri:"))
                    {
                        nsuri = tag.Value;

                        string nsprefix = tag.Name.Substring("nsuri:".Length);
                        if (!namespaces.ContainsKey(nsprefix))
                        {
                            MessageBox.Show("in Resource_Configuration \n the nsuri " + tag.Name + "has no  corresponding nsprefic");
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine("in Resource_Configuration \n the nsuri " + tag.Name + "has no  corresponding nsprefix");
                        }
                        else
                        {
                            namespaces[nsprefix] = nsuri;
                        }
                    }
                }
                string Entete = "";
                Entete = Entete + "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n";
                Entete = Entete+"<rdf:RDF\n";
                XMLParser XMLP = new XMLParser(repo);
                if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
                {
                    string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                    string[] stereos = liststereos.Split(new char[] { '|' });
                    // verifier si les indicateurs de stereos sont positiones
                    if (Main.IndStereos.Count == 0)
                    {
                        //MessageBox.Show("it seems that you want to introduce classifying stereos but you do not have saved your choices \n\r (menu option)");
                        RDFLAutilitaires.InitIndStereos(stereos, XMLP);
                    }
                    //string nsextensions = "";
                    //List<string> prefixies = new List<string>();
                    //prefixies.Add(profparameters.Prefix); // ne pas oublier le name space par default dans le test de redondance
                    foreach (string stereo in stereos)
                    {
                        prefix = profparameters.urisbystereo[stereo][0];
                        if(prefix ==XMLP.GetXmlValueProfData("Prefix")) continue;
                        if (!namespaces.ContainsKey(prefix)  )  
                        {
                            namespaces[prefix] = profparameters.urisbystereo[stereo][1];
                           
                        }
                    }
                        }
                foreach (string nspref in namespaces.Keys)
                {
                    if ((nspref == XMLP.GetXmlValueProfData("Prefix")) && (kind=="shacl"))
                    {
                        
                    }
                    else
                    {
                        Entete = Entete + "xmlns:" + nspref + "=\"" + namespaces[nspref] + "\"\n";
                    }
                }
                /*
                if (XMLP.GetXmlValueConfig("Xmlbase") == "Checked")
                {
                    Entete = Entete + " xml:base=\"" + profparameters.RootModelURI.Trim('#') + "\"";
                }
                */
                
                // get the profile uri
                string ontology = package.Name.Replace("Profile", "") +"-EU_Ontology";
                prefix = XMLP.GetXmlValueProfData("Prefix");
                //string uri = XMLP.GetXmlValueProfData("RootModelURI").Trim('#');
                string uri = XMLP.GetXmlValueProfData("ProfileNamespace").Trim('#');
               // int ind = uri.LastIndexOf('/');
               // uri = uri.Substring(0, ind);
                //Entete = Entete + "xml:base " + prefix + "=\"" + uri + "\"";
               
                
                if(kind=="shacl")
                {
                    
                    Entete = Entete + "xmlns:" + prefix + "=\"" + uri + "/Constraints#\"\n";
                    
                    Entete = Entete + "xml:base " + "=\"" + uri + "/Constraints\"\n";
                }else
                {

                    Entete = Entete + "xmlns:" + prefix + "=\"" + uri + "#\"\n";
                    if (!namespaces.ContainsKey(prefix)) namespaces[prefix] = uri +"#" ;
                    Entete = Entete + "xml:base " + "=\"" +  XMLP.GetXmlValueProfData("DefaultRootModelURI").Trim('#') + "\"\n";
                }
                /*
                if(Main.typerdfexport == "501Ed2")
                {
                    Entete = Entete + "\nxmlns:skos"+ "=\"" + "http://www.w3.org/2004/02/skos/core#" + "\"";
                }
                */
                Entete = Entete + ">"; // close the RDF tag
                Entete = Entete + "\n" + profparameters.copyrightnotice;
                ret = Entete;
                //TODO  ici introduire le header

                /****************************************************************/
      }
        catch(Exception ee)
      {
            MessageBox.Show(" ISSUE in generation the Entete " + ee.Message);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" ISSUE in generation the Entete " + ee.Message);
      }
      return ret;
    }
        

        /// <summary>
        /// the owl-ontology (header) rdf serialization
        /// /// </summary>
        /// <param name="package"></param>
        /// <returns></returns>
        public string GenerHeader(EA.Package package, EA.Package profilespackage,string kind)
        {
            string ret = "";
            try
            {
                /**********************************************************************/
                //string versionIRI = "";
                string about = "";
                EA.Element ontology = null;
                string profilename = "";
                if(!package.Name.Contains("Profile"))
                {
                    throw new Exception(String.Format(" Profile PackageName {0} does not end with 'Profile'", package.Name));
                }
                profilename = package.Name.Replace("Profile", "");
                string ontologyname = profilename  + "-EU_Ontology";
                foreach (EA.Element elt in package.Elements)
                {
                    if(elt.Name==ontologyname)
                    {
                        ontology = elt;
                        break;
                    }
                }
                if(ontology==null)
                {
                    throw new Exception(String.Format(" class {0} not found in Profile PackageName ", ontologyname));
                }
                    foreach (EA.Attribute atr in ontology.Attributes)
                {
                    if(atr.Name== "versionIRI")
                    {
                        string[] split = atr.Default.Split(new char[] { '/' });
                        int n = split.Length;
                        for(int i=0;i<n-1;i++)
                        {
                            about = about + split[i] +"/";
                        }
                    }
                    about = about.Trim('/');
                    if (ret == "")
                    {
                        ret = "\n<!--  ********** Header **************** -->\n";
                        ret = ret +  "<!-- RDFS header -->\n";
                    }
                }
                if (about == "") throw new Exception("versionIRI attribute not found in versionIRI");
                //ret = ret + "<owl:Ontology rdf:about = \"" + about + "_Ontology\">\n";
                if (kind == "shacl")
                {
                    ret = ret + "<rdf:Description rdf:about = \"" + about + "/Constraints#" + "Ontology" + "\">\n";
                }
                else
                {
                    ret = ret + "<rdf:Description rdf:about = \"" + about + "#" + "Ontology" + "\">\n";
                }
                string language = "en";
                foreach(EA.Attribute atr in ontology.Attributes)
                {
                    if(atr.Name=="language")
                    {
                        language = atr.Default.Substring(0,2); // usually en-GB
                        break;
                       
                    }
                }
                foreach(EA.Attribute atr in ontology.Attributes )
                {
                    string type = atr.Type;
                    string stereo = atr.Stereotype;
                    string name = stereo + ":" + atr.Name;
                    /* ABA20230905
                    if((name=="dct:issued") || (name=="dct:modified"))
                    {
                        string prov = ";";
                    }*/
                    if (name == "dct:issued") atr.Default=DateTime.UtcNow.ToString("yyyy-MM-ddTHH:mm:ssZ");
                    if ((atr.Default == null) || atr.Default == "")
                    {
                        MessageBox.Show(String.Format(" in ontology the attribute {0} has no initial value", atr.Name));
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(String.Format(" in ontology the attribute {0} has no initial value", atr.Name));
                        continue;
                    }
                    if (name == "dct:rights")
                    {
                        if (profparameters.forXml)
                        {
                            ret = ret + "\t<" + name + " xml:lang =\"" + language + "\">";
                            ret = ret + ReplaceSpecialCharacters(generCopyright(false)) + "\n";
                            ret = ret + "\t</" + name + ">\n";
                        }
                        else
                        {
                            ret = ret + "\t<" + name + " xml:lang =\"" + language + "\"" +" rdf:parseType=\"Literal" + "\">";
                            ret = ret + generCopyright(false) + "\n";
                            ret = ret + "\t</" + name + ">\n";
                        }
                    }
                    if (atr.UpperBound == "n")
                    {
                         
                        // there may be  several values for this attribute
                        string[] values = atr.Default.Split(new char[] { '|' });
                        int n = values.Length;
                        
                        for(int i=0;i<n;i++)
                        {
                            if (kind=="shacl")
                            {
                                if ((atr.Name == "theme") && (values[i].Contains("vocabulary"))) values[i] = "constraints";
                            }
                            string ligne = generOntologyLine(name, type, values[i], language) ;
                            ret = ret + ligne;
                        }
                    }
                    else
                    {

                        string ligne;
                        if (atr.Name == "rights") continue;
                        
                        if( kind != "shacl")
                        {

                            ligne = generOntologyLine(name, type, atr.Default, language);
                            ret = ret + ligne;
                        }
                        else
                        {                             
                            switch (atr.Name)
                            {
                                    case "versionIRI":
                                        string uriorg = atr.Default;
                                        int ind = uriorg.LastIndexOf('/');
                                        string vers = uriorg.Substring(ind);
                                        string uricore = uriorg.Substring(0, ind);
                                        string newuri = uricore + "/Constraints" + vers;
                                        ligne = generOntologyLine(name, type,newuri , language);
                                        ret = ret + ligne;
                                        break;
                                   
                                    case "title":
                                        string content = atr.Default.Replace("Vocabulary", "Constraints");
                                        ligne = generOntologyLine(name, type, content, language);
                                        ret = ret + ligne;
                                        break;
                                    case "description":
                                        string tt = atr.Default.Replace("This vocabulary is describing", "The constraints for");
                                        ligne = generOntologyLine(name, type, tt, language);
                                        ret = ret + ligne;
                                        break;
                                    case "theme":
                                        if (atr.Default.Contains("vocabulary")) atr.Default=atr.Default.Replace("vocabulary","constraints");
                                         ligne = generOntologyLine(name, type, atr.Default, language);
                                         ret = ret + ligne;
                                         break;
                            default:
                                       ligne = generOntologyLine(name, type, atr.Default, language);
                                        ret = ret + ligne;
                                        break;
                                }
                            
                        }
                    }
                }
                //ret = ret + "</owl:Ontology>\n";
                ret = ret + "<rdf:type rdf:resource=\"http://www.w3.org/2002/07/owl#Ontology\"/>\n";
                ret = ret + "</rdf:Description >\n";
                ret = ret + "<!-- ******************************** -->\n";
                /****************************************************************/
            }
            catch (Exception ee)
            {
                MessageBox.Show(" ISSUE in generation the Header " + ee.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" ISSUE in generation the Header " + ee.Message);
            }
            return ret;
        }


        /// <summary>
        /// the owl-ontology (header) rdf serialization
        /// /// </summary>
        /// <param name="package"></param>
        /// <returns></returns>
        public string getOntologyAttribute(EA.Package package, string atrname, string type)
        {
            string ret = "";
            try
            {
                /**********************************************************************/
                //string versionIRI = "";
                string about = "";
                EA.Element ontology = null;
                string profilename = "";
                if (!package.Name.Contains("Profile"))
                {
                    throw new Exception(String.Format(" Profile PackageName {0} does not end with 'Profile'", package.Name));
                }
                profilename = package.Name.Replace("Profile", "");
                string ontologyname = profilename + "-" + type +"_Ontology";
                foreach (EA.Element elt in package.Elements)
                {
                    if (elt.Name == ontologyname)
                    {
                        ontology = elt;
                        break;
                    }
                }
                if (ontology == null)
                {
                    throw new Exception(String.Format(" class {0} not found in Profile PackageName ", ontologyname));
                }
                foreach (EA.Attribute atr in ontology.Attributes)
                {
                    if (atr.Name == atrname)
                    {
                        if (atr.Default == null) atr.Default = "";
                        ret = atr.Default;
                        break;
                    }
                    
                }
                if (about == "") throw new Exception("versionIRI attribute not found in versionIRI");
               
            }
            catch (Exception ee)
            {
                MessageBox.Show(" ISSUE in generation the Header " + ee.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" ISSUE in generation the Header " + ee.Message);
            }
            return ret;
        }

        
        /// <summary>
        /// gener one ligne of the header
        /// </summary>
        /// <param name="name"></param>
        /// <param name="type"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public string generOntologyLine(string name,string type,string value,string language)
        {
            string ret = "";
            switch (type)
            {
                case "String":
                    ret = "<" + name + " xml:lang =\"" + language + "\">" + value + "</" + name + ">\n";
                    break;
                case "StringIRI":
                    string datatype= "";
                    string vv = value.Trim('#');
                    ret = "<" + name + datatype + ">" + vv + "</" + name + ">\n";
                    break;
                case "IRI":
                    vv = value.Trim('#');
                    ret = "<" + name + " rdf:resource=\"" + vv + "\"/>\n";
                    break;
                case "StringFixedLanguage":
                    ret = "<" + name + ">" + value + "</" + name + ">\n";
                    break;
                case "URL":
                    vv = value.Trim('#');
                    ret = "<" + name + ">" + vv + "</" + name + ">\n";
                    break;
                case "DateTime":
                    datatype = " rdf:datatype=" + "\"" + "http://www.w3.org/2001/XMLSchema#dateTime" + "\"";
                    vv = value.Trim('#');
                    ret = "<" + name + datatype + ">" + vv + "</" + name + ">\n";
                    break;
                case "Date":
                    datatype = " rdf:datatype=" + "\"" + "http://www.w3.org/2001/XMLSchema#date" + "\"";
                    vv = value.Trim('#');
                    ret = "<" + name + datatype + ">" + vv + "</" + name + ">\n";
                    break;
                default:
                    break;
            }
            return "\t" + ret;
        }
        //-----------------------------------------------------------
        /// <summary>
        /// 
        /// </summary>
        /// <param name="package"></param>
        /// <param name="tw"></param>
        /// <returns></returns>
        public bool serialize(EA.Repository repo, EA.Package package,TextWriter tw)
        {
            //Ta tb = new Ta("serialize pour package=" + package.Name);
            List<EA.Element> elemliste = new List<EA.Element>();
            // dejatraite = new List<long>();
            // datatypedone = new List<long>();
            // traitement du package
            traitpackage(repo, package, tw);

            //traitement des classes
             foreach (EA.Element e in package.Elements)
             {
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
                /* ABA20230905
                if((package.Name=="Core") && (e.Name=="Name"))
                {
                     int prov=1;
                }*/
                if(e.Type=="Class")
                {
                  if (e.Name != "") 
                  { // on ne traite pas les elements sans nom
                     {
                        if (!NoDoublons.Contains(e.Name))
                        {
                        NoDoublons.Add(e.Name);
                        }
                        else
                        {
                           // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING there are at least two classes of the same name {" + e.Name + "} in the profile");
                           MessageBox.Show(" WARNING  there are at least two classes of the same name {" + e.Name + "} in the profile ");
                          // tb.stop();
                           return false;
                        }
                        if (e.Name == "ActivePower")
                        {
                             string prov = e.Name;
                        }
                        traitclass(e, tw);
                     };
                  }
                  else
                  {
                 //  // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING an element without name of GUI" + e.ElementGUID + "has been encountered and zapped");
                  }
                }
             }
            // tb.stop();
             return true;
        }

//--------------------------------------------------------------------------------------------------------
      public bool traitpackage(EA.Repository repo, EA.Package p,TextWriter tw)
        {
            //Ta tb = new Ta("traitpackage pour package=" + p.Name);

        if (
            (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 0)
            ||
            (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 2)
            )
        {
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitpackage not publishabled " + p.Name);
            return false;//am mai 2020
        }
        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Treatment of Package " + p.Name );
        ConstDefinition constantes=new ConstDefinition();               
        bool answer= true;
        EA.Package Profpack = Main.Repo.GetTreeSelectedPackage();
            // tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(p) + "Package_" + p.Name + "\">");
            XMLParser XMLP = new XMLParser(repo);
            string pref = XMLP.GetXmlValueProfData("Prefix");
            string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
            string names;
            if (Main.typerdfexport == "2019")
            {
                names = profuri;
            }
            else
            {
                 names = RDFLAutilitaires.namespaces[pref];
            }
            //tw.WriteLine("\t <rdf:Description rdf:about=\"" +  names + "Package_" + p.Name + "\">");
            tw.WriteLine("\t <rdf:Description rdf:about=\"" + names + p.Name + "\">");
            //tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + profparameters.copyrightnotice + "</rdfs:comment>");
            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + p.Name + "</rdfs:label>");
        tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_CIMS + "ClassCategory\"/>");
        if ((p.Notes == "") ||  (!profparameters.hasFullDesc(p.StereotypeEx)))
        {
         //    tw.WriteLine("\t<rdfs:comment>" + "</rdfs:comment>");
         }
         else
         {
                //tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(p.Notes) + "</rdfs:comment>");
                tw.WriteLine(specialCharactersFilter(p.Notes));
         }
            // tw.WriteLine("</cims:ClassCategory>");   
        tw.WriteLine("</rdf:Description>");
        //tb.stop();
                  return answer;    
}
/****************************************************************************/
                //------------------------------am 271015--------------------------------------------------------------------------
                public bool traitpackage(EA.Package p, Dictionary<string,TextWriter>   dictw)
          {
            if (
                (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 0)
                ||
                (RDFLAutilitaires.getPublishable(p.StereotypeEx) == 2)
                )
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitpackage not publishabled " + p.Name);
                return false;//am mai 2020
            }

            //Ta tb = new Ta("traitpackage dictw pour package="+ p.Name);
            /* ABA20230905
              if (p.Name == "EquipmentProfile")
              {
                  string prov = "";
              }*/
              ConstDefinition constantes = new ConstDefinition();
              bool answer = true;
              // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n*** entsoe export by stereotypes  Treatment of Package <<" + p.StereotypeEx + ">> " + p.Name); 

              foreach(KeyValuePair<string,TextWriter>kv in  dictw)
              {
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Treatment of Package <<" + kv.Key.ToString() + ">>" + p.Name);
                // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 + "Package_" + p.Name  + "\">");
                //dictw[kv.Key].WriteLine("\t <rdf:Description rdf:about=\"" + getURI(p) + "Package_" + p.Name + "\">"); //ATTENTION pour legacy entsoe2.4
                // dictw[kv.Key].WriteLine("\t <rdf:Description rdf:about=\"" + RDFLAutilitaires.namespaces[new XMLParser(repo).GetXmlValueProfData("Prefix")] + "Package_" + p.Name + "\">");
                dictw[kv.Key].WriteLine("\t <rdf:Description rdf:about=\"" + RDFLAutilitaires.namespaces[new XMLParser(repo).GetXmlValueProfData("Prefix")] + p.Name + "\">");
                dictw[kv.Key].WriteLine("\t<rdfs:label xml:lang=\"en\">" + p.Name + "</rdfs:label>");
              dictw[kv.Key].WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_CIMS + "ClassCategory\"/>");
              if ((p.Notes == "") || (!profparameters.hasFullDesc(p.StereotypeEx)))
              {
                   // tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(p.Notes) + "</rdfs:comment>");
                   // tw.Writeline(RDFLAutilitaires.transComment(RDFutilitaires.RemoveRc(p.Notes));
              }
              else
              {
                    //  dictw[kv.Key].WriteLine("\t<rdfs:comment>" + RDFutilitaires.RemoveRc(p.Notes) + "</rdfs:comment>");
                    string notes = RDFutilitaires.RemoveRc(p.Notes);
                    if (profparameters.forXml)
                    {
                        dictw[kv.Key].WriteLine("\t<rdfs:comment rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + specialCharactersFilter(notes) + "</rdfs:comment>");
                    }
                    else
                    {
                        dictw[kv.Key].WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + notes + "</rdfs:comment>");
                    }
                  
              }
              // dictw[kv.Key].WriteLine("</cims:ClassCategory>");   
              dictw[kv.Key].WriteLine("</rdf:Description>");
              }
              //tb.stop();
              return answer;
          }
          /****************************************************************************/
       /// <summary>
      /// for a given class
        /// prints the skeletton of rdf schema for each class which are not datatype or enumeration
  /// according to the following algorithm
  /// </summary> 
  ///  case legacy rdfs langdale
  /// <rdf:Description rdf:about="namespaces(j.0)#Class.Name">
  ///  <rdfs:subClassOf rdf:resource="namespaces(j.0)#MySuperClass.Name"/> 
  ///  <cims:belongsToCategory rdf:resource="namespaces(j.0)#Package.Name"/>
  ///  <rdfs:comment>Class.Documentation</rdfs:comment>	
  ///  <rdfs:label >Class.Name</rdfs:label>
  /// <cims:stereotype>"Class.Stereotype"</cims:stereotype> 
  ///  </rdfs:Class>
  ///  <rdf:type rdf:resource="namespaces(rdfs)#Class"/>
 ///   </rdf:Description>
        /// <param EA.Element></param>
        /// <returns> bool </returns>
 /// cas de la norme officielle rdfs de la 501
   
/*****************************************************************
 For each class, print
    <rdfs:Class rdf:ID="Class.Name">
<rdfs:label xml:lang="en">Class.Name</rdfs:label>
<rdfs:subClassOf rdf:resource="#MySuperClasses.Name"/>
<rdfs:comment>"Class.Documentation"</rdfs:comment>
<cims:stereotype>"Class.Stereotype"</cims:stereotype> 
       </rdfs:Class>
*******************************************************************/

          public bool traitclass(EA.Element elem, TextWriter tw)
          {
           

            
            //Ta tb = new Ta("traitclass pour elem=" + elem.Name);//18
	        // if(Main.DO_REPORTLOG) // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Treatment of Element " + elem.Name   );
            if (Main.typerdfexport == "2020")
            {
                if (elem.Name.Contains("Version")) return false;//  Version class is eliminated
                if (elem.Name.Contains("Ontology")) return false; // Ontology class is eliminated (beeing in header)
            }
            if (Main.typerdfexport == "2019")
            {
                if (elem.Name.Contains("Ontology"))
                {
                    elem.Name = "Ontology";
                }
            }
            /* ABA20230905
                if (elem.Name == "WindPowerPlant")
            {
                  string prov="";
            }*/
            if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
                       || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitclass " + elem.Name + " not  publishabled");
                return false;//am mai 2020
            }
            // MessageBox.Show(" classe=" + elem.Name);
            ConstDefinition constantes = new ConstDefinition();
              //string ligne = "";
              bool answer = false;
              bool datatype = false;
              if ((elem.Type == "Class") || (elem.MetaType=="Enumeration") || (elem.Type=="Enumeration")) //am mai 2018
              {
                  if ((elem.Stereotype != CD.GetEnumStereotype()) && (elem.MetaType!="Enumeration") && (elem.Type!="Enumeration"))  // not an enumeration //am mai 2018
                  {
		        bool todo=true;
                      if(StereoExContainsStereo(elem.StereotypeEx,"Datatype")
                        || StereoExContainsStereo(elem.StereotypeEx,CD.GetPrimitiveStereotype())
                        ||StereoExContainsStereo(elem.StereotypeEx,CD.GetCompoundStereotype())  
                        ||StereoExContainsStereo(elem.StereotypeEx,CD.GetDatatypeStereotype()))
                       {
                datatype = true;
                if (datatypedone.Contains(elem.ElementID)) { // the datatype have already been treated
                          todo=false;
			}else{
			  if(LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID))  todo=false;// the datatype is already   part of the profile	
	
			}}
		     if(todo == true){
			datatypedone.Add(elem.ElementID);
            LocalDatatypeNames.Add(elem.Name); // to avoid duplication of identifier name references

                     // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 + elem.Name + "\">");    // augmented
                     tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem)+ elem.Name + "\">");    // am juin 2011

                      tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");
             
                      // is there a superclass?
    
                      EA.Element superclass = getElementSuperclass(elem);
 
                      if (superclass != null)
                      {
			 // tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"" + NS_J0 +  superclass.Name + "\"/>");
                          tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"" + getURI(superclass) +  superclass.Name + "\"/>");
                      }
                      if((elem.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
                        {// tw.WriteLine("\t<rdfs:comment>" + RDFutilitaires.RemoveRc(elem.Notes) + "</rdfs:comment>");
                         //tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(elem.Notes) + "</rdfs:comment>");
                            tw.WriteLine(specialCharactersFilter(elem.Notes));
                        }

                     /************* am fev 2016
                      if (elem.Stereotype != "")
                      {
                          tw.WriteLine("<cims:stereotype>" + elem.Stereotype + "</cims:stereotype>");
                         
                      }
                      ***********************/
                      if (elem.StereotypeEx != "")
                      {
                          string[] split = elem.StereotypeEx.Split(',');
                          for (int i = 0; i < split.Length; i++)
                          {
                              tw.WriteLine("<cims:stereotype>" + split[i] + "</cims:stereotype>");
                          }
                      }
                        XMLParser XMLP = new XMLParser(Main.Repo);
                        EA.Package pa = Main.Repo.GetPackageByID((int)elem.PackageID);
                        if ((datatype==true) && !LocalDatatypeIDs.Contains(elem.ElementID)) {  // it is a datatype copied from above level
                            //tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + NS_J0 + "Package_" + DatatypePackageName + "\"/>");
                            string luri = (new XMLParser(Main.Repo)).GetXmlValueConfig("Xmlbase") == "Checked" ? "#" : NS_J0;
                            // tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + luri + "Package_" + DatatypePackageName + "\"/>");//am juin 2011 PROBLEME
                            if (Main.typerdfexport == "2019")
                            {
                                string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                            }
                            else
                            {
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                            }

                            }
                        else
                        {
                            //tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + getURI(Main.Repo.GetPackageByID((int)elem.PackageID)) + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "\"/>");   
                            if (Main.typerdfexport == "2019")
                            {
                                string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                            }
                            else
                            {
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                            }
                            }

              
                      //	 tw.WriteLine("</rdfs:Class>");

                      if ((elem.Abstract != "1" )&& (datatype== false))
                      {
                          tw.WriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "concrete\"/>");    //augmented
                      }
                      tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDFS + "Class\"/>");   //augmented
                      tw.WriteLine("\t </rdf:Description>");  // augmented

                      // traitement des attributs
                      foreach (EA.Attribute att in elem.Attributes)
                      {
                          traitAttribute(elem, att, tw);
                      }
                      // traitement des associations
                      EA.Collection connectors = elem.Connectors;
                      foreach (EA.Connector con in connectors)
                      {
                          // on verifie que le connector n'a pas ete deja traite dans un autre package
                          if (!dejatraite.Contains(con.ConnectorID))
                          {
                             if(con.ConnectorID != 0) dejatraite.Add(con.ConnectorID);

                              traitConnector(con, tw);
                          }
                      }


                      //tb.stop();
                      answer = true;
                      return answer;
			}
                  }
                  else
                  { // is an enumeration
			 bool todo=true;
			if (datatypedone.Contains(elem.ElementID)){  // the datatype have already been treated
                          todo=false;
			}else{
			  if(LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID))  todo=false;// the datatype is already   part of the profile
              
            }
			if (todo == true ) {
			datatypedone.Add(elem.ElementID);
            LocalDatatypeNames.Add(elem.Name); // to avoid duplication of identifier name references // am june 2011     
                     // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name +  "\">");    // augmented
			 tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem) +  elem.Name +  "\">");    // augmented
                      tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");
                        // we suppose there is NO  superclass?
                        EA.Package pa = Main.Repo.GetPackageByID((int)elem.PackageID);
                        if ((elem.Notes != "") &&  (profparameters.hasFullDesc(elem.StereotypeEx)))
                        {
                            //tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(elem.Notes) + "</rdfs:comment>");
                            tw.WriteLine(specialCharactersFilter(elem.Notes));
                        }
                        XMLParser XMLP = new XMLParser(Main.Repo);
                        //  tw.WriteLine("\t<cims:belongsToCategory rdf:resource=" + dicpackbyid[elem.PackageID].Name + "\"/>");
                        if (!LocalDatatypeIDs.Contains(elem.ElementID))
                        {  // it is a datatype copied from above level
                           //tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + NS_J0 + "Package_" + DatatypePackageName + "\"/>");// am juin 2011 PROBLEME
                            if (Main.typerdfexport == "2019")
                            {
                                string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                            }
                            else
                            { 
                            tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");// am juin 2011 PROBLEME
                            }
                        }
                        else
                        {
                            if (Main.typerdfexport == "2019")
                            {
                                string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                            }
                            else
                            {
                                //tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + getURI(Main.Repo.GetPackageByID((int)elem.PackageID)) + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "\"/>");  // am juin 2011 
                                tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                            }
                        }
                   //   tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + NS_J0 + "Package_" + dicpackbyid[elem.PackageID].Name + "\"/>");
                           tw.WriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "enumeration\"/>");    //augmented
                      /*************** ajout am fev 2016 ***************************/
                      if (elem.StereotypeEx != "")
                      {
                          string[] split = elem.StereotypeEx.Split(',');
                          for (int i = 0; i < split.Length; i++)
                          {
                              if ((split[i] != "enumeration") && (split[i] != "Enumeration"))
                              {
                                  tw.WriteLine("<cims:stereotype>" + split[i] + "</cims:stereotype>");
                              }
                          }
                      }
                      /*********************************************************/ 
                
                
                //  tw.WriteLine("</rdfs:Class>");
                      tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDFS + "Class\"/>");   //augmented
                      tw.WriteLine("\t </rdf:Description>");  // augmented
                      foreach (EA.Attribute att in elem.Attributes)
                      {
                          traitEnummember(elem, att, tw);

                      }

                     // tb.stop();
                      answer = true;
                      return answer;

                  }

              }}
              //tb.stop();
              return answer;
          }


//-------------------------------------------------------
                 /*
                For each attribute, print
   <rdf:Property rdf:ID="Class.Name.Attribute.Name">
      <rdfs:label xml:lang="en">Attribute.Name</rdfs:label>
      <rdfs:domain rdf:resource="#Class.Name"/>
      <rdfs:range rdf:resource="#Attribute.Type"/>
      <rdfs:comment>"Attribute.Documentation"</rdfs:comment>
      </rdf:Property>
            */
      public bool traitAttribute(EA.Element elem,EA.Attribute attribute,TextWriter tw)
        	{
     
          
           // Ta tb = new Ta("traitAttribute pour attribute=" + elem.Name + "." + attribute.Name);
            if ((RDFLAutilitaires.getPublishable(attribute.StereotypeEx) == 0)
         || (RDFLAutilitaires.getPublishable(attribute.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitAttribute " + elem.Name + "." + attribute.Name + "not  publishabled");
                return false;//am mai 2020Ta 
            }
            int classifierid = (int)attribute.ClassifierID;//18
          // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t\t Treatment of Attribute " + attribute.Name );
                ConstDefinition constantes = new ConstDefinition(); 
	        bool answer= false;
  
	// tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name+ "." + attribute.Name +  "\">");  // augmented
            tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem,attribute) + elem.Name + "." + attribute.Name + "\">");// am juin 2011
         tw.WriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "attribute\"/>");  // augmented
        tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + attribute.Name + "</rdfs:label>");
       //tw.WriteLine("\t<rdfs:domain rdf:resource=\"" + NS_J0 + elem.Name + "\"/>");   //augmented
        tw.WriteLine("\t<rdfs:domain rdf:resource=\"" + getURI(elem) + elem.Name + "\"/>");  //am juin 2011
      // tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"#" + attribute.Type + "\"/>"); 
        //if ((attribute.ClassifierID != 0)  && (dicelembyid.ContainsKey(attribute.ClassifierID)))
          if(classifierid != 0)
        {
            //18 EA.Element classifier= dicelembyid[attribute.ClassifierID];
            EA.Element classifier = Main.Repo.GetElementByID(classifierid);
          // if(StereoExContainsStereo(classifier.StereotypeEx,CD.GetEnumStereotype()))//19
          if(isEnumeration(classifier))
                { 
                tw.WriteLine("\t<rdfs:range rdf:resource=\"" + getURI(classifier) + classifier.Name  + "\"/>");
            }else{
            tw.WriteLine("\t<cims:dataType rdf:resource=\"" + getURI(classifier) + classifier.Name  + "\"/>");   //augmented
            }
        }
        else
        {
           // tw.WriteLine("\t<cims:dataType rdf:resource=\"" + NS_J0 + attribute.Type + "\"/>");   //augmented
		 tw.WriteLine("\t<cims:dataType rdf:resource=\"" + getURI(elem,attribute) + attribute.Type + "\"/>");   //augmented
        }

          /* ********* addition am feb 2010 ****************/
      string upperbound=attribute.UpperBound.Trim();  // am june 2011
           if(upperbound=="*") upperbound="n";
            
       string multiplicity = attribute.LowerBound + ".." + upperbound;
       tw.WriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + RDFutilitaires.eten(multiplicity) + "\" />");
  
        if (attribute.Default != "")
        {
            if (attribute.IsConst)
            {
                    // tw.WriteLine("\t<cims:isFixed rdfs:Literal=\"" + attribute.Default + "\" />");
                    // tw.WriteLine("\t<cims:isFixed rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + attribute.Default + "</cims:isFixed>");//"\" />");
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    tw.WriteLine("\t<cims:isFixed rdf:datatype=\"http://www.w3.org/2001/XMLSchema#" + type + "\">" + attribute.Default + "</cims:isFixed>");//"\" /     
                 
                }
            else
            {
                    // tw.WriteLine("\t<cims:isDefault rdfs:Literal=\"" + attribute.Default + "\" />");
                    // tw.WriteLine("\t<cims:isDefault rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + attribute.Default + " </cims:isDefault>");//"\" />");
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    tw.WriteLine("\t<cims:isDefault rdf:datatype=\"http://www.w3.org/2001/XMLSchema#" + type + "\">" + attribute.Default + "</cims:isDefault>");//"\"
                }
        }

       // if (attribute.Stereotype != "") {
          if(attribute.StereotypeEx != "") { // am may 2011
              string[] stereos = attribute.StereotypeEx.Split(',');
              foreach (string stereo in stereos)
              {
                  tw.WriteLine("\t<cims:stereotype>" + stereo + "</cims:stereotype>");
              }
        } 
          /*************************************************/ 
       if((attribute.Notes != "") && (profparameters.hasFullDesc(attribute.StereotypeEx)))
            {

                //tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(attribute.Notes) + "</rdfs:comment>");
                tw.WriteLine(specialCharactersFilter(attribute.Notes));
            }
      
      // tw.WriteLine("</rdf:Property>");
 	 tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>");  //augmented
	 tw.WriteLine("\t </rdf:Description>"); //augmented
          /*18
     if ((attribute.ClassifierID != 0)  &&(dicelembyid.ContainsKey(attribute.ClassifierID))&& !datatypedone.Contains(attribute.ClassifierID))
     { // the datatype hasnot  been already generated ?  
         traitclass(dicelembyid[attribute.ClassifierID], tw);
         datatypedone.Add(attribute.ClassifierID);
     }
     */
     if ((classifierid != 0) && (!datatypedone.Contains(attribute.ClassifierID)))
     {
         // the datatype hasnot  been already generated ?  
         traitclass(Main.Repo.GetElementByID(classifierid), tw);
         datatypedone.Add((long)classifierid);
     }  
                  answer = true;
                  //tb.stop();
                  return answer;    
	}

/*
                For each member of an enumeration, print
   <rdf:Description  rdf:ID="EnumerationClass.Name.Attribute.Name">
      <rdfs:label xml:lang="en">Attribute.Name</rdfs:label>
      <rdfs:comment>"Attribute.Documentation"</rdfs:comment>
      <rdf:type rdf:resource="#Class.Name"/>
      </rdf:Description>
*/
      public bool traitEnummember(EA.Element elem,EA.Attribute member,TextWriter tw)
        	{
            if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
               || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitEnummember " + elem.Name + "." + member.Name + "not  publishabled");
                return false;//am mai 2020Ta 
            }
            
           // Ta tb = new Ta("traitEnummember pour member=" + elem.Name +"."+member.Name);
                ConstDefinition constantes = new ConstDefinition(); 
	        bool answer= false;
  
	 //tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name+ "." + member.Name +  "\">");  // augmented
	tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem) +  elem.Name+ "." + member.Name +  "\">");  // augmented
       tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + member.Name + "</rdfs:label>");
       if((member.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
            {

                //tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(member.Notes) + "</rdfs:comment>"); 
                tw.WriteLine(specialCharactersFilter(member.Notes));
            }
            if (member.StereotypeEx != "")
            { // am may 2011
                string[] stereos = member.StereotypeEx.Split(',');
                foreach (string stereo in stereos)
                {
                    tw.WriteLine("\t<cims:stereotype>" + stereo + "</cims:stereotype>");
                }
            }
            //tw.WriteLine("\t<rdf:type rdf:resource=" + "\"" + NS_J0 + elem.Name  + "\"/>");  
            tw.WriteLine("\t<rdf:type rdf:resource=" + "\"" + getURI(elem) + elem.Name  + "\"/>");  
       tw.WriteLine("</rdf:Description>");
       //tb.stop();
                  answer = true;
                      return answer;    
	}




       /// <summary>
       ///            
       ///         For each rolename, print 
       ///      <rdf:Property rdf:ID="Class.Name.Role.Name">
       ///       <rdfs:label xml:lang="en">Role.Name</rdfs:label>
       ///      <rdfs:domain rdf:resource="#Class.Name"/>
       ///       <rdfs:range rdf:resource="#Role.ToClass.Name"/>
       ///      <cims:inverseRoleName rdf:resource="#Role.ToClass.Name.Role.OtherRole.Name"/>
       ///       <cims:multiplicity rdf:resource="http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#M:Role.CardinalityFrom"/>
       ///       <cims:isAggregate rdf:Literal="Role.IsAggregate"/>
       ///       <rdfs:comment>"Role.Documentation"</rdfs:comment>
       /// </rdf:Property>
       /// </summary>
       /// <param name="package"></param>
       /// <param name="tw"></param>
       /// <returns></returns>
    public bool traitConnector(EA.Connector con, TextWriter tw)
    {
       // Ta tb = new Ta("traitConnector pour id=" + con.ConnectorID.ToString() + " source=" + con.ClientEnd.Role + " target=" + con.SupplierEnd.Role);//18
        ConstDefinition constantes = new ConstDefinition();
            //tb.diffelaps("676");
            string urins = "";
        if (con.Type == "Association" ||
                    con.Type == "Aggregation")
        {
            if (!LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.ClientID).Name)
				|| !LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.SupplierID).Name))
            {// one end is not part of the profile
                string texte = "WARNING one  end  of an association between " + Main.Repo.GetElementByID((int)con.ClientID).Name + " and " + Main.Repo.GetElementByID((int)con.SupplierID).Name;
                texte = texte + "\n seems not to be part of the profile.  That is not correct";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                MessageBox.Show(texte);
                return false;
            }
            EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
            EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                /* ABA20230905
                if ((source_element.Name == "OperationalLimitType") && (target_element.Name == "AmbientTemperatureDependencyCurve"))
                {
                    string prov = "";
                }*/
                EA.ConnectorEnd source = con.ClientEnd;
            EA.ConnectorEnd target = con.SupplierEnd;
            bool isAggregatesource = false;
            bool isAggregatetarget = false;
                string urisource = getURI(source_element);
                string uritarget = getURI(target_element);
                urins = "#"; // name space par defaut
                if (
                    (urisource != "#") && (urisource != NS_J0)
                    )
                {
                    if ((uritarget != "#") && (uritarget != NS_J0) && (urisource != uritarget))
                    {
                        throw new Exception("traitconnector 2 identical endassociation stereotypes");
                    }
                    else
                    {                    
                        urins = urisource;
                    }
                }
                else //urisource = # 
                {
                    if ((uritarget != "#") || (uritarget != NS_J0))
                    {
                        urins = uritarget;
                    }
                }

                if (
                           ( (RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 0)
                                  || (RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 2))
                          ||
                          ((RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 0)
                                  || (RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 2))
                          ||
                           ((RDFLAutilitaires.getPublishable(con.StereotypeEx) == 0)
                                  || (RDFLAutilitaires.getPublishable(con.StereotypeEx) == 2))
                    )
                    {//am mai 2020
                        return false;//am mai 2020
                    }
                    
                                                                                      //-------------------------- ajout fev 2016 -------------------------//
                //tb.elapsetime("696");   
            string EntsoeExpStereo = new XMLParser(Main.Repo).GetXmlValueProfData("EntsoeExpStereo");
            //tb.elapsetime("698");

            // -----       ajout juillet 2012  ------------------- //
            // en cas d'ambiguite sur le lien 
            // les 2 cardinalits  [0,1] ou a [1] ou bien  [x,*]
            // on teste la navigabilite pour lever le'ambiguite et marquer 
            // la bonne association comme utilisee el l'autre non
            // avec <cims:AssociationUsed
            //
            bool ambiguite = true;
         
            // ------------------------------------
            if (/*con.Type == "Aggregation" || */ source.Aggregation == 1)
            {
                isAggregatesource = true;
            }
            if (/* con.Type == "Aggregation" || */ target.Aggregation == 1) // achtoung doute
            {
                isAggregatetarget = true;
            }

			Nomrole  rname= new Nomrole();

                // COTE SOURCE

                if (target.Role != "")
                    /* ABA20230905
                    if (target.Role == "DiagramObjectStyle")
                    {
                        string yy = "";
                    }*/
			{ //there must be a non empty rolename		
        		rname.elemid=target_element.ElementID;
				rname.rolename=target.Role;
           
                if(nomsRoles.Contains(rname)) 
				{
						/**************************
							MessageBox.Show("WARNING this Role name " + target.Role
							+ " associated with "
							+ target_element.Name
							+ " has already been used\n"
							+ " verify if this is licit in your model");
						********************************/
					// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
      //                  + " associated with "
      //                  + target_element.Name
      //                  + " has already been used\n"
						//+ " verify if this is licit in your model"
						//+ "\n");
                }else
				{
					nomsRoles.Add(rname);
				}

                  
                if ((!source_element.StereotypeEx.Contains(EntsoeExpStereo))  && (target_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
                {
                    //tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(target_element) + source_element.Name + "." + target.Role + "\">"); //am juin 2011
                    tw.WriteLine("\t <rdf:Description rdf:about=\"" + urins + source_element.Name + "." + target.Role + "\">"); //am juin 2011

                    }
                    else
                {
                    //tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(source_element) + source_element.Name + "." + target.Role + "\">"); //am juin 2011
                    tw.WriteLine("\t <rdf:Description rdf:about=\"" + urins + source_element.Name + "." + target.Role + "\">"); //am juin 2011

                    }
                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + target.Role + "</rdfs:label>");
                    bool fdesc = (profparameters.hasFullDesc(target_element.StereotypeEx) || profparameters.hasFullDesc(source_element.StereotypeEx));
                    // if ((target.RoleNote != "") && (profparameters.hasFullDesc(target_element.StereotypeEx)))
                    if ((target.RoleNote != "") && fdesc)
                         {

                        //tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + target.RoleNote + "</rdfs:comment>");
                        tw.WriteLine(specialCharactersFilter(target.RoleNote));
                    }
						
               // tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(source_element) + source_element.Name + "\"/>");  //augmented	                  
                tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + urisource + source_element.Name + "\"/>");  //augmented	                  

               //tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(target_element) + target_element.Name + "\"/>");// am juin 2011
                tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + uritarget + target_element.Name + "\"/>");// am juin 2011

                if (source.Role != "")
				{
				rname.elemid=source_element.ElementID;
				rname.rolename=source.Role;
					if(nomsRoles.Contains(rname)) 
					{
						/*******************
							MessageBox.Show( "WARNING this Role name " + source.Role
							+ " associated with " 
							+ source_element.Name 
							+ " has already been used\n"
							+ " verify if this is licit in your model");
						*******************/
						// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
										//+ " associated with "
										//+ target_element.Name
										//+ " has already been used\n"
										//+ " verify if this is licit in your model"
										//+ "\n");
					}else
					{
						nomsRoles.Add(rname);
					}
                
							
					if ((!target_element.StereotypeEx.Contains(EntsoeExpStereo))  && (source_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
					{
						//tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(source_element) + target_element.Name + "." + source.Role + "\"/>"); //am juin 2011
                        tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + target_element.Name + "." + source.Role + "\"/>"); //am juin 2011

                        }
                        else
					{
						//tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(target_element) + target_element.Name + "." + source.Role + "\"/>");
                        tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + target_element.Name + "." + source.Role + "\"/>");

                        }
                        //}
                        if (target.Cardinality != "")
					{
						string cardinality=target.Cardinality.Trim(); // am 2011
						cardinality=cardinality.Replace('*','n'); // am 2011
						tw.WriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + RDFutilitaires.eten(cardinality) + "\"/>");
					}
					if (isAggregatesource)
					{
							
						tw.WriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "ofAggregate\"/>");  // augmented
					}
						// ajout july 2012 usabilite
					if (ambiguite)
					{
						string used = "No";
						if (target.IsNavigable) used = "Yes";
						tw.WriteLine("\t<cims:AssociationUsed>" + used + "</cims:AssociationUsed>");
                      //
					}
					tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>");  //augmented
					
					if (con.Stereotype != "")
					{
						tw.WriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>");
					}
					
							tw.WriteLine("\t </rdf:Description>"); //augmented
				}
			}
            //tb.elapsetime("832");
            // COTE TARGET
			
			if(source.Role != "") 
			{ //there must be a non empty rolename
                  
				if ((!target_element.StereotypeEx.Contains(EntsoeExpStereo))  && (source_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
                {
                   // tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(source_element) + target_element.Name + "." + source.Role + "\">"); //am juin 2011
                    tw.WriteLine("\t <rdf:Description rdf:about=\"" + urins + target_element.Name + "." + source.Role + "\">"); //am juin 2011

                    }
                    else
                {
                   // tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(target_element) + target_element.Name + "." + source.Role + "\">"); //am juin 2011
                    tw.WriteLine("\t <rdf:Description rdf:about=\"" + urins + target_element.Name + "." + source.Role + "\">"); //am juin 2011

                    }

                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + source.Role + "</rdfs:label>");
                    bool fdesc = (profparameters.hasFullDesc(target_element.StereotypeEx) || profparameters.hasFullDesc(source_element.StereotypeEx));
                    // if ( (source.RoleNote != "") && (profparameters.hasFullDesc(source_element.StereotypeEx)))
                    if ((source.RoleNote != "") && fdesc) 
                    {

                        // tw.WriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + source.RoleNote + "</rdfs:comment>");
                        tw.WriteLine(specialCharactersFilter(source.RoleNote));
                    }
                 
				    //tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(target_element) + target_element.Name + "\"/>");
                     tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"" + uritarget + target_element.Name + "\"/>");

                    //tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(source_element) + source_element.Name + "\"/>");
                    tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"" + urisource + source_element.Name + "\"/>");

                    if (target.Role != "")  
				{ //there must be a non empty rolename  
                       		
					if ((!source_element.StereotypeEx.Contains(EntsoeExpStereo))  && (target_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
					{
						//tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(target_element) + source_element.Name + "." + target.Role + "\"/>"); //am fev 2016
                        tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + source_element.Name + "." + target.Role + "\"/>"); //am fev 2016

                        }
                        else
					{
                    //tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(source_element) + source_element.Name + "." + target.Role + "\"/>");
                    tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + source_element.Name + "." + target.Role + "\"/>");

                    }


                        if (source.Cardinality != "")
					{
						string cardinality=source.Cardinality.Trim(); // am 2011
						cardinality=cardinality.Replace('*','n'); // am 2011
                       
						tw.WriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:"  + RDFutilitaires.eten(cardinality) + "\"/>");
					}
					if (isAggregatetarget)
					{
							
						tw.WriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "ofAggregate\"/>");  // augmented
					}
						// ajout july 2012 usabilite
					if (ambiguite)
					{
						string used = "No";
						if (source.IsNavigable) used = "Yes";
						tw.WriteLine("\t<cims:AssociationUsed>" + used + "</cims:AssociationUsed>");
					}
						//
						
					tw.WriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>");  //augmented

					if (con.Stereotype != "")
					{
						tw.WriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>");
					}
						tw.WriteLine("\t </rdf:Description>"); //augmented
				}		
			}
		}
        //tb.elapsetime("902");
       // tb.stop();
        return true;
	}
      
       /// <sUMM2ary>
        /// retrieves recursively elements with a given stereotype or all elements
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public static List<EA.Element>  getAllElements(EA.Package package, List<EA.Element> resultList, String stereotype)
        {
            string inter;
           // Ta tb = new Ta("getAllElements pour package=" + package.Name + " lg result=" + resultList.Count.ToString());
            /* 18
	 if(stereotype == "all") // building of package containement
	{
	    //18 if (!dicpackbyid.ContainsKey(package.PackageID)) dicpackbyid.Add(package.PackageID,package);
        
	}
             * */
            foreach (EA.Element e in package.Elements)
            {
              //if(! RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"))   return resultList;   
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");                   
                inter = e.Stereotype;
                if (e.Stereotype.Equals(stereotype) || e.Stereotype == "" || stereotype == "all")
                {
                    resultList.Add(e);
                }
            }
            foreach (EA.Package p in package.Packages)
            {
                if ((RDFutilitaires.Barre != null) && ( !RDFutilitaires.Barre.go)) break;
               getAllElements(p, resultList, stereotype);
            }
            //tb.stop();
          return resultList;
        }

/**************************************************************************/
       public static List<EA.Connector>  getAllConnectors(EA.Package package, List<EA.Connector> resultList)
        {
            //Ta tb = new Ta("getAllConnectors pour package " + package.Name + " lg resultlist=" + resultList.Count.ToString());
           // if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return resultList; // am dec 15
            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");
            foreach (EA.Connector con  in package.Connectors)
            {

                    resultList.Add(con);
                
            }
            foreach (EA.Package p in package.Packages)
            {
                
               getAllConnectors(p, resultList);
            }
            //tb.stop();
          return resultList;
        }
/**************************************************************************/

       public static List<EA.Package>  getAllPackages(EA.Package package, List<EA.Package> resultList)
        {
           /*
            if(RDFutilitaires.Barre !=null)
            {
            if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return resultList; //am dec 15
            }
            */
           // Ta tb = new Ta("getAllPackages" + "lg resultlist=" + resultList.Count.ToString());
            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");
	         if(!resultList.Contains(package))
             {
                     resultList.Add(package);
             }
                   foreach (EA.Package pack  in package.Packages)
                     {
                         if (!resultList.Contains(package))
                       {
                         resultList.Add(package);
                         }
                    resultList.Add(pack);
                
            }
            foreach (EA.Package p in package.Packages)
            {
                
               getAllPackages(p, resultList);
            }
            //tb.stop();
          return resultList;
        }
/**************************************************************************/

       /// retrieves recursively elements which are like classe with a given list of stereotype for CIM which is in 2009 <<datatype>>,<<primitive>>,Enumeration>>,<<Compound>>
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public static List<EA.Element>  getStereotypedElements(EA.Package package, List<EA.Element> resultList,List<string> stereolist)
        {
            //Ta tb = new Ta("getStereotypedElements pour package=" + package.Name);
            string stereo;
            foreach (EA.Element e in package.Elements)
            {
                stereo = e.Stereotype;
                if(stereo == "" || stereolist.Contains(stereo))
                {
                    resultList.Add(e);
                }
                /* ABA20240828
                foreach (string s in stereolist)
                if(s == stereo || stereo == "")
                {
                    resultList.Add(e);
                }*/
            }
            foreach (EA.Package p in package.Packages)
            {
               getStereotypedElements(p, resultList, stereolist);
            }
            //tb.stop();
          return resultList;
        }

       /// <summary>
       /// Get all the elements in a package (without consulting descendant packages)
       /// wich have a stereotype according to a list
       /// </summary>
       /// <param name="package"></param>
       /// <param name="resultList"></param>
       /// <param name="stereolist"></param>
       /// <returns></returns>
        public static List<EA.Element>  getLocalStereotypedElements(EA.Package package,List<string> stereolist)
        {
           // Ta tb = new Ta("getLocalStereotypedElements pour package=" + package.Name);
           List<EA.Element> elemList = new List<EA.Element>();

            string stereo;
            foreach (EA.Element e in package.Elements)
            {
                stereo = e.Stereotype;
                if ((stereo == "")|| (stereolist.Contains(stereo)) ){
	
                    elemList.Add(e);
            }
                }

            //tb.stop();
          return elemList;
        }

/// <summary>
/// 
/// </summary>
/// <param name="ElList"></param>
/// <param name="id"></param>
/// <returns></returns>
    public static EA.Element getElementbyID(List<EA.Element> ElList,long id)
		 {
             EA.Element match = ElList.Find(e=>e.ElementID==id);
             string prov = match.Name;
		    
	          return match;
		}
       /// <summary>
       /// 
       /// </summary>
       /// <param name="elem"></param>
       /// <returns></returns>
    public static EA.Element  getElementSuperclass(EA.Element elem)
               {
                  // Ta tb = new Ta("getElementSuperclass pour elem=" + elem.Name);
             string prov=elem.Name;
              EA.Element tobereturn=null;
             foreach (EA.Connector con in elem.Connectors)
		{
            if (tobereturn != null) break;
            string s = con.Type;
                 switch(s )
		    {
        case  "Generalization":
                    if (con.SupplierID == elem.ElementID)
                    {
                        tobereturn = null;
                    }
                    else
                    {
                        //18 tobereturn = dicelembyid[con.SupplierID];
                        tobereturn = Main.Repo.GetElementByID((int)con.SupplierID); //18 dicelembyid[con.SupplierID]
                    }
		break;
		case "Dependency":
		break;
        case "Association":
		break;
		case "Aggregation":
		break;
		default:
            break;
		}
		}
             //tb.stop();
             return tobereturn;
               }

//------------------------------ 
       /// <summary>
       /// Get the direct element on which
       /// the current element is based on
       /// if the element is based on itself or without isbasedon dependancy 
       /// its ID is returned or "" if the element is nullC:\Users\andre\Documents\diversesdocs\EA\ESXSDAddin\Copie (3) de CIMSchemaGenerator.cs
       /// </summary>
       /// <param name="elem"></param>
       /// <returns></returns>
    public static EA.Element  getElementBasedonElement(EA.Element elem)
               {
                   //Ta tb = new Ta("getElementBasedonElement pour elem=" + elem.Name);
             string prov=elem.Name;
             EA.Element tobereturn = elem;
        /*18
             if (elem != null)
             {
          
                 if (elem.Connectors.Count > 0)
                 {
                     foreach (EA.Connector con in elem.Connectors)
                     {
                         string s = con.Type;
                         switch (s)
                         {
                             case "Generalization":

                                 break;
                             case "Dependency":
                                 if (con.SupplierID == elem.ElementID)
                                 {
                                     tobereturn = elem;
                                 }
                                 else
                                 {
                                     tobereturn = dicelembyid[con.SupplierID];
                                     //          ""MessageBox.Show( tobereturn.Name + "|" + tobereturn.PackageID.ToString());
                                 }
                                 break;
                             case "Association":
                                 break;
                             case "Aggregation":
                                 break;
                             default:
                                 break;
                         }
                     }
                 }
             }
        */
             string eltguid = RDFutilitaires.getEltParentGuid(elem);
             Main.Repo.GetElementByGuid(eltguid);
             //tb.stop();
             return tobereturn;
               }

//------------------------------ 
    //------------------------------ 
    /// <summary>
    /// Get the original element on which
    /// the current element is based on
    /// </summary>
    /// <param name="elem"></param>
    /// <returns></returns>
    public static EA.Element getElementOriginBasedonElement(EA.Element elem)
    {
        //Ta tb = new Ta("getElementOriginBasedonElement pour elem=" + elem.Name);
        string prov = elem.Name;
        EA.Element tobereturn = elem;
        EA.Element inter=elem;
        while(tobereturn !=   (inter =getElementBasedonElement(inter))){
            tobereturn = inter;
        }
        //tb.stop();
        return tobereturn;
    }

    //------------------------------ 
       public static string SelectFileAndCopy(string FileName)
		{
	Stream myStream = null;
    string nomfichier = "";
	SaveFileDialog saveFileDialog1 = new SaveFileDialog();
    // saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"  ;
    saveFileDialog1.Filter = "rdf files (*.rdf)|*.rdf|All files (*.*)|*.*";
     saveFileDialog1.FilterIndex = 1 ;
     saveFileDialog1.RestoreDirectory = true ;

    if(saveFileDialog1.ShowDialog() == DialogResult.OK)
    {
 
        try
        {
            if ((myStream = saveFileDialog1.OpenFile()) != null)
            {
 
                using (myStream)
                {
		       nomfichier = saveFileDialog1.FileName;
                    // Insert code to write the stream here.
      
         //           MessageBox.Show(FileName);
          //          MessageBox.Show(nomfichier);
  
        try 
        {
            myStream.Close();

  
            System.IO.File.Delete(nomfichier);

            // Copy the file.
  
            System.IO.File.Copy(FileName, nomfichier);
            System.IO.File.Delete(FileName);
          //  MessageBox.Show(FileName + " | " + nomfichier);
            Console.WriteLine("{0} copied to {1}", FileName, nomfichier);
         } 
        catch 
        {
            Console.WriteLine( "copy is not allowed, which was not expected.");
        } 
   
                 }
 
         //       princ.StartProcess("", nomfichier);
            }
        }
        catch (Exception ex)
        {
            MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Error: Could not read file from disk. Original error: " + ex.Message + "\n");
        }
    }
            saveFileDialog1.Dispose(); // ABA20230729
return nomfichier;
}
//---------------------------------------------------------
     /// <summary>
     /// get the Package in which the object on which 
     /// the element is based on is situated
     /// </summary>
     /// <param name="el"></param>
     /// <returns>ArrayList[0]= path to the isbasedon class
     ///          ArrayList[1]= path to the isbasedon class</returns>
       public static ArrayList GetPackageBasedOnContainmentPath(EA.Element el)
       {
         //  Ta tb = new Ta("GetPackageBasedOnContainmentPath pour element=" + el.Name);
           EA.Element elbase;
           ArrayList forreturn = new ArrayList();
           forreturn.Add("");
           forreturn.Add(null);

           try
           {
 
		if(el != null) {
               if (el == null)
               { // this is a locally defined element
                    elbase = el;
               }
               else
               {
                   elbase = getElementBasedonElement(el);
               }
               if (elbase == null) elbase = el;

               List<String> chemin = new List<String>();
               DirectPackageContainmentPath(RDFLAutilitaires.dicrepobyid[elbase.PackageID], chemin);
               chemin.Reverse();
               StringBuilder bchemin = new StringBuilder();
               chemin.ForEach(delegate(String name)
                   {
                       bchemin.Append("/" + name);
                   });
               forreturn[0]= bchemin.ToString();
               forreturn[1] = elbase;
              // tb.stop();
               return forreturn;
           }else{ 
            MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
       //tb.stop();
            return forreturn;
           }
           }
           catch
           {
               MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");

        //tb.stop();
                return forreturn;
           }       
  }
       //---------------------------------------------------------
       /// <summary>
       /// get the Package in which the object on which 
       /// the element is based at the Model Information origin on is situated
       /// </summary>
       /// <param name="el"></param>
       /// <returns>ArrayList[0]= path to the isbasedon class
       ///          ArrayList[1]= path to the isbasedon class</returns>
       public static ArrayList GetPackageBasedOnOriginContainmentPath(EA.Element el)
       {
//      Ta tb = new Ta("GetPackageBasedOnOriginContainmentPath pour element=" + el.Name);
           EA.Element elbase;
           ArrayList forreturn = new ArrayList();
           forreturn.Add("");
           forreturn.Add(null);
           try
           {
  
               if (el != null)
               {
                   if (el == null)
                   { // this is a locally defined element
                       elbase = el;
                   }
                   else
                   {
                       elbase = getElementBasedonElement(el);
                   }
                   if (elbase == null) elbase = el;

                   List<String> chemin = new List<String>();
                   DirectPackageContainmentPath(RDFLAutilitaires.dicrepobyid[elbase.PackageID], chemin);
                   chemin.Reverse();
                   StringBuilder bchemin = new StringBuilder();
                   chemin.ForEach(delegate(String name)
                   {
                       bchemin.Append("/" + name);
                   });
                   forreturn[0] = bchemin.ToString();
                   forreturn[1] = elbase;
                   forreturn[0] = bchemin.ToString();
                   forreturn[1] = elbase;
                 //  tb.stop();
                   return forreturn;
                 
               }
               else
               {
                   MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                //tb.stop(); 
                    return forreturn; ;
               }
           }
           catch
           {
               MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath " + "\n");
                //tb.stop(); 
                return forreturn; ;
           }
       }
  

  
//--------------------------------------------------------
       /// <summary>
       /// calculate the Package containment from a given Package
       /// the result is in the form of a string list in reverse order
       /// </summary>
       /// <param name="pa"></param>
       /// <param name="path"></param>
        static void  DirectPackageContainmentPath(EA.Package pa, List<String> path)
        {
          //  Ta tb = new Ta("DirectPackageContainmentPath  lg result=" + path.Count.ToString());
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
     
            {
                DirectPackageContainmentPath(RDFLAutilitaires.dicrepobyid[pa.ParentID],path);

            }
            //tb.stop();
        }	
//-------------------------
        static public bool isnumeric(string s)
        {
            List<char> digits = new List<char>("0123456789");
            bool result = true;
            List<char> ss = new List<char>(s);
            foreach  (char c in ss)
            {
                if (!digits.Contains(c))
                {
                    result = false;
                    break;
                }
            }
            return result;
        }
                
//---------------------------------------------------
       /// <summary>
       ///  give the list of all classes of a package (including all included packages)
       ///  which are without ascendant (rootclass in WG19NDR terms)
       /// </summary>
       /// <param name="package"></param>
       /// <param name="resultlist" </param>
       /// <returns></returns>
        static public void  GetClassesWithoutAscendant(EA.Package package,List<long> resultlist)
        {
            /*
            if (RDFutilitaires.Barre != null)
            {
                if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return; //am dec 15
            }
             * */
           // Ta tb = new Ta("GetClassesWithoutAscendant pour package=" + package.Name + "  lg result=" + resultlist.Count.ToString());
            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");
                   foreach (EA.Element e in package.Elements)
            {
                if ((e.Stereotype == "Class"  || e.Stereotype == "" )&& e.IsActive )
                {
                    //MessageBox.Show("|" + e.ElementID + "|" + e.Name + "|");
                if(! resultlist.Contains(e.ElementID)){
                    resultlist.Add(e.ElementID);
                }
                }
            }
            foreach (EA.Package p in package.Packages)
            {
             GetClassesWithoutAscendant( p, resultlist);
            }
          ;
          //tb.stop();
        }
//---------------------------------------------------------------------------------------------    
/**************************************************************************/
       public static List<long>  getAllPackID(long pid, List<long> resultList)
        {
           // Ta tb = new Ta("getAllPack"+ " lg resultlist=" + resultList.Count.ToString());
            string prov;
	    EA.Package package;
        //18package = dicpackbyid[pid];
        package = Main.Repo.GetPackageByID((int)pid);
	    long packid=0;
        //if (!RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress")) return resultList; //am dec 15
        RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");
	    prov=package.Name;
	         if(!resultList.Contains(pid))
             { 
                 resultList.Add(pid);
             }
                   foreach (EA.Package pack  in package.Packages)
                     {
                        packid=pack.PackageID;
                         prov = pack.Name;
                    resultList.Add(packid);
                
            }
            foreach (EA.Package p in package.Packages)
            {
		packid=p.PackageID;
               getAllPackID(packid, resultList);
            }
            //tb.stop();
          return resultList;
        }
/**************************************************************************/
       public static void buildLocalClassNames(EA.Package apackage, List<string> classnamelist)
       {
           //Ta tb = new Ta("buildLocalClassNames pour package=" + apackage.Name);
           List<EA.Element> ellist = new List<EA.Element>();
           RDFutilitaires.getTypedElements(apackage, ellist, "Class");
           foreach (EA.Element el in ellist)
           {
               if (el.Name != null)
               {
                   classnamelist.Add(el.Name);

                   //  MessageBox.Show(" classtype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
               }
           }
           //tb.stop();
       }

        //-------------------------------------------------------------------------- 
public static void  buildLocalDatatypeNames(EA.Package apackage,List<string> datanamelist,List<long> dataidlist){
    //Ta tb = new Ta("buildLocalDatatypeNames pour package=" + apackage.Name);
    List<EA.Element> ellist = new List<EA.Element>();
    RDFutilitaires.getStereotypedElements(apackage,ellist,new List<string>()
                                      {
	                                "Datatype",
				     CD.GetDatatypeStereotype(),
                                     CD.GetPrimitiveStereotype(),
	                             CD.GetCompoundStereotype(),
	                              CD.GetEnumStereotype(),
                                       });
  
	foreach(EA.Element el in ellist){
	if(el.Name != null) {
	datanamelist.Add(el.Name);
    dataidlist.Add(el.ElementID);
     //  MessageBox.Show(" datatype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
			}}
     //tb.stop();
}  
       //------------------------

public string getURI(EA.Element elt)
{
    string prov = elt.Name;

            // XMLParser xmlp = new XMLParser();
            XMLParser xmlp = new XMLParser(repo);
    string ret = "";
    string stereoex = elt.StereotypeEx;
    string liststereos = xmlp.GetXmlValueProfData("ListStereoNamespace");
    string uridebase=profparameters.RootModelURI;
    if (xmlp.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
    {
        string eligible = "";
        string[] splitns = liststereos.Split('|');
        for (int i = 0; i < splitns.Length; i++)
        {

            if (splitns[i].Contains(","))
            {
                eligible = splitns[i];
                string[] split = splitns[i].Split(',');
                for (int j = 0; j < split.Length; j++)
                {
                    if (!StereoExContainsStereo(stereoex,split[j]))
                    {
                        eligible = "";
                        break;
                    }

                }
            }
            else
            {
                if (StereoExContainsStereo(stereoex,splitns[i]))
                {
                    eligible = splitns[i];
                    break;
                }

            }

        }
        if (eligible != "")
        {// on a trouve un stereotype qui convient
            if (Main.IndStereos[eligible]["RDFS"])
            {
                string[] prefuri = profparameters.urisbystereo[eligible];
                if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                {
                    if (prefuri[0] != profparameters.Prefix)
                    {
                        ret = prefuri[1]; // +"#";
                    }
                    else
                    {
                        ret = "#";
                    }
                }  
            }
            else
            {
                if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                {
                    ret = "#";
                }

                else
                {
                    ret = NS_J0;
                }
            }
                
        }
        else
        {
            if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
            {
                ret = "#";
            }

            else
            {
                ret = NS_J0;
            }
        }
    }
    else
    {
        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
        {
            ret = "#";
        }
        
        else
        {
            ret=NS_J0;
        }
    }
    return ret;
}
       /// <summary>
       /// recherche le bon URI pour un attribut
       /// attention le choix aujourd'hui est de privilegier
       /// l'extension sur la classe a l'extension sur l'attribut
       /// </summary>
       /// <param name="elt"></param>
       /// <param name="atr"></param>
       /// <returns></returns>
string getURI(EA.Element elt,EA.Attribute atr)
{
    string ret = "";
    string prov = elt.Name;
    string prov1 = atr.Name;
    XMLParser xmlp = new XMLParser(repo);
    string stereoex = elt.StereotypeEx;
    string atrstereoex=atr.StereotypeEx;
    string liststereos = xmlp.GetXmlValueProfData("ListStereoNamespace");
    string uridebase = profparameters.RootModelURI;
    if (xmlp.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
    {
        string eligible = "";
        string[] splitns = liststereos.Split('|');
        for (int i = 0; i < splitns.Length; i++)
        {

            if (splitns[i].Contains(","))
            {
                eligible = splitns[i];
                string[] split = splitns[i].Split(',');
                for (int j = 0; j < split.Length; j++)
                {
                    if (!StereoExContainsStereo(stereoex,split[j])&& !StereoExContainsStereo(atrstereoex,split[j]))
                    {
                        eligible = "";
                        break;
                    }

                }
            }
            else
            {
                if (StereoExContainsStereo(stereoex,splitns[i]) || StereoExContainsStereo(atrstereoex,splitns[i]))
                {
                    eligible = splitns[i];
                    break;
                }

            }

        }
        if (eligible != "")
        {// on a trouve un stereotype qui convient
            if (Main.IndStereos[eligible]["RDFS"])
            {
                string[] prefuri = profparameters.urisbystereo[eligible];
                if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked"){
                if (prefuri[0] != profparameters.Prefix){
                    ret = prefuri[1]; //+ "#";
                }else{
                    ret = "#";
                }
                }
            }
            else
            {
                if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
                {
                    ret = "#";
                }

                else
                {
                    ret = NS_J0;
                }
            }

        }
        else
        {
            if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
            {
                ret = "#";
            }

            else
            {
                ret = NS_J0;
            }
        }
    }
    else
    {

        if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
        {
            ret = "#";
        }

        else
        {
            ret = NS_J0;
        }
    }

    return ret;
}
public string getURI(EA.Package pack)
{
    string ret = "";
    XMLParser xmlp = new XMLParser(repo);
      if (xmlp.GetXmlValueConfig("Xmlbase") == "Checked")
        {
            ret = "#";
        }

        else
        {
            ret = NS_J0;
        }
    

    return ret;
}

       /// <summary>
       /// initialisation de Main.Indstereos
       /// </summary>
       /// <param name="?"></param>
 static public void InitIndStereos(string[] stereos,XMLParser xmlp)
 {
     foreach (string stereo in stereos)
     {      
         ArrayList  indicateurs=xmlp.GetXmlProfstereo( stereo);
         Dictionary<string, bool> indics = new Dictionary<string, bool>();
         if((string)indicateurs[2]=="Unchecked")
         {
         indics.Add("HtmlDoc", false);
         }else{
             indics.Add("HtmlDoc", true);
         }
           if((string)indicateurs[2]=="Unchecked")
         {
         indics.Add("RDFS", false);
         }
           else
           {
          indics.Add("RDFS", true);
           }
         if (!Main.IndStereos.ContainsKey(stereo))
         {
             Main.IndStereos.Add(stereo, indics);
         }
     }
 }

/// <summary>
/// give an index to publish one element given its stereos
//
/// </summary>
/// <param name="stereos"></param>
/// <returns>
///    0 not publishable
///    1 publishable as rdfs, not as html
///    2 publishable as html, not as rdfs
///    3 publishable as rdfs and html
/// </returns>
static public int getPublishable(string stereos)
        {
            
            int rdfs = 1;
            int html = 2;
            string[] stereolist = stereos.Split(new char[] { ',' });
            foreach(string stereo in stereolist)
            {
                if(Main.IndStereos.ContainsKey(stereo))
                {
                    if (!Main.IndStereos[stereo]["RDFS"]) rdfs = 0;
                    if (!Main.IndStereos[stereo]["HtmlDoc"]) html = 0;
                }
            }
            return rdfs+html;
        }
 /// <summary>
 /// les stereosEx se prsentent sous la forme de listes de
 /// string.
 /// Ce programme redonne une chaine liste o tous les membres sont dans l'ordre alaphabtique
 /// </summary>
 /// <param name="stereos"></param>
static  public string RedressStereo(string stereos)
 {
     string ret = "";
     string[] ss = stereos.Split(',');
     List<string> lss = new List<string>(ss);
     lss.Sort();
     StringBuilder newstereos = new StringBuilder();
     foreach (string s in lss)
     {
         newstereos.Append("," + s);
     }
     ret = newstereos.ToString().Trim(',');
     return ret;
 }

 public static  bool StereoExContainsStereo(string stereoex, string stereo)
 {
     bool ret = false;
     if (!stereo.Contains(","))
     {
         foreach (string ss in stereo.Split(','))
         {
             if (stereoex.Contains(stereo))
             {
                 ret = true;
                 break;
             }
         }
     }
     else
     {
         if (!stereoex.Contains(","))
         {
             ret = false;
         }
         else
         {

             stereo = RedressStereo(stereo);
             stereoex = RedressStereo(stereoex);

             if (stereoex.Contains(stereo))
             {// ATTENTION cet algorithme peut etre faux dans le cas peu probable ou on trouve
                 // par ex  stereoex=Enstsoe,Operational  stereo=Entsoe,Operation
                 ret = true;
             }
         }
     }
     return ret;
 }

/// <summary>
/// verifie l'appartenance d'au moins une des chaines de stereoex  une liste de chaines
/// </summary>
/// <param name="stereoex"></param>
/// <param name="stereo"></param>
/// <returns></returns>
 public static bool StereoExContainsStereo(string stereoex, List<string> stereos)
 {
     bool ret = false;
     
         foreach (string ss in stereos)
         {
             if (stereoex.Contains(ss))
             {
                 ret = true;
                 break;
             }
         }
     return ret;
 }
  

//----------------------------------------------------------------------------------------------------------------  
 /// <summary>
 /// serialisation avec export selon le stereotype am 271015
 /// </summary>
 /// <param name="package"></param>
 /// <param name="dicTwbyStereotype"></param>
  public bool serialize(Package package, Dictionary<string, TextWriter> dicTwbyStereotype)
 {
     //Ta tb = new Ta("serialize dictw pour package=" + package.Name);
     string prov1 = package.Name;
     List<EA.Element> elemliste = new List<EA.Element>();
     // dejatraite = new List<long>();
     // datatypedone = new List<long>();
     // traitement du package
     traitpackage(package,dicTwbyStereotype );

     //traitement des classes
     foreach (EA.Element e in package.Elements)
     {
         RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
         if (e.Type == "Class")
         {
             if (e.Name != "")
             { // on ne traite pas les elements sans nom
                 {
                     if (!NoDoublons.Contains(e.Name))
                     {
                         NoDoublons.Add(e.Name);
                     }
                     else
                     {
                         // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING there are at least two classes of the same name {" + e.Name + "} in the profile");
                         MessageBox.Show(" WARNING  there are at least two classes of the same name {" + e.Name + "} in the profile ");

                         //tb.stop(); 
                         return false;
                     }
                     if (e.Name == "Accumulator")
                     {
                         string prov = e.Name;
                     }
                   //  MessageBox.Show("traitclass " + e.Name);
                     traitclass(e, dicTwbyStereotype);
                 };
             }
             else
             {
                 //  // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING an element without name of GUI" + e.ElementGUID + "has been encountered and zapped");
             }

         }
     }
            //tb.stop(); 
            return true;
 }

  void twWriteLine(string ss)
  {
      foreach (KeyValuePair<string, TextWriter> kv in Main.dicTwbyStereotype)
      {
         
              kv.Value.WriteLine(ss);
          
      }
  }

  void twWriteLine(string ss,bool exportable)
  {
      foreach (KeyValuePair<string, TextWriter> kv in Main.dicTwbyStereotype)
      {
          if ((kv.Key.ToString() == "all") || exportable)
          {
              kv.Value.WriteLine(ss);
          }

      }
  }
  void twWriteLine(string ss, List<string> exportable)
  {
      foreach (KeyValuePair<string, TextWriter> kv in Main.dicTwbyStereotype)
      {
          if ((kv.Key.ToString() == "all") || exportable.Contains(kv.Key.ToString()))
             
          {
              kv.Value.WriteLine(ss);
          }

      }
  }

/*******************************************************************/

          public bool traitclass(EA.Element elem, Dictionary<string,TextWriter> dictw)
          {
            if (Main.typerdfexport == "2020")
            {
                if (elem.Name.Contains("Version")) return false;//  Version class is eliminated
                if (elem.Name.Contains("Ontology")) return false; // Ontology class is eliminated (beeing in header)
            }
            if (elem.Name.Contains("Version")) return false;// on elimine la classe Version
            if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
                || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitclass " + elem.Name +"not  publishabled");
                return false;//am mai 2020Ta 
            }
            //Ta tb = new Ta("traitclass dictw pour elem=" + elem.Name);
              try { 
              string prov = elem.Name;
              if ((elem.Name == "ACDCConverter") || (elem.Name== "ACDCConverter"))
              {
                   prov = "";
              }
            //  bool exportable = isExportable(elem.StereotypeEx);
                 List<string> exportable = getExportable(elem.StereotypeEx);
              
             

   // MessageBox.Show(" classe=" + elem.Name);
              ConstDefinition constantes = new ConstDefinition();
              bool answer = false;
              bool datatype = false;
               if (exportable.Count >0)             
              {
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n*** entsoe export by stereotypes  Treatment of  exportable Element <<" + elem.StereotypeEx + ">> " + elem.Name);
              }
              if ( (elem.Type == "Class") || (elem.Type=="Enumeration")) // am juil 2016
              {
                  if ((elem.Stereotype != CD.GetEnumStereotype()) && (elem.Type !="Enumeration"))  // not an enumeration
                  {
		        bool todo=true;
                      if(StereoExContainsStereo(elem.StereotypeEx,"Datatype")
                        || StereoExContainsStereo(elem.StereotypeEx,CD.GetPrimitiveStereotype())
                        ||StereoExContainsStereo(elem.StereotypeEx,CD.GetCompoundStereotype())  
                        ||StereoExContainsStereo(elem.StereotypeEx,CD.GetDatatypeStereotype()))
                       {
                datatype = true;
                if (datatypedone.Contains(elem.ElementID)) { // the datatype have already been treated
                          todo=false;
			}else{
			  if(LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID))  todo=false;// the datatype is already   part of the profile	
	
			}}
		     if(todo == true){
			if(!datatypedone.Contains(elem.ElementID)) datatypedone.Add(elem.ElementID); //am juil 2016  j'ai mes doutes sur ce tes
            if(!LocalDatatypeNames.Contains(elem.Name))LocalDatatypeNames.Add(elem.Name); // to avoid duplication of identifier name references

                     // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 + elem.Name + "\">");    // augmented
                     twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem)+ elem.Name + "\">",exportable);    // am juin 2011

                      twWriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>",exportable);
             
                      // is there a superclass?
    
                      EA.Element superclass = getElementSuperclass(elem);
 
                      if (superclass != null)
                      {
			 // tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"" + NS_J0 +  superclass.Name + "\"/>");
                          twWriteLine("\t<rdfs:subClassOf rdf:resource=\"" + getURI(superclass) +  superclass.Name + "\"/>",exportable);
                      }
                      if((elem.Notes != "") &&  (profparameters.hasFullDesc(elem.StereotypeEx)))
                            {
				                //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(elem.Notes) + "</rdfs:comment>",exportable);
                                 twWriteLine(specialCharactersFilter(elem.Notes),exportable);
                            }

                    /****************** am fev 016
                      if (elem.Stereotype != "")
                      {
                          twWriteLine("<cims:stereotype>" + elem.Stereotype + "</cims:stereotype>",exportable);
                         
                      }
                   *********************/
                      if (elem.StereotypeEx != "")
                      {
                          string[] split = elem.StereotypeEx.Split(',');
                          for (int i = 0; i < split.Length; i++)
                          {
                              twWriteLine("<cims:stereotype>" + split[i] + "</cims:stereotype>", exportable);
                          }
                      }
                      EA.Package pa = Main.Repo.GetPackageByID((int)elem.PackageID);
                            XMLParser XMLP = new XMLParser(Main.Repo);
                      if ((datatype == true) && !LocalDatatypeIDs.Contains(elem.ElementID))
                      {  // it is a datatype copied from above level
                          if (Main.typerdfexport == "2019")
                          {
                              string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                              twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                          }
                          else
                          { 
                                //string luri = (new XMLParser()).GetXmlValueConfig("Xmlbase") == "Checked" ? "#" : NS_J0;
                                //twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + luri + "Package_" + pa.Name + "\"/>",exportable);//am juin 2011 PROBLEME
                                twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                          }
                      }
                      else
                      {		
                        //twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + getURI(Main.Repo.GetPackageByID((int)elem.PackageID)) + "Package_" + Main.Repo.GetPackageByID((int)elem.PackageID).Name + "\"/>", exportable);
                         twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                      }

              
                      //	 tw.WriteLine("</rdfs:Class>");

                      if ((elem.Abstract != "1" )&& (datatype== false))
                      {
                          twWriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "concrete\"/>",exportable);    //augmented
                      }
                      twWriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDFS + "Class\"/>",exportable);   //augmented
                      twWriteLine("\t </rdf:Description>",exportable);  // augmented

                      // traitement des attributs
                      foreach (EA.Attribute att in elem.Attributes)
                      {
                          traitAttribute(elem, att, dictw);
                      }
                      // traitement des associations
                      EA.Collection connectors = elem.Connectors;
                      foreach (EA.Connector con in connectors)
                      {
                                if(con.ConnectorID==40375)
                                {
                                    long id = con.ConnectorID;
                                }
                          // on verifie que le connector n'a pas ete deja traite dans un autre package
                          if (!dejatraite.Contains(con.ConnectorID))
                          {
                             if(con.ConnectorID != 0) dejatraite.Add(con.ConnectorID);
                           
                              traitConnector(con, dictw);
                          }
                      }



                      answer = true;
                      //tb.stop(); 
                      return answer;
			}
                  }
                  else
                  { // is an enumeration
			 bool todo=true;
			if (datatypedone.Contains(elem.ElementID)){  // the datatype have already been treated
                          todo=false;
			}else{
			  if(LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID))  todo=false;// the datatype is already   part of the profile
              
            }
			if (todo == true ) {
			datatypedone.Add(elem.ElementID);
            LocalDatatypeNames.Add(elem.Name); // to avoid duplication of identifier name references // am june 2011     
                     // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name +  "\">");    // augmented
			 twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem) +  elem.Name +  "\">",exportable);    // augmented
                      twWriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>",exportable);
                      // we suppose there is NO  superclass?
                      if((elem.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
                            {
			 
                          //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(elem.Notes) + "</rdfs:comment>",exportable);
                          twWriteLine(specialCharactersFilter(elem.Notes),exportable);
                            }
                            //  tw.WriteLine("\t<cims:belongsToCategory rdf:resource=" + dicpackbyid[elem.PackageID].Name + "\"/>");
                            EA.Package pa = Main.Repo.GetPackageByID((int)elem.PackageID);
                            if (!LocalDatatypeIDs.Contains(elem.ElementID))
                            {  // it is a datatype copied from above level
                                if (Main.typerdfexport == "2019")
                                {
                                    string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                    twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                                }
                                else
                                {

                                    // twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + NS_J0 + "Package_" + DatatypePackageName + "\"/>",exportable);// am juin 2011 PROBLEME
                                    twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                                }
                            }
                            else
                            {
                                if (Main.typerdfexport == "2019")
                                {
                                    string profuri = XMLP.GetXmlValueProfData("ProfileNamespace");
                                    twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + profuri + GetCategoryName(pa.Name) + "\"/>");
                                }
                                else
                                {
                                    //twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + getURI(Main.Repo.GetPackageByID(elem.PackageID)) + "Package_" + Main.Repo.GetPackageByID(elem.PackageID).Name + "\"/>", exportable);  // am juin 2011 
                                    twWriteLine("\t<cims:belongsToCategory rdf:resource=\"" + namespaces[profparameters.Prefix] + GetCategoryName(pa.Name) + "\"/>");
                                }
                            }
                   //   tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"" + NS_J0 + "Package_" + dicpackbyid[elem.PackageID].Name + "\"/>");
                      twWriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "enumeration\"/>",exportable);    //augmented
                      //  tw.WriteLine("</rdfs:Class>");
                /*************** ajout am fev 2016 ***************************/
                      if (elem.StereotypeEx != "")
                      {
                          string[] split = elem.StereotypeEx.Split(',');
                          for (int i = 0; i < split.Length; i++)
                          {
                              if ((split[i] != "enumeration") && (split[i] != "Enumeration"))
                              {
                                  twWriteLine("<cims:stereotype>" + split[i] + "</cims:stereotype>", exportable);
                              }
                          }
                      }
                 /*********************************************************/
                      twWriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDFS + "Class\"/>",exportable);   //augmented
                      twWriteLine("\t </rdf:Description>",exportable);  // augmented
                      foreach (EA.Attribute att in elem.Attributes)
                      {
                          traitEnummember(elem, att, dictw);

                      }


                      answer = true;
                      //tb.stop(); 
                      return answer;

                  }

              }}
                //tb.stop();
                return answer;
                }catch(Exception e)
                 {
              string mes="error" +e.Message;
                 }
              //tb.stop();
              return false;
          
          }

          private bool isExportable(string ss)
          {
    
              bool res = false;
              // ss is StereotypeEx
              // it is exportable if ss contains an exportable Stereotype
              string[] gg = ss.Split(',');
              for (int i = 0; i < gg.Length; i++)
              {
                /* ABA20230905
                  if(gg[i]=="Primitive")
                  {
                      string prov = "";
                  }*/
                  bool a = gg[i] == "";
                  bool b = profparameters.ListStereoNamespaceExport.Contains(gg[i]);
                  bool c = profparameters.ListStereoNamespace.Contains(gg[i]);
                  bool d = profparameters.ListCimstereos.Contains(gg[i]);
                  bool e=profparameters.ListStereoNamespaceExport.Contains(gg[i]);
                  bool f = ((c || d) && (!e));
                  bool g= a || b || f;
                  if(     a
                      ||  b
                      ||  f
                      )
                  {
                      res = true;
                      break;
                  }
              }
                  return res;
          }


//-------------------------------------------------------
          public bool traitAttribute(EA.Element elem, EA.Attribute attribute, Dictionary<string,TextWriter> dictw)
          {

            if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
                || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitAttribute " + elem.Name + "." + attribute.Name + "not  publishabled");
                return false;//am mai 2020Ta tb = new Ta("traitAttribute dictw pour atr=" + attribute.Name);
                
            }
            //Ta tb = new Ta("traitAttribute pour attribute=" + elem.Name + "." + attribute.Name);
            int classifierid=(int)attribute.ClassifierID;//am aout 2018
              if (attribute.Name == "backwardCompatibleWith")
            {
                  string prov = elem.Name;
              }
             // bool exportable = isExportable(attribute.StereotypeEx);
              List<string> exportableparent = getExportable(elem.StereotypeEx);
              List<string> exportable = getExportable(attribute.StereotypeEx,exportableparent);
             
              if (exportable.Count >0)
              {
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n*** entsoe export by stereotypes  Treatment of  Exportable  Attribute <<" + attribute.StereotypeEx + ">> " + attribute.Name);
              }
              ConstDefinition constantes = new ConstDefinition();
              bool answer = false;

              // tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name+ "." + attribute.Name +  "\">");  // augmented
              twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem, attribute) + elem.Name + "." + attribute.Name + "\">",exportable);// am juin 2011
              twWriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "attribute\"/>",exportable);  // augmented
              twWriteLine("\t<rdfs:label xml:lang=\"en\">" + attribute.Name + "</rdfs:label>",exportable);
              //tw.WriteLine("\t<rdfs:domain rdf:resource=\"" + NS_J0 + elem.Name + "\"/>");   //augmented
              twWriteLine("\t<rdfs:domain rdf:resource=\"" + getURI(elem) + elem.Name + "\"/>",exportable);  //am juin 2011
              // tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"#" + attribute.Type + "\"/>"); 
             //18  if ((attribute.ClassifierID != 0) && (dicelembyid.ContainsKey(attribute.ClassifierID)))
              if(classifierid != 0)
              {
                  EA.Element classifier =Main.Repo.GetElementByID(classifierid); //dicelembyid[attribute.ClassifierID];//18
                  if (StereoExContainsStereo(classifier.StereotypeEx, CD.GetEnumStereotype()))
                  {
                      twWriteLine("\t<rdfs:range rdf:resource=\"" + getURI(classifier) + classifier.Name + "\"/>",exportable);
                  }
                  else
                  {
                      twWriteLine("\t<cims:dataType rdf:resource=\"" + getURI(classifier) + classifier.Name + "\"/>",exportable);   //augmented
                  }
              }

              else
              {
                  // tw.WriteLine("\t<cims:dataType rdf:resource=\"" + NS_J0 + attribute.Type + "\"/>");   //augmented
                  twWriteLine("\t<cims:dataType rdf:resource=\"" + getURI(elem, attribute) + attribute.Type + "\"/>",exportable);   //augmented
              }

              /* ********* addition am feb 2010 ****************/
              string upperbound = attribute.UpperBound.Trim();  // am june 2011
              if (upperbound == "*") upperbound = "n";

              string multiplicity = attribute.LowerBound + ".." + upperbound;
              twWriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + RDFutilitaires.eten(multiplicity) + "\" />",exportable);

              if (attribute.Default != "")
              {
                  if (attribute.IsConst)
                  {
                    //twWriteLine("\t<cims:isFixed rdfs:Literal=\"" + attribute.Default + "\" />", exportable);
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    twWriteLine("\t<cims:isFixed rdf:datatype=\"http://www.w3.org/2001/XMLSchema#"+type+"\">" + attribute.Default + "</cims:isFixed>",exportable);//"\" />");
              
                }
                  else
                  {
                    //twWriteLine("\t<cims:isDefault rdfs:Literal=\"" + attribute.Default + "\" />",exportable);
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    twWriteLine("\t<cims:isDefault rdf:datatype=\"http://www.w3.org/2001/XMLSchema#" + type + "\">" + attribute.Default + "</cims:isDefault>", exportable);//"\" />");
                }
              }

              // if (attribute.Stereotype != "") {
              if (attribute.StereotypeEx != "")
              { // am may 2011
                  string[] stereos = attribute.StereotypeEx.Split(',');
                  foreach (string stereo in stereos)
                  {
                      twWriteLine("\t<cims:stereotype>" + stereo + "</cims:stereotype>",exportable);
                  }
              }
              /*************************************************/
              if ((attribute.Notes != "") && ((profparameters.hasFullDesc(elem.StereotypeEx)) || (profparameters.hasFullDesc(attribute.StereotypeEx))))
            {

                //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(attribute.Notes) + "</rdfs:comment>",exportable);
                twWriteLine(specialCharactersFilter(attribute.Notes),exportable);
            }

              // tw.WriteLine("</rdf:Property>");
              twWriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>",exportable);  //augmented
              twWriteLine("\t </rdf:Description>",exportable); //augmented
              /*am aout 2018
              if ((attribute.ClassifierID != 0) && (dicelembyid.ContainsKey(attribute.ClassifierID)) && !datatypedone.Contains(attribute.ClassifierID))
              { // the datatype hasnot  been already generated ?  
                  traitclass(dicelembyid[attribute.ClassifierID], dictw);
                  datatypedone.Add(attribute.ClassifierID);
              }
               * */
              if ((classifierid != 0) && (!datatypedone.Contains(attribute.ClassifierID)))
              {
                  // the datatype hasnot  been already generated ?  
                  traitclass(Main.Repo.GetElementByID(classifierid),dictw);
                  datatypedone.Add((long)classifierid);
              }  
              answer = true;
             // tb.stop(); 
              return answer;
          }

          private List<string> oldgetExportable(string ss)
          {
              List<string> res = new List<string>();
              if (ss == "")
              {
                  foreach (string stereo in profparameters.ListStereoNamespaceExport)
                  {
                      res.Add(stereo);
                  }
                  res.Add("all");
                  if (!res.Contains("")) res.Add(""); //additional exportable stereoypes
                  return res;
              }
              string[] split = ss.Split(',');
              for(int i=0;i<split.Length;i++)
              {
                  if(profparameters.ListStereoNamespaceExport.Contains(split[i]))
                  {
                      res.Add(split[i]); //strictly exportable stereoypes
                    if (!res.Contains("all")) res.Add("all");
                  }
                  if (!profparameters.ListStereoNamespaceExport.Contains(split[i])
                      &&
                       (
                       profparameters.ListCimstereos.Contains(split[i])
                      || profparameters.ListStereoNamespace.Contains(split[i])
                      ))
                  {
                      foreach (string stereo in profparameters.ListStereoNamespaceExport)
                      {
                          res.Add(stereo);
                      }
                    if (!res.Contains("all")) res.Add("all"); res.Add("all");
                      if (!res.Contains("")) res.Add(""); //additional exportable stereoypes
                     
                  }              
              }
          
              return res;
             
          }
       /// <summary>
       /// exportables pour un attribut ou une association
       /// </summary>
       /// <param name="ss"></param>
       /// <param name="parentss"></param>
       /// <returns></returns>
          private List<string> oldgetExportable(string ss,List<string> parentss)
          {
              List<string> res = new List<string>();
              if (ss == "") // si l'attribut n'a pas de stereotype son exportabilite est sans restriction
              {
                  foreach (string stereo in profparameters.ListStereoNamespaceExport)
                  {
                      res.Add(stereo);
                  }
                  res.Add("all");
                  if (!res.Contains("")) res.Add(""); //additional exportable stereoypes 
                  res = parentss;
                  return res;
              }
              string[] split = ss.Split(',');   // sinon 
              for (int i = 0; i < split.Length; i++)
              {
                  if (profparameters.ListStereoNamespaceExport.Contains(split[i]))
                  {
                      if (parentss.Contains(split[i]))
                      {
                          res.Add(split[i]); //strictly exportable stereoypes n    // on limite l'exportabilite a celle de son parent si c'est un stereotype exportable
                      }
                      res.Add("all");
                  }
                  if (!profparameters.ListStereoNamespaceExport.Contains(split[i])  // si le stereotype n'est pas un stereotype d'export
                                                                                    // il peut etre exporte dans l'un quelconque des export
                    //  &&
                      // (
                     //  profparameters.ListCimstereos.Contains(split[i])
                    //  || profparameters.ListStereoNamespace.Contains(split[i])
                     // )
                  )
                  {
                      //bool hasexport=false;
                      foreach (string stereo in profparameters.ListStereoNamespaceExport)
                      {
                          if (parentss.Contains(stereo))
                          {
                              //hasexport = true; ABA20230905 meaningless!
                              res.Add(stereo);
                          }
                      }
                      if (!res.Contains("all")) res.Add("all");
                    //  if (!hasexport)
                     // {
                          if (!res.Contains("")) res.Add(""); //additional exportable stereoypes
                     // }

                  }
              }

              return res;

          }
        // --------  selecting exportables files --------------------------
        /// <summary>
        ///  collect to which files the element is exportable 
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        private List<string> getExportable(string ss)
        {
            List<string> res = new List<string>();
            if (ss == "")
            {
                foreach (string stereo in Main.selectedstereotypes)
                {
                    res.Add(stereo);
                }
               // res.Add("all");
               // if (!res.Contains("")) res.Add(""); //additional exportable stereoypes
                return res;
            }
            string[] split = ss.Split(',');
            for (int i = 0; i < split.Length; i++)
            {
                if (Main.selectedstereotypes.Contains(split[i]))
                {
                    res.Add(split[i]); //strictly exportable stereoypes
                   // if (!res.Contains("all")) res.Add("all");
                }
                if (!profparameters.ListStereoNamespaceExport.Contains(split[i])
                    &&
                     (
                     profparameters.ListCimstereos.Contains(split[i])
                    || profparameters.ListStereoNamespace.Contains(split[i])
                    ))
                {
                    foreach (string stereo in Main.selectedstereotypes)
                    {
                        res.Add(stereo);
                    }
                    //if (!res.Contains("all")) res.Add("all"); res.Add("all");
                   // if (!res.Contains("")) res.Add(""); //additional exportable stereoypes

                }
            }

            return res;

        }
        /// <summary>
        /// exportables pour un attribut ou une association
        /// </summary>
        /// <param name="ss"></param>
        /// <param name="parentss"></param>
        /// <returns></returns>
        private List<string> getExportable(string ss, List<string> parentss)
        {
            List<string> res = new List<string>();
            if (ss == "") // si l'attribut n'a pas de stereotype son exportabilite est sans restriction
            {
                foreach (string stereo in Main.selectedstereotypes)
                {
                    res.Add(stereo);
                }
               // res.Add("all");
               // if (!res.Contains("")) res.Add(""); //additional exportable stereoypes 
                res = parentss;
                return res;
            }
            string[] split = ss.Split(',');   // sinon 
            for (int i = 0; i < split.Length; i++)
            {
                if (Main.selectedstereotypes.Contains(split[i]))
                {
                    if (parentss.Contains(split[i]))
                    {
                        res.Add(split[i]); //strictly exportable stereoypes n    // on limite l'exportabilite a celle de son parent si c'est un stereotype exportable
                    }
                  //  res.Add("all");
                }
                if (!profparameters.ListStereoNamespaceExport.Contains(split[i])  // si le stereotype n'est pas un stereotype d'export
                                                                                  // il peut etre exporte dans l'un quelconque des export
                                                                                  //  &&
                                                                                  // (
                                                                                  //  profparameters.ListCimstereos.Contains(split[i])
                                                                                  //  || profparameters.ListStereoNamespace.Contains(split[i])
                                                                                  // )
                )
                {
                    //bool hasexport = false;
                    foreach (string stereo in Main.selectedstereotypes)
                    {
                        if (parentss.Contains(stereo))
                        {
                            //hasexport = true; ABA20230905 meaningless!
                            res.Add(stereo);
                        }
                    }
                    //if (!res.Contains("all")) res.Add("all");
                    //  if (!hasexport)
                    // {
                   // if (!res.Contains("")) res.Add(""); //additional exportable stereoypes
                                                        // }

                }
            }

            return res;

        }


        //----------------------------------------------------------------
        /// <summary>
        /// cree le RDFS d'un connector
        ///  pour le traitement des namespaces:
        /// si il n'y a pas dde stereotype sur les classes terminales, CIM pur
        ///  1/ stereotype ext sur une des classes terminale
        ///   le rdfabout des deux proprits terminales prennent ce namespace
        ///  2/stereotype sur les 2 classes terminales
        ///   si mme stereotype comme 1
        ///   sinon  erreur
        ///  3/ stereotyope sur l'association ce qui nous ramne au cas 1
        /// </summary>
        /// <param name="con"></param>
        /// <param name="dictw"></param>
        /// <returns></returns>
        public bool traitConnector(EA.Connector con, Dictionary<string,TextWriter> dictw)
    {
           
           // Ta tb = new Ta("traitConnector dictw pour id=" +con.ConnectorID.ToString() +" source=" + con.ClientEnd.Role + " target=" + con.SupplierEnd.Role);//18
		ConstDefinition constantes = new ConstDefinition();
            string urins = ""; // le namespace trouv pour l'association
             //bool exportable = false;
        List<string> exportable = new List<string>();
        if (con.Type == "Association" ||
                        con.Type == "Aggregation")
        {
            if (!LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.ClientID).Name)
				|| !LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.SupplierID).Name))
            {// one end is not part of the profile
                     // string texte = "WARNING one  end  of an association between " + (RDFLAutilitaires.dicelembyid[con.ClientID]).Name + " and " + (RDFLAutilitaires.dicelembyid[con.SupplierID]).Name;
                string texte = "WARNING one  end  of an association between " + Main.Repo.GetElementByID((int)con.ClientID).Name + " and " + Main.Repo.GetElementByID((int)con.SupplierID).Name;          
                texte = texte + "\n seems not to be part of the profile.  That is not correct";
                      // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                      MessageBox.Show(texte);
                     // tb.stop();
                      return false;
            }
            EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
            EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                /* ABA20230905
                if((source_element.Name== "OperationalLimitType") && (target_element.Name == "AmbientTemperatureDependencyCurve"))
                {
                    string prov = "";
                }*/
                string urisource = getURI(source_element);
                string uritarget = getURI(target_element);
                urins = "#"; // name space par defaut
                if (
                    (urisource != "#") && (urisource != NS_J0) 
                    )
                {
                    if ((uritarget != "#") && (uritarget != NS_J0) && (urisource != uritarget))
                    {
                        throw new Exception("traitconnector 2 identical endassociation stereotypes");
                    }
                    else
                        if (urisource != uritarget)
                        {
                            throw new Exception("traitconnector 2 identical endassociation stereotypes");
                        }
                        else
                        {
                             urins = urisource;
                        }
                }
                else //urisource = # 
                {
                    if ((uritarget == "#") || (uritarget == NS_J0))
                    {
                        urins = uritarget;
                    }
                }
                    

                if (
                      ((RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(source_element.StereotypeEx) == 2))
                     ||
                     ((RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(target_element.StereotypeEx) == 2))
                     ||
                      ((RDFLAutilitaires.getPublishable(con.StereotypeEx) == 0)
                             || (RDFLAutilitaires.getPublishable(con.StereotypeEx) == 2))
               )
                {//am mai 2020
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitconnector not publishabled " + source_element.Name + "|" + target_element.Name);
                    return false;//am mai 2020
                }

                /*    
                string[] targetex = target_element.StereotypeEx.Split(',');
                string[] sourceex = source_element.StereotypeEx.Split(',');

                for (int i = 0; i < targetex.Length; i++)
                {
                    bool ilyaautreexportstereo = false;
                    if (profparameters.ListStereoNamespaceExport.Contains(targetex[i])) //si la target a stereotype exportable
                        {
                            for (int j = 0; j < sourceex.Length; j++)
                            {
                                if (profparameters.ListStereoNamespaceExport.Contains(sourceex[j]))                                     
                                {    
                                    ilyaautreexportstereo=true;
                                    if (sourceex[j] == targetex[i]) // meme stereotype de chaque ct
                                    {
                                        ilyaautreexportstereo=false;
                                        if (!exportable.Contains(sourceex[j])) exportable.Add(sourceex[j]);
                                        if (!exportable.Contains("all")) exportable.Add("all");
                                    }
                                }
                            }
                            if (ilyaautreexportstereo)
                            {
                                  // seul all peut tre exporte
                                if (!exportable.Contains("all")) exportable.Add("all");
                            }else
                            {
                                  //il la source est une  classe ordinaire target peut tre exporte
                                if (!exportable.Contains("all")) exportable.Add("all");
                                if (!exportable.Contains(targetex[i])) exportable.Add(targetex[i]);
                            }                                                  
                        }else
                        { // la target est une classe ordinaire
                            bool ilyasourceexport=false;
                            for(int j=0;j < sourceex.Length;j++)
                            {
                                if((profparameters.ListStereoNamespaceExport.Contains(sourceex[j])))
                                {
                                    if (!exportable.Contains(sourceex[j])) exportable.Add(sourceex[j]);
                                    ilyasourceexport=true;
                                }
                            }
                            if(ilyasourceexport)
                            {
                                if (!exportable.Contains("all")) exportable.Add("all");
                            }else
                            {
                                if (!exportable.Contains("all")) exportable.Add("all");
                                if (!exportable.Contains("")) exportable.Add("");
                            }
                        }   
                }
                    */
                List<string> exportables = getExportable(source_element.StereotypeEx);
                List<string> exportablet = getExportable(target_element.StereotypeEx);
                // is here any common exportable stereotype?
                foreach(string ss in exportables)
                {
                    foreach(string st in exportablet)
                    {
                        if(ss==st)
                        {
                            if (!exportable.Contains(ss)) exportable.Add(ss); //possible export in the corresponding export file
                        }
                    }
                }
                if (exportable.Count > 0)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n*** entsoe export by stereotypes  Connector  linking <<{0}>>{1} and <<{2}>>{3}", source_element.StereotypeEx, source_element.Name, target_element.StereotypeEx, target_element.Name);
            }
                      
            EA.ConnectorEnd source = con.ClientEnd;
            EA.ConnectorEnd target = con.SupplierEnd;
            bool isAggregatesource = false;
            bool isAggregatetarget = false;
            string EntsoeExpStereo = XMLP.GetXmlValueProfData("EntsoeExpStereo");//am fev 2016
                  // -----       ajout juillet 2012  ------------------- //
                  // en cas d'ambiguite sur le lien 
                  // les 2 cardinalits  [0,1] ou a [1] ou bien  [x,*]
                  // on teste la navigabilite pour lever le'ambiguite et marquer 
                  // la bonne association comme utilisee el l'autre non
                  // avec <cims:AssociationUsed
                  //
            bool ambiguite = true;
                  /*
                       string scard=source.Cardinality;
                       string tcard=target.Cardinality;
                    if(( scard != "") && (tcard != ""))
                    {
                        if (
                            ((source.Role != "") && (target.Role != ""))
                            ||
                            (scard.Contains("*") && tcard.Contains("*"))
                            || (
                                ((scard == "1") || (scard == "0..1") || (scard == "1..1"))
                              &&
                                ((tcard == "1") || (tcard == "0..1") || (tcard == "1..1"))
                                )
                            )
                        {
                            ambiguite = true;
                        }

                    }
                   * */
                  // ------------------------------------
            if (/*con.Type == "Aggregation" || */ source.Aggregation == 1)
            {
                isAggregatesource = true;
            }
            if (/* con.Type == "Aggregation" || */ target.Aggregation == 1) // achtoung doute
			{
                isAggregatetarget = true;
            }
            Nomrole rname = new Nomrole();
			
            // COTE SOURCE
			
            if (target.Role != "")
            { //there must be a non empty rolename		
                rname.elemid = target_element.ElementID;
                rname.rolename = target.Role;
                if (nomsRoles.Contains(rname))
                {
                          /**************************
                                                 MessageBox.Show("WARNING this Role name " + target.Role
                                                    + " associated with "
                                                   + target_element.Name
                                                   + " has already been used\n"
                                               + " verify if this is licit in your model");
                          ********************************/
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
                                      //              + " associated with "
                                      //             + target_element.Name
                                      //             + " has already been used\n"
                                      //         + " verify if this is licit in your model"
                                      //+ "\n");
				}
				else
                {
                     nomsRoles.Add(rname);
                }
	
				if ((!source_element.StereotypeEx.Contains(EntsoeExpStereo))  && (target_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
				{

                        // twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(target_element) + source_element.Name + "." + target.Role + "\">",exportable); //am juil 2016
                        twWriteLine("\t <rdf:Description rdf:about=\"" + urins + source_element.Name + "." + target.Role + "\">",exportable);
                    }
                    else
				    {

                    //twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(source_element) + source_element.Name + "." + target.Role + "\">",exportable); //am juil 2016
                     twWriteLine("\t <rdf:Description rdf:about=\"" + urins + source_element.Name + "." + target.Role + "\">", exportable); //am juil 2016

                    }
                    twWriteLine("\t<rdfs:label xml:lang=\"en\">" + target.Role + "</rdfs:label>",exportable);
                if ( (target.RoleNote != "") && (profparameters.hasFullDesc(target_element.StereotypeEx)))
                    {

                        //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + target.RoleNote + "</rdfs:comment>",exportable);
                        twWriteLine(specialCharactersFilter(target.RoleNote), exportable);
                    }
  
               // twWriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(source_element) + source_element.Name + "\"/>",exportable); // am juin 2011
   
               // twWriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(target_element) + target_element.Name + "\"/>",exportable);// am juin 2011
                twWriteLine("\t<rdfs:domain rdf:resource=" + "\"" + urisource + source_element.Name + "\"/>",exportable); // am juin 2011
                twWriteLine("\t<rdfs:range rdf:resource=" + "\"" + uritarget + target_element.Name + "\"/>",exportable);// am juin 2011
                if (source.Role != "")
                {
                    rname.elemid = source_element.ElementID;
                    rname.rolename = source.Role;
                    if (nomsRoles.Contains(rname))
                    {
                              /*******************
                                                  MessageBox.Show( "WARNING this Role name " + source.Role
                                                      + " associated with " 
                                                     + source_element.Name 
                                                     + " has already been used\n"
                                                 + " verify if this is licit in your model");
                              *******************/
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
                                          //              + " associated with "
                                          //             + target_element.Name
                                          //             + " has already been used\n"
                                          //         + " verify if this is licit in your model"
                                          //+ "\n");
                    }
                    else
                    {
                        nomsRoles.Add(rname);
                    }


					if ((!target_element.StereotypeEx.Contains(EntsoeExpStereo))  && (source_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
					{

                            //twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(source_element) + target_element.Name + "." + source.Role + "\"/>",exportable); //am juin 2011
                            twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + target_element.Name + "." + source.Role + "\"/>",exportable); //am juin 2011

                        }
                        else
					    {

                            //twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(target_element) + target_element.Name + "." + source.Role + "\"/>",exportable);  
                            twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + target_element.Name + "." + source.Role + "\"/>",exportable);  

                        }

                    }

                if (target.Cardinality != "")
                {
                    string cardinality = target.Cardinality.Trim(); // am 2011
                    cardinality = cardinality.Replace('*', 'n'); // am 2011
                    twWriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + RDFutilitaires.eten(cardinality) + "\"/>",exportable);
                }
                if (isAggregatesource)
                {
                          // tw.WriteLine("\t<cims:isAggregate rdf:Literal=\"" + "isAggregate" + "\"/>");
                    twWriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "ofAggregate\"/>",exportable);  // augmented
                }
                      // ajout july 2012 usabilite
                if (ambiguite)
                {
                    string used = "No";
                    if (target.IsNavigable) used = "Yes";
					twWriteLine("\t<cims:AssociationUsed>" + used + "</cims:AssociationUsed>",exportable);
                          //
                }
				twWriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>",exportable);  //augmented
                      // tw.WriteLine("</rdf:Property>");
                if (con.Stereotype != "")
                {
                    twWriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>",exportable);
                }
                      // tw.WriteLine("</rdf:Property>");
                twWriteLine("\t </rdf:Description>",exportable); //augmented
            }
			
                  // COTE TARGET
				  
				if(source.Role != "") 
				{ //there must be a non empty rolename
					//tw.WriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 + target_element.Name + "." + source.Role + "\">");  //augmented
					//tw.WriteLine("\t <rdf:Description rdf:about=\"" + getURI(target_element) + target_element.Name + "." + source.Role + "\">");
					if ((!target_element.StereotypeEx.Contains(EntsoeExpStereo))  && (source_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
					{
				        //twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(source_element) + target_element.Name + "." + source.Role + "\">",exportable); //am juil 2016
                        twWriteLine("\t <rdf:Description rdf:about=\"" + urins + target_element.Name + "." + source.Role + "\">", exportable); //am juil 2016

                    }
                    else
					{
					//	twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(target_element) + target_element.Name + "." + source.Role + "\">"); //am juin 2011
				        twWriteLine("\t <rdf:Description rdf:about=\"" + urins + target_element.Name + "." + source.Role + "\">",exportable); //am juil 2016
                                 	}  
					   // twWriteLine("\t<rdfs:label xml:lang=\"en\">" + source.Role + "</rdfs:label>");
                          twWriteLine("\t<rdfs:label xml:lang=\"en\">" + source.Role + "</rdfs:label>",exportable);//am juil 2016

					if ((source.RoleNote != "") && (profparameters.hasFullDesc(source_element.StereotypeEx)))
                    {

                        //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + source.RoleNote + "</rdfs:comment>",exportable); // am juil 2016
                        twWriteLine(specialCharactersFilter(source.RoleNote),exportable);
                    }
                    
                    
                    //twWriteLine("\t<rdfs:domain rdf:resource=" + "\"" + getURI(target_element) + target_element.Name + "\"/>",exportable); // am juil 2016
                    twWriteLine("\t<rdfs:domain rdf:resource=" + "\"" + urins + target_element.Name + "\"/>", exportable); // am juil 2016

                    //twWriteLine("\t<rdfs:range rdf:resource=" + "\"" + getURI(source_element) + source_element.Name + "\"/>",exportable);// am juil 2016
                    twWriteLine("\t<rdfs:range rdf:resource=" + "\"" + urins + source_element.Name + "\"/>", exportable);// am juil 2016

                    if (target.Role != "")
					{
                          //tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"" + NS_J0 + source_element.Name + "." + target.Role + "\"/>"); //augmented
						//twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(source_element) + source_element.Name + "." + target.Role + "\"/>",exportable);
						if ((!source_element.StereotypeEx.Contains(EntsoeExpStereo))  && (target_element.StereotypeEx.Contains(EntsoeExpStereo)))  // am fev 2016
						{
                            //twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(target_element) + source_element.Name + "." + target.Role + "\"/>",exportable); //am juil 2016
                            twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + source_element.Name + "." + target.Role + "\"/>", exportable); //am juil 2016

                        }
                        else
						{
                            //twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + getURI(source_element) + source_element.Name + "." + target.Role + "\"/>",exportable);  //am juil 2016
                            twWriteLine("\t<cims:inverseRoleName rdf:resource=\"" + urins + source_element.Name + "." + target.Role + "\"/>", exportable);  //am juil 2016

                        }

                    }
					if (source.Cardinality != "")
					{
						string cardinality = source.Cardinality.Trim(); // am 2011
						cardinality = cardinality.Replace('*', 'n'); // am 2011
                          //   tw.WriteLine("\t <cims:multiplicity rdf:resource=\"http://www.omg.org/schema/utility/99-10-03#M:" + RDFutilitaires.eten(cardinality) + "\"/>");  
						twWriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + RDFutilitaires.eten(cardinality) + "\"/>",exportable);
					}
					if (isAggregatetarget)
					{
                          //      tw.WriteLine("\t<cims:isAggregate rdf:Literal=\"" + "isAggregate" + "\"/>");
						twWriteLine("\t<cims:stereotype rdf:resource=\"" + constantes.NS_NONSTANDARD + "ofAggregate\"/>",exportable);  // augmented
					}
							// ajout july 2012 usabilite
					if (ambiguite)
					{
                        string used = "No";
						if (source.IsNavigable) used = "Yes";
						twWriteLine("\t<cims:AssociationUsed>" + used + "</cims:AssociationUsed>",exportable);
					}
                      //
                      //        twWriteLine("</rdf:Property>");
                    twWriteLine("\t<rdf:type rdf:resource=\"" + constantes.NS_RDF + "Property\"/>",exportable);  //augmented

					if (con.Stereotype != "")
					{
						twWriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>",exportable);
					}
					twWriteLine("\t </rdf:Description>",exportable); //augmented
				}
            }

            //tb.stop(); 
            return true;
    }
//----------------------------------------------------------------
          public bool traitEnummember(EA.Element elem, EA.Attribute member, Dictionary<string,TextWriter> dictw)
          {
            if ((RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 0)
               || (RDFLAutilitaires.getPublishable(elem.StereotypeEx) == 2))
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Info traitEnummeber " + elem.Name + "."+ member.Name+"not  publishabled");
                return false;//am mai 2020Ta 
            }
           
                                                                                  //bool exportable = isExportable(member.StereotypeEx);
            List<string> exportableparent = getExportable(elem.StereotypeEx);
                 List<string> exportable = getExportable(elem.StereotypeEx,exportableparent);
                 //Ta tb = new Ta("traitEnummember dictw pour elem=" + elem.Name); //18
              if (exportable.Count >0)           
  
              {
                  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n*** entsoe export by stereotypes  Treatment of  exportable Enummember <<" + member.StereotypeEx + ">> " + member.Name);
              }


              ConstDefinition constantes = new ConstDefinition();
              bool answer = false;

              //twWriteLine("\t <rdf:Description rdf:about=\"" + NS_J0 +  elem.Name+ "." + member.Name +  "\">");  // augmented
              twWriteLine("\t <rdf:Description rdf:about=\"" + getURI(elem) + elem.Name + "." + member.Name + "\">",exportable);  // augmented
              twWriteLine("\t<rdfs:label xml:lang=\"en\">" + member.Name + "</rdfs:label>",exportable);
              if ((member.Notes != "") && (profparameters.hasFullDesc(elem.StereotypeEx)))
              {

                //twWriteLine("\t<rdfs:comment  rdf:parseType=\"Literal\">" + RDFutilitaires.RemoveRc(member.Notes) + "</rdfs:comment>",exportable);
                twWriteLine(specialCharactersFilter(member.Notes),exportable);
            }
              //tw.WriteLine("\t<rdf:type rdf:resource=" + "\"" + NS_J0 + elem.Name  + "\"/>");  
              twWriteLine("\t<rdf:type rdf:resource=" + "\"" + getURI(elem) + elem.Name + "\"/>",exportable);
              twWriteLine("</rdf:Description>",exportable);
              answer = true;
            //tb.stop(); 
            return answer;
          }

       /// <summary>
  /// loging error in validations
  /// </summary>
  /// <param name="texte"></param>
  public static void wtest(string logtype, string texte)
  {
     // MessageBox.Show(" wtest log=" + XMLP.GetXmlValueConfig("Log") +" test=" + XMLP.GetXmlValueConfig("ModeTest")); // am pour test
      if (XMLP.GetXmlValueConfig("ModeTest") == ("True"))
      {       
              XMLP.AddXmlLog(logtype, texte);
      }
  }
/// <summary>
/// teste si un element est une enumeration
/// </summary>
/// <param name="el"></param>
/// <returns></returns>
public  bool isEnumeration(EA.Element el)
{
    bool ret = false;
    if(
        (el.StereotypeEx.Contains("enumeration"))
        ||
         (el.StereotypeEx.Contains("Enumeration"))
        ||
        (el.Type=="Enumeration")
        ||
        (el.MetaType=="Enumeration")
        )
    {
        ret = true;
    }
    return ret;
}

public bool withFullDescription(string stereos)
        {
            bool ret = true;

            return ret;
        }
        
public  static string generCopyright( bool comment)
    {
        string  res = "";
            try
            {
                string date = XMLP.GetXmlValueProfData("CCPublicationDate"); 
                string profilename = XMLP.GetXmlValueProfData("CCStandardNumber") +"-" + XMLP.GetXmlValueProfData("CCProfileName");
                string type = "RDFS";
                string diffusionstate = XMLP.GetXmlValueProfData("CCDiffusionState");
                string componentName = XMLP.GetXmlValueProfData("CCCodeComponentName");
                string versioninfo = XMLP.GetXmlValueProfData("CCVersionStateInfo");
                string notice;
                if (comment)
                {
                     notice = "<!-- \n <Copyright >\n\t<Notice>\n";
                }
                else 
                {
                     notice = "\n\t\t\t<Copyright >\n\t\t\t\t <Notice>\n";
                }
                notice = notice + "\t\t\t\tCOPYRIGHT (c) IEC " + DateTime.Now.Year + "\n";
                notice = notice + "\t\t\t\tThis version of  " + type + " is part of the IEC" + " " + profilename + "\n";
                notice = notice + "\t\t\t\t";
                notice = notice + " where full legal notices are provided.\n\tIn case of any differences between the here - below code and the IEC published content,";
                notice = notice + "the ";
                notice = notice + "here - below definition supersedes the IEC publication; \n\tit may contain updates.";
                notice = notice + " See history files (if it exists).\n\tThe whole document shall be taken into account in order  to have a full description of this code component.\n";
                notice = notice + "\t\t\t\tSee www.iec.ch/CCv1 for copyright details\n";
                notice = notice + "\t\t\t\t</Notice>\n";
                notice =notice + "\t\t\t\t<Notice>\n";
                if (diffusionstate == "Draft")
                {
                    string dateToPrint = DateTime.UtcNow.ToString("yyyy-MM-ddTHH:mm:ssZ");
                    notice = notice + "\t\t\t\t" + type + " for " + profilename + " version=" + versioninfo + " released " + dateToPrint + " as " + diffusionstate + "\n";
                }
                else
                {
                    notice = notice + "\t\t\t\t" + type + " for " + profilename + " version=" + versioninfo + " released " + date + " as " + diffusionstate + "\n";
                }
                notice = notice + "\t\t\t\t</Notice>\n";
                string licenceURI= "www.iec.ch/CCv1 ";
                string kind = "";
                if (XMLP.GetXmlValueProfData("CCDiffusionState") == "IEC")
                {
                    kind = "Standard";
                }
                else
                {
                    kind = XMLP.GetXmlValueProfData("CCDiffusionState");
                }
                notice = notice + "\t\t\t\t<License uri =\"" + licenceURI + "\" kind =\"" + kind + "\" > IEC License </License>\n";
                if (comment)
                {
                    notice = notice + "\t\t\t</Copyright>\n -->";
                }
                else
                {
                    notice = notice + "\t\t\t</Copyright>\n";
                }
                res = notice;
                return res;
            }
            catch (Exception ee)
            {
                throw new Exception("generCopy  " + ee.Message);
            }
            //return res;

        }
        /// <summary>
        /// give all descendants of a class beeing in the given profile package
        /// </summary>
        /// <param name="profpack"></param>
        /// <param name="elem"></param>
        /// <returns></returns>
        public static List<EA.Element> getDescendantsInProfile(EA.Element elem)
        {
            
            List<EA.Element> res = new List<EA.Element>();
            EA.Package thepack = Main.Repo.GetTreeSelectedPackage();
            EA.Package pack= Main.Repo.GetPackageByID((int) elem.PackageID);
            foreach (EA.Connector con in elem.Connectors)
            {
                
                if (con.Type != "Generalization") continue;
                if (con.SupplierID != elem.ElementID) continue;
                if (!isInProfile(elem,thepack)) continue; // this instance is not in the profile
                EA.Element instance = Main.Repo.GetElementByID((int)con.ClientID);
                if (!res.Contains(instance))res.Add(instance);
            }
            return res;

        }
        public static void getAllDescendantsInProfile(EA.Element elem,List<EA.Element> descendants)
        {
            List<EA.Element> deslist = new List<EA.Element>();
            deslist = getDescendantsInProfile(elem);
            if(deslist.Count!=0)
            {
                foreach(EA.Element elt in deslist)
                {
                    if (!descendants.Contains(elt)) descendants.Add(elt);
                        getAllDescendantsInProfile(elt, descendants);
                }
            }
        }
        public static bool isInProfile(EA.Element elem,EA.Package profpack)
        {
            bool res = false;
            EA.Package pack = Main.Repo.GetPackageByID((int)elem.PackageID);
            while((pack.PackageID !=0) && (pack.PackageID != profpack.PackageID))
            {
                pack= Main.Repo.GetPackageByID((int)pack.ParentID);
            }
            if(pack.PackageID!=0)
            {
                res = true;
            }  
            return res;
        }

        /// <summary>
        /// & - &amp;
        ///< - &lt;10
        ///> - &gt;
        ///" - &quot;
        ///'  - &apos;
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        public  string specialCharactersFilter(string ss)
        {
            string notes = RDFutilitaires.RemoveRc(ss);
            string res = "";
            
            //(ss);
            //   
            if (profparameters.forXml)
            {
                res = notes;
                Dictionary<string, string> forxmldic = new Dictionary<string, string>();
                forxmldic.Add("&", "&amp;");
                forxmldic.Add("<", "&lt;");
                forxmldic.Add(">", "&gt;");
                forxmldic.Add("'", "&apos;");
                forxmldic.Add("\"", "&quot;");
                foreach (string cc in forxmldic.Keys)
                {
                    res = res.Replace(cc, forxmldic[cc]);
                }
                res = "\t<rdfs:comment rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + res + "</rdfs:comment>";
            }
            else
            {
                res="\t<rdfs:comment rdf:parseType=\"Literal\">" + notes + "</rdfs:comment>";
            }

            return res;
        }
       /// <summary>
       /// replace in one string th sppecial caracterers with their UTF coding
       /// </summary>
       /// <param name="ss"></param>
       /// <returns></returns>
        public string ReplaceSpecialCharacters(string ss)
        {
            string notes = RDFutilitaires.RemoveRc(ss);
            string res = notes;

            //(ss);
            //   
            if (profparameters.forXml)
            {
                res = notes;
                Dictionary<string, string> forxmldic = new Dictionary<string, string>();
                forxmldic.Add("&", "&amp;");
                forxmldic.Add("<", "&lt;");
                forxmldic.Add(">", "&gt;");
                forxmldic.Add("'", "&apos;");
                forxmldic.Add("\"", "&quot;");
                foreach (string cc in forxmldic.Keys)
                {
                    res = res.Replace(cc, forxmldic[cc]);
                }
                
            }
            return res;
        }
        public static string transComment(string comment,XMLProfileParameters profparams)
        {
            string res = "";
            string notes = comment;
            if (profparams.forXml)
            {

                Dictionary<string, string> forxmldic = new Dictionary<string, string>();
                forxmldic.Add("&", "&amp;");
                forxmldic.Add("<", "&lt;");
                forxmldic.Add(">", "&gt;");
                forxmldic.Add("'", "&apos;");
                forxmldic.Add("\"", "&quot;");
                foreach (string cc in forxmldic.Keys)
                {
                   notes = notes.Replace(cc, forxmldic[cc]);
                }
                res = "\t<rdfs:comment rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string>\"" + notes + "</rdfs:comment>";
            }
            else
            {
                res="\t<rdfs:comment rdf:parseType=\"Literal\">" + notes + "</rdfs:comment>";
            }
           
            

            return res;
        }
        /// <summary>
        /// gives type of an element
        /// </summary>
        /// <param name="elt"></param>
        /// <returns>type</returns>
        public string getEltType(EA.Element elt)
        {
            string res="";
            string type = elt.Type;
            if (type == "Enumeration") return "enumeration";
            if (type == "Note") return "note";
            if (elt.MetaType == "Enumeration") return "enumeration";
            if (elt.StereotypeEx.Contains("Primitive")) return "primitive";
            if (elt.StereotypeEx.Contains("CIMDatatype")) return "CIMDatatype";
            if (elt.StereotypeEx.Contains("Compound")) return "compound";
            return res;
        }
        public bool isFlat(EA.Element datatype)
        {
            bool res = false;
            if(datatype.StereotypeEx.Contains("CIMDatatype"))
            {
                if (datatype.Attributes.Count == 0) res = true;
            }
            return res;
        }
        /// <summary>
        /// est'ce dans le profil?
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="el"></param>
        /// <param name="packenvelop"></param>
        /// <returns></returns>
        public bool IsInProfile(EA.Repository repo, EA.Element el, EA.Package packenvelop)
        {
            bool res = false;

            try
            {
                long envelopid = packenvelop.PackageID;
                string prov = el.Name;
                prov = packenvelop.Name;

                long packid = el.PackageID;
                while (packid != envelopid && packid != 0)
                {
                    prov = repo.GetPackageByID((int)packid).Name;
                    packid = repo.GetPackageByID((int)packid).ParentID;

                }
                if (packid == envelopid) res = true;
                /********* pour test ****************/

                string texte = " IsInprofile " + repo.GetPackageByID(el.PackageID).Name + "::" + el.Name;
                texte = texte + " envelop:  " + packenvelop.Name + " resultat=" + res.ToString();
                // wlog("isInProfil",texte);
                /************************************/
            }
            catch (Exception e)
            {
                /********* pour test ****************/
                string texte = " IsInprofile " + repo.GetPackageByID(el.PackageID).Name + "::" + el.Name;
                texte = texte + " envelop:  " + packenvelop.Name + " exception=" + e.Message;
                //  wlog("isInProfil",texte);
                /************************************/
                throw new Exception(" IsInProfile " + e.Message);
                  
            }
            return res;

        }
        /// <summary>
        /// clean a string by removiv all newline and Rc characteres 
        /// on front of the string
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        public static string cleanSS(string ss)
        {
            try
            {
                string res = ss;

                for (int i = 0; i < res.Length; i++)
                {
                    int value = Convert.ToInt32(res[i]);
                    if (value < 32) // first printable character
                    {
                        continue;
                    }
                    else
                    {
                        res = res.Substring(i);
                        break;
                    }
                }
                return res;
            }
            catch(Exception ee)
            {
                throw new Exception(" cleanSS " + ee.Message);
            }
        }
  
        //----------------------------------------------------------------
    }
}