/*******************************************************************************
Ce fichier est un ensmble de programes pour produire un fichier RDF selon l'agorithme du document CEI61970-501

Attention on suListppose ici qu'il n'y a qu'un niveau de package:
 on itere sur les classes a un niveau de package
*******************************************************************************/
using System;

using System.IO;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Windows.Forms;
using EA;
using System.Runtime.InteropServices;
using CimSyntaxGen.Utilities;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France)  *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.4.4                                          *    janv 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen

{
    public class RDFutilitaires
    {
        private static Logger logger = new Logger(Main.LOG_FILE, Main.DO_LOG);
        public static bool amtest = false; // am oct 2013
        public static ConstantDefinition CD = new ConstantDefinition();

        public static bool ongoing = true; // tells after each message if we should continue to generate
        //static public TextWriter reportlog; // to report details of generation
        static public StreamWriter reportlog; // to report details of generation
        public static Dictionary<long, EA.Element> dicelembyid = new Dictionary<long, EA.Element>();
        public static Dictionary<string, EA.Element> dicelembyname = new Dictionary<string, EA.Element>();
        public static DialGenerXSD Barre = null;
        public static Dictionary<long, EA.Element> dicdatabyid = new Dictionary<long, EA.Element>();

        public static Dictionary<string, EA.Element> dicdatabyname = new Dictionary<string, EA.Element>();

       // public static Dictionary<long, EA.Package> dicpackbyid = new Dictionary<long, EA.Package>();
       // public static Dictionary<long, EA.Package> dicrepobyid = new Dictionary<long, EA.Package>();
        public static Dictionary<long, List<long>> dicconstbycon = new Dictionary<long, List<long>>(); // dic of const elements attached to a connector
        public static Dictionary<string, EA.Stereotype> dicstereobyname = new Dictionary<string, EA.Stereotype>(); //dic of stereotype of the repository
        public List<long> dejatraite;
        public List<long> datatypedone;
        public struct Nomrole
        {
            public long elemid;
            public string rolename;
        }
        public List<Nomrole> nomsRoles; // for avoiding duplication of roles name

        internal static bool DEBUG;
        public static List<string> LocalClassNames;
        public List<string> NoDoublons;
        public List<string> LocalDatatypeNames;
        public List<long> LocalDatatypeIDs;
        private string datatypepackagename;
        public string DatatypePackageName { get { return datatypepackagename; } set { datatypepackagename = value; } }

        public static ArrayList resulpermutation;
        static int permindex = 0;
        //----------------------------------------------- 
        /// <summary>
        /// construction des dicos pour elements d'un Package
        /// </summary>
        /// <param name="package"></param>
        public static void buildDicsElem(EA.Package package)
        {

            if (dicelembyid.Count == 0) //first time
               //18 if (!dicpackbyid.ContainsKey(package.PackageID)) dicpackbyid.Add(package.PackageID, package);
            {
                List<EA.Element> elist = new List<EA.Element>();
                getAllElements(package, elist, "all");
                foreach (EA.Element e in elist)
                {
                    if (!dicelembyid.ContainsKey(e.ElementID))
                    {
                        dicelembyid.Add(e.ElementID, e);
                       //  MessageBox.Show("ID=" + e.ElementID + " nom= " + e.Name + " type= " + e.Type); //pour test
                    }
                    if (e.Name != "")
                    {
                        if (!dicelembyname.ContainsKey(e.Name))
                        {
                            dicelembyname.Add(e.Name, e);
                        }
                    }
                    else
                    {
                        if ((e.Type == "Constraint") && ((e.Notes == "XOR") || (e.Notes == "CHOICE") || (e.Notes == "UNION")))  // we treat  the XOR constraints and the CHOICE
                        {
                            char[] separateurs = { '=', ';' };
                            string[] split = (e.get_MiscData(3)).Split(separateurs);
                            List<string> lscons = new List<string>();
                            List<long> lcons = new List<long>();
                            for (short i = 0; i < split.Length; i++)
                            {
                                if ((split[i] != "") && (isnumeric(split[i])))
                                { lcons.Add((long)Convert.ToUInt64(split[i])); }
                            }
                            foreach (long conid in lcons)
                            {
                                // here we should put a protection like checking that the conid is c=valid in the the repository
                                if (!dicconstbycon.ContainsKey(conid))
                                {
                                    dicconstbycon.Add(conid, new List<long>());
                                    dicconstbycon[conid].Add(e.ElementID);

                                    // 
                                }
                                else
                                {
                                    if (!dicconstbycon[conid].Contains(e.ElementID)) dicconstbycon[conid].Add(e.ElementID);
                                }


                            }

                        }

                    }

                }
            }
        }
        //-----------------------------------------------------------

        /// <summary>
        /// construction des dicos pour packages d'un Repository
        /// </summary>
        /// <param name="repository"></param>
        /// 
        /*18
        public static void buildDicsrepo(EA.Repository repo)
        {
            if (dicrepobyid.Count == 0) //first time
            {

                EA.Package model = (EA.Package)(repo.Models).GetAt(0);

                List<EA.Package> Lpa = new List<EA.Package>();
                getAllPackages(model, Lpa);
                foreach (EA.Package pa in Lpa)
                {
                    //   MessageBox.Show("name= " + pa.Name + " ID=" + pa.PackageID );
                    if (!dicrepobyid.ContainsKey(pa.PackageID))
                    {
                        dicrepobyid.Add(pa.PackageID, pa);
                    }
                }

            }
        }
        */
        //-----------------------------------------------------------

        /// <summary>
        /// construction des dicos pour packages d'un Repository
        /// </summary>
        /// <param name="repository"></param>
        public static void buildDicrepobyid(EA.Repository repo, Dictionary<long, EA.Package> dicrepobyid)
        {
            if (dicrepobyid.Count == 0) //first time
            {

                EA.Package model = (EA.Package)(repo.Models).GetAt(0);

                List<EA.Package> Lpa = new List<EA.Package>();
                getAllPackages(model, Lpa);
                foreach (EA.Package pa in Lpa)
                {
                    //   MessageBox.Show("name= " + pa.Name + " ID=" + pa.PackageID );
                    if (!dicrepobyid.ContainsKey(pa.PackageID))
                    {
                        dicrepobyid.Add(pa.PackageID, pa);
                    }
                }

            }
        }

        //-----------------------------------------------------------

        /// <summary>
        /// construction des dicos pour stereotypes d'un Repository
        /// </summary>
        /// <param name="repository"></param>
        public static void buildDicstereo(EA.Repository repo)
        {
            if (dicstereobyname.Count == 0) //first time
            {

                foreach (EA.Stereotype st in repo.Stereotypes)
                {
                    //   MessageBox.Show("name= " + pa.Name + " ID=" + pa.PackageID );
                    if (!dicstereobyname.ContainsKey(st.Name))
                    {
                        dicstereobyname.Add(st.Name, st);
                    }
                }

            }
        }
        //-----------------------------------------------------------
        /// <summary>
        /// 
        /// </summary>
        /// <param name="package"></param>
        /// <param name="tw"></param>
        /// <returns></returns>
        public bool serialize(EA.Package package, StreamWriter tw)
        {
           // Ta ta = new Ta("serialize");
            List<EA.Element> elemliste = new List<EA.Element>();
            // dejatraite = new List<long>() ;
            //datatypedone = new List<long>();
         
            // traitement du package
            traitpackage(package, tw);

            //traitement des classes
            foreach (EA.Element e in package.Elements)
            {
                if (RDFutilitaires.Barre != null) if (!Barre.go) return false; // am dec 15
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 15
                
                if (e.Name != "")
                { // on ne traite pas les elements sans nom
                    {
                        if (!NoDoublons.Contains(e.Name))
                        {
                            NoDoublons.Add(e.Name);
                        }
                        else
                        {
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" ERROR there are at least two classes of the same name " + e.Name + " in the profile");
                            MessageBox.Show(" ERROR there are at least two classes of the same name " + e.Name + " in the profile ");

                            return false;
                        }
                        traitclass(e, tw);
                    };
                }
                else
                {
                    //  // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING an element without name of GUI" + e.ElementGUID + "has been encountered and zapped");
                }
            }
            //ta.stop();
            //ta.quit();
            return true;

        }

        //----------------------------------------
        public bool traitpackage(EA.Package p, StreamWriter tw)
        {
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Treatment of Package " + p.Name);
            ConstDefinition constantes = new ConstDefinition();
            bool answer = true;

            tw.WriteLine("<cims:ClassCategory rdf:ID=\"" + p.Name + "\">");
            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + p.Name + "</rdfs:label>");
            if (p.Notes == "")
            {
                //    tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + "</rdfs:comment>");
            }
            else
            {
                tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RemoveRc(p.Notes) + "</rdfs:comment>");
            }
            tw.WriteLine("</cims:ClassCategory>");

            return answer;
        }
        /****************************************************************************/

        /// <summary>
        /// for a given class
        /// prints the skeletton of rdf schema for each class which are not datatype or enumeration
        /// according to the following algorithm
        /// </summary> 
        ///  case legacy rdfs langdale
        /// <rdf:Description rdf:about="namespaces(j.0)#Class.Name">
        ///  <rdfs:subClassOf rdf:resource="namespaces(j.0)#MySuperClass.Name"/> 
        ///  <cims:belongsToCategory rdf:resource="namespaces(j.0)#Package.Name"/>
        ///  <rdfs:comment>Class.Documentation</rdfs:comment>	
        ///  <rdfs:label >Class.Name</rdfs:label>
        /// <cims:stereotype>"Class.Stereotype"</cims:stereotype> 
        ///  </rdfs:Class>
        ///  <rdf:type rdf:resource="namespaces(rdfs)#Class"/>
        ///   </rdf:Description>
        /// <param EA.Element></param>
        /// <returns> bool </returns>
        /// cas de la norme officielle rdfs de la 501

        /*****************************************************************
         For each class, print
            <rdfs:Class rdf:ID="Class.Name">
        <rdfs:label xml:lang="en">Class.Name</rdfs:label>
        <rdfs:subClassOf rdf:resource="#MySuperClasses.Name"/>
        <rdfs:comment>"Class.Documentation"</rdfs:comment>
        he <cims:stereotype>"Class.Stereotype"</cims:stereotype> 
               </rdfs:Class>
        *******************************************************************/

        public bool traitclass(EA.Element elem, StreamWriter tw)
        {
           // Ta tb = new Ta("start traitclass");
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Treatment of Element " + elem.Name);
            if(elem.Name== "GasCapacityAllocations_Document")
            {
                string prov = elem.Name;
            }
            ConstDefinition constantes = new ConstDefinition();
            string ligne = "";
            bool answer = false;
            bool datatype = false;
            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
            if (elem.Type == "Class")
            {
                if (elem.Stereotype != CD.GetEnumStereotype())  // not an enumeration
                {
                    bool todo = true;
                    if (elem.StereotypeEx.Contains("Datatype") || elem.StereotypeEx.Contains(CD.GetDatatypeStereotype()) || elem.StereotypeEx.Contains(CD.GetPrimitiveStereotype()) || elem.Stereotype == CD.GetCompoundStereotype())
                    {
                        datatype = true;
                        if ((elem.ElementID != 0) && (datatypedone.Contains(elem.ElementID)))
                        { // the datatype have already been treated
                            todo = false;
                        }
                        else
                        {
                            if (LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID)) todo = false;// the datatype is already   part of the profile		
                        }
                    }

                    if (todo == true)
                    {
                        datatypedone.Add(elem.ElementID);
                        ligne = "<rdfs:Class rdf:ID=\"" + elem.Name + "\">";
                        tw.WriteLine(ligne);
                        tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");

                        // is there a superclass?

                        EA.Element superclass = getElementSuperclass(elem);
                        if (superclass != null)
                        {
                            tw.WriteLine("\t<rdfs:subClassOf rdf:resource=\"#" + superclass.Name + "\"/>");
                        }
                        if (elem.Notes != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RemoveRc(elem.Notes) + "</rdfs:comment>");


                        if (elem.Stereotype != "")
                        {
                            tw.WriteLine("<cims:stereotype>" + elem.Stereotype + "</cims:stereotype>");
                        }

                        if ((datatype == true) && !LocalDatatypeIDs.Contains(elem.ElementID))
                        {  // it is a datatype copied from above level
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" A datatype   non existant in the profile has been duplicated in the profile's package which can or not had preexisted");
                           //18  DatatypePackageName = dicpackbyid[elem.PackageID].Name;
                            DatatypePackageName = Main.Repo.GetPackageByID((int)elem.PackageID).Name;
                            tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"#" + DatatypePackageName + "\"/>");
                        }
                        else
                        {
                            tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"#" + Main.Repo.GetPackageByID((int)elem.PackageID) + "\"/>");
                        }


                        tw.WriteLine("</rdfs:Class>");

                        // traitement des attributs
                        foreach (EA.Attribute att in elem.Attributes)
                        {
                            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
                            traitAttribute(elem, att, tw);
                        }
                        // traitement des associations
                        EA.Collection connectors = elem.Connectors;
                        foreach (EA.Connector con in connectors)
                        {


                            // on verifie que le connector n'a pas ete deja traite dans un autre package
                            if (!dejatraite.Contains(con.ConnectorID))
                            {
                                if (con.ConnectorID != 0) dejatraite.Add(con.ConnectorID);
                                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
                                traitConnector(con, tw);
                            }
                        }



                        answer = true;
                        return answer;
                    }
                }
                else
                { // is an enumeration
                    bool todo = true;
                    if ((elem.ElementID != 0) && datatypedone.Contains(elem.ElementID))
                    {  // the datatype have already been treated
                        todo = false;
                    }
                    else
                    {
                        if (LocalDatatypeNames.Contains(elem.Name) && !LocalDatatypeIDs.Contains(elem.ElementID)) todo = false;// the datatype is already   part of the profile
                    }
                    if (todo == true)
                    {
                        datatypedone.Add(elem.ElementID);

                        tw.WriteLine("<rdfs:Class rdf:ID=\"" + elem.Name + "\">");
                        tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + elem.Name + "</rdfs:label>");
                        // we suppose there is NO  superclass?
                        if (elem.Notes != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RemoveRc(elem.Notes) + "</rdfs:comment>");

                        if (!LocalDatatypeIDs.Contains(elem.ElementID))
                        {// it is a datatype copied from above level
                            DatatypePackageName = Main.Repo.GetPackageByID((int)elem.PackageID).Name;
                            tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"#" + DatatypePackageName + "\"/>");
                        }
                        else
                        {
                            tw.WriteLine("\t<cims:belongsToCategory rdf:resource=\"#" + Main.Repo.GetPackageByID((int)elem.PackageID) + "\"/>");
                        }
                        /************* addition am 20109 ****************************************/
                        if (elem.Stereotype != "") { tw.WriteLine("\t<cims:stereotype>" + elem.Stereotype + "</cims:stereotype>"); }
                        /******************************************************************************/
                        tw.WriteLine("</rdfs:Class>");

                        foreach (EA.Attribute att in elem.Attributes)
                        {
                            RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress");//18
                            traitEnummember(elem, att, tw);

                        }

                        answer = true;
                        //tb.stop();
                        return answer;

                    }

                }
            }
            //tb.stop();
            return answer;
        }

        /*
                        For each attribute, print
           <rdf:Property rdf:ID="Class.Name.Attribute.Name">
              <rdfs:label xml:lang="en">Attribute.Name</rdfs:label>
              <rdfs:domain rdf:resource="#Class.Name"/>
              <rdfs:range rdf:resource="#Attribute.Type"/>
              <rdfs:comment>"Attribute.Documentation"</rdfs:comment>
              </rdf:Property>
        */
        public bool traitAttribute(EA.Element elem, EA.Attribute attribute, StreamWriter tw)
        {
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t\t Treatment of Attribute " + attribute.Name);
            ConstDefinition constantes = new ConstDefinition();
            bool answer = false;

            tw.WriteLine("<rdf:Property rdf:ID=\"" + elem.Name + "." + attribute.Name + "\">");
            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + attribute.Name + "</rdfs:label>");
            tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"#" + elem.Name + "\"/>");
            tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"#" + attribute.Type + "\"/>");
            /* ********* addition am feb 2010 ****************/
            string multiplicity = attribute.LowerBound + ".." + attribute.UpperBound;
            tw.WriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + eten(multiplicity) + "\" />");
            if (attribute.Default != "")
            {
                if (attribute.IsConst)
                {
                    // tw.WriteLine("\t<cims:isFixed rdfs:Literal=\"" + attribute.Default + "\" />");
                    // tw.WriteLine("\t<cims:isFixed rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + attribute.Default + "</cims:isFixed>");
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    tw.WriteLine("\t<cims:isFixed rdf:datatype=\"http://www.w3.org/2001/XMLSchema#" + type + "\">" + attribute.Default + "</cims:isFixed>");//"\"
                }
                else
                {
                    //tw.WriteLine("\t<cims:isDefault rdfs:Literal=\"" + attribute.Default + "\" />");
                    // tw.WriteLine("\t<cims:isDefault rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + attribute.Default + " </cims:isDefault>");
                    string type = attribute.Type;
                    if ((type == "UnitSymbol") || (type == "UnitMultiplier")) type = "string";
                    type = type.ToLower();
                    tw.WriteLine("\t<cims:isDefault rdf:datatype=\"http://www.w3.org/2001/XMLSchema#" + type + "\">" + attribute.Default + "</cims:isDefault>");//"\"
                }
            }
            if (attribute.Stereotype != "") { tw.WriteLine("\t<cims:stereotype>" + attribute.Stereotype + "</cims:stereotype>"); }
            /*************************************************/

            if (attribute.Notes != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RemoveRc(attribute.Notes) + "</rdfs:comment>");
            tw.WriteLine("</rdf:Property>");
            if ((attribute.ClassifierID != 0) && !datatypedone.Contains(attribute.ClassifierID)) //18 && (dicelembyid.ContainsKey(attribute.ClassifierID))
            { // the datatype hasnot  been already generated ?  
                //18traitclass(dicelembyid[attribute.ClassifierID], tw);
                traitclass(Main.Repo.GetElementByID((int)attribute.ClassifierID), tw);
                //    datatypedone.Add(attribute.ClassifierID);
            }
            answer = true;
            return answer;
        }

        /*
                        For each member of an enumeration, print
           <rdf:Description  rdf:ID="EnumerationClass.Name.Attribute.Name">
              <rdfs:label xml:lang="en">Attribute.Name</rdfs:label>
              <rdfs:comment>"Attribute.Documentation"</rdfs:comment>
              <rdf:type rdf:resource="#Class.Name"/>
              </rdf:Description>
        */
        public bool traitEnummember(EA.Element elem, EA.Attribute member, StreamWriter tw)
        {
            ConstDefinition constantes = new ConstDefinition();
            bool answer = false;

            //tw.WriteLine("<rdf:Description rdf:ID=\"" + elem.Name +"." + member.Name +  "\">"); 
            tw.WriteLine("<rdf:Description rdf:about=\"#" + elem.Name + "." + member.Name + "\">");
            tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + member.Name + "</rdfs:label>");
            if (member.Notes != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + RemoveRc(member.Notes) + "</rdfs:comment>");
            tw.WriteLine("\t<rdf:type rdf:resource=" + "\"#" + elem.Name + "\"/>");
            tw.WriteLine("</rdf:Description>");
            answer = true;
            return answer;
        }




        /// <summary>
        ///            
        ///         For each rolename, print 
        ///      <rdf:Property rdf:ID="Class.Name.Role.Name">
        ///       <rdfs:label xml:lang="en">Role.Name</rdfs:label>
        ///      <rdfs:domain rdf:resource="#Class.Name"/>
        ///       <rdfs:range rdf:resource="#Role.ToClass.Name"/>
        ///      <cims:inverseRoleName rdf:resource="#Role.ToClass.Name.Role.OtherRole.Name"/>
        ///       <cims:multiplicity rdf:resource="http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#M:Role.CardinalityFrom"/>
        ///       <cims:isAggregate rdf:Literal="Role.IsAggregate"/>
        ///       <rdfs:comment>"Role.Documentation"</rdfs:comment>
        /// </rdf:Property>
        /// </summary>
        /// <param name="package"></param>
        /// <param name="tw"></param>
        /// <returns></returns>
        public bool traitConnector(EA.Connector con, StreamWriter tw)
        {
            ConstDefinition constantes = new ConstDefinition();

            if (con.Type == "Association" ||
                      con.Type == "Aggregation")
            {

               //18  if (!LocalClassNames.Contains((RDFutilitaires.dicelembyid[con.ClientID]).Name)
                if (!LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.ClientID).Name)
         //18 || !LocalClassNames.Contains((RDFutilitaires.dicelembyid[con.SupplierID]).Name))
                    || !LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.SupplierID).Name))
                {// one end is not part of the profile
                    string texte = "WARNING one  end  of an association between " + (Main.Repo.GetElementByID((int)con.ClientID)).Name + " and " + (Main.Repo.GetElementByID((int)con.SupplierID)).Name;
                    texte = texte + "\n seems not to be part of the profile.  That is not correct";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    MessageBox.Show(texte);
                    return false;
                }
               //18 EA.Element source_element = dicelembyid[con.ClientID];
               //18 EA.Element target_element = dicelembyid[con.SupplierID];
                EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
                EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                EA.ConnectorEnd source = con.ClientEnd;
                EA.ConnectorEnd target = con.SupplierEnd;
                bool isAggregatesource = false;
                bool isAggregatetarget = false;

                if (source.Aggregation == 1)
                {
                    isAggregatesource = true;
                }
                if (target.Aggregation == 1) // achtoung doute
                {
                    isAggregatetarget = true;
                }


                Nomrole rname = new Nomrole();
                // cote source
                if (target.Role != "")
                { //there must be a non empty rolename
                    rname.elemid = target_element.ElementID;
                    rname.rolename = target.Role;
                    if (nomsRoles.Contains(rname))
                    {
                        /**********************
                                               MessageBox.Show("WARNING this Role name " + target.Role
                                                  + " associated with "
                                                 + target_element.Name
                                                 + " has already been used\n"
                                             + " verify if this is licit in your model");
                        ***************/
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + target.Role
                                    //              + " associated with "
                                    //             + target_element.Name
                                    //             + " has already been used\n"
                                    //         + " verify if this is licit in your model"
                                    //+ "\n");
                    }
                    else
                    {
                        nomsRoles.Add(rname);
                    }
                    tw.WriteLine("<rdf:Property rdf:ID=\"" + source_element.Name + "." + target.Role + "\">");
                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + target.Role + "</rdfs:label>");
                    if (target.RoleNote != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + target.RoleNote + "</rdfs:comment>");
                    tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"#" + source_element.Name + "\"/>");
                    tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"#" + target_element.Name + "\"/>");
                    if (source.Role != "")
                    {
                        tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"#" + target_element.Name + "." + source.Role + "\"/>");
                    }
                    if (target.Cardinality != "")
                    {
                        tw.WriteLine("\t<cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + eten(target.Cardinality) + "\"/>");
                    }
                    if (isAggregatesource)
                    {
                        tw.WriteLine("\t<cims:isAggregate rdfs:Literal=\"" + "isAggregate" + "\"/>");
                    }
                    if (con.Stereotype != "")
                    {
                        tw.WriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>");
                    }
                    tw.WriteLine("</rdf:Property>");

                }
                // cote target
                if (source.Role != "")
                { //there must be a non empty rolename
                    rname.elemid = source_element.ElementID;
                    rname.rolename = source.Role;
                    if (nomsRoles.Contains(rname))
                    {
                        /**********************
                                            MessageBox.Show( "WARNING this Role name " + source.Role
                                                + " associated with " 
                                               + source_element.Name 
                                               + " has already been used\n"
                                           + " verify if this is licit in your model");
                        ***********************/
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t WARNING this Role name " + source.Role
                                    //            + " associated with "
                                    //           + source_element.Name
                                    //           + " has already been used\n"
                                    //       + " verify if this is licit in your model"
                                    //+ "\n");
                    }
                    else
                    {
                        nomsRoles.Add(rname);
                    }
                    tw.WriteLine("<rdf:Property rdf:ID=\"" + target_element.Name + "." + source.Role + "\">");
                    tw.WriteLine("\t<rdfs:label xml:lang=\"en\">" + source.Role + "</rdfs:label>");
                    if (source.RoleNote != "") tw.WriteLine("\t<rdfs:comment rdf:parseType=\"Literal\">" + source.RoleNote + "</rdfs:comment>");
                    tw.WriteLine("\t<rdfs:domain rdf:resource=" + "\"#" + target_element.Name + "\"/>");
                    tw.WriteLine("\t<rdfs:range rdf:resource=" + "\"#" + source_element.Name + "\"/>");
                    if (target.Role != "")
                    {
                        tw.WriteLine("\t<cims:inverseRoleName rdf:resource=\"#" + source_element.Name + "." + target.Role + "\"/>");
                    }
                    if (source.Cardinality != "")
                    {
                        tw.WriteLine("\t <cims:multiplicity rdf:resource=\"" + constantes.NS_CIMS + "M:" + eten(source.Cardinality) + "\"/>");
                    }
                    if (isAggregatetarget)
                    {
                        tw.WriteLine("\t<cims:isAggregate rdfs:Literal=\"" + "isAggregate" + "\"/>");
                    }
                    if (con.Stereotype != "")
                    {
                        tw.WriteLine("<cims:stereotype>" + con.Stereotype + "</cims:stereotype>");
                    }
                    tw.WriteLine("</rdf:Property>");
                }
            }

            return true;
        }
        /// <summary>
        /// recupere les classes d'un package a un seul niveau
        /// </summary>
        /// <param name="package"></param>
        /// <returns></returns>
        public static List<EA.Element> getAllPackageClasses(EA.Package package)
        {

            List<EA.Element> resul = new List<EA.Element>();
            List<EA.Element> elemlist = new List<Element>();
            getAllElements(package, elemlist, "all");
            foreach (EA.Element el in elemlist)
            {
                if (
                   !el.StereotypeEx.Contains(CD.GetCompoundStereotype())
                   &&
                    !el.StereotypeEx.Contains(CD.GetDatatypeStereotype())
                    &&
                    !el.StereotypeEx.Contains(CD.GetEnumStereotype())
                    &&
                    !el.StereotypeEx.Contains(CD.GetPrimitiveStereotype())
                   )
                {
                    if (!resul.Contains(el)) resul.Add(el);
                }
            }
            return resul;
        }
        /// <sUMM2ary>
        /// retrieves recursively elements with a given stereotype or all elements
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public static List<EA.Element> getAllElements(EA.Package package, List<EA.Element> resultList, String stereotype)
        {
            string inter;
            /* 18
            if (stereotype == "all") // building of package containement
            {
                if (!dicpackbyid.ContainsKey(package.PackageID)) dicpackbyid.Add(package.PackageID, package);

            }
             * */
            if (Barre != null)
            {
                if (package.Elements.Count == 0)
                {
                    barreupdate(Barre, "start", 1);
                }
                else
                {
                    barreupdate(Barre, "start", package.Elements.Count);
                }
            }
            else
            {
                barreupdate(Barre, "continue", package.Elements.Count);// am 2012
            }
            foreach (EA.Element e in package.Elements)
            {
                if(Barre != null) Barre.progress();
                inter = e.Stereotype;
                if (e.Stereotype.Equals(stereotype) || e.Stereotype == "" || stereotype == "all")
                {
                    resultList.Add(e);
                }
            }
            foreach (EA.Package p in package.Packages)
            {
                getAllElements(p, resultList, stereotype);
            }

            return resultList;
        }
        public static List<EA.Element> getAllTypedElements(EA.Package package, List<EA.Element> resultList, String mytype)
        {
            string inter;
            
            if (Barre != null)
            {
                if (package.Elements.Count == 0)
                {
                    barreupdate(Barre, "start", 1);
                }
                else
                {
                    barreupdate(Barre, "start", package.Elements.Count);
                }
            }
            else
            {
                barreupdate(Barre, "continue", package.Elements.Count);// am 2012
            }
            foreach (EA.Element e in package.Elements)
            {
                if (Barre != null) Barre.progress();
                inter = e.Type;
                if (e.Type.Equals(mytype) || mytype == "all")
                {
                    resultList.Add(e);
                }
            }
            foreach (EA.Package p in package.Packages)
            {
                getAllTypedElements(p, resultList, mytype);
            }

            return resultList;
        }

        /**************************************************************************/
        public static List<EA.Connector> getAllConnectors(EA.Package package, List<EA.Connector> resultList)
        {


            foreach (EA.Connector con in package.Connectors)
            {

                resultList.Add(con);

            }
            foreach (EA.Package p in package.Packages)
            {
                getAllConnectors(p, resultList);
            }
            return resultList;
        }
        /**************************************************************************/

        public static List<EA.Package> getAllPackages(EA.Package package, List<EA.Package> resultList)
        {
            string prov;
            // // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-1 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
            if (!resultList.Contains(package))
            {
                prov = package.Name;
                resultList.Add(package);
                //     // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-2 " + package.Name + " | " + package.PackageID + "| count " + resultList.Count);
            }
            foreach (EA.Package pack in package.Packages)
            {
                //   // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-3 " + pack.Name + " | " + pack.PackageID + "| count " + resultList.Count);
                if (!resultList.Contains(pack))
                {

                    prov = pack.Name;
                    resultList.Add(pack);
                    //      // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-4 " + pack.Name + " | " + pack.PackageID + "| count " + resultList.Count);
                }
            }


            foreach (EA.Package p in package.Packages)
            {
                //  // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-5 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
                getAllPackages(p, resultList);
                //    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\npackage-6 " + p.Name + " | " + p.PackageID + "| count " + resultList.Count);
            }
            return resultList;
        }
        /**************************************************************************/
        public static List<long> getAllPackID(long pid, List<long> resultList)
        {
            string prov;
            EA.Package package;
            //18 package = dicpackbyid[pid];
            package = Main.Repo.GetPackageByID((int)pid);
            long packid = 0;
            prov = package.Name;
            if (!resultList.Contains(pid))
            {
                resultList.Add(pid);
            }
            foreach (EA.Package pack in package.Packages)
            {
                packid = pack.PackageID;
                prov = pack.Name;
                resultList.Add(packid);

            }
            foreach (EA.Package p in package.Packages)
            {
                packid = p.PackageID;
                getAllPackID(packid, resultList);
            }
            return resultList;
        }
        /**************************************************************************/

        /// retrieves recursively elements which are like classe with a given list of stereotype for CIM which is in 2009 <<datatype>>,<<primitive>>,Enumeration>>,<<Compound>>
        /// if no stereotype (null) is given
        /// </sUMM2ary>
        /// <param name="package">the package to start from</param>
        /// <param name="resultList">list to which the found elements should be added</param>
        /// <param name="stereotype">either a given stereotype if only specific elements
        /// should be retrieved, or null if all elements should be retrieved</param>
        /// <returns>a List containing all elements that correspond to the given
        /// criteria (stereotype)</returns>
        public static List<EA.Element> getStereotypedElements(EA.Package package, List<EA.Element> resultList, List<string> stereolist)
        {
            string stereo;
            foreach (EA.Element e in package.Elements)
            {
                string prov = e.StereotypeEx; //am mai 2018
                stereo = e.Stereotype;

                if (stereo == "") stereo = "Class"; // "" means implicitely a stereotype Class
                if ((e.Type == "Enumeration") || (e.MetaType == "Enumeration")) stereo = CD.GetEnumStereotype(); // means an enumeration //am mai 2018
                foreach (string s in stereolist)
                    if (s == stereo || stereo == "")
                    {
                        resultList.Add(e);
                    }
            }
            foreach (EA.Package p in package.Packages)
            {
                getStereotypedElements(p, resultList, stereolist);
            }
            return resultList;
        }

        //-----------------------------------------------------------------------------------
        public static List<EA.Element> getTypedElements(EA.Package package, List<EA.Element> resultList, string type)
        {

            foreach (EA.Element e in package.Elements)
            {


                if (e.Type == type)
                {
                    if (!resultList.Contains(e)) resultList.Add(e);
                }
            }
            if(package.Packages.Count > 0) // EA API's problem with collections 
            {
                foreach (EA.Package p in package.Packages)
                {
                    getTypedElements(p, resultList, type);
                }
            }
            return resultList;
        }
        //-----------------------------------------------------------------------------------
        public static List<EA.Element> getTypedOneLevelElements(EA.Package package, List<EA.Element> resultList, string type)
        {

            foreach (EA.Element e in package.Elements)
            {


                if (e.Type == type)
                {
                    if (!resultList.Contains(e)) resultList.Add(e);

                    string texte = "======   GetTypedList element=" + e.Name;
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    //MessageBox.Show(texte);
                }
            }

            return resultList;
        }
        //----------------------------------------------------------------------------	

        /// <summary>
        /// Get all the elements in a package (without consulting descendant packages)
        /// wich have a stereotype according to a list
        /// </summary>
        /// <param name="package"></param>
        /// <param name="resultList"></param>
        /// <param name="stereolist"></param>
        /// <returns></returns>
        public static List<EA.Element> getLocalStereotypedElements(EA.Package package, List<string> stereolist)
        {
            List<EA.Element> elemList = new List<EA.Element>();

            string stereo;
            foreach (EA.Element e in package.Elements)
            {
                stereo = e.Stereotype;
                if (stereo == "") stereo = "Class"; // an element without a stereotype is implicitely a Class
                if (stereolist.Contains(stereo))
                {

                    elemList.Add(e);
                }
            }


            return elemList;
        }
        //--------------------------------------------------------------------


        /// <summary>
        /// Get all the elements in a package (without consulting descendant packages)
        /// wich have a type according to a string
        /// </summary>
        /// <param name="package"></param>
        /// <param name="resultList"></param>
        /// <param name="type"></param>
        /// <returns></returns>
        public static List<EA.Element> getLocalTypedElements(EA.Package package, string type)
        {
            List<EA.Element> elemList = new List<EA.Element>();

            foreach (EA.Element e in package.Elements)
            {

                if (e.Type == type)
                {

                    elemList.Add(e);
                }
            }


            return elemList;
        }

        //---------------------------------------------------------------------

        /// <summary>
        /// 
        /// </summary>
        /// <param name="ElList"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public static EA.Element getElementbyID(List<EA.Element> ElList, long id)
        {
            EA.Element match = ElList.Find(e => e.ElementID == id);
            string prov = match.Name;

            return match;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="elem"></param>
        /// <returns></returns>
        public static EA.Element getElementSuperclass(EA.Element elem)
        {
            string prov = elem.Name;
            EA.Element tobereturn = null;
            foreach (EA.Connector con in elem.Connectors)
            {
                string s = con.Type;
                switch (s)
                {
                    case "Generalization":
                        if (con.SupplierID == elem.ElementID)
                        {
                            tobereturn = null;
                        }
                        else
                        {
                            //18 tobereturn = dicelembyid[con.SupplierID];
                            tobereturn = Main.Repo.GetElementByID((int)con.SupplierID);
                        }
                        break;
                    case "Dependency":
                        break;
                    case "Association":
                        break;
                    case "Aggregation":
                        break;
                    default:
                        break;
                }
            }
            return tobereturn;
        }
        //-----------------------------------
        public static EA.Attribute getAttributeBasedOnAttribute(EA.Attribute atr, EA.Repository repo)
        {
            string guid = "";
            EA.Attribute retour = null;
            foreach (EA.AttributeTag atagv in atr.TaggedValues)
            {
                if (atagv.Name == CD.GetIBOTagValue())
                {
                    guid = atagv.Value;
                    break;
                }

            }
            if (guid != "")
            {
                retour = repo.GetAttributeByGuid(guid);
            }
            else
            {
                retour = atr; // soit meme si non base sur une autre classe
            }
            return retour;
        }


        //-----------------------------------
        public static EA.Attribute getAttributeOriginBasedOnAttribute(EA.Attribute atr, EA.Repository repo)
        {

            string prov = atr.Name;
            EA.Attribute tobereturn = atr;
            EA.Attribute inter = atr;
            while (tobereturn != (inter = getAttributeBasedOnAttribute(inter, repo)))
            {
                tobereturn = inter;
            }
            return tobereturn;
        }


        //------------------------------ 
        /// <summary>
        /// Get the direct element on which
        /// the current element is based on
        /// if the element is based on itself or without isbasedon dependancy 
        /// its ID is returned or "" if the element is null
        /// </summary>
        /// <param name="elem"></param>
        /// <returns></returns>
        public static EA.Element getElementBasedonElement(EA.Element elem)
        {
            EA.Element ret = elem;
            string guid = getEltParentGuid(elem);
            if(guid != "")
            {
                ret = Main.Repo.GetElementByGuid(guid);
            }
            return ret;;
        }
        public static EA.Element oldgetElementBasedonElement(EA.Element elem)//18
        {

            EA.Element tobereturn = elem;
            if (elem != null)
            {
                string prov = elem.Name;
                if (elem.Connectors.Count > 0)
                {
                    foreach (EA.Connector con in elem.Connectors)
                    {
                        string s = con.Type;
                        switch (s)
                        {
                            case "Generalization":

                                break;
                            case "Dependency":
                                prov = con.StereotypeEx + "|" + con.Stereotype;
                                if (con.Stereotype.Contains(CD.GetIsBasedOnStereotype()))
                                {

                                    if (con.SupplierID != elem.ElementID)
                                    {
                                        /*
                                    {
                                        tobereturn = elem;
                                    }
                                    else
                                    {
                                         */
                                       //18 if (dicelembyid.ContainsKey(con.SupplierID))   //  ATTENTION PROBLEME
                                       //18 {
                                            tobereturn = Main.Repo.GetElementByID((int)con.SupplierID);
                                        }


                                        //  MessageBox.Show( tobereturn.Name + "|" + tobereturn.StereotypeEx); // tobereturn.PackageID.ToString());
                                        return tobereturn;
                                    //18}

                                }
                                break;
                            case "Association":
                                break;
                            case "Aggregation":
                                break;
                            default:
                                break;
                        }
                    }
                }
            }

            //  MessageBox.Show(tobereturn.Name + "|"  + tobereturn.StereotypeEx);
            return tobereturn;
        }
        
        public static string getEltParentGuid(EA.Element elt) //18
        {
            string ret = "";
            string prov = elt.Name;
            foreach (EA.TaggedValue tag in elt.TaggedValues)
            {
                if (tag.Name == CD.GetIBOTagValue())
                {
                    ret = tag.Value;
                    break;
                }

            }
            return ret;
        }
        /// <summary>
        /// get the element on which one elem is basedon
        /// </summary>
        /// <param name="elt"></param>
        /// <returns></returns>
        public static EA.Element getEltParent(EA.Element elt) //18
        {
            EA.Element ret = null;
            string eltguid = getEltParentGuid(elt);
            string prov = elt.Name;

            Main.Repo.GetElementByGuid(eltguid);
            
            return ret;
        }
        //------------------------------ 
        //------------------------------ 
        /// <summary>
        /// Get the original element on which
        /// the current element is based on
        /// </summary>
        /// <param name="elem"></param>
        /// <returns></returns>
        public static EA.Element getElementOriginBasedonElement(EA.Element elem)
        {
            string prov = elem.Name;
            EA.Element tobereturn = elem;
            EA.Element inter = elem;
            while (tobereturn != (inter = getElementBasedonElement(inter)))
           
            {
                if(inter == null)
                {
                    MessageBox.Show("ERROR: In " + tobereturn + " specidied 'based on' element not found!");
                    return null;
                }
                tobereturn = inter;
            }
            return tobereturn;
        }

        //------------------------------ 
        public static string SelectFileAndCopy(string FileName)
        {
            Stream myStream = null;
            string nomfichier = "";
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "txt files (*.rdf)|*.rdf|All files (*.*)|*.*";
            //saveFileDialog1.Filter = "rdf files (*.rdf)|*.rdf |All files (*.*)|*.*" ;
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.RestoreDirectory = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {

                try
                {
                    if ((myStream = saveFileDialog1.OpenFile()) != null)
                    {

                        using (myStream)
                        {
                            nomfichier = saveFileDialog1.FileName;
                            // Insert code to write the stream here.

                            //           MessageBox.Show(FileName);


                            try
                            {
                                myStream.Close();
                                // Ensure that the target does not exist.
                                System.IO.File.Delete(nomfichier);

                                // Copy the file.
                                System.IO.File.Copy(FileName, nomfichier);
                                System.IO.File.Delete(FileName);

                                Console.WriteLine("{0} copied to {1}", FileName, nomfichier);
                            }
                            catch (Exception e)
                            {
                                MessageBox.Show(" copy of file " + FileName + " to file " + nomfichier + " not allowed " + e.Message);
                            }

                        }

                        //       princ.StartProcess("", nomfichier);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t Error: Could not read file from disk. Original error: " + ex.Message + "\n");
                }
            }
            saveFileDialog1.Dispose(); // ABA20230730
            return nomfichier;
        }
        //------------------------------ 
        public static string SelectFile(string ext)
        {
            //Stream myStream = null;
            string nomfichier = "";
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            // string filtre = "ext files (*." + ext + ")*." + ext + "|All files (*.*)|*.*";
            string filtre = "html files (*.html)|*.html|All files (*.*)|*.*";
            saveFileDialog1.Filter = filtre;
            //saveFileDialog1.Filter = "rdf files (*.rdf)|*.rdf |All files (*.*)|*.*" ;
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.RestoreDirectory = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {

                nomfichier = saveFileDialog1.FileName;
                // Insert code to write the stream here.

                //           MessageBox.Show(FileName);
            }
            saveFileDialog1.Dispose(); // ABA20230730
            return nomfichier;
        }

        //---------------------------------------------------------
        /// <summary>
        /// get the Package path  in which the object on which 
        /// the element  is situated
        /// </summary>
        /// <param name="el"></param>
        /// <returns>string path of Packages hierarchie
        ///          </returns>
        public static string GetPackageContainmentPath(EA.Element el)
        {
            string retour = "";

            try
            {

                if (el != null)
                {

                    List<String> chemin = new List<String>();
                    DirectPackageContainmentPath(Main.Repo.GetPackageByID((int)el.PackageID), chemin);
                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                    {
                        bchemin.Append("/" + name);
                    });

                    retour = bchemin.ToString();
                    return retour;
                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return retour;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Error  GetPackageBasedOnContainmentPath " + e.Message + "\n");
                return retour;
            }
        }
        //---------------------------------------------------------
        //---------------------------------------------------------
        /// <summary>
        /// get the Package in which the object on which 
        /// the element is based on is situated
        /// </summary>
        /// <param name="el"></param>
        /// <param name="uri">uri</param>
        /// <returns>ArrayList[0]= string path of Packages hierarchie
        ///                       the upper name is substituted by http:// if uri=true
        ///          ArrayList[1]= path to the isbasedon class</returns>
        public static ArrayList GetPackageBasedOnContainmentPath(EA.Element el)
        {
            EA.Element elbase;
            ArrayList forreturn = new ArrayList();
            forreturn.Add("");
            forreturn.Add(null);

            try
            {

                if (el != null)
                {

                    elbase = getElementBasedonElement(el);

                    if (elbase == null) elbase = el;

                    string prov = " elname=" + el.PackageID.ToString() + "::" + el.Name + "," + elbase.PackageID.ToString() + "::" + elbase.Name;
                    RDFLAutilitaires.wtest("utilitaites.GetPackageBasedOnContainmentPath",  prov);
                    List<String> chemin = new List<String>();
                    //18 DirectPackageContainmentPath(RDFutilitaires.dicrepobyid[elbase.PackageID], chemin);
                    DirectPackageContainmentPath(Main.Repo.GetPackageByID((int)elbase.PackageID), chemin);
                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                        {
                            bchemin.Append("/" + name);
                        });

                    forreturn[0] = bchemin.ToString();

                    forreturn[1] = elbase;
                    return forreturn;
                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return forreturn;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath  " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Error  GetPackageBasedOnContainmentPath " + "\n" + e.Message);
                return forreturn;
            }
        }


        //---------------------------------------------------------
        /// <summary>
        /// get the Package in which the object on which 
        /// the element is based at the Model Information origin on is situated
        /// </summary>
        /// <param name="el"></param>
        /// <returns>ArrayList[0]= path to the isbasedon class
        ///          ArrayList[1]= path to the isbasedon class</returns>
        public static ArrayList GetPackageBasedOnOriginContainmentPath(EA.Element el)
        {

            EA.Element elbase;
            ArrayList forreturn = new ArrayList();
            forreturn.Add("");
            forreturn.Add(null);
            try
            {

                if (el != null)
                {
                    if (el == null)
                    { // this is a locally defined element
                        elbase = el;
                    }
                    else
                    {
                        elbase = getElementOriginBasedonElement(el);
                    }
                    if (elbase == null) elbase = el;

                    List<String> chemin = new List<String>();
                   //18  DirectPackageContainmentPath(RDFutilitaires.dicrepobyid[elbase.PackageID], chemin);
                    DirectPackageContainmentPath(Main.Repo.GetPackageByID((int)elbase.PackageID), chemin);
                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                    {
                        bchemin.Append("/" + name);
                    });


                    forreturn[0] = bchemin.ToString();


                    forreturn[1] = elbase;

                    return forreturn;

                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return forreturn; ;
                }
            }
            catch
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath " + "\n");
                return forreturn; ;
            }
        }
        //---------------------
        /// <summary>
        /// hierarchie et classe du SI sur lequel estest base la classe d'ou vient l' attribut.
        /// </summary>
        /// <param name="el"></param>
        /// <param name="atr"></param>
        /// <returns>ArrayList[0]= path to the isbasedon class (the highest level)
        ///          ArrayList[1]= the class from which the atr comes </returns>
        public static ArrayList GetPackageBasedOnOriginContainmentPath(EA.Element el, EA.Attribute atr)
        {

            EA.Element elbase;
            ArrayList forreturn = new ArrayList();
            forreturn.Add("");
            forreturn.Add(null);
            try
            {

                if (el != null)
                {

                    elbase = getElementOriginBasedonElement(el);


                    if (elbase == null) elbase = el; // locally defined
                    EA.Element classeorigine = elbase;
                    EA.Element mother = GetMotherClass(elbase);
                    while (mother != null)
                    {
                        if (IsAtrMember(mother, atr))
                        {
                            classeorigine = mother;
                            break;
                        }
                        else
                        {
                            mother = GetMotherClass(mother);
                        }

                    }

                    List<String> chemin = new List<String>();
                    //18 DirectPackageContainmentPath(RDFutilitaires.dicrepobyid[classeorigine.PackageID], chemin);
                    DirectPackageContainmentPath(Main.Repo.GetPackageByID((int)classeorigine.PackageID), chemin);

                    chemin.Reverse();
                    if (chemin[0] == "Model") chemin.Remove("Model");
                    StringBuilder bchemin = new StringBuilder();
                    chemin.ForEach(delegate(String name)
                    {
                        bchemin.Append("/" + name);
                    });


                    forreturn[0] = bchemin.ToString();


                    forreturn[1] = classeorigine;

                    return forreturn;

                }
                else
                {
                    MessageBox.Show("error GetPackageBasedOnContainmentPath el==null");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath el==null" + "\n");
                    return forreturn; ;
                }
            }
            catch
            {
                MessageBox.Show("Error  GetPackageBasedOnContainmentPath ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t error GetPackageBasedOnContainmentPath " + "\n");
                return forreturn; ;
            }
        }

        //----------------------------------


        //--------------------------------------------------------
        /// <summary>
        /// calculate the Package containment from a given Package
        /// the result is in the form of a string list in reverse order
        /// </summary>
        /// <param name="pa"></param>
        /// <param name="path"></param>
        static void DirectPackageContainmentPath(EA.Package pa, List<String> path)
        {
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
            {
                DirectPackageContainmentPath(Main.Repo.GetPackageByID((int)pa.ParentID), path);

            }
        }
        //--------------------------------------------------------
        /// <summary>
        /// Get the top CIM package   from a given Package
        /// the result is the CIM package
        /// </summary>
        /// <param name="pa"></param>
        /// <param name="repo"></param>
        /// <returns></returns>
        static public EA.Package GetCIMOrExtensionPackage(EA.Package pa, EA.Repository repo,XMLProfileParameters profparams)
        {
            EA.Package retpa = null;
            EA.Package cimpa=pa;
            /*
            if(pa.Name==profparams.PackageExtension)
            {
                return cimpa;
            }
             * */
            int  ind = 1;
            long paid = cimpa.ParentID;
            while (ind != 0)
            {
                
                if(cimpa.Name.Contains("IEC")) // il s'agi bien d'un package CIM
                {
                    break;

                }
                else
                {
                    /*
                    if (cimpa.Name == profparams.PackageExtension)
                    {
                        break; // il s'agit d'un package extension
                    }
                    */
                }
                retpa = repo.GetPackageByID((int)paid);
                paid = retpa.ParentID;
                cimpa = retpa;
                if (paid == 0) break;   // on a atteint le sommet
            }

            return cimpa;
        }
        //-------------------------
        /// <summary>
        /// Get the top model package   from a given Package
        /// the result is the model package
        /// </summary>
        /// <param name="pa"></param>
        /// <param name="repo"></param>
        static public EA.Package GetModelPackage(EA.Package pa, EA.Repository repo)
        {
            EA.Package retpa = null;
            long paid = pa.ParentID;
            while (paid != 0)
            {
                retpa = repo.GetPackageByID((int)paid);
                paid = retpa.ParentID;
                if (paid == 0) break;   // on a trouve                            
            }
            return retpa;
        }
        //-------------------------
        static public bool isnumeric(string s)
        {
            List<char> digits = new List<char>("0123456789");
            bool result = true;
            List<char> ss = new List<char>(s);
            foreach (char c in ss)
            {
                if (!digits.Contains(c))
                {
                    result = false;
                    break;
                }
            }
            return result;
        }

        //---------------------------------------------------
        /// <summary>
        ///  give the list of all classes of a package (including all included packages)
        ///  which are without ascendant (rootclass in WG19NDR terms)
        /// </summary>
        /// <param name="package"></param>
        /// <param name="resultlist" </param>
        /// <returns></returns>
        static public void GetClassesWithoutAscendant(EA.Package package, List<long> resultlist)
        {
            foreach (EA.Element e in package.Elements)
            {

                if ((e.StereotypeEx).Contains("Class") && e.IsActive)
                {
                    //MessageBox.Show("|" + e.ElementID + "|" + e.Name + "|");
                    if (!resultlist.Contains(e.ElementID))
                    {
                        resultlist.Add(e.ElementID);
                    }
                }
            }
            EA.Collection col = package.Packages;

            for (short i = 0; i < col.Count; i++)
            {
                EA.Package p = (EA.Package)col.GetAt(i);
                GetClassesWithoutAscendant(p, resultlist);
            }
            ;
        }
        //---------------------------------------------------------------------------------------------       
        static public EA.Element GetMotherClass(EA.Element el)
        {
            EA.Element res = null;
            if (el != null)
            {
                EA.Collection cons = el.Connectors;
                foreach (EA.Connector con in cons)
                {
                    if ((con.Type == "Generalization") && (el.ElementID != con.SupplierID)) res = Main.Repo.GetElementByID((int)con.SupplierID);
                }
            }
            return res;
        }
        //---------------------------------------------------------------------------------------------       
        /// <summary>
        /// get the hierarchy of ascendant classes of an element
        /// </summary>
        /// <param name="elid"></param>
        /// <param name="lmothersid"></param>
        static public void GetMothersClass(long elid, List<long> lmothersid)
        {
            EA.Element el = null;
            //18if (dicelembyid.ContainsKey(elid)) 
                el = Main.Repo.GetElementByID((int)elid);
            if (el != null)
            {
                EA.Collection cons = el.Connectors;
                foreach (EA.Connector con in cons)
                {
                    if ((con.Type == "Generalization") && (elid != con.SupplierID))
                    {
                        if (!lmothersid.Contains(con.SupplierID))
                        {
                            lmothersid.Add(con.SupplierID);
                        }
                        GetMothersClass(con.SupplierID, lmothersid);
                    }
                }
            }
        }
        //---------------------------------------------------------------------------------------------       
        /// <summary>
        /// get the hierarchy path of ascendant classes of an element
        /// </summary>
        /// <param name="elid"></param>
        /// <param name="lmothersid"></param>
        static public string GetInheritancePath(EA.Repository repo, long elid, List<long> lmotherselid)
        {
            string texte = "";
            foreach (long eltid in lmotherselid)
            {
                texte = texte + "->" + repo.GetElementByID((int)eltid).Name;

            }
            // texte = texte + "->" + repo.GetElementByID((int)elid).Name;
            return texte;
        }
        //--------------------------------------------------------------------------
        /// <summary>
        /// change * into n
        /// and potentially 1..1 into 1
        /// </summary>
        /// <param name="s"></param>
        /// <returns></returns>
        static public string eten(string s)
        {
            if (s == "0..*") return s.Replace("0..*", "0..n");
            if (s == "1..*") return s.Replace("1..*", "1..n");
            if (s == "1..1") return s.Replace("1..1", "1..1");
            return s;
        }
        //--------------------------------------------------------------------------
        /// <summary>
        /// remove /r/n from the end of the s
        /// </summary>
        /// <param name="s"></param>
        static public string RemoveRc(string s)
        {
            s = RDFutilitaires.modifrefs(s, "<a href=\"{??");
            char[] rc = { '\n', '\r' };
            s = s.TrimEnd(rc);
            return s;
        }
        //--------------------------------------------------------------------------
        //--------------------------------------------------------------------------
        /// <summary>
        /// remove the qualifier from  a name 
        /// </summary>
        /// <param name="s"></param>
        static public string RemoveQual(string s)
        {
            Int32 ind = s.IndexOfAny(new char[] { '_' });
            string ss = s.Substring(ind + 1);
            return ss;
        }
        //--------------------------------------------------------------------------
        static public string getBasedOnConnectoryGUID(EA.Repository repo, string guid)
        {
            string ret = null;

            EA.Connector con = repo.GetConnectorByGuid(guid);
            if (con == null) return ret;
            EA.Collection tags = con.TaggedValues;
            foreach (ConnectorTag ctag in tags)
            {
                if (ctag.Name == CD.GetIBOTagValue()) { ret = ctag.Value; return ret; }
            }
            return ret;
        }
        //--------------------------------------------------------------------------
        static public string getOriginBasedOnConnectorbyGUID(EA.Repository repo, string guid)
        {
            string ginterim = guid;
            string ret = null;
            while (ginterim != null)
            {
                ret = ginterim;
                ginterim = getBasedOnConnectoryGUID(repo, ginterim);
            }
            return ret;
        }
        //--------------------------------------------------------------------------     
        static public bool ElementBelongsToProfile(EA.Element clroot, EA.Package apackage, EA.Package toppack)
        {
            bool ret = false;
            long packid = clroot.PackageID;
            long topid = toppack.PackageID;
            long profid = apackage.PackageID;
            while (packid != topid)
            {
                if (packid == profid)
                {
                    ret = true;
                    break;
                }
                //18 packid = (dicpackbyid[packid]).ParentID;
                packid = Main.Repo.GetPackageByID((int)packid).ParentID;
            }
            return ret;
        }

        //-------------------------------------------------------------------------- 
        static public void GetConcreteDescendants(EA.Element element, List<long> concretids)
        {// update concretel list and return abs
            try
            {
                // MessageBox.Show(" GetConcreteDescendants element: " + element.Name);// pour test
                if ((element == null) || (element.Abstract == "0"))
                {
                    if (!concretids.Contains(element.ElementID)) concretids.Add(element.ElementID);
                    return;
                }
                else
                {
                    foreach (EA.Connector con in element.Connectors)
                    {
                        if ((con.Type == "Generalization") && (con.SupplierID == element.ElementID))
                        {  // descending the hierarchy
                            EA.Element elt = Main.Repo.GetElementByID((int)con.ClientID);
                            if (elt.Abstract == "0")
                            {// we get a concrete descendant
                                if (!concretids.Contains(elt.ElementID)) concretids.Add(elt.ElementID);
                            }
                            else
                            { // it is an abstract descendant should go on
                                GetConcreteDescendants(elt, concretids);
                            }
                        }
                    }
                }
            }
            catch (Exception e)
            {
                (Main.reportlog).WriteLine(" Error in trying to find descendants of Element" + element.Name + " | " + e.Message);
                MessageBox.Show(" Error in trying to find descendants of Element" + element.Name + " | " + e.Message);
                return;
            }
        }
        //-------------------------------------------------------------------------- 
        //-------------------------------------------------------------------------------
        public static void buildLocalClassNames(EA.Package apackage, List<string> classnamelist)
        {
            List<EA.Element> ellist = new List<EA.Element>();
            getTypedElements(apackage, ellist, "Class");
            foreach (EA.Element el in ellist)
            {
                if (el.Name != null)
                {
                    classnamelist.Add(el.Name);

                    //  MessageBox.Show(" classtype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }

        }

        //--------------------------------------------------------------------------   
        public static void buildLocalDatatypeNames(EA.Package apackage, List<string> datanamelist, List<long> dataidlist)
        {
            List<EA.Element> ellist = new List<EA.Element>();
            RDFutilitaires.getStereotypedElements(apackage, ellist, new List<string>()
                                      {
	                                "Datatype", // for ascendant compatibility
                                    "Enumeration", // am mai 2018
					CD.GetDatatypeStereotype(),
                                        CD.GetPrimitiveStereotype(),
	                                CD.GetPrimitiveStereotype(),
	                                CD.GetEnumStereotype(),
                                       });

            foreach (EA.Element el in ellist)
            {
                if (el.Name != null)
                {
                    datanamelist.Add(el.Name);
                    dataidlist.Add(el.ElementID);
                    //  MessageBox.Show(" datatype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }

        }
        //-------------------------------------------------------------------------------------
        //------------------
        public static int CompareElementsbyName(EA.Element x, EA.Element y)
        {
            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    return (x.Name).CompareTo(y.Name);

                }
            }
        }
        /// <summary>
        /// comparer 2 elements par leur nom s'ils sont donns par leur ID
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <returns></returns>
        public static int CompareElementIDsbyName(long elemidx, long elemidy)
        {
            if (elemidx == 0)  //(elemidx == null) ABA20230905 long is never null!!
            {
                if (elemidy == 0)  //(elemidy == null) ABA20230905 long is never null!!
                {
                    // If elemidx is null and elemidy is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If elemidx is null and y is not null, elemidy
                    // is greater. 
                    /*18
                    if (!dicelembyid.ContainsKey(elemidy))
                    {
                        return 0;
                    }
                    else
                    {
                     * */
                        return -1;
                   //18 }
                }
            }
            else
            {
                // If x is not null...
                //

                if (elemidy == 0)  //((elemidy == null)) ABA20230905 //18 || (!dicelembyid.ContainsKey(elemidy)))
                // ...and elemidy is null, ilemidx is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                   //18  string namx = dicelembyid[elemidx].Name;
                   //18  string namy = dicelembyid[elemidy].Name;
                    string namx = Main.Repo.GetElementByID((int)elemidx).Name;
                    string namy = Main.Repo.GetElementByID((int)elemidy).Name;
                    return (namx).CompareTo(namy);

                }
            }
        }
        //-----------------------------

        public static int CompareAttributesbyName(EA.Attribute x, EA.Attribute y)
        {
            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    return (x.Name).CompareTo(y.Name);

                }
            }
        }

        public static int CompareConnectorsbyRoleName(EA.Element el, EA.Connector conx, EA.Connector cony)
        {
            EA.ConnectorEnd endx;
            EA.ConnectorEnd endy;
            if (conx == null)
            {
                if (cony == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                // If x is null and y is not null,
                // if(endy is null equal
                // if(endy is not null )
                // y  is greater. 
                {

                    endy = (EA.ConnectorEnd)getOtherend(el, cony)[0];
                    if (endy == null) return 0;
                    return -1;
                }
            }
            else

            // If y is null and x is not null,
            // if(endx is null equal
            // if(endx is not null )
            // x  is greater. 
            {
                endx = (EA.ConnectorEnd)(getOtherend(el, conx))[0];
                if (endx == null) return 0;
                return 1;
            }
            /* ABA20230905 NOT REACHABLE!!
            endx = (EA.ConnectorEnd)(getOtherend(el, conx))[0];
            endy = (EA.ConnectorEnd)(getOtherend(el, cony))[0];

            if (endx == null)
            {
                if (endy == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (endy == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {
                    // sort them with ordinary string comparison.
                    //
                    return (endx.Role).CompareTo(endy.Role);

                }
            }*/
        }

        static public ArrayList getOtherend(EA.Element el, EA.Connector con)
        { // get the connexion otherend caracteristics
            ArrayList ret = new ArrayList();

            ret.Add(null);
            ret.Add(0);
            EA.ConnectorEnd theotherend = null;
            long theotherendID = 0;
            if ((con.Type == "Association") || (con.Type == "Aggregation"))
            {
                if (con.ClientID == el.ElementID)  // the otherend is target
                {
                    if ((con.SupplierEnd.Role != "") && (con.SupplierEnd.Aggregation == 0))
                    {//the otherend is target
                        theotherend = con.SupplierEnd;
                        theotherendID = con.SupplierID;

                    }
                }
                if (con.SupplierID == el.ElementID)  // the otherend is source
                {
                    if ((con.ClientEnd.Role != "") && (con.ClientEnd.Aggregation == 0))
                    {//the otherend is source
                        theotherend = con.ClientEnd;
                        theotherendID = con.ClientID;
                    }
                }
                ret[0] = theotherend;
                ret[1] = theotherendID;
            }
            return ret;

        }

        //-------------------------
        static public EA.Element getTheotherend(EA.Repository repo, EA.Element el, EA.Connector con)
        {

            string prov = con.ConnectorID.ToString();
            EA.Element theotherend = null;
            if (con.ClientID == el.ElementID)
            { // theother end is target
                try
                {
                    theotherend = repo.GetElementByID((int)con.SupplierID);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }
            }
            else
            {
                theotherend = (EA.Element)repo.GetElementByID(con.ClientID);
            }
            return theotherend;
        }
        //---------------------------------------------------------------------------------
        static public List<string> getOrderedWg16ClassElementNames(EA.Repository repo, EA.Element el)
        {
            string prov = el.Name;
            List<string> resul = new List<string>();
            SortedDictionary<int, string> elementbyrg = new SortedDictionary<int, string>();
            foreach (EA.Attribute at in el.Attributes)
            {
                if (!elementbyrg.ContainsKey(getAtRang(at))) elementbyrg.Add(getAtRang(at), at.Name);
            }
            foreach (EA.Connector con in el.Connectors)
            {
                EA.ConnectorEnd otherend = null;
                if ((con.Type != "Association") && (con.Type != "Aggregation")) continue;
                if ((el.ElementID == con.SupplierID) && (con.SupplierEnd.Aggregation == 1))
                {
                    otherend = con.ClientEnd;
                }

                if ((el.ElementID == con.ClientID) && (con.ClientEnd.Aggregation == 1))
                {
                    otherend = con.SupplierEnd;
                }
                if (otherend != null)
                {
                    if (!elementbyrg.ContainsKey(getAtRang(con))) elementbyrg.Add(getAtRang(con), otherend.Role);
                }
            }
            foreach (KeyValuePair<int, string> kv in elementbyrg)
            {
                if (!resul.Contains(kv.Value)) resul.Add(kv.Value);
            }
            return resul;
        }
        //-----------------------
        static public int getAtRang(EA.Connector con)
        {
            ConstantDefinition CD = new ConstantDefinition();
            int resul = -1;
            foreach (EA.ConnectorTag tag in con.TaggedValues)
            {
                if (tag.Name == CD.GetRangTagValue())
                {
                    resul = System.Convert.ToInt32(tag.Value);
                    break;
                }
            }
            return resul;
        }
        static public int getAtRang(EA.Attribute at)
        {
            int resul = -1;
            foreach (EA.AttributeTag tag in at.TaggedValues)
            {
                if (tag.Name == CD.GetRangTagValue())
                {

                    resul = System.Convert.ToInt32(tag.Value);

                    break;
                }
            }

            return resul;
        }


        //-------------------------------------------------------------------------------------- 
        /*
              string GetModelVersionForElement(EA.Element el,EA.Repository repo){
       // this is ugly and temporary: it will last for ever
       EA.Element version61970=(EA.Element)repo.GetElementByName("IEC61970Version");
       EA.Element version61968=(EA.Element)repo.GetElementByName("IEC61968Version");
       EA.Element version62325=(EA.Element)repo.GetElementByName("IEC626325Version");
       List<EA.Package> lpa =new List<EA.Package>();
       long ind=0;
       paid=el.PackageID;
       EA.Element elt = el;
       while(ind==0){
       if(repo.GetPackageByID(paid)== "IEC61970Version"){


       break;
       }{
       return version61970.version;
       break;
       }
       if(version61968.PackageID == paid){
       return version61968.version;
       break;
       }
       if(version62325.PackageID == paid){
       return version62325.version;
       break;
       }
       }
       }
       */
        //------------------------------------------------------------------------------------- 
        public static int CompareStringsByLength(string x, string y)
        {
            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {
                    // ...and y is not null, compare the 
                    // lengths of the two strings.
                    //
                    int retval = x.Length.CompareTo(y.Length);

                    if (retval != 0)
                    {
                        // If the strings are not of equal length,
                        // the longer string is greater.
                        //
                        return retval;
                    }
                    else
                    {
                        // If the strings are of equal length,
                        // sort them with ordinary string comparison.
                        //
                        return x.CompareTo(y);
                    }

                }
            }

        }





        //==================================================
        static public void swapl(ArrayList myliste, int a, int b)
        {

            if (a == b) return;
            string interm = "";
            interm = (string)myliste[a];
            myliste[a] = myliste[b];
            myliste[b] = interm;
            ArrayList prov = myliste;
        }

        static public void setper(ArrayList maliste)
        {
            RDFutilitaires.resulpermutation = new ArrayList();
            permindex = 0;
            int nbperm = factorielle(maliste.Count);
            for (int q = 0; q < nbperm; q++)
            {
                RDFutilitaires.resulpermutation.Add(new ArrayList());
            }
            if (maliste.Count > 0)
            {
                //  RDFutilitaires.resulpermutation.Add(maliste);  // la liste initiale
                int x = maliste.Count - 1;
                go(maliste, 0, x);
            }
        }

        static public void go(ArrayList laliste, int k, int m)
        {
            int i;
            if (k == m)
            {
                string texte = "";
                foreach (string s in laliste)
                {
                    texte = texte + s + "|";
                }
                //MessageBox.Show(">" + texte); // pour test
                resulpermutation[permindex] = laliste.Clone();
                permindex++;
                ArrayList prov = resulpermutation; // pour test
            }
            else
                for (i = k; i <= m; i++)
                {
                    swapl(laliste, k, i);
                    go(laliste, k + 1, m);
                    swapl(laliste, k, i);
                }
        }

        public static int factorielle(int n)
        {

            if (n == 0) return 1;
            return n * factorielle(n - 1);

        }
        /// <summary>
        ///  cherche si la class contient un attribut de meme nom
        /// 
        /// </summary>
        /// <param name="el"></param>
        /// <param name="atr" </param>
        /// <returns>vrai si attribut de mem nom trouve</returns>
        public static bool IsAtrMember(EA.Element el, EA.Attribute atr)
        {
            bool ret = false;
            foreach (EA.Attribute at in el.Attributes)
            {
                if (atr.Name == at.Name)
                {
                    ret = true;
                    break;
                }
            }
            return ret;
        }

         //----------------------------
        /// <summary>
        /// get the URI from the Version class either from the IM package or from the extension package
        /// </summary>
        /// <param name="el"></param>
        /// <param name="profparams"></param>
        /// <returns>uri</returns>
         public static string getURIFromVersion(EA.Element el,XMLProfileParameters profparams)
         {
             string ret = "";
             EA.Element origel= getElementOriginBasedonElement(el);
             if (origel == null)
             {
                 return null;
             }
             EA.Package packorig =null;
             if (Main.Repo!= null)
             {
                  packorig = Main.Repo.GetPackageByID((int)origel.PackageID);
             }
             else
             {
                 return ret;
             }
             XMLParser xmlp=new XMLParser(Main.Repo);
             EA.Package cimpack = GetCIMOrExtensionPackage(packorig, Main.Repo,profparams);
             /*
             if(cimpack.Name== profparams.PackageExtension)// nom du package extension pour entsoe
             {
                 foreach(EA.Element elt in cimpack.Elements)
                 {
                    if(elt.Name==ExtensionName)
                    {
                        foreach(EA.Attribute at in elt.Attributes)
                        {
                            if(at.Name == "namespaceURI")
                            {
                                ret = at.Default;
                            }
                        }
                    }
                 }
             }
             else // il s'agit d'un package du CIM
             {
             */
                 ret = profparams.RootModelURI;
                /* ATTENTION pour l'instant on ne tient pas compte des versions des packages mais il faudra definir une stategie
                 foreach (EA.Element elt in cimpack.Elements)
                 {
                     if (elt.Name == cimpack.Name + "CIMVersion")
                     {
                         foreach (EA.Attribute at in elt.Attributes)
                         {
                             if (at.Name == "version")
                             {
                                 ret = at.Default;
                                 break;
                             }
                         }
                     }
                 }
                 * */
             //}
             return ret;
         }

  

        //----------------------------
        /// <summary>
        /// donne tous les packages en ligne direct sur lesquels sont bases le package
        /// </summary>
        /// <param name="pack"></param>
        /// <param name="allpacks"></param>
        /// <param name="resultlist"></param>
        public static void getPackagesOrigineIBO(long packid, Dictionary<long, EA.Package> dicpackbyid, List<long> resultlist)
        {

            EA.Package pack = dicpackbyid[packid];
            string prov = pack.Name;
            EA.Element packel = pack.Element;
            foreach (EA.Connector con in packel.Connectors)
            {
                if ((con.Type == "Dependency") && (con.StereotypeEx.Contains(CD.GetIsBasedOnStereotype())))
                {
                    if (con.ClientID == packel.ElementID)
                    {
                        foreach (long paid in dicpackbyid.Keys)
                        {
                            if (dicpackbyid[paid].Element != null)
                            {
                                if (dicpackbyid[paid].Element.ElementID == con.SupplierID)
                                {
                                    if (!resultlist.Contains(paid)) resultlist.Add(paid);
                                    getPackagesOrigineIBO(paid, dicpackbyid, resultlist);
                                    break;
                                }
                            }
                        }

                    }
                }
            }
        }
        /// <summary>
        /// donne la liste de tous les packages id le long d'un chemin d'heritance
        /// </summary>
        /// <param name="packid"></param>
        /// <param name="dicpackbyid"></param>
        /// <param name="resultlist"></param>
        public static void getInheritanceEltById(EA.Repository repo, EA.Element el, Dictionary<long, EA.Element> resultlist)// elid/el
        {
            foreach (EA.Connector con in el.Connectors)
            {
                if (con.Type == "Generalization")
                {
                    if (con.ClientID == el.ElementID)
                    {
                        if (!resultlist.ContainsKey(con.SupplierID))
                        {
                            resultlist.Add(con.SupplierID, repo.GetElementByID((int)con.SupplierID));
                            getInheritanceEltById(repo, resultlist[con.SupplierID], resultlist);
                        }

                    }

                }
            }
        }
        /// <summary>
        /// recupere la classe et l'attribut (ou role) du sawsdl
        /// met "" "" si la chaine ne contient pas au plus un # ou .
        /// </summary>
        /// <param name="ss"></param>
        /// <returns></returns>
        public static string[] GetCleanSwsdl(string ss)
        {
            string[] retour = { "", "" };
            if (ss.Contains("#"))
            {
                retour = ss.Split(new char[] { '#' });
            }
            else
            {
                retour[0] = retour[1] = "";
            }
            if ((retour.Length == 2) && retour[1].Contains("."))
            {
                retour = retour[1].Split('.');
            }
            else
            {
                retour[0] = retour[1];
                retour[1] = "";
            }
            return retour;
        }
        /// <summary>
        /// substitue les chaines clefs  du dictionnaire entities
        /// dans la chaine d'appel par leur valeur.
        /// </summary>
        /// <param name="s"></param>
        /// <param name="entites"></param>
        /// <returns></returns>
        public static string filterNotes(string s, Dictionary<string, string> entities)
        {
            string res = s;
            foreach (KeyValuePair<string, string> kvp in entities)
            {
                res = res.Replace(kvp.Key, kvp.Value);
            }
            return res;

        }
        
        //-------------------------------------------
        public static bool barreupdate(DialGenerXSD Barre,string prem, int max)
        {
            bool ret=true;
            string myprem=prem;
            if (Barre == null) return true;
          
            switch(myprem)
            { 
                case "start":         
            //    Barre = new DialGenerXSD("generation continue ...");
                Barre.setmax(max);
                
               // Barre.ShowDialog();
               // Barre.Show();
                break;
            
                case "continue":
               
                    Barre.resetmax(max);
                
                break;
                
                case "progress":
                if (!Barre.go)
                {
                    ret = false;
                    return ret;
                }
                    Barre.progress();
                
                break;
                
                case "end":
              
                    Barre.Close();
                
                break;

                default:
                break;
        }
            return ret;
        }
        public static bool barreupdate(DialGenerXSD Barre, string prem)
        {
            bool res = true;
            if (Barre == null) return false;
            switch (prem)
            {
               
                case "progress":
                  
                    res = Barre.go;
                    if (!res) return false;
                    Barre.BringToFront();
                    Barre.progress();
                    break;

                case "end":

                    Barre.Close();

                    break;
                case "show":
                    Barre.Show();
                    break;
                case "front":
                    Barre.BringToFront();
                    break;
                default:
                    break;
            }
            return res;
        }
        static public string getParentGuid(EA.Element elt)
        {

            string IBOguid = "";
            foreach (EA.TaggedValue tgv in elt.TaggedValues)
            {
                if (tgv.Name == CD.GetIBOTagValue())
                {
                    IBOguid = tgv.Value;
                    break;
                }
            }
            return IBOguid;
        }


        //---------------- ajout am oct 2012 --------------------
        public static int CompareEltConnectorsbyRoleName(EA.Connector conx, EA.Connector cony)
        {
            EA.Element el = null;
            EA.ConnectorEnd endx = null;
            EA.ConnectorEnd endy = null;

            if (conx == null)
            {
                if (cony == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                // If x is null and y is not null,
                // if(endy is null equal
                // if(endy is not null )
                // y  is greater. 
                {

                    // endy = (EA.ConnectorEnd)getOtherend(el, cony)[0];
                    //if (endy == null) return 0;
                    return -1;
                }
            }
            else

            // If y is null and x is not null,
            // if(endx is null equal
            // if(endx is not null )
            // x  is greater. 
            {
                if (cony == null)
                {
                    // endx = (EA.ConnectorEnd)(getOtherend(el, conx))[0];
                    // if (endx == null) return 0;
                    return 1;
                }
            }

            long Sconx = conx.SupplierID;
            long Cconx = conx.ClientID;
            long Scony = cony.SupplierID;
            long Ccony = cony.ClientID;
            if ((Sconx == Scony) || (Sconx == Ccony) || (Cconx == Scony) || (Cconx == Ccony))
            {

                if (((Sconx == Scony) || (Sconx == Ccony)))
                {
                    el = Main.Repo.GetElementByID((int)Sconx);
                }
                else
                {
                    el = Main.Repo.GetElementByID((int)Cconx);
                }

                try
                {
                    endx = (EA.ConnectorEnd)(getOtherend(el, conx))[0];
                    endy = (EA.ConnectorEnd)(getOtherend(el, cony))[0];
                }
                catch (Exception ex)
                {
                    logger.Log("ex: " + ex.Message + ": " + ex.StackTrace);
                }

                if (endx == null)
                {
                    if (endy == null)
                    {
                        // If x is null and y is null, they're
                        // equal. 
                        return 0;
                    }
                    else
                    {
                        // If x is null and y is not null, y
                        // is greater. 
                        return -1;
                    }
                }
                else
                {
                    // If x is not null...
                    //
                    if (endy == null)
                    // ...and y is null, x is greater.
                    {
                        return 1;
                    }
                    else
                    {
                        // sort them with ordinary string comparison.
                        int compRes = (endx.Role).CompareTo(endy.Role);
                        return compRes;

                    }
                }
            }
            else
            {
                return 0; // il n'y a pas d'element commun entre les connecteurs
            }
        }
        //-----------------------------
        public static int CompareEltConnectorsbyOrder(EA.Connector conx, EA.Connector cony)
        {
            //EA.Element el = null;
            int rgx = RDFutilitaires.getAtRang(conx);
            int rgy = RDFutilitaires.getAtRang(cony);

            if (conx == null)
            {
                if (cony == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                // If x is null and y is not null,
                // if(endy is null equal
                // if(endy is not null )
                // y  is greater. 
                {

                    // endy = (EA.ConnectorEnd)getOtherend(el, cony)[0];
                    //if (endy == null) return 0;
                    return -1;
                }
            }
            else

            // If y is null and x is not null,
            // if(endx is null equal
            // if(endx is not null )
            // x  is greater. 
            {
                if (cony == null)
                {
                    // endx = (EA.ConnectorEnd)(getOtherend(el, conx))[0];
                    // if (endx == null) return 0;
                    return 1;
                }
            }


            if (rgx == 0) //(rgx == null) ABA20230905 int is never null!
            {
                if (rgy == 0) //(rgy == null) ABA20230905 int is never null!
                {
                    // If rgx is null and rgy is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If rgx is null and rgy is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (rgy == 0)  // (rgy == null) ABA20230905 int is never null
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {
                    // sort them with ordinary string comparison.
                    //
                    //int prov = (rgx).CompareTo(rgy); ABA20230905 never used!
                    return (rgx).CompareTo(rgy);

                }
            }
        }

        //-----------------------------
        public static bool isESMPGPresent(EA.Element el)
        {
            //  if ((this.ESMPGPresent != null)&&( this.ESMPGPresent)) return this.ESMPGPresent;

            if (el.Attributes.Count > 0)
            {
                foreach (EA.AttributeTag atag in ((EA.Attribute)el.Attributes.GetAt(0)).TaggedValues)
                {
                    if (atag.Name == CD.GetRangTagValue())
                    {
                        return true;
                    }
                }
            }
            else
            {
                if (el.Connectors.Count > 0)
                {
                    foreach (EA.ConnectorTag ctag in ((EA.Connector)el.Connectors.GetAt(0)).TaggedValues)
                    {
                        if (ctag.Name == CD.GetRangTagValue())
                        {
                            return true;
                        }
                    }
                }
            }

            return false;
        }
        //-----------------------------------------------
        /// <summary>
        /// examine la derniere lettre
        ///  - /              enleve / et ajoute #
        ///  - #              rien
        ///  - letre non #    ajoute #
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static string addAmpelsand(string path)
        {
            string resul = path;
            int longueur = resul.Length;
            if (resul.EndsWith("/"))
            {
                resul = resul.TrimEnd('/');
                resul = resul + "#";
            }
            else
            {
                if (!resul.EndsWith("#"))
                {
                    resul = resul + "#";
                }
            }
            return resul;
        }

        //-----------------------------------------   
        //-----------------------------------
        /// <summary>
        /// recupere l'attribut sur lequel un attribut est base
        /// </summary>
        /// <param name="">guidatr</param>
        /// <param name="repo"></param>
        /// <returns></returns>
        public static string getAttrBasedOnAttribute(string guidatr, EA.Repository repo)
        {
            string guid = "";
            string retour = null;
            string texte = "";

            EA.Attribute atr = repo.GetAttributeByGuid(guidatr);
            if (atr == null)
            {
                texte = " ERROR in search of the origin of an attribute the attribute of guid=";
                texte = texte + guidatr + "does not correspond to any of attribute in EA repository";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return "";
            }
            if (amtest) // am oct 2013
            {
                texte = "\t\t getAttrBasedOnAttribute  guidatr=" + guidatr;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                if (atr != null)
                {
                    texte = "\t\t\t objet detype=" + atr.ObjectType.ToString() + "of name=" + atr.Name;
                    EA.Element elt = repo.GetElementByID((int)atr.ParentID);
                    EA.Package pa = null;
                    if (elt != null) pa = repo.GetPackageByID((int)elt.PackageID);
                    if (((elt != null) && (pa != null)))
                    {
                        texte = texte + " held in " + pa.Name + "::" + elt.Name;
                    }
                    else
                    {
                        texte = texte + "held in null";
                    }
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }

            }
            foreach (EA.AttributeTag atagv in atr.TaggedValues)
            {
                if (atagv.Name == CD.GetIBOTagValue())
                {
                    guid = atagv.Value;
                    break;
                }

            }
            if (guid != "")
            {
                retour = guid;
            }
            else
            {
                retour = guidatr; // soit meme si non base sur une autre classe
            }
            return retour;
        }


        //-----------------------------------
        public static string getAttrOriginBasedOnAttribute(string guidatr, EA.Repository repo)
        {

            // string prov = atr.Name;
            //string ss = "";
            string tobereturn = guidatr;
            string inter = guidatr;
            while (tobereturn != (inter = getAttrBasedOnAttribute(inter, repo)))
            {
                if (inter == "") return "";  // am 28/10/2013
                tobereturn = inter;
            }
            return tobereturn;
        }

        public bool isConcreteClass(EA.Element el)
        {
            bool rs = true;
            foreach (string stereo in ConstantDefinition.CimDatatypeStereos)
            {
                if (el.StereotypeEx.Contains(stereo))
                {
                    rs = false;
                    break;
                }
            }
            return rs;
        }


        /// <summary>
        /// cas tres particulier a wg19byref ou une classe abstraite qui 
        /// au moins une association orient et pas de descendants
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        public bool Wg19byrefEligibleClass(EA.Element el)
        {
            bool ret = false;
           
            if(el.Name=="EnergySource")
            {
                string prov = el.Name;
            }
            List<EA.Connector> assocs = new List<EA.Connector>();
            foreach (EA.Connector con in el.Connectors)
            {
                if (con.Type == "Generalization")
                {
                    if (con.SupplierID == el.ElementID)
                    {
                        return ret; // il y a un descendant
                    }
                }
                else
                {
                    if (con.Type == "Association")
                    {
                        if (!assocs.Contains(con)) assocs.Add(con);
                    }
                }
            }
                foreach (EA.Connector assoc in assocs)
                {
                    if (assoc.ClientID == el.ElementID)
                    {
                        // the other end is target
                        if (assoc.SupplierEnd.Navigable == "Navigable")
                        {
                            return true; // cette association est eleigible
                        }

                    }
                    else
                    {
                        //the other end is source
                        if (assoc.ClientEnd.Navigable == "Navigable")
                        {
                            return true; // cette association est eleigible
                        }

                    }
                }
            
            return ret;
        }
   
        //------------------------------ 
        public static string modifrefs(string ss, string chaine)
        // on suppose que la string contient des strings de type 
        //<a href="{??')"><font color="#0000ff"><u>https://a</u></font></a>
        // ou <a href="{??')"><font color="#0000ff"><u>https://a</u></font></a>
        {
            string res = ss;
            string substr = "";
            List<int> startrefs = new List<int>();
            List<int> endrefs = new List<int>();
            ArrayList refs = new ArrayList();
            ArrayList newrefs = new ArrayList();

            int ind = 0;
            while (ind >= 0)
            {
                ind = ss.IndexOf(chaine, ind);
                if (ind >= 0)
                {
                    startrefs.Add(ind);
                    ind++;
                }

            }
            foreach (int i in startrefs)
            {
                int fin = ss.IndexOf("</a>", i);
                int startu;
                int endu;
                substr = ss.Substring(i, fin + 4 - i);
                //string[] splitu;
                startu = substr.IndexOf("<u>");
                string substrref = "";
                if (startu >= 0)
                {
                    endu = substr.IndexOf("</u>");
                    substrref = substr.Substring(startu + 3, endu - startu - 3);

                }

                string tt = "";

                tt = "<a href=\"" + substrref + "\"><font color=\"#0000ff\">";
                refs.Add(substr.Substring(0, startu));
                newrefs.Add(tt);

            }
            for (int j = 0; j < refs.Count; j++)
            {
                string avant = (string)refs[j];
                string apres = (string)newrefs[j];
                string g = res.Replace(avant, apres);
                res = g;
            }
            return res;
        }
        /// <summary>
        /// dans la nouvelle version de EA une contrainte est lie par une NoteLink  la contrainte
        /// on recupere donc le type lie a la contrainte:
        /// soit  "Class" dans le cas d'une note
        /// soit "Constraint" dans le cas d'une contrainte
        /// </summary>
        /// <param name="repo"></param>  // repository
        /// <param name="con"></param>  // connector
        /// <param name="elt"></param>   // element a qui est attache la contrainte
        /// <returns>type de contrainte</returns>

        //-------------------------------
        static public EA.Element GetElementById(long id)
        {
            EA.Element ret = null;
            try
            {
                ret = Main.Repo.GetElementByID((int)id);
            }
                 catch(Exception e)
            {
                string ee = e.Message;
               // MessageBox.Show("Exception " + e.Message);
            }
           /*
            catch(COMException c ) 
            {
                string cc = c.ToString();
                string error = Main.Repo.GetLastError();
                MessageBox.Show("COMException " + c.Message);
                ret=null;
            }
            * */
            return ret;
        }

        //----------------------------------------------- 
        /// <summary>
        /// construction du dico de containtes XOR   pour les elements d'un profil
        /// </summary>
        /// <param name="elist"></param>
        public static void buildConstraintDisc(List<EA.Element> elist)
        {

            dicconstbycon = new Dictionary<long, List<long>>();


                foreach (EA.Element e in elist)
                { 
                    // ABA20230809 CHECK e.Notes should be e.Name
                    if ((e.Type == "Constraint") && (e.Notes == "XOR"))  // we treat only the XOR constraints
                    {
                        char[] separateurs = { '=', ';' };
                        string[] split = (e.get_MiscData(3)).Split(separateurs);
                        List<string> lscons = new List<string>();
                        List<long> lcons = new List<long>();
                        for (short i = 0; i < split.Length; i++)
                        {
                            if ((split[i] != "") && (isnumeric(split[i])))
                            { lcons.Add((long)Convert.ToUInt64(split[i])); }
                        }
                        foreach (long conid in lcons)
                        {
                            if (!dicconstbycon.ContainsKey(conid))
                            {
                                dicconstbycon.Add(conid, new List<long>());
                                dicconstbycon[conid].Add(e.ElementID);
                                // 
                            }
                            else
                            {
                                dicconstbycon[conid].Add(e.ElementID);
                            }
                        }

                    }



                }
            
        }

    }
}