using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using EA;
using System.Xml;
using System.Xml.Schema;
using System.Xml.XPath;
using System.Windows.Forms;
using CimSyntaxGen.Option;
using System.Diagnostics;
using System.Threading;

/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.11                                     *    december 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/

namespace CimSyntaxGen
{

    public class CIMSchemaGenerator
    {
        
        private static string Wg;// le type d'appel
        private const bool hierarchie = true;
         public static EA.Package ThePackage=null;
        public static XmlSchema schema; // main generated schema
        public static ConstantDefinition CD = new ConstantDefinition();
        private const string NS_XSD = "http://www.w3.org/2001/XMLSchema";
        public const string NS_SAWSDL = "http://www.w3.org/ns/sawsdl";
        public const string NS_CIMP = "http://www.iec.ch/cimprofile";
        static XMLParser XMLP;// am juin 2011
         public static XMLProfileParameters profparameters = new XMLProfileParameters();// operator's data
        private static string schemaversion = "1";
        private string res = "";
        public static string nomfic = FileManager.GetUserDirPath() + "\\XSDexample.xsd";
        //static TextWriter ficlog = new StreamWriter("ficlog.txt");
        //static public TextWriter   reportlog; // to report details of generation
        //static public StreamWriter reportlog; // to report details of generation
        static public string stringtowrite;
        static public List<long> ElemRootList;  // list of rootclass (WG19NDR)
        static public XmlSchemaUse usage = new XmlSchemaUse();

        static public TextWriter fluxdata;
        static RDFutilitaires rdfutilitaires;
        static List<long> datatypetraite; // to avoid duplication of datatype, enumeration and compound elements
        static Dictionary<string, List<long>> dicsamerolesbyname; // give for each element the roles which are identical
      public  static EA.Repository Repos;
       public static Dictionary<string, string> mapforprimitivetypes;  // these roles usualy come from associations to subclasses inherited
        static List<string> LocalDatatypeNames;
        static List<long> LocalDatatypeIDs;
        static List<string> LocalClassNames;
        static Dictionary<string, EA.Element> LocalClassesbyName = new Dictionary<string, Element>();
        static Dictionary<long, EA.Element> dicInline; // classes inline id,element
        static Dictionary<long, Connexion> ConexesWithUnion;  // list of connexions in a union

        //public static Ta td = new Ta(); //am 2021 pour analyse du temps
        public static long ConexesID;

        public struct Connexion
        {
            public long ConexID;
            public long ConnectorID;
            public EA.Element Source_element;
            public EA.Element Target_element;
            public EA.ConnectorEnd Source;
            public int SourceAggregation;
            public EA.ConnectorEnd Target;
            public int TargetAggregation;  // 

            public Connexion(EA.Connector con)
            {

                ConstDefinition constantes = new ConstDefinition(); // constants
                ConexesID++;
                ConexID = ConexesID;
                ConnectorID = con.ConnectorID;
                /*****pour test******
                EA.Element client = Repos.GetElementByID((int)con.ClientID);
                EA.Element supplier = Repos.GetElementByID((int)con.SupplierID);
                string prov = client.Name;
                string prov1 = supplier.Name;
                ********************************/
               //18  Source_element = RDFutilitaires.dicelembyid[con.ClientID];
                //18 Target_element = RDFutilitaires.dicelembyid[con.SupplierID];
                Source_element = Main.Repo.GetElementByID((int)con.ClientID);
                Target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                Source = con.ClientEnd;
                SourceAggregation = (con.ClientEnd).Aggregation;
                Target = con.SupplierEnd;
                TargetAggregation = (con.SupplierEnd).Aggregation;
            }
            public Connexion(Connexion conex)
            {
                ConexesID++;
                ConexID = ConexesID;
                ConnectorID = conex.ConnectorID;
                Source_element = conex.Source_element;
                Target_element = conex.Target_element;
                Source = conex.Source;
                SourceAggregation = conex.SourceAggregation;
                Target = conex.Target;
                TargetAggregation = conex.TargetAggregation;
            }
        }
        public static List<long> inheritedconids; // list of father  connectors inherited for each concrete class byid
        public static Dictionary<long, List<Connexion>> inheritedconex; // list of inherited conex  for each concrete class byid
        public static List<long> motherconids; // list of inherited mother conid   for each concrete class byid

        public static List<long> CreatedEnumerations;

        /// <summary>
        /// for memmo of an EA object
        /// </summary>
        public class ModelObject
        {
            public EA.Element el = null;
            public EA.Connector con = null;
            public EA.Attribute attribute = null; // pointeur vers un attribut si objet  
            public Connexion conex;
            public string type = "";  //
            public string keyname = "";
            public ModelObject(EA.Element el, EA.Attribute atr)
            {
                this.el = el;
                type = "attribute";
                attribute = atr;
                if (atr != null)
                {
                    keyname = atr.Name;

                }
            }
            public ModelObject(EA.Element element, EA.Connector connector)
            {
                el = element;
                string prov = el.Name;
                conex = new Connexion(connector);
                type = "connexion";
                keyname = GetConnexionName(this);
            }
            public ModelObject(EA.Element element, Connexion conex)
            {
                el = element;
                this.conex = conex;
                type = "connexion";
                keyname = GetConnexionName(this);
            }

        }

        /// <summary>
        /// for json generation according of the target wg
        /// wg19,wg14,wg16
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="aPackage"></param>
        /// <param name="wg"></param>
        //public static void PackageGenerateJson(EA.Repository repo, EA.Package aPackage, string wg)
        //{
        //    try
        //    { 
        //    Wg = wg;
        //    Repos = repo;
        //    ThePackage = aPackage;
        //    RDFutilitaires.amtest = false; //am oct 2013
        //    repo.SaveAllDiagrams();
        //    Dictionary<long, XmlSchemaElement> dicrootcardinality = new Dictionary<long, XmlSchemaElement>();
        //    ConstDefinition constantes = new ConstDefinition(); // constants
        //    //  CreatedEnumerations = new List<long>(); // lists of already created enumerations
        //    datatypetraite = new List<long>(); // lists of already created datatypes,compounds or enumerations
        //    XMLP = new XMLParser(repo); //am juin 2011
        //    XMLProfileParameters profparameters = new XMLProfileParameters();
        //    string uripath = XMLP.GetXmlValueProfData("URICodelist");
        //    string unixpath = uripath.Replace('\\', '/');


            

        //        //18 string nomfichier = Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen);
        //        string nomfichier = CD.ReportGen;//am aout 18
        //        //18 if(System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
        //        //18 if (RDFutilitaires.reportlog != null) RDFutilitaires.reportlog.Close();
        //        //18 if (reportlog != null) reportlog.Close();
        //        //18 reportlog = new StreamWriter(nomfichier,true); //  the report file
        //        //reportlog = Main.reportlog;
        //        //RDFutilitaires.reportlog = Main.reportlog;
        //        //RDFLAutilitaires.reportlog = Main.reportlog;
        //        //18 reportlog.AutoFlush = true;
        //        // MessageBox.Show(" reportlog= " + nomfichier);
        //        //RDFLAutilitaires.wtest("TEST", " " + "PackageGenerateJson  reportlog=" + nomfichier);

        //        if (System.IO.File.Exists(nomfic))  // am 
        //        {
        //            System.IO.File.Delete(nomfic);
        //        }

        //        if (RDFutilitaires.ongoing == false) return;
            


        //    if (wg == "wg19")
        //    {
        //        if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
        //        {
        //            Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19");
        //            aDialxsd.ShowDialog();
        //        }
        //    }
            
        //    if (wg == "wg14")
        //    {
        //        if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
        //        {
        //            Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19");
        //            aDialxsd.ShowDialog();
        //            aDialxsd.Dispose(); // ABA20230728
        //        }
        //    }

        //    if (wg == "wg16")
        //    {
        //        if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
        //        {
        //            Dialxsd bDialxsd = new Dialxsd(profparameters, "wg16");
        //            bDialxsd.ShowDialog();
        //        }
        //    }
        //    if (RDFutilitaires.ongoing == false) return;
        //    //// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating XSD profile : ");
        //    // reportlog.Write(stringtowrite);
        //    //// if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t{0}", profparameters.TargetNamespace);
        //    //// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
        //    //// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");

        //    }
        //    catch (XmlSchemaException e)
        //    {
        //        //// if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);
        //        //// if(Main.DO_REPORTLOG) reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
        //        //// if(Main.DO_REPORTLOG) reportlog.WriteLine("LinePosition = {0}", e.LinePosition);              
        //    }
        //    if (RDFutilitaires.Barre != null) RDFutilitaires.Barre.Close();
        //}


        /// <summary>
        /// for xsg generation according of the target wg
        /// wg19,wg14
        /// </summary>
        /// <param name="repo"></param>
        /// <param name="aPackage"></param>
        /// <param name="wg"></param>
        public static void  PackageGenerateXSD(EA.Repository repo, EA.Package aPackage, string wg)
        {

            Wg = wg;
            //td.start("generateXSD");
            //td.elapsetime("generateXSD");
            Repos = repo;
            ThePackage=aPackage;
            RDFutilitaires.amtest = false; //am oct 2013
            repo.SaveAllDiagrams();
            Dictionary<long, XmlSchemaElement> dicrootcardinality = new Dictionary<long, XmlSchemaElement>();
            ConstDefinition constantes = new ConstDefinition(); // constants
            //  CreatedEnumerations = new List<long>(); // lists of already created enumerations
            datatypetraite = new List<long>(); // lists of already created datatypes,compounds or enumerations
            XMLP = new XMLParser(repo); //am juin 2011
            XMLProfileParameters profparameters = new XMLProfileParameters();
            string uripath = XMLP.GetXmlValueProfData("URICodelist");
            string unixpath = uripath.Replace('\\', '/');


            try
            {

                //18 string nomfichier = Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\" + Path.GetFileName(constantes.ReportGen);
                string nomfichier = CD.ReportGen;//am aout 18
                //18 if(System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                //18 if (RDFutilitaires.reportlog != null) RDFutilitaires.reportlog.Close();
                //18 if (reportlog != null) reportlog.Close();
                //18 reportlog = new StreamWriter(nomfichier,true); //  the report file
                //reportlog = Main.reportlog;
                //RDFutilitaires.reportlog = Main.reportlog;
                //RDFLAutilitaires.reportlog = Main.reportlog;
                //18 reportlog.AutoFlush = true;
               // MessageBox.Show(" reportlog= " + nomfichier);
                //RDFLAutilitaires.wtest("TEST", " " + "PackageGenerateXSD  reportlog=" + nomfichier);
               
                if(System.IO.File.Exists(nomfic))  // am 
                {
                    System.IO.File.Delete(nomfic);
                }
          
                if (RDFutilitaires.ongoing == false) return;
            }
            catch (Exception e)
            {
                MessageBox.Show(" Error when opening file CimSyntaxGenReport.txt " + e.Message + "source=" +e.Source);
                return;
            }


            if (wg == "wg19")
            {
                if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                {
                    Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19");
                    aDialxsd.ShowDialog();
                    aDialxsd.Dispose(); // ABA20230730
                }
            }
            if (wg == "wg19byref")
            {
                if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                {
                    Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19byref");
                    aDialxsd.ShowDialog();
                    aDialxsd.Dispose(); // ABA20230730
                }
            }
            if (wg == "wg14")
            {
                 if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                {
                    Dialxsd aDialxsd = new Dialxsd(profparameters, "wg19");
                    aDialxsd.ShowDialog();
                    aDialxsd.Dispose(); // ABA20230730
                }


            }

            if (wg == "wg16")
            {
                 if (XMLP.GetXmlValueConfig("ModeBatch") != "Checked")  // am june 2013
                {
                    Dialxsd bDialxsd = new Dialxsd(profparameters, "wg16");
                    bDialxsd.ShowDialog();
                    bDialxsd.Dispose(); // ABA20230729
                 }
            }


            // ArrayList elements = new ArrayList();

            if (RDFutilitaires.ongoing == false) return;


            //// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating XSD profile : ");
            // reportlog.Write(stringtowrite);
            //// if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t{0}", profparameters.TargetNamespace);
            //// if(Main.DO_REPORTLOG) reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
            //// if(Main.DO_REPORTLOG) reportlog.WriteLine("--------------------------------------------------------------------------------\n");

            schema = new XmlSchema { };
            schema.Namespaces.Add(profparameters.Prefix, profparameters.TargetNamespace);// pointe sur ce schema
            schema.Namespaces.Add("cimp", NS_CIMP);
            schema.Namespaces.Add("xs", "http://www.w3.org/2001/XMLSchema");
            schema.Namespaces.Add("sawsdl", NS_SAWSDL);
            schema.TargetNamespace = profparameters.TargetNamespace;
            schema.AttributeFormDefault = XmlSchemaForm.Unqualified;
            schema.ElementFormDefault = XmlSchemaForm.Qualified;


            if (wg == "wg16")
            {
                /********** import ****************/
                if (profparameters.import == true)
                {// on importe les codelist
                    string newuripath = XMLP.GetXmlValueProfData("URICodelist");
                    string newunixpath = newuripath.Replace('\\', '/');
                    schema.Namespaces.Add(XMLP.GetXmlValueProfData("PrefixCodelist"), newunixpath);
                    XmlSchemaImport import = new XmlSchemaImport();
                    import.Namespace = newunixpath; ;
                    import.SchemaLocation = XMLP.GetXmlValueProfData("URISchemaLocation");// "wgedi-codelists.xsd";// XMLP.GetXmlValueProfData("URISchemaLocation");//PROVISOIRE beurk mars 2012
                    schema.Includes.Add(import);
                    RDFLAutilitaires.wtest("TEST", " GenerSchema import " + import.SchemaLocation.ToString());

                }
                else
                {// on include les codelists
                    XmlSchemaInclude include = new XmlSchemaInclude();
                   // include.Namespaces = unixpath;
                    include.SchemaLocation = XMLP.GetXmlValueProfData("URISchemaLocation"); //XMLP.GetXmlValueProfData("URICodelist") +
                    schema.Includes.Add(include);
                    RDFLAutilitaires.wtest("TEST", " GenerSchema include" + include.SchemaLocation.ToString());
                }
               
            }


            // -------begining of the iterative traitment
            rdfutilitaires = new RDFutilitaires();
            List<EA.Element> ElemList = new List<EA.Element>();
            // we initialize the necessary dictionaries
            EA.Collection modellist;
            modellist = repo.Models;
            EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, repo);
            //Ta ta = new Ta("CimSyntaxGengeneratorXSD");
            try
            {
               
                //18 RDFutilitaires.dicelembyid=new Dictionary<long,Element>();
                //RDFutilitaires.dicrepobyid = new Dictionary<long, Package>();
               // RDFutilitaires.dicpackbyid = new Dictionary<long, Package>();
                RDFutilitaires.dicelembyname = new Dictionary<string, Element>();
                //18 RDFutilitaires.dicelembyid = new Dictionary<long, Element>();

                //18 RDFutilitaires.buildDicsElem(toppack);
                //ta.diffelaps(" apres construction des dictionnaires generaux");
                // RDFutilitaires.getStereotypedElements(aPackage, ElemList, Cimstereos);
                 RDFutilitaires.getTypedElements(aPackage, ElemList, "Class");
                //18 RDFutilitaires.buildDicsrepo(repo);
                RDFutilitaires.buildDicstereo(repo);
                //RDFutilitaires.buildDiscsDatatype(toppack);
                mapforprimitivetypes = new Dictionary<string, string>();
                BuildMapforprimitivetypes(mapforprimitivetypes);
                //ta.diffelaps(" apres construction des dictionnaires et listes");

            }
            catch (Exception) 
            {  
                string texte = " Problem in building dictionaries";
                //// if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                MessageBox.Show(texte);
            }

            LocalDatatypeNames = new List<string>();
            LocalDatatypeIDs = new List<long>();
            buildLocalDatatypeNames(aPackage, LocalDatatypeNames, LocalDatatypeIDs);
            LocalClassNames = new List<string>();
            buildLocalClassNames(aPackage, LocalClassNames);
            dicInline = new Dictionary<long, EA.Element>();

            ConexesID = 0; // resen of conexes IDs
            inheritedconex = new Dictionary<long, List<Connexion>>(); // to find for each class the possible inherited Connexion
            inheritedconids = new List<long>(); // to find all the inherited connexion
            motherconids = new List<long>(); // to know which connection are already be inherited
            BuidInheritedConnexion(inheritedconids, inheritedconex, motherconids, ElemList);
            //dicconexDump(inheritedconex);

            //------------------------------------------
            //---  test if the profile has been donewith help of CimSyntaxGen and there no class of the same name

            List<EA.Element> ProfileClasses = new List<EA.Element>();
            List<EA.Element> ProfileConstraints = new List<EA.Element>();
            RDFutilitaires.getAllElements(aPackage, ProfileClasses, "Class");
            RDFutilitaires.getAllTypedElements(aPackage, ProfileConstraints, "Constraint");
            RDFutilitaires.buildConstraintDisc(ProfileConstraints);
            
            List<string> NoDoublons = new List<string>();
            foreach (EA.Element elt in ProfileClasses)
            {
                string nom = elt.Name;
                if (nom.Length != 0)
                { // no treatment it's probably a note
                    if (!NoDoublons.Contains(elt.Name))
                    {
                        NoDoublons.Add(elt.Name);
                    }
                    else
                    {
                        //// if(Main.DO_REPORTLOG) reportlog.WriteLine(" ERROR there are at least two classes of the same name " + elt.Name + " in the profile");
                        MessageBox.Show(" ERROR there are at least two classes of the same name " + elt.Name + " in the profile so the process will be interrupted");

                        return;
                    }
                    if(!LocalClassesbyName.ContainsKey(elt.Name))   LocalClassesbyName.Add(elt.Name, elt); // sert a wg16 dans la remmise en ordre des elements

                    EA.Element belt = RDFutilitaires.getElementBasedonElement(elt);
                    if (belt.ElementID == elt.ElementID)
                    { //element not based on another class
                        string name = "";
                        name = elt.Name;
                        DialogResult r = MessageBox.Show("Error the Class " + name + " is not based on another Class the Profile is not correct", "Error", MessageBoxButtons.OKCancel);
                        if (r == DialogResult.Cancel) return;
                        // return;
                    }
                }
            }


            //---------------------------------------

            //  treatment of every "root classes"

            // RDFutilitaires.GetClassesWithoutAscendant(aPackage, ElemRootList);
            if ((wg == "wg19") || (wg == "wg14") || (wg == "wg16") || (wg == "wg19byref"))
            {
                ElemRootList = new List<long>();
                if (Wg == "wg19byref")
                {
                    foreach(EA.Element elt in ElemList)
                        if (
                            ((elt.Abstract != "1") && rdfutilitaires.isConcreteClass(elt))
                            || ((elt.Abstract == "1") && rdfutilitaires.Wg19byrefEligibleClass(elt))
                                )
                        {
                            elt.IsActive =true;
                        }
                       
                }
                foreach (EA.Element elt in ElemList)
                {
                    if (elt.IsActive)
                    {
                        if (!ElemRootList.Contains(elt.ElementID))
                        {
                            ElemRootList.Add(elt.ElementID);
                        }
                    }

                }
            }
            if (ElemRootList.Count == 0)
            {
                MessageBox.Show("Error!   There must be at least one RootClass in the model");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  the program is interupted because there should be at least on RootClass in the profile");
                return;


            }
            ElemRootList.Sort(RDFutilitaires.CompareElementIDsbyName);
            try
            {

                // creation of the top element
                XmlSchemaElement elementItem = new XmlSchemaElement();
                if (wg != "wg16")
                {
                    elementItem.Name = profparameters.EnvelopName;

                    elementItem.SchemaTypeName = new XmlQualifiedName(profparameters.EnvelopName, profparameters.TargetNamespace);
                    schema.Items.Add(elementItem);
                    XmlSchemaComplexType ct = new XmlSchemaComplexType();
                    schema.Items.Add(ct);
                    ct.Name = profparameters.EnvelopName;
                    XmlSchemaSequence sequence = new XmlSchemaSequence();
                    ct.Particle = sequence;
                    //EA.Element clroot;

                    foreach (long clrootid in ElemRootList)
                    {
                       //18  EA.Element clroot = RDFutilitaires.dicelembyid[clrootid];
                        EA.Element clroot = Main.Repo.GetElementByID((int)clrootid);
                        if (RDFutilitaires.ElementBelongsToProfile(clroot, aPackage, toppack))
                        {

                            XmlSchemaElement nel = new XmlSchemaElement();

                            string atrtype = clroot.Name;
                            nel.Name = clroot.Name;
                            if ((XMLP.GetXmlValueConfig("ModeBatch") != "Checked") ) //&& (wg=="wg19") )  // am june 2013
                            {
                                if ((wg == "wg14") || (wg == "wg16")|| (wg == "wg19"))//am janv 2018
                            {      
                                    Dialroot aDialroot = new Dialroot(nel);
                                    aDialroot.ShowDialog();
                                }
                            if ((wg == "wg19byref")
                                //|| (wg == "wg19"))//am janv 2018
                                )
                            {

                           nel.MinOccursString = "0";
                           nel.MaxOccursString="unbounded";
                            }
                            }
                        
                            /**********************
                            if (wg == "wg14")
                            {
                                nel = dicrootcardinality[clroot.ElementID];
                            }
                             * *************************/

                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            sequence.Items.Add(nel);


                        }
                    }
                }
                else
                {
                    if (ElemRootList.Count != 1)
                    {
                        MessageBox.Show("Error a XW16 ESMP profile must have a single root class");
                        return;
                    }
                    long clrootid = ElemRootList[0];
                    //18 EA.Element clroot = RDFutilitaires.dicelembyid[clrootid];
                    EA.Element clroot = Main.Repo.GetElementByID((int)clrootid);
                    elementItem.SchemaTypeName = new XmlQualifiedName(clroot.Name, profparameters.TargetNamespace);
                    elementItem.Name = clroot.Name;
                    schema.Items.Add(elementItem);

                }
            }
            catch (Exception e)
            {

                DialogResult r = MessageBox.Show("the following error has occured: " + e.Message, "Error", MessageBoxButtons.OKCancel);

                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  {0}", e.Message);
                if (r == DialogResult.Cancel) return;

            }

            /******************preparation exemple  inclusion du copyright en cas de codecomponent *************
            if(XMLP.GetXmlValueConfig("CodeComponent")=="Checked")
            {
                < Copyright >
            < Notice >
            COPYRIGHT(c) IEC, 2016.This version of this NSD is part of IEC 61850 - 7 - 4:2007B; see the IEC 61850 -
                7 - 4:2007B for full legal notices.In case of any differences between the here - below code and the IEC published content, the
             here - below definition supersedes the IEC publication; it may contain updates. See history files.The whole document has to be taken
              into account to have a full description of this code component.
                See www.iec.ch / CCv1 for copyright details
             </ Notice >
            < License uri = "www.iec.ch/CCv1" kind = "Standard" > IEC License </ License >
             </ Copyright >
             }
             ***************************************************************/



            


            /********************************/


            DialGenerXSD dialgenerxsd = new DialGenerXSD();

            // we explore each Package in turn (pour l'instant)
            List<long> packlist = new List<long>();
            RDFutilitaires.getAllPackID(aPackage.PackageID, packlist);


            foreach (long paid in packlist)
            {
                /*
                if (!RDFutilitaires.dicrepobyid.ContainsKey(paid))//am oct 2013
                {
                    RDFutilitaires.dicrepobyid = new Dictionary<long, Package>();
                    RDFutilitaires.buildDicsrepo(repo);
                }
                 * */
                EA.Package pa = Main.Repo.GetPackageByID((int)paid); 
              

                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t ++++  The Package {0} is beeing treated +++", pa.Name);

                List<EA.Element> elList = new List<EA.Element>();
                // elList = RDFutilitaires.getLocalStereotypedElements(pa, Cimstereos);
                elList = RDFutilitaires.getLocalTypedElements(pa, "Class");
                XmlSchemaObject sobj = null;

                //----------------- barre progression ---------------------
                // calcul du maxi de la barre

                List<EA.Element> calist = new List<EA.Element>();
                foreach (long packid in packlist)
                {      
                        EA.Package pac = Main.Repo.GetPackageByID((int)packid);
                 
                    calist.AddRange(RDFutilitaires.getLocalTypedElements(pac, "Class"));
                }
                int max = calist.Count;
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" trace dialgenerxsd " + "count=" + calist.Count);
                if (dialgenerxsd != null)
                {
                 //   dialgenerxsd.setmax(max);
                  //  dialgenerxsd.Show();
                }
           
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "continue",100); // am aout 201_
                //-------------------------------------------------------
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 2016
                //Stopwatch stopWatch = new Stopwatch();//am 2021
                //stopWatch.Start(); //am 2021
                //Ta tc = new Ta();
                //td.elapsetime("start loop on elements");
                foreach (EA.Element nel in elList)
                {
                    //on ne cree pas a priori les objets identifiers  priori mais au fur et  mesure de leur utilisation
                    RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 2016
                    if (RDFLAutilitaires.StereoExContainsStereo(nel.StereotypeEx, ConstantDefinition.CimDatatypeStereos))
                    {
                        continue; //on passe a element suivant  // am juil 2011
                    }

                    try
                    {
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t\t ... The Element {0} is beeing treated", nel.Name);
                        //   MessageBox.Show("The Element " + nel.Name + "is beeing treated"); // for test

                        sobj = TraitElem(nel, pa, schema);
                        if ((sobj != null) && !IsInline(nel))
                        {
                            schema.Items.Add(sobj);
                        }

                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(" trace dialgenerxsd " + "progress avant"+ dialgenerxsd.ToString());
                  //      dialgenerxsd.progress();
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(" trace dialgenerxsd " + "progress apres" + dialgenerxsd.ToString());
                    }
                    catch (Exception e)
                    {
                        DialogResult r = MessageBox.Show(" error TraitElem " + e.Message, "Error", MessageBoxButtons.OKCancel);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR {0}", e.Message);
                        if (r == DialogResult.Cancel) return;
                    }
                }
                //stopWatch.Stop();//am 2021
                //long tt = stopWatch.ElapsedMilliseconds;//am 2021
                //MessageBox.Show(string.Format("treatment loop total elapseTime {0} ms", tt));//am 2021
                //td.elapsetime("end of loop on elements");
                if (dialgenerxsd != null) dialgenerxsd.Close();
            }
            //---------------------------------------------------------------------------
            try
            {
                /*
                XmlSchemaSet schemaSet = new XmlSchemaSet();
                schemaSet.ValidationEventHandler += new ValidationEventHandler(ValidationCallbackOne);
                schemaSet.Add(schema);

                schemaSet.Compile();

                XmlSchema compiledSchema = null;

                foreach (XmlSchema schema1 in schemaSet.Schemas())
                {
                    compiledSchema = schema1;



                }

                */



                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xs", NS_XSD);
               
                    nsmgr.AddNamespace(profparameters.Prefix, profparameters.TargetNamespace);
               
                nsmgr.AddNamespace("cimp", NS_CIMP);



                //  compiledSchema.Write(Console.Out, nsmgr);
                // StreamWriter fluxdata = new StreamWriter(nomfic);
                //   fluxdata =
                //ABA 20240303 if (nomfic.StartsWith(".\\")) nomfic = FileManager.GetUserDirPath() + nomfic.Replace(".\\\\", "\\");
                nomfic = Path.GetDirectoryName(profparameters.CurrentXSDFilePath) + "\\XSDexample.xsd";
                TextWriter fluxd =  new StreamWriter(nomfic);
                // true, System.Text.Encoding.UTF8, 512);

                // XmlWriter fluxdata = XmlWriter.Create(nomfic);
                /*
                if (compiledSchema == null)
                {
                    MessageBox.Show("  Error , the compiled schema is empty ");
                }
                else
                {
                   // compiledSchema.Write(fluxdata);
                    compiledSchema.Write(fluxd);

                }
                 */
              //  fluxdata.Flush();
               // fluxdata.Close();
                schema.Write(fluxd);// am janv 17
                 fluxd.Flush();
                 fluxd.Close();

                Schemarecopie(profparameters);
        
                EA.Element rootclass=repo.GetElementByID((int)ElemRootList[0]);
                if ((Wg=="wg16") && RDFutilitaires.isESMPGPresent(rootclass))  // cas d'un package ordonne
                {
                    List<string> classnames = new List<string>();// nom des classes du package
                   classnames= getOrderedAssClasses(ThePackage);

                    SchemaWg16Recopie(profparameters, classnames);
                }
                
                string dirname = Path.GetDirectoryName(XMLP.GetXmlValueProfData("CurrentXSDFilePath"));
                //RDFLAutilitaires.wtest("TEST", "SchemaWg16Recopie  fichier" + dirname + "\\XSDexample.xsd existe-t-il?");
                if (System.IO.File.Exists(dirname + "\\XSDexample.xsd"))
                {
                    System.IO.File.Delete(dirname + "\\XSDexample.xsd");
                 //   RDFLAutilitaires.wtest("TEST", "SchemaWg16Recopie  fichier" + dirname + "\\XSDexample.xsd deleted");
                }
                //ficlog.WriteLine("----------------------------" + DateTime.Now.ToLongDateString());
                //  ficlog.Close();
                if (dialgenerxsd != null) dialgenerxsd.Close();
            }
            catch (XmlSchemaException e)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("!!!generation aborted,Error in   compilation of schema Message = {0}", e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LineNumber = {0}", e.LineNumber);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("LinePosition = {0}", e.LinePosition);
                if (dialgenerxsd != null) dialgenerxsd.Close();
                ErrorCodes.ShowException(ErrorCodes.ERROR_064, e);
            }
            if (dialgenerxsd != null) dialgenerxsd.Close();
            if (RDFutilitaires.Barre != null) RDFutilitaires.Barre.Close();
            //ta.stop();
            //ta.quit();
            //td.elapsetime("XSDGenerate");
            //td.stop();
            //td.quit();

        }



        public static void ValidationCallbackOne(object sender, ValidationEventArgs args)
        {
            try
            {
                Console.WriteLine(args.Message);


                // if(Main.DO_REPORTLOG) reportlog.WriteLine("validation of the schema while beeing created:  " + args.Message);
                //  MessageBox.Show(" Validation Schema: " + args.Message);
            }
            catch (Exception e)
            {
                MessageBox.Show("40- Error Validation Schema: " + e.Message, "Error");
                // ficlog.WriteLine("40- Error Validation Schema: " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t ---MessageFromSchemaValidator:  {0}", e.Message);
            }

        }

        /************************************************************************************
        * here begins all programs which allow the transformation from UML to XSD
        * each program is preceded by the relevant NDR rule
        *************************************************************************************/

        /*****************************************************************************
         *  * top level element
         * ++++++++++++ R1 +++++++++++++++++++++++
          <xs:element 
            name= envelope-name 
            type= envelope-name>
        </xs:element>
        *   not yet impmented
         ******************************************************************************/
        /*****************************************************************************
          * Structured and Compound Classes
          * ++++++++++++ R2 +++++++++++++++++++++++
                <xs:complexType 
	              name = class-name
	             abstract = abstract-value (true or false)
	            sawsdl:modelReference = class-ref>
	            Content: (annotation, (whole-class|derived-class))
               </xs:complexType>
         * +++++++++++++++++++++++++
         * for a subclass
         * ++++++++++++++++++++++++
         * <xs:extension 
	         base = super-name>
	        Content: whole-class
            </xs:extension>
         * +++++++++++++++++++
         * the content:
         * 
         * <xs:sequence>
	     Content: ((simple-elem|typed-elem|ref-elem|
	     choice-elem|inline-elem|compound-elem)*)
        </xs:sequence> 
         * ******************************************************************************/
        /// <summary>
        /// to treat each element (like class)
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        static XmlSchemaObject TraitElem(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            XmlSchemaObject ret = null;
            string prov = el.Name;
            if (prov == "AssetInfo")
            {
                prov = el.Name;
        }
            string stereos = el.StereotypeEx;
            if (el.StereotypeEx=="RemoteUnit")
            {
                stereos = el.Stereotype; // am juil 2015 car j'a remarqu que StereotypeEx n'est pas bien positionne dans certain cas
            }
            string cas = "";
            if ((el.MetaType == "Enumeration") || (el.Type=="enumeration") || (el.Type=="Enumeration")) //am aout 18
            {
                cas = CD.GetEnumStereotype();
            }
            else // am oct 2017
            {
                string[] split = stereos.Split(new Char[] { ',' });
                if (!((split.Length == 1) && (split[0] == CD.GetInlineStereotype())))

                    foreach (string ss in split)
                    {
                        if (ss == CD.GetPrimitiveStereotype()) { cas = ss; break; };
                        if (ss == "Datatype") { cas = ss; break; };// ascendant compatibility
                        if (ss == CD.GetDatatypeStereotype()) { cas = ss; break; };
                        if (ss == CD.GetCompoundStereotype()) { cas = ss; break; };
                        if (ss == CD.GetEnumStereotype()) { cas = ss; break; };
                        if (ss == CD.GetInlineStereotype()) { cas = "none"; continue; };
                        if (ss == CD.GetAssemblyStereotype()) { cas = ss; break; }; // case of wg14 treatment envelop object
                    }
            }
            RDFLAutilitaires.wtest("TEST ", "traitelem " + el.Name   + " cas=" + cas);
            switch (cas)
            {

                case "none":
                    break;
                case ConstantDefinition.PrimitiveStereotype:
                    transPrimitive(el, apackage, schem);
                    break;
                case "Datatype": // ascending compatibility
                    ret = transDatatype(el, apackage, schem);
                    break;
                case ConstantDefinition.DatatypeStereotype:
                    if ((XMLP.GetXmlValueConfig("CimDataTypeAsCompound") == null)
                       ||
                       (XMLP.GetXmlValueConfig("CimDataTypeAsCompound") == "Unchecked"))
                    {
                        ret = transDatatype(el, apackage, schem);
                    }
                    else
                    {
                        ret = transCompound(el, apackage, schem);
                    }
                    break;
                case ConstantDefinition.CompoundStereotype:
                    ret = transCompound(el, apackage, schem);
                    break;
                case ConstantDefinition.EnumStereotype:
                    if (el.StereotypeEx.Contains(CD.GetCodeListStereotype()))
                    {
                        ret = transCodeListEnumeration(el, apackage, schem);
                        break;
                    }
                    ret = transenumeration(el, apackage, schem);
                    break;
                case ConstantDefinition.AssemblyStereotype:
                    break;
                default:
                    ret = transClass(el, apackage, schem);
                    break;
            }

            return ret;
        }


        //-------------------------------------------


        //------------------------------------------- 

        static XmlSchemaObject transClass(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            //td.diffelaps("start class treatment for " + el.Name.ToString());
            XmlSchemaObject ret = null;
            string prov1 = el.Name;
            if (el.Name == "BundledCableInfo")// "ConnectivityNode"//"TimeSeries")
            {
                prov1 = el.Name;
            }
            try
            {
                if (hierarchie)
                {
                    if (el.Name != "")
                    {
                       // if (el.Name == "Series_Period") RDFutilitaires.amtest = true; //am 27/10/2013
                        if(RDFutilitaires.amtest) //am 27/10/2013
                        {
                            string tt = el.Name;
                            string ss = " ++++++++  TEST BUG 27-10-2013 " + "transclass: " + el.Name + " elGUID=" + el.ElementGUID + " ++++++++++++";
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            EA.Element pel = RDFutilitaires.getElementBasedonElement(el);
                            ss = " \t classe parente : " + Repos.GetPackageByID((int)pel.PackageID).Name +"::";
                            ss = ss + pel.Name + "  de guid=" + pel.ElementGUID;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            foreach (EA.Attribute at in pel.Attributes)
                            {
                                ss = "\t\t attribut: " + at.Name + " de guid=" + at.AttributeGUID + "from element: " + pel.Name;
                                ss=ss + " de tagvalueGUID= " + RDFutilitaires.getAttrBasedOnAttribute(at.AttributeGUID,Repos);
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            }
                        }

                        //MessageBox.Show(" treatin the class " + el.Name + " "); // for test
                        // <xs:complexType name="">
                        XmlSchemaComplexType ct = new XmlSchemaComplexType();
                        ret = ct;
                        // schem.Items.Add(ct);
                        if (!IsInline(el)) ct.Name = el.Name;
                        XmlSchemaObject sobj = ct;
                        string prov = sobj.ToString();
                        //==============================================================================
                        //documentation et  attribut sawsdl
                        if (el.Abstract == "1")
                        { // case where the class is abstract
                            ct.IsAbstract = true;
                            if (Wg == "wg14")
                            {
                                if (el.Attributes.Count == 0) return null;
                            }
                        }
                        AddAnnForClass(el, ct, false);

                        //==============================================================================
                        // treatment in case of the existence of a super class or not
                        XmlSchemaSequence sequence = new XmlSchemaSequence();
                        EA.Element mother = RDFutilitaires.GetMotherClass(el);
                        if (mother != null)
                        {
                            if ((Wg != "wg14") || (mother.Attributes.Count != 0)) // ajout am sept 2012
                            {
                                // <xs:complexContent>
                                XmlSchemaComplexContent complexContent = new XmlSchemaComplexContent();
                                ct.ContentModel = complexContent;

                                // <xs:extension base="class">
                                XmlSchemaComplexContentExtension extensionClass = new XmlSchemaComplexContentExtension();
                                complexContent.Content = extensionClass;
                                extensionClass.BaseTypeName = new XmlQualifiedName(mother.Name, profparameters.TargetNamespace);

                                // <xs:sequence>

                                extensionClass.Particle = sequence;
                            }
                            else
                            {
                                ct.Particle = sequence;  // ajout am sept 2012
                            }
                        }
                        else
                        {
                            ct.Particle = sequence;
                        }
                        // <xs:element name=""   type=""/>
                        EA.Collection colattributes = el.Attributes;
                        List<EA.Attribute> attributes = new List<EA.Attribute>();
                        List<ModelObject> listconmobj = new List<ModelObject>();
                        EA.Attribute atmrid = null;
                        ModelObject mobj;
                        
                        foreach (EA.Attribute attrib in colattributes)
                        {
                            if (attrib.Name == "mRID")
                            {
                                atmrid = attrib;
                            }
                            else
                            {
                                if (isTypeCompound(attrib))
                                {
                                    mobj = new ModelObject(el, attrib);
                                    if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);

                                }
                                else
                                {
                                    attributes.Add(attrib);
                                }
                            }
                        }
                        //td.diffelaps("start of loop on attributes for " + el.Name);
                        if (Wg != "wg16" && !el.StereotypeEx.Contains(CD.GetCompoundStereotype())) // dec 2012
                        {
                            attributes.Sort(RDFutilitaires.CompareAttributesbyName);
                        }
                        if (atmrid != null) attributes.Insert(0, atmrid);
                        
                        foreach (EA.Attribute atr in attributes)
                        {
                            XmlSchemaElement nel = new XmlSchemaElement();
                            sequence.Items.Add(nel);
                            nel.Name = atr.Name;
                            if (atr.Name == "isAggregateRes")
                            {
                                 prov = atr.Type;
                            }
                            string atrtype = atr.Type;
                            long classifierid = atr.ClassifierID;
                            if ((classifierid != 0))  //18 && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
                            {
                                EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);

                                //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                                //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                                string classtereos = "";
                                string classsrereo = classifier.Stereotype;
                                classtereos = classifier.StereotypeEx;
                                string xstype = "";
                                if (classifier.StereotypeEx.Contains(CD.GetPrimitiveStereotype()))
                                {
                                    xstype = classifier.Name;
                                }
                                else
                                {
                                    xstype = GetXSType(classifier);
                                }
                                if (
                                    ((classtereos != "") && IsValidCimDatatype(classtereos))
                                    || 
                                    ((classifier.MetaType=="enumeration") || (classifier.MetaType=="Enumeration"))
                                    ) // 
                                // on peut reduire le classifier  une primitive xs ou a une union (dans le cas Float)
                                {

                                    if (xstype != "") //classtereos.Contains(CD.GetPrimitiveStereotype()))
                                    // il s'agit d'une primitive de type xs ou un union Float
                                    {
                                       // if ((xstype == CD.GetFloatType()) && (Wg != "wg14") ) // dans le cas wg14 on traite Float comme xs:float
                                        if ((xstype == CD.GetFloatType()) && (Wg != "wg14") && (Wg != "wg19byref")) // dans le cas wg14 on traite Float comme xs:float //am mars 2017
                                        { //Float is a special case sauf dans le cas de wg14

                                            nel.SchemaTypeName = new XmlQualifiedName(xstype, profparameters.TargetNamespace);
                                            if (!LocalDatatypeNames.Contains(xstype))
                                            {
                                                if (classtereos.Contains(CD.GetPrimitiveStereotype()))
                                                {
                                                    transPrimitive(classifier, apackage, schem);
                                                }
                                                else
                                                { // il s'agit d'un datatype a une value
                                                    EA.Attribute at = (EA.Attribute)classifier.Attributes.GetAt(0);
                                                    EA.Element elfloat = Repos.GetElementByID((int)at.ClassifierID);
                                                    transPrimitive(elfloat, apackage, schem);
                                                    if (!LocalDatatypeNames.Contains(xstype)) LocalDatatypeNames.Add(xstype);
                                                }
                                            }

                                        }
                                        else
                                        {
                                            if (((Wg == "wg14") || (Wg == "wg19byref")) && (xstype == CD.GetFloatType())) //am mars 2017
                                            {
                                                xstype = "float";  // avr 2014 ugly patch mais rapide  implmenter
                                            }
                                            if (!mapforprimitivetypes.ContainsKey(xstype))//classifier.Name))
                                            {
                                                // a primitive should be with the given list
                                                MessageBox.Show("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                                    " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                                //" is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                                //RDFutilitaires.ongoing= false;
                                                //return;

                                            }
                                            else
                                            {

                                                nel.SchemaTypeName = new XmlQualifiedName(mapforprimitivetypes[xstype], NS_XSD); //classifier.Name
                                            }
                                        }
                                    }
                                    else
                                     {
                                        if (IsInline(classifier))
                                        {
                                            XmlSchemaObject sobjj = TraitElem(classifier, apackage, schem);
                                            string xmltyp = sobjj.GetType().ToString();
                                            switch (xmltyp)
                                            {
                                                case "System.Xml.Schema.XmlSchemaComplexType":
                                                    nel.SchemaType = (XmlSchemaComplexType)sobjj;
                                                    break;
                                                case "System.Xml.Schema.XmlSchemaSimpleType":
                                                    nel.SchemaType = (XmlSchemaSimpleType)sobjj;
                                                    break;
                                                default:
                                                    break;
                                            }
                                        }
                                        else
                                        {
                                            if (!IsImportOrIncludeRelated(el, classifier, CD.GetImportStereotype()))
                                            {// ne pas creer ,
                                                // importer si necessaire am nov 201
                                                nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                                            }
                                            else
                                            {

                                                nel.SchemaTypeName = new XmlQualifiedName(atrtype, XMLP.GetXmlValueProfData("URICodeList"));

                                            }
                                            if (!datatypetraite.Contains(classifierid))
                                            {
                                                if (!IsImportOrIncludeRelated(el, classifier, CD.GetImportStereotype()))
                                                {// ne pas creer ,
                                                    // importer si necessaire am nov 2011
                                                    CreateDatatypIfNeeded(classifierid, apackage, schem);
                                                    //TraitElem(classifier,apackage,schem);
                                                }
                                            }
                                        }
                                    }
                                    //    if (atr.LowerBound == "0") nel.MinOccurs = 0;
                                    nel.MinOccursString = atr.LowerBound;
                                    nel.MaxOccursString = atr.UpperBound;


                                    // AddAnnForAtr(el, nel, atr, true);
                                    
                                    
                                    
                                    AddAnnForAtr(el, nel, atr);
                                    
                                   
                                    /******** default or fixed values of the attribute ************************/
                                    if (atr.Default != "")
                                    {
                                        if (atr.IsConst)
                                        {
                                            nel.FixedValue = atr.Default;
                                        }
                                        else
                                        {
                                            nel.DefaultValue = atr.Default;
                                        }
                                    }

                                }
                                else
                                {
                                    // classifier == not a CIM type
                                    MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type " + classifier.Name + "  The element has been created without any type");
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type " + classifier.Name + ". The element has been created without any type");
                                }
                            }
                            else
                            {  // classifier == 0 probably a type from EA
                                MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type( native?). The element has been created without any type");
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type( native?). The element has been created without any type");
                            }
                        }
                       // td.diffelaps("end  loop on attributes for " + el.Name);
                        // ====================     treatment of associations

                        prov = el.Name;// pour test
                        if(el.Name=="TimeSeries")
                        {
                            prov = el.Name;
                        }
                        //                     

                        Dictionary<long, List<EA.Connector>> constraineds = new Dictionary<long, List<EA.Connector>>(); // connectors which are constrained 

                        dicsamerolesbyname = new Dictionary<string, List<long>>();
                        initDicSamerolesbyname(el);


                        // all connections are between concrete classes
                        EA.Collection connectors = el.Connectors;
                        /*
                        List<EA.Connector> connectors = new List<Connector>();
                        foreach(KeyValuePair<string,EA.Connector>kv in sortedcons){
                            connectors.Add(kv.Value);
                        }
                         * */

                        //  List<ModelObject> listconmobj = new List<ModelObject>(); 
                        //td.diffelaps("start  loop on connectors for " + el.Name);
                        foreach (EA.Connector con in connectors)
                        {

                            if (con.Type == "Association" ||
                                         con.Type == "Aggregation")
                            {
                                if (!LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.ClientID).Name)
                                    || !LocalClassNames.Contains(Main.Repo.GetElementByID((int)con.SupplierID).Name))
                                {// one end is not part of the profile
                                    string texte = "WARNING one  end  of an association between " + (Main.Repo.GetElementByID((int)con.ClientID).Name + " and " + (Main.Repo.GetElementByID((int)con.SupplierID)).Name);
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                                    MessageBox.Show(texte);
                                    return ret;
                                }
                            }


                            if (!RDFutilitaires.dicconstbycon.ContainsKey(con.ConnectorID))
                            {
                                if (con.Type == "Association" ||
                                       con.Type == "Aggregation")
                                {
                                    mobj = new ModelObject(el, con);
                                    if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);
                                    //  transConnector(el, sequence, con);
                                }
                            }
                            else
                            {
                                List<long> constids = RDFutilitaires.dicconstbycon[con.ConnectorID];
                                foreach (long constid in constids)
                                { // for each constraints attached to the given connector
                                    if (constraineds.ContainsKey(constid))
                                    {// we regroup the constrained associations by constraint ID
                                        constraineds[constid].Add(con);
                                    }
                                    else
                                    {
                                        constraineds.Add(constid, new List<EA.Connector>());
                                        constraineds[constid].Add(con);
                                    }
                                }
                            }
                        }
                        //td.diffelaps("end  loop on connectors for " + el.Name);
                        foreach (long constid in constraineds.Keys)
                        {

                           //18  if (RDFutilitaires.dicelembyid[constid].Notes == "XOR")
                                if (Main.Repo.GetElementByID((int)constid).Notes == "XOR")
                            { //we treat  the "choices" case
                                if (constraineds[constid].Count > 1)
                                { // must be at least 2 to have a choice
                                    transChoiceConnector(el, sequence, constraineds[constid]);

                                }
                            }
                          //18  if (RDFutilitaires.dicelembyid[constid].Notes == "UNION")
                                if (Main.Repo.GetElementByID((int)constid).Notes == "UNION")
                            { //we treat  the "choices" case
                                if (constraineds[constid].Count > 1)
                                { // must be at least 2 to have a choice
                                    transChoiceUnionConnector(el, sequence, constraineds[constid]);

                                }
                            }
                        }

                        //  treatment of inherited connections
                        prov = el.Name; // pour test
                        if (el.Name == "DCLineSegment")
                        {
                            prov = el.Name;
                        }
                        Dictionary<long, List<Connexion>> inheritedConstrainedConexes = new Dictionary<long, List<Connexion>>(); // all conexes inheriting a choice condid are registered as constraint
                        List<long> choicedconids = new List<long>(); // we marq the conid which are constrained with a choice
                        Dictionary<long, List<Connexion>> unions = new Dictionary<long, List<Connexion>>(); // eltid,connex
                        if (inheritedconex.ContainsKey(el.ElementID))
                        {
                            List<Connexion> co = inheritedconex[el.ElementID];
                            //td.diffelaps("start  loop on inheritedconnectors for " + el.Name);
                            foreach (Connexion conex in inheritedconex[el.ElementID])
                            {
                                if ((!RDFutilitaires.dicconstbycon.ContainsKey(conex.ConnectorID)) && !(ConexesWithUnion.ContainsKey(conex.ConexID)))
                                { // no constrained connection
                                    EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);
                                    if (con.Type == "Association" ||
                                      con.Type == "Aggregation")
                                    {
                                        //mobj = new ModelObject(el, conex);
                                        // if ((!listconmobj.Contains(mobj)) && (mobj.keyname != "")) listconmobj.Add(mobj);
                                        // transInheritedConnector(el, sequence, conex);

                                    }
                                }
                                else
                                {
                                    // it is a constrained  connection
                                    // ici il doit y avoir un test sur la nature de la contrainte
                                    // mais aujourd'hui c'est forcement un choice par construction
                                    if ((!inheritedConstrainedConexes.ContainsKey(conex.ConnectorID)) && (!ConexesWithUnion.ContainsKey(conex.ConexID)))
                                    { // we regroupe connections inherited from the same conid
                                        inheritedConstrainedConexes.Add(conex.ConnectorID, new List<Connexion>());
                                        inheritedConstrainedConexes[conex.ConnectorID].Add(conex);
                                    }
                                    else
                                    {
                                        bool present = false;
                                        if (inheritedConstrainedConexes.Count > 0)
                                        {
                                            foreach (Connexion con in inheritedConstrainedConexes[conex.ConnectorID])
                                            {
                                                if (con.ConexID == conex.ConexID)
                                                {
                                                    present = true;
                                                    break;
                                                }
                                            }
                                            if (!present) inheritedConstrainedConexes[conex.ConnectorID].Add(conex);

                                        }
                                    }
                                    if (ConexesWithUnion.Count > 0)
                                    {
                                        if (ConexesWithUnion.ContainsKey(conex.ConexID))
                                        {  // this connexion is member of an union
                                            long conid = conex.ConnectorID; // get the connector id
                                            if (!unions.ContainsKey(conid))
                                            {
                                                unions.Add(conid, new List<Connexion>());
                                            }
                                            if (!unions[conid].Contains(conex)) { unions[conid].Add(conex); };

                                        }

                                    }
                                }

                            }//foreach
                            //td.diffelaps("end  loop on attributes for " + el.Name);

                            foreach (KeyValuePair<long, List<Connexion>> kv in inheritedConstrainedConexes)
                            { // we treat all the choiced connections
                                transChoiceInheritedConnector(el, sequence, kv.Value);
                            }
                            foreach (KeyValuePair<long, List<Connexion>> kv in unions)
                            {
                                transUnionInheritedConnector(el, sequence, kv.Value);
                            }

                        }

                        listconmobj.Sort(CompareModelObjectbyKeyName);// il y a aussi les attributs compound
                        foreach (ModelObject mob in listconmobj)
                        {
                            if (mob.keyname != "")
                            {
                                if (mob.keyname == "T!Operator_MarketParticipant")
                                {
                                    prov = mob.keyname;
                                }
                                switch (mob.type)
                                {
                                    case "attribute":
                                        AddElementAttribute(schem, sequence, apackage, el, mob.attribute);
                                        break;
                                    case "connexion":

                                        string[] split = mob.keyname.Split('!');
                                        switch (split[1])
                                        {
                                            case "ref":
                                                if (split[0] == "T")  // T comme target
                                                {
                                                    //AddElementRef(sequence, getMrid(el), mob.conex.Target_element, mob.conex.Target);
                                                    AddElementRef(sequence, getMrid(el), mob.conex, "target");
                                                }
                                                else
                                                {
                                                    //AddElementRef(sequence, getMrid(el), mob.conex.Source_element, mob.conex.Source);
                                                    AddElementRef(sequence, getMrid(el), mob.conex, "source");
                                                }
                                                break;
                                            default:
                                                if (split[0] == "T")
                                                {
                                                    //AddElement(sequence, split[1], mob.conex.Target_element.Name, mob.conex.Target_element, mob.conex.Target);
                                                    AddElement(sequence, split[1], mob.conex, "target");
                                                }
                                                else
                                                {
                                                    //AddElement(sequence, split[1], mob.conex.Source_element.Name, mob.conex.Source_element, mob.conex.Source);
                                                    AddElement(sequence, split[1], mob.conex, "source");
                                                }
                                                break;
                                        }
                                        break;
                                    default:
                                        break; ;
                                }
                            }

                        }



                        //------------------------------------------------------------------------------- 

                        /***  for test  **********/
                        //am 27/10/2013
                        if (RDFutilitaires.amtest)
                        {
                            RDFutilitaires.amtest = false;
                        }
                        /*************************/
                    }
                    else
                    {
                        // it is an unnamed element. Most probably a constraint to associations
                        //MessageBox.Show( "|notes=" + el.Notes + "|Otype=" + el.ObjectType + "|type=" + el.Type );


                        //-------------------------------------------------------------------------------------------------

                    }
                    // AddAnnForAtr(el, nel, atr, true);
                    
                }//

                else
                {// not hierarchy
                }

            }

            catch (Exception e)
            {
                MessageBox.Show("2-CIMSchemagenerator Error : " + e.Message + "\n" + e.ToString());
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR in treating an Element of Type  Class " + el.Name + "   " + e.Message);
                //// reportlog.Flush();
            }
            //td.diffelaps("end of Class treatment for " +el.Name.ToString());
            return ret;
        }




        //--------------------------------------------
        //-------------------------------------------
        /// <summary>
        ///  // nous devons decider plusieurs cas de datatypes qui peuvent tre en ligne ou non en ligne
        ///  on commence par verifier la compatibilit des elements fourni avec in-line ou non
        ///att2: primitive, enumeration  pas in-line
        ///att3: CimDatatype  simple value and restriction in-line ou pas in-line
        ///att4: CimDatatype multi  pas in-line 
        ///  
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        /// <returns></returns>
        static XmlSchemaObject transDatatype(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            string prov = el.Name + "|" + Repos.GetPackageByID((int)el.PackageID).Name;

            XmlSchemaObject ret = null;
            bool inline = false;
            if (IsInline(el))
            {
                inline = true;
            }
            if ((el.ElementID != 0) && (datatypetraite.Contains(el.ElementID)))
            {//  already treated
                return ret;  // return null
            }
            //   MessageBox.Show(" treating Datatype" + el.Name);// pour test 

            //datatypetraite.Add(el.ElementID);

            string codelistname = ""; //nom d'une codelist etso 
            string cas = "datatype";
            EA.Attribute value = null;
            EA.Attribute multiplier = null;
            EA.Attribute unit = null;
            int count = 0;
            /*
            if ((Wg=="wg16") || el.Attributes.Count <= 3)
            {
             * */
            foreach (EA.Attribute att in el.Attributes)
            {
                if (att.Name == "value") { value = att; count++; };
                if (att.Name == "multiplier") { multiplier = att; count++; };
                if (att.Name == "unit") { unit = att; count++; };
            }
            if (value != null)
            {
                // MessageBox.Show(" datatype=" + el.Name + " attribute of name=" + value.Name + " nb contraintes=" + (value.Constraints).Count.ToString());


                if (!IsValuePrimitive(value.Type))
                {
                    if ((Wg == "wg16") || (CD.GetImportCodeList()))
                    { // dans le cas de w16 european side on peut se referer  une code list sur le site etso
                        // ICI METTRE UNE VERIFICATION qu'il y a une enumeration correspondante declaree (am mars 2012)
                        codelistname = value.Type;
                    }
                    else
                    {
                        string texte = "Error there is a CimDatatype" + el.Name + "which has a value" + value.Type + " not being a primitivet";
                        //	MessageBox.Show(texte);
                        //reportlog.Write(texte);
                       //18  // reportlog.Flush();
                        return ret;
                    }
                };

                if (count == 1) { cas = "valueseule"; };
                if ((cas == "valueseule") && (value.Constraints.Count > 0)) { cas = "valueseulerestreinte"; };
                if ((count == 2) && ((multiplier != null) || (unit != null))) { cas = "valueetmulti"; };
                if ((count == 3) && (multiplier != null) && (unit != null)) { cas = "valueetmulti"; };
                if ((Wg == "wg16") && (cas == "valueseule") && (el.Attributes.Count > 1)) { cas = "valueetmulti"; };
                if ((cas == "valueetmulti") && (value.Constraints.Count > 0))
                {
                    bool rest = true;
                    if ((cas == "valueetmulti") && (value.Constraints.Count == 1) &&
                        ((value.Type == CD.GetFloatType()) || (value.Type == CD.GetStringType()))
                        )
                    {
                        EA.AttributeConstraint co = (EA.AttributeConstraint)(value.Constraints.GetAt(0));
                        if ((co.Type == "INV") || (co.Type == "Invariant")) { cas = "valueetmulti"; rest = false; }
                    }
                    if (rest) cas = "valueetmultirestreinte";

                }

                if ((Wg == "wg16") && (cas == "valueseule"))
                {
                    bool rest = false;


                    if (value.TaggedValues.Count > 0)
                    {
                        List<string> listfac = CD.GetListeFacets();
                        foreach (EA.AttributeTag atag in value.TaggedValues)
                        {
                            if (listfac.Contains(atag.Name.ToLower()))
                            {
                                rest = true;
                                break;
                            }
                        }
                    }
                    if (rest) cas = "valueseulerestreinte";
                }

                if ((Wg == "wg16") && (cas == "valueetmulti"))
                {
                    bool rest = true;
                    if (value.Constraints.Count == 0) rest = false;
                    if (value.Constraints.Count == 1 &&
                        ((value.Type == CD.GetFloatType()) || (value.Type == CD.GetStringType()))
                        )
                    {
                        EA.AttributeConstraint co = (EA.AttributeConstraint)(value.Constraints.GetAt(0));
                        if ((co.Type == "INV") || (co.Type == "Invariant")) { cas = "valueetmulti"; rest = false; }
                    }

                    if (value.TaggedValues.Count > 0)
                    {
                        List<string> listfac = CD.GetListeFacets();
                        foreach (EA.AttributeTag atag in value.TaggedValues)
                        {
                            if (listfac.Contains(atag.Name.ToLower()))
                            {
                                rest = true;
                                break;
                            }
                        }
                    }
                    if (rest) cas = "valueetmultirestreinte";
                }
                // cas par defaut   cas = "datatype";

                if (inline && (cas == "valueetmultirestreinte"))
                {
                    string texte = " WARNING  datatype " + el.Name + " which is restricted and with multiplier or unit cannot be with stereotype  " + CD.GetInlineStereotype() + " it will bee ignored";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    MessageBox.Show(texte);
                    //return ret; // ret=null car interdit
                }
                datatypetraite.Add(el.ElementID);
                if ((cas == "valueseule") && (el.Attributes.Count > 1)) { cas = "valueetmulti"; }
                if ((cas == "valueseulerestreinte") && (el.Attributes.Count > 1)) { cas = "valueetmultirestreinte"; };
                switch (cas)
                {

                    case "valueseule":

                        if ((Wg == "wg16") && codelistname != "")
                        {
                            ret = traitValueSeule(apackage, schem, el, value, ret);
                            // ret = null;
                        }
                        else
                        {
                            ret = null;
                        }

                        break;

                    case "valueseulerestreinte":
                        if (Wg != "wg16")
                        {

                            ret = traitValueSeuleRestrainte(apackage, schem, el, value, ret);
                        }
                        else
                        {
                            //ret = traitValueSeuleRestraintewg16(apackage, schem, el, value, ret);
                            ret = traitValueSeuleRestrainte(apackage, schem, el, value, ret);
                        }

                        break;

                    case "valueetmulti":
                        if (Wg == "wg16")
                        {
                            //ret = traitValueEtMultiwg16(apackage, schem, el, value, multiplier, unit, ret);
                            ret = traitValueEtMulti(apackage, schem, el, value, multiplier, unit, ret);
                        }
                        else
                        {
                            ret = traitValueEtMulti(apackage, schem, el, value, multiplier, unit, ret);
                        }
                        break;

                    case "valueetmultirestreinte":
                        if (Wg != "wg16")
                        {

                            ret = traitValueEtMultiRestreinte(apackage, schem, el, value, multiplier, unit, ret);
                        }
                        else
                        {
                            //ret = traitValueEtMultiResteintewg16(apackage, schem, el, value, multiplier, unit, ret);
                            ret = traitValueEtMultiRestreinte(apackage, schem, el, value, multiplier, unit, ret);
                        }
                        break;

                    case "datatype":
                        ret = traitDatatype(apackage, schem, el, ret);
                        break;
                    default:
                        break;

                }



            }
            else
            {  // value est nul c'est un datatype normal 
                ret = traitDatatype(apackage, schem, el, ret);
            }
            return ret;

        }// end if elemnt exits already



        //--------------------------------------------
        //-------------------------------------------
        static void transPrimitive(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            // traitement specifique de la primitive FLOAT (global simple type creation)

            {

                if (el.Name == CD.GetFloatType())
                {
                    if (!datatypetraite.Contains(el.ElementID))
                    {
                        datatypetraite.Add(el.ElementID);

                        //-----------------------------------------------------------------------


                        if (!LocalDatatypeNames.Contains(CD.GetFloatType()))
                        {

                            //<xs:simpleType name="Float">

                            XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                            flottant.Name = CD.GetFloatType();
                            schema.Items.Add(flottant);
                            XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                            flottant.Content = union;
                            XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                            union.MemberTypes = members;
                            XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                            flottant.Annotation = flotanno; ;
                           
                            //  string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                            string reference = "";
                            ArrayList reff = getReff(el, false);// am mai 2017 PENSER a supprimer dans les lignes suivantes les def de reff redondantes
                            switch (Wg)
                            {
                                case "wg14":
				                case "wg16":
                                     reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
                                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                                    break;
                                case "wg19byref":
                                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                                    break;   
                                default:
                                     reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
                                    reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                                    break;
                            }
                            AddAppInfoSawdsl(flotanno, reference);
                            if (el.Notes != "")
                            {
                                XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                                flotanno.Items.Add(flotdoc);
                                flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                            }

                        }



                        /*
                        //<xs:simpleType name="Float">
                        XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                        flottant.Name = CD.GetFloatType();
                        schem.Items.Add(flottant);
                        XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                        flottant.Content = union;
                        XmlQualifiedName[] members;
                        //   members.SetValue( new XmlQualifiedName("double", NS_XSD));
                        // members.SetValue( new XmlQualifiedName("float", NS_XSD));
                        XmlQualifiedName qname = new XmlQualifiedName("double", NS_XSD);
                        union.MemberTypes.SetValue(qname, 0);
                        qname = new XmlQualifiedName("float", NS_XSD);
                        union.MemberTypes.SetValue(qname, 1);
                        */
                    }

                }
            }
        }
        //--------------------------------------------
        //-------------------------------------------
        static XmlSchemaObject transenumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            try
            {
                XmlSchemaObject ret = null;
                bool inline = IsInline(el);
                if ((!inline) && ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID))))
                {
                    ret = null;

                }
                //if ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID)))
                //{
                if (!inline) datatypetraite.Add(el.ElementID);
                // <xs:simpleType name="">
                XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                //if(IsInline(el)) simpptype.Name = el.Name;
                if (!inline)
                {
                    simpptype.Name = el.Name;
                    schem.Items.Add(simpptype);
                }
                else
                {
                    ret = simpptype;

                }
                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();

                simppRestriction.BaseTypeName = new XmlQualifiedName("string", NS_XSD);
                //les facets
                int nombre = el.Attributes.Count;
                EA.Collection attributes = el.Attributes;
                //EA.Attribute co;
                List<EA.Attribute> lat = new List<EA.Attribute>();
                for (short i = 0; i < nombre; i++)
                {
                    lat.Add((EA.Attribute)attributes.GetAt(i));
                }
                lat.Sort(CompareAttributebyName);

                foreach (EA.Attribute at in lat)
                {
                    AddFacetEnumeration(simppRestriction, at);
                }
                simpptype.Content = simppRestriction;
                // schem.Items.Add(simpptype);
                AddAnnForStx(el, simpptype, false);
                string texte = " le simple element enumeration " + el.Name + " a t ajout au schema";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                // MessageBox.Show(el.Name + " contrainte");
                EA.Element bel = RDFutilitaires.getElementBasedonElement(el);
                if (bel != null)
                {
                    //          transBaseEnumeration(bel, apackage, schem);
                }
                return ret;
            }
            catch (XmlException e)
            {
                MessageBox.Show(" dans transenumeration :" + e.Message);

            }
            // }
            return null;
        }


        //-------------------------------------------
        static XmlSchemaObject transCodeListEnumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            try
            {
                XmlSchemaObject ret = null;
                bool inline = IsInline(el);
                if ((!inline) && ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID))))
                {
                    ret = null;

                }
                // if ((el.ElementID != 0) && (!datatypetraite.Contains(el.ElementID)))
                // {
                if (!inline) datatypetraite.Add(el.ElementID);
                // <xs:simpleType name="">
                XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                //simpptype.Name = el.Name;
                if (!inline)
                {
                    simpptype.Name = el.Name;
                    schem.Items.Add(simpptype);
                }
                else
                {
                    ret = simpptype;

                }

                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                string codelistvaluetype = getCodeListValueType(el);
                simppRestriction.BaseTypeName = new XmlQualifiedName(codelistvaluetype, NS_XSD);
                //les facets
                int nombre = el.Attributes.Count;
                EA.Collection attributes = el.Attributes;
                EA.Attribute co;
                for (short i = 0; i < nombre; i++)
                {
                    co = (EA.Attribute)attributes.GetAt(i);
                    AddFacetCodeListEnumeration(simppRestriction, co);
                }
                simpptype.Content = simppRestriction;
                //schem.Items.Add(simpptype);
                AddAnnForStx(el, simpptype, false);
                // MessageBox.Show(el.Name + " contrainte");
                EA.Element bel = RDFutilitaires.getElementBasedonElement(el);
                if (bel != null)
                {
                    //   transBaseEnumeration(bel, apackage, schem);
                }
                return ret;
                //}
            }
            catch (XmlException e)
            {
                MessageBox.Show(" dans transCodelistenumeration :" + e.Message);

            }
            // }
            return null;
        }
        //--------------------------------------------
        //-------------------------------------------
        /// <summary>
        /// create the XSD the enumeration which is the base of an other enumeration
        /// verify that it is not created twice
        /// </summary>
        /// <param name="el"></param>
        /// <param name="apackage"></param>
        /// <param name="schem"></param>
        static void transBaseEnumeration(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            //  if (!CreatedEnumerations.Contains(el.ElementID))

            if ((el.ElementID != 0) && (!el.StereotypeEx.Contains(CD.GetPrimitiveStereotype())) && (!datatypetraite.Contains(el.ElementID)))
            {
                // CreatedEnumerations.Add(el.ElementID);
                datatypetraite.Add(el.ElementID);
                if (!LocalDatatypeNames.Contains(el.Name))
                { // there is no classifier with same name
                    if (!datatypetraite.Contains(el.ElementID)) datatypetraite.Add(el.ElementID);
                    // <xs:simpleType name="">
                    XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
                    simpptype.Name = el.Name;
                    XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                    simppRestriction.BaseTypeName = new XmlQualifiedName("string", NS_XSD);
                    //les facets
                    int nombre = el.Attributes.Count;
                    EA.Collection attributes = el.Attributes;
                    EA.Attribute co;
                    for (short i = 0; i < nombre; i++)
                    {
                        co = (EA.Attribute)attributes.GetAt(i);
                        AddFacetEnumeration(simppRestriction, co);
                    }
                    simpptype.Content = simppRestriction;
                    schem.Items.Add(simpptype);
                    AddAnnForStx(el, simpptype, false);
                    // MessageBox.Show(el.Name + " contrainte");

                }
                else
                {
                    // a similar name already exists in the package
                    if (!LocalDatatypeIDs.Contains(el.ElementID))
                    {
                        string texte = " WARNING: it seems that you used a type " + el.Name + " which was already been defined in the profile\n";
                        texte = texte + " the reference has been made to the already  defined local type";
                        MessageBox.Show(texte);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    }
                }
            }
        }
        //--------------------------------------------
        //-------------------------------------------
        /****
        static XmlSchemaObject transCompound(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            return transClass(el, apackage, schem);
        }
         * */
        //--------------------------------------------
        public static XmlNode[] TextToNodeArray(string text)
        {
            XmlDocument doc = new XmlDocument();
            return new XmlNode[1] {
                   doc.CreateTextNode(text)};
        }
        //-----------------------------------------
        static void ContainmentPath(EA.Package pa, List<String> path)
        {
            path.Add(pa.Name);
            if (!(pa.ParentID == 0)) // arrive to top
            {
                //18 ContainmentPath(RDFutilitaires.dicrepobyid[pa.ParentID], path);
                ContainmentPath(Main.Repo.GetPackageByID((int)pa.ParentID), path);

            }
        }
        //-----------------------------------------------------
        static void AddFacet(XmlSchemaSimpleTypeRestriction rest, EA.AttributeConstraint co)
        {
            string[] fac = {"fractiondigits","length","maxexclusive","maxinclusive","maxlength","minexclusive","mininclusive","minlength","pattern","totaldigits","whitespace","enumeration"
    };



            List<string> facets = new List<string>(fac);
            string notes = RDFutilitaires.RemoveRc(co.Notes);
            //notes = notes.ToLower();

            int ind1 = notes.IndexOf("->"); // position de operateur OCL
            int ind2 = notes.IndexOf('('); // parenthese ouvrante de operateur , suppose aucune parenthese pealable
            int ind3 = notes.LastIndexOf(')');
            if (!(ind1 > 0) || !(ind2 > ind1 + 2) || !(ind3 > ind1 + 3))
            {
                string texte = " ATTENTION la contrainte " + co.Name + " contient " + notes + " et semble mal formee";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return;
            }
            string s = notes.Substring(ind1 + 2, ind2 - ind1 - 2);
            s = s.ToLower();
            string value = notes.Substring(ind2 + 1, ind3 - ind2 - 1);
            if (!facets.Contains(s))
            {
                string texte = " ATTENTION operateur dans la contrainte " + co.Name + " de contenu" + notes + " pas une facette valide pour XML";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                return;
            }

            switch (s)
            {
                case "fractiondigits":
                    XmlSchemaFractionDigitsFacet fa = new XmlSchemaFractionDigitsFacet();
                    fa.Value = value;
                    rest.Facets.Add(fa);
                    break;
                case "length":
                    XmlSchemaLengthFacet length = new XmlSchemaLengthFacet();
                    length.Value = value;
                    rest.Facets.Add(length);
                    break;
                case "maxexclusive":
                    XmlSchemaMaxExclusiveFacet maxexclusive = new XmlSchemaMaxExclusiveFacet();
                    maxexclusive.Value = value;
                    rest.Facets.Add(maxexclusive);
                    break;
                case "maxinclusive":
                    XmlSchemaMaxInclusiveFacet maxinclusive = new XmlSchemaMaxInclusiveFacet();
                    maxinclusive.Value = value;
                    rest.Facets.Add(maxinclusive);
                    break;
                case "maxlength":
                    XmlSchemaMaxLengthFacet maxlength = new XmlSchemaMaxLengthFacet();
                    maxlength.Value = value;
                    rest.Facets.Add(maxlength);
                    break;
                case "minexclusive":
                    XmlSchemaMinExclusiveFacet minexclusive = new XmlSchemaMinExclusiveFacet();
                    minexclusive.Value = value;
                    rest.Facets.Add(minexclusive);
                    break;
                case "mininclusive":
                    XmlSchemaMinInclusiveFacet mininclusive = new XmlSchemaMinInclusiveFacet();
                    mininclusive.Value = value;
                    rest.Facets.Add(mininclusive);
                    break;
                case "minlength":
                    XmlSchemaMinLengthFacet minlength = new XmlSchemaMinLengthFacet();
                    minlength.Value = value;
                    rest.Facets.Add(minlength);
                    break;
                case "pattern":
                    XmlSchemaPatternFacet pattern = new XmlSchemaPatternFacet();
                    pattern.Value = value;
                    rest.Facets.Add(pattern);
                    break;
                case "totaldigits":
                    XmlSchemaTotalDigitsFacet totaldigits = new XmlSchemaTotalDigitsFacet();
                    totaldigits.Value = value;
                    rest.Facets.Add(totaldigits);
                    break;
                case "whitespace":
                    XmlSchemaWhiteSpaceFacet whitespace = new XmlSchemaWhiteSpaceFacet();
                    whitespace.Value = value;
                    rest.Facets.Add(whitespace);
                    break;
                case "enumeration":
                    XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                    enumeration.Value = value;
                    rest.Facets.Add(enumeration);
                    break;
                default:

                    break;
            }
        }

        //-----------------------------------------------------------
        /// <summary>
        /// add a facet xith precision for Float facet
        /// </summary>
        /// <param name="rest"></param>
        /// <param name="co"></param>
        /// <param name="precision"></param>
        static void AddFacet(XmlSchemaSimpleTypeRestriction rest, EA.AttributeConstraint co, string precision)
        {

            string[] fac = {"fractiondigits","length","maxexclusive","maxinclusive","maxlength","minexclusive","mininclusive","minlength","pattern","totaldigits","whitespace","enumeration"
    };



            List<string> facets = new List<string>(fac);
            string notes = RDFutilitaires.RemoveRc(co.Notes);
            notes = notes.ToLower();
            foreach (string s in facets)
            {
                string op = s + "(";
                if (notes.Contains(op))
                {
                    string[] split = notes.Split(new Char[] { '(', ')' });
                    string value = split[1];
                    switch (s)
                    {
                        case "fractiondigits":
                            XmlSchemaFractionDigitsFacet fa = new XmlSchemaFractionDigitsFacet();
                            fa.Value = value;
                            rest.Facets.Add(fa);
                            break;
                        case "length":
                            XmlSchemaLengthFacet length = new XmlSchemaLengthFacet();
                            length.Value = value;
                            rest.Facets.Add(length);
                            break;
                        case "maxexclusive":
                            XmlSchemaMaxExclusiveFacet maxexclusive = new XmlSchemaMaxExclusiveFacet();
                            maxexclusive.Value = value;
                            rest.Facets.Add(maxexclusive);
                            break;
                        case "maxinclusive":
                            XmlSchemaMaxInclusiveFacet maxinclusive = new XmlSchemaMaxInclusiveFacet();
                            maxinclusive.Value = value;
                            rest.Facets.Add(maxinclusive);
                            break;
                        case "maxlength":
                            XmlSchemaMaxLengthFacet maxlength = new XmlSchemaMaxLengthFacet();
                            maxlength.Value = value;
                            rest.Facets.Add(maxlength);
                            break;
                        case "minexclusive":
                            XmlSchemaMinExclusiveFacet minexclusive = new XmlSchemaMinExclusiveFacet();
                            minexclusive.Value = value;
                            rest.Facets.Add(minexclusive);
                            break;
                        case "mininclusive":
                            XmlSchemaMinInclusiveFacet mininclusive = new XmlSchemaMinInclusiveFacet();
                            mininclusive.Value = value;
                            rest.Facets.Add(mininclusive);
                            break;
                        case "minlength":
                            XmlSchemaMinLengthFacet minlength = new XmlSchemaMinLengthFacet();
                            minlength.Value = value;
                            rest.Facets.Add(minlength);
                            break;
                        case "pattern":
                            XmlSchemaPatternFacet pattern = new XmlSchemaPatternFacet();
                            pattern.Value = value;
                            rest.Facets.Add(pattern);
                            break;
                        case "totaldigits":
                            XmlSchemaTotalDigitsFacet totaldigits = new XmlSchemaTotalDigitsFacet();
                            totaldigits.Value = value;
                            rest.Facets.Add(totaldigits);
                            break;
                        case "whitespace":
                            XmlSchemaWhiteSpaceFacet whitespace = new XmlSchemaWhiteSpaceFacet();
                            whitespace.Value = value;
                            rest.Facets.Add(whitespace);
                            break;
                        case "enumeration":
                            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                            enumeration.Value = value;
                            rest.Facets.Add(enumeration);
                            break;
                        default:
                            break;
                    }
                }
            }
        }
        //-----------------------------------------------------------
        //-----------------------------------------------------------
        /// <summary>
        /// add a facet for constraints expressed as tagvalue in wg16
        /// </summary>
        /// <param name="rest"></param>
        /// <param name="co"></param>
        /// <param name="precision"></param>
        static void AddFacet(XmlSchemaSimpleTypeRestriction rest, EA.AttributeTag tag)
        {
            string[] fac = {"fractiondigits","length","maxexclusive","maxinclusive","maxlength","minexclusive","mininclusive","minlength","pattern","totaldigits","whitespace","enumeration"
    };



            List<string> facets = new List<string>(fac);
            string tagname = tag.Name.ToLower();
            string value = tag.Value;
            bool trouve = false;
            foreach (string s in facets)
            {

                if (facets.Contains(tagname))
                {

                    switch (tagname)
                    {
                        case "fractiondigits":
                            XmlSchemaFractionDigitsFacet fa = new XmlSchemaFractionDigitsFacet();
                            fa.Value = value;
                            rest.Facets.Add(fa);
                            trouve = true;
                            break;
                        case "length":
                            XmlSchemaLengthFacet length = new XmlSchemaLengthFacet();
                            length.Value = value;
                            rest.Facets.Add(length);
                            trouve = true;
                            break;
                        case "maxexclusive":
                            XmlSchemaMaxExclusiveFacet maxexclusive = new XmlSchemaMaxExclusiveFacet();
                            maxexclusive.Value = value;
                            rest.Facets.Add(maxexclusive);
                            trouve = true;
                            break;
                        case "maxinclusive":
                            XmlSchemaMaxInclusiveFacet maxinclusive = new XmlSchemaMaxInclusiveFacet();
                            maxinclusive.Value = value;
                            rest.Facets.Add(maxinclusive);
                            trouve = true;
                            break;
                        case "maxlength":
                            XmlSchemaMaxLengthFacet maxlength = new XmlSchemaMaxLengthFacet();
                            maxlength.Value = value;
                            rest.Facets.Add(maxlength);
                            trouve = true;
                            break;
                        case "minexclusive":
                            XmlSchemaMinExclusiveFacet minexclusive = new XmlSchemaMinExclusiveFacet();
                            minexclusive.Value = value;
                            rest.Facets.Add(minexclusive);
                            trouve = true;
                            break;
                        case "mininclusive":
                            XmlSchemaMinInclusiveFacet mininclusive = new XmlSchemaMinInclusiveFacet();
                            mininclusive.Value = value;
                            rest.Facets.Add(mininclusive);
                            trouve = true;
                            break;
                        case "minlength":
                            XmlSchemaMinLengthFacet minlength = new XmlSchemaMinLengthFacet();
                            minlength.Value = value;
                            rest.Facets.Add(minlength);
                            trouve = true;
                            break;
                        case "pattern":
                            XmlSchemaPatternFacet pattern = new XmlSchemaPatternFacet();
                            pattern.Value = value;
                            rest.Facets.Add(pattern);
                            trouve = true;
                            break;
                        case "totaldigits":
                            XmlSchemaTotalDigitsFacet totaldigits = new XmlSchemaTotalDigitsFacet();
                            totaldigits.Value = value;
                            rest.Facets.Add(totaldigits);
                            trouve = true;
                            break;
                        case "whitespace":
                            XmlSchemaWhiteSpaceFacet whitespace = new XmlSchemaWhiteSpaceFacet();
                            whitespace.Value = value;
                            rest.Facets.Add(whitespace);
                            trouve = true;
                            break;
                        case "enumeration":
                            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
                            enumeration.Value = value;
                            rest.Facets.Add(enumeration);
                            trouve = true;
                            break;
                        default:
                            break;
                    }
                    if (trouve) break;
                }
            }
        }
        //-----------------------------------------------------------

        static void AddFacetEnumeration(XmlSchemaSimpleTypeRestriction rest, EA.Attribute co)
        {
            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
            enumeration.Value = co.Name;
            rest.Facets.Add(enumeration);
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            enumeration.Annotation = ann;

            if (co.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(co.Notes));
            }

        }
        //-----------------------------------------------------------

        static void AddFacetCodeListEnumeration(XmlSchemaSimpleTypeRestriction rest, EA.Attribute at)
        {
            XmlSchemaEnumerationFacet enumeration = new XmlSchemaEnumerationFacet();
            // enumeration.Value = at.Style;
            enumeration.Value = at.Default;
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            enumeration.Annotation = ann;
            AddDocCat(ann, "enumValue", "", at.Name, "");
            rest.Facets.Add(enumeration);
        }
        //----------------------------------------------------------------------------


        //----------------------------------------------------------------------------------------
        public static void transChoiceUnionConnector(EA.Element el, XmlSchemaSequence sequence, List<EA.Connector> cons)
        {
            string conids = "";
            foreach (EA.Connector co in cons)
            {
                conids = conids + " ConID=" + (co.ConnectorID).ToString() + "|";
            }
            //MessageBox.Show(" elementName=" + el.Name + "|" + conids);

            bool atraiter = true;
            bool cardinalite = true;
            bool pointesur = false;
            XmlSchemaChoice choice = new XmlSchemaChoice();

            foreach (EA.Connector con in cons)
            {

                if (con.Type == "Association" ||
                          con.Type == "Aggregation")
                {

                    EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
                    EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                    EA.ConnectorEnd source = con.ClientEnd;
                    EA.ConnectorEnd target = con.SupplierEnd;
                    Connexion conex = new Connexion(con);
                    //  MessageBox.Show("elem=" + el.Name + " se= " + source_element.Name + " te= " + target_element.Name );
                    bool isAggregatesource = false;
                    bool isAggregatetarget = false;

                    if (con.Type == "Aggregation" || source.Aggregation == 1)
                    {
                        isAggregatesource = true;
                    }
                    if (con.Type == "Aggregation" || target.Aggregation == 1) // achtoung doute
                    {
                        isAggregatetarget = true;
                    }


                    // we decide to treat only the otherend with a role name
                    if (((source_element.ElementID == el.ElementID)
                               && ((target.Containment == "Reference") || (target.Role != "")))
                             ||
                            ((target_element.ElementID == el.ElementID)
                               && ((source.Containment == "Reference") || (source.Role != ""))))
                    {
                        if (atraiter)
                        {
                            // sequence.Items.Add(cxtype);
                            sequence.Items.Add(choice);

                            atraiter = false;
                        }
                    }


                    if (source_element.ElementID == el.ElementID)
                    {
                        if (cardinalite)  // the first time we must put choice's cardinality
                        {
                            string[] occur = getEndCardinality(target);
                            string[] vide = { "0", "0" };

                            if (!occur.Equals(vide))
                            {
                                choice.MinOccursString = occur[0];
                                choice.MaxOccursString = occur[1];
                            }
                            cardinalite = false;
                        }
                        string rolname = "";
                        if ((target.Role != "") && !isAggregatetarget)
                        {
                            rolname = ChgtNom(con, target_element, target);
                        }
                        if (target.Containment == "Reference")
                        {
                            //AddElementRefChoice(choice, getMrid(el), source_element, target);
                            //AddElementRefChoiceUnion(choice, getMrid(el), conex, "target",ref  pointesur);
                            AddElementRefChoiceUnion(choice, rolname, conex, "target", ref  pointesur);
                        }
                        else
                        {

                            if ((target.Role != "") && !isAggregatetarget)
                            {
                                //string rolname = target.Role;
                                //string rolname = ChgtNom(con, target_element, target);


                                //AddElementChoice(choice, rolname, target_element.Name, source_element, target);
                                AddElementChoiceUnion(choice, rolname, conex, "target", ref pointesur);
                            }
                        }
                    }
                    if (target_element.ElementID == el.ElementID)
                    {
                        if (cardinalite)  // the first time we must put choice's cardinality
                        {
                            string[] occur = getEndCardinality(source);
                            string[] vide = { "0", "0" };

                            if (!occur.Equals(vide))
                            {
                                choice.MinOccursString = occur[0];
                                choice.MaxOccursString = occur[1];
                            }
                            cardinalite = false;
                        }
                        string rolname = "";
                        if ((source.Role != "") && !isAggregatesource)
                        {
                            // string rolname = source.Role;
                            rolname = ChgtNom(con, source_element, source);
                        }
                        if (source.Containment == "Reference")
                        {
                            rolname = ChgtNom(con, source_element, source);
                            //AddElementRefChoice(choice, getMrid(el), target_element, source);
                            // AddElementRefChoiceUnion(choice, getMrid(el), conex, "source",ref pointesur);
                            AddElementRefChoiceUnion(choice, rolname, conex, "source", ref pointesur);
                        }
                        else
                        {
                            if ((source.Role != "") && !isAggregatesource)
                            {
                                // string rolname = source.Role;
                                rolname = ChgtNom(con, source_element, source);



                                //AddElementChoice(choice, rolname, source_element.Name, target_element, source);
                                AddElementChoiceUnion(choice, rolname, conex, "source", ref pointesur);

                            }
                        }
                    }
                }
            }



        }
        //-----------------------------------------------------------------------------------------
        //----------------------------------------------------------------------------------------
        public static void transChoiceConnector(EA.Element el, XmlSchemaSequence sequence, List<EA.Connector> cons)
        {
            string conids = "";
            string prov = el.Name;
            foreach (EA.Connector co in cons)
            {
                conids = conids + " ConID=" + (co.ConnectorID).ToString() + "|";
            }
            //MessageBox.Show(" elementName=" + el.Name + "|" + conids);

            bool atraiter = true;

            XmlSchemaChoice choice = new XmlSchemaChoice();

            foreach (EA.Connector con in cons)
            {

                if (con.Type == "Association" ||
                          con.Type == "Aggregation")
                {

                    EA.Element source_element = Main.Repo.GetElementByID((int)con.ClientID);
                    EA.Element target_element = Main.Repo.GetElementByID((int)con.SupplierID);
                    EA.ConnectorEnd source = con.ClientEnd;
                    EA.ConnectorEnd target = con.SupplierEnd;
                    Connexion conex = new Connexion(con);
                    //  MessageBox.Show("elem=" + el.Name + " se= " + source_element.Name + " te= " + target_element.Name );
                    bool isAggregatesource = false;
                    bool isAggregatetarget = false;

                    if (con.Type == "Aggregation" || source.Aggregation == 1)
                    {
                        isAggregatesource = true;
                    }
                    if (con.Type == "Aggregation" || target.Aggregation == 1) // achtoung doute
                    {
                        isAggregatetarget = true;
                    }
                   
                
                    
                    // we decide to treat only the otherend with a role name
                        if (((source_element.ElementID == el.ElementID)
                               && ((target.Containment == "Reference") || (target.Role != "")))
                             ||
                            ((target_element.ElementID == el.ElementID)
                               && ((source.Containment == "Reference") || (source.Role != ""))))
                    {
                        if (atraiter)
                        {
                            // sequence.Items.Add(cxtype);
                            sequence.Items.Add(choice);

                            atraiter = false;
                        }
                    }


                    if (source_element.ElementID == el.ElementID)
                    {

                        if (target.Containment == "Reference")
                        {
                            //AddElementRefChoice(choice, getMrid(el), source_element, target);
                            AddElementRefChoice(choice, getMrid(el), conex, "target");

                        }
                        else
                        {

                            if ((target.Role != "") && !isAggregatetarget)
                            {
                                //string rolname = target.Role;
                                string rolname = ChgtNom(con, target_element, target);


                                //AddElementChoice(choice, rolname, target_element.Name, source_element, target);
                                AddElementChoice(choice, rolname, conex, "target");
                            }
                        }
                    }
                    if (target_element.ElementID == el.ElementID)
                    {

                        if (source.Containment == "Reference")
                        {

                            //AddElementRefChoice(choice, getMrid(el), target_element, source);
                            AddElementRefChoice(choice, getMrid(el), conex, "source");
                        }
                        else
                        {
                            if ((source.Role != "") && !isAggregatesource)
                            {
                                // string rolname = source.Role;
                                string rolname = ChgtNom(con, source_element, source);



                                //AddElementChoice(choice, rolname, source_element.Name, target_element, source);
                                AddElementChoice(choice, rolname, conex, "source");

                            }
                        }
                    }
                }
            }



        }
        //-----------------------------------------------------------------------------------------


        //------
        //-----------------------------------------------------------------------------------------
        /// <summary>
        /// ajout d'un element association a une classe (complexetype)
        /// </summary>
        /// <param name="sequence"></param>   la sequence des elements du schema represeantaant la classe
        /// <param name="name"></param> le nom de l'element (role de l'otherend
        /// <param name="conex"></param> la connexion refletee par l'element
        /// <param name="typend"></param> type extrimite du role (target ou source)
        static void AddElement(XmlSchemaSequence sequence, string name, Connexion conex, string typend)
        {

            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                sequence.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                EA.Element otherelementend = null;
                EA.ConnectorEnd end = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }


                if (IsInline(otherelementend))
                { // element inline
                    if (!dicInline.ContainsKey(otherelementend.ElementID))
                    { //the member is inline
                        dicInline.Add(otherelementend.ElementID, otherelementend);
                    }
                    XmlSchemaObject sobj = TraitElem(otherelementend, Repos.GetPackageByID(otherelementend.PackageID), schema);
                    if (sobj != null)
                    {
                        string xmltyp = sobj.GetType().ToString();
                        switch (xmltyp)
                        {
                            case "System.Xml.Schema.XmlSchemaComplexType":
                                nel.SchemaType = (XmlSchemaComplexType)sobj;
                                break;
                            case "System.Xml.Schema.XmlSchemaSimpleType":
                                nel.SchemaType = (XmlSchemaSimpleType)sobj;
                                break;
                            default:
                                break;
                        }
                    }
                }
                else
                {
                    // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                    nel.SchemaTypeName = new XmlQualifiedName(otherelementend.Name, profparameters.TargetNamespace);
                }

                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                if (cardinalite == "1") cardinalite = "1..1"; 
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if ((split.Length != 1) && (split.Length != 3))
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    //18 // reportlog.Flush();
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }

                //AddAnnForAssociationEnd(otherelement, nel, end, false);
                AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelementend);

            }
            catch (Exception e)
            {
                MessageBox.Show("3-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while adding an element " + name + " to a squence {0} ", e.Message);
                // reportlog.Flush();
                return;
            }
        }


        //--------------------------

        //
        static void AddElementRef(XmlSchemaSequence sequence, string reff, Connexion conex, string typend)
        {
            EA.Element otherelement = null;
            EA.ConnectorEnd end = null;
            EA.Element element = null;
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();

                if (typend == "target")
                {
                    element = conex.Source_element;
                    otherelement = conex.Target_element;
                    end = conex.Target;
                }
                else
                {
                    element = conex.Target_element;
                    otherelement = conex.Source_element;
                    end = conex.Source;
                }

                sequence.Items.Add(nel);

                nel.Name = end.Role;
                // string atrtype = type;
                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                if (cardinalite == "1") cardinalite = "1..1";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }

                // AddAnnForAssociationEnd(elementend, nel, end, false);
                AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelement);

                XmlSchemaComplexType complexType = new XmlSchemaComplexType();
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;



                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;

                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);
            }
            catch (Exception e)
            {
                MessageBox.Show("4-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }
        //------------------------------------------------
        static void AddAnnTagForXmlAttribute(XmlSchemaAttribute attribute, EA.ConnectorEnd end, string tagname)
        {


            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            attribute.Annotation = ann;
            //==============    treatment of  tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                if (tag.Tag == tagname)
                {
                    AddSpecDocCat(ann, "TagValue", tag.Tag, tag.Value, "");
                    break;
                }

            }
        }
        //-----------------------------------------------------------------------------------------

        //-----------------------------------------------------------------------------------------
        static void AddElementChoice(XmlSchemaChoice choice, string name, Connexion conex, string typend)
        {
            EA.ConnectorEnd end = null;
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);
                nel.Name = name;
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }
                //string atrtype = elementend.Name;
                nel.SchemaTypeName = new XmlQualifiedName(otherelementend.Name, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                if (cardinalite == "1") cardinalite = "1..1";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }
                //AddAnnForAssociationEnd(elementend, nel, end, false);
                AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelementend);
            }
            catch (Exception e)
            {
                MessageBox.Show("5-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }


        //------------------------------------------------------------
        //--------------------------

        //--------------------------
        static void AddElementRefChoice(XmlSchemaChoice choice, string reff, Connexion conex, string typend)
        {
            EA.ConnectorEnd end = null;
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);

                nel.Name = end.Role;
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }

                // string atrtype = type;


                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                char[] arg = { '.' };
                string cardinalite = end.Cardinality;
                if (cardinalite == "") cardinalite = "0..*";
                if (cardinalite == "1") cardinalite = "1..1";
                string[] split = cardinalite.Split(arg);
                if (split[0] != "") nel.MinOccursString = split[0];
                if (split.Length != 3)
                {
                    MessageBox.Show("Error for " + nel.Name + " bad syntax of a cardinality");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error for " + nel.Name + " bad syntax of a cardinality");
                    return;
                }
                if (split.Length == 3)
                {
                    if (split[2] != "*")
                    {
                        nel.MaxOccursString = split[2];
                    }
                    else
                    {
                        nel.MaxOccursString = "unbounded";
                    }
                }
                else
                {
                    if (split[0] == "*")
                    { //very special case where there is only one digit cardinality
                        nel.MaxOccursString = "unbounded";
                    }
                    else
                    {
                        nel.MaxOccursString = "1";
                    }

                }
                // AddAnnForAssociationEnd(elementend, nel, end, false);
                AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelementend);
                XmlSchemaComplexType complexType = new XmlSchemaComplexType();
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;




                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;
                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);


            }
            catch (Exception e)
            {
                MessageBox.Show("6-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an reference choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }

        //-----------------------------------------------------------------------------------------

        static void AddAppInfoSawdsl(XmlSchemaAnnotation ann, string refstring, string abstrac)
        {

            XmlSchemaAppInfo ressource = new XmlSchemaAppInfo();
            ann.Items.Add(ressource);


            string bontexte = "<newattributes>"
                               + "<attribute name='modelReference'>"

                               + refstring

                               + "</attribute>";

            if (abstrac != "0")
            {
                bontexte = bontexte + "<attribute name='abstract'>"

                                    + "true"

                                    + "</attribute>";
            }

            bontexte = bontexte + "</newattributes>";
            bontexte = bontexte.Normalize();
            ressource.Markup = TextToNodeArray(bontexte);
        }

        /// <summary>
        /// add sawdsl to an annotation
        /// </summary>
        /// <param name="ann"></param>
        /// <param name="refstring"></param>
        static void AddAppInfoSawdsl(XmlSchemaAnnotation ann, string refstring)
        {

            XmlSchemaAppInfo ressource = new XmlSchemaAppInfo();
            ann.Items.Add(ressource);


            string bontexte = "<newattributes>"
                               + "<attribute name='modelReference'>"

                               + refstring

                               + "</attribute>"
                               + "</newattributes>";

            bontexte = bontexte.Normalize();
            ressource.Markup = TextToNodeArray(bontexte);
        }
        //-----------------------------------------------------------------------------------------


        static void AddDocCat(XmlSchemaAnnotation ann, string category, string subcategory, string value, string notes)
        {
            // <xs:documentation><m:category name='tagvalue'>toto</m:category></xs:documentation>
            //we introduce a filter for certain categories like tagvalues
            if (!CD.GetAnnCategoryOption()) { return; } // nothing to do if option is absent
            if (!profparameters.TagValuesToFiler.Contains(subcategory))
            {

                XmlSchemaDocumentation categorie = new XmlSchemaDocumentation();
                ann.Items.Add(categorie);

                string bontexte = "<newattributes>"
                                   + "<attribute name='category'>" + category + "</attribute>\n";
                if (subcategory != "")
                {
                    bontexte = bontexte + "<attribute name='subcategory'>" + subcategory + "</attribute>\n";
                }
                if (notes != "")
                {
                    bontexte = bontexte + "<attribute name='notes'>" + notes + "</attribute>\n";
                }
                bontexte = bontexte + "<attribute name='content'>" + value + "</attribute>\n"
                + "</newattributes>";
                bontexte = bontexte.Normalize();
                categorie.Markup = TextToNodeArray(bontexte);

            }
        }

        //--------------------------------------------------------
        /// <summary>
        /// action according to special names of subcategory
        /// </summary>
        /// <param name="ann"></param>
        /// <param name="category"></param>
        /// <param name="subcategory"></param>
        /// <param name="value"></param>
        /// <param name="notes"></param>
        static void AddSpecDocCat(XmlSchemaAnnotation ann, string category, string subcategory, string value, string notes)
        {
            // <xs:documentation><m:category name='tagvalue'>toto</m:category></xs:documentation>
            //we introduce a filter for certain categories like tagvalues
            if (!CD.GetAnnCategoryOption()) { return; } // nothing to do if option is absent
            if (profparameters.TagValuesToFiler.Contains(subcategory))
            {

                switch (subcategory)
                {
                    case XMLProfileParameters.Referencetypes:

                        subcategory = "";

                        XmlSchemaDocumentation categorie = new XmlSchemaDocumentation();
                        ann.Items.Add(categorie);

                        string bontexte = "<newattributes>"
                                           + "<attribute name='category'>" + XMLProfileParameters.Referencetypes + "</attribute>\n";
                        if (subcategory != "")
                        {
                            bontexte = bontexte + "<attribute name='subcategory'>" + subcategory + "</attribute>\n";
                        }
                        if (notes != "")
                        {
                            bontexte = bontexte + "<attribute name='notes'>" + notes + "</attribute>\n";
                        }
                        bontexte = bontexte + "<attribute name='content'>" + value + "</attribute>\n"
                        + "</newattributes>";
                        bontexte = bontexte.Normalize();
                        categorie.Markup = TextToNodeArray(bontexte);

                        break;
                    default:
                        break;
                }
            }
        }


        //------------------------------------------------------------------------------------------------------

        static string getMrid(EA.Element el)
        {
            string result = "";
            foreach (EA.Attribute at in el.Attributes)
            {
                if (at.Name == "mRID") result = at.Type;
            }
            return result;
        }

        //------------------------------------------------------------

        public static void Schemarecopie(XMLProfileParameters profparams)
        {

            //string toto = "prov";

            XmlDocument doc = new XmlDocument();
            try
            {


                // ABA20240116 TextReader FileReader = new StreamReader("XSDexample.xsd");
                // ABA20240303 TextReader FileReader = new StreamReader(FileManager.GetUserDirPath() + "\\XSDexample.xsd");
                TextReader FileReader = new StreamReader(Path.GetDirectoryName(profparams.CurrentXSDFilePath) + "\\XSDexample.xsd");
                doc.Load(FileReader);



                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xs", NS_XSD);
                nsmgr.AddNamespace(profparams.Prefix, profparams.TargetNamespace);
                nsmgr.AddNamespace("cimp", NS_CIMP);



                //on repere les partie <documentation
                XmlNodeList nodeList;


                nodeList = doc.SelectNodes("xs:schema//xs:documentation", nsmgr);

                foreach (XmlElement noeud in nodeList)
                {
                    string contenu = noeud.InnerText;
                    int mm = contenu.Length;
                    if (mm > 20) mm = 20;
                    RDFLAutilitaires.wtest("TEST", "xs:documentation  =" + contenu.Substring(0,mm));
                    /* ABA20230905
                    if(contenu.Substring(0,mm).Contains("was Switch"))
                            {
                        string prov = "";
                            }*/
                    //MessageBox.Show("type noeud= "+ noeud.NodeType);
                    // MessageBox.Show(contenu);
                    string contenudoc = null;
                    if (contenu.StartsWith("<"))
                    {
                        XmlDocument dd = new XmlDocument();
                        dd.LoadXml(contenu);
                        XmlNodeList nList;
                        nList = dd.SelectNodes("newattributes/attribute");
                        foreach (XmlNode nn in nList)
                        {
                            if (nn != null)
                            {
                                string contient = nn.InnerText;
                                XmlAttributeCollection atcol = nn.Attributes;
                                foreach (XmlNode at in atcol)
                                {

                                    //MessageBox.Show(" | " + "LocalName=" + at.LocalName + "|" + "value=" + at.Value + "|" + "contenu=" + contient);
                                    // on modifie le document d'origine en ajoutant un attribut qui n'est pas dans le namespace xs

                                    if (at.Value == "content")
                                    {
                                        contenudoc = contient;
                                    }
                                    else
                                    {
                                        XmlAttribute batr = doc.CreateAttribute(at.Value, NS_CIMP);
                                        //batr.Prefix = "m:";

                                        batr.Value = contient;
                                        noeud.SetAttributeNode(batr);

                                    }

                                }
                            }
                        }
                        noeud.InnerText = contenudoc;
                    }
                }

                //------------------------------------------------------------------------------
                nodeList = doc.SelectNodes("xs:schema//xs:appinfo", nsmgr);


                XmlElement noeudparent;
                XmlNode noeudGdparent;

                foreach (XmlElement noeud in nodeList)
                {

                    string contenu = noeud.InnerText;
                    int mm = contenu.Length;
                    if (mm > 20) mm = 20;
                    RDFLAutilitaires.wtest("TEST", "xs:appinfo  =" + contenu.Substring(0, mm));
                    //   MessageBox.Show("type noeud= "+ noeud.NodeType);
                    //   MessageBox.Show(contenu);
                    string contenudoc = null;
                    if (contenu.StartsWith("<"))
                    {
                        XmlDocument dd = new XmlDocument();
                        dd.LoadXml(contenu);
                        XmlNodeList nList;
                        nList = dd.SelectNodes("newattributes/attribute");
                        foreach (XmlNode nn in nList)
                        {
                            if (nn != null)
                            {
                                string contient = nn.InnerText;
                                XmlAttributeCollection atcol = nn.Attributes;
                                foreach (XmlNode at in atcol)
                                {

                                    // MessageBox.Show(" | " + "LocalName=" + at.LocalName + "|" + "value=" + at.Value + "|" + "contenu=" + contient);
                                    // on modifie le document d'origine en ajoutant un attribut qui n'est pas dans le namespace xs

                                    if (at.Value == "content")
                                    {
                                        contenudoc = contient;
                                    }
                                    else
                                    {
                                        XmlAttribute batr = doc.CreateAttribute(at.Value, NS_SAWSDL);
                                        //batr.Prefix = "sawsdl";
                                        batr.Value = contient;
                                        noeud.InnerText = contenudoc;
                                        noeudGdparent = (noeud.ParentNode).ParentNode;
                                        ((XmlElement)noeudGdparent).SetAttributeNode(batr);
                                    }
                                }
                            }
                        }

                        noeudparent = (XmlElement)noeud.ParentNode;
                        noeudGdparent = (noeud.ParentNode).ParentNode;
                        noeudparent.RemoveChild(noeud);
                        // we go up one level to see if there is any doc left and if not remove the annotation node
                        /*        
                    // XmlNodeList nnList = noeudGdparent.SelectNodes("xs:Annotation/xs:documentation", nsmgr);
                            string innercontenu=noeudparent.InnerText; 
                            if((innercontenu == "" ) 
                    */
                        /*
                          XmlElement nodeparent = (XmlElement)noeud.ParentNode; // we go up to the xs:annotation
                          if (nodeparent.InnerText == "")
                          { // if there are no other document in the annotation
                              XmlElement nodeGdparent = (XmlElement)(noeud.ParentNode).ParentNode;// then we go up to the above element
                              nodeGdparent.RemoveChild(nodeparent);// then we remove completly the annotation
                          }
   
                       */
                    }
                }
                //------------------- ajout septembre 2012  -----------------------------------------------------------

                nodeList = doc.SelectNodes("xs:schema//xs:annotation", nsmgr);

                foreach (XmlElement noeud in nodeList)
                {
                    XmlNode parent;
                    string contenu = noeud.InnerText;
                    int mm = contenu.Length;
                    if (mm > 20) mm = 20;
                    RDFLAutilitaires.wtest("TEST", "xs:annotation  =" + contenu.Substring(0, mm));
                    if (contenu == "")
                    {
                        parent = noeud.ParentNode;

                        parent.RemoveChild(noeud);
                    }
                }

                //----------------------------------------------------------------------------

                //TextWriter FileWriter = new StreamWriter(profparams.CurrentXSDFilePath);
                TextWriter FileWriter = new StreamWriter(XMLP.GetXmlValueProfData("CurrentXSDFilePath"));
                XmlTextWriter writer = new XmlTextWriter(FileWriter);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Flush();
                writer.Close();
                FileReader.Close();
                FileReader.Dispose();
                try
                {
                    //   MessageBox.Show(" for test no delete of " + path);
                    // System.IO.File.Delete(path);
                    //********** ajout octobre 2014  **********************//
                    if (Wg == "wg14")
                    {
                        OrdonXsd(profparams.CurrentXSDFilePath, nsmgr);
                    }
                    //*****************************************************//

                }
                catch (Exception e)
                {
                    MessageBox.Show("30-CIMSchemagenerator Error : " + e.Message);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  file {0} access", nomfic);
                    // reportlog.Flush();
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("7-CIMSchemagenerator Error : " + e.Message + "\n" + e.ToString());
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while creating final file from  intermediate file {0} ", e.Message);
                // reportlog.Flush();
            }




        }
        //  -----------------------------------------
        static void AddAnnForCtx(EA.Element el, XmlSchemaComplexType ct, bool origin)
        {



            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            ct.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            /* am mai 2017
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             * */
            reff = getReff(el, origin);
            //string reference = profparameters.RootModelURI + reff[0] + "#" + RDFutilitaires.getElementOriginBasedonElement(el).Name;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                    //reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + ((EA.Element)reff[1]).Name;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    }
                                            
                    else
                    {
                   //     reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                    reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name;
                    }
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }

            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }
            }

        }
        //--------------------------------------------------------------
        static void AddAnnForStx(EA.Element el, XmlSchemaSimpleType st, bool origin)
        {
            /* ABA20230905
            if(el.Name=="Float")
            {
                string prov = "";
            }*/

            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            st.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            /* am mai 2017
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             * */
            reff = getReff(el, origin);
            // string basedonel = RDFutilitaires.getElementBasedonElement;
            // string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    }
                    else
                    {
                   //     reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                        reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name;
                    }
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype stt in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", stt.Name, RDFutilitaires.RemoveRc(stt.Notes));

                }
            }

        }

        //--------------------------------------------------------------
        static void AddAnnForStxBase(EA.Element el, XmlSchemaSimpleType st)
        {

            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            st.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            //am mai 2017 reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            reff = getReff(el, false);
            //  string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    }
                    else
                   {
                  //      reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                       reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name;
                    }
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            /*
              //<xs:documentation>[the class notes]</xs:documentation>
                         if (el.Notes != "")
                         {
                             XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                             ann.Items.Add(notes);
                             notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                         }
            */

        }


        //-----------------------------------------------------------
        static void AddAnnForAtr(EA.Element el, XmlSchemaElement elt, EA.Attribute atr, bool origin)
        {



            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            elt.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>

            ArrayList reff;
            
            /*
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el, atr);

            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);

            }
             * */
            reff = getReff(el, origin);//
            // string basedonel = RDFutilitaires.getElementBasedonElement;

            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + elt.Name;
            string reference = "";
            //EA.Attribute at = RDFutilitaires.getAttributeOriginBasedOnAttribute(atr, Repos)
           // EA.Attribute at = RDFutilitaires.getAttributeOriginBasedOnAttribute(atr, Repos)
            EA.Attribute at = Repos.GetAttributeByGuid(RDFutilitaires.getAttrOriginBasedOnAttribute(atr.AttributeGUID, Repos));
            EA.Element elbase = (EA.Element)Repos.GetElementByID((int)atr.ParentID);
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                   // reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + elt.Name;
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + elbase.Name + "." + at.Name; 
                   break;
                case "wg19byref":
                   reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + at.Name;
                   break;
                default:
                   if (profparameters.XSDByRef == "Checked")
                   {
                       reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + at.Name;
                   }
                   else
                   {
                       //reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + at.Name;
                       reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name + "." + at.Name;
                   }
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (atr.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(atr.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.AttributeTag tag in atr.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.AttributeConstraint aconstrt in atr.Constraints)
            {
                AddDocCat(ann, "Constrtraint", aconstrt.Name, aconstrt.Type, RDFutilitaires.RemoveRc(aconstrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = atr.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }
            }
        }
        //-----------------------------------------------------------
        //-----------------------------------------------------------
        static void AddAnnForAtr(EA.Element el, XmlSchemaElement elt, EA.Attribute atr)
        {
            /* ABA20230905
            if (atr.Name == "isImportant")
            {
                string prov = "";
            }*/
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            elt.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>


            // string basedonel = RDFutilitaires.getElementBasedonElement;

            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + elt.Name;
            string reference = "";
           // EA.Attribute at = RDFutilitaires.getAttributeBasedOnAttribute(atr, Repos);
            //EA.Attribute at = RDFutilitaires.getAttributeOriginBasedOnAttribute(atr, Repos);
            EA.Attribute at=null;  //am oct 2013
           
                 at = Repos.GetAttributeByGuid(RDFutilitaires.getAttrOriginBasedOnAttribute(atr.AttributeGUID, Repos));
            if(at==null) 
            {
            
                string kk="\t ERROR in adding annotation to attribute " + el.Name + "." +  atr.Name;
                kk=kk+ " the ascendant chain of isbasedon attributes was found broken  (model issue), the sawsdl is not positionned";
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(kk);
                return;
            }
            
            EA.Element elbase = Repos.GetElementByID((int)at.ParentID);
            ArrayList reff = getReff(elbase, false);// am mai 2017
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    //reference = profparameters.RootModelURI.TrimEnd('#') + RDFutilitaires.GetPackageContainmentPath(elbase) + "#" + elbase.Name + "." + elt.Name;
                    //reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + elbase.Name + "." + elt.Name;
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + elbase.Name + "." + at.Name;
                    break;
                case "wg19byref":
                   // ArrayList reff = getReff(elbase, false);// am mai 2017
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + at.Name;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {

                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + at.Name;
                    }
                    else
                    {
                       // reference = profparameters.RootModelURI.TrimEnd('#') + RDFutilitaires.GetPackageContainmentPath(elbase) + "#" + elbase.Name + "." + elt.Name;
                        reference = ((string)reff[0]).TrimEnd('#') + "/" + elbase.Name + "." + elt.Name;
                    }
       
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (atr.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(atr.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.AttributeTag tag in atr.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.AttributeConstraint aconstrt in atr.Constraints)
            {
                AddDocCat(ann, "Constrtraint", aconstrt.Name, aconstrt.Type, RDFutilitaires.RemoveRc(aconstrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = atr.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }
            }
        }
        //-----------------------------------------------------------
        //  -----------------------------------------
        static void AddAnnForClass(EA.Element el, XmlSchemaComplexType ct, bool origin)
        {


            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            ct.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff = null;
            /*
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             * */
            reff = getReff(el, origin);
            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    //reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    }
                    else
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name;
                       // reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                    }
                    break;
            }

            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (el.Notes != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
            }
            //==============    treatment of tagvalues

            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Name, tag.Value, RDFutilitaires.RemoveRc(tag.Notes));

            }
            //==============    treatment of constraintss

            foreach (EA.Constraint constrt in el.Constraints)
            {
                AddDocCat(ann, "Constraint", constrt.Name, constrt.Type, RDFutilitaires.RemoveRc(constrt.Notes));

            }
            //==============    treatment of stereotypes
            List<EA.Stereotype> stereos = new List<EA.Stereotype>();
            string stereonames = el.StereotypeEx;
            if (stereonames != "")
            {
                string[] split = stereonames.Split(new char[] { ',' });
                for (int i = 0; i < split.Length; i++)
                {
                    if (RDFutilitaires.dicstereobyname.ContainsKey(split[i]))
                    {
                        stereos.Add(RDFutilitaires.dicstereobyname[split[i]]);
                    }
                    else
                    {
                        MessageBox.Show("Error " + split[i] + "seems to be pure texte and not a UML EA stereotype");
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error " + split[i] + "seems to be pure texte and not a UML EA stereotype");
                    }
                }

                foreach (EA.Stereotype st in stereos)
                {
                    AddDocCat(ann, "Stereotype", "", st.Name, RDFutilitaires.RemoveRc(st.Notes));

                }

            }

        }

        //  -----------------------------------------
        static void AddAnnForAssociationEnd(EA.Element el, XmlSchemaElement nel, EA.ConnectorEnd end, bool origin)
        {


            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            nel.Annotation = ann;

            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            /* am mai 2017
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             * */
            reff = getReff(el, origin);
            string role = "";
            string[] split = { "" };
            char[] delimit = { '_' };
            if (end.Role != "") split = (end.Role).Split(delimit);
            if (split.Length == 1) { role = split[0]; } else { role = split[1]; };
            //  string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + role;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + role;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + role;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                       reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + role;
                    }
                    else
                    {
                        //reference = profparameters.RootModelURI + reff[0] + "#" + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + role;
                        reference = ((string)reff[0]).TrimEnd('#') + "/" + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + role;
                    }
                    
                    break;
            }

            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations)
            {
                return;
            }
            //<xs:documentation>[the class notes]</xs:documentation>
            if (end.RoleNote != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(end.RoleNote));
            }
            //==============    treatment of tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Tag, tag.Value, "");

            }

        }
        //  -----------------------------------------
        static void AddAnnForAssociationEnd(long conid, XmlSchemaElement nel, EA.ConnectorEnd end, EA.Element elementend)
        {
            /* ABA2030905
            if (elementend.Name == "TimeSeries")
          {
              string prov = "";
          }*/
            try{
            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            nel.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            EA.Connector con = Repos.GetConnectorByID((int)conid);
            string conguid = con.ConnectorGUID;
            //EA.Connector conorigin = Repos.GetConnectorByGuid(RDFutilitaires.getOriginBasedOnConnectorbyGUID(Repos, conguid));
                string conoriginguid=RDFutilitaires.getBasedOnConnectoryGUID(Repos, conguid);
               // MessageBox.Show(" association end=" + end.Role.ToString() + " elementend=" + elementend.Name + "guidorigin=" + conoriginguid);

            EA.Connector conorigin = Repos.GetConnectorByGuid(conoriginguid);
            EA.Element target_element = Repos.GetElementByID(conorigin.SupplierID);
            EA.Element source_element = Repos.GetElementByID(conorigin.ClientID);
            EA.Element el = null;
            string rolename = "";
            EA.Element elementendIBO = RDFutilitaires.getElementBasedonElement(elementend); // the element on wich the elementend is basedon
            List<long> motherslistid = new List<long>();
            RDFutilitaires.GetMothersClass(elementendIBO.ElementID, motherslistid);
            if (!motherslistid.Contains(elementendIBO.ElementID)) motherslistid.Add(elementendIBO.ElementID);
            if( // am juil 2017
                (motherslistid.Contains(conorigin.ClientID))
                && 
                (motherslistid.Contains(conorigin.SupplierID))
               )
            { // il s'agit d'un ca trs particulier ou l'association relie un objet avec son ancetre 
                // exemple: Asset et AssetContainer
                // dans ce cas on traite  directement  partir de l'assosiation mere
                if (target_element.ElementID == elementendIBO.ElementID)
                {
                  // dans ce cas l'element qui porte le role est le client d'origune
                    el = source_element;
                    rolename = conorigin.SupplierEnd.Role;
                }
                else
                {
                    el = target_element;// element origine dont l'end donne le role
                    rolename = conorigin.ClientEnd.Role;
                }
            }else{
            if (motherslistid.Contains(conorigin.ClientID))
            {
                el = target_element;// element origine dont l'end donne le role
                rolename = conorigin.ClientEnd.Role;
            }
            else
            {
                if (motherslistid.Contains(conorigin.SupplierID))
                {
                    el = source_element;// element origine dont l'end donne le role
                    rolename = conorigin.SupplierEnd.Role;
                }
                else
                {
                    MessageBox.Show("Probmem while adding an element elementend.Name =" + elementend.Name);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Probmem while adding an element elementend.Name =" + elementend.Name);
                  //18  // reportlog.Flush();
                }
            }
            }


            //reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);// ATTENTION pourquoi pas origin? am mai 2017
            reff = getReff(el, false); //am juin 17 pourquoi pas origin?

            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    //  reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + rolename;
                    break;
                case "wg19byref":
                    //reff = getReff(el, false);
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name +"." + rolename ;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                    }
                    else
                    {
                       // reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                        reference = ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name + "." + rolename;
                    }
                    break;
            }

            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (end.RoleNote != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(end.RoleNote));
            }
            //==============    treatment of tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                AddDocCat(ann, "{", tag.Tag, tag.Value, "");

            } 
        }catch(Exception e){
                    MessageBox.Show("ERROR  while adding an annotation to an AssociationEnd " + end.Role.ToString() + "|" + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
        }
        }
        //--------------------------------------------------------------------------------------------------
        //  -----------------------------------------
        static string getReferenceForAssociationEnd(long conid, EA.ConnectorEnd end, EA.Element elementend)
        {
            ArrayList reff;
            EA.Connector con = Repos.GetConnectorByID((int)conid);
            string conguid = con.ConnectorGUID;
            EA.Connector conorigin = Repos.GetConnectorByGuid(RDFutilitaires.getOriginBasedOnConnectorbyGUID(Repos, conguid));
            EA.Element target_element = Repos.GetElementByID(conorigin.SupplierID);
            EA.Element source_element = Repos.GetElementByID(conorigin.ClientID);
            EA.Element el = null;
            string rolename = "";
            EA.Element elementendIBO = RDFutilitaires.getElementBasedonElement(elementend); // the element on wich the elementend is basedon
            List<long> motherslistid = new List<long>();
            RDFutilitaires.GetMothersClass(elementendIBO.ElementID, motherslistid);
            if (!motherslistid.Contains(elementendIBO.ElementID)) motherslistid.Add(elementendIBO.ElementID);
            if (motherslistid.Contains(conorigin.ClientID))
            {
                el = target_element;// element origine dont l'end donne le role
                rolename = conorigin.ClientEnd.Role;
            }
            else
            {
                if (motherslistid.Contains(conorigin.SupplierID))
                {
                    el = source_element;// element origine dont l'end donne le role
                    rolename = conorigin.SupplierEnd.Role;
                }
                else
                {
                    MessageBox.Show("Probmem while adding an element elementend.Name =" + elementend.Name);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Probmem while adding an element elementend.Name =" + elementend.Name);
                    //18 // reportlog.Flush();
                }
            }


            reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);// attention voir pour pas origin ammai 2017


            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + rolename;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name;
                    break;
                default:
                    reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                    break;
            }

            return reference;
        }
        //-----------------------------------------------
        //  -----------------------------------------
        static void AddAnnForAssociationEnd(long conid, XmlSchemaChoice nel, EA.ConnectorEnd end, EA.Element elementend)
        {


            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            nel.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff;
            EA.Connector con = Repos.GetConnectorByID((int)conid);
            string conguid = con.ConnectorGUID;
            // EA.Connector conorigin = Repos.GetConnectorByGuid(RDFutilitaires.getOriginBasedOnConnectorbyGUID(Repos, conguid));
            EA.Connector conorigin = Repos.GetConnectorByGuid(RDFutilitaires.getBasedOnConnectoryGUID(Repos, conguid));
            EA.Element target_element = Repos.GetElementByID(conorigin.SupplierID);
            EA.Element source_element = Repos.GetElementByID(conorigin.ClientID);
            EA.Element el = null;
            string rolename = "";
            EA.Element elementendIBO = RDFutilitaires.getElementBasedonElement(elementend); // the element on wich the elementend is basedon
            List<long> motherslistid = new List<long>();
            RDFutilitaires.GetMothersClass(elementendIBO.ElementID, motherslistid);
            if (!motherslistid.Contains(elementendIBO.ElementID)) motherslistid.Add(elementendIBO.ElementID);
            if (motherslistid.Contains(conorigin.ClientID))
            {
                el = target_element;// element origine dont l'end donne le role
                rolename = conorigin.ClientEnd.Role;
            }
            else
            {
                if (motherslistid.Contains(conorigin.SupplierID))
                {
                    el = source_element;// element origine dont l'end donne le role
                    rolename = conorigin.SupplierEnd.Role;
                }
                else
                {
                    MessageBox.Show("Probmem while adding an element elementend.Name =" + elementend.Name);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Probmem while adding an element elementend.Name =" + elementend.Name);
                }
            }





            //   string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
            string reference = "";
            // am mai 2016reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            reff = getReff(el, false);//ATTENTION se poser la question pourquoi manque origin
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name + "." + rolename;
                    break;
                case "wg19byref":
                    reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                    break;
                default:
                    if (profparameters.XSDByRef == "Checked")
                    {
                        reference = ((string)reff[0]).TrimEnd('#') + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                    }
                    else
                    {
                        //reference = profparameters.RootModelURI.TrimEnd('#') + reff[0] + "#" + ((EA.Element)reff[1]).Name + "." + rolename;
                        reference =  ((string)reff[0]).TrimEnd('#') + "/" + ((EA.Element)reff[1]).Name + "." + rolename;
                    }
                    break;
            }

            AddAppInfoSawdsl(ann, reference);
            if ((Wg == "wg16") && !profparameters.WithAnnotations) return;
            //<xs:documentation>[the class notes]</xs:documentation>
            if (end.RoleNote != "")
            {
                XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                ann.Items.Add(notes);
                notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(end.RoleNote));
            }
            //==============    treatment of tagvalues

            foreach (EA.RoleTag tag in end.TaggedValues)
            {
                AddDocCat(ann, "TagValue", tag.Tag, tag.Value, "");

            }

        }
        //-----------------------------------------------
        static public void AddDataType(EA.Attribute at, EA.Package apackage, XmlSchema schem)
        {
            long classifierid = at.ClassifierID;
            if ((classifierid != 0)) //18 && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);

                string classtereos = classifier.StereotypeEx;

                if ((classtereos != "") && (!classtereos.Contains(CD.GetPrimitiveStereotype())))
                {
                    if (!datatypetraite.Contains(classifierid))
                    {
                        CreateDatatypIfNeeded(classifierid, apackage, schem);
                        // TraitElem(classifier,apackage,schem);
                    }
                }
            }
        }


        //--------------------------------------------------------------------------------------------------
        static public void initDicSamerolesbyname(EA.Element el)
        {
            //++++
            // treatment of the connectors
            EA.Collection connectors = el.Connectors;
            foreach (EA.Connector con in connectors)
            {
                // we consider only the other end
                if (con.Type == "Association" ||
                            con.Type == "Aggregation")
                {
                    Connexion conex = new Connexion(con);

                    // we decide to treat only the otherend with a role name

                    if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                    {
                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Target.Role))
                            {  // 
                                dicsamerolesbyname[conex.Target.Role].Add(con.SupplierID);

                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Target.Role, new List<long>() { con.SupplierID });
                            }
                        }
                    }
                    if (conex.Target_element.ElementID == el.ElementID)  //the otherend is source
                    {
                        if ((conex.Source.Role != "") && conex.SourceAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Source.Role))
                            {  // 
                                dicsamerolesbyname[conex.Source.Role].Add(con.ClientID);
                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Source.Role, new List<long>() { con.ClientID });
                            }
                        }
                    }
                }
            }

            // ++++
            //treatment of the inherited connections
            if (inheritedconex.ContainsKey(el.ElementID))
            {
                List<Connexion> conexes = inheritedconex[el.ElementID];
                foreach (Connexion conex in conexes)
                {
                    // we consider only the other end
                    EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);
                    // we decide to treat only the otherend with a role name

                    if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                    {
                        if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Target.Role))
                            {  // 
                                dicsamerolesbyname[conex.Target.Role].Add(con.SupplierID);

                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Target.Role, new List<long>() { con.SupplierID });
                            }
                        }
                    }
                    if (conex.Target_element.ElementID == el.ElementID)  //the otherend is source
                    {
                        if ((conex.Source.Role != "") && conex.SourceAggregation == 0)
                        {
                            if (dicsamerolesbyname.ContainsKey(conex.Source.Role))
                            {  // 
                                dicsamerolesbyname[conex.Source.Role].Add(con.ClientID);
                            }
                            else
                            {
                                dicsamerolesbyname.Add(conex.Source.Role, new List<long>() { con.ClientID });
                            }
                        }
                    }
                }
            }
            Dictionary<string, List<long>>.KeyCollection names = dicsamerolesbyname.Keys;
            List<string> toberemoved = new List<string>();
            foreach (string key in names)
            {
                if (dicsamerolesbyname[key].Count < 2)
                    toberemoved.Add(key);
            }
            foreach (string key in toberemoved)
            {
                dicsamerolesbyname.Remove(key);
            }

        }


        //--------------------------------------------------------------------------------------------------

        static bool IsRoleNotUnique(string role)
        {  //decide si ce nom de role est unique pour un element donne
            bool ret = false;
            if (dicsamerolesbyname.Count == 0) return ret;
            if (!dicsamerolesbyname.ContainsKey(role)) return ret;
            ret = true;
            return ret;
        }
        //--------------------------------------------------------------------------------------------------
        static ArrayList IsRoleClass(string role, string guid)
        {  //decide si ce nom de role doit etre le nom de la classe associe

            ArrayList ret = new ArrayList();
            ret.Add(false);
            ret.Add("");
            string guidorg = RDFutilitaires.getOriginBasedOnConnectorbyGUID(Repos, guid); // find the original association
            if (guidorg == "") return ret;
            EA.Connector conorg = Repos.GetConnectorByGuid(guidorg);
            EA.ConnectorEnd source = conorg.ClientEnd;
            EA.ConnectorEnd target = conorg.SupplierEnd;
            EA.Element source_element = Main.Repo.GetElementByID((int)conorg.ClientID);
            EA.Element target_element = Main.Repo.GetElementByID((int)conorg.SupplierID);
            string roledebase = RDFutilitaires.RemoveQual(role);// nom de role debarrase d'un eventuel qualificatif
            string rolesing = roledebase;
            //bool plural = false;
            if (Wg == "wg14")
            {
                // dans le cas du wg14 les roles sont mis au pluriel
                //et provoque des changements  de nom indus
                // dans ce cas on enleve le s
                if (IsPlural(roledebase))
                {
                    string texte = "ATTENTION the role: " + roledebase + " has bin removed from its last 's' to put it in singular";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);

                    rolesing = roledebase.TrimEnd('s');

                }
            }

            if (rolesing == source_element.Name)
            {
                if (Wg == "wg14")
                {
                    ret[1] = roledebase;
                }
                ret[0] = true;
            }
            else
            {
                if (rolesing == target_element.Name)
                {
                    if (Wg == "wg14")
                    {
                        ret[1] = roledebase;
                    }
                    ret[0] = true;

                }
            }
            return ret;
        }
        //----------------
        static void setAtrTypeName(XmlSchemaAttribute sat, EA.Attribute eat, EA.Package apackage, XmlSchema schem)
        {
            // Be careful: we presuppose here that eat  has a type based on string and there is no control of tha fact
            string atrtype = eat.Type;
            long classifierid = eat.ClassifierID;
            if ((classifierid != 0)) //18  && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);

                string classtereos = "";

                classtereos = classifier.StereotypeEx;

                if ((classtereos != "") && (classtereos.Contains(CD.GetPrimitiveStereotype())))
                {
                    sat.SchemaTypeName = new XmlQualifiedName(classifier.Name.ToLower(), NS_XSD);
                }
                else
                {
                    if (!IsInline(classifier))
                    {

                      
                        
                       if ((Wg == "wg16") && ((eat.Name == "unit") || (eat.Name == "multiplier")))
                        {
                            if (profparameters.import)
                            {
                                sat.SchemaTypeName = new XmlQualifiedName(atrtype, XMLP.GetXmlValueProfData("URICodelist"));
                            }
                            else
                            {
                                sat.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                                CreateDatatypIfNeeded(classifierid, apackage, schem);// am septembre 2015
                            }
                        // createEnumCodelistIfNeeded(classifierid, apackage,schem); // QUESTION en SUSPEND
                            
                        }
                        else
                        {
                            sat.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                           // if (!datatypetraite.Contains(classifierid))
                           // {
                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                            //}
                        }
                    }
                    else
                    {
                        if (!dicInline.ContainsKey(classifier.ElementID)) dicInline.Add(classifier.ElementID, classifier);
                        XmlSchemaObject sobj = TraitElem(classifier, apackage, schem);
                        string xmltyp = sobj.GetType().ToString();
                        if (xmltyp != "System.Xml.Schema.XmlSchemaSimpleType")
                        {
                            sat.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                        }
                        else
                        {
                            sat.SchemaType = (XmlSchemaSimpleType)sobj;

                        }

                    }
                }
            }
            else
            {
                //in that case atrtype should be String or string for multiplier or unit
                if ((atrtype == "string") || (atrtype == CD.GetStringType()))
                {
                    sat.SchemaTypeName = new XmlQualifiedName(atrtype.ToLower(), NS_XSD);
                }
                else
                {
                    MessageBox.Show("Error!   multiplier or unit should be based on String");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  multiplier or unit should be based on String ");
                    return;
                }
            }
        }


        //-------------------------------------------------------------------------------------------------
      public  static void BuildMapforprimitivetypes(Dictionary<string, string> map)
        {

            map.Add(CD.GetIntegerType(), "integer");
            map.Add("integer", "integer");
            map.Add("float", "float");
            map.Add("Float", "float");
            map.Add(CD.GetBooleanType(), "boolean");
            map.Add("boolean", "boolean");
            map.Add(CD.GetStringType(), "string");
            map.Add("string", "string");
            map.Add("double", "double");
            map.Add("Double", "double");
            map.Add("Time", "time");
            map.Add("time", "time");
            map.Add("Date", "date");
            map.Add("date", "date");
            map.Add("DateTime", "dateTime");
            map.Add("dateTime", "dateTime");
            map.Add("Decimal", "decimal");
            map.Add("decimal", "decimal");
            map.Add("Duration", "duration");
            map.Add("duration", "duration");
            map.Add("normalizedString", "normalizedString");
            map.Add("token", "token");
            map.Add("NMTOKEN", "NMTOKEN");
            map.Add("Name", "Name");
            map.Add("NCName", "NCName");
            map.Add("anyURI", "anyURI");
            map.Add("AnyURI", "anyURI");
            map.Add("MonthDay", "gMonthDay"); // ajoute am fevrier 2014
            map.Add("ID", "ID");
            map.Add("IDREF", "IDREF");
            map.Add("Long", "long");
            map.Add("long", "long");
            map.Add("Int", "int");
            map.Add("int", "int");
            map.Add("Short", "short");
            map.Add("short", "short");
            map.Add("Byte", "byte");
            map.Add("byte", "byte");
            map.Add("UnsignedLong", "unsignedLong");
            map.Add("unsignedLong", "unsignedLong");
            map.Add("UnsignedInt", "unsignedInt");
            map.Add("unsignedInt", "unsignedInt");
            map.Add("UnsignedShort", "unsignedShort");
            map.Add("unsignedShort", "unsignedShort");
            map.Add("UnsignedByte", "unsignedByte");
            map.Add("unsignedByte", "unsignedByte");
            map.Add("HexBinary", "hexBinary");
            map.Add("Base64Binary", "base64Binary");
            map.Add("IRI", "anyURI");
            map.Add("StringIRI", "anyURI");
            map.Add("URL", "anyURI");
            map.Add("StringFixedLanguage", "string");
        }



        //------------------------------------------------------------------------------------
        static bool IsValuePrimitive(string v)
        {
            bool ret = false;
            if (mapforprimitivetypes.ContainsKey(v) || (v == CD.GetFloatType())) ret = true;
            return ret;
        }

        //--------------------------------------------------------------------------------

        public static void BuidInheritedConnexion(List<long> inheritedconids, Dictionary<long, List<Connexion>> inheritedconex
            , List<long> motherconids, List<EA.Element> Elemlist)
        {// build dictionnaries for inherited connexion
            // ACHTOUNG pour optimisation regarder si on ne peut pas tester le premier passage avec le  risque que les elements evoluent da,s le modle d'information.
            // for each abstract classes we populate the dictionnaries for concrete classes with the different inherited connexions
            //Ta tb = new Ta("BuidInheritedConnexion");
            List<EA.Element> abstractlist = new List<EA.Element>();
            ConexesWithUnion = new Dictionary<long, Connexion>();  // list ol all inherited connexion wich support a union
            List<long> dejatraite = new List<long>();
            foreach (EA.Element elt in Elemlist)
            {
                if ((elt.Abstract == "1") && (!abstractlist.Contains(elt)))
                {
                    abstractlist.Add(elt);
                }
            }

            foreach (EA.Element el in abstractlist)
            {
                // MessageBox.Show(" BuidInheritedConnexion  element: " + el.Name);// pour test
                if (!dejatraite.Contains(el.ElementID))
                {// if this element has previously not been treated
                    dejatraite.Add(el.ElementID);
                    bool union = false;
                    List<long> concretids = new List<long>(); // all the concrete classes for one abstract class
                    RDFutilitaires.GetConcreteDescendants(el, concretids);
                    List<long> otherendconcretids = null;
                    if (el.StereotypeEx.Contains(CD.GetUnionStereotype())) { union = true; };
                    foreach (EA.Connector con in el.Connectors)
                    {
                        if ((con.Type == "Association") || (con.Type == "Aggregation"))
                        { //eligible association
                            if (con.StereotypeEx.Contains(CD.GetUnionStereotype())) { union = true; };
                            Connexion conex = new Connexion(con);
                            if (!motherconids.Contains(conex.ConnectorID))
                            { // not yet registered connection
                                // look for the element at the other end
                                string typeotherend = TypeOtherEnd(el, conex); // source or target of the connexion
                                if(((typeotherend == "source") && (conex.TargetAggregation==1))
                                    ||
                                    ((typeotherend == "target") && (conex.SourceAggregation == 1))
                                    )// l'aggregatione  du cote de l'element abstrait
                                {
                                    continue; // dans ce conditions cette connexion n'est pas a retenir
                                }
                                motherconids.Add(conex.ConnectorID);
                                
                                EA.Element elotherend;
                                if ("source" == TypeOtherEnd(el, conex)) { elotherend = conex.Source_element; } else { elotherend = conex.Target_element; }
                                otherendconcretids = new List<long>();
                                RDFutilitaires.GetConcreteDescendants(elotherend, otherendconcretids);

                                // for each concrete classes on abstract elt  side we create a  connection if not yet registered
                                foreach (long classid in concretids)
                                {
                                    if (!inheritedconex.ContainsKey(classid))
                                    { // the inherited connnextion must be created from the abstractside
                                        inheritedconex.Add(classid, new List<Connexion>());
                                    }
                                    foreach (long otherclassid in otherendconcretids)
                                    {
                                        Connexion newconex = new Connexion(conex);
                                        typeotherend = TypeOtherEnd(el, conex);
                                        if (typeotherend == "source")
                                        {
                                           //18 newconex.Source_element = RDFutilitaires.dicelembyid[otherclassid];
                                           //18 newconex.Target_element = RDFutilitaires.dicelembyid[classid];
                                            newconex.Source_element = Main.Repo.GetElementByID((int)otherclassid);
                                            newconex.Target_element = Main.Repo.GetElementByID((int)classid);
                                        }
                                        else
                                        {
                                            newconex.Target_element = Main.Repo.GetElementByID((int)otherclassid);
                                            newconex.Source_element = Main.Repo.GetElementByID((int)classid);
                                        }


                                        inheritedconex[classid].Add(newconex);
                                        if ((union == true) && !(ConexesWithUnion.ContainsKey(newconex.ConexID)))
                                        {
                                            ConexesWithUnion.Add(newconex.ConexID, newconex);
                                        }

                                        if (!inheritedconex.ContainsKey(otherclassid))
                                        { // the inherited connnextion must be created from the abstractside
                                            inheritedconex.Add(otherclassid, new List<Connexion>());
                                        }
                                        inheritedconex[otherclassid].Add(newconex);

                                    }
                                    //	}
                                }// classid
                            }//motherconids
                        }//eligible

                    }//connectors
                }// dejatraite
            }// abstractlist
            //tb.stop();
        }


        //--------------------------------------------------------------------------------
        public static string TypeOtherEnd(EA.Element el, Connexion conex)
        { // which is   the other end type (source or target?)
            if ((conex.Source_element).ElementID == el.ElementID)
            {
                return "target";
            }
            else
            {
                return "source";
            }
        }
        //--------------------------------------------------------------------------------
        public static void dicconexDump(Dictionary<long, List<Connexion>> dicconex)
        {
            // if(Main.DO_REPORTLOG) reportlog.WriteLine("------------------- dum du dico des conex ------------------------\n");
            foreach (KeyValuePair<long, List<Connexion>> kv in dicconex)
            {
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("classid " + kv.Key.ToString() + "|" + Main.Repo.GetElementByID((int)kv.Key).Name + "\n");
                foreach (Connexion conex in kv.Value)
                {
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t| " + (kv.Value).Count + "|" + conex.ConexID.ToString() + "|" + (conex.Source_element).Name + "|" + ((conex.Target_element).Name) + "|\n");

                }
            }
        }
        //--------------------------------------------------------------------------------

        public static void transInheritedConnector(EA.Element el, XmlSchemaSequence sequence, Connexion conex)
        {

            EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);




            // we decide to treat only the otherend with a role name

            if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
            {
                if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                {
                    if (conex.Target.Containment == "Reference")
                    {

                        // AddElementRef(sequence, getMrid(el), conex.Source_element, conex.Target);
                        AddElementRef(sequence, getMrid(el), conex, "target");
                    }
                    else
                    {
                        // string rolname = conex.Target.Role;
                        string rolname = ChgtNom(con, conex.Target_element, conex.Target);

                        //AddElement(sequence, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);
                        AddElement(sequence, rolname, conex, "target");
                    }
                }
            }

            if (conex.Target_element.ElementID == el.ElementID)
            {
                if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                {

                    if ((conex.Source).Containment == "Reference")
                    {

                        //AddElementRef(sequence, getMrid(el), conex.Target_element, conex.Source);
                        AddElementRef(sequence, getMrid(el), conex, "source");
                    }
                    else
                    {

                        // string rolname = (conex.Source).Role;
                        string rolname = ChgtNom(con, conex.Source_element, conex.Source);

                        //  AddElement(sequence, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);
                        AddElement(sequence, rolname, conex, "source");
                    }
                }
            }

        }
        //---------------------------------------------------------------------------------------- 
        public static void transChoiceInheritedConnector(EA.Element el, XmlSchemaSequence sequence, List<Connexion> conexes)
        {
            if ((conexes == null) || (conexes.Count == 0)) return; // liste vide
            bool atraiter = true;
            XmlSchemaChoice choice = new XmlSchemaChoice();

            foreach (Connexion conex in conexes)
            {
                EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);


                // we decide to treat only the otherend with a role name

                // we decide to treat only the otherend with a role name
                if (((conex.Source_element.ElementID == el.ElementID)
                           && ((conex.Target.Containment == "Reference") || (conex.Target.Role != "")))
                         ||
                        ((conex.Target_element.ElementID == el.ElementID)
                           && ((conex.Source.Containment == "Reference") || (conex.Source.Role != ""))))
                {
                    if (atraiter)
                    {
                        // sequence.Items.Add(cxtype);
                        sequence.Items.Add(choice);

                        atraiter = false;
                    }
                }

                if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                {
                    if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                    {
                        if (conex.Target.Containment == "Reference")
                        {

                            //AddElementRefChoice(choice, getMrid(el), conex.Source_element, conex.Target);
                            AddElementRefChoice(choice, getMrid(el), conex, "target");
                        }
                        else
                        {
                            //    string rolname = conex.Target.Role;
                            string rolname = ChgtNom(con, conex.Target_element, conex.Target);

                            // AddElementChoice(choice, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);
                            AddElementChoice(choice, rolname, conex, "target");
                        }
                    }
                }

                if (conex.Target_element.ElementID == el.ElementID)
                {
                    if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                    {

                        if ((conex.Source).Containment == "Reference")
                        {

                            //AddElementRefChoice(choice, getMrid(el), conex.Target_element, conex.Source);
                            AddElementRefChoice(choice, getMrid(el), conex, "source");
                        }
                        else
                        {

                            // string rolname = (conex.Source).Role;
                            string rolname = ChgtNom(con, conex.Source_element, conex.Source);

                            //AddElementChoice(choice, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);
                            AddElementChoice(choice, rolname, conex, "source");
                        }
                    }
                }

            }
        }

        //--------------------------------------------------------------------------------
        public static void buildLocalDatatypeNames(EA.Package apackage, List<string> datanamelist, List<long> dataidlist)
        {
            /*   // devenu inutile depuis qu'on a cree les datatype individuellement
            List<EA.Element> ellist = new List<EA.Element>();
            RDFutilitaires.getStereotypedElements(apackage, ellist, new List<string>()
                                      {
                                        "Datatype",  // compatibility
	                                CD.GetDatatypeStereotype(),
                                        CD.GetPrimitiveStereotype(),
	                                CD.GetCompoundStereotype(),
	                                CD.GetEnumStereotype(),
                                       });

            foreach (EA.Element el in ellist)
            {
                if (el.Name != null)
                {
                    datanamelist.Add(el.Name);
                    dataidlist.Add(el.ElementID);
                    //  MessageBox.Show(" datatype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }
             * */

        }
        //-------------------------------------------------------------------------------
        public static void buildLocalClassNames(EA.Package apackage, List<string> classnamelist)
        {
            List<EA.Element> ellist = new List<EA.Element>();
            RDFutilitaires.getTypedElements(apackage, ellist, "Class");
            foreach (EA.Element el in ellist)
            {
                if ((el.Name != null)&&(el.Name != ""))
                {
                    classnamelist.Add(el.Name);

                    //  MessageBox.Show(" classtype name= " + el.Name + " id= " + el.ElementID + " classifiername= " + el.ClassifierName + " classifierid = " + el.ClassifierID);
                }
            }

        }
        //--------------------------------------------------------------------------------

        /*
        static XmlSchemaObject  CreateFloatSimpleTypeIfNeeded(long classifierid, EA.Package apackage, XmlSchema schem)
        {
              XmlSchemaObject ret=null;
              if (el.Name == CD.GetFloatType())
            { // in the case ther is locally defined "Float"
                if (!LocalDatatypeNames.Contains(CD.GetFloatType())) LocalDatatypeNames.Add(CD.GetFloatType());
                XmlSchemaSimpleType flottant = new XmlSchemaSimpleType();
                flottant.Name = CD.GetFloatType();
                //   schem.Items.Add(flottant); //220311
                ret = flottant;
                XmlSchemaSimpleTypeUnion union = new XmlSchemaSimpleTypeUnion();
                flottant.Content = union;
                XmlQualifiedName[] members = { new XmlQualifiedName("float", NS_XSD), new XmlQualifiedName("double", NS_XSD) };
                union.MemberTypes = members;
                XmlSchemaAnnotation flotanno = new XmlSchemaAnnotation();
                flottant.Annotation = flotanno; ;
                ArrayList reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
              //  string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
			switch(Wg){
                       case "wg14":
                       case "wg16":
                         reference = profparameters.RootModelURI  + RDFutilitaires.getElementOriginBasedonElement(el).Name;

			break;
                       default:
			 reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
			break;
			}
                AddAppInfoSawdsl(flotanno, reference);
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation flotdoc = new XmlSchemaDocumentation();
                    flotanno.Items.Add(flotdoc);
                    flotdoc.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }//float
        }
         * */
        static void CreateDatatypIfNeeded(long classifierid, EA.Package apackage, XmlSchema schem)
        {

            EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);
            XmlSchemaObject sobj = null;
            if (!datatypetraite.Contains(classifierid))
            {
                if (LocalDatatypeNames.Contains(classifier.Name))
                {
                    string texte = " le datattype " + classifier.Name + " existait deja, il n'a pas t recree localement";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                if (!LocalDatatypeNames.Contains(classifier.Name))
                {
                    sobj = TraitElem(classifier, apackage, schem);
                    if ((sobj != null) && (!IsInline(classifier)))
                    {
                        schem.Items.Add(sobj);
                    }
                    if (!LocalDatatypeNames.Contains(classifier.Name)) LocalDatatypeNames.Add(classifier.Name);  // am june 2011
                }
                else
                { // a similar name already exists in the package
                    if (!LocalDatatypeIDs.Contains(classifierid))
                    {
                        string texte = " WARNING: it seems that you used a type " + classifier.Name + " which was already been defined in the profile\n";
                        texte = texte + " the reference has been made to the already  defined local type";
                        //	MessageBox.Show(texte);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    }
                }
            }
        }

        //-------------------------------------------------------------------------------------------
        static bool IsMandatory(EA.Attribute at)
        {
            string lowerbound = at.LowerBound;
            if (lowerbound == "0")
            {
                return false;
            }
            else
            {
                return true;
            }
        }
        //----------------------------------------------
        static bool IsInline(EA.Element el)
        {
            bool ret = false;
            if (el.StereotypeEx.Contains(CD.GetInlineStereotype()))
            {
                ret = true;
            }
            return ret;
        }
        //--------------------------------------------------------------------------------------------------
        static bool IsValidCimDatatype(string stereos)
        {
            bool ret = false;
            List<string> cimdatatypes = new List<string>() { CD.GetPrimitiveStereotype(), "Datatype", CD.GetDatatypeStereotype(), CD.GetCompoundStereotype(), CD.GetEnumStereotype() };
            if (stereos != "")
            {
                char[] sep = { ',' };
                string[] split = stereos.Split(sep);
                for (int i = 0; i < split.Length; i++)
                    if (cimdatatypes.Contains(split[i]))
                    {
                        ret = true;
                        break;
                    }
            }
            return ret;
        }
        /// <summary>
        /// buid a sorted dictionary
        /// string, EA.Connector
        /// each key and cons are eligible roles
        /// for this Class
        /// </summary>
        /// <param name="el"></param>

        static void buildDicSortedCons(EA.Element el, SortedDictionary<string, EA.Connector> sortedcons)
        {
            EA.Collection col = el.Connectors;
            //string nomrole = "";
            ArrayList res;
            foreach (EA.Connector con in col)
            {
                res = RDFutilitaires.getOtherend(el, con);
                if ((EA.ConnectorEnd)res[0] != null)
                {
                    sortedcons.Add(((EA.ConnectorEnd)res[0]).Role, con);

                }
            }
        }

        //--------------------------------------------------------------------------------------------------
        /// <summary>
        /// This is a transitory method to get the version of the CIM package of an element 
        /// assuming that the profile is in the same package 
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        string GetVersionElement(EA.Element el)
        {
            string ret = "";
            return ret;
        }

        //------------------------ programmes pour union  -------------------------------------------------------------------
        //---------------------------------------------------------------------------------------- 
        public static void transUnionInheritedConnector(EA.Element el, XmlSchemaSequence sequence, List<Connexion> conexes)
        {
            if ((conexes == null) || (conexes.Count == 0)) return; // liste vide

            //string comguid = "";
            //string sens = "";

            XmlSchemaChoice choice = new XmlSchemaChoice();

            // there is at leat one  connexion
            // because it is an inherited connexion
            // We are going to Search  for the cardinality of the original connexion

            /*
            foreach (Connexion conex in conexes)
            { 
                if(comguid !=""){
                   comguid=Repos.GetConnectorByID((int)conex.ConnectorID).ConnectorGUID; // id de la classe union commune
                    EA.ConnectorEnd end=null;
                    EA.Element elementend=null;
                   if (conex.Target_element.ElementID == el.ElementID)
                   {
                       sens = "source";
                    end=conex.Source;
                    elementend=conex.Source_element;
                   }
                   else
                   {
                       sens = "target";
                      end=conex.Source;
                    elementend=conex.Source_element;
                   }
               //    AddAnnForAssociationEnd(conex.ConnectorID, choice, end, elementend);
               }
                if (comguid != Repos.GetConnectorByID((int)conex.ConnectorID).ConnectorGUID)
                {
                    MessageBox.Show("An association marked <<union>> from" + el.Name + " is not based on the same association");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("An association marked <<union>> from" + el.Name + " is not based on the same association");
                    return;
                }
              
            }

*/


            string prov = el.Name; // pour test

            bool atraiter = true;
            bool cardinalite = true;
            foreach (Connexion conex in conexes)
            {
                EA.Connector con = Repos.GetConnectorByID((int)conex.ConnectorID);


                // we decide to treat only the otherend with a role name

                // we decide to treat only the otherend with a role name
                if (((conex.Source_element.ElementID == el.ElementID)
                           && ((conex.Target.Containment == "Reference") || ((conex.Target.Role != "") && (conex.TargetAggregation == 0))))
                         ||
                        ((conex.Target_element.ElementID == el.ElementID)
                           && ((conex.Source.Containment == "Reference") || ((conex.Source.Role != "") && (conex.SourceAggregation == 0)))))
                {
                    if (atraiter)
                    {

                        // sequence.Items.Add(cxtype);

                        sequence.Items.Add(choice);
                        string but;
                        if (conex.Source_element.ElementID == el.ElementID)
                        {
                            but = "target";
                        }
                        else
                        {
                            but = "source";
                        }
                        AddSawsdlChoiceUnion(choice, conex, but);

                        atraiter = false;
                    }
                }

                if (conex.Source_element.ElementID == el.ElementID)  // the otherend is target
                {
                    if ((conex.Target.Role != "") && conex.TargetAggregation == 0)
                    {



                        //string rolname = conex.Target.Role;
                        string rolname = ChgtNom(con, conex.Target_element, conex.Target);


                        if (cardinalite)  // the first time we must put choice's cardinality
                        {
                            string[] occur = getEndCardinality(conex.Target);
                            string[] vide = { "0", "0" };

                            if (!occur.Equals(vide))
                            {
                                choice.MinOccursString = occur[0];
                                choice.MaxOccursString = occur[1];
                            }
                            cardinalite = false;
                        }
                        if (conex.Target.Containment == "Reference")
                        {

                            // AddElementRefUnion(choice, rolname, conex.Source_element, conex.Target);
                            AddElementRefUnion(choice, rolname, conex, "target");


                        }
                        else
                        {

                            //AddElementUnion(choice, rolname, conex.Target_element.Name, conex.Source_element, conex.Target);
                            AddElementUnion(choice, rolname, conex, "target");


                        }
                    }
                }

                if (conex.Target_element.ElementID == el.ElementID)
                {
                    if (((conex.Source).Role != "") && conex.SourceAggregation == 0)
                    {
                        //  string rolname = (conex.Source).Role;
                        string rolname = ChgtNom(con, conex.Source_element, conex.Source);


                        if (cardinalite)  // the first time we must put choice's cardinality
                        {
                            string[] occur = getEndCardinality(conex.Source);
                            string[] vide = { "0", "0" };

                            if (!occur.Equals(vide))
                            {
                                choice.MinOccursString = occur[0];
                                choice.MaxOccursString = occur[1];
                            }
                            cardinalite = false;
                        }

                        if ((conex.Source).Containment == "Reference")
                        {

                            //AddElementRefUnion(choice, rolname, conex.Target_element, conex.Source);
                            AddElementRefUnion(choice, rolname, conex, "source");

                        }
                        else
                        {

                            //AddElementUnion(choice, rolname, conex.Source_element.Name, conex.Target_element, conex.Source);

                            AddElementUnion(choice, rolname, conex, "source");

                        }
                    }
                }

            }

        }
        //--------------------------------

        //--------------------------------

        static long getotherendid(EA.Element el, Connexion conex)
        {

            if (conex.Source_element.ElementID == el.ElementID) return conex.Target_element.ElementID;
            if (conex.Target_element.ElementID == el.ElementID) return conex.Source_element.ElementID;
            return 0;
        }
        //--------------------------------

        static void AddElementChoiceUnion(XmlSchemaChoice choice, string name, Connexion conex, string typend, ref bool withchoicesawsdl)
        {
            EA.ConnectorEnd end = null;
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }
                nel.SchemaTypeName = new XmlQualifiedName(otherelementend.Name, profparameters.TargetNamespace);
                if (!withchoicesawsdl)
                {
                    AddAnnForAssociationEnd(conex.ConnectorID, choice, end, otherelementend);
                    withchoicesawsdl = true;
                }
                XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
                nel.Annotation = ann;
                AddAppInfoSawdsl(ann, "");

            }
            catch (Exception e)
            {
                MessageBox.Show("5-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }
        //------------------------------------------------------------
        //--------------------------------

        static void AddElementUnion(XmlSchemaChoice choice, string name, Connexion conex, string typend)
        {
            EA.ConnectorEnd end = null;
            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);
                nel.Name = name;
                //string atrtype = elementend.Name;
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }
                nel.SchemaTypeName = new XmlQualifiedName(otherelementend.Name, profparameters.TargetNamespace);

                AddAnnForAssociationEnd(conex.ConnectorID, choice, end, otherelementend);


            }
            catch (Exception e)
            {
                MessageBox.Show("5-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }
        //-----------------------------------------------------------------------------------------

        //---------------------------------
        static string[] getEndCardinality(EA.ConnectorEnd end)
        {
            string[] ret = { "0", "0" };
            char[] arg = { '.' };
            string cardinalite = "";
            cardinalite = end.Cardinality;
            if (cardinalite == "") cardinalite = "0..*";
            string[] split = cardinalite.Split(arg);
            if (split[0] != "") ret[0] = split[0];
            if (split.Length != 3)
            {
                MessageBox.Show("Error  bad syntax of a cardinality");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error for  bad syntax of a cardinality");
                return ret;
            }
            if (split.Length == 3)
            {
                if (split[2] != "*")
                {
                    ret[1] = split[2];
                }
                else
                {
                    ret[1] = "unbounded";
                }
            }
            else
            {
                if (split[0] == "*")
                { //very special case where there is only one digit cardinality
                    ret[1] = "unbounded";
                }
                else
                {
                    ret[1] = "1";
                }
            }
            return ret;
        }
        //--------------------------------
        static void AddElementRefChoiceUnion(XmlSchemaChoice choice, string reff, Connexion conex, string typend, ref bool withchoicesawsdl)
        {
            EA.ConnectorEnd end = null;

            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);

                nel.Name = reff;
                // string atrtype = type;
                //  nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }

                //AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelementend);


                if (!withchoicesawsdl)
                {
                    AddAnnForAssociationEnd(conex.ConnectorID, choice, end, otherelementend);
                    withchoicesawsdl = true;
                }
                XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
                nel.Annotation = ann;
                AddAppInfoSawdsl(ann, "");


                XmlSchemaComplexType complexType = new XmlSchemaComplexType();

                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;
                AddAnnForCtx(otherelementend, complexType, true);
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;
                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);

            }
            catch (Exception e)
            {
                MessageBox.Show("6-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an reference choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }


        static void AddElementRefUnion(XmlSchemaChoice choice, string reff, Connexion conex, string typend)
        {
            EA.ConnectorEnd end = null;

            try
            {
                XmlSchemaElement nel = new XmlSchemaElement();
                choice.Items.Add(nel);

                nel.Name = reff;
                // string atrtype = type;
                // nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }

                AddAnnForAssociationEnd(conex.ConnectorID, nel, end, otherelementend);
                XmlSchemaComplexType complexType = new XmlSchemaComplexType();
                AddSwsdlForCtx(otherelementend, complexType, false);
                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute refattribute = new XmlSchemaAttribute();
                refattribute.Name = XMLProfileParameters.Referencetype;
                refattribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                refattribute.Use = XmlSchemaUse.Optional;
                complexType.Attributes.Add(refattribute);
                nel.SchemaType = complexType;

                // <xs:attribute name="" type=""/>
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                attribute.Name = "ref";
                attribute.SchemaTypeName = new XmlQualifiedName("string", NS_XSD);
                complexType.Attributes.Add(attribute);
                nel.SchemaType = complexType;
                AddAnnTagForXmlAttribute(attribute, end, XMLProfileParameters.Referencetypes);
            }
            catch (Exception e)
            {
                MessageBox.Show("6-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  while adding an annotation to an reference choice AssociationEnd {0} | {1}", end.Role);
                // reportlog.Flush();
            }
        }


        ///-----------------------------------------------------
        public static XmlSchemaObject traitValueSeule(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, XmlSchemaObject ret)
        {

            if ((Wg != "wg16") && !CD.GetImportCodeList())
            {// la value d'un datatype est forcement une primitive hors cas wg16
                return null;
            }

            string uricodelist = XMLP.GetXmlValueProfData("URICodelist");
            string valuetype = value.Type; ;
            // <xs:simpleType name="">
            XmlSchemaSimpleType simplistype = new XmlSchemaSimpleType();
            simplistype.Name = el.Name;
            XmlSchemaSimpleTypeRestriction simplisRestriction = new XmlSchemaSimpleTypeRestriction();
            if (profparameters.import == true)
            {
                if (profparameters.import == true)
                {
                    simplisRestriction.BaseTypeName = new XmlQualifiedName(value.Type, uricodelist);
                }
                else
                {
                    simplisRestriction.BaseTypeName = new XmlQualifiedName(value.Type, "");
                }
            }
            else
            {
                simplisRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);
            }

            simplistype.Content = simplisRestriction;
            // schem.Items.Add(simptype);  //220311
            ret = simplistype;
            // doc and annotations sawdsl
            AddAnnForStx(el, simplistype, false);
            return ret;

        }
        //----------------------------------------------
        public static XmlSchemaObject traitValueSeuleRestrainte(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, XmlSchemaObject ret)
        {


            // <xs:simpleType name="">
            XmlSchemaSimpleType simpptype = new XmlSchemaSimpleType();
            if (!IsInline(el)) simpptype.Name = el.Name;
            string valuetype = value.Type;
            EA.Collection contraintes = value.Constraints;
            EA.AttributeConstraint co;

            List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            List<AttributeTag> TagConstraints = new List<AttributeTag>();
            List<string> dejafacets = new List<string>();

            int nombre = value.Constraints.Count;
            int nombretag = 0;
            string precision = "";
            for (short i = 0; i < nombre; i++)
            {
                co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
                if (co.Type == "Invariant") InvConstraints.Add(co);
            }
            if (Wg == "wg16")
            {
                List<string> exclus = new List<string>() { CD.GetIBOTagValue(), CD.GetESMBusinessTermTag() };
                nombretag = 0;
                List<string> listefacets = CD.GetListeFacets();
                foreach (EA.AttributeTag atag in value.TaggedValues)
                {
                    if (listefacets.Contains(atag.Name.ToLower()))
                    {
                        TagConstraints.Add(atag);
                        nombretag++;
                    }

                }
            }
            //specific case of specific FACETS (not xml)
            if (valuetype == CD.GetFloatType() || valuetype == CD.GetStringType() || valuetype == CD.GetDateTimeType())
            {
                if (InvConstraints.Count > 0)
                { // we treat only precision constraint

                    switch (valuetype)
                    {
                        case "Float":
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice=simple"))
                                {
                                    precision = "simple"; valuetype = "float";
                                }
                                if (constr.Notes.Contains("choice=double"))
                                {
                                    precision = "double"; valuetype = "double";
                                }
                            }
                            break;
                        case "String":
                            valuetype = "string";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);
                                    break;
                                }
                            }
                            break;
                        //---------ajout am sept 2012 ------------------      break;

                        case "DateTime":
                            valuetype = "datetime";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Name.Contains("TruncationOrReduced"))
                                {
                                    precision = "";
                                    if (constr.Notes.Contains("choice="))
                                    {
                                        precision = getXmlType(constr);
                                        if (precision == "gYearMonthDayHourMinute")
                                        {
                                            //string pattern = GetDateTimePattern(precision); // ce fut une idee provisoire
                                            // d'introduire le pattern a ce niveau mais en fait on 
                                            // utilise une restriction pattern
                                            // il faut singer une contrainte OCL patern sur string avec le commentaire de la contrainte
                                            //  XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                                            //simppRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes["string"], NS_XSD);

                                            valuetype = "string"; // on force la restriction sur string
                                        }
                                        break;
                                    }
                                }
                            }
                            break;
                        //---------------------------------------------
                        default:
                            break;
                    }

                }
            }



            if ((valuetype != CD.GetFloatType()))
            {
                XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();

                if (!mapforprimitivetypes.ContainsKey(valuetype))
                {
                    // a primitive should be with the given list
                    MessageBox.Show("Error the type  " + valuetype + " for value \n" +
                        " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the type  " + valuetype + " for value \n" +
                    //" is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                    //RDFutilitaires.ongoing= false;
                    //return;

                }
                else
                {

                    simppRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);
                }



                //les facets

                if (OclConstraints.Count > 0)
                {

                    foreach (EA.AttributeConstraint constr in OclConstraints)
                    {

                        AddFacet(simppRestriction, constr);
                        if (!dejafacets.Contains(constr.Name.ToLower())) dejafacets.Add(constr.Name.ToLower());

                    }
                }
                if (Wg == "wg16")
                {// les contraintes peuvent etre  exprimees sous forme de tagvalues
                    if (nombretag > 0)
                    {
                        foreach (EA.AttributeTag atag in TagConstraints)
                        {
                            if (!dejafacets.Contains(atag.Name.ToLower()))
                            {
                                dejafacets.Add(atag.Name.ToLower());
                                AddFacet(simppRestriction, atag);
                            }
                        }
                    }
                }
                //---
                simpptype.Content = simppRestriction;
                // schem.Items.Add(simpptype);//220311
                ret = simpptype;
                // MessageBox.Show(el.Name + " contrainte");

            }
            else
            {
                MessageBox.Show("Error  in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t :::Error  a restriction can't be applied to a Float  without giving the precision");
                return ret;

            }
            // doc and annotations sawdsl
            AddAnnForStx(el, simpptype, false);
            return ret;
        }
        //--------------------------------------------------------------
        public static string getXmlType(EA.AttributeConstraint constr)
        {
            string ret = "";
            string notes = constr.Notes;

            if (!notes.Contains("choice=")) return ret; // retour immediat
            int index = notes.IndexOf("choice=");
            ret = notes.Substring(index + 7).TrimEnd(' ');
            return ret;
        }

        //----------------------------------------------
        public static XmlSchemaObject traitValueEtMultiwg16(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {
            /*****  test *****/
            string entree = " entree dans traitValueEtMultiResteintewg16 el=" + el.Name + " |value=" + value.Type + " |nb contraintes=" + value.Constraints.Count.ToString();
            MessageBox.Show(entree);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(entree);
            /* */
            //XMLParser xmlp = new XMLParser(repo);

            try
            {
                string prov = el.Name;
                string valuetype = value.Type;
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                //schem.Items.Add(ct); //220311
                ret = ct;
                ct.Name = el.Name;

                //XmlSchemaComplexContentExtension extensionvalue = new XmlSchemaComplexContentExtension();


                foreach (EA.Attribute atr in el.Attributes)
                {

                    if (atr.Name == "value") // l'attribut est value on pointe vers le codelist
                    {

                        // <xs:simpleType name="">
                        XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                        ct.Attributes.Add(attribute);
                        attribute.Name = "v";

                        if (!IsValuePrimitive(atr.Type))
                        {
                            string uricodelist = XMLP.GetXmlValueProfData("URICodelist");
                            valuetype = atr.Type; ;
                            // <xs:simpleType name="">


                            attribute = new XmlSchemaAttribute();
                            ct.Attributes.Add(attribute);
                            attribute.Name = "v";
                            if (profparameters.import == true)
                            {
                                attribute.SchemaTypeName = new XmlQualifiedName(value.Type, uricodelist);
                            }
                            else
                            {
                                attribute.SchemaTypeName = new XmlQualifiedName(value.Type, "");
                            }

                        }
                        else
                        {
                            attribute.SchemaTypeName = new XmlQualifiedName(value.Type, NS_XSD);

                        }
                    }
                    else
                    {// il s'agit d'un attribut supplementaire
                        AddDataType(atr, apackage, schem); // add a datatype to the profile if necessary
                        XmlSchemaAttribute elat = new XmlSchemaAttribute();
                        ct.Attributes.Add(elat);
                        elat.Name = atr.Name;
                        //elat.SchemaTypeName = new XmlQualifiedName(atr.Type, profparameters.TargetNamespace);
                        setAtrTypeName(elat, atr, apackage, schem);
                        if (atr.Default != "")
                        {
                            if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required;//  am september 2015
                            if (atr.IsConst)
                            {
                               // elat.Use = XmlSchemaUse.Required;
                                //if (IsMandatory(atr)) elat.FixedValue = atr.Default; 
                                elat.FixedValue = atr.Default;// am  september 2015
                                if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required; // am  september 2015
                            }
                            else
                            {
                                elat.DefaultValue = atr.Default;
                                if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required; // am  september 2015
                            }
                        }
                        else
                        {
                            if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required;
                        }

                    }

                }

                // doc 
                //<xs:documentation>[the class notes]</xs:documentation>
                // <xs:annotation>
                XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
                ct.Annotation = ann;
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                    ann.Items.Add(notes);
                    notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }

            catch (Exception e)
            {
                DialogResult r = MessageBox.Show("20- Error  " + e.Message, "Error", MessageBoxButtons.OKCancel);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  in treating a Datattype {0}", e.Message);
                // reportlog.Flush();
                if (r == DialogResult.Cancel) return ret;
            }
            return ret;
        }
        //--------------------------------------
        public static XmlSchemaObject traitValueEtMultiResteintewg16(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {
            /*****  test *****/
            string entree = " entree dans traitValueEtMultiResteintewg16 el=" + el.Name + " |value=" + value.Type + " |nb contraintes=" + value.Constraints.Count.ToString();
            MessageBox.Show(entree);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(entree);
            /* */
            //XMLParser xmlp = new XMLParser(repo);

            try
            {
                string prov = el.Name;
                if(el.Name=="Peps_ActivePower")
                {
                    prov = el.Name;
                }
                string valuetype = value.Type;
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                //schem.Items.Add(ct); //220311
                ret = ct;
                ct.Name = el.Name;

                //XmlSchemaComplexContentExtension extensionvalue = new XmlSchemaComplexContentExtension();


                foreach (EA.Attribute atr in el.Attributes)
                {

                    if (atr.Name == "value") // l'attribut est value 
                    {
                        EA.Collection contraintes = value.Constraints;
                        List<AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
                        List<AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
                        int nombre = value.Constraints.Count;
                        //string precision = "";
                        for (short i = 0; i < nombre; i++)
                        {
                            EA.AttributeConstraint co = (EA.AttributeConstraint)contraintes.GetAt(i);
                            if (co.Type == "OCL") OclConstraints.Add(co);
                            if (co.Type == "INV") InvConstraints.Add(co);
                            if (co.Type == "Invariant") InvConstraints.Add(co);

                        }
                        // <xs:simpleType name="">
                        XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                        ct.Attributes.Add(attribute);
                        // attribute.Name = "v";

                        if (!IsValuePrimitive(atr.Type))
                        {
                            string texte = "Error in treating datatype " + el.Name + " value has a non primitivevalue";
                            MessageBox.Show(texte);
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                        }
                        else
                        {
                            valuetype = mapforprimitivetypes[value.Type];
                            if (OclConstraints.Count == 0)
                            {
                                attribute.Name = "v";
                                attribute.SchemaTypeName = new XmlQualifiedName(valuetype, NS_XSD);
                            }
                            else
                            {

                                XmlSchemaSimpleType simptype = new XmlSchemaSimpleType();

                                XmlSchemaSimpleTypeRestriction simpRestriction = new XmlSchemaSimpleTypeRestriction();
                                // simpRestriction.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);

                                if (valuetype != "")
                                {
                                    simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);
                                    simptype.Content = simpRestriction;
                                    attribute.SchemaType = simptype;
                                    //attribute.RefName  = new XmlQualifiedName("v");
                                    attribute.Name = "v";
                                }
                                else
                                {
                                    MessageBox.Show("Error   in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t :::Error  in: {0},  a restriction can't be applied to a Float  without giving the precision", el.Name);
                                    return ret;
                                    // simpRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
                                    //attribute.SchemaTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);
                                }

                                foreach (EA.AttributeConstraint constr in OclConstraints)
                                {

                                    AddFacet(simpRestriction, constr);

                                }
                            }

                        }
                    }
                    else
                    {// il s'agit d'un attribut supplementaire
                        AddDataType(atr, apackage, schem); // add a datatype to the profile if necessary
                        XmlSchemaAttribute elat = new XmlSchemaAttribute();
                        ct.Attributes.Add(elat);
                        elat.Name = atr.Name;
                        //elat.SchemaTypeName = new XmlQualifiedName(atr.Type, profparameters.TargetNamespace);
                        setAtrTypeName(elat, atr, apackage, schem);
                        if (atr.Default != "")
                        {
                            if (atr.IsConst)
                            {
                               // elat.Use = XmlSchemaUse.Required;
                              //  if (IsMandatory(atr)) elat.FixedValue = atr.Default;
                                if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required;// am september 2015
                                elat.FixedValue = atr.Default;   //am september 2015
                            }
                            else
                            {
                                if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required;// am september 2015
                                elat.DefaultValue = atr.Default;
                            }
                        }
                        else
                        {
                            if (IsMandatory(atr)) elat.Use = XmlSchemaUse.Required;
                        }

                    }

                }

                // doc 
                //<xs:documentation>[the class notes]</xs:documentation>
                // <xs:annotation>
                XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
                ct.Annotation = ann;
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                    ann.Items.Add(notes);
                    notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }

            catch (Exception e)
            {
                DialogResult r = MessageBox.Show("20- Error  " + e.Message, "Error", MessageBoxButtons.OKCancel);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  in treating a Datattype {0}", e.Message);
                if (r == DialogResult.Cancel) return ret;
            }
            return ret;
        }
        //--------------------------------------



        public static XmlSchemaObject traitValueEtMulti(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {
            try
            {
                string prov = el.Name;
                /* ABA20230905
                if(el.Name=="ActivePower")
                {
                    int y = 1;
                }*/
                string valuetype = "";
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                //schem.Items.Add(ct); //220311
                ret = ct;
                if (!IsInline(el)) ct.Name = el.Name;
                // <xs:complexContent>
                //XmlSchemaComplexContent complexContent = new XmlSchemaComplexContent();// am 080911
                XmlSchemaSimpleContent complexContent = new XmlSchemaSimpleContent();
                ct.ContentModel = complexContent;

                // <xs:extension base="address">
                //XmlSchemaComplexContentExtension extensionvalue = new XmlSchemaComplexContentExtension();
                XmlSchemaSimpleContentExtension extensionvalue = new XmlSchemaSimpleContentExtension();
                complexContent.Content = extensionvalue;

                //   extensionvalue.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);
                valuetype = GetXSType(value);
                if (valuetype != "")
                {
                    if (valuetype == CD.GetFloatType())
                    { //Float is a special case

                        extensionvalue.BaseTypeName = new XmlQualifiedName(valuetype, profparameters.TargetNamespace);
                        if (!LocalDatatypeNames.Contains(valuetype))
                        {


                            EA.Element elfloat = Repos.GetElementByID((int)value.ClassifierID);
                            transPrimitive(elfloat, apackage, schem);
                            if (!LocalDatatypeNames.Contains(valuetype)) LocalDatatypeNames.Add(valuetype);

                        }

                    }
                    else
                    {

                        extensionvalue.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);

                    }
                }
                else
                {
                    extensionvalue.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
                }



                if (multiplier != null)
                {
                    //AddDataType(multiplier, apackage, schem); // add a datatype to the profile if necessary

                    XmlSchemaAttribute atr = new XmlSchemaAttribute();
                    extensionvalue.Attributes.Add(atr);

                    atr.Name = "multiplier";
                    //   atr.SchemaTypeName = new XmlQualifiedName(multiplier.Type, profparameters.TargetNamespace);
                    setAtrTypeName(atr, multiplier, apackage, schem);
                    if (multiplier.Default != "")
                    {
                        if (multiplier.IsConst)
                        {
                            if (IsMandatory(multiplier)) atr.Use = XmlSchemaUse.Required;
                            atr.FixedValue = multiplier.Default;
                           
                        }
                        else
                        {
                            if (IsMandatory(multiplier)) atr.Use = XmlSchemaUse.Required;//am september 2015
                            atr.DefaultValue = multiplier.Default;
                        }
                    }
                    else
                    {
                        if (IsMandatory(multiplier)) atr.Use = XmlSchemaUse.Required;
                    }
                }



                if (unit != null)
                {
                   //   AddDataType(unit, apackage, schem); // add a datatype to the profile if necessary
                    XmlSchemaAttribute at = new XmlSchemaAttribute();
                    at.Name = "unit";
                    //   at.SchemaTypeName = new XmlQualifiedName(unit.Type, profparameters.TargetNamespace);

                    setAtrTypeName(at, unit, apackage, schem);

                    if (unit.Default != "")
                    {
                        if (unit.IsConst)
                        {
                            if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                            at.FixedValue = unit.Default;
                        }
                        else
                        {
                            if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required; // am september 2015
                            at.DefaultValue = unit.Default;
                        }
                    }
                    else
                    {
                        if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                    }
                    extensionvalue.Attributes.Add(at);
                }
                XmlSchemaAttribute btt = new XmlSchemaAttribute();
                
                foreach (EA.Attribute atr in el.Attributes)
                {
                    
                    if ((atr.Name != "value") && (atr.Name != "unit") && (atr.Name != "multiplier"))
                    {

                        {// il s'agit d'un attribut supplementaire
                            bool vraiattribut = true; // il peut s'agir d'un attribut codelist importe uniquement pour wg16
                            if ((Wg == "wg16") || CD.GetImportCodeList())
                            {
                                long classifierid = atr.ClassifierID;
                                EA.Element classifier = null;
                                if (classifierid != 0)
                                {
                                    classifier = Repos.GetElementByID((int)classifierid);
                                }

                                // if (atr.Name == CD.GetCodingScheme()[0]) // l'attribut est "c on pointe vers le codelist
                                if ( ((classifierid == 0) || classifier.StereotypeEx.Contains(CD.GetEnumStereotype()) || (classifier.Type=="Enumeration")))
                                {
                                    vraiattribut = false;

                                    string uricodelist = XMLP.GetXmlValueProfData("URICodelist");
                                    // MessageBox.Show("URICodelist=" + uricodelist + "ImportCodeList=" + XMLP.GetXmlValueConfig("ImportCodeList"));// pour test am  nov 2011
                                    valuetype = atr.Type;//CD.GetCodingScheme()[1]; // import la code list
                                    // <xs:simpleType name="">
                                    btt.Name = atr.Name;
                                    if (profparameters.import == true)
                                    {
                                        btt.SchemaTypeName = new XmlQualifiedName(valuetype, uricodelist);
                                    }
                                    else
                                    {
                                        btt.SchemaTypeName = new XmlQualifiedName(valuetype, "");
                                    }
                                    if (atr.Default != "")
                                    {
                                        if (atr.IsConst)
                                        {
                                           // btt.Use = XmlSchemaUse.Required;
                                            //if (IsMandatory(atr)) btt.FixedValue = atr.Default;
                                            if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required; // am september 2015
                                            btt.FixedValue = atr.Default; // am september 2015
                                        }
                                        else
                                        {
                                            if (IsMandatory(unit)) btt.Use = XmlSchemaUse.Required; // am september 2015
                                            btt.DefaultValue = atr.Default;
                                        }
                                    }
                                    else
                                    {
                                        if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;
                                    }
                                    extensionvalue.Attributes.Add(btt);

                                }


                            }
                            // else
                            // {
                            if (vraiattribut)
                            {
                                AddDataType(atr, apackage, schem); // add a datatype to the profile if necessary
                                // XmlSchemaAttribute elat = new XmlSchemaAttribute();

                                btt.Name = atr.Name;
                                // valuetype = atr.Type;
                                // btt.SchemaTypeName = new XmlQualifiedName(valuetype, "");
                                //elat.SchemaTypeName = new XmlQualifiedName(atr.Type, profparameters.TargetNamespace);
                                setAtrTypeName(btt, atr, apackage, schem);
                                if (atr.Default != "")
                                {
                                    if (atr.IsConst)
                                    {
                                       // btt.Use = XmlSchemaUse.Required;
                                      //  if (IsMandatory(atr)) btt.FixedValue = atr.Default;
                                        if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required; // am september 2015
                                        btt.FixedValue = atr.Default; // am  september 2015
                                    }
                                    else
                                    {
                                        if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required; // am september 2015
                                        btt.DefaultValue = atr.Default;
                                    }
                                }
                                else
                                {
                                    if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;
                                }
                                extensionvalue.Attributes.Add(btt);
                                // }
                            }
                        }

                    }
                }
                //
                // doc and annotations sawdsl
                AddAnnForCtx(el, ct, false);
            }

            catch (Exception e)
            {
                DialogResult r = MessageBox.Show("20- Error  " + e.Message, "Error", MessageBoxButtons.OKCancel);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  in treating a Datattype {0}", e.Message);
                if (r == DialogResult.Cancel) return ret;
            }
            return ret;
        }
        //-----------------------------------------------------------
        public static XmlSchemaObject traitValueEtMultiRestreinte(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, EA.Attribute multiplier, EA.Attribute unit, XmlSchemaObject ret)
        {
            string prov = el.Name;
            if (prov == "Peps_ActivePower")
            {
                prov = el.Name;
                prov = value.Name;
                prov = value.Type;
            }
            EA.Collection contraintes = value.Constraints;
            List<AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            List<AttributeTag> TagConstraints = new List<AttributeTag>();

            int nombre = value.Constraints.Count;
            int nombretag = 0;
            //string precision = "";
            for (short i = 0; i < nombre; i++)
            {
                EA.AttributeConstraint co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
                if (co.Type == "Invariant") InvConstraints.Add(co);
            }
            if (Wg == "wg16")
            {
                List<string> exclus = new List<string>() { CD.GetIBOTagValue(), CD.GetESMBusinessTermTag() };
                nombretag = 0;
                List<string> listefacets = CD.GetListeFacets();
                foreach (EA.AttributeTag atag in value.TaggedValues)
                {
                    if (listefacets.Contains(atag.Name.ToLower()))
                    {
                        TagConstraints.Add(atag);
                        nombretag++;
                    }

                }
            }
            string valuetype = value.Type;

            // <xs:simpleType name="">
            XmlSchemaSimpleType simptype = new XmlSchemaSimpleType();
            simptype.Name = el.Name + "-base";
            XmlSchemaSimpleTypeRestriction simpRestriction = new XmlSchemaSimpleTypeRestriction();
            // simpRestriction.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);

            valuetype = GetXSType(value);
            if ((valuetype == "") && (value.Type == CD.GetStringType())) valuetype = value.Type;
            if (valuetype != "")
            {
                simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);

            }
            else
            {
                MessageBox.Show("Error   in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t :::Error  in: {0},  a restriction can't be applied to a Float  without giving the precision", el.Name);
                return ret;
                // simpRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
            }
            //---

            //les facets
            List<string> dejafacets = new List<string>();
            if (OclConstraints.Count > 0)
            {

                foreach (EA.AttributeConstraint constr in OclConstraints)
                {

                    AddFacet(simpRestriction, constr);
                    if (!dejafacets.Contains(constr.Name.ToLower())) dejafacets.Add(constr.Name.ToLower());
                }
            }
            if (Wg == "wg16")
            {// les contraintes peuvent etre  exprimees sous forme de tagvalues
                if (nombretag > 0)
                {
                    foreach (EA.AttributeTag atag in TagConstraints)
                    {
                        if (!dejafacets.Contains(atag.Name.ToLower()))
                        {
                            dejafacets.Add(atag.Name.ToLower());
                            AddFacet(simpRestriction, atag);
                        }
                    }
                }
            }
            //---
            simptype.Content = simpRestriction;
            //ret= simppptype;
            schem.Items.Add(simptype);
            // MessageBox.Show(el.Name + " contrainte");
            // doc and annotations sawdsl
            AddAnnForStxBase(el, simptype);





            //complextype
            XmlSchemaComplexType ctt = new XmlSchemaComplexType();
            //schem.Items.Add(ctt);
            ret = ctt;
            ctt.Name = el.Name;

            // <xs:complexContent>
            //XmlSchemaComplexContent complexContentt = new XmlSchemaComplexContent();// nov 2012
            XmlSchemaSimpleContent sct = new XmlSchemaSimpleContent();
           // ctt.ContentModel = complexContentt;
            ctt.ContentModel = sct;
            // <xs:extension base="address">
           // XmlSchemaComplexContentExtension extensionvaluee = new XmlSchemaComplexContentExtension();//nov 2012
            XmlSchemaSimpleContentExtension extensionvaluee = new XmlSchemaSimpleContentExtension();
            //complexContentt.Content = extensionvaluee;
            sct.Content = extensionvaluee;
            extensionvaluee.BaseTypeName = new XmlQualifiedName((el.Name + "-base"), profparameters.TargetNamespace);
          //ATTENTION la modification faite sur simple content suppose multiplier et unit null A COMPLETER
            if (multiplier != null)
            {
                //AddDataType(multiplier, apackage, schem); // add a datatype to the profile if necessary
                XmlSchemaAttribute att = new XmlSchemaAttribute();
                att.Name = "multiplier";
                //att.SchemaTypeName = new XmlQualifiedName(multiplier.Type, profparameters.TargetNamespace);
                setAtrTypeName(att, multiplier, apackage, schem);
                if (multiplier.Default != "")
                {
                    if (multiplier.IsConst)
                    {
                        if (IsMandatory(multiplier)) att.Use = XmlSchemaUse.Required;
                        att.FixedValue = multiplier.Default;
                    }
                    else
                    {
                        if (IsMandatory(multiplier)) att.Use = XmlSchemaUse.Required; //am september 2015
                        att.DefaultValue = multiplier.Default;
                    }
                }
                else
                {
                    if (IsMandatory(multiplier)) att.Use = XmlSchemaUse.Required;
                }

                extensionvaluee.Attributes.Add(att);
            }
            if (unit != null)
            {
               // AddDataType(unit, apackage, schem); // add a datatype to the profile if necessary
                XmlSchemaAttribute at = new XmlSchemaAttribute();
                at.Name = "unit";
                //  at.SchemaTypeName = new XmlQualifiedName(unit.Type, profparameters.TargetNamespace);
                setAtrTypeName(at, unit, apackage, schem);
                if (unit.Default != "")
                {
                    if (unit.IsConst)
                    {
                        if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                        at.FixedValue = unit.Default;
                    }
                    else
                    {
                        if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;// am september 2015
                        at.DefaultValue = unit.Default;
                    }
                }
                else
                {
                    if (IsMandatory(unit)) at.Use = XmlSchemaUse.Required;
                }


                extensionvaluee.Attributes.Add(at);
            }

            //MessageBox.Show(el.Name + " contrainte");
            //-----------------------------------------------------
            //XMLParser xmlp = new XMLParser(repo);
            //  if (xmlp.GetXmlValueConfig("ImportCodeList") == "Checked")





            XmlSchemaAttribute btt = new XmlSchemaAttribute();
            foreach (EA.Attribute atr in el.Attributes)
            {

                if ((atr.Name != "value") && (atr.Name != "unit") && (atr.Name != "multiplier"))
                {
                   
                    {// il s'agit d'un attribut supplementaire
                        bool vraiattribut = true; // il peut s'agir d'un attribut codelist importe uniquement pour wg16
                        if ((Wg == "wg16") || CD.GetImportCodeList())
                        {
                            long classifierid = atr.ClassifierID;
                            EA.Element classifier = null;
                            if (classifierid != 0)
                            {
                                classifier = Repos.GetElementByID((int)classifierid);
                            }

                            // if (atr.Name == CD.GetCodingScheme()[0]) // l'attribut est "c on pointe vers le codelist
                            if (((classifierid == 0) || classifier.StereotypeEx.Contains(CD.GetEnumStereotype()) || (classifier.Type=="Enumeration")))
                            {
                                vraiattribut = false;

                                string uricodelist = XMLP.GetXmlValueProfData("URICodelist");
                                // MessageBox.Show("URICodelist=" + uricodelist + "ImportCodeList=" + XMLP.GetXmlValueConfig("ImportCodeList"));// pour test am  nov 2011
                                valuetype = atr.Type;//CD.GetCodingScheme()[1]; // import la code list
                                // <xs:simpleType name="">
                                btt.Name = atr.Name;
                                if (profparameters.import == true)
                                {
                                    btt.SchemaTypeName = new XmlQualifiedName(valuetype, uricodelist);
                                }
                                else
                                {
                                    btt.SchemaTypeName = new XmlQualifiedName(valuetype, "");
                                }
                                if (atr.Default != "")
                                {
                                    if (atr.IsConst)
                                    {
                                       // btt.Use = XmlSchemaUse.Required;
                                       // if (IsMandatory(atr)) btt.FixedValue = atr.Default;
                                        if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required; //am september 2015
                                        btt.FixedValue = atr.Default;//am september 2015


                                    }
                                    else
                                    {
                                        if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required; //am september 2015
                                        btt.DefaultValue = atr.Default;
                                    }
                                }
                                else
                                {
                                    if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;
                                }
                                extensionvaluee.Attributes.Add(btt);

                            }
                           

                        }
                       // else
                       // {
                        if (vraiattribut)
                        {
                            AddDataType(atr, apackage, schem); // add a datatype to the profile if necessary
                           // XmlSchemaAttribute elat = new XmlSchemaAttribute();

                            btt.Name = atr.Name;
                           // valuetype = atr.Type;
                           // btt.SchemaTypeName = new XmlQualifiedName(valuetype, "");
                            //elat.SchemaTypeName = new XmlQualifiedName(atr.Type, profparameters.TargetNamespace);
                            setAtrTypeName(btt, atr, apackage, schem);
                            if (atr.Default != "")
                            {
                                if (atr.IsConst)
                                {
                                   // btt.Use = XmlSchemaUse.Required;
                                   // if (IsMandatory(atr)) btt.FixedValue = atr.Default;
                                    if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;// am september 2015
                                    btt.FixedValue = atr.Default; // am september 2015
                                }
                                else
                                {
                                    if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;// am september 2015
                                    btt.DefaultValue = atr.Default;
                                }
                            }
                            else
                            {
                                if (IsMandatory(atr)) btt.Use = XmlSchemaUse.Required;
                            }
                            extensionvaluee.Attributes.Add(btt);
                            // }
                        }
                    }

                }
            }
            //---------------------------------------------------

            // doc and annotations sawdsl
            AddAnnForCtx(el, ctt, false);
            return ret;
        }
        //------------------------------------------------------------
        public static XmlSchemaObject traitDatatype(EA.Package apackage, XmlSchema schem, EA.Element el, XmlSchemaObject ret)
        {
            // normal UML datatype
            try
            {
                if (el.Name == "Float")
                {
                    string prov = el.Name;
                }

                // <xs:complexType name="">
                XmlSchemaComplexType ctx = new XmlSchemaComplexType();
                // schem.Items.Add(ctx);  //220311
                ret = ctx;
                if (!IsInline(el)) ctx.Name = el.Name;
                //==============================================================================
                //documentation et  attribut sawsdl
                // <xs:annotation>
                AddAnnForClass(el, ctx, false);

                //============================================================
                // <xs:sequence> Attributes
                //==========================================================
                XmlSchemaSequence sequenc = new XmlSchemaSequence();
                ctx.Particle = sequenc;


                // <xs:element name=""   type=""/>
                foreach (EA.Attribute atr in el.Attributes)
                {
                    XmlSchemaElement nel = new XmlSchemaElement();
                    sequenc.Items.Add(nel);
                    nel.Name = atr.Name;
                    string atrtype = atr.Type;
                    long classifierid = atr.ClassifierID;
                    if ((classifierid != 0)) //18 && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
                    {
                        EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);

                        //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                        //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                        string classtereos = "";

                        classtereos = classifier.StereotypeEx;

                        if ((classtereos != "") && (classtereos.Contains(CD.GetPrimitiveStereotype())))
                        {
                            if (classifier.Name == CD.GetFloatType())
                            { //Float is a special case

                                nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);

                            }
                            else
                            {
                                nel.SchemaTypeName = new XmlQualifiedName(classifier.Name.ToLower(), NS_XSD);
                            }
                        }
                        else
                        {

                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            if (!datatypetraite.Contains(classifierid))
                            {
                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                                //	TraitElem(classifier,apackage,schem);
                            }
                        }
                        // if (atr.LowerBound == "0") nel.MinOccurs = 0;
                        nel.MinOccursString = atr.LowerBound;
                        nel.MaxOccursString = atr.UpperBound;
                        //AddAnnForAtr(el, nel, atr, true);
                        AddAnnForAtr(el, nel, atr);
                        /******** default or fixed values of the attribute ************************/
                        if (atr.Default != "")
                        {
                            if (atr.IsConst)
                            {
                                nel.FixedValue = atr.Default;
                            }
                            else
                            {
                                nel.DefaultValue = atr.Default;
                            }
                        }

                    }
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("9-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while treating a No CimDatatype {0} ", e.Message);
                // reportlog.Flush();
            }
            return ret;
        }
        /// <summary>
        /// type enumeration
        /// decrit dans un stereotype de
        /// CodeListValueType et qui prend comme valeur 
        /// les types xml valides
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        static string getCodeListValueType(EA.Element el)
        {
            string tagvalue = "string"; // the default value is always string
            foreach (EA.TaggedValue tag in el.TaggedValues)
            {
                if (tag.Name == XMLProfileParameters.CodeListValueType)
                {
                    tagvalue = tag.Value; ;
                    break;
                }
            }
            if ((tagvalue != "") && (!mapforprimitivetypes.ContainsValue(tagvalue)))
            {
                tagvalue = "string";
            }
            return tagvalue;
        }

        //------------------

        static string  GetConnexionName(ModelObject mobj)
        {
            EA.Connector con = Repos.GetConnectorByID((int)mobj.conex.ConnectorID);
            string ret = "";
            // we decide to treat only the otherend with a role name and if it is not abstract         

            if (mobj.conex.Source_element.ElementID == mobj.el.ElementID)  // the otherend is target
            {
                if ((mobj.conex.Target_element.Abstract == "1")
                    && mobj.conex.Target_element.StereotypeEx.Contains(CD.GetUnionStereotype())
                    )
                { // on ne definipas une association vers la classe abstraite dans le cas de l'union
                    return ret;
                }
                //if (mobj.conex.Target_element.Abstract == "0")
                // { //the other end class is concrete


                if ((mobj.conex.Target.Role != "") && ((mobj.conex.SourceAggregation == 1) || ((mobj.conex.Target).IsNavigable))) 
              
                {
                    // if (mobj.conex.Target_element.Abstract == "0")
                    // { //the other end class is concrete
                    if (Wg != "wg19byref")
                    {
                        if (mobj.conex.Target.Containment == "Reference")
                        {
                            // AddElementRef(sequence, getMrid(el), conex.Target_element, conex.Target);
                            ret = "T!" + "ref";
                        }
                        else
                        {

                            string rolname = mobj.conex.Target.Role;
                            if (IsRoleNotUnique(rolname))
                            {

                                rolname = ChgtNom(con, mobj.conex.Target_element, mobj.conex.Target);
                            }


                            //  AddElement(sequence, rolname, conex.Target_element.Name, conex.Target_element, conex.Target);
                            ret = "T!" + rolname;
                        }
                    }
                    else
                    {
                        if ((mobj.conex.Target).IsNavigable) // the only valid case is when one end is navigable without the aggregated end march 2017
                       { 
                        ret = "T!" + "ref";
                       }
                    }
                    
                }
            }
            if (mobj.conex.Target_element.ElementID == mobj.el.ElementID)
            {//the other end is a source

                if ((mobj.conex.Source_element.Abstract == "1")
                    && mobj.conex.Source_element.StereotypeEx.Contains(CD.GetUnionStereotype())
                    )
                { // on ne definipas une association vers la classe abstraite dans le cas de l'union
                    return ret;
                }

                // if (mobj.conex.Source_element.Abstract == "0")
                // { //the other end class is concrete


                if (((mobj.conex.Source).Role != "") && ((mobj.conex.TargetAggregation == 1) || ((mobj.conex.Source).IsNavigable))) 
                {

                    if(Wg!="wg19byref") 
                    {
                    if ((mobj.conex.Source).Containment == "Reference")
                    {


                        // AddElementRef(sequence, getMrid(el), conex.Source_element, conex.Source);
                        ret = "S!" + "ref";
                    }
                    else
                    {

                        string rolname = (mobj.conex.Source).Role;
                        if (IsRoleNotUnique(rolname))
                        {

                            rolname = ChgtNom(con, mobj.conex.Source_element, mobj.conex.Source);
                        }

                        // AddElement(sequence, rolname, mobj.conex.Source_element.Name, mobj.conex.Source_element, conex.Source);
                        ret = "S!" + rolname;
                    }
                    }else{
                        if((mobj.conex.Source).IsNavigable) // the only valid case is when one end is navigable without the aggregated end march 2017
                        {
                         ret = "S!" + "ref";
                        }
                    }

                }
            }
            return ret;
        }

        //--------------
        public static int CompareModelObjectbyKeyName(ModelObject x, ModelObject y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    string xname = x.keyname;
                    string yname = y.keyname;
                    string[] split = null;
                    string sensend=""; //il s'agit d'un EndAssociation target ou source
                    //EA.ConnectorEnd end = null;
                    if (x.type == "connexion")
                    {
                        if (x.keyname.Contains("!"))
                        {
                            split = x.keyname.Split('!');
                            xname = split[1];
                            if (xname == "ref") // cas d'une association par reference
                            {
                                sensend = split[0];
                                if (sensend == "T")
                                {// 
                                    xname = x.conex.Target.Role;
                                }
                                else
                                {
                                    xname = x.conex.Source.Role;
                                }
                            }
                        }
                    }
                    if (y.type == "connexion")
                    {
                        if (y.keyname.Contains("!"))
                        {
                            split = y.keyname.Split('!');
                            yname = split[1];
                            if (yname == "ref") // cas d'une association par reference
                            {
                                sensend = split[0];
                                if (sensend == "T")
                                {// 
                                    yname = y.conex.Target.Role;
                                }
                                else
                                {
                                    yname = y.conex.Source.Role;
                                }
                            }
                        }
                    }
                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }
        //--------------------
        public static int CompareAttributebyName(EA.Attribute x, EA.Attribute y)
        {

            if (x == null)
            {
                if (y == null)
                {
                    // If x is null and y is null, they're
                    // equal. 
                    return 0;
                }
                else
                {
                    // If x is null and y is not null, y
                    // is greater. 
                    return -1;
                }
            }
            else
            {
                // If x is not null...
                //
                if (y == null)
                // ...and y is null, x is greater.
                {
                    return 1;
                }
                else
                {



                    // sort them with ordinary string comparison.
                    //
                    string xname = x.Name;
                    string yname = y.Name;

                    int prov = xname.CompareTo(yname);
                    // MessageBox.Show("comppare mobjs by keyname "+ " xname=" + xname + " yname=" + yname + prov.ToString());
                    return xname.CompareTo(yname);

                }
            }
        }
        //-------------------------
        /// <summary>
        /// le type d'un attribut est un compound
        /// </summary>
        /// <param name="atr"></param>
        /// <returns></returns>
        static bool isTypeCompound(EA.Attribute atr)
        {
            bool ret = false;
            if (ObjectType.otAttribute != atr.ObjectType) return ret;

            if (atr.ClassifierID != 0)// il y a un classifier peut-etre compound
            {
                try
                {
                    if (Repos.GetElementByID((int)atr.ClassifierID).StereotypeEx.Contains(CD.GetCompoundStereotype()))
                    {
                        // eligible
                        ret = true;
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(" In IsTypeCompound , error geting classifier=" + atr.ClassifierID.ToString() + " " + e.Message);
                }
            }
            return ret;

        }
        //------------------------
        /// si un  datatype est form d'une valeur simple mais restreinte et que cette valeur porte une restriction
        ///  et une seule restriction speciale sur String ou Float , alors on donne directement le xs format,
        /// sinon on garde un simple type  de restriction comme d'habitude
        static string GetXSType(EA.Element cimdatatype)
        {
            if (!cimdatatype.StereotypeEx.Contains(CD.GetDatatypeStereotype()) && !cimdatatype.StereotypeEx.Contains("Datatype")) return "";
            // ce traitement n'a d'intrt que pour les classes de type datatype  une value , resteinte spciale dans le cas de Float ou de String
            string ret = ""; // ce n'est pas un nom de xstype  priori
            EA.Attribute value = null;
            if (cimdatatype.Attributes.Count != 1) return ret; // il faut une base de restriction
            value = (EA.Attribute)cimdatatype.Attributes.GetAt(0);
            if (value.Name != "value")
            {
                MessageBox.Show(" the classifier " + cimdatatype.Name + " has not an attribute named value");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" the classifier " + cimdatatype.Name + " has not an attribute named value");
                return ret;
            }
            string valuetype = value.Type;
            List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            int nombre = value.Constraints.Count;
            string precision = "";
            EA.AttributeConstraint co = null;
            EA.Collection contraintes = value.Constraints;
            for (short i = 0; i < nombre; i++)
            {
                co = (EA.AttributeConstraint)contraintes.GetAt(i);
                if (co.Type == "OCL") OclConstraints.Add(co);
                if (co.Type == "INV") InvConstraints.Add(co);
                if (co.Type == "Invariant") InvConstraints.Add(co);
            }
            if ((Wg == "wg16") && isTagConstrained(value)) return ret;
            if ((nombre == 0) && (valuetype == CD.GetFloatType())) return CD.GetFloatType(); // cas de Float
            if (nombre == 0)
            { // il n'y a pas de contraintes on peut donner le nom d'un type xs si possible
                //bool isprimitive = false;
                foreach (string ss in mapforprimitivetypes.Keys)
                {
                    if (ss == valuetype)
                    { // en fait il s'agit d'une primitive
                        //isprimitive = true; ABA20230905 meaningless!!
                        return valuetype;

                    }
                }
            }

            if (
                (
                    (valuetype == CD.GetFloatType())
                 || (valuetype ==CD.GetStringType())
                 || (valuetype == CD.GetIntegerType())
                 || (valuetype == CD.GetLongType())
                 || (valuetype == CD.GetIntType())
                 || (valuetype ==  CD.GetShortType())
                 || (valuetype == CD.GetUnsignedLongType())
                 || (valuetype == CD.GetUnsignedIntType())
                 || (valuetype == CD.GetUnsignedShortType())  
                )
                && 
                    (OclConstraints.Count == 0)
                )
            {
                if (InvConstraints.Count > 0)
                { // we treat only precision constraint

                    switch (valuetype)
                    {
                        case "Float":
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice=simple"))
                                {
                                    precision = "simple"; valuetype = "float";
                                }
                                if (constr.Notes.Contains("choice=double"))
                                {
                                    precision = "double"; valuetype = "double";
                                }
                            }
                            ret = valuetype;
                            break;
                        case "String":
                            valuetype = "string";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);

                                    break;
                                }
                            }
                            ret = valuetype;
                            break;

                        default:
                            valuetype = valuetype.ToLower();
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);

                                    break;
                                }
                            }
                            ret = valuetype;
                            break;
                    }

                }
            }


            return ret;

        }

        //------------------------
        /// si un  attribut value (en general d'un datatype  a une  valeur qui porte une restriction
        ///  et une seule restriction speciale sur String ou Float , alors on donne directement le xs format,
        /// sinon on garde un simple type  de restriction comme d'habitude
        static string GetXSType(EA.Attribute value)
        {
            string ret = "";
            if (value.Name != "value")
            {
                MessageBox.Show("treating an attribute value of a datatype but the  name is not value ");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("treating an attribute value of a datatype but the  name is not value ");
                return ret;
            }
            string valuetype = value.Type;
            List<EA.AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
            List<EA.AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
            int nombre = value.Constraints.Count;
            string precision = "";
            EA.AttributeConstraint co = null;
            EA.Collection contraintes = value.Constraints;
            if (nombre > 0)
            {
                for (short i = 0; i < nombre; i++)
                {
                    co = (EA.AttributeConstraint)contraintes.GetAt(i);
                    if (co.Type == "OCL") OclConstraints.Add(co);
                    if (co.Type == "INV") InvConstraints.Add(co);
                    if (co.Type == "Invariant") InvConstraints.Add(co);
                }
            }
            else
            {
                if ((Wg == "wg16") && isTagConstrained(value)) return ret;
            }

            if (nombre == 0)
            { // il n'y a pas de contraintes on peut donner le nom d'un type xs si possible
                //bool isprimitive = false;
                foreach (string ss in mapforprimitivetypes.Keys)
                {
                    if (ss == valuetype)
                    { // en fait il s'agit d'une primitive
                        //isprimitive = true; ABA20230905 meaningless!!
                        return valuetype;

                    }
                }
            }


            if (valuetype == CD.GetFloatType() || valuetype == CD.GetStringType())
            {
                if (InvConstraints.Count > 0)
                { // we treat only precision constraint

                    switch (valuetype)
                    {
                        case "Float":
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice=simple"))
                                {
                                    precision = "simple"; valuetype = "float";
                                }
                                if (constr.Notes.Contains("choice=double"))
                                {
                                    precision = "double"; valuetype = "double";
                                }
                            }
                            ret = valuetype;
                            break;
                        case "String":
                            valuetype = "string";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Notes.Contains("choice="))
                                {
                                    valuetype = getXmlType(constr);

                                    break;
                                }
                            }
                            ret = valuetype;
                            break;

                        //---------ajout am juil 2015 ------------------      break;

                        case "DateTime":
                            valuetype = "datetime";
                            foreach (EA.AttributeConstraint constr in InvConstraints)
                            {
                                if (constr.Name.Contains("TruncationOrReduced"))
                                {
                                    precision = "";
                                    if (constr.Notes.Contains("choice="))
                                    {
                                        precision = getXmlType(constr);
                                        if (precision == "gYearMonthDayHourMinute")
                                        {
                                            //string pattern = GetDateTimePattern(precision); // ce fut une idee provisoire
                                            // d'introduire le pattern a ce niveau mais en fait on 
                                            // utilise une restriction pattern
                                            // il faut singer une contrainte OCL patern sur string avec le commentaire de la contrainte
                                            //  XmlSchemaSimpleTypeRestriction simppRestriction = new XmlSchemaSimpleTypeRestriction();
                                            //simppRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes["string"], NS_XSD);

                                            valuetype = "string"; // on force la restriction sur string
                                            ret = valuetype;
                                        }
                                        break;
                                    }
                                }
                            }
                            break;
                        //---------------------------------------------

                        default:
                            return ret;
                    }

                }
                else
                {
                    if (valuetype == CD.GetFloatType()) ret = CD.GetFloatType();
                }
            }
            else
            { 
                foreach (string ss in mapforprimitivetypes.Keys)
                {
                    if (ss == valuetype)
                    { 
                        return valuetype;

                    }
                }
            }


            return ret;

        }

        //-------------------------------------------------
        static void AddElementAttribute(XmlSchema schem, XmlSchemaSequence sequence, EA.Package apackage, EA.Element el, EA.Attribute atr)
        {
            XmlSchemaElement nel = new XmlSchemaElement();
            sequence.Items.Add(nel);
            nel.Name = atr.Name;
            /* ABA20230905
            if(atr.Name=="value")
            {
                string tt="tt";
            }*/
            string atrtype = atr.Type;
            long classifierid = atr.ClassifierID;
            if ((classifierid != 0)) //18 && (RDFutilitaires.dicelembyid.ContainsKey(classifierid)))
            {
                EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);

                //  MessageBox.Show("classifier "+ classifierid.ToString() + "of the attribute " + atr.Name + "of type " + atr.Type);
                //    MessageBox.Show("the classifier " + classifierid.ToString() + " is of name " + classifier.Name);
                string classtereos = "";
                string classstereo=classifier.Stereotype;
                classtereos = classifier.StereotypeEx;
                if ((classtereos != "") && IsValidCimDatatype(classtereos))
                {

                    if (classtereos.Contains(CD.GetPrimitiveStereotype()))
                    {
                        if (classifier.Name == CD.GetFloatType())
                        { //Float is a special case

                            //juin 21 nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            nel.SchemaTypeName = new XmlQualifiedName(mapforprimitivetypes[classifier.Name], NS_XSD);
                        }
                        else
                        {
                            if (!mapforprimitivetypes.ContainsKey(classifier.Name))
                            {
                                // a primitive should be with the given list
                                MessageBox.Show("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                    " is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error the type  " + classifier.Name + " for the attribute " + atr.Name + "\n" +
                                //" is stereotyped wrongly as a <<primitive>> processing is not beeing interrupted but the type of the attribute is going to be missing");
                                //RDFutilitaires.ongoing= false;
                                //return;

                            }
                            else
                            {

                                nel.SchemaTypeName = new XmlQualifiedName(mapforprimitivetypes[classifier.Name], NS_XSD);
                            }
                        }
                    }
                    else
                    {
                        if (IsInline(classifier))
                        {
                            XmlSchemaObject sobjj = TraitElem(classifier, apackage, schem);
                            string xmltyp = sobjj.GetType().ToString();
                            switch (xmltyp)
                            {
                                case "System.Xml.Schema.XmlSchemaComplexType":
                                    nel.SchemaType = (XmlSchemaComplexType)sobjj;
                                    break;
                                case "System.Xml.Schema.XmlSchemaSimpleType":
                                    nel.SchemaType = (XmlSchemaSimpleType)sobjj;
                                    break;
                                default:
                                    break;
                            }
                        }
                        else
                        {
                            nel.SchemaTypeName = new XmlQualifiedName(atrtype, profparameters.TargetNamespace);
                            if (!datatypetraite.Contains(classifierid))
                            {
                                CreateDatatypIfNeeded(classifierid, apackage, schem);
                                //TraitElem(classifier,apackage,schem);
                            }
                        }
                    }
                    // if (atr.LowerBound == "0") nel.MinOccurs = 0;
                    nel.MinOccursString = atr.LowerBound;
                    nel.MaxOccursString = atr.UpperBound;
                    //AddAnnForAtr(el, nel, atr, true);
                    AddAnnForAtr(el, nel, atr);
                    /******** default or fixed values of the attribute ************************/
                    if (atr.Default != "")
                    {
                        if (atr.IsConst)
                        {
                            nel.FixedValue = atr.Default;
                        }
                        else
                        {
                            nel.DefaultValue = atr.Default;
                        }
                    }

                }
                else
                {
                    // classifier == not a CIM type
                    MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type " + classifier.Name + "  The element has been created without any type");
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type " + classifier.Name + ". The element has been created without any type");
                }
            }
            else
            {  // classifier == 0 probably a type from EA
                MessageBox.Show(" WARNING the attribute of name " + atr.Name + " has a non CIM type( native?). The element has been created without any type");
                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" WARNING the attribute of name " + atr.Name + "has a non CIM type( native?). The element has been created without any type");
            }
        }

        //-----------------------------------

        public static string ChgtNom(EA.Connector con, EA.Element elementend, EA.ConnectorEnd end)
        {

            string rolename = end.Role;


            ArrayList resIsRoleClass = IsRoleClass(end.Role, con.ConnectorGUID);
            if ((bool)resIsRoleClass[0])
            { //  rolename=classname in original asssociation
                // this is systematic even if the role is unique
                string[] split = (end.Role).Split(new char[] { '_' });
                string qualifier = "";
                if (split.Length == 1) qualifier = ""; else qualifier = split[0];
                if (qualifier != "")
                {
                    rolename = qualifier + "_" + elementend.Name;
                }
                else
                {
                    rolename = elementend.Name;
                    /*
                    if (((string)resIsRoleClass[1] != "") && IsPlural(end.Role))
                    {
                        rolename = rolename + "s";
                    }
                     */
                }
            }
            else
            {
                if (IsRoleNotUnique(end.Role))
                { // 
                    //rolename = end.Role + "-" + elementend.Name;
                    rolename= elementend.Name;
                }
            }
            return rolename;

        }

        /// <summary>
        /// vrai si la chaine se termine par s
        /// est necessite par l'emploi abusif par 61968 de roles au pluriel
        /// </summary>
        /// <param name="rolename"></param>
        /// <returns></returns>

        public static bool IsPlural(string rolename)
        { // dans le cas du wg14 les roles sont mis au pluriel
            List<string> specialYnames = new List<string>() { "quantity", "Quantity" };

            char[] cs = rolename.ToCharArray();
            int ll = cs.Length;
            if ((ll > 0) && (cs[ll - 1] == 's'))
            {

                /* en attente
               if ((ll > 3) && (cs[ll - 3] == 'i') && (cs[ll - 2] == 'e'))
               {
                       
                   string ss = "";
                   for (int i = 0; i < ll - 3; i++)
                   {
                       ss = ss + cs[i].ToString();
                   }
                   if (specialYnames.Contains(ss + "y"))
                   {
                       return true;
                   }
                         
               }
                 */
                return true;
            }
            else
            {
                return false;
            }


        }

        //------------------------------------------------------------------------------------------









        //-----------------------------------------------------------------------------
        //----------------------------------------------
        public static XmlSchemaObject traitValueSeuleRestraintewg16(EA.Package apackage, XmlSchema schem, EA.Element el, EA.Attribute value, XmlSchemaObject ret)
        {
            /*****  test *****/
            string entree = " entree dans traitValueEtMultiResteintewg16 el=" + el.Name + " |value=" + value.Type + " |nb contraintes=" + value.Constraints.Count.ToString();
            MessageBox.Show(entree);
            // if(Main.DO_REPORTLOG) reportlog.WriteLine(entree);
            /* */
            // XMLParser xmlp = new XMLParser(repo);

            try
            {
                string prov = el.Name;
                string valuetype = value.Type;
                XmlSchemaComplexType ct = new XmlSchemaComplexType();
                //schem.Items.Add(ct); //220311
                ret = ct;
                ct.Name = el.Name;

                //XmlSchemaComplexContentExtension extensionvalue = new XmlSchemaComplexContentExtension();



                EA.Collection contraintes = value.Constraints;
                List<AttributeConstraint> InvConstraints = new List<AttributeConstraint>();
                List<AttributeConstraint> OclConstraints = new List<AttributeConstraint>();
                int nombre = value.Constraints.Count;
                //string precision = "";
                for (short i = 0; i < nombre; i++)
                {
                    EA.AttributeConstraint co = (EA.AttributeConstraint)contraintes.GetAt(i);
                    if (co.Type == "OCL") OclConstraints.Add(co);
                    if (co.Type == "INV") InvConstraints.Add(co);
                    if (co.Type == "Invariant") InvConstraints.Add(co);
                }
                // <xs:simpleType name="">
                XmlSchemaAttribute attribute = new XmlSchemaAttribute();
                ct.Attributes.Add(attribute);
                // attribute.Name = "v";

                if (!IsValuePrimitive(value.Type))
                {
                    string texte = "Error in treating datatype " + el.Name + " value has a non primitivevalue";
                    MessageBox.Show(texte);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                else
                {
                    valuetype = mapforprimitivetypes[value.Type];
                    if (OclConstraints.Count == 0)
                    {
                        attribute.Name = "v";
                        attribute.SchemaTypeName = new XmlQualifiedName(valuetype, NS_XSD);
                    }
                    else
                    {

                        XmlSchemaSimpleType simptype = new XmlSchemaSimpleType();

                        XmlSchemaSimpleTypeRestriction simpRestriction = new XmlSchemaSimpleTypeRestriction();
                        // simpRestriction.BaseTypeName = new XmlQualifiedName((value.Type).ToLower(), NS_XSD);

                        if (valuetype != "")
                        {
                            simpRestriction.BaseTypeName = new XmlQualifiedName(mapforprimitivetypes[valuetype], NS_XSD);
                            simptype.Content = simpRestriction;
                            attribute.SchemaType = simptype;
                            //attribute.RefName  = new XmlQualifiedName("v");
                            attribute.Name = "v";
                        }
                        else
                        {
                            MessageBox.Show("Error   in: " + el.Name + "a restriction can't be applied to a Float  without giving the precision");
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(" \t\t :::Error  in: {0},  a restriction can't be applied to a Float  without giving the precision", el.Name);
                            return ret;
                            // simpRestriction.BaseTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);// cas Float
                            //attribute.SchemaTypeName = new XmlQualifiedName(value.Type, profparameters.TargetNamespace);
                        }

                        foreach (EA.AttributeConstraint constr in OclConstraints)
                        {

                            AddFacet(simpRestriction, constr);

                        }
                    }

                }


                // doc 
                //<xs:documentation>[the class notes]</xs:documentation>
                // <xs:annotation>
                XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
                ct.Annotation = ann;
                if (el.Notes != "")
                {
                    XmlSchemaDocumentation notes = new XmlSchemaDocumentation();
                    ann.Items.Add(notes);
                    notes.Markup = TextToNodeArray(RDFutilitaires.RemoveRc(el.Notes));
                }
            }

            catch (Exception e)
            {
                DialogResult r = MessageBox.Show("20- Error  " + e.Message, "Error", MessageBoxButtons.OKCancel);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  in treating a Datattype {0}", e.Message);
                if (r == DialogResult.Cancel) return ret;
            }
            return ret;
        }

        //--------------------------------------------------------------
        /// <summary>
        /// lorsque l'on cree une classe, ses attributs on des types soit simples, 
        /// soit des CimDatatypes ou Compound qui sont dfinis dans le schema sont importe
        /// ou inclus d'un autre namespace
        /// quand c'est le cas le package qui contient l'element doit etre relie
        /// a l'un des package qui contient l'identifier par une Dependency de strereotype
        /// dependencytype
        /// </summary>
        /// <param name="el">
        /// l'element qui porte les attributs dont les types sont dans un autre namespace
        ///   il y a un namespace pour l'import acquit par dialogue et sauvegarde dans config.xml.
        ///   il y a dememe un namespace pour l'include
        /// </param>
        /// <param name="identifier">
        /// l'identifier du type de l'attribut
        /// </param>
        /// <param name="dependencytype">
        /// peut etre Importfrom ou Includefrom
        /// </param> 
        /// 
        /// <returns></returns>
        static bool IsImportOrIncludeRelated(EA.Element el, EA.Element identifier, string dependencytype)
        {
            bool ok = false;
            bool trouve = false;
            EA.Package pack = Repos.GetPackageByID(el.PackageID);
            EA.Collection col = pack.Connectors;
            EA.Connector dependence = null;
            foreach (EA.Connector con in col)
            {
                if ((con.Type == "Dependency") && (con.Stereotype == dependencytype))
                {
                    ok = true;
                    dependence = con;
                    break;
                }
            }
            if (ok)
            {
                long supplierid = dependence.SupplierID;
                EA.Element packel = Repos.GetElementByID((int)supplierid);
                long packid = packel.PackageID;

                long identifierpackid = identifier.PackageID;
                while (identifierpackid != 0)
                { // il y a un parent
                    if (identifierpackid == packid)
                    {
                        trouve = true;
                        break;
                    }
                    else
                    {
                        identifierpackid = (Repos.GetPackageByID((int)identifierpackid)).ParentID;
                    }
                }
            }
            return trouve;
        }

        static bool isTagConstrained(EA.Attribute value)
        {
            bool rest = false;
            if (value.TaggedValues.Count > 0)
            {
                List<string> listfac = CD.GetListeFacets();
                foreach (EA.AttributeTag atag in value.TaggedValues)
                {
                    if (listfac.Contains(atag.Name.ToLower()))
                    {
                        rest = true;
                        break;
                    }
                }
            }
            return rest;
        }
        //--------------------------------------------------------------
        static void AddSawsdlChoiceUnion(XmlSchemaChoice choice, Connexion conex, string typend)
        {
            EA.ConnectorEnd end = null;

            try
            {
                EA.Element otherelementend = null;
                if (typend == "source")
                {
                    otherelementend = conex.Source_element;
                    end = conex.Source;
                }
                else
                {
                    otherelementend = conex.Target_element;
                    end = conex.Target;
                }

                AddAnnForAssociationEnd(conex.ConnectorID, choice, end, otherelementend);
            }
            catch (Exception e)
            {
                MessageBox.Show("Error ds sawsdl choice " + e.Message);
            }
        }
        //  -----------------------------------------
        static void AddSwsdlForCtx(EA.Element el, XmlSchemaComplexType ct, bool origin)
        {



            // <xs:annotation>
            XmlSchemaAnnotation ann = new XmlSchemaAnnotation();
            ct.Annotation = ann;
            //<xs:appinfo for defining complementary attributes like sawsdl
            // <xs:appinfo><newattrbutes ... </xs:appinfo>
            ArrayList reff=null;
            /*
            if (origin)
            {
                reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
            }
            if(profparameters.XSDByRef=="Checked") // am mai 2017
            {
                reff[0] = RDFutilitaires.getURIFromVersion(el,profparameters);
                reff[1] = el;
            }
            else
            {
                reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             * */
            reff = getReff(el, origin);//am mai 2017
            //string reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
            string reference = "";
            switch (Wg)
            {
                case "wg14":
                case "wg16":
                    reference = RDFutilitaires.addAmpelsand(profparameters.RootModelURI) + RDFutilitaires.getElementOriginBasedonElement(el).Name;
                    break;
                case "wg19byref":// am mai 2017
                    reference = reff[0] + "#" + el.Name;
                    break;
                default:
                    reference = profparameters.RootModelURI + reff[0] + "#" + ((EA.Element)reff[1]).Name;
                    break;
            }
            AddAppInfoSawdsl(ann, reference);
        }
        //--------------------------------------------------------------------------------
        //------------------------------------------------------------

        public static void SchemaWg16Recopie(XMLProfileParameters profparams, List<string> classnamelist)
        {

            //string toto = "prov";

            XmlDocument doc = new XmlDocument();
            Dictionary<string, XmlNode> complextypes = new Dictionary<string, XmlNode>();
            XmlNode parentnode;
            try
            {
                string dirname=Path.GetDirectoryName(profparams.CurrentXSDFilePath);
                RDFLAutilitaires.wtest("TEST", "SchemaWg16Recopie  fichier" + dirname + "\\XSDexample.xsd existe-t-il?");
                if (System.IO.File.Exists( dirname + "\\XSDexample.xsd"))
                {     
                    System.IO.File.Delete(dirname + "\\XSDexample.xsd");
                    RDFLAutilitaires.wtest("TEST", "SchemaWg16Recopie  fichier" + dirname + "\\XSDexample.xsd deleted");
                }
                System.Security.AccessControl.DirectorySecurity da = System.IO.Directory.GetAccessControl(dirname);

                System.IO.File.Copy(profparams.CurrentXSDFilePath,dirname + "\\XSDexample.xsd");
                
                RDFLAutilitaires.wtest("TEST", "SchemaWg16Recopie  fichier " + profparams.CurrentXSDFilePath + "\\XSDexample.xsd");
                TextReader FileReader = new StreamReader(dirname + "\\XSDexample.xsd");
                doc.Load(FileReader);

                XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
                nsmgr.AddNamespace("xs", NS_XSD);
                nsmgr.AddNamespace(profparams.Prefix, profparams.TargetNamespace);
                nsmgr.AddNamespace("cimp", NS_CIMP);

                //on repere les partie <documentation
                XmlNodeList nodeList;

                nodeList = doc.SelectNodes("xs:schema//xs:complexType", nsmgr);

                foreach (XmlElement noeud in nodeList)
                {
                      
                    string nom=getComplexetypeNom(noeud);
                    
                    if((nom != "") && classnamelist.Contains(nom)) 
                    {
                    if(!complextypes.ContainsKey(nom)) complextypes.Add(nom,noeud.Clone());
                    }
                }
                nodeList = doc.SelectNodes("xs:schema//xs:complexType", nsmgr);
                int index=0;
                foreach (XmlElement nod in nodeList) // on remet de l'ordre
                {
                    parentnode = nod.ParentNode;
                    string nodenom = classnamelist[index];
                    if ((getComplexetypeNom(nod) != "") && (complextypes.ContainsKey(getComplexetypeNom(nod))))
                    {                       
                        parentnode.ReplaceChild(complextypes[nodenom], nod);
                        index++;
                    }

                }
                
         //---------------------------------------------------
                
                List<EA.Element> localelems = new List<EA.Element>();
                  RDFutilitaires.getAllElements(ThePackage,localelems, "all");
                Dictionary<string, EA.Element> localclassesbyname = new Dictionary<string, Element>();
                foreach (EA.Element el in localelems)
                {
                    if (!localclassesbyname.ContainsKey(el.Name)) localclassesbyname.Add(el.Name, el);
                }
                nodeList = doc.SelectNodes("xs:schema//xs:complexType", nsmgr);
                 index=0;
                foreach (XmlElement classnod in nodeList) // on remet de l'ordre
                {
                    parentnode = classnod.ParentNode;
                    string nodenom = classnamelist[index];
                    XmlDocument atribdoc = new XmlDocument();
                    string classannotation = ""; // la description eventuelle de la classe
                    if ((getComplexetypeNom(classnod) != "") && (complextypes.ContainsKey(getComplexetypeNom(classnod))))
                    {
                        index++;
                       // le complexnode est compose 
                        //d'une annotation si l'option annotation est positionnee
                        //d'une sequence d'elements  remettre dans l'ordre de leur "order tagvalue"
                       
                        parentnode = classnod.ParentNode;
                        atribdoc = new XmlDocument();
                        string nomclassnode = getComplexetypeNom(classnod);
                        if ((nomclassnode == "") || !classnamelist.Contains(nomclassnode)) continue;
                        if (localclassesbyname.ContainsKey(nomclassnode))
                        {
                            EA.Element el = localclassesbyname[nomclassnode];
                            List<string> orderedelementnames = RDFutilitaires.getOrderedWg16ClassElementNames(Repos, el);
                             classannotation = "";
                            string contenu = classnod.InnerXml;
                      if(profparams.WithAnnotations)
                      {
                          XmlDocument classdoc = new XmlDocument();
                          classdoc.LoadXml(classnod.OuterXml); // on recupere le noeud de classe sous forme de document
                          XmlNode annode = classdoc.SelectSingleNode("//xs:annotation", nsmgr);
                          XmlNode seqnod = classdoc.SelectSingleNode("//xs:sequence", nsmgr);
                         if(annode != null) classannotation = annode.OuterXml;
                          contenu = seqnod.OuterXml;
                      }   
                            

                            atribdoc.LoadXml(contenu);
                            XmlNodeList elementnodes = atribdoc.SelectNodes("xs:sequence//xs:element", nsmgr);
                            Dictionary<string, XmlNode> elementsbyname = new Dictionary<string, XmlNode>();
                            foreach (XmlNode eltnode in elementnodes)
                            {
                                string nomelt = getComplexetypeNom(eltnode);
                                if ((nomelt != "") && orderedelementnames.Contains(nomelt))
                                {
                                    if (!elementsbyname.ContainsKey(nomelt)) elementsbyname.Add(nomelt, eltnode.Clone());
                                }
                                else
                                {
                                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error in SchemaWG16Recopie .... one element does not corresponf to an attribute :" + el.Name + "." + nomelt);
                                    MessageBox.Show("Error in SchemaWG16Recopie .... one element doesnot corresponf to an attribute :" + el.Name + "." + nomelt);
                                    // reportlog.Flush();
                                }

                            }

                           int ind = 0;
                            foreach (XmlNode eltnode in elementnodes) // aligner l'ordre
                            {
                                string nomelt = getComplexetypeNom(eltnode);
                                if ((nomelt != "") && orderedelementnames.Contains(nomelt))
                                {
                                    string nom = orderedelementnames[ind];
                                    parentnode = eltnode.ParentNode;
                                    parentnode.ReplaceChild(elementsbyname[nom], eltnode);
                                    ind++;
                                }
                            }
                            if (((ind > 0) && (ind != orderedelementnames.Count)))
                            {
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error in SchemaWg16Recopie ... there is a difference in number");
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(" between nb of element in the class " + el.Name + "nb of elements" + orderedelementnames.Count.ToString() + " nb of elements in XSD file " + index.ToString());
                                MessageBox.Show("Error SchemaWg16Recopie difference in nb of elements in " + el.Name + "see details in logfile");
                            }

                        }
                        else
                        {
                            string texte = "Error SchemaWG16recopie no class found in assembly for complextype :" + nomclassnode;
                            MessageBox.Show(texte);
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                            // reportlog.Flush();
                            return;
                        }

                        //XmlNode newclassnod = classnod.Clone();
                           classnod.InnerXml = classannotation + atribdoc.InnerXml;

                    }
                }
                FileReader.Close();
                FileReader.Dispose();


                //----------------------------------------------------------------------------

                TextWriter FileWriter = new StreamWriter(profparams.CurrentXSDFilePath);
                XmlTextWriter writer = new XmlTextWriter(FileWriter);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Flush();
                writer.Close();
                string path = "./" + nomfic;
                try
                {
                    //   MessageBox.Show(" for test no delete of " + path);
                    // System.IO.File.Delete(path);
                }
                catch (Exception e)
                {
                    MessageBox.Show("30-CIMSchemagenerator Error : " + e.Message);
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR  file {0} access", nomfic);
                    // reportlog.Flush();
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("7-CIMSchemageneratorXg16 Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR while creating final file from  intermediate file {0} ", e.Message);
                // reportlog.Flush();
            }

        }
        /// <summary>
        /// donne les classes 
        /// </summary>
        /// <param name="asspack"></param>
        static List<string> getOrderedAssClasses(EA.Package asspack)
        {
            List<string> resul=new List<string>();
            List<EA.Element> elems=new List<EA.Element>();
            elems=RDFutilitaires.getAllPackageClasses(asspack);
            foreach (EA.Element el in elems)
            {
                if ((!resul.Contains(el.Name))&& el.Name != "")
                {
                    resul.Add(el.Name);
                }
            }
            resul.Sort();
            return resul;
            
        }
        //  -----------------------------------------
        /// <summary>
        /// recupere dans l'ordre toutes les classes en lien descendant  avec la classe 
        /// en parametre 
        /// pour etre utilise recursivement pour ordonner un arbre
        /// </summary>
        /// <param name="el"></param>
        /// <returns></returns>
        /// 
        /*
        static void getOrderedAssClasses(EA.Element el, List<string> classnames)
        {
            if (!classnames.Contains(el.Name)) classnames.Add(el.Name);
            SortedDictionary<int,string> elbyrg=new SortedDictionary<int,string>();
            List<EA.Element> elts = new List<EA.Element>();
            EA.Element elt = null;
            int rang = 0;
            foreach (EA.Connector con in el.Connectors)
            {
                if ((con.Type != "Association") && (con.Type != "Aggregation")) continue;
                if (
                 (((el.ElementID == con.SupplierID) && (con.SupplierEnd.Aggregation == 1))
                 || ((el.ElementID == con.ClientID) && (con.ClientEnd.Aggregation == 1)))
                 )
                {
                    elt = RDFutilitaires.getTheotherend(Repos, el, con);
                    rang = RDFutilitaires.getAtRang(con);
                    if (!elbyrg.ContainsKey(rang))
                    {
                        if (rang > -1) elbyrg.Add(rang, elt.Name);
                    }
                    else
                    {
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine("Error two connexion have the same rank");
                        MessageBox.Show("Error two connexion have the same rank");
                    }
                    if (!elts.Contains(elt)) elts.Add(elt);
                }
            }
            foreach (KeyValuePair<int, string> kv in elbyrg)
            {
                if(!classnames.Contains(kv.Value)) classnames.Add(kv.Value);
            }
         
        }
         */
        //-----------------------------------------------

       
        //----------------------------------------------
      static string  getComplexetypeNom(XmlNode noeud)
        {
            XmlAttributeCollection atcol = noeud.Attributes;
            string nom = "";
            foreach (XmlNode at in atcol)
            {
                string prov = at.Name;
                if (at.Name == "name")
                {
                    nom = at.Value;
                }
            }
            return nom;
        }
        static void createEnumCodelistIfNeeded(long classifierid, EA.Package apackage, XmlSchema schem)
        {

             EA.Element classifier = Main.Repo.GetElementByID((int)classifierid);  //soit unit symbol, soit unitmultiplier

             string prov = classifier.Name;
            if (!datatypetraite.Contains(classifierid))
            {
                if (LocalDatatypeNames.Contains(classifier.Name))
                {
                    string texte = " le datattype " + classifier.Name + " existait deja, il n'a pas t recree localement";
                    // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                }
                if (!LocalDatatypeNames.Contains(classifier.Name))
                {
                    string uricodelist = XMLP.GetXmlValueProfData("URICodelist");
                    // <xs:simpleType name="">
                    XmlSchemaSimpleType simplistype = new XmlSchemaSimpleType();
                    simplistype.Name = classifier.Name; //el.Name;
                    XmlSchemaSimpleTypeRestriction simplisRestriction = new XmlSchemaSimpleTypeRestriction();
                    if (profparameters.import == true)
                    {
                        simplisRestriction.BaseTypeName = new XmlQualifiedName(classifier.Name, uricodelist);
                    }
                    else
                    {
                        simplisRestriction.BaseTypeName = new XmlQualifiedName(classifier.Name, profparameters.TargetNamespace);
                    }

                    simplistype.Content = simplisRestriction;
                    schem.Items.Add(simplistype);  //220311
                    //ret = simplistype;
                    // doc and annotations sawdsl
                   AddAnnForStx(classifier, simplistype, false);
                    
                    if (!LocalDatatypeNames.Contains(classifier.Name)) LocalDatatypeNames.Add(classifier.Name);  // am june 2011
                }
                else
                { // a similar name already exists in the package
                    if (!LocalDatatypeIDs.Contains(classifierid))
                    {
                        string texte = " WARNING: it seems that you used a type " + classifier.Name + " which was already been defined in the profile\n";
                        texte = texte + " the reference has been made to the already  defined local type";
                        //	MessageBox.Show(texte);
                        // if(Main.DO_REPORTLOG) reportlog.WriteLine(texte);
                    }
                }
            }
             
                          
        }
       

        //------------------------------------------- 

        static XmlSchemaObject transCompound(EA.Element el, EA.Package apackage, XmlSchema schem)
        {
            XmlSchemaObject ret = null;
            string prov1 = el.Name;
            if (el.Name == "PostalAddress")
            {
                prov1 = el.Name;
            }
            try
            {
                if (hierarchie)
                {
                    if (el.Name != "")
                    {
                       // if (el.Name == "Series_Period") RDFutilitaires.amtest = true; //am 27/10/2013
                        if(RDFutilitaires.amtest) //am 27/10/2013
                        {
                            string tt = el.Name;
                            string ss = " ++++++++  TEST BUG 27-10-2013 " + "transCompound: " + el.Name + " elGUID=" + el.ElementGUID + " ++++++++++++";
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            EA.Element pel = RDFutilitaires.getElementBasedonElement(el);
                            ss = " \t classe parente : " + Repos.GetPackageByID((int)pel.PackageID).Name +"::";
                            ss = ss + pel.Name + "  de guid=" + pel.ElementGUID;
                            // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            foreach (EA.Attribute at in pel.Attributes)
                            {
                                ss = "\t\t attribut: " + at.Name + " de guid=" + at.AttributeGUID + "from element: " + pel.Name;
                                ss=ss + " de tagvalueGUID= " + RDFutilitaires.getAttrBasedOnAttribute(at.AttributeGUID,Repos);
                                // if(Main.DO_REPORTLOG) reportlog.WriteLine(ss);
                            }
                        }

                        //MessageBox.Show(" treatin the Compound " + el.Name + " "); // for test
                        // <xs:complexType name="">
                        XmlSchemaComplexType ct = new XmlSchemaComplexType();
                        ret = ct;
                        // schem.Items.Add(ct);
                        if (!IsInline(el)) ct.Name = el.Name;
                        XmlSchemaObject sobj = ct;
                        string prov = sobj.ToString();
                        //==============================================================================
                        //documentation et  attribut sawsdl
                      
                        AddAnnForClass(el, ct, false);

                        //==============================================================================
                        // ON suppose que les compound n'herite pas d'autres compounds
                        XmlSchemaSequence sequence = new XmlSchemaSequence();
 
                            ct.Particle = sequence;
                        
                        // <xs:element name=""   type=""/>
                        EA.Collection colattributes = el.Attributes;
                        List<EA.Attribute> attributes = new List<EA.Attribute>();
                  
                        foreach (EA.Attribute attrib in colattributes)
                        {
			     // if (isTypeCompound(attrib))
                           attributes.Add(attrib); 
                         }
                            
                        //la liste attributes permet d'eventuelle manip d'ordonancement
                       
                        foreach (EA.Attribute atr in attributes)
                        {
		
                               AddElementAttribute(schem, sequence, apackage, el, atr);
                                 }
                             


      


                        //------------------------------------------------------------------------------- 

                        /***  for test  **********/
                        //am 27/10/2013
                        if (RDFutilitaires.amtest)
                        {
                            RDFutilitaires.amtest = false;
                        }
                        /*************************/
                    }
                    else
                    {
                        // it is an unnamed element. Most probably a constraint to associations
                        //MessageBox.Show( "|notes=" + el.Notes + "|Otype=" + el.ObjectType + "|type=" + el.Type );


                        //-------------------------------------------------------------------------------------------------

                    }
                    // AddAnnForAtr(el, nel, atr, true);
                    
                }//

                else
                {// not hierarchy
                }

            }

            catch (Exception e)
            {
                MessageBox.Show("2-CIMSchemagenerator Error : " + e.Message);
                // if(Main.DO_REPORTLOG) reportlog.WriteLine("\t\t !!!ERROR in treating an Element of Type  COMPOUND " + el.Name + "   " + e.Message);
                // reportlog.Flush();
            }
            return ret;
        }

         static void OrdonXsd(string fichier, XmlNamespaceManager nsmgr)
        {// ordonne un fichier xsd par ordre alphabetique
            int step = 0;
            XPathDocument results = new XPathDocument(fichier);
            step++;
            XPathNavigator navigator = results.CreateNavigator();
            step++;
            XPathExpression exp = navigator.Compile("xs:schema//xs:complexType");
            step++;
            XPathExpression sortExpr = navigator.Compile("@name");
            step++;
            exp.AddSort(sortExpr, XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
            step++;

           // navigator.MoveToRoot();
           // step++;
             try
             {
             XmlWriter xw = XmlWriter.Create("XSDSorted");
            step++;
            exp.SetContext(nsmgr);
            XPathNodeIterator iter = navigator.Select(exp);
            step++;
            while (iter.MoveNext())
            {
               // string res = iter.Current.Value;
                xw.WriteNode(iter.Current,true);
            }
            xw.Close();
            //navigator.WriteSubtree(xw);
             }catch (Exception e){
                 MessageBox.Show("Erreur au tri du schema \n" + step.ToString()+ e.Message);
             }

        }

 public static ArrayList getReff(EA.Element el,bool origin)
         {
             ArrayList reff = new ArrayList();
             reff.Add("");
             reff.Add("");
             if (origin)
             {
                 reff = RDFutilitaires.GetPackageBasedOnOriginContainmentPath(el);
             }
             else
             {
                 reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
             }
             if ((profparameters.XSDByRef == "Checked")
                || (Wg=="wg19byref")) // am mai 2017
             {
                 reff[0]= RDFutilitaires.getURIFromVersion(el,profparameters); // il faudrait faire evoluer la version pour recuperer 
                                                                               // le bon URI des schemas selon le package une fois 
                                                                                  // que la decision est prise
                 //reff.Add(profparameters.RootModelURI);  
                 reff[1]=el;
             }
             else
             {
                string uriFromVersion = (string)RDFutilitaires.getURIFromVersion(el, profparameters);
                if(uriFromVersion == null)
                {
                    return new ArrayList();
                }
                 reff[0] = uriFromVersion.TrimEnd('#') + "#" +  ((string)reff[0]).TrimStart('/');
           //      reff = RDFutilitaires.GetPackageBasedOnContainmentPath(el);
            }
             return reff;
         }
        //--------------------------------------------
//--------------------------------------------------------
     

    }
}



